NB. Plugin
NB. random.ijs
NB. Random number plug-in

coclass 'random'
(;:'base z') copath 'random'


NB. Define menu item for plug-in

MENU=: 0 : 0
menu Rand "&Random numbers..." "" "Random number generator" "Random number generator";
)

NB. menu button in base locale

mstat_Rand_button__=: open_random_

NB. Dialog definition

RAND=: 0 : 0
pc rand dialog nosize escclose closeok;pn "Random number generator";
bin v;
groupbox "Type";
bin v;
bin h;
cc rb0 radiobutton;cn "&Uniform integers";
cc rb1 radiobutton group;cn "&Normal";
bin z;
bin h;
cc rb2 radiobutton group;cn "&Poisson";
cc rb3 radiobutton group;cn "Negative binomial";
bin z;
groupboxend;

bin h;
groupbox "Parameters";
bin h;
minwh 80 32;cc p1l static right;cn "Param 1 ";
cc p1 edit;set p1 wh 60 _1;
minwh 80 32;cc p2l static right;cn "Param 2 ";
cc p2 edit;set p2 wh 60 _1;
bin z;
groupboxend;
bin z;

bin h;
cc spc static;cn "";set spc wh 80 32;
cc labelns static right;cn "Number of samples  ";
cc numrand edit;set numrand wh 60 _1;
bin sz;

bin h;
cc spc2 static;cn "";set spc2 wh 80 32;
cc varcb checkbox;cn "&Assign to variable  ";
bin sz;

bin h;
cc label static right;cn "Variable name";
cc var edit;
bin z;

bin hs2;
cc ok button;cn "&OK";
cc cancel button;cn "&Cancel";
bin zz;
pcenter;

)


NB. Static variables

MakeVar=: 0
VarType=: 0

NB. Code

open=: 3 : 0
MakeVar=: 0
wd RAND
wd 'set rb',(":VarType),' 1'
". 'rand_rb',(":VarType),'_button'''''
rand_varcb_button''
wd 'pshow;'
)

close=: 3 : 0
wd'pclose'
)

rand_cancel_button=: rand_close=: rand_cancel=: close

rand_varcb_button=: 3 : 0
if. MakeVar do.
  MakeVar=: 0
  wd 'set varcb value 0'
  wd 'set var enable 0'
else.
  MakeVar=: 1
  wd 'set varcb value 1'
  wd 'set var enable 1'
end.
)

rand_rb0_button=: 3 : 0
VarType=: 0
wd'set p1l text Minimum'
wd'set p2 enable; set p2l enable'
wd'set p2l text Maximum'
)

rand_rb1_button=: 3 : 0
VarType=: 1
wd'set p1l text Mean'
wd'set p2 enable; set p2l enable'
wd'set p2l text Variance'
)

rand_rb2_button=: 3 : 0
VarType=: 2
wd'set p1l text Mean'
wd'set p2 enable 0; set p2l enable 0'
wd'set p2l text ""'
)

rand_rb3_button=: 3 : 0
VarType=: 3
wd'set p1l text Mean m'
wd'set p2 enable; set p2l enable'
wd'set p2l text k'
)

rand_ok_button=: 3 : 0
if. MakeVar do.
  Vn=. var
  if. e=.'v' invalidVn Vn do.
    vnError e
    wd 'set var focus'
    return.
  end.
end.
if. -. ValidN numrand do. 
  wd'set numrand focus'
  return.
end.
n=. ". numrand
if. -. ValidN p1 do. 
  wd'set p1 focus'
  return.
end.
select. VarType
  case. 0 do.
    min=. ". p1
    if. -. ValidN p2 do. 
      wd'set p2 focus'
      return.
    end.
    max=. ". p2
    if. max <: min do.
      mbError 'Invalid value';'Max must be larger than Min'
      wd 'set p2 focus'
      return.
    end.
    r=. (min;max) urand n
    head=. (": n),' random integers between ',(":min),' and ',":max
  case. 1 do.
    m=. ". p1
    if. -. ValidN p2 do. 
      wd'set p2 focus'
      return.
    end.
    v=. ". p2
    r=. (m;v^0.5) nrand n
    head=. (": n),' random normal (',(": m),',',(":v),') variates'
  case. 2 do.
    m=. ".p1
    r=. m poisrand n
    head=. (": n),' random Poisson (m=',(":m),') variates'
  case. 3 do.
    if. -. ValidN p2 do. 
      wd'set p2 focus'
      return.
    end.
    m=. ".p1
    k=. ".p2
    r=. (m;k) nbdrand n
    head=. (": n),' negative binomial (m=',(":m),',k=',(":k),') variates'
end.
tout head,LF
if. MakeVar do. 
  ". (locv Vn),'=: ',":r
  tout 'Assigned to variable ',Vn,LF,LF
else.
  tout ,vfm 50 list ft r
  tout LF,LF
end.
close''
view''
)

ValidN=: 3 : 0
if. 0=#y do.
  mbError 'Missing value';'You must enter a value.'
  ret=. 0
  return.
end.
n=. __ ". y
if. ((<,y) e. (,'-');,'_') +. n=__ do.
  mbError'Invalid value';'You must enter a valid number.'
  ret=. 0
  return.
end.
ret=. 1
)

NB. rn =: (>:@? % 2147483647&[) @ $ & 2147483646 NB. 32-bit
rn=: rand01__

nrand =: 4 : 0
NB. x is mean;sd
NB. y is number of values desired
'm s'=.x
p =. rn y
z =. invnorm 1-p
m+z*s
)

urand=: 4 : 0
NB. x is min;max
NB. y is number of values desired
'min max'=. x
m=.min-1
p=. rn y
>.m+(max-m)*p
)

nbdrand=: 4 : 0
NB. x is m;k
NB. y is number of values desired
'm k'=. x
s=. %: m+(*:m)%k
d=. (m;k) nbd i.>.1+m+10*s NB. Run dist to 10 sd out
cdf=. +/\d
p=. rn y
NB.res=. 0>. _1++/"1 p >/ cdf
res=. +/"1 p >/ cdf
)

poisrand=: 4 : 0
NB. x is m
NB. y is number of values desired
m=. x
s=. %: m
d=. m poisson i.>.1+m+10*s NB. Run dist to 10 sd out
cdf=. +/\d
p=. rn y
NB.res=. 0>. _1++/"1 p >/ cdf
res=. +/"1 p >/ cdf
)


rand_var_button=: rand_ok_button

rand_octrl_fkey=: rand_ok_button
