NB. mstat.ijs
NB. Norman Drinkwater
NB. University of Wisconsin
NB. Copyright 1996-2023

NB. J profile
NB. JFE sets BINPATH_z_ and ARGV_z_
NB. add your sentences in startup.ijs

systype=. 9!:12''
jpathsep_z_=: '/'&(('\' I.@:= ])})
BINPATH_z_=: jpathsep BINPATH_z_

NB. create SystemFolders
bin=: BINPATH
install=: (bin i: '/'){.bin
home=: >(systype-5){(2!:5'HOME');2!:5'USERPROFILE'
home=: >(0-:home){home;,'/'
userx=: '/.mstat7'
user=: home,userx
config=: user,'/config'
temp=: user,'/temp'
ids=. ;:'bin config home install temp user'


SystemFolders_j_=: ids,.jpathsep@".&.>ids

md=. 3 : 0 NB. recursive makedir
a=. jpathsep y,'/'
if. -.#1!:0 }:a do.
  for_n. I. a='/' do. 1!:5 :: [ <n{.a end.
end.
)

NB. try to ensure user folders exist
md user
md config
md temp

18!:4 <'z'
3 : 0 ''

JLIB=: '9.5.5'

notdef=. 0: ~: 4!:0 @ <
hostpathsep=: ('/\'{~6=9!:12'')&(I. @ (e.&'/\')@] })
jpathsep=: '/'&(('\' I.@:= ])})
winpathsep=: '\'&(('/' I.@:= ])})
PATHJSEP_j_=: '/'
IFDEF=: 3 : '0=4!:0<''DEF'',y,''_z_'''
IF64=: 16={:$3!:3[2
IFBE=: 'a'~:{.2 (3!:4) a.i.'a'
'IFUNIX IFWIN IFWINCE'=: 5 6 7 = 9!:12''
IFJHS=: 0
IFWINE=: (0 ~: 'ntdll wine_get_version >+ x'&(15!:0)) ::(0:@(15!:10))`0:@.IFUNIX ''
if. notdef 'IFIOS' do.
  IFIOS=: 0
end.
if. notdef 'IFJA' do.
  IFJA=: 0
end.
if. notdef 'IFJNET' do.
  IFJNET=: 0
end.
if. notdef 'BINPATH' do.
  BINPATH=: '/j/bin'
end.
if. notdef 'UNAME' do.
  if. IFUNIX do.
    if. -.IFIOS do.
      if. 'wasm'-:4{.9!:56 ::('Unknown'"_)'cpu' do.
        UNAME=: 'Wasm'
      else.
        UNAME=: (2!:0 ::('Unknown'"_)'uname')-.10{a.
      end.
    else.
      UNAME=: 'Darwin'
    end.
  elseif. do.
    UNAME=: 'Win'
  end.
end.
if. notdef 'LIBFILE' do.
  LIBFILE=: BINPATH,'/',IFUNIX{::'j.dll';(UNAME-:'Darwin'){::'libj.so';'libj.dylib'
end.
if. notdef 'FHS' do.
  FHS=: IFUNIX>'/'e.LIBFILE
end.
if. notdef 'RUNJSCRIPT' do.
  RUNJSCRIPT=: 0
end.
if. notdef 'IFRASPI' do.
  if. ((<UNAME)e.'Linux';'OpenBSD';'FreeBSD') do.
    IFRASPI=: (<9!:56'cpu') e. 'arm';'arm64'
  else.
    IFRASPI=: 0
  end.
end.
if. IF64 +. IFIOS do.
  IFWOW64=: 0
else.
  if. IFUNIX do.
    IFWOW64=: '64'-:_2{.(2!:0 ::(''"_)(UNAME-:'Android'){::'uname -m';'getprop ro.product.cpu.abi')-.10{a.
  else.
    IFWOW64=: 'AMD64'-:2!:5'PROCESSOR_ARCHITEW6432'
  end.
end.
if. notdef 'IFQT' do.
  IFQT=: 0
  libjqt=: IFUNIX{::'jqt.dll';'libjqt',(UNAME-:'Darwin'){::'.so';'.dylib'
  if. 0 ~: 1!:4 :: 0: < ((BINPATH,'/')&,) libjqt do.
    libjqt=: ((BINPATH,'/')&,) libjqt
  end.
end.
if. UNAME-:'Android' do.
  AndroidLibPath=: '/lib',~ ({.~i:&'/')^:2 BINPATH
end.

assert. IFQT *: IFJA
)
jcwdpath=: jpathsep@(1!:43@(0&$) ,`(, }.)@.(('/' = {:)@:[ *. ('/' = {.)@:]) ])@((*@# # '/'"_) , ])
jsystemdefs=: 3 : 0
xuname=. UNAME
xuname=. 'Linux'"_^:(xuname-:'Wasm') xuname
if. 0=4!:0 <f=. y,'_',(tolower xuname),(IF64#'_64'),'_j_' do.
  0!:100 toHOST f~
else.
  0!:0 <jpath '~system/defs/',y,'_',(tolower xuname),(IF64#'_64'),'.ijs'
end.
)
18!:4 <'j'

setjdefs=: 4 : 'if. _1=4!:0 y do. (>y)=: x end.'

1 setjdefs"_ 0 <;._2 [ 0 : 0
RGBSEQ
)

(0 2$<'') setjdefs"_ 0 <;._2 [ 0 : 0
SystemFolders
UserFolders
)

3 : 0''
if. (<'bin') -.@e. {."1 SystemFolders do.
  SystemFolders=: SystemFolders, 'bin';BINPATH
end.

if. (<'home') -.@e. {."1 SystemFolders do.
  if. 'Win'-:UNAME do. t=. 2!:5'USERPROFILE'
  elseif. 'Android'-:UNAME do. t=. '/sdcard'
  elseif. ((<UNAME)e.'Linux';'OpenBSD';'FreeBSD';'Darwin') do. t=. (0-:t){::'';~t=. 2!:5'HOME'
  elseif. do. t=. ''
  end.
  if. (''-:t)+.((,'/')-:t)+.('/root'-:t)+.('/usr/'-:5{.t) do.
    t=. '/tmp/',":2!:6''
    1!:5 ::] <t
  end.
  SystemFolders=: SystemFolders, 'home';t
end.

if. (<'temp') -.@e. {."1 SystemFolders do.
  if. 'Win'-:UNAME do. 1!:5 ::] <t=. (2!:5'USERPROFILE'),'\Temp'
  elseif. 'Android'-:UNAME do. t=. '/sdcard'
  elseif. ((<UNAME)e.'Linux';'OpenBSD';'FreeBSD';'Darwin') do. 1!:5 ::] <t=. '/tmp/',":2!:6''
  elseif. do. t=. ''
  end.
  SystemFolders=: SystemFolders, 'temp';t
end.
''
)

4!:55 <'setjdefs'

18!:4 <'z'
18!:4 <'z'
UNXLIB=: ([: <;._1 ' ',]);._2 (0 : 0)
libc.so.6 libc.so.7 libc.so.7 libc.so libc.dylib libc.so
libz.so.1 libz.so.7 libz.so.6 libz.so libz.dylib libz.so
libsqlite3.so.0 libsqlite3.so.0 libsqlite3.so.0 libsqlite.so libsqlite3.dylib libsqlite3.so
libxml2.so.2 libxml2.so.18.0 libxml2.so.2 libxml2.so libxml2.dylib libxml2.so
libpcre2-8.so.0 libpcre2-8.so.0.6 libpcre2-8.so.0 libpcre2-8.so libpcre2-8.dylib libpcre2-8.so
)
3 : 0^:((<UNAME)e.'Linux';'OpenBSD';'FreeBSD')''
b=. (<UNAME)i.~'Linux';'OpenBSD';'FreeBSD'
a=. 2!:0 ::(''"_) b{::'/sbin/ldconfig -p';'/sbin/ldconfig -r';'/sbin/ldconfig -r'
if. #a1=. I. '/libc.so.' E. a do.
  UNXLIB=: (<({.~i.&(10{a.))}.a}.~{.a1) (<0,b)}UNXLIB
end.
if. #a1=. I. '/libz.so.' E. a do.
  UNXLIB=: (<({.~i.&(10{a.))}.a}.~{.a1) (<1,b)}UNXLIB
end.
if. #a1=. I. '/libsqlite3.so.' E. a do.
  UNXLIB=: (<({.~i.&(10{a.))}.a}.~{.a1) (<2,b)}UNXLIB
end.
if. #a1=. I. '/libxml2.so.' E. a do.
  UNXLIB=: (<({.~i.&(10{a.))}.a}.~{.a1) (<3,b)}UNXLIB
end.
if. #a1=. I. '/libpcre2-8.so.' E. a do.
  UNXLIB=: (<({.~i.&(10{a.))}.a}.~{.a1) (<4,b)}UNXLIB
end.
''
)
unxlib=: 3 : 0
r=. (;: 'c z sqlite3 libxml2 pcre2') i. <,y
c=. (;: 'Linux OpenBSD FreeBSD Android Darwin') i. <UNAME_z_
(<r,c) {:: UNXLIB_z_
)
18!:4 <'z'
anddf=: 4 : '''libj.so android_download_file > i *c *c'' 15!:0 x;y'
andunzip=: 3 : 0
'' andunzip y
:
'libj.so java_unzip_file > i *c *c' 15!:0 y;x
)
android_exec_am=: 3 : 0
'intent uri mimetype flags'=. 4{.y
user=. (UserNumber_ja_"_)^:(0=4!:0<'UserNumber_ja_') (_1)
2!:0 ::0: utf8 'am start ',((user>:0)#'--user ', ":user),' -a ', intent, ' -d ', (dquote uri), ((*#mimetype)#' -t ', mimetype), ((0~:flags)#' -f ', ":flags)
i.0 0
)

android_exec_host=: 2!:1@(3&{.)`android_exec_am@.(0=4!:0<'AndroidPackage')
android_getdisplaymetrics=: 3 : 0
dm=. 0 2 320 1280 2 720 243.247 244.273
if. 18<:APILEVEL_ja_ do.
  if. 0=4!:0<'android_getdisplaymetrics_memo_ja_' do.
    dm=. android_getdisplaymetrics_memo_ja_
  else.
    try.
      densityDpi=. 0&". ' '-.~ (}.~ i:&' ') LF-.~ 2!:0 'wm density'
      ('widthPixels heightPixels')=: 0&". ;._1 'x', ' '-.~ (}.~ i:&' ') LF-.~ 2!:0 'wm size'
      density=. (0.5*heightPixels>480) + (0.5*heightPixels>320) + densityDpi% 160
      dm=. 1 2 3 4 5 (density, densityDpi, heightPixels, density, widthPixels)}dm
    catch. end.
    android_getdisplaymetrics_memo_ja_=: dm
  end.
end.
'DM_density_ja_ DM_densityDpi_ja_ DM_scaledDensity_ja_'=: 1 2 4{dm
dm
)
18!:4 <'z'
'TAB LF FF CR DEL EAV'=: 9 10 12 13 127 255{a.
LF2=: LF,LF
CRLF=: CR,LF
EMPTY=: 0 0$0
Debug=: 0
'noun adverb conjunction verb monad dyad'=: 0 1 2 3 3 4
setalpha=: 16bff&$: : (4 : 0)
((_32&(34 b.))^:IF64 _8 (32 b.) x)&(23 b.) 16bffffff (17 b.) y
)
getalpha=: 16bff (17 b.) _24&(34 b.)
abspath=: 3 : 0
if. (1 e. '://'&E.) y=. ,jpathsep y do. y return. end.
if. IFWIN do.
  assert. 0<rc=. >@{. cdrc=. 'kernel32 GetFullPathNameW   i *w i *w *w'&cd (uucp y);((#;])1024$u:' '),<<0
  y=. jpathsep utf8 rc{.3{::cdrc
elseif. ('/' ~: {.) y do.
  y=. iospath^:IFIOS (1!:43'') , '/' , utf8 y
end.
y
)
apply=: 128!:2
assert=: 0 0 $ 13!:8^:((0 e. ])`(12"_))
bind=: 2 : 'u@(v"_)'
boxopen=: <^:(0&(>: L.))
boxxopen=: <^:((> L.)~ *@#)
bx=: I.
clear=: 3 : 0
". 'do_',(' '-.~y),'_ '' (#~ -.@(4!:55)) (4!:1) 0 1 2 3'''
)
cutLF=: 3 : 'if. 0 (<L.) y do. y else. a: -.~ <;._2 y,LF end.'
cutopen=: 3 : 0
y cutopen~ (' ',LF) {~ LF e. ,y
:
if. 0 (<L.) y do. y return. end.
if. 1 < #$y do. <"_1 y return. end.
(<'') -.~ (y e.x) <;._2 y=. y,1{.x
)
datatype=: 3 : 0
n=. 1 2 4 8 16 32 64 128 1024 2048 4096 8192 16384 32768 65536 131072 262144
t=. '/boolean/literal/integer/floating/complex/boxed/extended/rational'
t=. t,'/sparse boolean/sparse literal/sparse integer/sparse floating'
t=. t,'/sparse complex/sparse boxed/symbol/unicode/unicode4'
(n i. 3!:0 y) pick <;._1 t
)
def=: :
define=: : 0
H=. '0123456789ABCDEF'
h=. '0123456789abcdef'
dfh=: (16 #. 16 | (H,h) i. ]) :.hfd
hfd=: (h {~ 16 #.^:_1 ]) :.dfh
4!:55 'H';'h'
do=: ".
drop=: }.
each=: &.>
empty=: EMPTY"_
erase=: [: 4!:55 ;: ::]
every=: &>
evtloop=: EMPTY"_
exit=: 2!:55
expand=: #^:_1
file2url=: 3 : 0
if. (1 e. '://'&E.) ,y do. y return. end.
y=. (' ';'%20') stringreplace abspath y -. '"'
if. IFWIN do.
  if. '//'-:2{.y do.
    'file:',y
  else.
    'file:///',y
  end.
else.
  'file://',y
end.
)
fixdotdot=: 3 : 0
while. 1 e. r=. '../' E. y do.
  y=. ((2+p)}.y),~ ({.~ i:&'/') }: (p=. {.I.r){.y
end.
y
)
fliprgb=: 3 : 0
s=. $y
d=. ((#y),4)$2 (3!:4) y=. <.,y
d=. 2 1 0 3{"1 d
s$_2(3!:4),d
)
getargs=: 3 : 0
ARGV getargs y
:
argb=. (]`(([: < 1: {. }.) , [: < 2: }. ])@.('-'"_ = {.))&.> x
parm=. 32 = ;(3!:0)&.> argb
((-. parm)#argb);(>parm#argb);(". (0 = isatty 0)#'stdin ''''')
)
getenv=: 2!:5
inv=: inverse=: ^:_1
iospath=: 3 : 0
if. IFIOS *. ('/j'-:2{.y) do. y=. y,~ '/Documents',~ 2!:5 'HOME' end.
y
)
3 : 0''
if. IFUNIX do.
  isatty=: ((unxlib 'c'),' isatty > i i') & (15!:0)
else.
  isatty=: 2: = ('kernel32 GetFileType > i x' & (15!:0)) @ ('kernel32 GetStdHandle > x i'& (15!:0)) @ - @ (10&+)
end.
''
)
isutf8=: 0:`(1:@(7&u:) :: 0:)@.(2=3!:0)
isutf16=: 0:`(1:@(8&u:) :: 0:)@.(131072=3!:0)
items=: "_1
fetch=: {::
leaf=: L:0
list=: 3 : 0
w=. {.wcsize''
w list y
:
if. 0=#y do. i.0 0 return. end.
if. 2>#$y=. >y do.
  d=. (' ',LF) {~ LF e. y=. toJ ": y
  y=. [;._2 y, d #~ d ~: {: y
end.
y=. y-. ' '{.~ c=. {:$ y=. (": y),.' '
(- 1>. <. x % c) ;\ <"1 y
)
nameclass=: nc=: 4!:0
namelist=: 4!:1
nl=: 3 : 0
'' nl y
:
if. 0 e. #y do. y=. 0 1 2 3 end.

if. 1 4 8 e.~ 3!:0 y do.
  nms=. (4!:1 y) -. ;: 'x y x. y.'
else.
  nms=. cutopen_z_ y
end.

if. 0 e. #nms do. return. end.

if. #t=. x -. ' ' do.
  'n s'=. '~*' e. t
  t=. t -. '~*'
  b=. t&E. &> nms
  if. s do. b=. +./"1 b
  else. b=. {."1 b end.
  nms=. nms #~ n ~: b
end.
)
names=: list_z_ @ nl
Note=: 3 : '0 0 $ 0 : 0' : [
on=: @:
pick=: >@{
rows=: "1
script=: [: 3 : '0!:0 y [ 4!:55<''y''' jpath_z_ &.: >
scriptd=: [: 3 : '0!:1 y [ 4!:55<''y''' jpath_z_ &.: >
stdout=: 1!:2&4
stderr=: 1!:2&5
stdin=: 1!:1@3: :. stdout
sign=: *
sminfo=: 3 : 0
if. IFJHS do. smoutput >{:boxopen y
elseif. IFQT do. wdinfo_jqtide_ y
elseif. IFJA do. wdinfo_ja_ y
elseif. IFJNET do. wdinfo_jnet_ y
elseif. (0-:11!:0 ::0:'qwd') < 3=4!:0<'wdinfo' do. wdinfo y
elseif. do. smoutput >{:boxopen y end.
)
echo=: 0 0 $ 1!:2&2
smoutput=: 0 0 $ 1!:2&2
tmoutput=: 0 0 $ 1!:2&4
sort=: /:~ : /:
split=: {. ,&< }.
table=: 1 : 0~
:
(((#~LF-.@e.])5!:5<'u');,.y),.({.;}.)":x,y u/x
)
take=: {.
timespacex=: 6!:2 , 7!:2@]
timex=: 6!:2
tolist=: }.@;@:(LF&,@,@":&.>)
tolower=: 3 : 0`((((97+i.26){a.)(65+i.26)}a.) {~ a. i. ])@.(2 = 3!:0)
x=. I. 26 > n=. ((65+i.26){a.) i. t=. ,y
($y) $ ((x{n) { (97+i.26){a.) x}t
)

toupper=: 3 : 0`((((65+i.26){a.)(97+i.26)}a.) {~ a. i. ])@.(2 = 3!:0)
x=. I. 26 > n=. ((97+i.26){a.) i. t=. ,y
($y) $ ((x{n) { (65+i.26){a.) x}t
)

3 : 0''
try.
  tolower=: 0&(3!:12)
  toupper=: 1&(3!:12)
catch. end.
''
)
t=. <;._1 '/invalid name/not defined/noun/adverb/conjunction/verb/unknown'
type=: {&t@(2&+)@(4!:0)&boxopen
ucp=: 7&u:
ucpcount=: # @ (7&u:)
3 : 0''
if. IFUNIX do.
  usleep=: 3 : ('''',(unxlib 'c'),' usleep > i i''&(15!:0) >.y')
else.
  usleep=: 3 : '0: ''kernel32 Sleep > n i''&(15!:0) >.y % 1000'
end.
EMPTY
)
utf8=: 8&u:
uucp=: u:@(7&u:)
toJ=: (LF I.@(CR=])}]) @: (#~ -.@(CRLF&E.@,))
toCRLF=: 2&}. @: ; @: (((CR&,)&.>)@<;.1@(LF&,)@toJ)

3 : 0''
if. 5=9!:12'' do.
  toHOST=: ]
else.
  toHOST=: toCRLF
end.
1
)
18!:4 <'z'
coclass=: 18!:4 @ boxxopen
cocreate=: 18!:3
cocurrent=: 18!:4 @ boxxopen
codestroy=: coerase @ coname
coerase=: 18!:55
cofullname=: 3 : 0
y=. ,> y
if. #y do.
  if. ('_' = {: y) +: 1 e. '__' E. y do.
    y,'_',(>18!:5''),'_'
  end.
end.
)
coinsert=: 3 : 0
n=. ;: :: ] y
p=. ; (, 18!:2) @ < each n
p=. ~. (18!:2 coname''), p
(p /: p = <,'z') 18!:2 coname''
)
coname=: 18!:5
conames=: list_z_ @ conl
conew=: 3 : 0
c=. <y
obj=. cocreate''
coinsert__obj c
COCREATOR__obj=: coname''
obj
:
w=. conew y
create__w x
w
)
conl=: 18!:1 @ (, 0 1"_ #~ # = 0:)
copath=: 18!:2 & boxxopen
coreset=: 3 : 0
0 0$coerase conl 1
)
cocurrent 'z'
cofind=: 3 : 0
r=. (<,>y) (4 : 'try. x e. nl__y $0 catch. 0 end.'"0 # ]) 18!:1]0 1
if. 0=#r do. i.0 2 end.
)
cofindv=: 3 : 0
lcs=. cofind y
if. #lcs do.
  lcs ,. ". each (<y,'_') ,each lcs ,each '_'
end.
)
coinfo=: 3 : 0
ref=. boxxopen y
if. 0 e. $ref do. i.0 4 return. end.
if. 0=4!:0 <'COCREATOR__ref'
do. c=. COCREATOR__ref else. c=. a: end.
(conouns ref),ref,c,< ;:inverse copath ref
)
conouns=: 3 : 0 "0
n=. nl 0
t=. n#~ (<y)-:&> ".each n
< ;: inverse t
)
conounsx=: 3 : 0
r=. ''
if. #y do.
  s=. #y=. boxxopen y
  loc=. conl 0
  for_i. loc do. r=. r,conouns__i y end.
  r=. (r~:a:) # (y$~#r),.r,.s#loc
end.
/:~~.r
)
copathnl=: 3 : 0
'' copathnl y
:
r=. ''
t=. (coname''),copath coname''
for_i. t -. <,'z' do.
  r=. r,x nl__i y
end.
/:~~.r
)
copathnlx=: 3 : 0
'' copathnlx y
:
r=. ''
t=. (coname''),copath coname''
for_i. t=. t -. <,'z' do.
  r=. r,<x nl__i y
end.
n=. ~.;r
n,.|:( n&e. &> r) #each t
)
costate=: 3 : 0
r=. ,: ;:'refs id creator path'
if. #n=. conl 1 do. r,coinfo &> n /: 0 ".&> n end.
)
cocurrent 'z'
cd=: 15!:0
memr=: 15!:1
memw=: 15!:2
mema=: 15!:3
memf=: 15!:4
memu=: '' 1 : 'try. 15!:15 m catch. a: { ] return. end. 15!:15'
cdf=: 15!:5
cder=: 15!:10
cderx=: 15!:11
symget=: 15!:6
symset=: 15!:7
symdat=: 15!:14
cdcb=: 15!:13
JB01=: 1
JCHAR=: 2
JSTR=: _1,JCHAR
JINT=: 4
JPTR=: JINT
JFL=: 8
JCMPX=: 16
JBOXED=: 32
JSB=: 65536
JCHAR2=: 131072
JSTR2=: _1,JCHAR2
JCHAR4=: 262144
JSTR4=: _1,JCHAR4
JTYPES=: JB01,JCHAR,JINT,JPTR,JFL,JCMPX,JBOXED,JSB,JCHAR2,JCHAR4
JSIZES=: >IF64{1 1 4 4 8 16 4 4 2 4;1 1 8 8 8 16 8 8 2 4
SZI=: IF64{4 8
ic=: 3!:4
fc=: 3!:5
endian=: |.^:('a'={.2 ic a.i.'a')
Endian=: |.^:('a'~:{.2 ic a.i.'a')
AND=: $:/ : (17 b.)
OR=: $:/ : (23 b.)
XOR=: $:/ : (22 b.)
cocurrent 'z'
calendar=: 3 : 0
0 calendar y
:
a=. ((j<100)*(-100&|){.6!:0'')+j=. {.y
b=. (a-x)+-/<.4 100 400%~<:a
r=. 28+3,(~:/0=4 100 400|a),10$5$3 2
r=. (-7|b+0,+/\}:r)|."0 1 r(]&:>:*"1>/)i.42
m=. (<:}.y),i.12*1=#y
h=. 'JanFebMarAprMayJunJulAugSepOctNovDec'
h=. ((x*3)|.' Su Mo Tu We Th Fr Sa'),:"1~_3(_12&{.)\h
<"2 m{h,"2[12 6 21 ($,) r{' ',3":1+i.31 1
)
getdate=: 3 : 0
0 getdate y
:
r=. ''
opt=. x
chr=. [: -. [: *./ e.&'0123456789 '
dat=. ' ' (I. y e.',-/:') } y

if. chr dat do.
  opt=. 0
  dat=. a: -.~ <;._1 ' ',dat
  if. 1=#dat do. r return. end.
  typ=. chr &> dat
  dat=. (2{.typ{dat),{:dat
  mth=. 3{.>1{dat
  uc=. 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
  lc=. 'abcdefghijklmnopqrstuvwxyz'
  mth=. (lc,a.) {~ mth i.~ uc,a.
  mos=. _3[\'janfebmaraprmayjunjulaugsepoctnovdec'
  mth=. <": >:mos i. mth
  dat=. ;' ',each mth 1 } dat
end.

dat=. ". :: (''"_) dat
if. 0 e. #dat do. return. end.

if. 3 ~: #dat do. r return. end.

if. 31 < {.dat do. 'y m d'=. dat
else. ((opt|.'d m '),' y')=. dat
end.

if. y<100 do.
  y=. y + (-100&|) {. 6!:0''
end.

(#~ valdate) y,m,d
)
isotimestamp=: 3 : 0
r=. }: $y
t=. _6 [\ , 6 {."1 y
d=. '--b:' 4 7 10 13 }"1 [ 4 3 3 3 3 ": <. 5{."1 <.t
d=. d ,. ':' 0 }"1 [ 7j3 ": ,. {:"1 t
c=. {: $d
d=. ,d
d=. '0' (I. d=' ')} d
d=. ' ' (I. d='b')} d
(r,c) $ d
)
todate=: 3 : 0
0 todate y
:
s=. $y
y=. s$ 0 (I. (,y) e. _ __)},y
a=. 657377.75 +, y=. <. p=. y
d=. <. a - 36524.25 * c=. <. a % 36524.25
d=. <.1.75 + d - 365.25 * y=. <. (d+0.75) % 365.25
r=. (1+12|m+2) ,: <. 0.41+d-30.6* m=. <. (d-0.59) % 30.6
if. 1<x do.
  h=. <. t=. 24*(1&|) ,p
  mm=. <. t=. 60*t-h
  ss=. 60*t-mm
  r=. s $ |: ((c*100)+y+m >: 10) ,r , |: h ,. mm,. ss
else.
  r=. s $ |: ((c*100)+y+m >: 10) ,r
end.
if. 1=x do. r=. 100 #. r end.
r
)
todayno=: 3 : 0
0 todayno y
:
a=. y
if. 1=x do. a=. 0 100 100 #: a end.
a=. ((*/r=. }: $a) , {:$a) $,a
if. 1<x do.
  'y m d h mm s'=. <"_1 |: a
else.
  'y m d'=. <"_1 |: a
end.
y=. 0 100 #: y - m <: 2
n=. +/ |: <. 36524.25 365.25 *"1 y
n=. n + <. 0.41 + 0 30.6 #. (12 | m-3),"0 d
if. 1<x do.
  n=. n + (24 60 60#.h,.mm,.s)%24*3600
end.
0 >. r $ n - 657378
)
tsdiff=: 4 : 0
r=. -/"2 d=. _6 (_3&([\)) \ ,x,"1 y
if. #i=. i#i.#i=. 0 > 2{"1 r do.
  j=. (-/0=4 100 400 |/ (<i;1;0){d)* 2=m=. (<i;1;1){d
  j=. _1,.j + m{0 31 28 31 30 31 30 31 31 30 31 30 31
  n=. <i;1 2
  r=. (j + n{r) n } r
end.
r +/ . % 1 12 365
)
tsrep=: 3 : 0
0 tsrep y
:
if. x do.
  r=. $y
  'w n t'=. |: 0 86400 1000 #: ,y
  w=. w + 657377.75
  d=. <. w - 36524.25 * c=. <. w % 36524.25
  d=. <.1.75 + d - 365.25 * w=. <. (d+0.75) % 365.25
  s=. (1+12|m+2) ,: <. 0.41+d-30.6* m=. <. (d-0.59) % 30.6
  s=. |: ((c*100)+w+m >: 10) ,s
  r $ s,. (_3{. &> t%1000) +"1 [ 0 60 60 #: n
else.
  a=. ((*/r=. }: $y) , {:$y) $, y
  'w m d'=. <"_1 |: 3{."1 a
  w=. 0 100 #: w - m <: 2
  n=. +/ |: <. 36524.25 365.25 *"1 w
  n=. n + <. 0.41 + 0 30.6 #. (12 | m-3),"0 d
  s=. 3600000 60000 1000 +/ .*"1 [ 3}."1 a
  r $ s+86400000 * n - 657378
end.
)
timestamp=: 3 : 0
if. 0 = #y do. w=. 6!:0'' else. w=. y end.
r=. }: $ w
t=. 2 1 0 3 4 5 {"1 [ _6 [\ , 6 {."1 <. w
d=. '+++::' 2 6 11 14 17 }"1 [ 2 4 5 3 3 3 ": t
mth=. _3[\'   JanFebMarAprMayJunJulAugSepOctNovDec'
d=. ,((1 {"1 t) { mth) 3 4 5 }"1 d
d=. '0' (I. d=' ') } d
d=. ' ' (I. d='+') } d
(r,20) $ d
)
tstamp=: timestamp
valdate=: 3 : 0
s=. }:$y
'w m d'=. t=. |:((*/s),3)$,y
b=. *./(t=<.t),(_1 0 0<t),12>:m
day=. (13|m){0 31 28 31 30 31 30 31 31 30 31 30 31
day=. day+(m=2)*-/0=4 100 400|/w
s$b*d<:day
)
weekday=: 7 | 3 + todayno
weeknumber=: 3 : 0
yr=. {.y
sd=. 1 ((i.~weekday){]) ((<:yr),.12,.29+i.3),yr,.1,.1+i.4
wk=. >.7%~>: y -&todayno sd
if. wk >weeksinyear yr do.
  (>:yr),1
elseif. wk=0 do.
  (,weeksinyear)<:yr
elseif. do.
  yr,wk
end.
)
weeksinyear=: 3 : '52+ +./"1 [ 4=weekday(1 1,:12 31),"0 1/~ y'
cocurrent 'z'
dbr=: 13!:0
dbs=: 13!:1
dbsq=: 13!:2
dbss=: 13!:3
dbrun=: 13!:4
dbnxt=: 13!:5
dbret=: 13!:6
dbjmp=: 13!:7
dbsig=: 13!:8
dbrr=: 13!:9
dbrrx=: 13!:10
dberr=: 13!:11
dberm=: 13!:12
dbstk=: 13!:13
dblxq=: 13!:14
dblxs=: 13!:15
dbtrace=: 13!:16
dbq=: 13!:17
dbst=: 13!:18
dbcut=: 13!:19
dbover=: 13!:20
dbinto=: 13!:21
dbout=: 13!:22
dbctx=: 10 10&$: : (4 : 0)
if. -.13!:17'' do. 0 0$'' return. end.
try.
  'before after'=. 2{. <. , x, 10 10
catch.
  'before after'=. 10 10
end.
if. 0= #d=. 13!:13'' do. 0 0$'' return. end.
if. '*' -.@e. sus=. >{:"1 d do. 0 0$'' return. end.
'name ln nc def src'=. 0 2 3 4 5{(sus i. '*'){d
dyad=. {: ':'&e.;._2 ] 13!:12''
if. (_2{.def) -: LF,')' do.
  def=. }.def [ def0=. {.def=. }:<;._2 def,LF
else.
  def=. ,<def [ def0=: ''
end.
if. def e.~ <,':' do.
  if. dyad do.
    def=. def}.~ >: def i. <,':'
  else.
    def=. def{.~ def i. <,':'
  end.
end.
min=. 0>.ln-before [ max=. (<:#def)<.ln+after
ctx=. ((,.ln=range){' >'),"1 '[',"1 (":,.range) ,"1 ('] ') ,"1 >def{~range=. min + i. >:max-min
; ,&LF&.> (<'@@ ', name, '[', (dyad#':'), (":ln) ,'] *', (nc{' acv'),' @@ ', src), def0, <@dtb "1 ctx
)
dbg=: 3 : 0
if. -.IFQT do.
  13!:0 y return.
end.
if. y do.
  if. _1 = 4!:0 <'jdb_open_jdebug_' do.
    0!:0 <jpath '~addons/ide/qt/debugs.ijs'
  end.
  jdb_open_jdebug_''
  13!:0 [ 1
else.
  jdb_close_jdebug_ :: ] ''
  13!:15 ''
  13!:0 [ 0
end.
)
dblocals=: _1&$: : (4 : 0)
stk=. }. 13!:13''
if. 0=#y do. y=. a: else. y=. (y e. i.#stk) # y end.
loc=. (<y ; 0 7) { stk
if. x-: 0 do.
  {."1 &.>@:{:"1 loc
elseif. -. x-:_1 do.
  t=. ;: ::] x
  f=. ({."1 e. t"_) # ]
  ({."1 loc) ,. f &.> {:"1 loc
end.
)
dbstack=: 3 : 0
hdr=. ;:'name en ln nc args locals susp'
stk=. }. 13!:13''
if. #y do.
  if. 2=3!:0 y do.
    stk=. stk #~ (<y)={."1 stk
  else.
    stk=. ((#stk)<.,y){.stk
  end.
end.
stk=. 1 1 1 1 0 0 1 1 1 #"1 stk
stk=. hdr, ": &.> stk
wds=. ({:@$@":@,.)"1 |: stk
len=. 20 >.<.-:({.wcsize'') - +/8, 4 {. wds
tc=. (len+1)&<.@$ {.!.'.' ({.~ len&<.@$)
tc@": each stk
)
dbstop=: 3 : 0
if. 0 e. #y -. ' ' do. 13!:3'' return. end.
t=. 13!:2''
if. #t do. t=. <;._2 t, ';' -. {:t end.
t=. ~. t, (;: ^: (L.=0:) y) ,&.> <' *:*'
13!:3 ; t ,&.> ';'
)
dbstops=: 3 : 0
13!:3 ; (;: ^: (L.=0:) y) ,&.> <' *:*;'
)
dbstopme=: 3 : 0
if. y do.
  if. 0 e. $c=. }. 13!:13'' do. return. end.
  c=. (> {. {. c), ' *:*'
  t=. 13!:2''
  if. #t do. t=. <;._2 t, ';' -. {:t end.
  t=. ~. t, <c
  13!:3 }: ; t ,&.> ';'
end.
)
dbstopnext=: 3 : 0
if. y do.
  if. 0 e. $c=. }. 13!:13'' do. return. end.
  'd n a'=. 0 2 6 { {. c
  c=. d,' ',(':'#~2=#a),":n+1
  t=. 13!:2''
  if. #t do. t=. <;._2 t, ';' -. {:t end.
  t=. ~. t, <c
  13!:3 }: ; t ,&.> ';'
end.
)
dbview=: 3 : 0
if. -.IFQT do. return. end.
if. _1 = 4!:0 <'jdbview_jdbview_' do.
  'require'~'~addons/ide/qt/dbview.ijs'
end.
jdbview_jdbview_ }. 13!:13''
)
dbhelp=: 0 : 0
The call stack (dbstk'') is a 9-column boxed matrix:
  0  name
  1  error number, or 0 if this call has no error.
  2  line number
  3  name class
  4  definition
  5  source script
  6  argument list
  7  locals
  8  suspense

f is the name of a verb
      dbss 'f 0'   monadic line 0
      dbss 'f :2'  dyadic line 2
      dbss 'f *:*' all lines

dbr     13!:0  reset, set suspension mode (0=disable, 1=enable)
dbs     13!:1  display stack
dbsq    13!:2  stop query
dbss    13!:3  stop set
dbrun   13!:4  run again (from current stop)
dbnxt   13!:5  run next (skip line and run)
dbret   13!:6  exit and return argument
dbjmp   13!:7  jump to line number
dbsig   13!:8  signal error
dbrr    13!:9  re-run with specified arguments
dbrrx   13!:10 re-run with specified executed arguments
dberr   13!:11 last error number
dberm   13!:12 last error message
dbstk   13!:13 call stack
dblxq   13!:14 latent expression query
dblxs   13!:15 latent expression set
dbtrace 13!:16 trace control
dbq     13!:17 queries suspension mode (set by dbr)
dbst    13!:18 returns stack text
(these 4 verbs are subject to change without notice)
dbcut   13!:19 cut back
dbover  13!:20 step over (13!:20'' or moveline 13!:20'')
dbinto  13!:21 step into ...
dbout   13!:22 step out  ...
(utilities)
dbctx       display context
dbg         turn debug window on/off
dblocals    display local names on stack
dbstack     display stack
dbstop      add stop definitions
dbstops     set all stop definitions
dbstopme    stop current definition
dbstopnext  stop current definition at next line
dbview      (GUI only) view stack
)
cocurrent 'z'
dir=: 3 : 0
'n' dir y
:
ps=. '/'
y=. jpath y,(0=#y)#'*'
y=. y,((':',ps) e.~ {:y)#'*'
if. 0=#dr=. 1!:0 y do. empty'' return. end.
fls=. 'd' ~: 4{"1>4{"1 dr
if. (1=#dr) *. 0={.fls do.
  r=. x dir y,ps,'*'
  if. #r do. r return. end.
end.
if. fmt=. 2=3!:0 x do. opt=. 2 1
else. opt=. 2{.x end.
if. 0={:opt do. fls=. 1#~#dr=. fls#dr end.
if. 0=#dr do. empty'' return. end.
nms=. {."1 dr
nms=. nms ,&.> fls{ps;''
ndx=. /: (":,.fls),.>nms
if. 0=opt do.
  list >ndx{nms
elseif. 1=opt do.
  path=. (+./\.y=ps)#y
  path&,&.>ndx{nms
elseif. fmt<2=opt do.
  ndx{nms,.}."1 dr
elseif. fmt do.
  'nms ts size'=. |:3{."1 dr
  ds=. '   <dir>    ' ((-.fls)#i.#fls) } 12 ":,.size
  mth=. _3[\'   JanFebMarAprMayJunJulAugSepOctNovDec'
  f=. > @ ([: _2&{. [: '0'&, ": )&.>
  'y m d h n s'=. f&> ,<"1 |: 100|ts
  m=. (1{"1 ts){mth
  time=. d,.'-',.m,.'-',.y,.' ',.h,.':',.n,.':',.s
  dat=. (>nms),.ds,.' ',.time
  dat /: fls,. /:/: >(3|'dns'i.x){ts;nms;size
elseif. 1 do.
  'invalid left argument'
end.
)
dircompare=: 3 : 0
0 dircompare y
:
if. 0=#y do.
  '''long dirtree timestamps'' dircompare dir1;dir2'
  return.
end.

opt=. 3 {. x
res=. opt dircompares y
if. 0 = L. res do. return. end.

ps=. '/'
'a b c'=. res

'x y'=. jpath each cutopen y
x=. x, ps #~ (*#x) *. ps~:_1{.x
y=. y, ps #~ (*#y) *. ps~:_1{.y

r=. 'comparing  ',x,'  and  ',y,LF

if. #a do.
  r=. r,LF,'not in  ',y,':',LF,,(list a),.LF
end.

if. #b do.
  r=. r,LF,'not in  ',x,':',LF,,(list b),.LF
end.

if. +/ # &> c do.
  'cf cd'=. c
  r=. r,LF,'not same in both:',LF,,(list cf),.LF
  if. {.opt do.
    r=. r,LF,;(,&(LF2)) &.> cd
  end.

end.

if. 0=+/# S:0 res do. r=. r,'no difference',LF end.

}:r
)
dircompares=: 3 : 0
0 dircompares y
:
ps=. '/'
opt=. 3{. x
'x y'=. jpath each cutopen y
x=. x, ps #~ (*#x) *. ps~:_1{.x
y=. y, ps #~ (*#y) *. ps~:_1{.y

if. 1{opt do.
  dx=. dirtree x [ dy=. dirtree y
else.
  dx=. 2 0 dir x [ dy=. 2 0 dir y
end.

if. dx -: dy do. 'no difference' return. end.
if. 0 e. #dx do. 'first directory is empty' return. end.
if. 0 e. #dy do. 'second directory is empty' return. end.

f=. #~ [: +./\. =&ps
sx=. f x
sy=. f y
fx=. {."1 dx
fy=. {."1 dy

if. 1{opt do.
  fx=. (#sx)}.&.>fx
  fy=. (#sy)}.&.>fy
  dx=. fx 0 }"0 1 dx
  dy=. fy 0 }"0 1 dy
end.

r=. <fx -. fy
r=. r , <fy -. fx

dx=. (fx e. fy)#dx
dy=. (fy e. fx)#dy

if. #j=. dx -. dy do.
  j=. {."1 j
  cmp=. <@fcompare"1 (sx&,&.>j),.sy&,&.>j

  if. 0=2{opt do.
    f=. 'no difference'&-: @ (_13&{.)
    msk=. -. f &> cmp
    j=. msk#j
    cmp=. msk#cmp
  end.

  r=. r,< j;<cmp
else.
  r=. r,a:
end.

r
)
dirfind=: 4 : 0
f=. [: 1&e. x&E.
g=. #~ [: -. [: +./\. =&'/'
d=. {."1 dirtree y
m=. f@g &> d
if. 1 e. m do. ; (m # d) ,each LF else. 0 0$'' end.
)
dirpath=: 3 : 0
0 dirpath y
:
r=. ''
t=. jpath y
ps=. '/'
if. #t do. t=. t, ps -. {:t end.
dirs=. <t
ifdir=. 'd'&= @ (4&{"1) @ > @ (4&{"1)
subdir=. ifdir # ]
while. #dirs do.
  fpath=. (>{.dirs) &,
  dirs=. }.dirs
  dat=. 1!:0 fpath '*'
  if. #dat do.
    dat=. subdir dat
    if. #dat do.
      r=. r, fpath each /:~ {."1 dat
      dirs=. (fpath @ (,&ps) each {."1 dat),dirs
    end.
  end.
end.
if. x do.
  f=. 1!:0 @ (,&(ps,'*'))
  g=. 0:`(0: e. ifdir)
  h=. g @. (*@#) @ f
  r=. r #~ h &> r
end.
if. #t do. r=. r,<}:t end.
/:~ r
)
dirss=: 4 : 0
if. (2=#x) *. 1=L. x do.
  x dirssrplc y return.
end.
sub=. ' '&(I.@(e.&(TAB,CRLF))@]})
fls=. {."1 dirtree y
if. 0 e. #fls do. 'not found: ',x return. end.
fnd=. ''
while. #fls do.
  dat=. 1!:1 <fl=. >{.fls
  fls=. }.fls
  ndx=. I. x E. dat
  if. rws=. #ndx do.
    dat=. (20$' '),dat,30$' '
    dat=. (rws,50)$sub(,ndx+/i.50){dat
    fnd=. fnd,LF2,fl,' (',(":#ndx),')'
    fnd=. fnd,,LF,.dat
  end.
end.
if. #fnd do. 2}.fnd else. 'not found: ',x end.
)
dirssrplc=: 4 : 0
fls=. {."1 dirtree y
if. 0 e. #fls do.
  'no files found' return.
end.
r=. (x&fssrplc) each fls
b=. r ~: <'no match found'
j=. >b # fls , each ': '&, each r
}: , j ,. LF
)
dirtree=: 3 : 0
0 dirtree y
:
if. 0=4!:0 <'DirTreeX_j_' do.
  ex=. cutopen DirTreeX_j_
else.
  ex=. ''
end.
r=. i.0 3
ps=. '/'
y=. jpath y
y=. y #~ (+./\ *. +./\.) y~:' '
y=. y,(0=#y)#'*'
if. ps={:y do. y=. y,'*' end.
if. -. '*' e. y do.
  if. 1 = #j=. 1!:0 y do.
    select. 'hd' = 1 4 { >4{,j
    case. 0 1 do. x dirtree y,ps,'*' return.
    case. 1 1 do. i.0 3 return.
    end.
  end.
end.
ts=. 100"_ #. 6: {. 0: >. <. - # {. 1980"_
'path ext'=. (b#y);(-.b=. +./\.y=ps)#y
if. #dl=. 1!:0 y do.
  att=. > 4{"1 dl
  fl=. (('h' ~: 1{"1 att) *. 'd' ~: 4{"1 att)#dl
  if. #fl do.
    r=. r,(path&,&.>{."1 fl),.1 2{"1 fl
  end.
end.
if. #dl=. 1!:0 path,'*' do.
  att=. > 4{"1 dl
  dr=. {."1 (('h' ~: 1{"1 att) *. 'd' = 4{"1 att) # dl
  dr=. dr -. ex
  if. #dr do.
    r=. r,;x&dirtree@(path&,@,&(ps,ext)) &.> dr
  end.
end.
r #~ (ts x) <: ts &> 1{"1 r
)
dirused=: [: (# , +/ @ ; @ (2: {"1 ])) 0&dirtree
cocurrent 'z'

fexists=: #~ fexist
f2utf8=: ]
fboxname=: <@(fixdotdot^:IFIOS)@jpath_j_@(8 u: >) ::]
fappend=: 4 : 0
(,x) (#@[ [ 1!:3) :: _1: fboxname y
)
fappends=: 4 : 0
(fputs x) (#@[ [ 1!:3) :: _1: fboxname y
)
fapplylines=: 1 : 0
0 u fapplylines y
:
y=. > fboxname y
s=. 1!:4 <y
if. s = _1 do. return. end.
p=. 0
dat=. ''
while. p < s do.
  b=. 1e6 <. s-p
  dat=. dat, 1!:11 y;p,b
  p=. p + b
  if. p = s do.
    len=. #dat=. dat, LF -. {:dat
  elseif. (#dat) < len=. 1 + dat i:LF do.
    'file not in LF-delimited lines' 13!:8[3
  end.
  if. x do.
    u ;.2 len {. dat
  else.
    u ;._2 CR -.~ len {. dat
  end.
  dat=. len }. dat
end.
)
fcopynew=: 4 : 0
dat=. fread each boxopen y
if. (<_1) e. dat do. _1 return. end.
dat=. ; dat
if. dat -: fread :: 0: x do. 0,#dat else.
  if. _1=dat fwrite x do. _1 else. 1,#dat end.
end.
)
fdir=: 1!:0@fboxname
ferase=: (1!:55 :: _1:) @ (fboxname &>) @ boxopen
fexist=: (1:@(1!:4) :: 0:) @ (fboxname &>) @ boxopen
fgets=: 3 : 0
y=. (-(26{a.)={:y) }. y
if. 0=#y do. '' return. end.
y,LF -. {:y=. toJ y
)
fmakex=: (] 1!:7~ 'x' 2 5 8} 1!:7) @ fboxname
fpathcreate=: 3 : 0
if. 0=#y do. 1 return. end.
p=. (,'/'-.{:) jpathsep y
if. # 1!:0 }: p do. 1 return. end.
for_n. I. p='/' do. 1!:5 :: 0: < n{.p end.
)
fpathname=: +./\.@:=&'/' (# ; -.@[ # ]) ]
fread=: 3 : 0
if. 1 = #y=. boxopen y do.
  1!:1 :: _1: fboxname y
else.
  1!:11 :: _1: (fboxname {.y),{:y
end.
:
x freads y
)
freadblock=: 3 : 0
1e6 freadblock y
:
'f p'=. y
f=. > fboxname f
s=. 1!:4 <f
if. s = _1 do. return. end.
if. (s = 0) +. p >: s do. '';p return. end.
if. x < s-p do.
  dat=. 1!:11 f;p,x
  len=. 1 + dat i: LF
  if. len > #dat do.
    'file not in LF-delimited lines' 13!:8[3
  end.
  p=. p + len
  dat=. len {. dat
else.
  dat=. 1!:11 f;p,s-p
  dat=. dat, LF -. {: dat
  p=. s
end.
(toJ dat);p
)
freadr=: 3 : 0
'f s'=. 2{.boxopen y
f=. fboxname f
max=. 1!:4 :: _1: f
if. max -: _1 do. return. end.
pos=. 0
step=. 10000
whilst. blk = cls
do.
  blk=. step<.max-pos
  if. 0=blk do. 'file not organized in records' return. end.
  dat=. 1!:11 f,<pos,blk
  cls=. <./dat i.CRLF
  pos=. pos+step
end.
len=. cls+pos-step
dat=. 1!:11 f,<len,2<.max-len
dlm=. +/CRLF e. dat
wid=. len+dlm
s=. wid*s,0 #~ 0=#s
dat=. 1!:11 f,<s
dat=. (-wid)[\dat
(-dlm)}."1 dat
)
freads=: 3 : 0
'' freads y
:
dat=. fread y
if. (dat -: _1) +. 0=#dat do. return. end.
dat=. fgets dat
if. 'b'e.x do. dat=. <;._2 dat
elseif. 'm'e.x do. dat=. ];._2 dat
end.
)
frename=: 4 : 0
x=. > fboxname x
y=. > fboxname y
if. x -: y do. 1 return. end.
if. IFUNIX do.
  0=((unxlib 'c'),' rename > i *c *c') 15!:0 y;x
else.
  'kernel32 MoveFileW > i *w *w' 15!:0 (uucp y);uucp x
end.
)
freplace=: 4 : 0
y=. boxopen y
dat=. ,x
f=. #@[ [ 1!:12
dat f :: _1: (fboxname {.y),{:y
)
fsize=: (1!:4 :: _1:) @ (fboxname &>) @ boxopen
fss=: 4 : 0
y=. fboxname y
size=. 1!:4 :: _1: y
if. size -: _1 do. return. end.
blk=. (#x) >. 100000 <. size
r=. i.pos=. 0
while. pos < size do.
  dat=. 1!:11 y,<pos,blk <. size-pos
  r=. r,pos+I. x E. dat
  pos=. pos+blk+1-#x
end.
r
)
fssrplc=: fstringreplace
fstamp=: (1: >@{ , @ (1!:0) @ fboxname) :: _1:
fputs=: 3 : 0
dat=. ":y
if. 0 e. $dat do.
  ''
else.
  if. 1>:#$dat do.
    toHOST dat,(-.({:dat) e. CRLF) # LF
  else.
    ,dat,"1 toHOST LF
  end.
end.
)
ftype=: 3 : 0
(1:@(1!:4) :: 0:)^:IFWIN < f=. }: ^: ('/' = {:) , > fboxname y
d=. 1!:0 f
if. #d do.
  >: 'd' = 4 { > 4 { ,d
else.
  0
end.
)
fview=: 3 : 0
if. 3 ~: nc <'textview_z_' do.
  sminfo 'textview not available.' return.
end.
txt=. freads y
if. txt -: _1 do.
  sminfo 'file not found: ',,>y return.
end.
textview txt
)
fwrite=: 4 : 0
(,x) (#@[ [ 1!:2) :: _1: fboxname y
)
fwritenew=: 4 : 0
dat=. ,x
if. dat -: fread y do. 0 return. end.
dat fwrite y
)
fwrites=: 4 : 0
(fputs x) (#@[ [ 1!:2) :: _1: fboxname y
)
cocurrent 'z'
install=: 3 : 0
require 'pacman'
do_install_jpacman_ y
)
getqtbin=: 3 : 0
if. (<UNAME) -.@e. 'Linux';'OpenBSD';'FreeBSD';'Darwin';'Win' do. return. end.
if. IFQT do.
  smoutput 'must run from jconsole' return.
end.
require 'pacman'
do_getqtbin_jpacman_ y
)
cocurrent 'z'
cuts=: 2 : 0
if. n=1 do. [: u (#@[ + E. i. 1:) {. ]
elseif. n=_1 do. [: u (E. i. 1:) {. ]
elseif. n= 2 do. [: u (E. i. 1:) }. ]
elseif. 1 do. [: u (#@[ + E. i. 1:) }. ]
end.
)
cut=: ' '&$: :([: -.&a: <;._2@,~)
deb=: #~ (+. 1: |. (> </\))@(' '&~:)
debc=: #~"1 [: (+. (1: |. (> </\))) ' '&(+./ .~:)
delstring=: 4 : ';(x E.r) <@((#x)&}.) ;.1 r=. x,y'
detab=: ' ' I.@(=&TAB@])} ]
3 : 0''
try.
  dlb=: 1&(128!:11)
  dltb=: 2&(128!:11)
  dtb=: 0&(128!:11)
catch.
  dlb=: }.~ =&' ' i. 0:
  dltb=: #~ [: (+./\ *. +./\.) ' '&~:
  dtb=: #~ [: +./\. ' '&~:
end.
''
)
joinstring=: ''&$: : (#@[ }. <@[ ;@,. ])
ljust=: (|.~ +/@(*./\)@(' '&=))"1
rjust=: (|.~ -@(+/)@(*./\.)@(' '&=))"1
ss=: I. @ E.
dropto=: ] cuts 2
dropafter=: ] cuts 1
taketo=: ] cuts _1
takeafter=: ] cuts _2
charsub=: 4 : 0
'f t'=. |: _2 ]\ x
l=. f i."1 0 y
x=. l { t,'?'
c=. l = #f
c } x ,: y
)
chopstring=: 3 : 0
(' ';'"') chopstring y
:
dat=. y
'fd sd'=. 2{. boxopen x
assert. 1 = #fd
if. #sd do.
  sd=. ~.sd
  if. 1 < #sd do.
    s=. {. '|`' -. fd
    dat=. dat charsub~ ,sd,.s
    sd=. s
  end.
  dat=. dat,fd
  b=. dat = fd
  c=. dat = {.sd
  d=. ~:/\ c
  fmsk=. b > d
  smsk=. (> (0 , }:)) c
  smsk=. -. smsk +. c *. 1|.fmsk
  y=. smsk#y,fd
  fmsk=. 0:^:(,@1: -: ]) smsk#fmsk
  fmsk <;._2 y
else.
  <;._2 dat,fd
end.
)
dltbs=: LF&$: : (4 : 0)
txt=. ({.x), y
a=. txt ~: ' '
b=. (a # txt) e. x
c=. b +. }. b, 1
d=. ~: /\ a #^:_1 c ~: }: 0, c
}. (a >: d) # txt
)
dquote=: ('"'&,@(,&'"'))@ (#~ >:@(=&'"'))
dquotex=: 3 : 0
s=. y#~ >: m=. (=&'"') y
p=. (i.#y)#~>: m
('"'&,@(,&'"')) '\' (p i.(I.m))}s
)
dtbs=: 3 : 0
CRLF dtbs y
:
txt=. y , {.x
blk=. txt ~: ' '
ndx=. +/\ blk
b=. blk < }. (txt e. x), 0
msk=. blk >: ndx e. b # ndx
}: msk # txt
)
rplc=: stringreplace~
rplci=: stringreplacei~
fstringreplace=: 4 : 0
nf=. 'no match found'
y=. fboxname y
try. size=. 1!:4 y catch. nf return. end.
if. size=0 do. nf return. end.
old=. freads y
new=. x stringreplace old
if. old -: new do. nf return. end.
new fwrites y
cnt=. +/ (0 pick x) E. old
(":cnt),' replacement',((1~:cnt)#'s'),' made'
)
quote=: (''''&,@(,&''''))@ (#~ >:@(=&''''))
nos=. i.@#@] e. #@[ ({~^:a:&0@(,&_1)@(]I.+) { _1,~]) I.@E.
splitnostring=: #@[ }.each [ (nos f. <;.1 ]) ,
splitstring=: #@[ }.each [ (E. <;.1 ]) ,
stringreplace=: 4 : 0

txt=. ,y
t=. _2 [\ ,x
old=. {."1 t
new=. {:"1 t
oldlen=. # &> old
newlen=. # &> new

if. *./ 1 = oldlen do.

  hit=. (;old) i. txt
  ndx=. I. hit < #old

  if. 0 e. $ndx do. txt return. end.

  cnt=. 1
  exp=. hit { newlen,1
  hnx=. ndx { hit
  bgn=. ndx + +/\ 0, (}: hnx) { newlen - 1

else.

  hit=. old I. @ E. each <txt
  cnt=. # &> hit

  if. 0 = +/ cnt do. txt return. end.

  bgn=. set=. ''

  pick=. > @ {
  diff=. }. - }:

  for_i. I. 0 < cnt do.
    ln=. i pick oldlen
    cx=. (i pick hit) -. set, ,bgn -/ i.ln
    while. 0 e. b=. 1, <:/\ ln <: diff cx do. cx=. b#cx end.
    hit=. (<cx) i} hit
    bgn=. bgn, cx
    set=. set, ,cx +/ i.ln
  end.

  cnt=. # &> hit
  msk=. 0 < cnt
  exp=. (#txt) $ 1
  del=. newlen - oldlen

  if. #add=. I. msk *. del > 0 do.
    exp=. (>: (add{cnt) # add{del) (;add{hit) } exp
  end.

  if. #sub=. I. msk *. del < 0 do.
    sbx=. ; (;sub{hit) + each (sub{cnt) # i. each sub{del
    exp=. 0 sbx } exp
  end.

  hit=. ; hit
  ind=. /: (#hit) $ 1 2 3
  hnx=. (/: ind { hit) { ind
  bgn=. (hnx { hit) + +/\ 0, }: hnx { cnt # del

end.

ind=. ; bgn + each hnx { cnt # i.each newlen
rep=. ; hnx { cnt # new
rep ind} exp # txt
)
stringreplacei=: 4 : 0

txt=. ,y
t=. _2 [\ ,x
old=. {."1 t
new=. {:"1 t
oldlen=. # &> old
newlen=. # &> new

if. *./ 1 = oldlen do.

  hit=. (;old) i.&tolower txt
  ndx=. I. hit < #old

  if. 0 e. $ndx do. txt return. end.

  cnt=. 1
  exp=. hit { newlen,1
  hnx=. ndx { hit
  bgn=. ndx + +/\ 0, (}: hnx) { newlen - 1

else.

  hit=. old (I. @ E.)&tolower each <txt
  cnt=. # &> hit

  if. 0 = +/ cnt do. txt return. end.

  bgn=. set=. ''

  pick=. > @ {
  diff=. }. - }:

  for_i. I. 0 < cnt do.
    ln=. i pick oldlen
    cx=. (i pick hit) -. set, ,bgn -/ i.ln
    while. 0 e. b=. 1, <:/\ ln <: diff cx do. cx=. b#cx end.
    hit=. (<cx) i} hit
    bgn=. bgn, cx
    set=. set, ,cx +/ i.ln
  end.

  cnt=. # &> hit
  msk=. 0 < cnt
  exp=. (#txt) $ 1
  del=. newlen - oldlen

  if. #add=. I. msk *. del > 0 do.
    exp=. (>: (add{cnt) # add{del) (;add{hit) } exp
  end.

  if. #sub=. I. msk *. del < 0 do.
    sbx=. ; (;sub{hit) + each (sub{cnt) # i. each sub{del
    exp=. 0 sbx } exp
  end.

  hit=. ; hit
  ind=. /: (#hit) $ 1 2 3
  hnx=. (/: ind { hit) { ind
  bgn=. (hnx { hit) + +/\ 0, }: hnx { cnt # del

end.

ind=. ; bgn + each hnx { cnt # i.each newlen
rep=. ; hnx { cnt # new
rep ind} exp # txt
)
undquote=: (#~ -.@('""'&E.))@}:@}.^:(('"' = {.) *. '"' = {:)
cutpara=: 3 : 0
txt=. topara y
txt=. txt,LF -. {:txt
b=. (}.b,0) < b=. txt=LF
b <;._2 txt
)
foldtext=: 4 : 0
if. 0 e. $y do. '' return. end.
y=. ; x&foldpara each cutpara y
y }.~ - (LF ~: |.y) i. 1
)
foldpara=: 4 : 0
if. 0=#y do. LF return. end.
r=. ''
x1=. >: x
txt=. y
while.
  ind=. ' ' i.~ |. x1{.txt
  s=. txt {.~ ndx=. x1 - >: x1 | ind
  s=. (+./\.s ~: ' ') # s
  r=. r, s, LF
  #txt=. (ndx + ind<x1) }. txt
do. end.
r
)
topara=: 3 : 0
if. 0=#y do. '' return. end.
b=. y=LF
c=. b +. y=' '
b=. b > (1,}:b) +. }.c,0
' ' (I. b) } y
)
18!:4 <'z'
3 : 0''
if. IFIOS>IFQT do.
  r=. 'Engine: ',9!:14''
  r=. r,LF,'Library: ',JLIB
  r=. r,LF,'J/iOS Version: ',VERSION
  r=. r,LF,'Platform: ',UNAME,' ',IF64 pick '32';'64'
  r=. r,LF,'InstallPath: ', (2!:5'HOME'), '/Documents/j'
  JVERSION=: toJ r
end.
EMPTY
)
NB. break
NB.%break.ijs - break utilities
NB.-This script defines break utilities and is included in the J standard library.
NB.-Definitions are loaded into the z locale.
NB.-
NB.-`setbreak 'default'` is done by profile for Jqt. JHS and jconsole can use ctrl+c.
NB.-
NB.-setbreak creates file `~break/Pid.Class` and writes 0 to the first byte.
NB.-
NB.-Pid is the process id and Class is normally 'default'.
NB.-
NB.-setbreak calls 9!:47 with this file.
NB.-
NB.-9!:47 maps the first byte of file, and JE tests this byte for break requests.
NB.-
NB.-Another task writes 1 or 2 to the file for attention/break.
NB.-
NB.-9!:46 returns the filename.
NB.-
NB.-`break 'abc'` sets break for JEs with class abc.
NB.-
NB.-JEs with the same class all get the break. A non-default class protects JE from the default break.
NB.-
NB.- A new setbreak replaces the old.
NB.-
NB.-`break 0'` shows breakhelp

cocurrent'z'

NB. =========================================================
NB.*break v break J execution
NB. y is class to signal - '' treated as 'default'
break=: 3 : 0
if. y-:0 do. breakhelp_j_ return. end.
breakclean_j_''
p=. jpath'~break/'
fs=. ((<p),each{."1[1!:0 p,'*')-.<9!:46''
pc=. (>:;fs i:each'/')}.each fs
i=. ;pc i.each'.'
pids=. _1".each i{.each pc
classes=. (>:i)}.each pc
if. y-:1 do. /:~(>":each pids),.>' ',each classes return. end.
'no task to break'assert #fs
if. (0=#y)+.2=3!:0 y do.
  b=. classes= (0=#y){y;'default'
  'bad class'assert +/b
  fs=. (<p),each (":each b#pids),each '.',each b#classes
else.
  i=. pids i.<y
  'bad pid'assert i~:#pids
  fs=. <p,(":;i{pids),'.',;i{classes
end.
for_f. fs do.
  v=. 2<.>:a.i.1!:11 f,<0 1
  (v{a.) 1!:12 f,<0
end.
i.0 0
)

NB. =========================================================
NB.*setbreak v set break file
NB.-Set break
NB. y is class
NB. Creates unique file ~break/Pid.Class
setbreak=: 3 : 0
if. (-.IFQT)*.y-:'default' do. i.0 0 return. end. NB. only for qt and not default
try.
  assert #y
  q=. jpath '~break/'
  1!:5 ::] <q
  f=. q,(":2!:6''),'.',y
  ({.a.) 1!:12 f;0
  9!:47 f
  breakclean_j_''
  f
catch. 13!:12'' end.
)

NB. =========================================================
NB.*breakclean v erase orphan break files
breakclean_j_=: 3 : 0
q=. jpath '~break/'
fs=. ((<q),each{."1[1!:0 q,'*')-.9!:46''
if. UNAME-:'Win' do.
  ferase fs NB. windows erase has not effect while file is in use
else.
  d=. dltb each}.<;._2 spawn_jtask_'ps -e'
  allpids=. ;0".each (d i.each ' '){.each d
  pc=. (>:;fs i:each'/')}.each fs
  pids=. ;_1".each (;pc i.each'.'){.each pc
  ferase (-.pids e. allpids)#fs
end.
)

NB. =========================================================
NB.*breakhelp n break help
breakhelp_j_=: 0 : 0
   break 0     NB. help
   break 1     NB. list other ~break pids and classes
   break ''    NB. break to all default class tasks
   break '...' NB. break to all ... class tasks
   break pid   NB. break to that pid

1st break stops execution at line start
2nd break stops execution mid-line, 6!:3 , socket select

profile does setbreak'default' for Jqt
profile does not do it for jconsole or JHS (use ctrl+c)

   setbreak'abc' NB. set break file for this pid and class abc

https://code.jsoftware.com/wiki/Standard_Library/break
)

cocurrent <'j'
Alpha=: a. {~ , (a.i.'Aa') +/ i.26
Num=: a. {~ (a.i.'0') + i.10
AlphaNum=: Alpha,Num
Boxes=: ((16+i.11) { a.),:'+++++++++|-'
ScriptExt=: '.ijs'
ProjExt=: '.jproj'

extnone=: {.~ i:&'.'
extproj=: , (ProjExt #~ '.'&e. < 0 < #)
extsrc=: , ('.ijs' #~ '.'&e. < 0 < #)

addfname=: , ('/' ~: {:) # i:&'/' }. ]
boxdraw=: 3 : '9!:7 y { Boxes'
hostcmd=: [: 2!:0 '(' , ,&' || true)'
fpath=: [: }: +./\.@:=&'/' # ]
isURL=: 1 e. '://'&E.
maxrecent=: 3 : '(RecentMax <. #r) {. r=. ~.y'
pack=: [: (,. ".&.>) ;: ::]
pdef=: 3 : '0 0$({."1 y)=: {:"1 y'
seldir=: #~ '-d'&-:"1 @ (1 4&{"1) @ > @ (4&{"1)
spath=: #~ [: *./\. '/'&~:
termLF=: , (0 < #) # LF -. {:
termsep=: , (0 < #) # '/' -. {:
remsep=: }.~ [: - '/' = {:

path2proj=: ,'/',ProjExt ,~ spath
win2lower=: 3 : 0
if. 0=#CasePaths_j_ do. tolower y return. end.
p=. jpathsep y
n=. 1 + p i. ':'
d=. n {. p
if. (<d) e. CasePaths_j_ do. y return. end.
b=. n }. p
p=. d,(('/'~:{.b)#'/'), b,'/'
p=. (1 + p i: '/') {. p
p=. (I.p='/') {.each <p
if. 1 e. p e. CasePaths_j_ do. y else. tolower y end.
)
3 : 0''
if. UNAME-:'Darwin' do.
  filecase=: tolower`]@.IFIOS
  isroot=: '/' = {.
elseif. IFUNIX do.
  filecase=: ]
  isroot=: '/' = {.
elseif. do.
  filecase=: win2lower
  isroot=: ('\\' -: 2&{.) +. ('//' -: 2&{.) +. (':' = {.@}.)
end.
0
)
dirtreex=: 3 : 0
'' dirtreex y
:
y=. jpath y
p=. (+./\. y = '/') # y
d=. 1!:0 y,('/' = {:y) # '*'
if. 0 = #d do. '' return. end.
a=. > 4 {"1 d
m=. 'd' = 4 {"1 a
f=. (<p) ,each {."1 d
if. 1 e. m do.
  f=. f, ; dirtreex each (m#f) ,each <'/','*'
end.
if. #x do.
  f #~ (1 e. x E. ])&> f
end.
)
getfolderdefs=: 3 : 0
p=. (, '/' , ProjExt ,~ spath) each subdirtree y
t=. p #~ #@(1!:0)&> p
t;<fpath each (1+#y) }. each (-#ProjExt) }. each t
)
isconfigfile=: 3 : 0
'p f'=. fpathname y
x=. f i: '.'
(p -: jpath '~config/') *. '.cfg'-:x}.f
)
isdir=: 3 : 0
d=. 1!:0 fboxname y
if. 1 ~: #d do. 0 return. end.
'd' = 4 { 4 pick ,d
)
isfile=: 3 : 0
d=. 1!:0 fboxname y
if. 1 ~: #d do. 0 return. end.
'd' ~: 4 { 4 pick ,d
)
istempname=: 3 : 0
x=. y i: '.'
*./ ('.ijs'-:x}.y),(x{.y) e. Num
)
istempscript=: 3 : 0
'p f'=. fpathname y
(p -: jpath '~temp/') *. istempname f
)
jshowconsole=: 3 : 0
if. -.IFWIN do. 'only supported in windows' return. end.
t=. {.>'kernel32.dll GetConsoleWindow x'cd''
'user32.dll ShowWindow n x i'cd t;(0-:y){5 0
i.0 0
)
mkdir=: 3 : 0
a=. termsep jpath y
if. #1!:0 }:a do. 1 return. end.
for_n. I. a='/' do.
  1!:5 :: 0: < n{.a
end.
)
newtempscript=: 3 : 0
x=. ScriptExt
p=. jpath '~temp/'
d=. 1!:0 p,'*',x
a=. (-#x) }. each {."1 d
a=. a #~ (*./ .e.&'0123456789') &> a
a=. 0, {.@:(0&".) &> a
p, x ,~ ": {. (i. >: #a) -. a
)
nounrep=: 2 }. [: ; [: nounrep1 each ;:
nounrep1=: LF2 , ] , '=: ' , [: nounrep2 ".
nounrep2=: 3 : 0
if. 0 = #y do. '''''' return. end.
select. 3!:0 y
fcase. 32 do.
  y=. ; y ,each LF
case. 2 do.
  if. LF e. y do.
    y=. y, LF -. {:y
    '0 : 0', LF, ; <;.2 y,')'
  else.
    quote y
  end.
case. do.
  ": y
end.
)
octal=: 3 : 0
t=. ,y
if. LF e. t do.
  t=. octal each <;._2 t,LF
  }: ; t ,each LF return.
end.
u=. isutf8 t
x=. a. i. t
m=. (x e. 9 13) < x < 32
if. u > 1 e. m do. t return. end.
n=. I. m=. m +. u < x > 126
s=. '\',.}.1 ": 8 (#.^:_1) 255,n{x
s ((n+3*i.#n)+/i.4)} (>:3*m)#t
)
revinfo=: 3 : 0
v=. 9!:14''
if. '.' e. (v i. '/') {. v do.
  res=. 8 {. <;._1 '/',v
  a=. 0 pick res
  ndx=. a i. '-'
  beta=. {. 0 ". (ndx+5) }. a
  vno=. 100 #. (0 ".&> <;._1 '.' 0} ndx {. a), beta
  vno;res
else.
  res=. 9 {. <;._1 '/',v
  'a b'=. 0 3 { res
  res=. (<<<0 3) {res
  res=. (('www.jsoftware.com' -: 3 pick res){'na';'GPL3') 2} res
  'm n'=. ": each ver=. 0 100 #: 0 ". }. a
  num=. _97 + a.i. {:b
  if. 'r' = {. b do.
    rev=. (num+1),0
    vst=. 'j',m,'.',n,'.',":num+1
  else.
    rev=. 0,num
    vst=. 'j',m,'.',n,'.0-beta',":num
  end.
  (100 #.ver,rev);vst;res
end.
)
rmdir=: 3 : 0
r=. 1;'not a directory: ',":y
if. 0=#y do. r return. end.
d=. 1!:0 y
if. 1 ~: #d do. r return. end.
if. 'd' ~: 4 { 4 pick {. d do. r return. end.
if. IFWIN do.
  shell_jtask_ 'rmdir "',y,'" /S /Q'
else.
  hostcmd_j_ 'rm -rf ',((UNAME-:'Linux')#'--preserve-root '),y
end.
(#1!:0 y);''
)
runimmx0_j_=: 3 : 0
IMMX_j_=: utf8 y
9!:27 '0!:100 IMMX_j_'
9!:29 [ 1
)
runimmx1_j_=: 3 : 0
IMMX_j_=: utf8 y
9!:27 '0!:101 IMMX_j_'
9!:29 [ 1
)
scripts=: 3 : 0
if. 0=#y do.
  list 0{"1 Public
elseif. 'v'e.y do.
  dir=. Public
  a=. >0{"1 dir
  b=. >1{"1 dir
  a /:~ a,.' ',.b
elseif. 1 do.
  'invalid argument to scripts: ',,":y
end.
)
setfolder=: 3 : 0
if. 0=#y do.
  Folder=: FolderTree=: FolderIds=: '' return.
end.
assert. (<y) e. {."1 UserFolders
Folder=: y
'FolderTree FolderIds'=: getfolderdefs jpath '~',y
if. 3=nc <'snapshot_tree_jp_' do.
  snapshot_tree_jp_ FolderTree
end.
EMPTY
)
subdirtree=: 3 : 0
if. 0=#1!:0 y do. '' return. end.
r=. ''
dir=. <y,'/'
while. #dir do.
  fpath=. (>{.dir) &,
  dir=. }.dir
  dat=. seldir 1!:0 fpath '*'
  if. #dat do.
    dat=. fpath each {."1 dat
    r=. r,dat
    dir=. (dat ,each '/'),dir
  end.
end.
sort filecase each r
)
unixshell=: 3 : 0
f=. jpath '~temp/shell.sh'
t=. jpath '~temp/shell.txt'
e=. jpath '~temp/shell.err'
('#!/bin/sh',LF,y,LF) fwrite f
'rwx------' 1!:7 <f
hostcmd '"',f,'" > "',t,'" 2> "',e,'"'
r=. (fread t);fread e
ferase f;t;e
r
)
unixshellx=: 3 : 0
'res err'=. unixshell y
if. #err do.
  smoutput 'Shell command error: ',LF,LF,err
end.
res
)
browseref=: 3 : 0
htmlhelp 'dictionary/',y
)
dquote=: 3 : 0
if. '"' = {.y do. y else. '"',y,'"' end.
)
browse=: 3 : 0
if. -. isURL cmd=. dltb y do.
  if. -.fexist cmd do. EMPTY return. end.
end.
if. IFJHS do.
  redirecturl_jijxm_=: file2url cmd
  EMPTY return.
elseif. IFIOS>IFQT do.
  jh '<a href="',(file2url cmd),'"</a>'
  EMPTY return.
end.
browser=. Browser_j_
select. UNAME
case. 'Win' do.
  ShellExecute=. 'shell32 ShellExecuteW > i x *w *w *w *w i'&cd
  SW_SHOWNORMAL=. 1
  NULL=. <0
  if. 0 = #browser do.
    r=. ShellExecute 0;(uucp 'open');(uucp winpathsep cmd);NULL;NULL;SW_SHOWNORMAL
  else.
    r=. ShellExecute 0;(uucp 'open');(uucp winpathsep browser);(uucp dquote winpathsep cmd);NULL;SW_SHOWNORMAL
  end.
  if. r<33 do. sminfo 'browse error:',browser,' ',cmd,LF2,1{::cderx'' end.
case. 'Android' do.
  android_exec_host 'android.intent.action.VIEW';(utf8 ('file://'&,)@abspath^:(-.@isURL) cmd);'text/html';16b0004000
case. do.
  if. 0 = #browser do.
    browser=. dfltbrowser''
  end.
  browser=. dquote (browser;Browser_nox_j_){::~ nox=. ((<UNAME)e.'Linux';'OpenBSD';'FreeBSD') *. (0;'') e.~ <2!:5 'DISPLAY'
  cmd=. browser,' ',dquote cmd
  try.
    2!:1 cmd, (0=nox)#' >/dev/null 2>&1 &'
  catch.
    msg=. 'Could not run the browser with the command:',LF2
    msg=. msg, cmd,LF2
    if. IFQT do.
      msg=. msg, 'You can change the browser definition in Edit|Configure|Base',LF2
    end.
    sminfo 'Run Browser';msg
  end.
end.
EMPTY
)
dfltbrowser=: verb define
select. UNAME
case. 'Android' do. ''
case. 'Win' do. ''
case. 'Darwin' do. 'open'
case. do.
  try.
    2!:0'which x-www-browser 2>/dev/null'
    'x-www-browser' return. catch. end.
  try.
    2!:0'which google-chrome 2>/dev/null'
    'google-chrome' return. catch. end.
  try.
    2!:0'which chromium 2>/dev/null'
    'chromium' return. catch. end.
  try.
    2!:0'which chromium-browser 2>/dev/null'
    'chromium-browser' return. catch. end.
  try.
    2!:0'which firefox 2>/dev/null'
    'firefox' return. catch. end.
  try.
    2!:0'which konqueror 2>/dev/null'
    'konqueror' return. catch. end.
  try.
    2!:0'which opera 2>/dev/null'
    'opera' return. catch. end.
  '' return.
end.
)
viewpdf=: 3 : 0
if. -. isURL cmd=. dltb y do.
  if. -.fexist cmd do. EMPTY return. end.
end.
if. IFJHS do.
  redirecturl_jijxm_=: file2url cmd
  EMPTY return.
elseif. IFIOS>IFQT do.
  jh '<a href="',(file2url cmd),'"</a>'
  EMPTY return.
end.
PDFReader=. PDFReader_j_
select. UNAME
case. 'Win' do.
  ShellExecute=. 'shell32 ShellExecuteW > i x *w *w *w *w i'&cd
  SW_SHOWNORMAL=. 1
  NULL=. <0
  if. 0 = #PDFReader do.
    r=. ShellExecute 0;(uucp 'open');(uucp winpathsep cmd);NULL;NULL;SW_SHOWNORMAL
  else.
    r=. ShellExecute 0;(uucp 'open');(uucp winpathsep PDFReader);(uucp dquote winpathsep cmd);NULL;SW_SHOWNORMAL
  end.
  if. r<33 do. sminfo 'view pdf error:',PDFReader,' ',cmd,LF2,1{::cderx'' end.
case. 'Android' do.
  android_exec_host 'android.intent.action.VIEW';(utf8 ('file://'&,)@abspath^:(-.@isURL) cmd);'application/pdf';0
case. do.
  PDFReader=. dquote PDFReader
  cmd=. PDFReader,' ',(dquote cmd),' &'
  try.
    2!:1 cmd
  catch.
    msg=. 'Could not run the PDFReader with the command:',LF2
    msg=. msg, cmd,LF2
    if. IFQT do.
      msg=. msg, 'You can change the PDFReader definition in Edit|Configure|Base',LF2
    end.
    sminfo 'Run PDFReader';msg
  end.
end.
EMPTY
)

linux_pdfreader=: <;._2]0 :0
xdg-open
evince
kpdf
xpdf
okular
acroread
)
dfltpdfreader=: verb define
select. UNAME
case. 'Win' do. ''
case. 'Android' do. ''
case. 'Darwin' do. 'open'
case. do.
  nox=. ((<UNAME)e.'Linux';'OpenBSD';'FreeBSD') *. (0;'') e.~ <2!:5 'DISPLAY'
  if. (((<UNAME)e.'Linux';'OpenBSD';'FreeBSD') > nox) *. ''-: te=. nox{::PDFReader_j_;PDFReader_nox_j_ do.
    for_t. linux_pdfreader do.
      try. 2!:0'which ',(>t),' 2>/dev/null'
        te=. >t
        break.
      catch. end.
    end.
  end.
  te
end.
)
Folder=: ''
FolderTree=: FolderIds=: 0

Cwh=: 79 24
jpath=: 3 : 0
nam=. jpathsep y
if. '~' ~: {. nam do. return. end.
fld=. SystemFolders, UserFolders
ind=. nam i. '/'
tag=. }. ind {. nam
if. 0=#tag do.
  tag=. 'home'
  nam=. '~home',}.nam
  ind=. nam i. '/'
end.
if. tag -: 'addons' do.
  bal=. 8 }. nam
end.
par=. '.' = {. tag
if. par do.
  len=. ('.' = tag) i. 0
  tag=. len }. tag
end.
ndx=. ({."1 fld) i. <tag
if. ndx < # fld do.
  bal=. ind }. nam
  pfx=. 1 pick ndx { fld
  if. '~' = {.pfx do.
    pfx=. jpath pfx
  end.
  if. par do.
    pfx=. ((#pfx) | (+/\. pfx='/') i: len) {. pfx
  end.
  nam=. pfx,bal
end.
nam
)
tofoldername=: 3 : 0
if. 0=#y do. '' return. end.
folders=. UserFolders,SystemFolders
pds=. {."1 folders
pps=. termsep each {:"1 folders
ndx=. \: # &> pps
pds=. ndx{pds
pps=. ndx{pps
res=. filecase each boxxopen y
len=. # &> pps
for_i. i.#res do.
  nam=. i pick res
  if. '~' = {. nam,'~' do. continue. end.
  msk=. pps = len {. each <nam,'/'
  if. 1 e. msk do.
    ndx=. ((i. >./) msk # len) { I. msk
    nam=. ('~', > ndx { pds),(<: ndx { len) }. nam
    res=. (<nam) i } res
  end.
end.
pps=. }: each pps
ndx=. 1 + pps i: &> '/'
msk=. ndx < len
pps=. msk # ndx {.each pps
pds=. msk # pds
len=. # &> pps
for_i. i.#res do.
  nam=. i pick res
  if. '~' = {. nam,'~' do. continue. end.
  if. '/' = {. nam do. continue. end.
  msk=. pps = len {. each <nam
  if. 1 e. msk do.
    ndx=. ((i. >./) msk # len) { I. msk
    nam=. ('~.', > ndx { pds),(<: ndx { len) }. nam
    res=. (<nam) i } res
  end.
end.
if. L. y do. res else. >res end.
)
Loaded=: ''
Public=: i. 0 2
UserFolders=: i. 0 2
getignore=: 3 : 0
r=. ' colib compare convert coutil dates dir dll files libpath strings text gl2 graphics/gl2'
Ignore=: <;._1 r
)

getignore''
buildpublic=: 3 : 0
dat=. deb toJ y
dat=. a: -.~ <;._2 dat, LF
ndx=. dat i. &> ' '
short=. ndx {.each dat
long=. ndx }. each dat
long=. extsrc@jpathsep@deb each long
msk=. (<'system','/') = 7 {. each long
long=. (msk{'';'~') ,each long
msk=. (i. ~.) {."1 Public=: Public,~ short,.long
Public=: sort msk{Public
empty''
)
cutnames=: 3 : 0
if. LF e. y do.
  txt=. y, LF
  nms=. (txt = LF) <;._2 txt
else.
  txt=. y, ' '
  msk=. txt = '"'
  com=. (txt = ' ') > ~: /\ msk
  msk=. (msk *. ~:/\msk) < msk <: 1 |. msk
  nms=. (msk # com) <;._2 msk # txt
end.
nms -. a:
)
3 : 0''
if. 0=9!:24'' do.
  exist=: fexist
else.
  exist=: 0:
end.
1
)
fullname=: 3 : 0
p=. '/'
d=. jpath y
if. </ d i. ':',p do.
elseif. (2{.d) -: 2#p do.
elseif. p ~: 1{.d do.
  jcwdpath d
elseif. IFWIN do.
  (2{.jcwdpath''),d
end.
)
getscripts=: 3 : 0
if. 0=#y do. '' return. end.
if. 0=L.y do.
  if. isfile y do.
    fullname each fboxname y return.
  end.
  y=. cutnames y
end.
y=. y -. Ignore
if. 0=#y do. '' return. end.
ndx=. ({."1 Public) i. y
ind=. I. ndx < # Public
y=. ((ind { ndx) { 1 {"1 Public) ind } y
ind=. (I.-.isroot&>y) -. ind
if. #ind do.
  bal=. jpath each ind { y
  msk=. (isfile &> bal) +. '/'={:&> bal
  y=. (msk#bal) (msk#ind) } y
  ind=. (-.msk)#ind
  if. #ind do.
    bal=. (-.msk)#bal
    msk=. -. '.'&e.@(}.~i:&'/') &> bal
    msk=. msk *. *./@:((a.{~, 65 97 +/i.26)e.~])@:({.~i.&'/') &> bal
    msk=. msk > isroot &> bal
    cnt=. ('/' +/ .= ]) &> bal
    ndx=. I. msk *. cnt=1
    bal=. (addfname each ndx { bal) ndx } bal
    ndx=. I. msk *. cnt > 0
    bal=. (<jpath '~addons/') ,each (ndx{bal) ,each <'.ijs'
    y=. bal (ndx{ind) } y
  end.
end.
fullname each y
)
getpath=: ([: +./\. =&'/') # ]
xedit=: 0&$: : (4 : 0)
'file row'=. 2{.(boxopen y),<0
file=. dltb file
if. -.fexist file do. EMPTY return. end.
if. IFJHS do.
  xmr ::0: file
  EMPTY return.
end.
if. UNAME-:'Android' do.
  if. IFJA do.
    android_exec_host 'android.intent.action.VIEW';(utf8 ('file://'&,)@abspath^:(-.@isURL) file);'text/plain';0
  elseif. 1=ftype '/system/bin/vi' do.
    2!:1 '/system/bin/vi', ' ', (dquote >@fboxname file)
  elseif. 1=ftype '/system/xbin/vi' do.
    2!:1 '/system/xbin/vi', ' ', (dquote >@fboxname file)
  elseif. #Editor_j_ do.
    2!:1 Editor_j_, ' ', (dquote >@fboxname file)
  end.
  EMPTY return.
end.
editor=. (Editor_j_;Editor_nox_j_){::~ nox=. ((<UNAME)e.'Linux';'OpenBSD';'FreeBSD') *. (0;'') e.~ <2!:5 'DISPLAY'
if. 0=#editor do. EMPTY return. end.
nox=. ((<UNAME)e.'Linux';'OpenBSD';'FreeBSD') *. (0;'') e.~ <2!:5 'DISPLAY'
if. ((<UNAME)e.'Linux';'OpenBSD';'FreeBSD')>nox do.
  if. 1 e. r=. 'term' E. editor do.
    if. '-e ' -: 3{. editor=. dlb (}.~ i.&' ') ({.I.r)}.editor do.
      editor=. TermEmu, (('gnome-terminal'-:TermEmu){::' -e ';' -- '), dlb 3}.editor
    else.
      editor=. TermEmu, ' ', editor
    end.
  else.
    editor=. TermEmu, (('gnome-terminal'-:TermEmu){::' -e ';' -- '), editor
  end.
end.
if. 1 e. '%f' E. editor do.
  cmd=. editor stringreplace~ '%f';(dquote >@fboxname file);'%l';(":>:row)
else.
  cmd=. editor, ' ', (dquote >@fboxname file)
end.
try.
  if. IFUNIX do.
    if. x do.
      2!:1 cmd
    else.
      2!:1 cmd, (0=nox)#' 1>/dev/null &'
    end.
  else.
    (x{0 _1) fork_jtask_ cmd
  end.
catch.
  msg=. '|Could not run the editor:',cmd,LF
  msg=. msg,'|You can change the Editor definition in Edit|Configure|Base'
  smoutput msg
end.
EMPTY
)

linux_terminal=: <;._2]0 :0
x-terminal-emulator
gnome-terminal
mate-terminal
konsole
urxvt
rxvt
lxterminal
xfce4-terminal
eterm
terminator
terminology
st
xterm
)
dflttermemu=: verb define
nox=. ((<UNAME)e.'Linux';'OpenBSD';'FreeBSD') *. (0;'') e.~ <2!:5 'DISPLAY'
if. (((<UNAME)e.'Linux';'OpenBSD';'FreeBSD') > nox) *. ''-: te=. nox{::TermEmu_j_;TermEmu_nox_j_ do.
  for_t. linux_terminal do.
    try. 2!:0'which ',(>t),' 2>/dev/null'
      te=. >t
      break.
    catch. end.
  end.
end.
te
)
viewimage=: 3 : 0
if. -. isURL cmd=. dltb y do.
  if. -.fexist cmd do. EMPTY return. end.
end.
if. IFJHS do.
  redirecturl_jijxm_=: file2url cmd
  EMPTY return.
elseif. IFIOS>IFQT do.
  jh '<a href="',(file2url cmd),'"</a>'
  EMPTY return.
end.
nox=. ((<UNAME)e.'Linux';'OpenBSD';'FreeBSD') *. (0;'') e.~ <2!:5 'DISPLAY'
ImageViewer=. nox{::ImageViewer_j_;ImageViewer_nox_j_
select. UNAME
case. 'Win' do.
  ShellExecute=. 'shell32 ShellExecuteW > i x *w *w *w *w i'&cd
  SW_SHOWNORMAL=. 1
  NULL=. <0
  r=. ShellExecute 0;NULL;(uucp winpathsep cmd);NULL;NULL;SW_SHOWNORMAL
  if. r<33 do. sminfo 'view image error: ',cmd,LF2,1{::cderx'' end.
case. 'Android' do.
  android_exec_host 'android.intent.action.VIEW';(utf8 ('file://'&,)@abspath^:(-.@isURL) cmd);'image/*';0
case. do.
  if. 0 = #ImageViewer do.
    ImageViewer=. dfltimageviewer''
  end.
  if. 0 = #ImageViewer do.
    browser=. Browser_j_
    if. 0 = #browser do.
      browser=. dfltbrowser''
    end.
    browser=. dquote (browser;Browser_nox_j_){::~ nox=. ((<UNAME)e.'Linux';'OpenBSD';'FreeBSD') *. (0;'') e.~ <2!:5 'DISPLAY'
  else.
    browser=. dquote ImageViewer
  end.
  cmd=. browser,' ',dquote cmd
  try.
    2!:1 cmd, (0=nox)#' >/dev/null 2>&1 &'
  catch.
    msg=. 'Could not run the image viewer with the command:',LF2
    msg=. msg, cmd,LF2
    if. IFQT do.
      msg=. msg, 'You can change the imageviewer definition in Edit|Configure|Base',LF2
    end.
    sminfo 'Run image viewer';msg
  end.
end.
EMPTY
)
dfltimageviewer=: verb define
select. UNAME
case. 'Win' do. ''
case. 'Android' do. ''
case. 'Darwin' do. 'open'
case. do.
  try.
    2!:0'which xdg-open 2>/dev/null'
    'xdg-open' return. catch. end.
  try.
    2!:0'which eog 2>/dev/null'
    'eog' return. catch. end.
  '' return.
end.
)
cocurrent 'z'
jpath=: jpath_j_
load=: 3 : 0
0 load y
:
fls=. getscripts_j_ y
fn=. ('script',x#'d')~
for_fl. fls do.
  if. Displayload_j_ do. smoutput > fl end.
  if. -. fexist fl do.
    smoutput 'not found: ',>fl
  end.
  fn fl
  Loaded_j_=: ~. Loaded_j_,fl
end.
empty''
)
loadd=: 1&load
require=: 3 : 0
fls=. Loaded_j_ -.~ getscripts_j_ y
if. # fls do. load fls else. empty'' end.
)
scripts=: scripts_j_
show=: 3 : 0
y=. y,(0=#y)#0 1 2 3
if. (3!:0 y) e. 2 32 do. y=. cutopen y
else. y=. (4!:1 y) -. (,'y');,'y.' end.
wid=. {.wcsize''
sub=. '.'&(I. @(e.&(9 10 12 13 127 254 255{a.))@]})
den=: {{ try. 0 $.y [ 3 $. y catch. y end. }}
j=. '((1<#$t)#(":$t),''$''),":,t'
j=. 'if. L. t=. den ".y do. 5!:5 <y return. end.';j
j=. 'if. 0~:4!:0 <y do. 5!:5 <y return. end.';j
a=. (,&'=: ',sub @ (3 : j)) each y
}: ; ((wid <. #&> a) {.each a) ,each LF
)
xedit=: xedit_j_
wcsize=: 3 : 0
if. (IFQT+.IFJNET+.IFJHS+.IFIOS+.UNAME-:'Android') < IFUNIX do.
  |.@".@(-.&LF)@(2!:0) :: (Cwh_j_"_) '/bin/stty size 2>/dev/null'
else.
  (Cwh_j_"_)`((0 ". wd) :: (Cwh_j_"_))@.IFQT 'sm get termcwh'
end.
)
coclass 'jcompare'

MAXPFX=: 100
MAXLCS=: *: MAXPFX
cin=: e. ,
fmt0=: 'p<0 [>q<] >' & (8!:0)
fmt1=: 'p<1 [>q<] >' & (8!:0)
lcs=: * * 1 + >./\@:(_1&|.)@:(>./\"1@:(_1&|."1))
mindx=: }.@{.@/:~@(+/"1 ,. ])
remltws=: 3 : 0
y=. y, LF
dat=. <;._2 y
msk=. CR = {: &> dat
dat=. (-msk) }. each dat
fn=. #~ ([: (+./\ *. +./\.) -.@(e.&(' ',TAB)))
dat=. fn each dat
dat=. dat ,each msk{'';CR
}: ; dat ,each LF
)
comp=: 4 : 0

sep=. ((LF cin x) +. LF cin y) { CRLF
if. 2=#$x do. x=. <@dtb"1 x
else. x=. <;._2 x,sep -. {:x end.
if. 2=#$y do. y=. <@dtb"1 y
else. y=. <;._2 y,sep -. {:y end.
if. x -: y do. 'no difference' return. end.
XY=: x,y
AX=: X=: XY i. x
AY=: Y=: XY i. y
NX=: i.#x
NY=: i.#y
SX=: SY=: ''
while. compend'' do. complcs'' end.
sx=. /:~ SX
sy=. /:~ SY
x=. (fmt0 sx) ,each (sx { AX) { XY
y=. (fmt1 sy) ,each (sy { AY) { XY
r=. (x,y) /: (sx,.0),sy,.1
}: ; r ,each LF
)
fcomp=: 4 : 0
'p j n'=. 3 {. x
'ifws ifsep'=. 2 2 #: j
'x y'=. _2 {. ,&p each cutopen y
if. L. n do.
  'nx ny'=. n
else.
  nx=. x [ ny=. y
end.
f=. 1!:1 :: _1:
tx=. f x=. fboxname x
if. tx -: _1 do. 'unable to read ',nx return. end.
ty=. f y=. fboxname y
if. ty -: _1 do. 'unable to read ',ny return. end.
tx=. f2utf8 tx
ty=. f2utf8 ty
if. ifsep do.
  tx=. toJ tx
  ty=. toJ ty
end.
if. ifws do.
  tx=. remltws tx
  ty=. remltws ty
end.
f=. _3&{.@('0'&,@(":@]))
mth=. _3[\'   JanFebMarAprMayJunJulAugSepOctNovDec'
'a m d h n s'=. 6{.1 pick dx=. ,1!:0 x
fx=. (4":d),' ',(m{mth),'  ::' 0 3 6 9};f &.> 100|a,h,n,s
'a m d h n s'=. 6{.1 pick dy=. ,1!:0 y
fy=. (4":d),' ',(m{mth),'  ::' 0 3 6 9};f &.> 100|a,h,n,s
'nx ny'=. <"1>nx;ny
r=. 'comparing:',LF
r=. r,nx,fx,'  ',(":2 pick dx),LF
r=. r,ny,fy,'  ',(":2 pick dy),LF
r,tx compare ty
)
compare=: 4 : 0
if. x -: y do. 'no difference' return. end.
if. 0=#x do. 'empty left argument' return. end.
if. 0=#y do. 'empty right argument' return. end.
a=. conew 'jcompare'
r=. x comp__a y
coerase a
r
)
fcompare=: 3 : 0
('';0) fcomp y
:
(x;0) fcomp y
)
fcompares=: 3 : 0
('';1) fcomp y
:
(x;1) fcomp y
)
compend=: 3 : 0
old=. 0 0
len=. (#X),#Y

while. -. len -: old do.
  old=. len
  t=. <./len
  m=. 0 i.~ (t {. X) = t {. Y
  X=: m }. X
  Y=: m }. Y
  t=. m - t
  n=. - +/ *./\. (t {. X) = t {. Y
  X=: n }. X
  Y=: n }. Y
  NX=: m }. n }. NX
  NY=: m }. n }. NY
  m=. X e. Y
  if. 0 e. m do.
    SX=: SX,(-.m)#NX
    X=: m # X
    NX=: m # NX
  end.
  m=. Y e. X
  if. 0 e. m do.
    SY=: SY,(-.m)#NY
    Y=: m # Y
    NY=: m # NY
  end.
  len=. (#X),#Y
end.
if. -. 0 e. len do. 1 return. end.
SX=: SX,NX
SY=: SY,NY
0
)
complcs=: 3 : 0
lx=. #X
ly=. #Y
if. MAXLCS < lx * ly do.
  select. MAXPFX < lx,ly
  case. 0 1 do.
    ly=. <. MAXLCS % lx
  case. 1 0 do.
    lx=. <. MAXLCS % ly
  case. do.
    lx=. ly=. MAXPFX
  end.
end.
a=. lx {. X
b=. ly {. Y
m=. ((b =/ a),.0),0
cm=. lcs ^:_ m
len=. >./ ,cm
rc=. 1 + mindx ($cm) #: I. len = ,cm
cm=. , rc {. cm
msk=. (1+i.len) =/ cm
ndx=. <@I."1 msk
pos=. ; (<rc) #: each ndx
pos=. (+/"1 pos),.pos
pos=. ((# &> ndx) # i.len),.pos
pos=. /:~ pos
'ib ia'=. |: 2 }."1 (~:{."1 pos)#pos
n=. 1 + {: ia
SX=: SX,(<<<ia) { n {. NX
X=: n }. X
NX=: n }. NX
n=. 1 + {: ib
SY=: SY,(<<<ib) { n {. NY
Y=: n }. Y
NY=: n }. NY
0
)
compare_z_=: compare_jcompare_
fcompare_z_=: fcompare_jcompare_
fcompares_z_=: fcompares_jcompare_
cocurrent <'base'
NB. task
NB.
NB. executing tasks with optional timeout or I/O
NB.
NB. TASKS WITHOUT I/O
NB.
NB.   fork_jtask_ 'notepad.exe'           NB. run notepad, no wait, no I/O
NB.   5000 fork_jtask_ 'notepad.exe'      NB. run notepad, wait 5 sec, no I/O
NB.   _1 fork_jtask_ 'notepad.exe'        NB. run notepad, until closed, no I/O
NB.
NB.   5000 fork_jtask_ 'cmd /k dir'  NB. show dir in cmd window for 5 sec and close
NB.   _1 fork_jtask_ 'cmd /k dir'    NB. show dir in cmd window until user closes it
NB.
NB.   launch jpath'~system'        NB. run default application, no wait
NB.
NB. TASKS WITH I/O
NB.
NB.   spawn_jtask_ 'net users'                    NB. get stdout from process
NB.   '+/i.3 4' spawn_jtask_ 'jconsole'           NB. call process with I/O
NB.   12 15 18 21
NB.
NB. SHELL COMMANDS (WITH I/O)
NB.
NB.   shell'echo.|time'                    NB. get result of shell command
NB. The current time is:  8:04:13.09
NB. Enter the new time:
NB.
NB.   (shell'dir /b')shell'find ".dll"'    NB. get all DDL names by piping
NB. j.dll
NB. jregexp.dll
NB.
NB. NOTE: the implementation uses C-type structures
NB.       by the original Method of Named Fields
NB.
NB. Script developed by Oleg Kobchenko.

coclass <'jtask'
NB. task util

int=: {.@:(_2&ic)
sint=: 2&ic

i64=: {.@:(_3&ic)
si64=: 3&ic

ptr=: int`i64@.IF64
sptr=: sint`si64@.IF64

NB. =========================================================
NB. METHOD OF NAMED FIELDS
sndx=: i.@#@[ + {.@I.@E.

NB. struct=. 'valu' 'memb' sset structdef struct
sset=: 2 : '(m sndx n)}'

NB. value=. 'memb' sget structdef struct
sget=: 2 : '(m sndx n)&{'

szero=: # # (0{a.)"_

st64=: -.&'.'^:(-.IF64)

t=. 'Cbyt....Resv....Desk....Titl....XposYposXsizYsizXcntYcnt'
STARTUPINFO=:  st64 t,'FillFlagSwRs....Resv....Inph....Outh....Errh....'
PROCESSINFO=:  st64 'Proh....Thrh....PridThid'
SECURITYATTR=: st64 'Cbyt....Secd....Inhe'

'Outh Errh Inph Proh Thrh'=: ,"1&'....'^:IF64>;:'Outh Errh Inph Proh Thrh'

STARTF_USESTDHANDLES=: 16b100
STARTF_USESHOWWINDOW=: 1
WAIT_TIMEOUT=: 258
CREATE_NEW_CONSOLE=: 16b10
DUPLICATE_SAME_ACCESS=: 2

cdk=: 1 : '(''kernel32 '',m)&cd'

WaitForSingleObject=: 'WaitForSingleObject > i x i' cdk
CloseHandle=:         'CloseHandle         > i x' cdk"0
TerminateProcess=:    'TerminateProcess    > i x i' cdk
ReadFile=:            'ReadFile              i x *c i *i x' cdk
WriteFile=:           'WriteFile             i x *c i *i x' cdk
GetCurrentProcess=:   'GetCurrentProcess   > x' cdk

DuplicateHandleF=:    'DuplicateHandle       i  x x  x *x  i i i' cdk
CreatePipeF=:         'CreatePipe            i *x *x *c i' cdk
CreateProcessF=:      'CreateProcessW        i x *w x x i  i x x *c *c' cdk

DuplicateHandle=: 3 : 0
p=. GetCurrentProcess ''
h=. {. 4{:: DuplicateHandleF p;y;p;(,_1);0;0;DUPLICATE_SAME_ACCESS
CloseHandle y
h
)

NB. =========================================================
NB. 'hRead hWrite'=. CreatePipe Inheritable=0
NB.    ... FileRead/FileWrite ...
NB. CloseHandle hRead,hWrite
NB.
NB. Inheritable: 0 none, 1 for read, 2 for write
CreatePipe=: 3 : 0
'inh size'=. 2{.y,0
sa=. szero SECURITYATTR
sa=. (sint #SECURITYATTR) 'Cbyt' sset SECURITYATTR sa
sa=. (sint *inh) 'Inhe' sset SECURITYATTR sa
'hRead hWrite'=. ; 1 2{ CreatePipeF (,_1);(,_1);sa;size
if. 1=inh do. hRead=. DuplicateHandle hRead end.
if. 2=inh do. hWrite=. DuplicateHandle hWrite end.
hRead,hWrite
)

NB. =========================================================
NB. hProcess=. [hWriteOut[,hReadIn]] CreateProcess 'program agr1 agr2 ...'
NB.    ...
NB. CloseHandle hProcess
CreateProcess=: 3 : 0
'' CreateProcess y
:
'ow ir'=. 2{.x,0
si=. szero STARTUPINFO
si=. (sint #STARTUPINFO) 'Cbyt' sset STARTUPINFO si
f=. inh=. 0
if. +/ir,ow do.
  inh=. 1
  f=. CREATE_NEW_CONSOLE
  si=. (sint STARTF_USESTDHANDLES+STARTF_USESHOWWINDOW) 'Flag' sset STARTUPINFO si
  if. ow do.
    si=. (sptr ow) Outh sset STARTUPINFO si
    si=. (sptr ow) Errh sset STARTUPINFO si
  end.
  if. ir do. si=. (sptr ir) Inph sset STARTUPINFO si end.
end.
pi=. szero PROCESSINFO
'r pi'=. 0 _1{ CreateProcessF 0;(uucp y);0;0;inh; f;0;0;si;pi
if. 0=r do. 0 return. end.
ph=. ptr Proh sget PROCESSINFO pi
th=. ptr Thrh sget PROCESSINFO pi
CloseHandle th
ph
)

NB. =========================================================
NB. ph=. h CreateProcess 'program agr1 agr2 ...'
NB.    ...
NB. Wait ph;5000
NB. CloseHandle ph
Wait=: 3 : 0
r=. WaitForSingleObject y
if. WAIT_TIMEOUT=r do. TerminateProcess (0 pick y);_1 end.
)

NB. =========================================================
NB. ph=. h CreateProcess 'program agr1 agr2 ...'
NB.    ...
NB. r=. ReadAll h
NB. CloseHandle h,ph
ReadAll=: 3 : 0
ret=. ''
str=. 4096#'z'
while. 1 do.
  'r str len'=. 0 2 4{ ReadFile y;str;(#str);(,_1);0
  len=. {.len
  if. (0=r)+.0=len do.
    'ec es'=: cderx''
    if. -.ec e.0 109 do. ret=. _1 end.
    break.
  end.
  ret=. ret,len{.str
end.
ret
)

NB. =========================================================
NB. ph=. hr,hw CreateProcess 'program agr1 agr2 ...'
NB. r=. WriteAll hw
NB. CloseHandle hw
NB. r=. ReadAll hr
NB. CloseHandle hr,ph
WriteAll=: 3 : 0
:
while. #x do.
  'r x len'=. 0 2 4{ WriteFile y;x;(#x);(,_1);0
  len=. {.len
  if. (0=r)+.0=len do.
    'ec es'=: cderx''
    if. -.ec e.0 109 do. ret=. _1 end.
    break.
  end.
  x=. len}.x
end.
1
)
NB. task main

NB. =========================================================
NB.*fork v run task and optionally wait for completion
NB.
NB. form: [timeout=0] fork cmdline
NB.
NB.   timeout: 0 no wait, _1 infinite, >0 timeout
NB.   cmdline: 'shortcmd arg1 arg2 ...'
NB.   cmdline: '"command with space" arg1 ...'
NB.
NB. e.g. fork_jtask_ 'notepad.exe'
fork=: (3 : 0)`([: 2!:1 '(' , ')&' ,~ ])@.IFUNIX
0 fork y
:
ph=. CreateProcess y
if. x do. Wait ph;x end.
CloseHandle ph
empty''
)

NB. =========================================================
NB.*spawn v [monad] get stdout of executed task
NB.
NB. form:  stdout=. spawn cmdline
NB.
NB.   stdout: _1 fail, '' or stdout stream value if success
NB.   cmdline: 'shortcmd arg1 arg2 ...'
NB.   cmdline: '"command with space" arg1 ...'
NB.
NB. e.g. spawn 'net users'

NB.*spawn v [dyad] send stdin and get stdout of task
NB.
NB. form: stdout=. [stdin=''] spawn cmdline
NB.
NB.   stdin: input to stream as stdin, '' no input
NB.
NB. e.g. 'i.3 4'spawn'jconsole'
spawn=: (3 : 0)`(2!:0@])@.IFUNIX
'' spawn y
:
'or ow'=. CreatePipe 1
'ir iw'=. CreatePipe 2,#x
ph=. (ow,ir) CreateProcess y
CloseHandle ir
if. #x do. x WriteAll iw end.
CloseHandle iw
CloseHandle ow
r=. ReadAll or
CloseHandle or
CloseHandle ph
r
)

NB. =========================================================
NB.*shell v [monad] get stdout of shell command
NB.
NB.   e.g. shell 'dir /b/s'

NB.*shell v [dyad] send stdin and get stdout of shell command
NB.
NB.   e.g. (shell 'dir /b/s') shell 'find ".dll"'
SHELL=: IFUNIX{::'cmd /c ';''

shell=: ''&$: : (spawn SHELL,])

NB. =========================================================
NB.*launch v [monad] launch default application for parameter
NB.
NB.    launch jpath'~system'              NB. file manager
NB.    launch jpath'~bin/installer.txt'   NB. text editor
NB.    launch 'http://jsoftware.com'      NB. web browser

3 : 0''
LAUNCH=: ('gnome-open';'gnome-open';'gnome-open';'open';'start';'') {::~ ('Linux';'OpenBSD';'FreeBSD';'Darwin';'Win')i.<UNAME
if. 0=nc<'LAUNCH_j_'do.if. 0<#LAUNCH_j_ do.LAUNCH=: LAUNCH_j_ end.end.
)
launch=: 3 : 'shell LAUNCH,'' '',y'
NB. task zdefs

NB. fork_z_=: fork_jtask_
NB. spawn_z_=: spawn_jtask_
shell_z_=: shell_jtask_
launch_z_=: launch_jtask_
load_z_=: require_z_=: script_z_=: ]
hostdefs_aix_j_=: 0 : 0
NB. do not edit -- created by sym2ijs
cocurrent<'jdefs'

F_OK=: 0
R_OK=: 4
W_OK=: 2
X_OK=: 1
STDIN_FILENO=: 0
STDOUT_FILENO=: 1
STDERR_FILENO=: 2
SEEK_CUR=: 1
SEEK_END=: 2
SEEK_SET=: 0

O_APPEND=: 8
O_CREAT=: 256
O_EXCL=: 1024
O_RDONLY=: 0
O_RDWR=: 2
O_TRUNC=: 512
O_WRONLY=: 1

O_ACCMODE=: 3
O_NOCTTY=: 2048
O_NONBLOCK=: 4
FD_CLOEXEC=: 1
F_DUPFD=: 0
F_GETFD=: 1
F_SETFD=: 2
F_GETFL=: 3
F_SETFL=: 4
F_SETLK=: 6
F_SETLKW=: 7
F_GETLK=: 5
F_UNLCK=: 3
F_WRLCK=: 2
flock_sz=: 24
l_len_off=: 8
l_len_sz=: 4
l_pid_off=: 16
l_pid_sz=: 4
l_start_off=: 4
l_start_sz=: 4
l_type_off=: 0
l_type_sz=: 2
l_whence_off=: 2
l_whence_sz=: 2

PROT_READ=: 1
PROT_WRITE=: 2
PROT_EXEC=: 4
PROT_NONE=: 0
MAP_SHARED=: 1
MAP_PRIVATE=: 2
MAP_FIXED=: 256

REG_EXTENDED=: 1
REG_ICASE=: 2
REG_NOSUB=: 8
REG_NEWLINE=: 4

regex_t_sz=: 360
re_nsub_off=: 0
re_nsub_sz=: 4
regmatch_t_sz=: 8
rm_so_off=: 0
rm_so_sz=: 4
rm_eo_off=: 4
rm_eo_sz=: 4


fd_set_sz=: 4096
fds_bits_off=: 0
fds_bits_sz=: 4096
FD_SETSIZE=: 32767
timeval_sz=: 8
tv_sec_off=: 0
tv_sec_sz=: 4
tv_usec_off=: 4
tv_usec_sz=: 4

E2BIG=: 7
EFAULT=: 14
ENFILE=: 23
ENOTTY=: 25
EACCES=: 13
EFBIG=: 27
ENODEV=: 19
ENXIO=: 6
EAGAIN=: 11
ENOENT=: 2
EPERM=: 1
EBADF=: 9
EINTR=: 4
ENOEXEC=: 8
EPIPE=: 32
EINVAL=: 22
ENOLCK=: 49
ERANGE=: 34
EBUSY=: 16
EIO=: 5
ENOMEM=: 12
EROFS=: 30
EISDIR=: 21
ENOSPC=: 28
ESPIPE=: 29
ECHILD=: 10
EMFILE=: 24
ENOSYS=: 109
ESRCH=: 3
EDEADLK=: 45
EMLINK=: 31
ENOTDIR=: 20
EDOM=: 33
ENOTEMPTY=: 17
EXDEV=: 18
EEXIST=: 17
ENAMETOOLONG=: 86

EINPROGRESS=: 55
ECANCELED=: 117
ETIMEDOUT=: 78
EMSGSIZE=: 59
ENOTSUP=: 124
)
hostdefs_android_j_=: 0 : 0
NB. do not edit -- created by sym2ijs

cocurrent <'jdefs'

F_OK=: 0
R_OK=: 4
W_OK=: 2
X_OK=: 1
STDIN_FILENO=: 0
STDOUT_FILENO=: 1
STDERR_FILENO=: 2
SEEK_CUR=: 1
SEEK_END=: 2
SEEK_SET=: 0

O_APPEND=: 1024
O_CREAT=: 64
O_EXCL=: 128
O_RDONLY=: 0
O_RDWR=: 2
O_TRUNC=: 512
O_WRONLY=: 1

O_ACCMODE=: 3
O_NOCTTY=: 256
O_NONBLOCK=: 2048
FD_CLOEXEC=: 1
F_DUPFD=: 0
F_GETFD=: 1
F_SETFD=: 2
F_GETFL=: 3
F_SETFL=: 4
F_SETLK=: 6
F_SETLKW=: 7
F_GETLK=: 5
F_UNLCK=: 2
F_WRLCK=: 1
flock_sz=: 16
l_len_off=: 8
l_len_sz=: 4
l_pid_off=: 12
l_pid_sz=: 4
l_start_off=: 4
l_start_sz=: 4
l_type_off=: 0
l_type_sz=: 2
l_whence_off=: 2
l_whence_sz=: 2

PROT_READ=: 1
PROT_WRITE=: 2
PROT_EXEC=: 4
PROT_NONE=: 0
MAP_SHARED=: 1
MAP_PRIVATE=: 2
MAP_FIXED=: 16

REG_EXTENDED=: 1
REG_ICASE=: 2
REG_NOSUB=: 4
REG_NEWLINE=: 8

regex_t_sz=: 16
re_nsub_off=: 4
re_nsub_sz=: 4
regmatch_t_sz=: 8
rm_so_off=: 0
rm_so_sz=: 4
rm_eo_off=: 4
rm_eo_sz=: 4


fd_set_sz=: 128
fds_bits_off=: 0
fds_bits_sz=: 128
FD_SETSIZE=: 1024
timeval_sz=: 8
tv_sec_off=: 0
tv_sec_sz=: 4
tv_usec_off=: 4
tv_usec_sz=: 4

E2BIG=: 7
EFAULT=: 14
ENFILE=: 23
ENOTTY=: 25
EACCES=: 13
EFBIG=: 27
ENODEV=: 19
ENXIO=: 6
EAGAIN=: 11
ENOENT=: 2
EPERM=: 1
EBADF=: 9
EINTR=: 4
ENOEXEC=: 8
EPIPE=: 32
EINVAL=: 22
ENOLCK=: 37
ERANGE=: 34
EBUSY=: 16
EIO=: 5
ENOMEM=: 12
EROFS=: 30
EISDIR=: 21
ENOSPC=: 28
ESPIPE=: 29
ECHILD=: 10
EMFILE=: 24
ENOSYS=: 38
ESRCH=: 3
EDEADLK=: 35
EMLINK=: 31
ENOTDIR=: 20
EDOM=: 33
ENOTEMPTY=: 39
EXDEV=: 18
EEXIST=: 17
ENAMETOOLONG=: 36

EINPROGRESS=: 115
ECANCELED=: 125
ETIMEDOUT=: 110
EMSGSIZE=: 90
ENOTSUP=: 95
)
hostdefs_android_64_j_=: 0 : 0
NB. do not edit -- created by sym2ijs

cocurrent <'jdefs'

F_OK=: 0
R_OK=: 4
W_OK=: 2
X_OK=: 1
STDIN_FILENO=: 0
STDOUT_FILENO=: 1
STDERR_FILENO=: 2
SEEK_CUR=: 1
SEEK_END=: 2
SEEK_SET=: 0

O_APPEND=: 1024
O_CREAT=: 64
O_EXCL=: 128
O_RDONLY=: 0
O_RDWR=: 2
O_TRUNC=: 512
O_WRONLY=: 1

O_ACCMODE=: 3
O_NOCTTY=: 256
O_NONBLOCK=: 2048
FD_CLOEXEC=: 1
F_DUPFD=: 0
F_GETFD=: 1
F_SETFD=: 2
F_GETFL=: 3
F_SETFL=: 4
F_SETLK=: 6
F_SETLKW=: 7
F_GETLK=: 5
F_UNLCK=: 2
F_WRLCK=: 1
flock_sz=: 32
l_len_off=: 16
l_len_sz=: 8
l_pid_off=: 24
l_pid_sz=: 4
l_start_off=: 8
l_start_sz=: 8
l_type_off=: 0
l_type_sz=: 2
l_whence_off=: 2
l_whence_sz=: 2

PROT_READ=: 1
PROT_WRITE=: 2
PROT_EXEC=: 4
PROT_NONE=: 0
MAP_SHARED=: 1
MAP_PRIVATE=: 2
MAP_FIXED=: 16

REG_EXTENDED=: 1
REG_ICASE=: 2
REG_NOSUB=: 4
REG_NEWLINE=: 8

regex_t_sz=: 32
re_nsub_off=: 8
re_nsub_sz=: 8
regmatch_t_sz=: 16
rm_so_off=: 0
rm_so_sz=: 8
rm_eo_off=: 8
rm_eo_sz=: 8


fd_set_sz=: 128
fds_bits_off=: 0
fds_bits_sz=: 128
FD_SETSIZE=: 1024
timeval_sz=: 16
tv_sec_off=: 0
tv_sec_sz=: 8
tv_usec_off=: 8
tv_usec_sz=: 8

E2BIG=: 7
EFAULT=: 14
ENFILE=: 23
ENOTTY=: 25
EACCES=: 13
EFBIG=: 27
ENODEV=: 19
ENXIO=: 6
EAGAIN=: 11
ENOENT=: 2
EPERM=: 1
EBADF=: 9
EINTR=: 4
ENOEXEC=: 8
EPIPE=: 32
EINVAL=: 22
ENOLCK=: 37
ERANGE=: 34
EBUSY=: 16
EIO=: 5
ENOMEM=: 12
EROFS=: 30
EISDIR=: 21
ENOSPC=: 28
ESPIPE=: 29
ECHILD=: 10
EMFILE=: 24
ENOSYS=: 38
ESRCH=: 3
EDEADLK=: 35
EMLINK=: 31
ENOTDIR=: 20
EDOM=: 33
ENOTEMPTY=: 39
EXDEV=: 18
EEXIST=: 17
ENAMETOOLONG=: 36

EINPROGRESS=: 115
ECANCELED=: 125
ETIMEDOUT=: 110
EMSGSIZE=: 90
ENOTSUP=: 95
)
hostdefs_darwin_j_=: 0 : 0
NB. do not edit -- created by sym2ijs
cocurrent<'jdefs'

F_OK =: 0
R_OK =: 4
W_OK =: 2
X_OK =: 1
STDIN_FILENO =: 0
STDOUT_FILENO =: 1
STDERR_FILENO =: 2
SEEK_CUR =: 1
SEEK_END =: 2
SEEK_SET =: 0

O_APPEND =: 8
O_CREAT =: 512
O_EXCL =: 2048
O_RDONLY =: 0
O_RDWR =: 2
O_TRUNC =: 1024
O_WRONLY =: 1

O_ACCMODE =: 3
O_NOCTTY =: 0
O_NONBLOCK =: 4
FD_CLOEXEC =: 1
F_DUPFD =: 0
F_GETFD =: 1
F_SETFD =: 2
F_GETFL =: 3
F_SETFL =: 4
F_SETLK =: 8
F_SETLKW =: 9
F_GETLK =: 7
F_UNLCK =: 2
F_WRLCK =: 3
flock_sz =: 24
l_len_off =: 8
l_len_sz =: 8
l_pid_off =: 16
l_pid_sz =: 4
l_start_off =: 0
l_start_sz =: 8
l_type_off =: 20
l_type_sz =: 2
l_whence_off =: 22
l_whence_sz =: 2

PROT_READ =: 1
PROT_WRITE =: 2
PROT_EXEC =: 4
PROT_NONE =: 0
MAP_SHARED =: 1
MAP_PRIVATE =: 2
MAP_FIXED =: 16

REG_EXTENDED =: 1
REG_ICASE =: 2
REG_NOSUB =: 4
REG_NEWLINE =: 8

regex_t_sz =: 16
re_nsub_off =: 4
re_nsub_sz =: 4
regmatch_t_sz =: 16
rm_so_off =: 4
rm_so_sz =: 4
rm_eo_off =: 12
rm_eo_sz =: 4


fd_set_sz =: 128
fds_bits_off =: 0
fds_bits_sz =: 128
FD_SETSIZE =: 1024
timeval_sz =: 8
tv_sec_off =: 0
tv_sec_sz =: 4
tv_usec_off =: 4
tv_usec_sz =: 4

E2BIG =: 7
EFAULT =: 14
ENFILE =: 23
ENOTTY =: 25
EACCES =: 13
EFBIG =: 27
ENODEV =: 19
ENXIO =: 6
EAGAIN =: 35
ENOENT =: 2
EPERM =: 1
EBADF =: 9
EINTR =: 4
ENOEXEC =: 8
EPIPE =: 32
EINVAL =: 22
ENOLCK =: 77
ERANGE =: 34
EBUSY =: 16
EIO =: 5
ENOMEM =: 12
EROFS =: 30
EISDIR =: 21
ENOSPC =: 28
ESPIPE =: 29
ECHILD =: 10
EMFILE =: 24
ENOSYS =: 78
ESRCH =: 3
EDEADLK =: 11
EMLINK =: 31
ENOTDIR =: 20
EDOM =: 33
ENOTEMPTY =: 66
EXDEV =: 18
EEXIST =: 17
ENAMETOOLONG =: 63

EINPROGRESS =: 36
ECANCELED =: 89
ETIMEDOUT =: 60
EMSGSIZE =: 40
ENOTSUP =: 45
)
hostdefs_darwin_64_j_=: 0 : 0
NB. do not edit -- created by sym2ijs

cocurrent <'jdefs'

F_OK=: 0
R_OK=: 4
W_OK=: 2
X_OK=: 1
STDIN_FILENO=: 0
STDOUT_FILENO=: 1
STDERR_FILENO=: 2
SEEK_CUR=: 1
SEEK_END=: 2
SEEK_SET=: 0

O_APPEND=: 8
O_CREAT=: 512
O_EXCL=: 2048
O_RDONLY=: 0
O_RDWR=: 2
O_TRUNC=: 1024
O_WRONLY=: 1

O_ACCMODE=: 3
O_NOCTTY=: 131072
O_NONBLOCK=: 4
FD_CLOEXEC=: 1
F_DUPFD=: 0
F_GETFD=: 1
F_SETFD=: 2
F_GETFL=: 3
F_SETFL=: 4
F_SETLK=: 8
F_SETLKW=: 9
F_GETLK=: 7
F_UNLCK=: 2
F_WRLCK=: 3
flock_sz=: 24
l_len_off=: 8
l_len_sz=: 8
l_pid_off=: 16
l_pid_sz=: 4
l_start_off=: 0
l_start_sz=: 8
l_type_off=: 20
l_type_sz=: 2
l_whence_off=: 22
l_whence_sz=: 2

PROT_READ=: 1
PROT_WRITE=: 2
PROT_EXEC=: 4
PROT_NONE=: 0
MAP_SHARED=: 1
MAP_PRIVATE=: 2
MAP_FIXED=: 16

REG_EXTENDED=: 1
REG_ICASE=: 2
REG_NOSUB=: 4
REG_NEWLINE=: 8

regex_t_sz=: 32
re_nsub_off=: 8
re_nsub_sz=: 8
regmatch_t_sz=: 16
rm_so_off=: 0
rm_so_sz=: 8
rm_eo_off=: 8
rm_eo_sz=: 8


fd_set_sz=: 128
fds_bits_off=: 0
fds_bits_sz=: 128
FD_SETSIZE=: 1024
timeval_sz=: 16
tv_sec_off=: 0
tv_sec_sz=: 8
tv_usec_off=: 8
tv_usec_sz=: 4

E2BIG=: 7
EFAULT=: 14
ENFILE=: 23
ENOTTY=: 25
EACCES=: 13
EFBIG=: 27
ENODEV=: 19
ENXIO=: 6
EAGAIN=: 35
ENOENT=: 2
EPERM=: 1
EBADF=: 9
EINTR=: 4
ENOEXEC=: 8
EPIPE=: 32
EINVAL=: 22
ENOLCK=: 77
ERANGE=: 34
EBUSY=: 16
EIO=: 5
ENOMEM=: 12
EROFS=: 30
EISDIR=: 21
ENOSPC=: 28
ESPIPE=: 29
ECHILD=: 10
EMFILE=: 24
ENOSYS=: 78
ESRCH=: 3
EDEADLK=: 11
EMLINK=: 31
ENOTDIR=: 20
EDOM=: 33
ENOTEMPTY=: 66
EXDEV=: 18
EEXIST=: 17
ENAMETOOLONG=: 63

EINPROGRESS=: 36
ECANCELED=: 89
ETIMEDOUT=: 60
EMSGSIZE=: 40
ENOTSUP=: 45
)
hostdefs_freebsd_64_j_=: 0 : 0
NB. do not edit -- created by sym2ijs

cocurrent <'jdefs'

F_OK=: 0
R_OK=: 4
W_OK=: 2
X_OK=: 1
STDIN_FILENO=: 0
STDOUT_FILENO=: 1
STDERR_FILENO=: 2
SEEK_CUR=: 1
SEEK_END=: 2
SEEK_SET=: 0

O_APPEND=: 8
O_CREAT=: 512
O_EXCL=: 2048
O_RDONLY=: 0
O_RDWR=: 2
O_TRUNC=: 1024
O_WRONLY=: 1

O_ACCMODE=: 3
O_NOCTTY=: 32768
O_NONBLOCK=: 4
FD_CLOEXEC=: 1
F_DUPFD=: 0
F_GETFD=: 1
F_SETFD=: 2
F_GETFL=: 3
F_SETFL=: 4
F_SETLK=: 12
F_SETLKW=: 13
F_GETLK=: 11
F_UNLCK=: 2
F_WRLCK=: 3
flock_sz=: 32
l_len_off=: 8
l_len_sz=: 8
l_pid_off=: 16
l_pid_sz=: 4
l_start_off=: 0
l_start_sz=: 8
l_type_off=: 20
l_type_sz=: 2
l_whence_off=: 22
l_whence_sz=: 2

PROT_READ=: 1
PROT_WRITE=: 2
PROT_EXEC=: 4
PROT_NONE=: 0
MAP_SHARED=: 1
MAP_PRIVATE=: 2
MAP_FIXED=: 16

REG_EXTENDED=: 1
REG_ICASE=: 2
REG_NOSUB=: 4
REG_NEWLINE=: 8

regex_t_sz=: 32
re_nsub_off=: 8
re_nsub_sz=: 8
regmatch_t_sz=: 16
rm_so_off=: 0
rm_so_sz=: 8
rm_eo_off=: 8
rm_eo_sz=: 8


fd_set_sz=: 128
fds_bits_off=: 0
fds_bits_sz=: 128
FD_SETSIZE=: 1024
timeval_sz=: 16
tv_sec_off=: 0
tv_sec_sz=: 8
tv_usec_off=: 8
tv_usec_sz=: 8

E2BIG=: 7
EFAULT=: 14
ENFILE=: 23
ENOTTY=: 25
EACCES=: 13
EFBIG=: 27
ENODEV=: 19
ENXIO=: 6
EAGAIN=: 35
ENOENT=: 2
EPERM=: 1
EBADF=: 9
EINTR=: 4
ENOEXEC=: 8
EPIPE=: 32
EINVAL=: 22
ENOLCK=: 77
ERANGE=: 34
EBUSY=: 16
EIO=: 5
ENOMEM=: 12
EROFS=: 30
EISDIR=: 21
ENOSPC=: 28
ESPIPE=: 29
ECHILD=: 10
EMFILE=: 24
ENOSYS=: 78
ESRCH=: 3
EDEADLK=: 11
EMLINK=: 31
ENOTDIR=: 20
EDOM=: 33
ENOTEMPTY=: 66
EXDEV=: 18
EEXIST=: 17
ENAMETOOLONG=: 63

EINPROGRESS=: 36
ECANCELED=: 85
ETIMEDOUT=: 60
EMSGSIZE=: 40
ENOTSUP=: 45
)
hostdefs_linux_j_=: 0 : 0
NB. do not edit -- created by sym2ijs
cocurrent<'jdefs'

F_OK=: 0
R_OK=: 4
W_OK=: 2
X_OK=: 1
STDIN_FILENO=: 0
STDOUT_FILENO=: 1
STDERR_FILENO=: 2
SEEK_CUR=: 1
SEEK_END=: 2
SEEK_SET=: 0

O_APPEND=: 1024
O_CREAT=: 64
O_EXCL=: 128
O_RDONLY=: 0
O_RDWR=: 2
O_TRUNC=: 512
O_WRONLY=: 1

O_ACCMODE=: 3
O_NOCTTY=: 256
O_NONBLOCK=: 2048
FD_CLOEXEC=: 1
F_DUPFD=: 0
F_GETFD=: 1
F_SETFD=: 2
F_GETFL=: 3
F_SETFL=: 4
F_SETLK=: 6
F_SETLKW=: 7
F_GETLK=: 5
F_UNLCK=: 2
F_WRLCK=: 1
flock_sz=: 16
l_len_off=: 8
l_len_sz=: 4
l_pid_off=: 12
l_pid_sz=: 4
l_start_off=: 4
l_start_sz=: 4
l_type_off=: 0
l_type_sz=: 2
l_whence_off=: 2
l_whence_sz=: 2

PROT_READ=: 1
PROT_WRITE=: 2
PROT_EXEC=: 4
PROT_NONE=: 0
MAP_SHARED=: 1
MAP_PRIVATE=: 2
MAP_FIXED=: 16

REG_EXTENDED=: 1
REG_ICASE=: 2
REG_NOSUB=: 8
REG_NEWLINE=: 4

regex_t_sz=: 32
re_nsub_off=: 24
re_nsub_sz=: 4
regmatch_t_sz=: 8
rm_so_off=: 0
rm_so_sz=: 4
rm_eo_off=: 4
rm_eo_sz=: 4


fd_set_sz=: 128
fds_bits_off=: 0
fds_bits_sz=: 128
FD_SETSIZE=: 1024
timeval_sz=: 8
tv_sec_off=: 0
tv_sec_sz=: 4
tv_usec_off=: 4
tv_usec_sz=: 4

E2BIG=: 7
EFAULT=: 14
ENFILE=: 23
ENOTTY=: 25
EACCES=: 13
EFBIG=: 27
ENODEV=: 19
ENXIO=: 6
EAGAIN=: 11
ENOENT=: 2
EPERM=: 1
EBADF=: 9
EINTR=: 4
ENOEXEC=: 8
EPIPE=: 32
EINVAL=: 22
ENOLCK=: 37
ERANGE=: 34
EBUSY=: 16
EIO=: 5
ENOMEM=: 12
EROFS=: 30
EISDIR=: 21
ENOSPC=: 28
ESPIPE=: 29
ECHILD=: 10
EMFILE=: 24
ENOSYS=: 38
ESRCH=: 3
EDEADLK=: 35
EMLINK=: 31
ENOTDIR=: 20
EDOM=: 33
ENOTEMPTY=: 39
EXDEV=: 18
EEXIST=: 17
ENAMETOOLONG=: 36

EINPROGRESS=: 115
ECANCELED=: 125
ETIMEDOUT=: 110
EMSGSIZE=: 90
ENOTSUP=: 95
)
hostdefs_linux_64_j_=: 0 : 0
NB. do not edit -- created by sym2ijs

cocurrent <'jdefs'

F_OK=: 0
R_OK=: 4
W_OK=: 2
X_OK=: 1
STDIN_FILENO=: 0
STDOUT_FILENO=: 1
STDERR_FILENO=: 2
SEEK_CUR=: 1
SEEK_END=: 2
SEEK_SET=: 0

O_APPEND=: 1024
O_CREAT=: 64
O_EXCL=: 128
O_RDONLY=: 0
O_RDWR=: 2
O_TRUNC=: 512
O_WRONLY=: 1

O_ACCMODE=: 3
O_NOCTTY=: 256
O_NONBLOCK=: 2048
FD_CLOEXEC=: 1
F_DUPFD=: 0
F_GETFD=: 1
F_SETFD=: 2
F_GETFL=: 3
F_SETFL=: 4
F_SETLK=: 6
F_SETLKW=: 7
F_GETLK=: 5
F_UNLCK=: 2
F_WRLCK=: 1
flock_sz=: 32
l_len_off=: 16
l_len_sz=: 8
l_pid_off=: 24
l_pid_sz=: 4
l_start_off=: 8
l_start_sz=: 8
l_type_off=: 0
l_type_sz=: 2
l_whence_off=: 2
l_whence_sz=: 2

PROT_READ=: 1
PROT_WRITE=: 2
PROT_EXEC=: 4
PROT_NONE=: 0
MAP_SHARED=: 1
MAP_PRIVATE=: 2
MAP_FIXED=: 16

REG_EXTENDED=: 1
REG_ICASE=: 2
REG_NOSUB=: 8
REG_NEWLINE=: 4

regex_t_sz=: 64
re_nsub_off=: 48
re_nsub_sz=: 8
regmatch_t_sz=: 8
rm_so_off=: 0
rm_so_sz=: 4
rm_eo_off=: 4
rm_eo_sz=: 4


fd_set_sz=: 128
fds_bits_off=: 0
fds_bits_sz=: 128
FD_SETSIZE=: 1024
timeval_sz=: 16
tv_sec_off=: 0
tv_sec_sz=: 8
tv_usec_off=: 8
tv_usec_sz=: 8

E2BIG=: 7
EFAULT=: 14
ENFILE=: 23
ENOTTY=: 25
EACCES=: 13
EFBIG=: 27
ENODEV=: 19
ENXIO=: 6
EAGAIN=: 11
ENOENT=: 2
EPERM=: 1
EBADF=: 9
EINTR=: 4
ENOEXEC=: 8
EPIPE=: 32
EINVAL=: 22
ENOLCK=: 37
ERANGE=: 34
EBUSY=: 16
EIO=: 5
ENOMEM=: 12
EROFS=: 30
EISDIR=: 21
ENOSPC=: 28
ESPIPE=: 29
ECHILD=: 10
EMFILE=: 24
ENOSYS=: 38
ESRCH=: 3
EDEADLK=: 35
EMLINK=: 31
ENOTDIR=: 20
EDOM=: 33
ENOTEMPTY=: 39
EXDEV=: 18
EEXIST=: 17
ENAMETOOLONG=: 36

EINPROGRESS=: 115
ECANCELED=: 125
ETIMEDOUT=: 110
EMSGSIZE=: 90
ENOTSUP=: 95
)
hostdefs_openbsd_64_j_=: 0 : 0
NB. do not edit -- created by sym2ijs

cocurrent <'jdefs'

F_OK=: 0
R_OK=: 4
W_OK=: 2
X_OK=: 1
STDIN_FILENO=: 0
STDOUT_FILENO=: 1
STDERR_FILENO=: 2
SEEK_CUR=: 1
SEEK_END=: 2
SEEK_SET=: 0

O_APPEND=: 8
O_CREAT=: 512
O_EXCL=: 2048
O_RDONLY=: 0
O_RDWR=: 2
O_TRUNC=: 1024
O_WRONLY=: 1

O_ACCMODE=: 3
O_NOCTTY=: 32768
O_NONBLOCK=: 4
FD_CLOEXEC=: 1
F_DUPFD=: 0
F_GETFD=: 1
F_SETFD=: 2
F_GETFL=: 3
F_SETFL=: 4
F_SETLK=: 8
F_SETLKW=: 9
F_GETLK=: 7
F_UNLCK=: 2
F_WRLCK=: 3
flock_sz=: 24
l_len_off=: 8
l_len_sz=: 8
l_pid_off=: 16
l_pid_sz=: 4
l_start_off=: 0
l_start_sz=: 8
l_type_off=: 20
l_type_sz=: 2
l_whence_off=: 22
l_whence_sz=: 2

PROT_READ=: 1
PROT_WRITE=: 2
PROT_EXEC=: 4
PROT_NONE=: 0
MAP_SHARED=: 1
MAP_PRIVATE=: 2
MAP_FIXED=: 16

REG_EXTENDED=: 1
REG_ICASE=: 2
REG_NOSUB=: 4
REG_NEWLINE=: 8

regex_t_sz=: 32
re_nsub_off=: 8
re_nsub_sz=: 8
regmatch_t_sz=: 16
rm_so_off=: 0
rm_so_sz=: 8
rm_eo_off=: 8
rm_eo_sz=: 8


fd_set_sz=: 128
fds_bits_off=: 0
fds_bits_sz=: 128
FD_SETSIZE=: 1024
timeval_sz=: 16
tv_sec_off=: 0
tv_sec_sz=: 8
tv_usec_off=: 8
tv_usec_sz=: 8

E2BIG=: 7
EFAULT=: 14
ENFILE=: 23
ENOTTY=: 25
EACCES=: 13
EFBIG=: 27
ENODEV=: 19
ENXIO=: 6
EAGAIN=: 35
ENOENT=: 2
EPERM=: 1
EBADF=: 9
EINTR=: 4
ENOEXEC=: 8
EPIPE=: 32
EINVAL=: 22
ENOLCK=: 77
ERANGE=: 34
EBUSY=: 16
EIO=: 5
ENOMEM=: 12
EROFS=: 30
EISDIR=: 21
ENOSPC=: 28
ESPIPE=: 29
ECHILD=: 10
EMFILE=: 24
ENOSYS=: 78
ESRCH=: 3
EDEADLK=: 11
EMLINK=: 31
ENOTDIR=: 20
EDOM=: 33
ENOTEMPTY=: 66
EXDEV=: 18
EEXIST=: 17
ENAMETOOLONG=: 63

EINPROGRESS=: 36
ECANCELED=: 88
ETIMEDOUT=: 60
EMSGSIZE=: 40
ENOTSUP=: 91
)
hostdefs_sunos_j_=: 0 : 0
NB. do not edit -- created by sym2ijs
cocurrent<'jdefs'
cocurrent <'jdefs'

F_OK=: 0
R_OK=: 4
W_OK=: 2
X_OK=: 1
STDIN_FILENO=: 0
STDOUT_FILENO=: 1
STDERR_FILENO=: 2
SEEK_CUR=: 1
SEEK_END=: 2
SEEK_SET=: 0

O_APPEND=: 8
O_CREAT=: 256
O_EXCL=: 1024
O_RDONLY=: 0
O_RDWR=: 2
O_TRUNC=: 512
O_WRONLY=: 1

O_ACCMODE=: 3
O_NOCTTY=: 2048
O_NONBLOCK=: 128
FD_CLOEXEC=: 1
F_DUPFD=: 0
F_GETFD=: 1
F_SETFD=: 2
F_GETFL=: 3
F_SETFL=: 4
F_SETLK=: 6
F_SETLKW=: 7
F_GETLK=: 14
F_UNLCK=: 3
F_WRLCK=: 2
flock_sz=: 36
l_len_off=: 8
l_len_sz=: 4
l_pid_off=: 16
l_pid_sz=: 4
l_start_off=: 4
l_start_sz=: 4
l_type_off=: 0
l_type_sz=: 2
l_whence_off=: 2
l_whence_sz=: 2

PROT_READ=: 1
PROT_WRITE=: 2
PROT_EXEC=: 4
PROT_NONE=: 0
MAP_SHARED=: 1
MAP_PRIVATE=: 2
MAP_FIXED=: 16

REG_EXTENDED=: 1
REG_ICASE=: 4
REG_NOSUB=: 2
REG_NEWLINE=: 8

regex_t_sz=: 24
re_nsub_off=: 0
re_nsub_sz=: 4
regmatch_t_sz=: 24
rm_so_off=: 8
rm_so_sz=: 4
rm_eo_off=: 12
rm_eo_sz=: 4


fd_set_sz=: 128
fds_bits_off=: 0
fds_bits_sz=: 128
FD_SETSIZE=: 1024
timeval_sz=: 8
tv_sec_off=: 0
tv_sec_sz=: 4
tv_usec_off=: 4
tv_usec_sz=: 4

E2BIG=: 7
EFAULT=: 14
ENFILE=: 23
ENOTTY=: 25
EACCES=: 13
EFBIG=: 27
ENODEV=: 19
ENXIO=: 6
EAGAIN=: 11
ENOENT=: 2
EPERM=: 1
EBADF=: 9
EINTR=: 4
ENOEXEC=: 8
EPIPE=: 32
EINVAL=: 22
ENOLCK=: 46
ERANGE=: 34
EBUSY=: 16
EIO=: 5
ENOMEM=: 12
EROFS=: 30
EISDIR=: 21
ENOSPC=: 28
ESPIPE=: 29
ECHILD=: 10
EMFILE=: 24
ENOSYS=: 89
ESRCH=: 3
EDEADLK=: 45
EMLINK=: 31
ENOTDIR=: 20
EDOM=: 33
ENOTEMPTY=: 93
EXDEV=: 18
EEXIST=: 17
ENAMETOOLONG=: 78

EINPROGRESS=: 150
ECANCELED=: 47
ETIMEDOUT=: 145
EMSGSIZE=: 97
ENOTSUP=: 48
)
hostdefs_win_j_=: 0 : 0
NB. do not edit -- created by sym2ijs
cocurrent<'jdefs'

F_OK=:0
R_OK=:4
W_OK=:2
X_OK=:1
SEEK_CUR=: 1
SEEK_END=: 2
SEEK_SET=: 0

O_APPEND=: 8
O_CREAT=: 256
O_EXCL=: 1024
O_RDONLY=: 0
O_RDWR=: 2
O_TRUNC=: 512
O_WRONLY=: 1


REG_EXTENDED=: 1
REG_ICASE=: 2
REG_NOSUB=: 8
REG_NEWLINE=: 4

regex_t_sz=: 280
re_nsub_off=: 8
re_nsub_sz=: 4
regmatch_t_sz=: 12
rm_so_off=: 0
rm_so_sz=: 4
rm_eo_off=: 4
rm_eo_sz=: 4


FD_SETSIZE=: 64
timeval_sz=: 8
tv_sec_off=: 0
tv_sec_sz=: 4
tv_usec_off=: 4
tv_usec_sz=: 4

E2BIG=: 7
EFAULT=: 14
ENFILE=: 23
ENOTTY=: 25
EACCES=: 13
EFBIG=: 27
ENODEV=: 19
ENXIO=: 6
EAGAIN=: 11
ENOENT=: 2
EPERM=: 1
EBADF=: 9
EINTR=: 4
ENOEXEC=: 8
EPIPE=: 32
EINVAL=: 22
ENOLCK=: 39
ERANGE=: 34
EBUSY=: 16
EIO=: 5
ENOMEM=: 12
EROFS=: 30
EISDIR=: 21
ENOSPC=: 28
ESPIPE=: 29
ECHILD=: 10
EMFILE=: 24
ENOSYS=: 40
ESRCH=: 3
EDEADLK=: 36
EMLINK=: 31
ENOTDIR=: 20
EDOM=: 33
ENOTEMPTY=: 41
EXDEV=: 18
EEXIST=: 17
ENAMETOOLONG=: 38

)
hostdefs_win_64_j_=: 0 : 0
NB. do not edit -- created by sym2ijs

cocurrent <'jdefs'

F_OK=:0
R_OK=:4
W_OK=:2
X_OK=:1
SEEK_CUR=: 1
SEEK_END=: 2
SEEK_SET=: 0

O_APPEND=: 8
O_CREAT=: 256
O_EXCL=: 1024
O_RDONLY=: 0
O_RDWR=: 2
O_TRUNC=: 512
O_WRONLY=: 1


REG_EXTENDED=: 1
REG_ICASE=: 2
REG_NOSUB=: 8
REG_NEWLINE=: 4

regex_t_sz=: 304
re_nsub_off=: 16
re_nsub_sz=: 8
regmatch_t_sz=: 12
rm_so_off=: 0
rm_so_sz=: 4
rm_eo_off=: 4
rm_eo_sz=: 4


FD_SETSIZE=: 64
timeval_sz=: 8
tv_sec_off=: 0
tv_sec_sz=: 4
tv_usec_off=: 4
tv_usec_sz=: 4

E2BIG=: 7
EFAULT=: 14
ENFILE=: 23
ENOTTY=: 25
EACCES=: 13
EFBIG=: 27
ENODEV=: 19
ENXIO=: 6
EAGAIN=: 11
ENOENT=: 2
EPERM=: 1
EBADF=: 9
EINTR=: 4
ENOEXEC=: 8
EPIPE=: 32
EINVAL=: 22
ENOLCK=: 39
ERANGE=: 34
EBUSY=: 16
EIO=: 5
ENOMEM=: 12
EROFS=: 30
EISDIR=: 21
ENOSPC=: 28
ESPIPE=: 29
ECHILD=: 10
EMFILE=: 24
ENOSYS=: 40
ESRCH=: 3
EDEADLK=: 36
EMLINK=: 31
ENOTDIR=: 20
EDOM=: 33
ENOTEMPTY=: 41
EXDEV=: 18
EEXIST=: 17
ENAMETOOLONG=: 38

)
NB. J qtide

require 'project'

coclass 'jqtide'

3 : 0''
WDCB=: 0
try.
  WDCB=: 'jqt'-:11!:0'qwd'
catch. end.
if. IFQT do.
  require 'ide/qt/qtlib'
end.
EMPTY
)
'jws_onOpen jws_onClose jws_onMessage jws_onError jws_onSslError jws_onStateChange'=: i.6
boxj2utf8=: 3 : 0
if. 1 < #$y do. y return. end.
b=. (16+i.11) { a.
if. -. 1 e. b e. y do. y return. end.
y=. ucp y
a=. ucp '┌┬┐├┼┤└┴┘│─'
x=. I. y e. b
utf8 (a {~ b i. x { y) x } y
)
clipread=: wd@('clippaste'"_)
clipwrite=: 3 : 0
txt=. boxj2utf8 flatten ":y
wd 'clipcopy *',txt
#txt
)
dbjqt=: 3 : 0
if. y do.
  if. _1 = 4!:0 <'jdb_open_jdebug_' do.
    0!:0 <jpath '~addons/ide/qt/debugs.ijs'
  end.
  jdb_open_jdebug_''
else.
  jdb_close_jdebug_ :: ] ''
end.
)
flatten=: 3 : 0
dat=. ": y
select. # $ dat
case. 1 do.
case. 2 do.
  }. , LF ,. dat
case. do.
  dat=. 1 1}. _1 _1}. ": < dat
  }: (,|."1 [ 1,.-. *./\"1 |."1 dat=' ')#,dat,.LF
end.
)
gridindex=: 3 : 0
'rws cls sel ndx shp'=. y
d=. (sel,rws,cls) |: i.shp
r=. (sel{shp),(*/rws{shp),*/cls{shp
,(<ndx) { r ($,) d
)
showevents=: 3 : 0
select. {. y,1
case. 0 do.
  4!:55 <'wdhandler_debug_z_'
case. 1 do.
  wdhandler_debug_z_=: 3 : 'smoutput sysevent'
case. 2 do.
  wdhandler_debug_z_=: 3 : 'smoutput wdq'
case. 3 do.
  wdhandler_debug_z_=: 3 : 'if. -. ''_mmove''-:_6{.sysevent do. smoutput sysevent end.'
case. 4 do.
  wdhandler_debug_z_=: 3 : 'if. -. ''_mmove''-:_6{.sysevent do. smoutput wdq end.'
end.
EMPTY
)
textview=: 3 : 0
p=. boxopen y
if. 1<#$p do.
  p=. <":p
elseif. 2=#p do.
  p=. 1 0 1 #^:_1 p
end.
'title caption text'=. _3 {. p
wd 'textview *;',title,';',caption,';',flatten text
)
echo_z_=: wd ::empty@'msgs'^:2 [ 1!:2&2
logcat_z_=: (wd ::empty)@('logcat ' , }.@:;@:(LF&,"1)@:":)
echol_z_=: (wd ::empty@'msgs'^:2 [ 1!:2&2) [ (wd ::empty)@('logcat ' , }.@:;@:(LF&,"1)@:":)
addons_msg=: 0 : 0
The XX are not yet installed.

To install, select menu Tools|Package Manager and install package YY.
)
addons_missing=: 3 : 0
'name addon script'=. y
if. fexist script do. 0 return. end.
sminfo name;addons_msg rplc 'XX';name;'YY';addon
1
)
demoqt=: 3 : 0
p=. jpath '~addons/demos/qtdemo/qtdemo.ijs'
if. addons_missing 'qt demos';'demos/qtdemo';p do. return. end.
load p
)
demowd=: 3 : 0
p=. jpath '~addons/demos/wd/demos.ijs'
if. addons_missing 'Showcase demos';'demos/wd';p do. return. end.
load p
)
labs_run=: 3 : 0
p=. jpath '~addons/labs/labs/lab.ijs'
if. addons_missing 'labs';'labs/labs';p do. return. end.
require p
if. 0 e. $y do.
  require '~addons/labs/labs/labs805.ijs'
  labselect_jlab805_'' return.
end.
if. y -: 1 do. y=. ':' end.
empty lab_jlab_ y
)
coclass 'jqtide'

Qt_Key_Escape                 =: 16b00f800
Qt_Key_Tab                    =: 16b00f801
Qt_Key_Backtab                =: 16b00f802
Qt_Key_Backspace              =: 16b00f803
Qt_Key_Return                 =: 16b00f804
Qt_Key_Enter                  =: 16b00f805
Qt_Key_Insert                 =: 16b00f806
Qt_Key_Delete                 =: 16b00f807
Qt_Key_Pause                  =: 16b00f808
Qt_Key_Print                  =: 16b00f809
Qt_Key_SysReq                 =: 16b00f80a
Qt_Key_Clear                  =: 16b00f80b
Qt_Key_Home                   =: 16b00f810
Qt_Key_End                    =: 16b00f811
Qt_Key_Left                   =: 16b00f812
Qt_Key_Up                     =: 16b00f813
Qt_Key_Right                  =: 16b00f814
Qt_Key_Down                   =: 16b00f815
Qt_Key_PageUp                 =: 16b00f816
Qt_Key_PageDown               =: 16b00f817
Qt_Key_Shift                  =: 16b00f820
Qt_Key_Control                =: 16b00f821
Qt_Key_Meta                   =: 16b00f822
Qt_Key_Alt                    =: 16b00f823
Qt_Key_CapsLock               =: 16b00f824
Qt_Key_NumLock                =: 16b00f825
Qt_Key_ScrollLock             =: 16b00f826
Qt_Key_F1                     =: 16b00f830
Qt_Key_F2                     =: 16b00f831
Qt_Key_F3                     =: 16b00f832
Qt_Key_F4                     =: 16b00f833
Qt_Key_F5                     =: 16b00f834
Qt_Key_F6                     =: 16b00f835
Qt_Key_F7                     =: 16b00f836
Qt_Key_F8                     =: 16b00f837
Qt_Key_F9                     =: 16b00f838
Qt_Key_F10                    =: 16b00f839
Qt_Key_F11                    =: 16b00f83a
Qt_Key_F12                    =: 16b00f83b
helpcontext0=: 3 : 0
require '~addons/ide/qt/help.ijs'
helpcontext y
)

helpcontext1=: 3 : 0
require '~addons/ide/qt/help.ijs'
helpcontext1 y
)
Multiline=: (,each '01234'),;:'noun adverb conjunction verb monad dyad'

ismultiline=: 3 : 0
if. 0=#y do. 0 return. end.
t=. ;: :: 0: y
if. t-:0 do. 0 return. end.
if. (<'Note') = {.t do. 1 return. end.
n=. I. }: t e. Multiline
if. 0=#n do. 0 return. end.
if. (<'define') e. (n+1){t do. 1 return. end.
(,each ':0') e. (n+/1 2){t,<''
)
dirdef_begin=: 3 : 0
t=. ;: :: 0: y
if. t-:0 do. return. end.
b=. t = <'{{'
e=. (t = <'}}') *. +./\ b
0 >. +/ b - e
)
dirdef_end=: 3 : 0
t=. ;: :: 0: y
if. t-:0 do. return. end.
b=. t = <'{{'
e=. t = <'}}'
+/ e - b
)
getnextentry=: 3 : 0
p=. 1
s=. 0 pick y
t=. }.y
if. n=. dirdef_begin s do.
  while. #t do.
    p=. p + 1
    s=. s,LF,w=. 0 pick t
    n=. n - dirdef_end w
    if. n <: 0 do. break. end.
    t=. }.t
  end.
end.
if. ismultiline s do.
  n=. 1 + t i. <,')'
  s=. s,LF,tolist n {. t
  p=. p + n
end.
p;s
)
cocurrent IFQT{'jqtide';'z'
wd=: 3 : 0"1
'r c l p n'=. wd1 (,y);(#,y);(,2);(,0)
select. r
case. 0 do.
  EMPTY
case. _1 do.
  memr p,0,n
case. _2 do.
  _2 [\ <;._2 memr p,0,n
case. do.
  (LF,~wd ::(''"_)'qer') (13!:8) 3
end.
)

wd1=: ('"',libjqt,'" wd ', (IFWIN#'+'),' i *c i *x *i') & cd f.

3 : 0''
if. WDCB_jqtide_ do.
  erase 'wd';'wd1'
  wd=: 11!:0
end.
EMPTY
)
wdhandler_0=: 3 : 0
wdq=: wd 'q'
wd_val=. {:"1 wdq
({."1 wdq)=: wd_val
if. 3=4!:0<'wdhandler_debug' do.
  try. wdhandler_debug'' catch. end.
end.
wd_ndx=. 1 i.~ 3 = 4!:0 [ 3 {. wd_val
if. 3 > wd_ndx do.
  wd_fn=. > wd_ndx { wd_val
  if. 13!:17'' do.
    wd_fn~''
  else.
    try. wd_fn~''
    catch.
      wd_err=. 13!:12''
      if. 0=4!:0 <'ERM_j_' do.
        wd_erm=. ERM_j_
        ERM_j_=: ''
        if. wd_erm -: wd_err do. i.0 0 return. end.
      end.
      wd_err=. LF,,LF,.(}.^:('|'e.~{.));._2 ,&LF^:(LF~:{:) wd_err
      wdinfo 'wdhandler';'error in: ',wd_fn,wd_err
    end.
  end.
end.
i.0 0
)
wdhandler=: 3 : 0
wdq=: wd 'q'
wd_val=. {:"1 wdq
({."1 wdq)=: wd_val
if. 3=4!:0<'wdhandler_debug' do.
  try. wdhandler_debug'' catch. end.
end.
wd_ndx=. 1 i.~ 3 = 4!:0 [ 3 {. wd_val
if. 3 > wd_ndx do.
  wd_fn=. > wd_ndx { wd_val
  if. 13!:17'' do.
    wd_fn~''
  else.
    try. wd_fn~''
    catch.
      wd_err=. 13!:12''
      if. 0=4!:0 <'ERM_j_' do.
        wd_erm=. ERM_j_
        ERM_j_=: ''
        if. wd_erm -: wd_err do. i.0 0 return. end.
      end.
      wd_err=. LF,,LF,.(}.^:('|'e.~{.));._2 ,&LF^:(LF~:{:) wd_err
      wdinfo 'wdhandler';'error in: ',wd_fn,wd_err
    end.
    i.0 0
  end.
else. i. 0 0
end.
)
wdhandlerx=: 3 : 0
loc=. <,y
if. 0 <: 18!:0 loc do.
  wdhandler__loc''
else.
  msg=. 'no locale for event handler: ',>loc
  if. #wdq=. wd 'q' do.
    msg=. msg, ', event: ',(<1 1) pick wdq
  end.
  smoutput msg
end.
)
wdclippaste=: (wd bind 'clippaste') :: (''"_)
wdqq=: (wd bind 'q') :: (''"_)
wdqchildxywh=: (0 ". [: wd 'qchildxywh ' , ]) :: (0 0 0 0"_)
wdqcolor=: (0 ". [: wd 'qcolor ' , ":) :: ( 0 0 0"_)
wdqd=: (wd bind 'qd') :: (''"_)
wdqer=: (wd bind 'qer') :: (''"_)
wdqform=: (0 ". wd bind 'qform') :: (0 0 800 600"_)
wdqhinst=: (0 ". wd bind 'qhinst') :: 0:
wdqhwndc=: (0 ". [: wd 'qhwndc ' , ]) :: 0:
wdqhwndp=: (0 ". wd bind 'qhwndp') :: 0:
wdqhwndx=: (0 ". wd bind 'qhwndx') :: 0:
wdqm=: (0 ". wd bind 'qm') :: (800 600 8 16 1 1 3 3 4 4 19 19 0 0 800 570"_)
wdqp=: (wd bind 'qp') :: (''"_)
wdqprinters=: (wd bind 'qprinters') :: (''"_)
wdqpx=: (wd bind 'qpx') :: (''"_)
wdqscreen=: (0 ". wd bind 'qscreen') :: (264 211 800 600 96 96 32 1 _1 36 36 51"_)
wdqwd=: (wd bind 'qwd') :: ('jqt'"_)
wdcenter=: 0:
wdfit=: 0:

wdreset=: wd bind 'reset'
wdforms=: <;._2;._2 @ wd bind 'qpx'
wdisparent=: (boxopen e. 0: {"1 wdforms) ::0:
wdishandle=: (boxopen e. 1: {"1 wdforms) ::0:
wdinfo=: 3 : 0
'a b'=. _2{. boxopen y
if. 2=#$b=. ":b do. b=. }.,LF,.b end.
f=. 8 u: DEL&, @ (,&DEL) @ -.&(0 127{a.)
empty wd 'mb info ',(f a),' ',(f b)
)
wdquery=: 3 : 0
0 3 wdquery y
:
msg=. ' mb_'&,&.> res=. ;:'ok cancel yes no save discard'
t=. x [ 'a b'=. _2{. boxopen y
if. 2=#$b=. ":b do. b=. }.,LF,.b end.
f=. 8 u: DEL&, @ (,&DEL) @ -.&(0 127{a.)
m=. 'mb query', (;t{msg), ' ', (f a),' ',(f b)
res i. <wd m
)
mbopen=: 3 : 0
jpathsep wd 8 u: 'mb open1 ',y
)
mbsave=: 3 : 0
jpathsep wd 8 u: 'mb save ',y
)
wdget=: 4 : 0
nms=. {."1 y
vls=. {:"1 y
if. L. x do. vls {~ nms i. ,&.>x
else. > vls {~ nms i. <,x
end.
)

wdpclose=: [: wd :: empty 'psel ' , ';pclose' ,~ ":
3 : 0^:(IFQT > IFJHS)''
dirmatch=: 3 : 'wd ''dirmatch '', ; dquote&.> 2 {. boxopen y'
open=: 3 : 'wd ''openj *'' , > {. getscripts_j_ y'
immexj=: [: wd 'immexj *'&,
smact=: wd bind 'smact'

clipread=: clipread_jqtide_
clipwrite=: clipwrite_jqtide_
textview=: textview_jqtide_
EMPTY
)
coclass 'jqtide'
JQTREQ=: '1.8.1'
JQTMSG=: 0 : 0
The JQt binary needs updating.

To do so, close this session, then load jconsole and run:

   getqtbin''
or
   getqtbin'slim'

or run XX in the J installation folder.
)
checkjqtversion=: 3 : 0
f=. 1000 #. 0 ". ' ' I.@('.'=])} ]
ver=. wd ::('0.0.0'"_) 'version'
ver=. (ver i.'(') {. ver
JQTVER=: f (1+ver i.'/') }. ver
act=. f (<./ ver i.'/s') {. ver
req=. f JQTREQ
if. req <: act do. return. end.
msg=. JQTMSG rplc 'XX';'updatejqt.',IFWIN pick 'sh';'cmd'
sminfo 'JQt';msg
)
checkjqtversion^:IFQT''

cocurrent 'base'
coclass 'jbmp'

RGBSEQ=: 1
flipreadrgb=: endian^:RGBSEQ
flipwritergb=: endian^:RGBSEQ
BITMAPINFOHEADERDATA=: dfh&> cut ; <@(12&{.);._2 [ 0 : 0
42 4D       0   "BM" ID field (42h, 4Dh)
46 00 00 00 2   70 bytes (54+16) Size of the BMP file (54 bytes header + 16 bytes data)
00 00       6   Unused Application specific
00 00       8   Unused Application specific
36 00 00 00 10  54 bytes (14+40) Offset where the pixel array (bitmap data) can be found DIB Header
28 00 00 00 14  40 bytes Number of bytes in the DIB header (from this point)
02 00 00 00 18  2 pixels (left to right order) Width of the bitmap in pixels
02 00 00 00 22  2 pixels (bottom to top order) Height of the bitmap in pixels.  Positive for bottom to top pixel order.
01 00       26  1 plane Number of color planes being used
18 00       28  24 bits Number of bits per pixel
00 00 00 00 30  0 BI_RGB, no pixel array compression used
10 00 00 00 34  16 bytes Size of the raw bitmap data (including padding)
13 0B 00 00 38  2835 pixels/metre horizontal Print resolution of the image, 72 DPI × 39.3701 inches per metre yields 2834.6472
13 0B 00 00 42  2835 pixels/metre vertical
00 00 00 00 46  0 colors Number of colors in the palette
00 00 00 00 50  0 important colors 0 means all colors are important Start of pixel array (bitmap data)
00 00 FF    54  0 0 255 Red, Pixel (0,1)
FF FF FF    57  255 255 255 White, Pixel (1,1)
00 00       60  0 0 Padding for 4 byte alignment (could be a value other than zero)
FF 00 00    62  255 0 0 Blue, Pixel (0,0)
00 FF 00    65  0 255 0 Green, Pixel (1,0)
00 00       68  0 0 Padding for 4 byte alignment (could be a value other than zero)
)
readbmp=: 3 : 0

r=. readbmphdrall y
if. 2 = 3!:0 r do. return. end.
'nos dat'=. r
'bits rws cls off shdr'=. nos

pal=. off {. dat
dat=. off }. dat

if. bits e. 1 4 8 do.
  pal=. 256 #. flipreadrgb"1 a. i. _4 }: \ (shdr+14) }. pal
  dat=. , ((#~ ^.&256) 2^bits) #: a. i. dat
  pal {~ |. (rws,cls){.(rws,cls+(32%bits)|-cls) $ dat
elseif. bits=24 do.
  cl4=. 4 * >. (3*cls) % 4
  |. (rws,cls) {. 256 #. flipreadrgb"1 a.i. _3 [\"1 (rws,cl4) $ dat
elseif. 1 do.
  'only 1,4,8 and 24-bit bitmaps supported, this is ',(":bits),'-bit'
end.
)
readbmphdr=: 3 : 0
r=. readbmphdrall y
if. 2 ~: 3!:0 r do.
  3 {. 0 pick r
end.
)
readbmphdrall=: 3 : 0

try.
  dat=. 1!:1 boxopen y
  if. -. 'BM'-:2{.dat do. 'not a bitmap file' return. end.
catch.
  dat=. y
  if. -. 'BM'-:2{.dat do. 'file read error' return. end.
end.

toi=. 256&#.@(a.&i.)@(|."1)
bits=. toi 28 29 {dat

if. toi 30 31 32 33{dat do.
  'compressed format not supported' return.
end.

'off shdr cls rws'=. toi (10+i.4 4){dat
(bits,rws,cls,off,shdr);dat
)
writebmp=: 4 : 0

dat=. x
'file min'=. 2 {. (boxopen y), < 24*(IFIOS+.UNAME-:'Darwin')

if3=. (3=#$dat) *. 3={:$dat

sbmp=. (-if3) }. $dat
pal=. /:~ ~. ,/ dat
bit=. 4 8 24 {~ +/ 16 256 < # pal
bit=. min >. bit

if. bit e. 4 8 do.
  dat=. pal i. dat
  if. bit=4 do.
    dat=. 16 #. _2[\"1 dat
  else.
    pal=. 256 {. pal
  end.
  spal=. #pal
  if. -. if3 do.
    pal=. 256 256 256 #: pal
  end.
  pal=. flipwritergb"1 pal
  pal=. , a. {~ pal ,. 0
  xsbmp=. ($dat) + 0 1 * 4|-$dat
  bmp=. xsbmp{.dat
else.
  pal=. ''
  spal=. 0
  if. -.if3 do.
    dat=. 256 256 256 #: dat
  end.
  dat=. flipwritergb"1 dat
  bmp=. ,"2 dat
  bmp=. ((1 4)* >. ($bmp) % (1 4)) {. bmp
end.

bmp=. ,|. bmp{ a.
sdat=. $bmp

j=. (|.sbmp),(256 #. 0, bit, 0 1),0,sdat,2835 2835,2#spal
b=. (54+(4*spal)+sdat),0,(54+4*spal),40,j
head=. 'BM',,a.{~,|."1 (4#256)#:b

(head,pal,bmp) 1!:2 boxopen file
)
readbmp_z_=: readbmp_jbmp_
readbmphdr_z_=: readbmphdr_jbmp_
writebmp_z_=: writebmp_jbmp_
NB. gl2 init

coclass 'jgl2'

WDCB_jqtide_=: (WDCB_jqtide_"_)^:(0=4!:0<'WDCB_jqtide_') (IFIOS*.IFQT)+.(UNAME-:'Wasm')
3 : 0''
if. 0~: 4!:0 <'PROFONT_z_' do. PROFONT=: (('Linux';'FreeBSD';'OpenBSD';'Darwin';'Android';'Win') i. <UNAME){:: 'Sans 10' ; 'Sans 10' ; 'Sans 10' ; '"Lucida Grande" 10' ; (IFQT{::'Sans 10';'"Droid Sans" 10') ; 'Tahoma 10' ; 'Tahoma 10' else. PROFONT=: PROFONT_z_ end.
if. 0~: 4!:0 <'FIXFONT_z_' do. FIXFONT=: (('Linux';'FreeBSD';'OpenBSD';'Darwin';'Android';'Win') i. <UNAME){:: 'mono 10' ; 'mono 10' ; 'mono 10' ; 'Monaco 10' ; (IFQT{::'monospace 10';'"Droid Sans Mono" 10') ; '"Lucida Console" 10' ; '"Lucida Console" 10' else. FIXFONT=: FIXFONT_z_ end.
)

NB. gl2 constant

PS_NULL=: 0
PS_SOLID=: 1
PS_DASH=: 2
PS_DOT=: 3
PS_DASHDOT=: 4
PS_DASHDOTDOT=: 5

IDC_ARROW=: 0
IDC_UPARROW=: 1
IDC_CROSS=: 2
IDC_WAIT=: 3
IDC_IBEAM=: 4
IDC_SIZEVER=: 5
IDC_SIZEHOR=: 6
IDC_SIZEBDIAG=: 7
IDC_SIZEFDIAG=: 8
IDC_SIZEALL=: 9
IDC_BLANK=: 10
IDC_SPLITV=: 11
IDC_SPLITH=: 12
IDC_POINTINGHAND=: 13
IDC_FORBIDDEN=: 14
IDC_OPENHAND=: 17
IDC_CLOSEDHAND=: 18
IDC_WHATSTHIS=: 15
IDC_BUSY=: 16
IDC_DRAGMOVE=: 20
IDC_DRAGCOPY=: 19
IDC_DRAGLINK=: 21
IDC_UNSET=: _1

NB. numeric constants used in glcmds

glarc_n=: 2001
glbrush_n=: 2004
glbrushnull_n=: 2005
glcapture_n=: 2062
glcaret_n=: 2065
glclear_n=: 2007
glclip_n=: 2078
glclipreset_n=: 2079
glcmds_n=: 2999
glcursor_n=: 2069
glellipse_n=: 2008
glemfopen_n=: 2084
glemfclose_n=: 2085
glemfplay_n=: 2086
glfile_n=: 2066
glfill_n=: 2093
glfont_n=: 2012
glfontextent_n=: 2094
gllines_n=: 2015
glnodblbuf_n=: 2070
glpaint_n=: 2020
glpaintx_n=: 2021
glpen_n=: 2022
glpie_n=: 2023
glpixel_n=: 2024
glpixelsx_n=: 2075
glpixels_n=: 2076
glprint_n=: 2089
glprintmore_n=: 2091
glpolygon_n=: 2029
glqextent_n=: 2057
glqextentw_n=: 2083
glqpixels_n=: 2077
glqpixelm_n=: 2080
glqprintpaper_n=: 2092
glqprintwh_n=: 2088
glqtextmetrics_n=: 2058
glqtype_n=: 2095
glqwh_n=: 2059
glqhandles_n=: 2060
glrect_n=: 2031
glrgb_n=: 2032
glroundr_n=: 2033
glsel_n=: 2035
gltext_n=: 2038
gltextcolor_n=: 2040
gltextxy_n=: 2056
glwindoworg_n=: 2045

glbkmode_n=: 2003
glnoerasebkgnd_n=: 2071
glsetlocale_n=: 2072

glfont2_n=: 2312
glfontangle_n=: 2096
glrgba_n=: 2097
glsel2_n=: 2098

NB. image utility
glgetimg_n=: 3000
glreadimg_n=: 3001
glputimg_n=: 3002
glwriteimg_n=: 3003

NB. keyboard events
kbBS=: Qt_Key_Backspace_jqtide_
kbTAB=: Qt_Key_Tab_jqtide_
kbLF=: Qt_Key_Enter_jqtide_
kbENTER=: Qt_Key_Enter_jqtide_
kbRETURN=: Qt_Key_Return_jqtide_
kbPUP=: Qt_Key_PageUp_jqtide_
kbPDOWN=: Qt_Key_PageDown_jqtide_
kbEND=: Qt_Key_End_jqtide_
kbHOME=: Qt_Key_Home_jqtide_
kbLEFT=: Qt_Key_Left_jqtide_
kbUP=: Qt_Key_Up_jqtide_
kbRIGHT=: Qt_Key_Right_jqtide_
kbDOWN=: Qt_Key_Down_jqtide_
kbESC=: Qt_Key_Escape_jqtide_
kbINS=: Qt_Key_Insert_jqtide_
kbDEL=: Qt_Key_Delete_jqtide_
kbMETA=: Qt_Key_Meta_jqtide_
kbALT=: Qt_Key_Alt_jqtide_
kbSHIFT=: Qt_Key_Shift_jqtide_
kbCTRL=: Qt_Key_Control_jqtide_
NB. qt gl2

chkgl2=: 13!:8@3:^:(0&<)@>@{.

NB. =========================================================
glarc=: chkgl2 @: (('"',libjqt,'" glarc >',(IFWIN#'+'),' i *i') cd <) "1
glbrush=: chkgl2 @: (('"',libjqt,'" glbrush >',(IFWIN#'+'),' i')&cd bind '') "1
glbrushnull=: chkgl2 @: (('"',libjqt,'" glbrushnull >',(IFWIN#'+'),' i')&cd bind '') "1
glcapture=: chkgl2 @: (('"',libjqt,'" glcapture >',(IFWIN#'+'),' i i')&cd) "1
glcaret=: chkgl2 @: (('"',libjqt,'" glcaret >',(IFWIN#'+'),' i *i') cd <) "1
glclear=: (('"',libjqt,'" glclear >',(IFWIN#'+'),' i')&cd bind '') "1
glclip=: chkgl2 @: (('"',libjqt,'" glclip >',(IFWIN#'+'),' i *i') cd <) "1
glclipreset=: chkgl2 @: (('"',libjqt,'" glclipreset >',(IFWIN#'+'),' i')&cd bind '') "1
glcmds=: chkgl2 @: (('"',libjqt,'" glcmds >',(IFWIN#'+'),' i *i i') cd (;#)) "1
glcursor=: chkgl2 @: (('"',libjqt,'" glcursor >',(IFWIN#'+'),' i i')&cd) "1
glellipse=: chkgl2 @: (('"',libjqt,'" glellipse >',(IFWIN#'+'),' i *i') cd <@:<.) "1
glfill=: chkgl2 @: (('"',libjqt,'" glfill >',(IFWIN#'+'),' i *i') cd <@:<.) "1
glfont=: chkgl2 @: (('"',libjqt,'" glfont >',(IFWIN#'+'),' i *c') cd <@,) "1
glfont2=: chkgl2 @: (('"',libjqt,'" glfont2 >',(IFWIN#'+'),' i *i i') cd (;#)@:<.) "1
glfontangle=: chkgl2 @: (('"',libjqt,'" glfontangle >',(IFWIN#'+'),' i i')&cd) "1
glfontextent=: chkgl2 @: (('"',libjqt,'" glfontextent >',(IFWIN#'+'),' i *c') cd <@,) "1
gllines=: chkgl2 @: (('"',libjqt,'" gllines >',(IFWIN#'+'),' i *i i') cd (;#)) "1
glnodblbuf=: chkgl2 @: (('"',libjqt,'" glnodblbuf >',(IFWIN#'+'),' i i') cd {.@(,&0)) "1
glpen=: chkgl2 @: (('"',libjqt,'" glpen >',(IFWIN#'+'),' i *i') cd <@:(2 {. (,&1))) "1
glpie=: chkgl2 @: (('"',libjqt,'" glpie >',(IFWIN#'+'),' i *i') cd <) "1
glpixel=: chkgl2 @: (('"',libjqt,'" glpixel >',(IFWIN#'+'),' i *i') cd <) "1
glpixels=: chkgl2 @: (('"',libjqt,'" glpixels >',(IFWIN#'+'),' i *i i') cd (;#)@:<.) "1
glpixelsx=: chkgl2 @: (('"',libjqt,'" glpixelsx >',(IFWIN#'+'),' i *i') cd <@:<.) "1
glpolygon=: chkgl2 @: (('"',libjqt,'" glpolygon >',(IFWIN#'+'),' i *i i') cd (;#)@:<.) "1
glrect=: chkgl2 @: (('"',libjqt,'" glrect >',(IFWIN#'+'),' i *i') cd <) "1
glrgb=: chkgl2 @: (('"',libjqt,'" glrgb >',(IFWIN#'+'),' i *i') cd <@:<.) "1
glrgba=: chkgl2 @: (('"',libjqt,'" glrgba >',(IFWIN#'+'),' i *i') cd <@:<.) "1
glsel1=: chkgl2 @: (('"',libjqt,'" glsel >',(IFWIN#'+'),' i x')&cd) "1
glsel2=: chkgl2 @: (('"',libjqt,'" glsel2 >',(IFWIN#'+'),' i *c') cd <@,) "1
gltext=: chkgl2 @: (('"',libjqt,'" gltext >',(IFWIN#'+'),' i *c') cd <@,) "1
gltextcolor=: chkgl2 @: (('"',libjqt,'" gltextcolor >',(IFWIN#'+'),' i')&cd bind '') "1
gltextxy=: chkgl2 @: (('"',libjqt,'" gltextxy >',(IFWIN#'+'),' i *i') cd <@:<.) "1
glwaitgl=: chkgl2 @: (('"',libjqt,'" glwaitgl >',(IFWIN#'+'),' i')&cd bind '') "1
glwaitnative=: chkgl2 @: (('"',libjqt,'" glwaitnative >',(IFWIN#'+'),' i')&cd bind '') "1
glwindoworg=: chkgl2 @: (('"',libjqt,'" glwindoworg >',(IFWIN#'+'),' i *i') cd <@:<.) "1

glsetlocale=: chkgl2 @: (('"',libjqt,'" glsetlocale >',(IFWIN#'+'),' i *c') cd <@,@>) "1

NB. =========================================================
NB. immediate paint
glpaint=: 3 : 0 "1
('"',libjqt,'" glpaint >',(IFWIN#'+'),' i')&cd ''
0
)

NB. =========================================================
NB. paint
glpaintx=: 3 : 0 "1
('"',libjqt,'" glpaintx >',(IFWIN#'+'),' i')&cd ''
0
)

NB. =========================================================
glqhandles=: 3 : 0"1
hs=. 3#2-2
chkgl2 cdrc=. ('"',libjqt,'" glqhandles  ',(IFWIN#'+'),' i *x') cd <hs
1{::cdrc
)

NB. =========================================================
glqtype=: 3 : 0"1
type=. 1#2-2
chkgl2 cdrc=. ('"',libjqt,'" glqtype  ',(IFWIN#'+'),' i *i') cd <type
1{::cdrc
)

NB. =========================================================
glqwh=: 3 : 0"1
wh=. 2#2-2
chkgl2 cdrc=. ('"',libjqt,'" glqwh  ',(IFWIN#'+'),' i *i') cd <wh
1{::cdrc
)

NB. =========================================================
NB. return matrix of pixels
NB. wh is limited to pixmap size
NB. -1 in w or h means read to end
glqpixelm=: 3 : 0"1
n=. */ 2{.2}.y
pix=. n#2-2
shape=. 2#2-2
chkgl2 cdrc=. ('"',libjqt,'" glqpixelm  ',(IFWIN#'+'),' i *i *i *i') cd y;shape;pix
(2&{:: $ 3&{::) cdrc
)

NB. =========================================================
NB. result is in opengl form
NB. pixels top to bottom, RGB24
NB. TODO
glqpixels=: 3 : 0"1
n=. */ 2{.2}.y
pix=. n#2-2
chkgl2 cdrc=. ('"',libjqt,'" glqpixels  ',(IFWIN#'+'),' i *i *i') cd y;pix
2{::cdrc
)

NB. =========================================================
NB. TODO
glqextent=: 3 : 0"1
wh=. 2#2-2
chkgl2 cdrc=. ('"',libjqt,'" glqextent  ',(IFWIN#'+'),' i *c *i') cd (,y);wh
2{::cdrc
)

NB. =========================================================
NB. TODO
glqextentw=: 3 : 0"1
y=. y,(LF~:{:y)#LF [ y=. ,y
w=. (+/LF=y)#2-2
chkgl2 cdrc=. ('"',libjqt,'" glqextentw  ',(IFWIN#'+'),' i *c *i') cd y;w
2{::cdrc
)

NB. =========================================================
NB. font information: Height, Ascent, Descent, InternalLeading, ExternalLeading, AverageCharWidth, MaxCharWidth
NB. TODO
glqtextmetrics=: 3 : 0"1
tm=. 7#2-2
chkgl2 cdrc=. ('"',libjqt,'" glqtextmetrics  ',(IFWIN#'+'),' i *i') cd <tm
1{::cdrc
)

NB. =========================================================
glsetbrush=: glbrush @ glrgb
glsetpen=: glpen @ ((1 1 [ glrgb) :((2 {. (,&1)) glrgb))

NB. =========================================================
NB. printer

NB. not implemented
glprint=: [:
glprintmore=: [:
glqprintpaper=: [:
glqprintwh=: [:

NB. not implemented
glemfclose=: [:
glemfopen=: [:
glemfplay=: [:
glfile=: [:
glroundr=: [:

NB. =========================================================
glsel=: glsel2@:(":^:(2~:3!:0))

NB. =========================================================
3 : 0''
if. WDCB_jqtide_ do.
  chkgl2=: ]
  glarc=: 11 !: glarc_n
  glbrush=: 11 !: glbrush_n
  glbrushnull=: 11 !: glbrushnull_n
  glcapture=: 11 !: glcapture_n
  glcaret=: 11 !: glcaret_n
  glclear=: 11 !: glclear_n
  glclip=: 11 !: glclip_n
  glclipreset=: 11 !: glclipreset_n
  glcmds=: 11 !: glcmds_n
  glcursor=: 11 !: glcursor_n
  glellipse=: 11 !: glellipse_n
  glfill=: 11 !: glfill_n
  glfont=: 11 !: glfont_n
  glfont2=: 11 !: glfont2_n
  glfontangle=: 11 !: glfontangle_n
  glfontextent=: 11 !: glfontextent_n
  gllines=: 11 !: gllines_n
  glnodblbuf=: 11 !: glnodblbuf_n
  glpen=: 11 !: glpen_n
  glpie=: 11 !: glpie_n
  glpixel=: 11 !: glpixel_n
  glpixels=: 11 !: glpixels_n
  glpixelsx=: 11 !: glpixelsx_n
  glpolygon=: 11 !: glpolygon_n
  glrect=: 11 !: glrect_n
  glrgb=: 11 !: glrgb_n
  glrgba=: 11 !: glrgba_n
  gltext=: 11 !: gltext_n
  gltextcolor=: 11 !: gltextcolor_n
  gltextxy=: 11 !: gltextxy_n
NB.   glwaitgl=: 11 !: glwaitgl_n
NB.   glwaitnative=: 11 !: glwaitnative_n
  glwindoworg=: 11 !: glwindoworg_n
  glsetlocale=: 11 !: glsetlocale_n
  glpaint=: 11 !: glpaint_n
  glpaintx=: 11 !: glpaintx_n
  glqhandles=: 11 !: glqhandles_n
  glqtype=: 11 !: glqtype_n
  glqwh=: 11 !: glqwh_n
  glqpixelm=: 11 !: glqpixelm_n
  glqpixels=: 11 !: glqpixels_n
  glqextent=: 11 !: glqextent_n
  glqextentw=: 11 !: glqextentw_n
  glqtextmetrics=: 11 !: glqtextmetrics_n
  glsel=: (11 !: glsel_n)`(11 !: glsel2_n)@.(2=3!:0)
NB. image utility
  glgetimg=: 11 !: glgetimg_n
  glreadimg=: 11 !: glreadimg_n
  glputimg=: 11 !: glputimg_n
  glwriteimg=: 11 !: glwriteimg_n
end.
EMPTY
)
NB. util

NB. =========================================================
RGBA=: 3 : 'r (23 b.) 8 (33 b.) g (23 b.) 8 (33 b.) b (23 b.) 8 (33 b.) a [ ''r g b a''=. <.y'
BGRA=: 3 : 'b (23 b.) 8 (33 b.) g (23 b.) 8 (33 b.) r (23 b.) 8 (33 b.) a [ ''r g b a''=. <.y'

NB. =========================================================
NB. pafc v Polar angle from cartesian coords
pafc=: 2p1&|@{:@:(*.@(j./))

rfd=: *&(1p1%180)
dfr=: *&(180%1p1)

NB. calcAngle gives polar angle in radians with zero at 3-o'clock
NB. from rectangular coordiates with origin (0,0) at the top, left
NB. (xctr,yctr) calcAngle xpt,ypt
calcAngle=: ([: pafc _1 1 * -)"1

NB. =========================================================
NB. convert radians to 64ths-of-a-degree
degree64=: 0.5 <.@:+ 64 * dfr

NB. =========================================================
NB. opengl (and normal folk?) are ARGB with A 0
NB. glpixels and glqpixels need to make these adjustments
3 : 0''
if. IF64 do.
  ALPHA=: 0{_3 ic 0 0 0 255 255 255 255 255{a.
else.
  ALPHA=: 0{_2 ic 0 0 0 255{a.
end.
''
)
NOTALPHA=: 0{_2 ic 255 255 255 0{a.
ALPHARGB=: IF64{::_1;16bffffffff

NB. =========================================================
NB. arc drawing - glellipse, glarc, glpie
NB. draw arc on the ellipse defined by rectangle
NB. arc starts at xa,ya and ends at xz,yz (counterclockwise)
NB. points need not lie on the ellipse
NB. they define a line from the center that intersects ellipse
NB. gdk arc has same xywh but args are start and end angles
NB. counterclockwise in 64th degrees

NB. =========================================================
parseFontname=: 3 : 0
font=. ' ',y
b=. (font=' ') > ~:/\font='"'
a: -.~ b <@(-.&'"');._1 font
)

NB.*FontStyle n Regular Bold Italic Underline Strikeout
NB.             0       1    2      4         8
FontStyle=: ;:'regular bold italic underline strikeout'

parseFontSpec=: 3 : 0
'ns styleangle'=. 2 split parseFontname y
'face size'=. ns
size=. 12". size
style=. FontStyle i. tolower each styleangle
style=. <.+/2^<:(style ((> 0) *. <) #FontStyle) # style
if. 1 e. an=. ('angle'-:5&{.)&> styleangle do.
  degree=. 10%~ 0". 5}.>(an i. 1){styleangle
else.
  degree=. 0
end.
face;size;style;degree
)

NB. delete leading white spaces
dlws=: 3 : 0
y }.~ +/ *./\ (y e. ' ')+.(y e. LF)+.(y e. TAB)
)

NB. count leading white spaces
clws=: 3 : 0
+/ *./\ (y e. ' ')+.(y e. LF)+.(y e. TAB)
)

NB. get first argument and remove enclosing dquotes or DEL
NB. update global noun wdglptr on exit
wdglshiftarg=: 3 : 0
if. (#wdglstr) = wdglptr=: wdglptr + clws wdglptr}. wdglstr do. '' return. end.
y=. wdglptr}.wdglstr
b=. y e. ' '
a=. y e. '*'
q=. 2| +/\ y e. '"'
d=. 2| +/\ y e. DEL
b=. b *. -.q+.d
a=. a *. -.q+.d
if. 1={.a do.     NB. *argument
  z=. }.y
  wdglptr=: #wdglstr
elseif. (1={.d)+.(1={.q) do.   NB. enclosed between DEL or "
  p2=. 1+ (}.y) i. {.y
  z=. }.p2{.y
  wdglptr=: wdglptr+ p2+1
elseif. 1 e. b do. NB. space delimited
  p2=. {.I.b
  z=. p2{.y
  wdglptr=: wdglptr+ 1+p2
elseif. do.
  z=. y
  wdglptr=: #wdglstr
end.
<z
)

NB. get all arguments by repeating calling wdglshiftarg
wdglshiftargs=: 3 : 0
wdglptr=: 0 [ wdglstr=: y
z=. 0$<''
while. wdglptr < #wdglstr do. z=. z, wdglshiftarg'' end.
z
)

tors=: 3 : 0
(2{.y),(2{.y)+2}.y
)
NB. convert between color triples and RGB values

cocurrent 'z'

NB. =========================================================
NB. form:  opt RGB dat
NB.   opt = 0 integers to RGB   (default)
NB.   dat = red, green, blue values or 3-col matrix of same
NB.
NB.   opt = 1 RGB to integers
NB.   dat = one or more RGB values
NB.
NB. RGB format is a 4 byte integer: unused blue green red
NB.
NB. e.g.  RGB 255 255 0   =  RGB value for bright yellow
NB.*RGB v convert between color triples and RGB values
RGB=: 3 : 0
0 RGB y
:
if. x do. |."1 [256 256 256 #: y
else. y +/ .* 1 256 65536
end.
)

NB. =========================================================
NB. form:  opt BGR dat
NB.   opt = 0 integers to BGR   (default)
NB.   dat = red, green, blue values or 3-col matrix of same
NB.
NB.   opt = 1 BGR to integers
NB.   dat = one or more BGR values
NB.
NB. BGR format is a 4 byte integer: unused red green blue
NB.
NB. e.g.  BGR 255 255 0   =  BGR value for bright yellow
NB.*BGR v convert between color triples and BGR values
BGR=: 3 : 0
0 BGR y
:
if. x do. 256 256 256 #: y
else. (|."1 y) +/ .* 1 256 65536
end.
)
NB. main colortable used in J

cocurrent 'z'

NB. =========================================================
NB.*COLORTABLE n main colortable
COLORTABLE=: ] ;._2 (0 : 0)
AliceBlue=:            240 248 255
AntiqueWhite=:         250 235 215
Aqua=:                   0 255 255
Aquamarine=:           127 255 212
ArmyOlive=:            192 220 192
Azure=:                240 255 255
Beige=:                245 245 220
Bisque=:               255 228 196
Black=:                  0   0   0
BlanchedAlmond=:       255 235 205
Blue=:                   0   0 255
BlueViolet=:           138  43 226
Brown=:                165  42  42
Burlywood=:            222 184 135
CadetBlue=:             95 158 160
Chartreuse=:           127 255   0
Chocolate=:            210 105  30
Coral=:                255 127  80
CornflowerBlue=:       100 149 237
Cornsilk=:             255 248 220
Crimson=:              220  20  60
Cyan=:                   0 255 255
DarkBlue=:               0   0 139
DarkCyan=:               0 139 139
DarkGoldenrod=:        184 134  11
DarkGray=:             169 169 169
DarkGreen=:              0 100   0
DarkKhaki=:            189 183 107
DarkMagenta=:          139   0 139
DarkOliveGreen=:        85 107  47
DarkOrange=:           255 140   0
DarkOrchid=:           153  50 204
DarkRed=:              139   0   0
DarkSalmon=:           233 150 122
DarkSeaGreen=:         143 188 143
DarkSlateBlue=:         72  61 139
DarkSlateGray=:         47  79  79
DarkTurquoise=:          0 206 209
DarkViolet=:           148   0 211
DeepPink=:             255  20 147
DeepSkyBlue=:            0 191 255
DimGray=:              105 105 105
DodgerBlue=:            30 144 255
EggshellWhite=:        255 251 240
Firebrick=:            178  34  34
FloralWhite=:          255 250 240
ForestGreen=:           34 139  34
Fuchsia=:              255   0 255
Gainsboro=:            220 220 220
GhostWhite=:           248 248 255
Gold=:                 255 215   0
Goldenrod=:            218 165  32
Gray=:                 128 128 128
Green=:                  0 128   0
GreenYellow=:          173 255  47
Honeydew=:             240 255 240
HotPink=:              255 105 180
IndianRed=:            205  92  92
Indigo=:                75   0 130
Ivory=:                255 255 240
Jade=:                   0 128 128
Khaki=:                240 230 140
Lavender=:             230 230 250
LavenderBlush=:        255 240 245
LawnGreen=:            124 252   0
LemonChiffon=:         255 250 205
LightBlue=:            173 216 230
LightCoral=:           240 128 128
LightCyan=:            224 255 255
LightGoldenrodYellow=: 250 250 210
LightGreen=:           144 238 144
LightGray=:            211 211 211
LightPink=:            255 182 193
LightSalmon=:          255 160 122
LightSeaGreen=:         32 178 170
LightSkyBlue=:         135 206 250
LightSlateGray=:       119 136 153
LightSteelBlue=:       176 196 222
LightYellow=:          255 255 224
Lime=:                   0 255   0
LimeGreen=:             50 205  50
Linen=:                250 240 230
Magenta=:              255   0 255
Maroon=:               128   0   0
MediumAquamarine=:     102 205 170
MediumBlue=:             0   0 205
MediumGray=:           190 190 190
MediumOrchid=:         186  85 211
MediumPurple=:         147 112 219
MediumSeaGreen=:        60 179 113
MediumSlateBlue=:      123 104 238
MediumSpringGreen=:      0 250 154
MediumTurquoise=:       72 209 204
MediumVioletRed=:      199  21 133
MidnightBlue=:          25  25 112
MintCream=:            245 255 250
MistyRose=:            255 228 225
Moccasin=:             255 228 181
NavajoWhite=:          255 222 173
Navy=:                   0   0 128
OldLace=:              253 245 230
Olive=:                128 128   0
OliveDrab=:            107 142  35
Orange=:               255 165   0
OrangeRed=:            255  69   0
Orchid=:               218 112 214
PaleGoldenrod=:        238 232 170
PaleGreen=:            152 251 152
PaleTurquoise=:        175 238 238
PaleVioletRed=:        219 112 147
PapayaWhip=:           255 239 213
PeachPuff=:            255 218 185
Peru=:                 205 133  63
Pink=:                 255 192 203
Plum=:                 221 160 221
PowderBlue=:           176 224 230
Purple=:               128   0 128
Red=:                  255   0   0
RosyBrown=:            188 143 143
RoyalBlue=:             65 105 225
SaddleBrown=:          139  69  19
Salmon=:               250 128 114
SandyBrown=:           244 164  96
SeaGreen=:              46 139  87
Seashell=:             255 245 238
Sienna=:               160  82  45
Silver=:               192 192 192
SkyBlue=:              135 206 235
SlateBlue=:            106  90 205
SlateGray=:            112 128 144
Snow=:                 255 250 250
SpringGreen=:            0 255 127
SteelBlue=:             70 130 180
Tan=:                  210 180 140
Teal=:                   0 128 128
Thistle=:              216 191 216
Tomato=:               255  99  71
Turquoise=:             64 224 208
Violet=:               238 130 238
Wheat=:                245 222 179
White=:                255 255 255
WhiteSmoke=:           245 245 245
Yellow=:               255 255   0
YellowGreen=:          154 205  50
)
coclass 'jprint'
coinsert^:IFQT 'qtprinter'

PATHSEP=: '/'
PRINTERFONT=: (('Linux';'FreeBSD';'OpenBSD';'Darwin';'Android';'Win') i. <UNAME){:: 'Serif 12' ; 'Serif 12' ; 'Serif 12' ; '"Lucida Grande" 12' ; (IFQT{::'Serif 12';'"Droid Serif" 12') ; '"Courier New" 12'
P2UPFONT=: (('Linux';'FreeBSD';'OpenBSD';'Darwin';'Android';'Win') i. <UNAME){:: 'Serif 7.5 bold' ; 'Serif 7.5 bold' ; 'Serif 7.5 bold' ; '"Lucida Grande" 7.5 bold' ; (IFQT{::'Serif 7.5 bold';'"Droid Serif" 7.5 bold') ; '"Courier New" 7.5 bold'
PRINTOPT=: ''
DEFFONT=: (('Linux';'FreeBSD';'OpenBSD';'Darwin';'Android';'Win') i. <UNAME){:: 'Serif 10 bold' ; 'Serif 10 bold' ; 'Serif 10 bold' ; '"Lucida Grande" 10 bold' ; (IFQT{::'Serif 10 bold';'"Droid Serif" 10 bold') ; '"Courier New" 10 bold'
DEFFONT2=: (('Linux';'FreeBSD';'OpenBSD';'Darwin';'Android';'Win') i. <UNAME){:: 'Serif 7 bold' ; 'Serif 7 bold' ; 'Serif 7 bold' ; '"Lucida Grande" 7 bold' ; (IFQT{::'Serif 7 bold';'"Droid Serif" 7 bold') ; '"Courier New" 7 bold'
TOPM=: 0.4
BOTM=: 0.75
FOOTM=: 0.4
LEFTM=: 0.5
RIGHTM=: 0.5
TOPM2=: 0.015
BOTM2=: 0.03
LEFTM2=: 0.015
FOOTM2=: 0.015
SCALE=: 1 1
OFFSET=: 0 0
CF=: 1
CFFONT=: (('Linux';'FreeBSD';'OpenBSD';'Darwin';'Android';'Win') i. <UNAME){:: 'Monospace 12' ; 'Monospace 12' ; 'Monospace 12' ; 'Monaco 12' ; (IFQT{::'monospace 12';'"Droid Sans Mono" 12') ; '"Lucida Console" 12'
bufinit=: 3 : 0
PCMDS=: ''
PCMD=: i.0 2
)
buf=: 3 : 0
if. y -: 'page' do.
  PCMDS=: PCMDS,<PCMD
  PCMD=: i. 0 2
else.
  PCMD=: PCMD, y
end.
empty''
)
bufexe=: 3 : 0
for_d. y do.
  'f v'=. d
  f~v
end.
)
vfont=: 3 : 0
glzfont TFONT=: y
buf 'glzfont';TFONT
)
vlines=: 3 : 0
buf 'glzlines';<. , SCALE * OFFSET + _2]\y
)
vpage=: 3 : 0
buf 'page'
)
vpen=: 3 : 0
buf 'glzpen';y
)
vtext=: 3 : 0
buf 'glztext';unibox y
)
vtextcolor=: 3 : 0
if. #y do.
  clr=. 256 256 256 #: y
else.
  clr=. 0 0 0
end.
buf 'glzrgb';clr
buf 'glztextcolor';''
)
vtextxy=: 3 : 0
buf 'glztextxy';<. SCALE * OFFSET + y
)
printit=: 4 : 0
bufinit''
PRINTFILES=: ''
PRINTFILE=: ''
P2UP=: 0
PRINTOPT=: 0 pick x
select. 1 pick x
case. 'print' do.
  PRINTTXT=: y
  printform 0
case. 'print2' do.
  PRINTTXT=: y
  P2UP=: 1
  printform 0
case. 'printfile' do.
  getprintfiles y
  printform 1
case. 'printfile2' do.
  getprintfiles y
  P2UP=: 1
  printform 1
end.
)
printclose=: 3 : 0
if. #PRINTFILES do.
  PRINTFILE=: 0 pick PRINTFILES
  PRINTFILES=: }. PRINTFILES
else.
  codestroy''
end.
)
printform=: 3 : 0
prnfile=. y
if. 0 e. $opt=. P2UP printopts PRINTOPT do. 1 return. end.
'Ascii Cols Filename Fit Font Header Footer Orient Ruler Tab Printer Printfile'=: opt
opt=. ; dq each '';Printer;Printfile
if. Orient do.
  glzorientation 2=Orient
end.
SCALE=: (glzqwh 6)%(1440 * glzqwh 2)
if. prnfile do.
  glzstartdoc''
  getcf''
  dirty=. 0
  while. #PRINTFILES do.
    PRINTFILE=: 0 pick PRINTFILES
    PRINTFILES=: }. PRINTFILES
    if. 0= printinit1`printinit2@.(1=P2UP)'' do.
      while. #PCMDS do.
        if. dirty do. glznewpage'' end.
        bufexe 0 pick PCMDS
        PCMDS=: }. PCMDS
        dirty=. 1
      end.
    end.
  end.
  glzenddoc''
else.
  glzstartdoc''
  getcf''
  if. 0= printinit1`printinit2@.(1=P2UP)'' do.
    dirty=. 0
    while. #PCMDS do.
      if. dirty do. glznewpage'' end.
      bufexe 0 pick PCMDS
      PCMDS=: }. PCMDS
      dirty=. 1
    end.
  end.
  glzenddoc''
end.
codestroy''
)
place=: 3 : 0

'just xywh font foreclr dummy lspace txt'=. y

rws=. #txt
if. 0=rws do. return. end.

if. #font do.
  vfont font
end.

vtextcolor foreclr
'x y width height'=. xywh
lspace=. {.lspace,1

hite=. 20* lspace*{.glzqtextmetrics''

len=. <.height%hite
pos=. x,y

rws=. rws <. len
res=. (<x,y,width,height-hite*rws) , <len }. txt
txt=. len {. txt

while. #txt do.

  line=. ,0 pick txt
  txt=. }.txt

  if. 0=#line do.
    pos=. pos+0,hite
    continue.
  end.
  if. -. 1 e. , E.&line &> TAGS do.

    if. just=0 do.
      vtextxy rnd0 pos
      vtext line

    elseif. just=1 do.
      wid=. 20* {. glzqextent line
      vtextxy rnd0 pos+(width-wid),0
      vtext line

    elseif. just=2 do.
    elseif. just=3 do.
      wid=. 20* {. glzqextent line
      vtextxy rnd0 pos+-:(width-wid),0
      vtext line
    end.
  else.
    'num wid'=. width fitline line
    vfont TFONT
    if. just=0 do.
      placeline pos;line

    elseif. just=1 do.

      placeline (pos+(width-wid),0);line

    elseif. just=2 do.
      blk=. +/line=' '

      if. (1<blk) *. wid >: width*3r4 do.
        opt=. (width-wid),blk
        opt placeline pos;line
      else.
        placeline pos;line
      end.

    elseif. just=3 do.
      placeline (pos+-:(width-wid),0);line

    end.

  end.
  pos=. pos+0,hite

end.

vtextcolor''
res
)
placeline=: 3 : 0
0 0 placeline y
:
'pos txt'=. y
'pad blk'=. x

while. #txt do.
  b=. +./ E.&txt &> TAGS
  ndx=. b i. 1
  bit=. ndx{.txt
  if. blk do.
    num=. +/bit=' '
    space=. >.pad*num%blk
    pad=. pad-space
    blk=. blk-num
  else.
    space=. 0
  end.

  vtextxy rnd0 pos
  vtext bit
  pos=. pos + 2{. space + 20* {. glzqextent bit

  txt=. ndx}.txt
  if. 0=#txt do. break. end.

  'tag txt'=. taketag txt

  vfont TFONT changetag tag
  b=. +./ E.&txt &> TAGS

end.
)
printinit2=: 3 : 0

if. #PRINTFILE do.
  Filename=: PRINTFILE , ' ' , (pfsize PRINTFILE) ,' ' , pfstamp PRINTFILE
  PRINTTXT=: fread PRINTFILE
end.

fascii=. boxascii^:Ascii

vfont Font

HEADER=: > 0 printheader Header ; Filename

'wid len'=. <. 1440* glzqwh 2
'hite width'=. 20* 0 6 { glzqtextmetrics ''

inlen=. len * 1 - TOPM2 + BOTM2
rws=. <. inlen % hite * 1.2
leftm0=. wid * LEFTM2
leftm1=. leftm0 + -:wid
ftrow=. len * 1 - FOOTM2
irws=. (len * TOPM2) + inlen * (i.rws) % rws
n=. #HEADER
rws=. rws - n

Cols=: <. width %~ -: wid * 1 - 3*LEFTM2
RULE=. fascii > printruler Cols

LHDR=: rnd0 leftm0 ,. n {. irws
RHDR=: rnd0 leftm1 ,. n {. irws
LTXT=: rnd0 leftm0 ,. n }. irws
RTXT=: rnd0 leftm1 ,. n }. irws
LFTR=: rnd0 leftm0 , ftrow
RFTR=: rnd0 leftm1 , ftrow
LINE=: rnd0 , (-:wid) ,. len * (1 - TOPM2) , FOOTM2

PAGE=: 0
foot=: (((Cols - 30) {.!.' ' Footer) , tstamp '')&stamp

dat=. cleanup PRINTTXT
dat=. fascii dat
dat=. Tab xtab dat
dat=. FF cutopen dat
dat=. Cols fold each ucp each dat
dat=. ((4 * Ruler) - rws)&(<\) each dat
TRWS=: rws
TCLS=: Cols
TEXT=: > ;dat
if. Ruler do.
  TEXT=: RULE ,"2 TEXT
end.
print2pages''
0
)
print2pages=: 3 : 0
bufinit''
PAGE=: 0
cmd=. (vtext@[ vtextxy)"1
while. #TEXT do.
  mat=. TRWS, TCLS
  vfont TFONT
  vpen 5 0
  vlines LINE
  if. #HEADER do. HEADER cmd LHDR end.
  (mat {. {.TEXT) cmd LTXT
  TEXT=: }.TEXT
  PAGE=: >:PAGE
  (foot PAGE) cmd LFTR
  if. #TEXT do.
    if. #HEADER do. HEADER cmd LHDR end.
    (mat {. {.TEXT) cmd RTXT
    TEXT=: }.TEXT
    PAGE=: >:PAGE
    (foot PAGE) cmd RFTR
  end.
  vpage''
end.
)
printn=: 4 : 0
if. 0 e. $y do. return. end.
if. 2 <: #$y do. mat=. y
else. mat=. ];._2 y,LF -. _1{.y
end.
cat=. ,&,.&.|:
txt=. ''
rws=. 72
cls=. _2+<. 161 % x
mat=. '  ' ,"1 ~ cls{."1 mat
pad=. 10
while. #mat do.
  blk=. rws {. mat
  ndx=. 1 i:~ blk *./ .= ' '
  if. ndx>rws-pad do. blk=. ndx{.blk end.
  txt=. txt,<rws{.blk
  mat=. mat }.~ #blk
end.
txt=. _4 (cat each /)\ txt
txt=. _2 (}."1) each txt
prn=. ; (,&FF) on  }. on , on (LF&,.) each txt
font=. P2UPFONT_jprint_
('land;font ',font) print prn
)
printinit1=: 3 : 0
if. #PRINTFILE do.
  Filename=: PRINTFILE , ' ' , (pfsize PRINTFILE) ,' ' , pfstamp PRINTFILE
  PRINTTXT=: fread PRINTFILE
end.

txt=. cleanup PRINTTXT
if. 0 e. $txt do. 1 return. end.
fascii=. boxascii ^: Ascii
vfont Font

getprintpage''
'x y width height'=. getframe LEFTM , TOPM , (-RIGHTM) , -FOOTM

HEADER=: > width printheader Header ; Filename

hite=. 20* {.glzqtextmetrics ''

fb=. 1440 * BOTM - FOOTM
headhite=. hite * #HEADER
texthite=. height - fb + headhite
HEADBOX=: x , y , width , headhite
TEXTBOX=: x , (y + headhite) , width , texthite
FOOTBOX=: x , (y + height - fb), width , hite
txt=. fascii txt
txt=. Tab xtab txt
if. Fit do. txt=. topara txt end.
txt=. FF cutopen txt
TEXT=: width wraptext each txt
TEXTP=: ''
if. Ruler do.
  if. (2 = 3!:0 y) *. 1 < # $y do.
    cls=. {: $y
  else.
    cls=. >./ ; #&> each TEXT
  end.
  RULE=: fascii each printruler cls
  RULEBOX=: x , (y + headhite), width , 3 * hite
  TEXTBOX=: x , (y + headhite + 3 * hite) , width , texthite - 3 * hite
else.
  RULE=: RULEBOX=: ''
end.
LFTR=: (-.0 e. $Footer) # < ,: ,Footer
rfoot=: [: < [: ,: (tstamp '')&stamp
printpages''
0
)
printpages=: 3 : 0
bufinit''
PAGE=: 0
while. (#TEXT) + #TEXTP do.
  PAGE=: >: PAGE
  if. #TEXTP do.
    printpage''
  else.
    if. #TEXT do.
      TEXTP=: 0 pick TEXT
      TEXT=: }.TEXT
      printpage''
    end.
  end.
end.
0
)
printpage=: 3 : 0
vfont TFONT
place 0 ; HEADBOX ; '' ; '' ; '' ; 1 ; <HEADER
place 0 ; RULEBOX ; '' ; '' ; '' ; 1 ; <RULE
'pos p1'=. place 0 ; TEXTBOX ; '' ; '' ; '' ; 1 ; <TEXTP
place 0 ; FOOTBOX ; '' ; '' ; '' ; 1 ; <LFTR
place 1 ; FOOTBOX ; '' ; '' ; '' ; 1 ; <rfoot PAGE
vpage ''
TEXTP=: p1
)
pfsize=: 3 : 0
}. ;',' , each |. _3 <@|.\ |. ":fsize y
)
pfstamp=: 3 : 0
'y r'=. split fstamp y
y=. (":y) , ;_2&{.@('0'&,)@":&> r
n=. 'xxxx-xx-xx xx:xx:xx'
y (I. n = 'x') } n
)
printopts=: 4 : 0

std=. PRINTOPT
y=. std,((0<#std)#';'),y

if. x do.
  font=. P2UPFONT
else.
  font=. PRINTERFONT
end.

filename=: ''
printer=: ''
printfile=: ''
header=. ''
footer=. ''
cols=. 80
tab=. 4

def=. 0: = 4!:0@<

if. #y do.
  opts=. dltb each ';' cutopen y
  opts=. ((tolower@{. ; }.@}.)~ i.&' ')&> opts
  try. ({."1 opts)=. {:"1 opts
  catch.
    sminfo 'Print';'Error in print options' return.
  end.
end.

fit=. def 'fit'
ruler=. def 'ruler'

if. def 'ascii' do.
  ascii=. {. 1 ". ascii,' 1'
else.
  ascii=. 0
end.

if. 2 = 3!:0 cols do.
  cols=. {. 80 ". cols
end.

if. 2 = 3!:0 tab do.
  tab=. {. 4 ". tab
end.

if. P2UP do.
  orient=. 2
else.
  if. +./ def&> 'port' ; 'portrait' do.
    orient=. 1
  elseif. +./ def&> 'land' ; 'landscape' do.
    orient=. 2
  elseif. 1 do.
    orient=. 0
  end.
end.

if. def 'fontsize' do.
  defsize=. ". >1 { boxfont font
  font=. font changefont defsize ". fontsize
end.

ascii ; cols ; filename ; fit ; font ; header ; footer ; orient ; ruler ; tab ; printer ; printfile
)
printruler=: 3 : 0
j=. >.0.2 * len=. y
'a b c'=. 1 4 7 { , 9!:6 ''
r=. len #"1 ,. c , ' ' , a
i=. }.5 * i.j
r=. b (<0 2 ; 0 , i) } r
r=. '0' (<1 ; 0) } r
if. len > 5 do.
  r=. (3 ": ,.i) (<1 ; i -/ 2 1 0) } r
end.
<"1 r
)
printfilename=: 4 : 0
f=. y
f2=. ''
tag=. '...'
if. x printnofit f do.
  ndx=. (_21 }. f) i: ' '
  f2=. (ndx + 1) }. f
  f=. dltb ndx {. f
  while. x printnofit f do.
    f=. (3 * tag -: 3 {. f) }. f
    f=. (PATHSEP = {.f) }. f
    f=. tag , f }.~ f i. PATHSEP
  end.
end.
f ; f2
)
printnofit=: 4 : 0
if. x do. w=. {.x fitline y else. w=. Cols end.
w < #y
)
printheader=: 4 : 0
'hdr fnm'=. y
'fnm fnm2'=. x printfilename fnm
r=. ''
if. #hdr do. r=. hdr ; '' end.
r , (boxxopen fnm) , (boxxopen fnm2) , boxxopen (0 < #fnm) # ' '
)
qprinter=: 3 : 0
''
)
TAB=: 9 { a.
TAGS=: '<b>';'</b>';'<i>';'</i>'
TAGIDS=: ;:'bold nobold italic noitalic'
BLACK=: 0
WHITE=: <:2^24

deb=: #~ (+. 1: |. (> </\))@(' '&~:)
dlb=: }.~ =&' ' i. 0:
dltb=: #~ [: (+./\ *. +./\.) ' '&~:
dtb=: #~ [: +./\. ' '&~:
round=: [ * [: <. 0.5"_ + %~
rnd0=: <.@(0.5&+)
tolist=: }.@;@:(LF&,@,@":&.>)
boxascii=: 3 : 0
y=. ": y
to=. '+++++++++|-'
fm=. 9!:6 ''
(to,a.) {~ (fm,a.) i. y
)
unibox=: 3 : 0
fm=. (16+i.11) { a.
msk=. y e. fm
if. -. 1 e. msk do. utf8 y return. end.
to=. 4 u: 9484 9516 9488 9500 9532 9508 9492 9524 9496 9474 9472
y=. ucp y
msk=. y e. fm
un=. to {~ fm i. msk#y
utf8 un (I.msk) } y
)
boxfont=: 3 : 0
font=. ' ',y
b=. (font=' ') > ~:/\font='"'
a: -.~ b <;._1 font
)
changefont=: 4 : 0
font=. ' ',x
b=. (font=' ') > ~:/\font='"'
font=. a: -.~ b <;._1 font
opt=. y
if. 0=L. opt do. opt=. cutopen ":opt end.
opt=. a: -.~ (-.&' ' @ ":) each opt
num=. _1 ~: _1 ". &> opt
if. 1 e. num do.
  font=. ({.num#opt) 1} font
  opt=. (-.num)#opt
end.
ayes=. ;:'bold italic'
noes=. ;:'nobold noitalic'
font=. font , opt -. noes
font=. font -. (noes e. opt)#ayes
}: ; ,&' ' each ~. font
)
changetag=: 4 : 0
x changefont TAGIDS {~ TAGS i. boxopen y
)
cleanup=: 3 : 0
y=. flatten y
toJ ' ' (I. y e. 27{a.) } y
)
cutpara=: 3 : 0
txt=. topara y
txt=. txt,(LF ~: {:txt)#LF
b=. (}.b,0) < b=. txt=LF
b <;._2 txt
)
dq=: 3 : 0
y=. ": y
if. '"' ~: {. y do.
  '"',(y #~ >: y = '"'),'" '
else.
  y,' '
end.
)
emptymatrix=: ,:`empty @. (0:=#)
fitchars=: 4 : 0

fit=. *&CF @ *&20 @ {. @ glzqextent @ ({.&y)
max=. #y
avg=. 20* 5{ glzqtextmetrics''

try=. max <. >. x % avg
if. x > fit try do.
  while.
    (max > try) *. x >: fit >: try
  do. try=. >: try end.
else.
  while.
    (0 < try) *. x < fit try
  do. try=. <: try end.
end.
try, fit try
)
fitline=: 4 : 0
wid=. x
txt=. y
b=. +./ E.&txt &> TAGS
if. -. 1 e. b do.
  num=. wid fitwords txt
  if. 0={.num do.
    num=. wid fitchars txt
  end.
  return.
end.
tnum=. tlen=. 0

while. 1 do.
  ndx=. b i. 1

  if. ndx>0 do.
    'num len'=. wid fitwords ndx{.txt

    tnum=. tnum + num
    tlen=. tlen + len

    if. num<ndx do.
      if. 0=tnum do.
        wid fitchars txt
      else.
        tnum,tlen
      end.
      return.
    end.

    wid=. wid-len
    txt=. ndx}.txt

    if. (wid <: 0) +. 0 = #txt do. tnum,tlen return. end.
  end.

  'tag txt'=. taketag txt
  tnum=. tnum + #;tag

  TFONT=: TFONT changetag tag
  glzfont TFONT

  if. 0=#txt do. tnum,tlen return. end.

  b=. +./ E.&txt &> TAGS

end.
)
fitwords=: 4 : 0
ndx=. 0, I. (y=' '),1 1
fit=. *&CF @ *&20 @ {. @ glzqextent @ ({.&y) @ ({&ndx)
max=. _2+#ndx
avg=. 20* 5{ glzqtextmetrics''

try=. max <. 1 i.~ ndx >: x % avg

if. x > len=. fit try do.
  while.
    (max > try) *. x >: trylen=. fit >: try
  do. len=. trylen [ try=. >: try end.

else.
  while.
    (0 < try) *. x < len=. fit try
  do. try=. <: try end.
end.
(try{ndx) , len

)
flatten=: 3 : 0
dat=. ": y
if. 2 > #$dat do. return. end.
dat=. 1 1}. _1 _1}. ": <dat
}: (,|."1 [ 1,.-. *./\"1 |."1 dat=' ')#,dat,.LF
)
fold=: 4 : 0
dat=. toJ y
dat=. <;._2 dat,LF #~ LF ~: {: dat
dat=. ({.!.' '~ 1&>.@#) &.> dat
> ,&.> / (-x) (x&{.) \ &.> dat
)
getdevmode=: 3 : 0
''
)
getfile=: 3 : 0
try. {."1 getscripts_j_ y
catch. <^:(< -: {:@;~) y
end.
)
getframe=: 3 : 0
'px py pw ph j j wid hit'=. ,PRINTPAGE
'x y w h'=. 1440 * y
x=. 0 >. x - px
if. w <: 0 do. w=. wid + w - 0 >. x - px end.
w=. w <. pw - x
y=. 0 >. y - py
if. h <: 0 do. h=. hit + h - 0 >. y - py end.
h=. h <. ph - y
x,y,w,h
)
getpos=: 3 : 0
0 getpos y
:
'px py pw ph j j wid hit'=. ,PRINTPAGE
if. x=0 do.
  'x y'=. 1440 * y
  if. x >: 0 do.
    x=. pw <. 0 >. x - px
  else.
    x=. 0 >. wid + x - px
  end.
  if. y >: 0 do.
    y=. 0 >. ph - 0 >. y - py
  else.
    y=. ph - 0 >. hit + y - py
  end.
  x,y
else.
  'x y'=. y
  x=. px + x
  y=. py + ph - y + h
  1440 %~ x,y
end.
)
getprintfiles=: 3 : 0
y=. getfile y
for_f. y do.
  try. 1!:1 f
  catch.
    empty sminfo 'print' ; 'file not found: ' , >f return.
  end.
  PRINTFILES=: PRINTFILES,y
end.
empty ''
)
getprintpage=: 3 : 0
'w h'=. <. 1440 * glzqwh 2
'l t r b'=. <. 1440 * glzqmargins 2
PRINTPAGE=: (l,t,(w-l+r),(h-t+b)),:0 0,w,h
)
preview=: 3 : 0
glwindowext (<0;2 3){PRINTPAGE
wd'pshow'
glpaint ''
)
printers=: }: @ wdqprinters
removetag=: 3 : 0
r=. ''
while. 1 e. b=. +./ E.&y &> TAGS do.
  ndx=. b i. 1
  r=. r,ndx{.y
  y=. ndx}.y
  y=. (>:y i.'>')}.y
end.
r=. r,y
)

stamp=: 4 : 0
x,'  Page ',":y
)
taketag=: 3 : 0
tag=. ''
txt=. y
while. '<' = 1{.txt do.
  ind=. >:txt i.'>'
  tag=. tag,<ind {.txt
  txt=. ind }. txt
end.
tag;txt
)
topara=: 3 : 0
if. 0=#y do. '' return. end.
if. 1<#$y do. y return. end.
txt=. toJ y
b=. txt=LF
c=. b +. txt=' '
b=. b > (0,}:b) +. }.c,0
txt=. ' ' (b#i.#b) } txt
return.
b=. b *: 0,}:b=. txt=LF
txt=. b#txt
)
tstamp=: 3 : 0
y=. <.y,(0=#y)#6!:0 ''
'y m d h n s'=. 6{.y
mth=. _3[\'   JanFebMarAprMayJunJulAugSepOctNovDec'
f=. _2: {. '0'&,@":
t=. (2":d),(m{mth),(":y),;f&.>h,n,s
r=. 'xx xxx xxxx xx:xx:xx'
t (I. r='x') } r
)
xtabline=: 4 : 0
r=. y
while.
  i=. >: r i. TAB
  i <: #r
do.
  r=. ((x * >. i % x){.!.' ' }:i{.r) , i}.r
end.
)
xtab=: 4 : 0
if. -. TAB e. y do. y return. end.
y=. <;._2 y,(LF ~: {:y)#LF
b=. TAB e.&> y
tolist (x xtabline each b#y) (I. b)} y
)
wrappara=: 4 : 0
if. 0=#y do. <a: return. end.
r=. ''
txt=. y
while. #txt do.
  len=. {.x fitline txt
  line=. len{.txt
  txt=. len}.txt
  txt=. (' '=1{.txt)}.txt
  r=. r,<line
end.
<r
)
wraptext=: 4 : 0
if. 0 e. $y do. '' return. end.
if. 2=#$y do. ;/y return. end.
txt=. toJ y
if. -. LF e. txt do. >x wrappara txt return. end.
txt=. txt,(LF~:{:txt)#LF
txt=. ;x&wrappara ;._2 txt
)

getcf=: 3 : 0
glzfont CFFONT
CF=: 72% {. glzqextent 10#'m'
)
doprint=: 1 : 0
cocurrent conew 'jprint'
('';m) printit y
:
cocurrent conew 'jprint'
(x;m) printit y
)
print=: 'print' doprint
print2=: 'print2' doprint
printfile=: 'printfile' doprint
printfile2=: 'printfile2' doprint
coclass 'jafm'
create=: 3 : 0
'font size'=. y
if. -. ischar font do.
  font=. font pick PSFONTNAMES
end.
fnt=. font -. '-'
Name=: font
Size=: size
Ascender=: 0
0!:100 (fnt,'_FontMetrics')~
mat=. (fnt,'_CharMetrics')~
Chars=: a. {~ 0 {"1 mat
Widths=: (1 {"1 mat) * Size % 1000
Boxes=: 2 }."1 mat
AscenderP=: Ascender * Size % 1000
Widths=: Widths, average Widths
Boxes=: Boxes, <. average Boxes
)

destroy=: codestroy
average=: +/ % #
ischar=: 3!:0 e. 2 131072 262144"_
getascender=: 3 : 0
'fnt sty siz ang und'=. 5 {. y
nam=. getfntnameNH fnt,sty
(siz % 1000) * (nam,'_Ascender')~
)
getextent=: 4 : 0
'fnt sty siz ang und'=. 5 {. x
nam=. getfntnameNH fnt,sty
met=. (nam,'_CharMetrics')~
chr=. 0 {"1 met
wid=. 1 {"1 met
if. 1 = #y do.
  ext=. ($y) $ +/ wid {~ (#chr) | chr i. a. i. 0 pick y
else.
  len=. # &> y
  ext=. wid {~ (#chr) | chr i. a. i.; y
  msk=. , len > 0
  ext=. msk expand (; len {.each 1) +/;.1 ext
end.
|: siz * (ext % 1000) ,. 1
)
getextent1=: 4 : 0
'fnt sty siz ang und'=. 5 {. x
nam=. getfntnameNH fnt,sty
met=. (nam,'_CharMetrics')~
chr=. 0 {"1 met
wid=. 1 {"1 met
ext=. +/ wid {~ (#chr) | chr i. a. i. y
siz * (ext % 1000), 1
)
getfntname=: 3 : 0
'fnt sty'=. y
if. 4 > fnt do.
  nam=. (4 #. y) pick PSFONTNAMES
else.
  nam=. fnt pick FONTNAMES
end.
)
getfntnameNH=: 3 : 0
'fnt sty'=. y
if. 4 > fnt do.
  nam=. (4 #. y) pick PSFONTNAMESNH
else.
  nam=. fnt pick FONTNAMESNH
end.
)
getfont=: 3 : 0
font=. tolower ' ',y -. '-'
b=. (font=' ') > ~:/\font='"'
fnt=. a: -.~ b <;._1 font
nam=. < '"' -.~ > {. fnt
fnt=. }. fnt
if. #fnt do.
  num=. {. &> 0 ". each fnt
  msk=. num > 0
  siz=. (msk i. 1) { num
else.
  siz=. 10
end.
sty=. 0
ndx=. PSFONTNAMESLC i. nam
if. ndx < #PSFONTNAMESLC do.
  fnx=. <. ndx % 4
  sty=. 4 | ndx
else.
  ndx=. GTKFONTNAMESLC i. nam
  if. ndx < # GTKFONTNAMESLC do.
    fnx=. ndx { GTKFONTNAMESX
  else.
    ndx=. ISIFONTNAMESLC i. nam
    if. ndx < # ISIFONTNAMESLC do.
      fnx=. ndx { ISIFONTNAMESX
    else.
      fnx=. (#FONTNAMESLC) | FONTNAMESLC i. nam
    end.
  end.
end.
if. 0 = sty do.
  sty=. +/ 1 2 * ('bold';'italic') e. fnt
end.
und=. (<'underline') e. fnt
ang=. {. 90 270 #~ ('angle900';'angle2700') e. fnt
fnx,sty,siz,ang,und
)
getfontid=: 3 : 0
if. ischar y do.
  getfont y
else.
  y
end.
)
getgtkfontid=: 3 : 0
if. ischar y do.
  getfont y
else.
  y
end.
)
getisifontid=: 3 : 0
if. ischar y do.
  fnt=. getfont y
else.
  fnt=. y
end.
'ind fst siz ang und'=. fnt
'ita bld'=. 2 2 #: fst
sty=. (bld#' bold'),(ita#' italic'),und#' underline'
sty=. sty,(0 < ang)#' angle',":10*ang
ind=. (#ISIFONTNAMES) | ISIFONTNAMESX i. ind
'"',(ind pick ISIFONTNAMES),'" ',(":siz),sty
)

getstringlen=: {. @ getextent
getstringlen1=: {. @ getextent1
getunderline=: 3 : 0
'fnt sty siz ang und'=. 5 {. y
id=. fnt pick PSFONTNAMESNH
pos=. (id,'_UnderlinePosition')~
thk=. (id,'_UnderlineThickness')~
(siz % 1000) * pos,thk
)
j=. 0 : 0
Helvetica
Courier
Times-Roman
Symbol
MSung-Light
STSong-Light
)

FONTNAMES=: <;._2 j
FONTNAMESLC=: <;._2 tolower j -. '-'
FONTNAMESNH=: <;._2 j -. '-'
j=. 0 : 0
Helvetica
Helvetica-Bold
Helvetica-Oblique
Helvetica-BoldOblique
Courier
Courier-Bold
Courier-Oblique
Courier-BoldOblique
Times-Roman
Times-Bold
Times-Italic
Times-BoldItalic
Symbol
ZapfDingbats
)

PSFONTNAMES=: <;._2 j
PSFONTNAMESLC=: <;._2 tolower j -. '-'
PSFONTNAMESNH=: <;._2 j -. '-'
fntms=. <;._2 (0 : 0)
0 Arial
0 Sans
0 SansSerif
1 Courier
1 Lucida Console
1 Mono
1 Monospace
2 Serif
2 Times
2 Times New Roman
2 Times New Roman
3 Symbol
)

ISIFONTNAMES=: 2 }. each fntms
ISIFONTNAMESLC=: tolower each ISIFONTNAMES
ISIFONTNAMESX=: 0 ". &> 2 {. each fntms

fntux=. <;._2 (0 : 0)
0 Helvetica
0 Sans
0 SansSerif
1 Courier
1 Lucida Console
1 Mono
1 Monospace
2 Serif
2 Times
2 Times New Roman
2 Times New Roman
3 Symbol
)

fnt=. IFUNIX {:: fntms ;< fntux
GTKFONTNAMES=: 2 }. each fnt
GTKFONTNAMESLC=: tolower each GTKFONTNAMES
GTKFONTNAMESX=: 0 ". &> 2 {. each fnt

fntand=. <;._2 (0 : 0)
0 Sans
0 Sans
0 Sans
1 Monospace
1 Monospace
1 Monospace
1 Monospace
2 Serif
2 Serif
2 Serif
2 Serif
3 Mono
)

ANDFONTNAMES=: 2 }. each fntand
ANDFONTNAMESLC=: tolower each ANDFONTNAMES
ANDFONTNAMESX=: 0 ". &> 2 {. each fntand

3 : 0''
if. 'Android'-:UNAME do.
  QTFONTNAMES=: ANDFONTNAMES
  QTFONTNAMESLC=: ANDFONTNAMESLC
  QTFONTNAMESX=: ANDFONTNAMESX
else.
  QTFONTNAMES=: GTKFONTNAMES
  QTFONTNAMESLC=: GTKFONTNAMESLC
  QTFONTNAMESX=: GTKFONTNAMESX
end.
EMPTY
)
getbbox=: 3 : 0
(Chars i. y) { Boxes
)
getcellwid=: 3 : 0
vec=. , y
len=. >./ # &> vec
txt=. > len {.!.({.a.) each vec
wid=. +/"1 (Chars i. txt) { Widths
($y) $ wid
)
getcolwid=: 3 : 0
rws=. # &> y
mat=. ; y
vec=. , mat
len=. >./ # &> vec
txt=. > len {.!.({.a.) each vec
wid=. +/"1 (Chars i. txt) { Widths
wid=. ($mat) $ wid
max=. >./ wid
tab=. (; rws {.each 1) <;.1 wid
tab;max
)
getcharlen=: 3 : 0
(Chars i. y) { Widths
)
getstrlen=: 3 : 0
+/ (Chars i. y) { Widths
)
getstrwid=: 3 : 0
>./ getstrlen &> <;._1 LF,y
)
getstrlens=: 3 : 0
+/\ (Chars i. y) { Widths
)
MSungLight_Ascender=: 826
MSungLight_FontBBox=: _260 _174 1043 826
MSungLight_CharMetrics=: ,: 0 600 92 38 503 520

MSungLight_FontMetrics=: 0 : 0
Ascender=: 826
CapHeight=: 625
Descender=: -174
FontBBox=: _260 _174 1043 826
)
STSongLight_Ascender=: 826
STSongLight_FontBBox=: _260 _174 1043 826
STSongLight_CharMetrics=: ,: 0 600 92 38 503 520

STSongLight_FontMetrics=: 0 : 0
Ascender=: 826
CapHeight=: 625
Descender=: -174
FontBBox=: _260 _174 1043 826
)
Courier_Ascender=: 629

Courier_FontBBox=: _23 _250 715 805

Courier_UnderlinePosition=: _100

Courier_UnderlineThickness=: 50

Courier_FontMetrics=: 0 : 0
Ascender=: 629
CapHeight=: 562
Descender=: _157
FontBBox=: _23 _250 715 805
StdHW=: 51
StdVW=: 51
UnderlinePosition=: _100
UnderlineThickness=: 50
XHeight=: 426
)

Courier_CharMetrics=: 0 ". [;._2 (0 : 0)
  0 600  92   38 503 520
 32 600   0    0   0   0
 33 600 236  _15 364 572
 34 600 187  328 413 562
 35 600  93  _32 507 639
 36 600 105 _126 496 662
 37 600  81  _15 518 622
 38 600  63  _15 538 543
 39 600 213  328 376 562
 40 600 269 _108 440 622
 41 600 160 _108 331 622
 42 600 116  257 484 607
 43 600  80   44 520 470
 44 600 181 _112 344 122
 45 600 103  231 497 285
 46 600 229  _15 371 109
 47 600 125  _80 475 629
 48 600 106  _15 494 622
 49 600  96    0 505 622
 50 600  70    0 471 622
 51 600  75  _15 466 622
 52 600  78    0 500 622
 53 600  92  _15 497 607
 54 600 111  _15 497 622
 55 600  82    0 483 607
 56 600 102  _15 498 622
 57 600  96  _15 489 622
 58 600 229  _15 371 385
 59 600 181 _112 371 385
 60 600  41   42 519 472
 61 600  80  138 520 376
 62 600  66   42 544 472
 63 600 129  _15 492 572
 64 600  77  _15 533 622
 65 600   3    0 597 562
 66 600  43    0 559 562
 67 600  41  _18 540 580
 68 600  43    0 574 562
 69 600  53    0 550 562
 70 600  53    0 545 562
 71 600  31  _18 575 580
 72 600  32    0 568 562
 73 600  96    0 504 562
 74 600  34  _18 566 562
 75 600  38    0 582 562
 76 600  47    0 554 562
 77 600   4    0 596 562
 78 600   7  _13 593 562
 79 600  43  _18 557 580
 80 600  79    0 558 562
 81 600  43 _138 557 580
 82 600  38    0 588 562
 83 600  72  _20 529 580
 84 600  38    0 563 562
 85 600  17  _18 583 562
 86 600  _4  _13 604 562
 87 600  _3  _13 603 562
 88 600  23    0 577 562
 89 600  24    0 576 562
 90 600  86    0 514 562
 91 600 269 _108 442 622
 92 600 118  _80 482 629
 93 600 158 _108 331 622
 94 600  94  354 506 622
 95 600   0 _125 600 _75
 96 600 224  328 387 562
 97 600  53  _15 559 441
 98 600  14  _15 575 629
 99 600  66  _15 529 441
100 600  45  _15 591 629
101 600  66  _15 548 441
102 600 114    0 531 629
103 600  45 _157 566 441
104 600  18    0 582 629
105 600  95    0 505 657
106 600  82 _157 410 657
107 600  43    0 580 629
108 600  95    0 505 629
109 600  _5    0 605 441
110 600  26    0 575 441
111 600  62  _15 538 441
112 600   9 _157 555 441
113 600  45 _157 591 441
114 600  60    0 559 441
115 600  80  _15 513 441
116 600  87  _15 530 561
117 600  21  _15 562 426
118 600  10  _10 590 426
119 600  _4  _10 604 426
120 600  20    0 580 426
121 600   7 _157 592 426
122 600  99    0 502 426
123 600 182 _108 437 622
124 600 275 _250 326 750
125 600 163 _108 418 622
126 600  63  197 540 320
161 600 236 _157 364 430
162 600  96  _49 500 614
163 600  84  _21 521 611
164 600  92  _57 509 665
165 600  26    0 574 562
166 600   4 _143 539 622
167 600 113  _78 488 580
168 600  73   58 527 506
169 600 259  328 341 562
170 600 143  328 471 562
171 600  37   70 563 446
172 600 149   70 451 446
173 600 149   70 451 446
174 600   3    0 597 629
175 600   3    0 597 629
177 600  75  231 525 285
178 600 141  _78 459 580
179 600 141  _78 459 580
180 600 222  189 378 327
182 600  50  _78 511 562
183 600 172  130 428 383
184 600 213 _134 376 100
185 600 143 _134 457 100
186 600 143  328 457 562
187 600  37   70 563 446
188 600  37  _15 563 111
189 600   3  _15 600 622
191 600 108 _157 471 430
193 600 151  497 378 672
194 600 242  497 469 672
195 600 124  477 476 654
196 600 105  489 503 606
197 600 120  525 480 565
198 600 153  501 447 609
199 600 249  537 352 640
200 600 148  537 453 640
202 600 218  463 382 627
203 600 224 _151 362  10
205 600 133  497 540 672
206 600 211 _172 407   4
207 600 124  492 476 669
208 600   0  231 600 285
225 600   3    0 550 562
227 600 156  249 442 580
232 600  47    0 554 562
233 600  43  _80 557 629
234 600   7    0 567 562
235 600 157  249 443 580
241 600  19  _15 570 441
245 600  95    0 505 426
248 600  95    0 505 629
249 600  62  _80 538 506
250 600  19  _15 559 441
251 600  48  _15 588 629
)
CourierBold_Ascender=: 629

CourierBold_FontBBox=: _113 _250 749 801

CourierBold_UnderlinePosition=: _100

CourierBold_UnderlineThickness=: 50

CourierBold_FontMetrics=: 0 : 0
Ascender=: 629
CapHeight=: 562
Descender=: _157
FontBBox=: _113 _250 749 801
StdHW=: 84
StdVW=: 106
UnderlinePosition=: _100
UnderlineThickness=: 50
XHeight=: 439
)

CourierBold_CharMetrics=: 0 ". [;._2 (0 : 0)
  0 600   68   34 525 525
 32 600    0    0   0   0
 33 600  202  _15 398 572
 34 600  135  277 465 562
 35 600   56  _45 544 651
 36 600   82 _126 519 666
 37 600    5  _15 595 616
 38 600   36  _15 546 543
 39 600  171  277 423 562
 40 600  219 _102 461 616
 41 600  139 _102 381 616
 42 600   91  219 509 601
 43 600   71   39 529 478
 44 600  123 _111 393 174
 45 600  100  203 500 313
 46 600  192  _15 408 171
 47 600   98  _77 502 626
 48 600   87  _15 513 616
 49 600   81    0 539 616
 50 600   61    0 499 616
 51 600   63  _15 501 616
 52 600   53    0 507 616
 53 600   70  _15 521 601
 54 600   90  _15 521 616
 55 600   55    0 494 601
 56 600   83  _15 517 616
 57 600   79  _15 510 616
 58 600  191  _15 407 425
 59 600  123 _111 408 425
 60 600   66   15 523 501
 61 600   71  118 529 398
 62 600   77   15 534 501
 63 600   98  _14 501 580
 64 600   16  _15 584 616
 65 600   _9    0 609 562
 66 600   30    0 573 562
 67 600   22  _18 560 580
 68 600   30    0 594 562
 69 600   25    0 560 562
 70 600   39    0 570 562
 71 600   22  _18 594 580
 72 600   20    0 580 562
 73 600   77    0 523 562
 74 600   37  _18 601 562
 75 600   21    0 599 562
 76 600   39    0 578 562
 77 600   _2    0 602 562
 78 600    8  _12 610 562
 79 600   22  _18 578 580
 80 600   48    0 559 562
 81 600   32 _138 578 580
 82 600   24    0 599 562
 83 600   47  _22 553 582
 84 600   21    0 579 562
 85 600    4  _18 596 562
 86 600  _13    0 613 562
 87 600  _18    0 618 562
 88 600   12    0 588 562
 89 600   12    0 589 562
 90 600   62    0 539 562
 91 600  245 _102 475 616
 92 600   99  _77 503 626
 93 600  125 _102 355 616
 94 600  108  250 492 616
 95 600    0 _125 600 _75
 96 600  178  277 428 562
 97 600   35  _15 570 454
 98 600    0  _15 584 626
 99 600   40  _15 545 459
100 600   20  _15 591 626
101 600   40  _15 563 454
102 600   83    0 547 626
103 600   30 _146 580 454
104 600    5    0 592 626
105 600   77    0 523 658
106 600   63 _146 440 658
107 600   20    0 585 626
108 600   77    0 523 626
109 600  _22    0 626 454
110 600   18    0 592 454
111 600   30  _15 570 454
112 600   _1 _142 570 454
113 600   20 _142 591 454
114 600   47    0 580 454
115 600   68  _17 535 459
116 600   47  _15 532 562
117 600   _1  _15 569 439
118 600   _1    0 601 439
119 600  _18    0 618 439
120 600    6    0 594 439
121 600   _4 _142 601 439
122 600   81    0 520 439
123 600  160 _102 464 616
124 600  255 _250 345 750
125 600  136 _102 440 616
126 600   71  153 530 356
161 600  202 _146 398 449
162 600   66  _49 518 614
163 600   72  _28 558 611
164 600   25  _60 576 661
165 600   10    0 590 562
166 600  _30 _131 572 616
167 600   83  _70 517 580
168 600   54   49 546 517
169 600  227  277 373 562
170 600   71  277 535 562
171 600    8   70 553 446
172 600  141   70 459 446
173 600  141   70 459 446
174 600   12    0 593 626
175 600   12    0 593 626
177 600   65  203 535 313
178 600  106  _70 494 580
179 600  106  _70 494 580
180 600  196  165 404 351
182 600    6  _70 576 580
183 600  140  132 460 430
184 600  175 _142 427 143
185 600   65 _142 529 143
186 600   61  277 525 562
187 600   47   70 592 446
188 600   26  _15 574 116
189 600 _113  _15 713 616
191 600   99 _146 502 449
193 600  132  508 395 661
194 600  205  508 468 661
195 600  103  483 497 657
196 600   89  493 512 636
197 600   88  505 512 585
198 600   83  468 517 631
199 600  230  498 370 638
200 600  128  498 472 638
202 600  198  481 402 678
203 600  205 _206 387   0
205 600   68  488 588 661
206 600  169 _199 400   0
207 600  103  493 497 667
208 600  _10  203 610 313
225 600  _29    0 602 562
227 600  147  196 453 580
232 600   39    0 578 562
233 600   22  _22 578 584
234 600  _25    0 595 562
235 600  147  196 453 580
241 600   _4  _15 601 454
245 600   77    0 523 439
248 600   77    0 523 626
249 600   30  _24 570 463
250 600  _18  _15 611 454
251 600   22  _15 596 626
)
CourierBoldOblique_Ascender=: 629

CourierBoldOblique_FontBBox=: _57 _250 869 801

CourierBoldOblique_UnderlinePosition=: _100

CourierBoldOblique_UnderlineThickness=: 50

CourierBoldOblique_FontMetrics=: 0 : 0
Ascender=: 629
CapHeight=: 562
Descender=: _157
FontBBox=: _57 _250 869 801
StdHW=: 84
StdVW=: 106
UnderlinePosition=: _100
UnderlineThickness=: 50
XHeight=: 439
)

CourierBoldOblique_CharMetrics=: 0 ". [;._2 (0 : 0)
  0 600 101   34 605 525
 32 600   0    0   0   0
 33 600 215  _15 495 572
 34 600 211  277 585 562
 35 600  88  _45 641 651
 36 600  87 _126 630 666
 37 600 101  _15 625 616
 38 600  61  _15 595 543
 39 600 229  277 543 562
 40 600 265 _102 592 616
 41 600 117 _102 444 616
 42 600 179  219 598 601
 43 600 114   39 596 478
 44 600  99 _111 430 174
 45 600 143  203 567 313
 46 600 206  _15 427 171
 47 600  90  _77 626 626
 48 600 135  _15 593 616
 49 600  93    0 562 616
 50 600  61    0 594 616
 51 600  71  _15 571 616
 52 600  81    0 559 616
 53 600  77  _15 621 601
 54 600 135  _15 652 616
 55 600 147    0 622 601
 56 600 115  _15 604 616
 57 600  75  _15 592 616
 58 600 205  _15 480 425
 59 600  99 _111 481 425
 60 600 120   15 613 501
 61 600  96  118 614 398
 62 600  97   15 589 501
 63 600 183  _14 592 580
 64 600  65  _15 642 616
 65 600  _9    0 632 562
 66 600  30    0 630 562
 67 600  74  _18 675 580
 68 600  30    0 664 562
 69 600  25    0 670 562
 70 600  39    0 684 562
 71 600  74  _18 675 580
 72 600  20    0 700 562
 73 600  77    0 643 562
 74 600  58  _18 721 562
 75 600  21    0 692 562
 76 600  39    0 636 562
 77 600  _2    0 722 562
 78 600   8  _12 730 562
 79 600  74  _18 645 580
 80 600  48    0 643 562
 81 600  83 _138 636 580
 82 600  24    0 617 562
 83 600  54  _22 673 582
 84 600  86    0 679 562
 85 600 101  _18 716 562
 86 600  84    0 733 562
 87 600  79    0 738 562
 88 600  12    0 690 562
 89 600 109    0 709 562
 90 600  62    0 637 562
 91 600 223 _102 606 616
 92 600 222  _77 496 626
 93 600 103 _102 486 616
 94 600 171  250 556 616
 95 600 _27 _125 585 _75
 96 600 297  277 487 562
 97 600  61  _15 593 454
 98 600  13  _15 636 626
 99 600  81  _15 631 459
100 600  60  _15 645 626
101 600  81  _15 605 454
102 600  83    0 677 626
103 600  40 _146 674 454
104 600  18    0 615 626
105 600  77    0 546 658
106 600  36 _146 580 658
107 600  33    0 643 626
108 600  77    0 546 626
109 600 _22    0 649 454
110 600  18    0 615 454
111 600  71  _15 622 454
112 600 _32 _142 622 454
113 600  60 _142 685 454
114 600  47    0 655 454
115 600  66  _17 608 459
116 600 118  _15 567 562
117 600  70  _15 592 439
118 600  70    0 695 439
119 600  53    0 712 439
120 600   6    0 671 439
121 600 _21 _142 695 439
122 600  81    0 614 439
123 600 203 _102 595 616
124 600 201 _250 505 750
125 600 114 _102 506 616
126 600 120  153 590 356
161 600 196 _146 477 449
162 600 121  _49 605 614
163 600 106  _28 650 611
164 600  22  _60 708 661
165 600  98    0 710 562
166 600 _57 _131 702 616
167 600  74  _70 620 580
168 600  77   49 644 517
169 600 303  277 493 562
170 600 190  277 594 562
171 600  62   70 639 446
172 600 195   70 545 446
173 600 165   70 514 446
174 600  12    0 644 626
175 600  12    0 644 626
177 600 108  203 602 313
178 600 175  _70 586 580
179 600 121  _70 587 580
180 600 248  165 461 351
182 600  61  _70 700 580
183 600 196  132 523 430
184 600 144 _142 458 143
185 600  34 _142 560 143
186 600 119  277 645 562
187 600  71   70 647 446
188 600  35  _15 587 116
189 600 _45  _15 743 616
191 600 100 _146 509 449
193 600 272  508 503 661
194 600 312  508 609 661
195 600 212  483 607 657
196 600 199  493 643 636
197 600 195  505 637 585
198 600 217  468 652 631
199 600 348  498 493 638
200 600 246  498 595 638
202 600 319  481 528 678
203 600 168 _206 368   0
205 600 171  488 729 661
206 600 143 _199 367   0
207 600 238  493 633 667
208 600  33  203 677 313
225 600 _29    0 708 562
227 600 188  196 526 580
232 600  39    0 636 562
233 600  48  _22 673 584
234 600  26    0 701 562
235 600 188  196 543 580
241 600  21  _15 652 454
245 600  77    0 546 439
248 600  77    0 587 626
249 600  54  _24 638 463
250 600  18  _15 662 454
251 600  22  _15 629 626
)
CourierOblique_Ascender=: 629

CourierOblique_FontBBox=: _27 _250 849 805

CourierOblique_UnderlinePosition=: _100

CourierOblique_UnderlineThickness=: 50

CourierOblique_FontMetrics=: 0 : 0
Ascender=: 629
CapHeight=: 562
Descender=: _157
FontBBox=: _27 _250 849 805
StdHW=: 51
StdVW=: 51
UnderlinePosition=: _100
UnderlineThickness=: 50
XHeight=: 426
)

CourierOblique_CharMetrics=: 0 ". [;._2 (0 : 0)
  0 600 125   38 580 520
 32 600   0    0   0   0
 33 600 243  _15 464 572
 34 600 273  328 532 562
 35 600 133  _32 596 639
 36 600 108 _126 596 662
 37 600 134  _15 599 622
 38 600  87  _15 580 543
 39 600 283  328 495 562
 40 600 313 _108 572 622
 41 600 137 _108 396 622
 42 600 212  257 580 607
 43 600 129   44 580 470
 44 600 157 _112 370 122
 45 600 152  231 558 285
 46 600 238  _15 382 109
 47 600 112  _80 604 629
 48 600 154  _15 575 622
 49 600  98    0 515 622
 50 600  70    0 568 622
 51 600  82  _15 538 622
 52 600 108    0 541 622
 53 600  99  _15 589 607
 54 600 155  _15 629 622
 55 600 182    0 612 607
 56 600 132  _15 588 622
 57 600  93  _15 574 622
 58 600 238  _15 441 385
 59 600 157 _112 441 385
 60 600  96   42 610 472
 61 600 109  138 600 376
 62 600  85   42 599 472
 63 600 222  _15 583 572
 64 600 127  _15 582 622
 65 600   3    0 607 562
 66 600  43    0 616 562
 67 600  93  _18 655 580
 68 600  43    0 645 562
 69 600  53    0 660 562
 70 600  53    0 660 562
 71 600  83  _18 645 580
 72 600  32    0 687 562
 73 600  96    0 623 562
 74 600  52  _18 685 562
 75 600  38    0 671 562
 76 600  47    0 607 562
 77 600   4    0 715 562
 78 600   7  _13 712 562
 79 600  94  _18 625 580
 80 600  79    0 644 562
 81 600  95 _138 625 580
 82 600  38    0 598 562
 83 600  76  _20 650 580
 84 600 108    0 665 562
 85 600 125  _18 702 562
 86 600 105  _13 723 562
 87 600 106  _13 722 562
 88 600  23    0 675 562
 89 600 133    0 695 562
 90 600  86    0 610 562
 91 600 246 _108 574 622
 92 600 249  _80 468 629
 93 600 135 _108 463 622
 94 600 175  354 587 622
 95 600 _27 _125 584 _75
 96 600 343  328 457 562
 97 600  76  _15 569 441
 98 600  29  _15 625 629
 99 600 106  _15 608 441
100 600  85  _15 640 629
101 600 106  _15 598 441
102 600 114    0 662 629
103 600  61 _157 657 441
104 600  33    0 592 629
105 600  95    0 515 657
106 600  52 _157 550 657
107 600  58    0 633 629
108 600  95    0 515 629
109 600  _5    0 615 441
110 600  26    0 585 441
111 600 102  _15 588 441
112 600 _24 _157 605 441
113 600  85 _157 682 441
114 600  60    0 636 441
115 600  78  _15 584 441
116 600 167  _15 561 561
117 600 101  _15 572 426
118 600  90  _10 681 426
119 600  76  _10 695 426
120 600  20    0 655 426
121 600  _4 _157 683 426
122 600  99    0 593 426
123 600 233 _108 569 622
124 600 222 _250 485 750
125 600 140 _108 477 622
126 600 116  197 600 320
161 600 225 _157 445 430
162 600 151  _49 588 614
163 600 124  _21 621 611
164 600  84  _57 646 665
165 600 120    0 693 562
166 600 _26 _143 671 622
167 600 104  _78 590 580
168 600  94   58 628 506
169 600 345  328 460 562
170 600 262  328 541 562
171 600  92   70 652 446
172 600 204   70 540 446
173 600 170   70 506 446
174 600   3    0 619 629
175 600   3    0 619 629
177 600 124  231 586 285
178 600 217  _78 546 580
179 600 163  _78 546 580
180 600 275  189 434 327
182 600 100  _78 630 562
183 600 224  130 485 383
184 600 185 _134 397 100
185 600 115 _134 478 100
186 600 213  328 576 562
187 600  58   70 618 446
188 600  46  _15 575 111
189 600  59  _15 627 622
191 600 105 _157 466 430
193 600 294  497 484 672
194 600 348  497 612 672
195 600 229  477 581 654
196 600 212  489 629 606
197 600 232  525 600 565
198 600 279  501 576 609
199 600 373  537 478 640
200 600 272  537 579 640
202 600 332  463 500 627
203 600 197 _151 344  10
205 600 239  497 683 672
206 600 189 _172 377   4
207 600 262  492 614 669
208 600  49  231 661 285
225 600   3    0 655 562
227 600 209  249 512 580
232 600  47    0 607 562
233 600  94  _80 625 629
234 600  59    0 672 562
235 600 210  249 535 580
241 600  41  _15 626 441
245 600  95    0 515 426
248 600  95    0 587 629
249 600 102  _80 588 506
250 600  54  _15 615 441
251 600  48  _15 617 629
)
Helvetica_Ascender=: 718

Helvetica_FontBBox=: _166 _225 1000 931

Helvetica_UnderlinePosition=: _100

Helvetica_UnderlineThickness=: 50

Helvetica_FontMetrics=: 0 : 0
Ascender=: 718
CapHeight=: 718
Descender=: _207
FontBBox=: _166 _225 1000 931
StdHW=: 76
StdVW=: 88
UnderlinePosition=: _100
UnderlineThickness=: 50
XHeight=: 523
)

Helvetica_CharMetrics=: 0 ". [;._2 (0 : 0)
  0  513   44   47  468 618
 32  278    0    0    0   0
 33  278   90    0  187 718
 34  355   70  463  285 718
 35  556   28    0  529 688
 36  556   32 _115  520 775
 37  889   39  _19  850 703
 38  667   44  _15  645 718
 39  222   53  463  157 718
 40  333   68 _207  299 733
 41  333   34 _207  265 733
 42  389   39  431  349 718
 43  584   39    0  545 505
 44  278   87 _147  191 106
 45  333   44  232  289 322
 46  278   87    0  191 106
 47  278  _17  _19  295 737
 48  556   37  _19  519 703
 49  556  101    0  359 703
 50  556   26    0  507 703
 51  556   34  _19  522 703
 52  556   25    0  523 703
 53  556   32  _19  514 688
 54  556   38  _19  518 703
 55  556   37    0  523 688
 56  556   38  _19  517 703
 57  556   42  _19  514 703
 58  278   87    0  191 516
 59  278   87 _147  191 516
 60  584   48   11  536 495
 61  584   39  115  545 390
 62  584   48   11  536 495
 63  556   56    0  492 727
 64 1015  147  _19  868 737
 65  667   14    0  654 718
 66  667   74    0  627 718
 67  722   44  _19  681 737
 68  722   81    0  674 718
 69  667   86    0  616 718
 70  611   86    0  583 718
 71  778   48  _19  704 737
 72  722   77    0  646 718
 73  278   91    0  188 718
 74  500   17  _19  428 718
 75  667   76    0  663 718
 76  556   76    0  537 718
 77  833   73    0  761 718
 78  722   76    0  646 718
 79  778   39  _19  739 737
 80  667   86    0  622 718
 81  778   39  _56  739 737
 82  722   88    0  684 718
 83  667   49  _19  620 737
 84  611   14    0  597 718
 85  722   79  _19  644 718
 86  667   20    0  647 718
 87  944   16    0  928 718
 88  667   19    0  648 718
 89  667   14    0  653 718
 90  611   23    0  588 718
 91  278   63 _196  250 722
 92  278  _17  _19  295 737
 93  278   28 _196  215 722
 94  469  _14  264  483 688
 95  556    0 _125  556 _75
 96  222   65  470  169 725
 97  556   36  _15  530 538
 98  556   58  _15  517 718
 99  500   30  _15  477 538
100  556   35  _15  499 718
101  556   40  _15  516 538
102  278   14    0  262 728
103  556   40 _220  499 538
104  556   65    0  491 718
105  222   67    0  155 718
106  222  _16 _210  155 718
107  500   67    0  501 718
108  222   67    0  155 718
109  833   65    0  769 538
110  556   65    0  491 538
111  556   35  _14  521 538
112  556   58 _207  517 538
113  556   35 _207  494 538
114  333   77    0  332 538
115  500   32  _15  464 538
116  278   14   _7  257 669
117  556   68  _15  489 523
118  500    8    0  492 523
119  722   14    0  709 523
120  500   11    0  490 523
121  500   11 _214  489 523
122  500   31    0  469 523
123  334   42 _196  292 722
124  260   94 _225  167 775
125  334   42 _196  292 722
126  584   61  180  523 326
161  333  118 _195  215 523
162  556   51 _115  513 623
163  556   33  _16  539 718
164  167 _166  _19  333 703
165  556    3    0  553 688
166  556  _11 _207  501 737
167  556   43 _191  512 737
168  556   28   99  528 603
169  191   59  463  132 718
170  333   38  470  307 725
171  556   97  108  459 446
172  333   88  108  245 446
173  333   88  108  245 446
174  500   14    0  434 728
175  500   14    0  432 728
177  556    0  240  556 313
178  556   43 _159  514 718
179  556   43 _159  514 718
180  278   77  190  202 315
182  537   18 _173  497 718
183  350   18  202  333 517
184  222   53 _149  157 106
185  333   26 _149  295 106
186  333   26  463  295 718
187  556   97  108  459 446
188 1000  115    0  885 106
189 1000    7  _19  994 703
191  611   91 _201  527 525
193  333   14  593  211 734
194  333  122  593  319 734
195  333   21  593  312 734
196  333   _4  606  337 722
197  333   10  627  323 684
198  333   13  595  321 731
199  333  121  604  212 706
200  333   40  604  293 706
202  333   75  572  259 756
203  333   45 _225  259   0
205  333   31  593  409 734
206  333   73 _225  287   0
207  333   21  593  312 734
208 1000    0  240 1000 313
225 1000    8    0  951 718
227  370   24  405  346 737
232  556  _20    0  537 718
233  778   39  _19  740 737
234 1000   36  _19  965 737
235  365   25  405  341 737
241  889   36  _15  847 538
245  278   95    0  183 523
248  222  _20    0  242 718
249  611   28  _22  537 545
250  944   35  _15  902 538
251  611   67  _15  571 728
)
HelveticaBold_Ascender=: 718

HelveticaBold_FontBBox=: _170 _228 1003 962

HelveticaBold_UnderlinePosition=: _100

HelveticaBold_UnderlineThickness=: 50

HelveticaBold_FontMetrics=: 0 : 0
Ascender=: 718
CapHeight=: 718
Descender=: _207
FontBBox=: _170 _228 1003 962
StdHW=: 118
StdVW=: 140
UnderlinePosition=: _100
UnderlineThickness=: 50
XHeight=: 532
)

HelveticaBold_CharMetrics=: 0 ". [;._2 (0 : 0)
  0  535   38   44  495 624
 32  278    0    0    0   0
 33  333   90    0  244 718
 34  474   98  447  376 718
 35  556   18    0  538 698
 36  556   30 _115  523 775
 37  889   28  _19  861 710
 38  722   54  _19  701 718
 39  278   69  445  209 718
 40  333   35 _208  314 734
 41  333   19 _208  298 734
 42  389   27  387  362 718
 43  584   40    0  544 506
 44  278   64 _168  214 146
 45  333   27  215  306 345
 46  278   64    0  214 146
 47  278  _33  _19  311 737
 48  556   32  _19  524 710
 49  556   69    0  378 710
 50  556   26    0  511 710
 51  556   27  _19  516 710
 52  556   27    0  526 710
 53  556   27  _19  516 698
 54  556   31  _19  520 710
 55  556   25    0  528 698
 56  556   32  _19  524 710
 57  556   30  _19  522 710
 58  333   92    0  242 512
 59  333   92 _168  242 512
 60  584   38   _8  546 514
 61  584   40   87  544 419
 62  584   38   _8  546 514
 63  611   60    0  556 727
 64  975  118  _19  856 737
 65  722   20    0  702 718
 66  722   76    0  669 718
 67  722   44  _19  684 737
 68  722   76    0  685 718
 69  667   76    0  621 718
 70  611   76    0  587 718
 71  778   44  _19  713 737
 72  722   71    0  651 718
 73  278   64    0  214 718
 74  556   22  _18  484 718
 75  722   87    0  722 718
 76  611   76    0  583 718
 77  833   69    0  765 718
 78  722   69    0  654 718
 79  778   44  _19  734 737
 80  667   76    0  627 718
 81  778   44  _52  737 737
 82  722   76    0  677 718
 83  667   39  _19  629 737
 84  611   14    0  598 718
 85  722   72  _19  651 718
 86  667   19    0  648 718
 87  944   16    0  929 718
 88  667   14    0  653 718
 89  667   15    0  653 718
 90  611   25    0  586 718
 91  333   63 _196  309 722
 92  278  _33  _19  311 737
 93  333   24 _196  270 722
 94  584   62  323  522 698
 95  556    0 _125  556 _75
 96  278   69  454  209 727
 97  556   29  _14  527 546
 98  611   61  _14  578 718
 99  556   34  _14  524 546
100  611   34  _14  551 718
101  556   23  _14  528 546
102  333   10    0  318 727
103  611   40 _217  553 546
104  611   65    0  546 718
105  278   69    0  209 725
106  278    3 _214  209 725
107  556   69    0  562 718
108  278   69    0  209 718
109  889   64    0  826 546
110  611   65    0  546 546
111  611   34  _14  578 546
112  611   62 _207  578 546
113  611   34 _207  552 546
114  389   64    0  373 546
115  556   30  _14  519 546
116  333   10   _6  309 676
117  611   66  _14  545 532
118  556   13    0  543 532
119  778   10    0  769 532
120  556   15    0  541 532
121  556   10 _214  539 532
122  500   20    0  480 532
123  389   48 _196  365 722
124  280   84 _225  196 775
125  389   24 _196  341 722
126  584   61  163  523 343
161  333   90 _186  244 532
162  556   34 _118  524 628
163  556   28  _16  541 718
164  167 _170  _19  336 710
165  556   _9    0  565 698
166  556  _10 _210  516 737
167  556   34 _184  522 727
168  556   _3   76  559 636
169  238   70  447  168 718
170  500   64  454  436 727
171  556   88   76  468 484
172  333   83   76  250 484
173  333   83   76  250 484
174  611   10    0  542 727
175  611   10    0  542 727
177  556    0  227  556 333
178  556   36 _171  520 718
179  556   36 _171  520 718
180  278   58  172  220 334
182  556   _8 _191  539 700
183  350   10  194  340 524
184  278   69 _146  209 127
185  500   64 _146  436 127
186  500   64  445  436 718
187  556   88   76  468 484
188 1000   92    0  908 146
189 1000   _3  _19 1003 710
191  611   55 _195  551 532
193  333  _23  604  225 750
194  333  108  604  356 750
195  333  _10  604  343 750
196  333  _17  610  350 737
197  333   _6  604  339 678
198  333   _2  604  335 750
199  333  104  614  230 729
200  333    6  614  327 729
202  333   59  568  275 776
203  333    6 _228  245   0
205  333    9  604  486 750
206  333   71 _228  304   0
207  333  _10  604  343 750
208 1000    0  227 1000 333
225 1000    5    0  954 718
227  370   22  401  347 737
232  611  _20    0  583 718
233  778   33  _27  744 745
234 1000   37  _19  961 737
235  365    6  401  360 737
241  889   29  _14  858 546
245  278   69    0  209 532
248  278  _18    0  296 718
249  611   22  _29  589 560
250  944   34  _14  912 546
251  611   69  _14  579 731
)
HelveticaBoldOblique_Ascender=: 718

HelveticaBoldOblique_FontBBox=: _174 _228 1114 962

HelveticaBoldOblique_UnderlinePosition=: _100

HelveticaBoldOblique_UnderlineThickness=: 50

HelveticaBoldOblique_FontMetrics=: 0 : 0
Ascender=: 718
CapHeight=: 718
Descender=: _207
FontBBox=: _174 _228 1114 962
StdHW=: 118
StdVW=: 140
UnderlinePosition=: _100
UnderlineThickness=: 50
XHeight=: 532
)

HelveticaBoldOblique_CharMetrics=: 0 ". [;._2 (0 : 0)
  0  535   80   44  600 624
 32  278    0    0    0   0
 33  333   94    0  397 718
 34  474  193  447  529 718
 35  556   60    0  644 698
 36  556   67 _115  622 775
 37  889  136  _19  901 710
 38  722   89  _19  732 718
 39  278  167  445  362 718
 40  333   76 _208  470 734
 41  333  _25 _208  369 734
 42  389  146  387  481 718
 43  584   82    0  610 506
 44  278   28 _168  245 146
 45  333   73  215  379 345
 46  278   64    0  245 146
 47  278  _37  _19  468 737
 48  556   86  _19  617 710
 49  556  173    0  529 710
 50  556   26    0  619 710
 51  556   65  _19  608 710
 52  556   60    0  598 710
 53  556   64  _19  636 698
 54  556   85  _19  619 710
 55  556  125    0  676 698
 56  556   69  _19  616 710
 57  556   78  _19  615 710
 58  333   92    0  351 512
 59  333   56 _168  351 512
 60  584   82   _8  655 514
 61  584   58   87  633 419
 62  584   36   _8  609 514
 63  611  165    0  671 727
 64  975  186  _19  954 737
 65  722   20    0  702 718
 66  722   76    0  764 718
 67  722  107  _19  789 737
 68  722   76    0  777 718
 69  667   76    0  757 718
 70  611   76    0  740 718
 71  778  108  _19  817 737
 72  722   71    0  804 718
 73  278   64    0  367 718
 74  556   60  _18  637 718
 75  722   87    0  858 718
 76  611   76    0  611 718
 77  833   69    0  918 718
 78  722   69    0  807 718
 79  778  107  _19  823 737
 80  667   76    0  738 718
 81  778  107  _52  823 737
 82  722   76    0  778 718
 83  667   81  _19  718 737
 84  611  140    0  751 718
 85  722  116  _19  804 718
 86  667  172    0  801 718
 87  944  169    0 1082 718
 88  667   14    0  791 718
 89  667  168    0  806 718
 90  611   25    0  737 718
 91  333   21 _196  462 722
 92  278  124  _19  307 737
 93  333  _18 _196  423 722
 94  584  131  323  591 698
 95  556  _27 _125  540 _75
 96  278  165  454  361 727
 97  556   55  _14  583 546
 98  611   61  _14  645 718
 99  556   79  _14  599 546
100  611   82  _14  704 718
101  556   70  _14  593 546
102  333   87    0  469 727
103  611   38 _217  666 546
104  611   65    0  629 718
105  278   69    0  363 725
106  278  _42 _214  363 725
107  556   69    0  670 718
108  278   69    0  362 718
109  889   64    0  909 546
110  611   65    0  629 546
111  611   82  _14  643 546
112  611   18 _207  645 546
113  611   80 _207  665 546
114  389   64    0  489 546
115  556   63  _14  584 546
116  333  100   _6  422 676
117  611   98  _14  658 532
118  556  126    0  656 532
119  778  123    0  882 532
120  556   15    0  648 532
121  556   42 _214  652 532
122  500   20    0  583 532
123  389   94 _196  518 722
124  280   36 _225  361 775
125  389  _18 _196  407 722
126  584  115  163  577 343
161  333   50 _186  353 532
162  556   79 _118  599 628
163  556   50  _16  635 718
164  167 _174  _19  487 710
165  556   60    0  713 698
166  556  _50 _210  669 737
167  556   61 _184  598 727
168  556   27   76  680 636
169  238  165  447  321 718
170  500  160  454  588 727
171  556  135   76  571 484
172  333  130   76  353 484
173  333   99   76  322 484
174  611   87    0  696 727
175  611   87    0  695 727
177  556   48  227  627 333
178  556  118 _171  626 718
179  556   46 _171  628 718
180  278  110  172  276 334
182  556   98 _191  688 700
183  350   83  194  420 524
184  278   41 _146  236 127
185  500   36 _146  463 127
186  500  162  445  589 718
187  556  104   76  540 484
188 1000   92    0  939 146
189 1000   76  _19 1038 710
191  611   53 _195  559 532
193  333  136  604  353 750
194  333  236  604  515 750
195  333  118  604  471 750
196  333  113  610  507 737
197  333  122  604  483 678
198  333  156  604  494 750
199  333  235  614  385 729
200  333  137  614  482 729
202  333  200  568  420 776
203  333  _37 _228  220   0
205  333  137  604  645 750
206  333   41 _228  264   0
207  333  149  604  502 750
208 1000   48  227 1071 333
225 1000    5    0 1100 718
227  370  125  401  465 737
232  611   34    0  611 718
233  778   35  _27  894 745
234 1000   99  _19 1114 737
235  365  123  401  485 737
241  889   56  _14  923 546
245  278   69    0  322 532
248  278   40    0  407 718
249  611   22  _29  701 560
250  944   82  _14  977 546
251  611   69  _14  657 731
)
HelveticaOblique_Ascender=: 718

HelveticaOblique_FontBBox=: _170 _225 1116 931

HelveticaOblique_UnderlinePosition=: _100

HelveticaOblique_UnderlineThickness=: 50

HelveticaOblique_FontMetrics=: 0 : 0
Ascender=: 718
CapHeight=: 718
Descender=: _207
FontBBox=: _170 _225 1116 931
StdHW=: 76
StdVW=: 88
UnderlinePosition=: _100
UnderlineThickness=: 50
XHeight=: 523
)

HelveticaOblique_CharMetrics=: 0 ". [;._2 (0 : 0)
  0  513   85   47  570 618
 32  278    0    0    0   0
 33  278   90    0  340 718
 34  355  168  463  438 718
 35  556   73    0  631 688
 36  556   69 _115  617 775
 37  889  147  _19  889 703
 38  667   77  _15  647 718
 39  222  151  463  310 718
 40  333  108 _207  454 733
 41  333   _9 _207  337 733
 42  389  165  431  475 718
 43  584   85    0  606 505
 44  278   56 _147  214 106
 45  333   93  232  357 322
 46  278   87    0  214 106
 47  278  _21  _19  452 737
 48  556   93  _19  608 703
 49  556  207    0  508 703
 50  556   26    0  617 703
 51  556   75  _19  610 703
 52  556   61    0  576 703
 53  556   68  _19  621 688
 54  556   91  _19  615 703
 55  556  137    0  669 688
 56  556   74  _19  607 703
 57  556   82  _19  609 703
 58  278   87    0  301 516
 59  278   56 _147  301 516
 60  584   94   11  641 495
 61  584   63  115  628 390
 62  584   50   11  597 495
 63  556  161    0  610 727
 64 1015  215  _19  965 737
 65  667   14    0  654 718
 66  667   74    0  712 718
 67  722  108  _19  782 737
 68  722   81    0  764 718
 69  667   86    0  762 718
 70  611   86    0  736 718
 71  778  111  _19  799 737
 72  722   77    0  799 718
 73  278   91    0  341 718
 74  500   47  _19  581 718
 75  667   76    0  808 718
 76  556   76    0  555 718
 77  833   73    0  914 718
 78  722   76    0  799 718
 79  778  105  _19  826 737
 80  667   86    0  737 718
 81  778  105  _56  826 737
 82  722   88    0  773 718
 83  667   90  _19  713 737
 84  611  148    0  750 718
 85  722  123  _19  797 718
 86  667  173    0  800 718
 87  944  169    0 1081 718
 88  667   19    0  790 718
 89  667  167    0  806 718
 90  611   23    0  741 718
 91  278   21 _196  403 722
 92  278  140  _19  291 737
 93  278  _14 _196  368 722
 94  469   42  264  539 688
 95  556  _27 _125  540 _75
 96  222  165  470  323 725
 97  556   61  _15  559 538
 98  556   58  _15  584 718
 99  500   74  _15  553 538
100  556   84  _15  652 718
101  556   84  _15  578 538
102  278   86    0  416 728
103  556   42 _220  610 538
104  556   65    0  573 718
105  222   67    0  308 718
106  222  _60 _210  308 718
107  500   67    0  600 718
108  222   67    0  308 718
109  833   65    0  852 538
110  556   65    0  573 538
111  556   83  _14  585 538
112  556   14 _207  584 538
113  556   84 _207  605 538
114  333   77    0  446 538
115  500   63  _15  529 538
116  278  102   _7  368 669
117  556   94  _15  600 523
118  500  119    0  603 523
119  722  125    0  820 523
120  500   11    0  594 523
121  500   15 _214  600 523
122  500   31    0  571 523
123  334   92 _196  445 722
124  260   46 _225  332 775
125  334    0 _196  354 722
126  584  111  180  580 326
161  333   77 _195  326 523
162  556   95 _115  584 623
163  556   49  _16  634 718
164  167 _170  _19  482 703
165  556   81    0  699 688
166  556  _52 _207  654 737
167  556   76 _191  584 737
168  556   60   99  646 603
169  191  157  463  285 718
170  333  138  470  461 725
171  556  146  108  554 446
172  333  137  108  340 446
173  333  111  108  314 446
174  500   86    0  587 728
175  500   86    0  585 728
177  556   51  240  623 313
178  556  135 _159  622 718
179  556   52 _159  623 718
180  278  129  190  257 315
182  537  126 _173  650 718
183  350   91  202  413 517
184  222   21 _149  180 106
185  333   _6 _149  318 106
186  333  124  463  448 718
187  556  120  108  528 446
188 1000  115    0  908 106
189 1000   88  _19 1029 703
191  611   85 _201  534 525
193  333  170  593  337 734
194  333  248  593  475 734
195  333  147  593  438 734
196  333  125  606  490 722
197  333  143  627  468 684
198  333  167  595  476 731
199  333  249  604  362 706
200  333  168  604  443 706
202  333  214  572  402 756
203  333    2 _225  232   0
205  333  157  593  565 734
206  333   43 _225  249   0
207  333  177  593  468 734
208 1000   51  240 1067 313
225 1000    8    0 1097 718
227  370  127  405  449 737
232  556   41    0  555 718
233  778   43  _19  890 737
234 1000   98  _19 1116 737
235  365  141  405  468 737
241  889   61  _15  909 538
245  278   95    0  294 523
248  222   41    0  347 718
249  611   29  _22  647 545
250  944   83  _15  964 538
251  611   67  _15  658 728
)
Symbol_Ascender=: 650

Symbol_FontBBox=: _180 _293 1090 1010

Symbol_UnderlinePosition=: _100

Symbol_UnderlineThickness=: 50

Symbol_FontMetrics=: 0 : 0
FontBBox=: _180 _293 1090 1010
StdHW=: 92
StdVW=: 85
UnderlinePosition=: _100
UnderlineThickness=: 50
)

Symbol_CharMetrics=: 0 ". [;._2 (0 : 0)
  0  587   47  _29  547  638
 32  250    0    0    0    0
 33  333  128  _17  240  672
 34  713   31    0  681  705
 35  500   20  _16  481  673
 36  549   25    0  478  707
 37  833   63  _36  771  655
 38  778   41  _18  750  661
 39  439   48  _17  414  500
 40  333   53 _191  300  673
 41  333   30 _191  277  673
 42  500   65  134  427  551
 43  549   10    0  539  533
 44  250   56 _152  194  104
 45  549   11  233  535  288
 46  250   69  _17  181   95
 47  278    0  _18  254  646
 48  500   24  _14  476  685
 49  500  117    0  390  673
 50  500   25    0  475  685
 51  500   43  _14  435  685
 52  500   15    0  469  685
 53  500   32  _14  445  690
 54  500   34  _14  468  685
 55  500   24  _16  448  673
 56  500   56  _14  445  685
 57  500   30  _18  459  685
 58  278   81  _17  193  460
 59  278   83 _152  221  460
 60  549   26    0  523  522
 61  549   11  141  537  390
 62  549   26    0  523  522
 63  444   70  _17  412  686
 64  549   11    0  537  475
 65  722    4    0  684  673
 66  667   29    0  592  673
 67  722   _9    0  704  673
 68  612    6    0  608  688
 69  611   32    0  617  673
 70  763   26    0  741  673
 71  603   24    0  609  673
 72  722   39    0  729  673
 73  333   32    0  316  673
 74  631   18  _18  623  689
 75  722   35    0  722  673
 76  686    6    0  680  688
 77  889   28    0  887  673
 78  722   29   _8  720  673
 79  722   41  _17  715  685
 80  768   25    0  745  673
 81  741   41  _17  715  685
 82  556   28    0  563  673
 83  592    5    0  589  673
 84  611   33    0  607  673
 85  690   _8    0  694  673
 86  439   40 _233  436  500
 87  768   34    0  736  688
 88  645   40    0  599  673
 89  795   15    0  781  684
 90  611   44    0  636  673
 91  333   86 _155  299  674
 92  863  163    0  701  487
 93  333   33 _155  246  674
 94  658   15    0  652  674
 95  500   _2 _125  502  _75
 96  500  480  881 1090  917
 97  631   41  _18  622  500
 98  549   61 _223  515  741
 99  549   12 _231  522  499
100  494   40  _19  481  740
101  439   22  _19  427  502
102  521   28 _224  492  673
103  411    5 _225  484  499
104  603    0 _202  527  514
105  329    0  _17  301  503
106  603   36 _224  587  499
107  549   33    0  558  501
108  549   24  _17  548  739
109  576   33 _223  567  500
110  521   _9  _16  475  507
111  549   35  _19  501  499
112  549   10  _19  530  487
113  521   43  _17  485  690
114  549   50 _230  490  499
115  603   30  _21  588  500
116  439   10  _19  418  500
117  576    7  _18  535  507
118  713   12  _18  671  583
119  686   42  _17  684  500
120  493   27 _224  469  766
121  686   12 _228  701  500
122  494   60 _225  467  756
123  480   58 _183  397  673
124  200   65 _293  135  707
125  480   79 _183  418  673
126  549   17  203  529  307
160  750   20  _12  714  685
161  620   _2    0  610  685
162  247   27  459  228  735
163  549   29    0  526  639
164  167 _180  _12  340  677
165  713   26  124  688  404
166  500    2 _193  494  686
167  753   86  _26  660  533
168  753  142  _36  600  550
169  753  117  _33  631  532
170  753  113  _36  629  548
171 1042   24  _15 1024  511
172  987   32  _15  942  511
173  603   45    0  571  910
174  987   49  _15  959  511
175  603   45  _22  571  888
176  400   50  385  350  685
177  549   10    0  539  645
178  411   20  459  413  737
179  549   29    0  526  639
180  549   17    8  533  524
181  713   27  123  639  404
182  494   26  _20  462  746
183  460   50  113  410  473
184  549   10   71  536  456
185  549   15  _25  540  549
186  549   14   82  538  443
187  549   14  135  527  394
188 1000  111  _17  889   95
189  603  280 _120  336 1010
190 1000  _60  220 1050  276
191  658   15  _16  602  629
192  823  175  _18  661  658
193  686   10  _53  578  740
194  795   26  _15  759  734
195  987  159 _211  870  573
196  768   43  _17  733  673
197  768   43  _15  733  675
198  823   39  _24  781  719
199  768   40    0  732  509
200  768   40  _17  732  492
201  713   20    0  673  470
202  713   20 _125  673  470
203  713   36  _70  690  540
204  713   37    0  690  470
205  713   37 _125  690  470
206  713   45    0  505  468
207  713   45  _58  505  555
208  768   26    0  738  673
209  713   36  _19  681  718
210  790   50  _17  740  673
211  790   51  _15  741  675
212  890   18  293  855  673
213  823   25 _101  803  751
214  549   10  _38  515  917
215  250   69  210  169  310
216  713   15    0  680  288
217  603   23    0  583  454
218  603   30    0  578  477
219 1042   27  _20 1023  510
220  987   30  _15  939  513
221  603   39    2  567  911
222  987   45  _20  954  508
223  603   44  _19  572  890
224  494   18    0  466  745
225  329   25 _198  306  746
226  790   50  _20  740  670
227  790   49  _15  739  675
228  786    5  293  725  673
229  713   14 _108  695  752
230  384   24 _293  436  926
231  384   24  _85  108  925
232  384   24 _293  436  926
233  384    0  _80  349  926
234  384    0  _79   77  925
235  384    0  _80  349  926
236  494  209  _85  445  925
237  494   20  _85  284  935
238  494  209  _75  445  935
239  494  209  _85  284  935
241  329   21 _198  302  746
242  274    2 _107  291  916
243  686  308  _88  675  920
244  686  308  _88  378  975
245  686   11  _87  378  921
246  384   54 _293  466  926
247  384  382  _85  466  925
248  384   54 _293  466  926
249  384   22  _80  371  926
250  384  294  _79  371  925
251  384   22  _80  371  926
252  494   48  _85  284  925
253  494  209  _85  473  935
254  494   48  _75  284  935
)
TimesBold_Ascender=: 683

TimesBold_FontBBox=: _168 _218 1000 935

TimesBold_UnderlinePosition=: _100

TimesBold_UnderlineThickness=: 50

TimesBold_FontMetrics=: 0 : 0
Ascender=: 683
CapHeight=: 676
Descender=: _217
FontBBox=: _168 _218 1000 935
StdHW=: 44
StdVW=: 139
UnderlinePosition=: _100
UnderlineThickness=: 50
XHeight=: 461
)

TimesBold_CharMetrics=: 0 ". [;._2 (0 : 0)
  0  516   27   34  487 587
 32  250    0    0    0   0
 33  333   81  _13  251 691
 34  555   83  404  472 691
 35  500    4    0  496 700
 36  500   29  _99  472 750
 37 1000  124  _14  877 692
 38  833   62  _16  787 691
 39  333   79  356  263 691
 40  333   46 _168  306 694
 41  333   27 _168  287 694
 42  500   56  255  447 691
 43  570   33    0  537 506
 44  250   39 _180  223 155
 45  333   44  171  287 287
 46  250   41  _13  210 156
 47  278  _24  _19  302 691
 48  500   24  _13  476 688
 49  500   65    0  442 688
 50  500   17    0  478 688
 51  500   16  _14  468 688
 52  500   19    0  475 688
 53  500   22   _8  470 676
 54  500   28  _13  475 688
 55  500   17    0  477 676
 56  500   28  _13  472 688
 57  500   26  _13  473 688
 58  333   82  _13  251 472
 59  333   82 _180  266 472
 60  570   31   _8  539 514
 61  570   33  107  537 399
 62  570   31   _8  539 514
 63  500   57  _13  445 689
 64  930  108  _19  822 691
 65  722    9    0  689 690
 66  667   16    0  619 676
 67  722   49  _19  687 691
 68  722   14    0  690 676
 69  667   16    0  641 676
 70  611   16    0  583 676
 71  778   37  _19  755 691
 72  778   21    0  759 676
 73  389   20    0  370 676
 74  500    3  _96  479 676
 75  778   30    0  769 676
 76  667   19    0  638 676
 77  944   14    0  921 676
 78  722   16  _18  701 676
 79  778   35  _19  743 691
 80  611   16    0  600 676
 81  778   35 _176  743 691
 82  722   26    0  715 676
 83  556   35  _19  513 692
 84  667   31    0  636 676
 85  722   16  _19  701 676
 86  722   16  _18  701 676
 87 1000   19  _15  981 676
 88  722   16    0  699 676
 89  722   15    0  699 676
 90  667   28    0  634 676
 91  333   67 _149  301 678
 92  278  _25  _19  303 691
 93  333   32 _149  266 678
 94  581   73  311  509 676
 95  500    0 _125  500 _75
 96  333   70  356  254 691
 97  500   25  _14  488 473
 98  556   17  _14  521 676
 99  444   25  _14  430 473
100  556   25  _14  534 676
101  444   25  _14  426 473
102  333   14    0  389 691
103  500   28 _206  483 473
104  556   16    0  534 676
105  278   16    0  255 691
106  333  _57 _203  263 691
107  556   22    0  543 676
108  278   16    0  255 676
109  833   16    0  814 473
110  556   21    0  539 473
111  500   25  _14  476 473
112  556   19 _205  524 473
113  556   34 _205  536 473
114  444   29    0  434 473
115  389   25  _14  361 473
116  333   20  _12  332 630
117  556   16  _14  537 461
118  500   21  _14  485 461
119  722   23  _14  707 461
120  500   12    0  484 461
121  500   16 _205  480 461
122  444   21    0  420 461
123  394   22 _175  340 698
124  220   66 _218  154 782
125  394   54 _175  372 698
126  520   29  173  491 333
161  333   82 _203  252 501
162  500   53 _140  458 588
163  500   21  _14  477 684
164  167 _168  _12  329 688
165  500  _64    0  547 676
166  500    0 _155  498 706
167  500   57 _132  443 691
168  500  _26   61  526 613
169  278   75  404  204 691
170  500   32  356  486 691
171  500   23   36  473 415
172  333   51   36  305 415
173  333   28   36  282 415
174  556   14    0  536 691
175  556   14    0  536 691
177  500    0  181  500 271
178  500   47 _134  453 691
179  500   45 _132  456 691
180  250   41  248  210 417
182  540    0 _186  519 676
183  350   35  198  315 478
184  333   79 _180  263 155
185  500   14 _180  468 155
186  500   14  356  468 691
187  500   27   36  477 415
188 1000   82  _13  917 156
189 1000    7  _29  995 706
191  500   55 _201  443 501
193  333    8  528  246 713
194  333   86  528  324 713
195  333   _2  528  335 704
196  333  _16  547  349 674
197  333    1  565  331 637
198  333   15  528  318 691
199  333  103  536  258 691
200  333   _2  537  335 667
202  333   60  527  273 740
203  333   68 _218  294   0
205  333  _13  528  425 713
206  333   90 _193  319  24
207  333   _2  528  335 704
208 1000    0  181 1000 271
225 1000    4    0  951 676
227  300   _1  397  301 688
232  667   19    0  638 676
233  778   35  _74  743 737
234 1000   22   _5  981 684
235  330   18  397  312 688
241  722   33  _14  693 473
245  278   16    0  255 461
248  278  _22    0  303 676
249  500   25  _92  476 549
250  722   22  _14  696 473
251  556   19  _12  517 691
)
TimesBoldItalic_Ascender=: 683

TimesBoldItalic_FontBBox=: _200 _218 996 921

TimesBoldItalic_UnderlinePosition=: _100

TimesBoldItalic_UnderlineThickness=: 50

TimesBoldItalic_FontMetrics=: 0 : 0
Ascender=: 683
CapHeight=: 669
Descender=: _217
FontBBox=: _200 _218 996 921
StdHW=: 42
StdVW=: 121
UnderlinePosition=: _100
UnderlineThickness=: 50
XHeight=: 462
)

TimesBoldItalic_CharMetrics=: 0 ". [;._2 (0 : 0)
  0  501    1   25 484 583
 32  250    0    0   0   0
 33  389   67  _13 370 684
 34  555  136  398 536 685
 35  500  _33    0 533 700
 36  500  _20 _100 497 733
 37  833   39  _10 793 692
 38  778    5  _19 699 682
 39  333   98  369 302 685
 40  333   28 _179 344 685
 41  333  _44 _179 271 685
 42  500   65  249 456 685
 43  570   33    0 537 506
 44  250  _60 _182 144 134
 45  333    2  166 271 282
 46  250   _9  _13 139 135
 47  278  _64  _18 342 685
 48  500   17  _14 477 683
 49  500    5    0 419 683
 50  500  _27    0 446 683
 51  500  _15  _13 450 683
 52  500  _15    0 503 683
 53  500  _11  _13 487 669
 54  500   23  _15 509 679
 55  500   52    0 525 669
 56  500    3  _13 476 683
 57  500  _12  _10 475 683
 58  333   23  _13 264 459
 59  333  _25 _183 264 459
 60  570   31   _8 539 514
 61  570   33  107 537 399
 62  570   31   _8 539 514
 63  500   79  _13 470 684
 64  832   63  _18 770 685
 65  667  _67    0 593 683
 66  667  _24    0 624 669
 67  667   32  _18 677 685
 68  722  _46    0 685 669
 69  667  _27    0 653 669
 70  667  _13    0 660 669
 71  722   21  _18 706 685
 72  778  _24    0 799 669
 73  389  _32    0 406 669
 74  500  _46  _99 524 669
 75  667  _21    0 702 669
 76  611  _22    0 590 669
 77  889  _29  _12 917 669
 78  722  _27  _15 748 669
 79  722   27  _18 691 685
 80  611  _27    0 613 669
 81  722   27 _208 691 685
 82  667  _29    0 623 669
 83  556    2  _18 526 685
 84  611   50    0 650 669
 85  722   67  _18 744 669
 86  667   65  _18 715 669
 87  889   65  _18 940 669
 88  667  _24    0 694 669
 89  611   73    0 659 669
 90  611  _11    0 590 669
 91  333  _37 _159 362 674
 92  278   _1  _18 279 685
 93  333  _56 _157 343 674
 94  570   67  304 503 669
 95  500    0 _125 500 _75
 96  333  128  369 332 685
 97  500  _21  _14 455 462
 98  500  _14  _13 444 699
 99  444   _5  _13 392 462
100  500  _21  _13 517 699
101  444    5  _13 398 462
102  333 _169 _205 446 698
103  500  _52 _203 478 462
104  556  _13   _9 498 699
105  278    2   _9 263 684
106  278 _189 _207 279 684
107  500  _23   _8 483 699
108  278    2   _9 290 699
109  778  _14   _9 722 462
110  556   _6   _9 493 462
111  500   _3  _13 441 462
112  500 _120 _205 446 462
113  500    1 _205 471 462
114  389  _21    0 389 462
115  389  _19  _13 333 462
116  278  _11   _9 281 594
117  556   15   _9 492 462
118  444   16  _13 401 462
119  667   16  _13 614 462
120  500  _46  _13 469 462
121  444  _94 _205 392 462
122  389  _43  _78 368 449
123  348    5 _187 436 686
124  220   66 _218 154 782
125  348 _129 _187 302 686
126  570   54  173 516 333
161  389   19 _205 322 492
162  500   42 _143 439 576
163  500  _32  _12 510 683
164  167 _169  _14 324 683
165  500   33    0 628 669
166  500  _87 _156 537 707
167  500   36 _143 459 685
168  500  _26   34 526 586
169  278  128  398 268 685
170  500   53  369 513 685
171  500   12   32 468 415
172  333   32   32 303 415
173  333   10   32 281 415
174  556 _188 _205 514 703
175  556 _186 _205 553 704
177  500  _40  178 477 269
178  500   91 _145 494 685
179  500   10 _139 493 685
180  250   51  257 199 405
182  500  _57 _193 562 669
183  350    0  175 350 525
184  333   _5 _182 199 134
185  500  _57 _182 403 134
186  500   53  369 513 685
187  500   12   32 468 415
188 1000   40  _13 852 135
189 1000    7  _29 996 706
191  500   30 _205 421 492
193  333   85  516 297 697
194  333  139  516 379 697
195  333   40  516 367 690
196  333   48  536 407 655
197  333   51  553 393 623
198  333   71  516 387 678
199  333  163  550 298 684
200  333   55  550 402 684
202  333  127  516 340 729
203  333  _80 _218 156   5
205  333   69  516 498 697
206  333   15 _183 244  34
207  333   79  516 411 690
208 1000  _40  178 977 269
225  944  _64    0 918 669
227  266   16  399 330 685
232  611  _22    0 590 669
233  722   27 _125 691 764
234  944   23   _8 946 677
235  300   56  400 347 685
241  722   _5  _13 673 462
245  278    2   _9 238 462
248  278   _7   _9 307 699
249  500   _3 _119 441 560
250  722    6  _13 674 462
251  500 _200 _200 473 705
)
TimesItalic_Ascender=: 683

TimesItalic_FontBBox=: _169 _217 1010 883

TimesItalic_UnderlinePosition=: _100

TimesItalic_UnderlineThickness=: 50

TimesItalic_FontMetrics=: 0 : 0
Ascender=: 683
CapHeight=: 653
Descender=: _217
FontBBox=: _169 _217 1010 883
StdHW=: 32
StdVW=: 76
UnderlinePosition=: _100
UnderlineThickness=: 50
XHeight=: 441
)

TimesItalic_CharMetrics=: 0 ". [;._2 (0 : 0)
  0  491   34   29  482 565
 32  250    0    0    0   0
 33  333   39  _11  302 667
 34  420  144  421  432 666
 35  500    2    0  540 676
 36  500   31  _89  497 731
 37  833   79  _13  790 676
 38  778   76  _18  723 666
 39  333  151  436  290 666
 40  333   42 _181  315 669
 41  333   16 _180  289 669
 42  500  128  255  492 666
 43  675   86    0  590 506
 44  250   _4 _129  135 101
 45  333   49  192  282 255
 46  250   27  _11  138 100
 47  278  _65  _18  386 666
 48  500   32   _7  497 676
 49  500   49    0  409 676
 50  500   12    0  452 676
 51  500   15   _7  465 676
 52  500    1    0  479 676
 53  500   15   _7  491 666
 54  500   30   _7  521 686
 55  500   75   _8  537 666
 56  500   30   _7  493 676
 57  500   23  _17  492 676
 58  333   50  _11  261 441
 59  333   27 _129  261 441
 60  675   84   _8  592 514
 61  675   86  120  590 386
 62  675   84   _8  592 514
 63  500  132  _12  472 664
 64  920  118  _18  806 666
 65  611  _51    0  564 668
 66  611   _8    0  588 653
 67  667   66  _18  689 666
 68  722   _8    0  700 653
 69  611   _1    0  634 653
 70  611    8    0  645 653
 71  722   52  _18  722 666
 72  722   _8    0  767 653
 73  333   _8    0  384 653
 74  444   _6  _18  491 653
 75  667    7    0  722 653
 76  556   _8    0  559 653
 77  833  _18    0  873 653
 78  667  _20  _15  727 653
 79  722   60  _18  699 666
 80  611    0    0  605 653
 81  722   59 _182  699 666
 82  611  _13    0  588 653
 83  500   17  _18  508 667
 84  556   59    0  633 653
 85  722  102  _18  765 653
 86  611   76  _18  688 653
 87  833   71  _18  906 653
 88  611  _29    0  655 653
 89  556   78    0  633 653
 90  556   _6    0  606 653
 91  389   21 _153  391 663
 92  278  _41  _18  319 666
 93  389   12 _153  382 663
 94  422    0  301  422 666
 95  500    0 _125  500 _75
 96  333  171  436  310 666
 97  500   17  _11  476 441
 98  500   23  _11  473 683
 99  444   30  _11  425 441
100  500   15  _13  527 683
101  444   31  _11  412 441
102  278 _147 _207  424 678
103  500    8 _206  472 441
104  500   19   _9  478 683
105  278   49  _11  264 654
106  278 _124 _207  276 654
107  444   14  _11  461 683
108  278   41  _11  279 683
109  722   12   _9  704 441
110  500   14   _9  474 441
111  500   27  _11  468 441
112  500  _75 _205  469 441
113  500   25 _209  483 441
114  389   45    0  412 441
115  389   16  _13  366 442
116  278   37  _11  296 546
117  500   42  _11  475 441
118  444   21  _18  426 441
119  667   16  _18  648 441
120  444  _27  _11  447 441
121  444  _24 _206  426 441
122  389   _2  _81  380 428
123  400   51 _177  407 687
124  275  105 _217  171 783
125  400   _7 _177  349 687
126  541   40  183  502 323
161  389   59 _205  322 473
162  500   77 _143  472 560
163  500   10   _6  517 670
164  167 _169  _10  337 676
165  500   27    0  603 653
166  500   25 _182  507 682
167  500   53 _162  461 666
168  500  _22   53  522 597
169  214  132  421  241 666
170  556  166  436  514 666
171  500   53   37  445 403
172  333   51   37  281 403
173  333   52   37  282 403
174  500 _141 _207  481 681
175  500 _141 _204  518 682
177  500   _6  197  505 243
178  500  101 _159  488 666
179  500   22 _143  491 666
180  250   70  199  181 310
182  523   55 _123  616 653
183  350   40  191  310 461
184  333   44 _129  183 101
185  556   57 _129  405 101
186  556  151  436  499 666
187  500   55   37  447 403
188  889   57  _11  762 100
189 1000   25  _19 1010 706
191  500   28 _205  368 471
193  333  121  492  311 664
194  333  180  494  403 664
195  333   91  492  385 661
196  333  100  517  427 624
197  333   99  532  411 583
198  333  117  492  418 650
199  333  207  548  305 646
200  333  107  548  405 646
202  333  155  492  355 691
203  333  _30 _217  182   0
205  333   93  494  486 664
206  333   20 _169  203  40
207  333  121  492  426 661
208  889   _6  197  894 243
225  889  _27    0  911 653
227  276   42  406  352 676
232  556   _8    0  559 653
233  722   60 _105  699 722
234  944   49   _8  964 666
235  310   67  406  362 676
241  667   23  _11  640 441
245  278   49  _11  235 441
248  278   41  _11  312 683
249  500   28 _135  469 554
250  667   20  _12  646 441
251  500 _168 _207  493 679
)
TimesRoman_Ascender=: 683

TimesRoman_FontBBox=: _168 _218 1000 898

TimesRoman_UnderlinePosition=: _100

TimesRoman_UnderlineThickness=: 50

TimesRoman_FontMetrics=: 0 : 0
Ascender=: 683
CapHeight=: 662
Descender=: _217
FontBBox=: _168 _218 1000 898
StdHW=: 28
StdVW=: 84
UnderlinePosition=: _100
UnderlineThickness=: 50
XHeight=: 450
)

TimesRoman_CharMetrics=: 0 ". [;._2 (0 : 0)
  0  495   31   37  459 572
 32  250    0    0    0   0
 33  333  130   _9  238 676
 34  408   77  431  331 676
 35  500    5    0  496 662
 36  500   44  _87  457 727
 37  833   61  _13  772 676
 38  778   42  _13  750 676
 39  333   79  433  218 676
 40  333   48 _177  304 676
 41  333   29 _177  285 676
 42  500   69  265  432 676
 43  564   30    0  534 506
 44  250   56 _141  195 102
 45  333   39  194  285 257
 46  250   70  _11  181 100
 47  278   _9  _14  287 676
 48  500   24  _14  476 676
 49  500  111    0  394 676
 50  500   30    0  475 676
 51  500   43  _14  431 676
 52  500   12    0  472 676
 53  500   32  _14  438 688
 54  500   34  _14  468 684
 55  500   20   _8  449 662
 56  500   56  _14  445 676
 57  500   30  _22  459 676
 58  278   81  _11  192 459
 59  278   80 _141  219 459
 60  564   28   _8  536 514
 61  564   30  120  534 386
 62  564   28   _8  536 514
 63  444   68   _8  414 676
 64  921  116  _14  809 676
 65  722   15    0  706 674
 66  667   17    0  593 662
 67  667   28  _14  633 676
 68  722   16    0  685 662
 69  611   12    0  597 662
 70  556   12    0  546 662
 71  722   32  _14  709 676
 72  722   19    0  702 662
 73  333   18    0  315 662
 74  389   10  _14  370 662
 75  722   34    0  723 662
 76  611   12    0  598 662
 77  889   12    0  863 662
 78  722   12  _11  707 662
 79  722   34  _14  688 676
 80  556   16    0  542 662
 81  722   34 _178  701 676
 82  667   17    0  659 662
 83  556   42  _14  491 676
 84  611   17    0  593 662
 85  722   14  _14  705 662
 86  722   16  _11  697 662
 87  944    5  _11  932 662
 88  722   10    0  704 662
 89  722   22    0  703 662
 90  611    9    0  597 662
 91  333   88 _156  299 662
 92  278   _9  _14  287 676
 93  333   34 _156  245 662
 94  469   24  297  446 662
 95  500    0 _125  500 _75
 96  333  115  433  254 676
 97  444   37  _10  442 460
 98  500    3  _10  468 683
 99  444   25  _10  412 460
100  500   27  _10  491 683
101  444   25  _10  424 460
102  333   20    0  383 683
103  500   28 _218  470 460
104  500    9    0  487 683
105  278   16    0  253 683
106  278  _70 _218  194 683
107  500    7    0  505 683
108  278   19    0  257 683
109  778   16    0  775 460
110  500   16    0  485 460
111  500   29  _10  470 460
112  500    5 _217  470 460
113  500   24 _217  488 460
114  333    5    0  335 460
115  389   51  _10  348 460
116  278   13  _10  279 579
117  500    9  _10  479 450
118  500   19  _14  477 450
119  722   21  _14  694 450
120  500   17    0  479 450
121  500   14 _218  475 450
122  444   27    0  418 450
123  480  100 _181  350 680
124  200   67 _218  133 782
125  480  130 _181  380 680
126  541   40  183  502 323
161  333   97 _218  205 467
162  500   53 _138  448 579
163  500   12   _8  490 676
164  167 _168  _14  331 676
165  500  _53    0  512 662
166  500    7 _189  490 676
167  500   70 _148  426 676
168  500  _22   58  522 602
169  180   48  431  133 676
170  444   43  433  414 676
171  500   42   33  456 416
172  333   63   33  285 416
173  333   48   33  270 416
174  556   31    0  521 683
175  556   32    0  521 683
177  500    0  201  500 250
178  500   59 _149  442 676
179  500   58 _153  442 676
180  250   70  199  181 310
182  453  _22 _154  450 662
183  350   40  196  310 466
184  333   79 _141  218 102
185  444   45 _141  416 102
186  444   30  433  401 676
187  500   44   33  458 416
188 1000  111  _11  888 100
189 1000    7  _19  994 706
191  444   30 _218  376 466
193  333   19  507  242 678
194  333   93  507  317 678
195  333   11  507  322 674
196  333    1  532  331 638
197  333   11  547  322 601
198  333   26  507  307 664
199  333  118  581  216 681
200  333   18  581  315 681
202  333   67  512  266 711
203  333   52 _215  261   0
205  333   _3  507  377 678
206  333   62 _165  243   0
207  333   11  507  322 674
208 1000    0  201 1000 250
225  889    0    0  863 662
227  276    4  394  270 676
232  611   12    0  598 662
233  722   34  _80  688 734
234  889   30   _6  885 668
235  310    6  394  304 676
241  667   38  _10  632 460
245  278   16    0  253 460
248  278   19    0  259 683
249  500   29 _112  470 551
250  722   30  _10  690 460
251  500   12   _9  468 683
)
ZapfDingbats_Ascender=: 650

ZapfDingbats_FontBBox=: _1 _143 981 820

ZapfDingbats_UnderlinePosition=: _100

ZapfDingbats_UnderlineThickness=: 50

ZapfDingbats_FontMetrics=: 0 : 0
FontBBox=: _1 _143 981 820
StdHW=: 28
StdVW=: 90
UnderlinePosition=: _100
UnderlineThickness=: 50
)

ZapfDingbats_CharMetrics=: 0 ". [;._2 (0 : 0)
  0  746 34   22 710 672
 32  278  0    0   0   0
 33  974 35   72 939 621
 34  961 35   81 927 611
 35  974 35   72 939 621
 36  980 35    0 945 692
 37  719 34  139 685 566
 38  789 35  _14 755 705
 39  790 35  _14 755 705
 40  791 35  _13 761 705
 41  690 34  138 655 553
 42  960 35  123 925 568
 43  939 35  134 904 559
 44  549 29  _11 516 705
 45  855 34   59 820 632
 46  911 35   50 876 642
 47  933 35  139 899 550
 48  911 35   50 876 642
 49  945 35  139 909 553
 50  974 35  104 938 587
 51  755 34  _13 721 705
 52  846 36  _14 811 705
 53  762 35    0 727 692
 54  761 35    0 727 692
 55  571 _1  _68 571 661
 56  677 36  _13 642 705
 57  763 35    0 728 692
 58  760 35    0 726 692
 59  759 35    0 725 692
 60  754 35    0 720 692
 61  494 35    0 460 692
 62  552 35    0 517 692
 63  537 35    0 503 692
 64  577 35   96 542 596
 65  692 35  _14 657 705
 66  786 35  _14 751 705
 67  788 35  _14 752 705
 68  788 35  _14 753 705
 69  790 35  _14 756 705
 70  793 35  _13 759 705
 71  794 35  _13 759 705
 72  816 35  _14 782 705
 73  823 35  _14 787 705
 74  789 35  _14 754 705
 75  841 35  _14 807 705
 76  823 35  _14 789 705
 77  833 35  _14 798 705
 78  816 35  _13 782 705
 79  831 35  _14 796 705
 80  923 35  _14 888 705
 81  744 35    0 710 692
 82  723 35    0 688 692
 83  749 35    0 714 692
 84  790 34  _14 756 705
 85  792 35  _14 758 705
 86  695 35  _14 661 706
 87  776 35   _6 741 699
 88  768 35   _7 734 699
 89  792 35  _14 757 705
 90  759 35    0 725 692
 91  707 35  _13 672 704
 92  708 35  _14 672 705
 93  682 35  _14 647 705
 94  701 35  _14 666 705
 95  826 35  _14 791 705
 96  815 35  _14 780 705
 97  789 35  _14 754 705
 98  789 35  _14 754 705
 99  707 34  _14 673 705
100  687 36    0 651 692
101  696 35    0 661 691
102  689 35    0 655 692
103  786 34  _14 751 705
104  787 35  _14 752 705
105  713 35  _14 678 705
106  791 35  _14 756 705
107  785 36  _14 751 705
108  791 35  _14 757 705
109  873 35  _14 838 705
110  761 35    0 726 692
111  762 35    0 727 692
112  762 35    0 727 692
113  759 35    0 725 692
114  759 35    0 725 692
115  892 35    0 858 705
116  892 35  _14 858 692
117  788 35  _14 754 705
118  784 35  _14 749 705
119  438 35  _14 403 705
120  138 35    0 104 692
121  277 35    0 242 692
122  415 35    0 380 692
123  392 35  263 357 705
124  392 34  263 357 705
125  668 35  263 633 705
126  668 36  263 634 705
128  390 35  _14 356 705
129  390 35  _14 355 705
130  317 35    0 283 692
131  317 35    0 283 692
132  276 35    0 242 692
133  276 35    0 242 692
134  509 35    0 475 692
135  509 35    0 475 692
136  410 35    0 375 692
137  410 35    0 375 692
138  234 35  _14 199 705
139  234 35  _14 199 705
140  334 35    0 299 692
141  334 35    0 299 692
161  732 35 _143 697 806
162  544 56  _14 488 706
163  544 34  _14 508 705
164  910 35   40 875 651
165  667 35  _14 633 705
166  760 35  _14 726 705
167  760  0  121 758 569
168  776 35    0 741 705
169  595 34  _14 560 705
170  694 35  _14 659 705
171  626 34    0 591 705
172  788 35  _14 754 705
173  788 35  _14 754 705
174  788 35  _14 754 705
175  788 35  _14 754 705
176  788 35  _14 754 705
177  788 35  _14 754 705
178  788 35  _14 754 705
179  788 35  _14 754 705
180  788 35  _14 754 705
181  788 35  _14 754 705
182  788 35  _14 754 705
183  788 35  _14 754 705
184  788 35  _14 754 705
185  788 35  _14 754 705
186  788 35  _14 754 705
187  788 35  _14 754 705
188  788 35  _14 754 705
189  788 35  _14 754 705
190  788 35  _14 754 705
191  788 35  _14 754 705
192  788 35  _14 754 705
193  788 35  _14 754 705
194  788 35  _14 754 705
195  788 35  _14 754 705
196  788 35  _14 754 705
197  788 35  _14 754 705
198  788 35  _14 754 705
199  788 35  _14 754 705
200  788 35  _14 754 705
201  788 35  _14 754 705
202  788 35  _14 754 705
203  788 35  _14 754 705
204  788 35  _14 754 705
205  788 35  _14 754 705
206  788 35  _14 754 705
207  788 35  _14 754 705
208  788 35  _14 754 705
209  788 35  _14 754 705
210  788 35  _14 754 705
211  788 35  _14 754 705
212  894 35   58 860 634
213  838 35  152 803 540
214 1016 34  152 981 540
215  458 35 _127 422 820
216  748 35   94 698 597
217  924 35  140 890 552
218  748 35   94 698 597
219  918 35  166 884 526
220  927 35   32 892 660
221  928 35  129 891 562
222  928 35  128 893 563
223  834 35  155 799 537
224  873 35   93 838 599
225  828 35  104 791 588
226  924 35   98 889 594
227  924 35   98 889 594
228  917 35    0 882 692
229  930 35   84 896 608
230  931 35   84 896 608
231  463 35  _99 429 791
232  883 35   71 848 623
233  836 35   44 802 648
234  836 35   44 802 648
235  867 35  101 832 591
236  867 35  101 832 591
237  696 35   44 661 648
238  696 35   44 661 648
239  874 35   77 840 619
241  874 35   73 840 615
242  760 35    0 725 692
243  946 35  160 911 533
244  771 34   37 736 655
245  865 35  207 830 481
246  771 34   37 736 655
247  888 34  _19 853 712
248  967 35  124 932 568
249  888 34  _19 853 712
250  831 35  113 796 579
251  873 36  118 838 578
252  927 35  150 891 542
253  970 35   76 931 616
254  918 34   99 884 593
)
cocurrent 'jmf'
jsystemdefs 'hostdefs'
coinsert 'jdefs'

doc=: 0 : 0
map name;filename [;sharename [;mt] ]
 map jmf file (self-describing)

(type [;tshape]) map name;filename [;sharename [;mt] ]
 map data file

 types from dll.ijs: JB01,JCHAR,JCHAR2,JCHAR4,JINT,JFL,JCMPX,JSB

 tshape - trailing shape - }.shape    (default '')

mt (map type):
 0 - MTRW - default read/write mapping 
 1 - MTRO - read-only mapping - map jmf file copies header to private area
 2 - MTCW - copy-on-write - private mapping - changes not reflected in file

[force] unmap name - result 0 ok, 1 not mapped, 2 refs prevent unmap

createjmf filename;msize  - create jmf file as empty vector (self-describing)
unmapall''                - unmap all
showmap''                 - map info with col headers and extras
mappings                  - map info
share name;sharename[;mt] - share 'sharename' as name

MAPNAME,MAPFN,... showmap col indexes 
)
memhad_z_=: [: {: [: memr 0 2 4 ,~ (15!:6)@<
memdad_z_=: 15!:14@<

0 : 0
807 made changes to the header that affect jmf J code
before 807 - HADR field bytes are (lilendian) rrrr (j32) rrrrrrrr (j64)
after  807 - HADR field bytes are (lilendian) rrhh (j32) rrhhxxxx (j64)
flipped for bigendian (fill,hh,rr)
hh field flags must not be touched by jmf
newheader is 1 if 807 header format
)
IFBE=: 'a'~:{.2 ic a.i.'a'
SZI=: IF64{4 8
'MAPNAME MAPFN MAPSN MAPFH MAPMH MAPADDRESS MAPHEADER MAPFSIZE MAPJMF MAPMT MAPMSIZE MAPREFS'=: i.12
'MTRW MTRO MTCW'=: i.3
'HADK HADFLAG HADM HADT HADC HADN HADR HADS'=: SZI*i.8
HADRUS=: HADR+IFBE*IF64{2 6
HADCN=: <.HADC%SZI
HSN=: 7+64
HS=: SZI*HSN
AFRO=: 1
AFNJA=: 2
NULLPTR=: <0
allochdr=: 3 : 'r[2 setHADC r=.15!:8 y'
freehdr=: 15!:9
msize=: gethadmsize=: 3 : 'memr y,HADM,1,JINT'
fullname=: 3 : 0
t=. y-.' '
t,('_'~:{:t)#'_base_'
)
newheader=: 0~:memr (memhad'SZI_jmf_'),HADR,1,JINT

setheader=: 4 : 0
if. newheader do.
 (6{.x) memw y,0,6,JINT
 (6{x)  setHADR y
 (7}.x) memw y,HADS,(#7}.x),JINT
else.
 x memw y,0,(#x),JINT
end.
)

getHADR=: 3 : 0
if. newheader do.
 _1 (3!:4) memr y,HADRUS,2,JCHAR
else.
 memr y,HADR,1,JINT
end.
)

setHADR=: 4 : 0
if. newheader do.
 (1 (3!:4) x) memw y,HADRUS,2,JCHAR
else.
 x memw y,HADR,1,JINT
end.
)

getHADC=: 3 : '  memr y,HADC,1,JINT'
setHADC=: 4 : 'x memw y,HADC,1,JINT'
refcount=: getHADC

3 : 0''
if. IFUNIX do.
  lib=. ' ',~ unxlib 'c'
  api=. 1 : ('(''',lib,''',m) & cd')
  c_open=: 'open i *c i i' api
  c_open_va=: 'open i *c i x x x x x x i' api
  c_close=: 'close i i' api
  c_read=: 'read x i * x' api
  c_write=: 'write x i * x' api
  c_lseek=: 'lseek x i x i' api
  c_ftruncate=: 'ftruncate i i x' api
  c_mmap=: 'mmap * * x i i i x' api
  c_munmap=: 'munmap i * x' api

  t=.           O_RDWR,   (PROT_WRITE+PROT_READ),  MAP_SHARED
  t=. t,:       O_RDONLY, PROT_READ,               MAP_SHARED
  mtflags=:  t, O_RDWR,   (PROT_WRITE+PROT_READ),  MAP_PRIVATE
else.
  CREATE_ALWAYS=: 2
  CREATE_NEW=: 1
  FALSE=: 0
  FILE_BEGIN=: 0
  FILE_END=: 2
  FILE_MAP_COPY=: 1
  FILE_MAP_READ=: 4
  FILE_MAP_WRITE=: 2
  FILE_SHARE_READ=: 1
  FILE_SHARE_WRITE=: 2
  GENERIC_READ=: _2147483648
  GENERIC_WRITE=: 1073741824
  OPEN_ALWAYS=: 4
  OPEN_EXISTING=: 3
  PAGE_READONLY=: 2
  PAGE_READWRITE=: 4
  TRUNCATE_EXISTING=: 5

  t=.           (GENERIC_READ+GENERIC_WRITE), PAGE_READWRITE,  FILE_MAP_WRITE
  t=.       t,: GENERIC_READ,                 PAGE_READONLY,   FILE_MAP_READ
  mtflags=: t,  (GENERIC_READ+GENERIC_WRITE), PAGE_READWRITE,  FILE_MAP_COPY

  CloseHandleR=: 'kernel32 CloseHandle > i x'&(15!:0)
  CreateFileMappingR=: 'kernel32 CreateFileMappingW > x x * i i i *w'&(15!:0)
  CreateFileR=: 'kernel32 CreateFileW > x *w i i * i i x'&(15!:0)
  GetLastError=: 'kernel32 GetLastError > i'&(15!:0)
  FlushViewOfFileR=: 'kernel32 FlushViewOfFile > i * x'&(15!:0)
  MapViewOfFileR=: >@{.@('kernel32 MapViewOfFile * x i i i x'&(15!:0))
  OpenFileMappingR=: 'kernel32 OpenFileMappingW > x i i *w'&(15!:0)
  SetEndOfFile=: 'kernel32 SetEndOfFile > i x'&(15!:0)
  UnmapViewOfFileR=: 'kernel32 UnmapViewOfFile > i *'&(15!:0)
  WriteFile=: 'kernel32 WriteFile i x * i *i *'&(15!:0)
  if. IF64 do.
    GetFileSizeR=: 2 >@{ 'kernel32 GetFileSizeEx i x *x' 15!:0 ;&(,2)
    SetFilePointerR=: 'kernel32 SetFilePointerEx > i x x *x i'&(15!:0)
  else.
    GetFileSizeR=: 'kernel32 GetFileSize > i x *i' 15!:0 ;&(<NULLPTR)
    SetFilePointerR=: 'kernel32 SetFilePointer > i x i *i i'&(15!:0)
  end.
end.

if. _1 = 4!:0<'mappings' do.
  mappings=: i.0 10
end.
empty''
)

nountype =: 17 b.&16b1fffff
MAXINTU=: 2 ^ IF64{32 64x
MAXINTS=: <: 2 ^ IF64{31 63x
ufs=: + MAXINTU * 0 > ]
sfu=: _1 x: ] - MAXINTU * MAXINTS < ]
findkey=: 4 : 'I. (<x) = {."1 y'
free=: 3 : 0
'fh mh fad'=. y
if. IFUNIX do.
  if. fad do. c_munmap (<fad);mh end.
  if. fh~:_1 do. c_close fh end.
else.
  if. fad do. UnmapViewOfFileR <<fad end.
  if. mh do. CloseHandleR mh end.
  if. fh~:_1 do. CloseHandleR fh end.
end.
)
mbxcheck=: 3 : 0
x=. 15!:12 y
b=. 0={:"1 x
'a s c'=. |: (-.b)#x
'u n z'=. ,b#x
z=. *./ c e. 1 2
z=. z, (-:<.) 2^.s
z=. z, (}.a)-:}:a+s
z=. z, u = {.a
z=. z, ({:a+s) <: u+n
z=. z, (-: <.) 64 %~ +/s
z=. z, (+/s) = <.&.(%&64) n
z=. z, *./ 0 = 8|a
)
settypeshape=: 3 : 0
'name type shape'=: y
type =: nountype type
rank=. #shape
had=. memhad name
'flag msize'=. memr had,HADFLAG,2,JINT
'not mapped and writeable' assert 2=3 (17 b.) flag
size=. (JTYPES i.type){JSIZES
ts=. size**/shape
'msize too small' assert ts<:msize
type memw had,HADT,1,JINT
(*/shape) memw had,HADN,1,JINT
rank setHADR had
shape memw had,HADS,(#shape),JINT
i.0 0
)
validate=: 3 : 0
'ts had'=. y
if. ts>:HS do.
  d=. memr had,0 4,JINT
  *./((HS,ts-HS)=0 2{d),1 2 4 8 16 32 131072 262144 65536 e.~ nountype 3{d
else. 0 end.
)
j=. <;._2 (0 : 0)
1  ERROR_INVALID_FUNCTION
2  ERROR_FILE_NOT_FOUND
3  ERROR_PATH_NOT_FOUND
4  ERROR_TOO_MANY_OPEN_FILES
5  ERROR_ACCESS_DENIED
6  ERROR_INVALID_HANDLE
7  ERROR_ARENA_TRASHED
8  ERROR_NOT_ENOUGH_MEMORY
9  ERROR_INVALID_BLOCK
10 ERROR_BAD_ENVIRONMENT
11 ERROR_BAD_FORMAT
12 ERROR_INVALID_ACCESS
13 ERROR_INVALID_DATA
14 ERROR_OUTOFMEMORY
15 ERROR_INVALID_DRIVE
16 ERROR_CURRENT_DIRECTORY
17 ERROR_NOT_SAME_DEVICE
18 ERROR_NO_MORE_FILES
19 ERROR_WRITE_PROTECT
20 ERROR_BAD_UNIT
21 ERROR_NOT_READY
22 ERROR_BAD_COMMAND
23 ERROR_CRC
24 ERROR_BAD_LENGTH
25 ERROR_SEEK
26 ERROR_NOT_DOS_DISK
27 ERROR_SECTOR_NOT_FOUND
28 ERROR_OUT_OF_PAPER
29 ERROR_WRITE_FAULT
30 ERROR_READ_FAULT
31 ERROR_GEN_FAILURE
32 ERROR_SHARING_VIOLATION
33 ERROR_LOCK_VIOLATION
34 ERROR_WRONG_DISK
)

WINERRNOS=: 0 ". 2 {.&> j
WINERRMSG=: 3 }.each j
createjmf=: 3 : 0
'fn msize'=. y
fn=. jpath fn
msize=. <. msize
ts=. HS+msize
if. IFUNIX do.
  if. ('Darwin'-:UNAME) *. 'arm64'-:3 :'try.9!:56''cpu''catch.''''end.' '' do.
  fh=. 0 pick c_open_va fn; (OR O_RDWR, O_CREAT, O_TRUNC); (6#<00) ,< 8b666
  else.
  fh=. 0 pick c_open fn; (OR O_RDWR, O_CREAT, O_TRUNC); 8b666
  end.
  c_lseek fh;(<:ts);SEEK_SET
  c_write fh; (,0{a.); 0+1
  c_lseek fh;0 ;SEEK_SET
  d=. HS,AFNJA,msize,JINT,0,0,1,0
  c_write fh;d;(SZI*#d)
  c_close fh
else.
  fh=. CreateFileR (uucp fn,{.a.);(GENERIC_READ+GENERIC_WRITE);0;NULLPTR;CREATE_ALWAYS;0;0
  SetFilePointerR fh;ts;NULLPTR;FILE_BEGIN
  SetEndOfFile fh
  SetFilePointerR fh;0;NULLPTR;FILE_BEGIN
  d=. HS,AFNJA,msize,JINT,0,0,1,0
  WriteFile fh;d;(SZI*#d);(,0);<NULLPTR
  CloseHandleR fh
end.
i.0 0
)
readonly=: 3 : 0
AFRO(17 b.) a.i.memr (HADFLAG+memhad fullname y),0 1,JCHAR
:
ad=. HADFLAG+memhad fullname y
flags=. a.i.memr ad,0 1,JCHAR
flags=. flags(17 b.)(26 b.)AFRO
flags=. flags(23 b.)AFRO*0~:x
(flags{a.) memw ad,0 1,JCHAR
i. 0 0
)
showmap=: 3 : 0
h=. 'name';'fn';'sn';'fh';'mh';'address';'header';'fsize';'jmf';'mt';'msize';'refs'
hads=. 6{"1 mappings
h,mappings,.(gethadmsize each hads),.refcount each hads
)
mapsub=: 3 : 0
'name fn sn ro'=. y
ts=. 1!:4 <fn
if. IFUNIX do.
  'Unix sharename must be same as filename' assert (sn-:'')+.sn-:fn
  'FO FMP FMM'=. ro{mtflags
  if. ('Darwin'-:UNAME) *. 'arm64'-:3 :'try.9!:56''cpu''catch.''''end.' '' do.
  fh=. >0 { c_open_va fn;FO;(6#<00),<0
  else.
  fh=. >0 { c_open fn;FO;0
  end.
  'bad file name/access' assert fh~:_1
  mh=. ts
  fad=. >0{ c_mmap (<0);ts;FMP;FMM;fh;0
  if. fad e. 0 _1 do. 'bad view' assert 0[free fh,mh,0 end.
else.
  'Win sharename must not have /' assert -.'/'e.sn
  'fa ma va'=. ro{mtflags



  fh=. CreateFileR (uucp fn,{.a.);fa;(OR FILE_SHARE_WRITE, FILE_SHARE_READ);NULLPTR;OPEN_EXISTING;0;0
  if. fh=_1 do.
   6!:3[2
   fh=. CreateFileR (uucp fn,{.a.);fa;(OR FILE_SHARE_WRITE, FILE_SHARE_READ);NULLPTR;OPEN_EXISTING;0;0
   'bad file name/access'assert fh~:_1
  end. 
  mh=: CreateFileMappingR fh;NULLPTR;ma;0;0;(0=#sn){(uucp sn,{.a.);<NULLPTR
  if. mh=0 do. 'bad mapping'assert 0[free fh,0,0 end.
  fad=. MapViewOfFileR mh;va;0;0;0
  if. fad=0 do.
    errno=. GetLastError''
    free fh,mh,0
    0 assert~;(8=errno){'bad view';'not enough memory'
  end.
end.
name;fn;sn;fh;mh;fad;0;ts;0;ro
)
map=: 3 : 0
0 map y
:
if. 0=L.x do. t=. <&> x else. t=. x end.
'type tshape hsize'=. 3 {. t, a:
type =. nountype type

'trailing shape may not be zero' assert -. 0 e. tshape

'name fn sn ro'=. 4{.y,(#y)}.'';'';'';0
fn=. jpath fn
sn=. '/' (('\'=sn)#i.#sn)} sn
name=. fullname name
c=. #mappings

'maptype must be 0 (MTRW), 1 (MTRO), or 2 (MTCW - copy on write)' assert ro e. 0 1 2
'name already mapped'assert c=({."1 mappings)i.<name
'filename already mapped'assert c=(1{"1 mappings)i.<fn
'sharename already mapped'assert (''-:sn)+.c=(2{"1 mappings)i.<sn
4!:55 ::] <name
'bad noun name'assert ('_'={:name)*._1=nc<name
aa=. AFNJA+AFRO*ro=1

m=. mapsub name;fn;sn;ro
'fh mh fad had ts'=. (MAPFH,MAPMH,MAPADDRESS,MAPHEADER,MAPFSIZE){m

if. ro*.0=type do.
  had=. allochdr 63
  d=. memr fad,0,HSN,JINT
  d=. (sfu HS+-/ufs fad,had),aa,2}.d
  d=. 1 HADCN} d
  d setheader had
elseif. 0=type do.
  had=. fad
  if. 0=validate ts,had do. 'bad jmf header' assert 0[free fh,mh,fad end.
  aa memw had,HADFLAG,1,JINT
  if. sn-:'' do.
    t=. 0
  else.
    t=. 10000+ getHADC had
  end.
  (,t+1) setHADC had
elseif. 1 do.
  had=. allochdr 63
  'JBOXED (non-jmf) not supported' assert JBOXED~:type
  bx=. JBOXED=type
  hs=. +/hsize [ asize=. JSIZES {~ JTYPES i. type
  lshape=. bx}.<.(ts-hs)%(*/tshape)*asize
  d=. sfu hs+-/ufs fad,had
  h=. d,aa,ts,type,1,(*/lshape,tshape),((-.bx)+#tshape),lshape,tshape
  h setheader had
end.

m=. (had;0=type) (MAPHEADER,MAPJMF)}m
mappings=: mappings,m
(name)=: 15!:7 had
i.0 0
)
remap=: 3 : 0
name=. fullname y
row=. ({."1 mappings)i.<name
'remap: not mapped' assert row<#mappings
m=. row{mappings
fn=. ;1{m
ro=.  >MAPMT{m
jmf=. >MAPJMF{m
hs=. HS*jmf
'sn fh mh fad had'=. 5{.2}.m
free fh,mh,fad
m=. mapsub name;fn;sn;ro
m=. (had;jmf) (MAPHEADER,MAPJMF)}m
mappings=: m row}mappings
fad=. >MAPADDRESS{m
d=. sfu hs+-/ufs fad,had
d memw had,HADK,1,JINT
((>MAPFSIZE{m)-hs) memw had,HADM,1,JINT
i.0 0
)
share=: 3 : 0
'name sn ro'=. 3{.y,<0
map name;sn;sn;ro
)
unmap=: 3 : 0
0 unmap y
:
'y newsize'=. 2{.(boxopen y),<_1
n=. <fullname y
row=. ({."1 mappings)i.n
if. row=#mappings do. 1 return. end.
m=. row{mappings
4!:55 ::] n
'sn fh mh fad had jmf ts'=. (MAPSN,MAPFH,MAPMH,MAPADDRESS,MAPHEADER,MAPJMF,,MAPFSIZE){m

if. *./(-.x),(0=#sn),1~:getHADC had do. 2 return. end.
if. -.jmf do. freehdr had end.
if. _1=newsize do.
  free fh,mh,fad
else.
  newsize=. <.newsize
  totsize=. newsize + jmf*HS
  free _1,mh,fad
  if. IFUNIX do.
    if. totsize>ts do.
      c_lseek fh;(<:totsize);SEEK_SET
      c_write fh;(,0{a.);0+1
    elseif. totsize<ts do.
      c_ftruncate fh;totsize
    end.
    if. jmf do.
      c_lseek fh;(SZI*2);SEEK_SET
      c_write fh;(,newsize);SZI
    end.
    c_close fh
  else.
    SetFilePointerR fh;totsize;NULLPTR;FILE_BEGIN
    SetEndOfFile fh
    if. jmf do.
      SetFilePointerR fh;(SZI*2);NULLPTR;FILE_BEGIN
      WriteFile fh;(,newsize);SZI;(,0);<NULLPTR
    end.
    CloseHandleR fh
  end.
end.
mappings=: (row~:i.#mappings)#mappings
0
)
unmapall=: 3 : '>unmap each 0{"1 mappings'
memshare=: 3 : 0
bNo_Inherit_Handle=. FALSE
'y ro'=. 2{.(boxopen y),<0
lpShareName=. y,{.a.
mh=. OpenFileMappingR (ro{FILE_MAP_WRITE,FILE_MAP_READ); bNo_Inherit_Handle; uucp lpShareName
('Unable to map ',y) assert mh~:0

addr=. MapViewOfFileR mh; (ro{FILE_MAP_WRITE,FILE_MAP_READ); 0; 0; 0
if. addr=0 do. 'MapViewOfFile failed' assert 0[CloseHandleR mh end.
".(_1=4!:0<'mapTable')#'mapTable=:i.0,3'
mapTable=: mapTable, y; mh; addr
addr
)
memshareclose=: 3 : 0
r=. y findkey mapTable
'Unknown share name' assert 0~:$r
'mh addr'=. {:(<r; 1 2){mapTable
('Unable to close share: ', y) assert $mh > 0
UnmapViewOfFileR <<addr
if. CloseHandleR mh do.
  mapTable=: (<((i.#mapTable)-.r); i.{:$mapTable){mapTable
end.
)
NB. =========================================================
NB. tables/dsv
NB. Read/write delimiter-separated value strings and files
NB. Supports user-specified delimiters (General case of CSV).

require 'files strings'
coclass 'pdsv'
NB. =========================================================
NB. utils for dsv

ischar=: ] e. 2 131072 262144"_     NB. is datatype a character

isreal=: ] e. 1 4 8 64 128"_ NB. is datatype numeric real

NB. ---------------------------------------------------------
NB.*enclose v Encloses string in quotes
NB. form: [sd0[,sd1]] enclose strng(s)
NB. returns: quoted string
NB.      Internal quotes are doubled if present.
NB. y is: string or boxed strings to enclose with quotes
NB. x is: optional quote type. Default is '""'
NB.       0{ is (start) string delimiter (sd0)
NB.       1{ is end string delimiter (sd1)
enclose=: 3 : 0
  '""' enclose y
  :
  if. 0<L. y do. x&enclose &.> y return. end.
  if. -.(#x)e. 0 2 do. x=. 2$x end.
  (}:x),((>: (y e. x) *. =/x)#y),}.x
)

NB. ---------------------------------------------------------
NB.*enclosestrings v Array cells to strings with literal quoted
NB. form: [sd0[,sd1]] enclosestrings strng(s)
NB. returns: array of boxed strings with literals quoted
NB.         Only contents of literal boxes in y are quoted.
NB.         Internal quotes are doubled if present.
NB.         Numeric boxes are converted to strings
NB. y is: boxed array of mixed type
NB. x is: optional quote chars. Default is '""'
NB.       0{ is (start) string delimiter (sd0)
NB.       1{ is end string delimiter (sd1)
enclosestrings=: 3 : 0
  '""' enclosestrings y
  :
  if. 1=#sd=. x do. sd=. 2#sd end.
  dat=. ,y
  t=. #. ((0<#@$) , (isreal,.ischar)@:(3!:0)) &> dat        NB. cell data type
  dat=. ((#idx)$sd enclose idx{dat)(idx=. I. t e. 1 5)}dat  NB. quote char cells
  dat=. (8!:0 idx{dat) (idx=. I. 2=t)}dat                   NB. format numeric cells
  dat=. (":@:,@:> &.> idx{dat)(idx=. I. t e. 0 4 6)}dat     NB. handle complex, boxed, numeric rank>0
  ($y)$dat
)

NB. ---------------------------------------------------------
NB.*makenum v Converts cells in array of boxed literals to numeric where possible
NB. form: [err] makenum array
NB. returns: numeric array or array of boxed literals and numbers
NB. y is: an array of boxed literals
NB. x is: optional numeric error code. Default is _9999
makenum=: 3 : 0
  _9999 makenum y
  :
  dat=. , x&". &.> y=. boxopen y
  idx=. I. x&e.@> dat
  if. #idx do.
    dat=. (idx{,y) idx}dat  NB. amend non-numeric cells
  else.
    dat=. >dat              NB. unbox to list if all numeric
  end.
  ($y)$dat
)

NB. ---------------------------------------------------------
NB.*makenumcol v Converts columns in table of boxed literals to numeric where possible
NB. form: [err] makenumcol array
NB. returns: numeric array or array of boxed literal and numeric columns
NB. y is: an array of boxed literals
NB. x is: optional numeric error code. Default is _9999
NB. Only converts column to numeric if conversion is possible for whole column
makenumcol=: 3 : 0
  _9999 makenumcol y
  :
  dat=. x&". &.> y=. boxopen y
  notnum=. x&e.@> dat               NB. mask of boxes containing error code
  idx=. I. +./notnum                NB. index of non-numeric columns
  if. #idx do.
    dat=. (idx{"1 y) (<a:;idx)}dat  NB. amend non-numeric columns
  else.
    dat=. >dat                      NB. unbox to list if all numeric
  end.
)


NB. filter the starting block of lines in a text file
NB. where the first non-whitespace char is #
dlws=: }.~ (e.&(' ',TAB) i. 0:)             NB. delete leading whitespace
getIdxFnc=: ([: ((=&'#') i. 0:) {.@dlws;.2) NB. index of first non-comment line
droplComments=: ;@:(<;.2 }.~ getIdxFnc)     NB. drop leading comments
takelComments=: ;@:(<;.2 {.~ getIdxFnc)     NB. take leading comments
getHeader=: ;@:(<;._2 {~ getIdxFnc)         NB. retrieve header line (1st non comment line)

NB. Try to ensure that header names are valid J names
forceLeadingAlpha=: ,~ 'X' {.~ [: -.@e.&Alpha_j_ {.
replaceNonAlpha=: (-.@e.&AlphaNum_j_)`(,:&'_')}
deus=: #~ (+. (1: |. (> </\)))@('_'&~:)    NB. delete extraneous underscores
coerce2Name=: forceLeadingAlpha@deus@replaceNonAlpha@deb NB. coerce string to valid J name

NB. uniqify v Ensures all boxed literals in a list are unique by appending numeral
uniqify=: 3 : 0
  idx=. ([: I. i:~ ~: i.~) y   NB. idx of non unique items
  ((,&.> 8!:0@i.@#) idx{y) idx}y
)
NB. =========================================================
NB. Convert from delimited strings to arrays of boxes

NB. ---------------------------------------------------------
NB.*fixdsv v Chop multiline delimited string to array of boxed strings
NB. returns: array of boxed literals
NB. form: [fd[;sd0[,sd1]]] fixdsv dat
NB. eg: ('|';'<>') fixdsv '<hello world>|4|84.3',LF,'<Big dig>|<hello world>|4',LF
NB. y is: multiline delimited string, lines delimited by LF
NB. x is: a literal or 1 or 2-item boxed list of optional delimiters.
NB.       0{:: single literal field delimiter (fd). Defaults to TAB
NB.   (1;0){:: (start) string delimiter (sd0). Defaults to '"'
NB.   (1;1){:: end string delimiter (sd1). Defaults to '"'
fixdsv=: 3 : 0
  (TAB;'""') fixdsv y
  :
  dat=. ydrp=. droplComments y
  'fd sd'=. 2{. boxopen x
  if. #sd do.                    NB. string delimiter
    sd=. ~.sd
    if. 1 < #sd do.              NB. different start & end sd
      s=. {. '|`' -. fd          NB. use single sd that isn't fd
      dat=. dat charsub~ ,sd,.s
      sd=. s
    end.
    b=. dat = LF
    c=. ~:/\ dat = {.sd
    msk=. b > c
    > msk <@(x&chopstring);._2 ydrp
  else.                          NB. no string delimiter
    ([: <;._2 ,&fd);._2 ydrp
  end.
)

NB. ---------------------------------------------------------
NB.*readdsv v Reads delimiter-separated value file into a boxed array
NB. form: [fd[;sd0[,sd1]]] readdsv file
NB. returns: array of boxed literals
NB. y is: filename of file to read from
NB. x is: a literal or 1- or 2-item boxed list of optional delimiters.
NB.       0{:: single literal field delimiter (fd). Defaults to TAB
NB.   (1;0){:: (start) string delimiter (sd0). Defaults to '"'
NB.   (1;1){:: end string delimiter (sd1). Defaults to '"'
NB. eg: ('|';'<>') readdsv jpath '~temp/test.csv'
readdsv=: 3 : 0
  (TAB;'""') readdsv y
  :
  x=. 2{. boxopen x
  dat=. freads y
  if. dat -: _1 do. return. end.
  x fixdsv dat
)
NB. =========================================================
NB. Convert from arrays of boxes to delimited strings

NB. ---------------------------------------------------------
NB.*joindsv v Unbox and delimit a list of boxed items y with x
NB. form: Delimiter joindsv BoxedList
NB. eg: '","' joindsv 'item1';'item2'
NB. eg: LF joindsv 'item1';'item2'
NB. eg: 99 joindsv <"0 i.8
NB. based on forum post
NB. http://www.jsoftware.com/pipermail/programming/2007-June/007077.html
joindsv=: ' '&$: : (4 : '(;@(#^:_1!.(<x))~  1 0$~0 >. _1 2 p.#) y')

NB. ---------------------------------------------------------
NB.*delimitarray v Delimits and quotes an array of boxed of mixed type items
NB. makedsv performs better for large arrays
NB. returns: delimited, quoted string
NB.       Only arrays with rank>1 have trailing LF
NB.       Rows of arrays with rank>1 are delimited by LF
NB.       Fields within rows delimited by fd
NB.       Only contents of literal boxes in y are quoted.
NB.       Internal quotes are doubled if present.
NB. form: [fd[;sd0[,sd1]]] delimitarray arrayofboxes
NB. y is: boxed array of mixed type
NB. x is: literal list or 1 or 2-item boxed list of optional delimiters.
NB.       0{:: single literal field delimiter (fd). Defaults to 'TAB'
NB.   (1;0){:: (start) string delimiter (sd0). Defaults to '"'
NB.   (1;1){:: end string delimiter (sd1). Defaults to '""
delimitarray=: 3 : 0
  (TAB;'""') delimitarray y
  :
  'fd sd'=. 2{. boxopen x
  if. (#sd) +. -. *./ ,ischar 3!:0 &>y do. NB. if sd not empty or y not all boxed strings
    y=. sd enclosestrings y                NB. quote strings & non-strings to string
  end.
  dat=. LF joindsv ,<@(fd&joindsv)"1 y
  dat, (1<#$y)#LF                          NB. append LF for arrays rank >1
)

--------------------------------------------------
NB.*appenddsv v Appends an array to a delimiter-separated value file
NB. returns: number of bytes appended or _1 if unsuccessful
NB. form: dat appenddsv file[;fd[;sd0[,sd1]]]
NB. eg: (3 2$'hello world';4;84.3;'Big dig') appenddsv (jpath '~temp/test.csv');'|';'<>'
NB. y is: literal list or a 2 or 3-item list of boxed literals
NB.       0{ filename of file to append dat to
NB.       1{ optional field delimiter. Default is TAB
NB.       2{ optional string delimiters, sd0 & sd1. Defaults are '""'
NB. x is: a J array
appenddsv=: 4 : 0
 args=. boxopen y
  'fln fd sd'=. args,(#args)}.'';TAB;'""'
  dat=. (fd;sd) makedsv x
  dat fappends fln
)

NB. ---------------------------------------------------------
NB.*makedsv v Makes a delimiter-separated value string from an array
NB. returns: DSV string
NB.          Results of all arrays except empty have trailing LF
NB. form: [fd[;sd0[,sd1]]] makedsv array
NB. eg: ('|';'<>') makedsv  3 2$'hello world';4;84.3;'Big dig'
NB. y is: an array
NB. x is: literal(s), or 1 or 2-item boxed list of optional delimiters.
NB.       0{:: literal field delimiter(s) (fd). Defaults to TAB
NB.   (1;0){:: (start) string delimiter (sd0). Defaults to '"'
NB.   (1;1){:: end string delimiter (sd1). Defaults to '"'
NB. Arrays are flattened to a max rank of 2.
makedsv=: 3 : 0
  (TAB;'""') makedsv y
  :
  dat=. y=. ,/^:(0>. _2+ [:#$) y   NB. flatten to max rank 2
  dat=. y=. ,:^:(2<. 2- [:#$) y    NB. raise to min rank 2
  'fd sd'=. 2{. boxopen x
  if. 1=#sd do. sd=. 2#sd end.
  NB. delim=. ',';',"';'",';'","';'';'"';'"'
  delim=. fd ; (fd,}:sd) ; ((}.sd),fd) ; ((}.sd),fd,}:sd) ; '' ; (}:sd) ; }.sd

  NB. choose best method for column datatypes
  try. type=. ischar 3!:0@:>"1 |: dat
    if. ({.!.a: sd) e. ;(<a:;I. type){dat do. assert.0 end. NB. sd in field
    if. -. +./ type do.          NB. all columns numeric
      dat=. 8!:0 dat
      delim=. 0{ delim
    else.                        NB. columns either numeric or literal
      idx=. I. -. type
      if. #idx do.               NB. format numeric cols
        dat=. (8!:0 tmp{dat) (tmp=. <a:;idx)}dat
      elseif. 0=L.dat do.        NB. y is literal array
        dat=. ,each 8!:2 each dat
      end.
      dlmidx=. 2#.\ type         NB. type of each column pair
      dlmidx=. _1|.dlmidx, 4&+@(2 1&*) ({:,{.) type
      delim=. (#dat)# ,: dlmidx { delim
    end.
  catch.                         NB. handle mixed-type columns
    dat=. sd enclosestrings dat
    delim=. 0{ delim
  end.
  NB. make an expansion vector to open space between cols
  d=. 0= 4!:0 <'dlmidx'           NB. are there char cols that need quoting
  c=. 0>. (+:d)+ <:+: {:$dat      NB. total num columns incl delims
  b=. c $d=0 1                    NB. insert empty odd cols if d, else even
  dat=. b #^:_1"1 dat             NB. expand dat
  if. #idx=. I.-.b do.
    dat=. delim (<a:;idx)}dat     NB. amend with delims
  end.
  ;,dat,.(1=#$dat){LF;a:          NB. add EOL if dat not empty & vectorise
)

NB. ---------------------------------------------------------
NB.*writedsv v Writes an array to a delimiter-separated value file
NB. returns: number of bytes written (_1 if write error)
NB.          An existing file will be written over.
NB. form: dat writedsv file[;fd[;sd0[,sd1]]]
NB. eg: (i.2 3 4) writedsv (jpath ~temp/test);'|';'{}'
NB. y is: literal list or a 2 or 3-item list of boxed literals
NB.       0{ filename of file to append dat to
NB.       1{ optional field delimiter. Default is TAB
NB.       2{ optional string delimiters, sd0 & sd1. Defaults are '""'
NB. x is: an array
writedsv=: 4 : 0
  args=. boxopen y
  'fln fd sd'=. args,(#args)}.'';TAB;'""'
  dat=. (fd;sd) makedsv x
  dat fwrites fln
)
NB. =========================================================
NB. Verbs exported to z locale

appenddsv_z_=: appenddsv_pdsv_
delimitarray_z_=: delimitarray_pdsv_
fixdsv_z_=: fixdsv_pdsv_
joindsv_z_=: joindsv_pdsv_
makedsv_z_=: makedsv_pdsv_
makenum_z_=: makenum_pdsv_
makenumcol_z_=: makenumcol_pdsv_
readdsv_z_=: readdsv_pdsv_
writedsv_z_=: writedsv_pdsv_

NB.*assign2hdr v Assigns columns in table of boxed literals to noun
NB. form: [hdr] assign2hdr array
NB. returns: empty
NB. y is: an array of boxed literals
NB. x is: optional list of boxed literals to assign columns of y to.
NB.       default is to use first line of y as header.
NB. Converts column to numeric if conversion is possible for whole column
assign2hdr_z_=: 3 : 0
  'hdr dat'=. split y
  hdr assign2hdr dat
:
  hdr111=. uniqify_pdsv_ coerce2Name_pdsv_&.> x
  dat111=. |: makenumcol y
  idx111=. I. 2 ~: (3!:0)&> {."1 dat111
  erase 'x y'
  ((<<<idx111){hdr111)=: <"1 (<<<idx111) { dat111
  (idx111{hdr111)=: idx111 { dat111
  EMPTY
)
NB. =========================================================
NB. tables/csv
NB. Read/write comma-separated value data (*.csv) files
NB. Special case of tables/dsv addon.

require 'tables/dsv'

coclass 'pcsv'
coinsert 'pdsv'
NB. =========================================================
NB. Utils for csv

NB. ---------------------------------------------------------
stdpathsep=: '/'&(I.@(e.&'/\')@]})
getfnme=: #~ ([: *./\. '/'&~:)

NB. extcsv v adds '.csv' extension if none present
extcsv=: , ('.csv' #~ '.'&e. < 0 < #)@getfnme@stdpathsep
NB. =========================================================
NB. Converting from csv files/strings to J array

NB. ---------------------------------------------------------
NB.*chopcsv v Convert csv string to list of boxed strings
NB. returns: list of boxed literals
NB. form: chopcsv string
NB. eg: chopcsv '"hello world",4,84.3'
NB. y is: csv delimited string
chopcsv=: (',';'""')&chopstring

NB. ---------------------------------------------------------
NB.*fixcsv v Convert csv data into J array
NB. returns: array of boxed literals
NB. form: fixcsv dat
NB. eg: fixcsv '"hello world",4,84.3',LF,'"Big dig","hello world",4',LF
NB. y is: csv delimited string, rows delimited by LF
fixcsv=: (',';'""')&fixdsv

NB. ---------------------------------------------------------
NB.*readcsv v Reads csv file into a boxed array
NB. returns: array of boxed literals
NB. form: readcsv file
NB. eg: readcsv jpath '~temp/test.csv'
NB. y is: filename of file to read from
readcsv=: (',';'""')&readdsv@extcsv
NB. =========================================================
NB. Converting from J array to csv files/strings

NB. ---------------------------------------------------------
NB.*appendcsv v Appends an array to a csv file
NB. returns: number of bytes appended or _1 if unsuccessful
NB. form: dat appendcsv file[;fd[;sd0[,sd1]]]
NB. eg: (3 2$'hello world';4;84.3;'Big dig') appendcsv jpath '~temp/test.csv'
NB. y is: filename of file to write dat to
NB. x is: a J array
appendcsv=: 4 : 0
  x appenddsv (extcsv y);',';'""'
)

NB. ---------------------------------------------------------
NB.*makecsv v Makes a CSV string from an array
NB. returns: CSV string
NB. form: makecsv array
NB. eg: makecsv  3 2$'hello world';4;84.3;'Big dig'
NB. y is: an array
NB. Arrays are flattened to a max rank of 2.
makecsv=: (',';'""')&makedsv

NB. ---------------------------------------------------------
NB.*writecsv v Writes an array to a csv file
NB. returns: number of bytes written (_1 if write error)
NB.          An existing file will be written over.
NB. form: dat writecsv file
NB. eg: (i.2 3 4) writecsv jpath ~temp/test
NB. y is: filename of file to write dat to
NB. x is: an array to write as csv
writecsv=: 4 : 0
  x writedsv (extcsv y);',';'""'
)
NB. =========================================================
NB. Verbs exported to z locale

appendcsv_z_=:appendcsv_pcsv_
chopcsv_z_=:chopcsv_pcsv_
fixcsv_z_=:fixcsv_pcsv_
makecsv_z_=:makecsv_pcsv_
readcsv_z_=:readcsv_pcsv_
writecsv_z_=:writecsv_pcsv_
NB. general/misc/validate.ijs
NB. Data validation functions
NB. version: 1.0.0
NB.
NB. data validation
NB.
NB. verbs return 1 if true, 0 if false
NB.
NB. data type verbs check the data, not the internal representation.
NB. For example, 1j1-0j1 is considered boolean, though stored as complex.
NB.
NB. Examples:
NB.
NB.   5 10 inrange i.12
NB.
NB.   '()' isbalanced '(123(45))'

NB.* inrange      v  (low, high) inrange data
NB.* isbalanced   v  pair isbalanced string
NB.* isboolean    v  data is all 0 or 1
NB.* isboxed      v  is boxed
NB.* ischaracter  v  data is character
NB.* iscounter    v  data is non-negative integer (counting number)
NB.* iscomplex    v  data is complex
NB.* isdate       v  is date (as yyyy mm dd)
NB.* isempty      v  data is empty
NB.* isinteger    v  data is all integer
NB.* ismatrix     v  data is a matrix
NB.* isnumeric    v  data is numeric
NB.* isrational   v  data is rational
NB.* isreal       v  data is all real
NB.* isscalar     v  data is a scalar
NB.* isunicode    v  data is unicode (literal2 or literal4)
NB.* isliteral2   v  data is literal2
NB.* isliteral4   v  data is literal4
NB.* isunique     v  data has no duplicates
NB.* isutf8       v  text is valid UTF-8
NB.* isutf16      v  text is valid UTF-16
NB.* isvector     v  data is a vector

cocurrent 'z'

inrange=: ([: *./ (>: {.) , (<: {:))~
isbalanced=: [: (-: +/\. + 0: >. +/\) [: -/ =/

isboolean=: [: *./ , e. 0 1"_
isboxed=: 0: < L.
ischaracter=: 3!:0 = 2:
iscounter=: -: |@<.
isempty=: 0: e. $
isinteger=: (-: <.) :: 0:
isnumeric=: 3!:0 e. 1 4 8 16 64 128"_
isrational=: isinteger < 3!:0 = 128"_
isreal=: (-: +) :: 0:
iscomplex=: -. @ (-: +) :: 0:
isunicode=: 131072 262144"_ e.~ 3!:0
isliteral2=: 131072"_ = 3!:0
isliteral4=: 262144"_ = 3!:0
isunique=: -: ~.

isscalar=: 0: = #@$
isvector=: 1: = #@$
ismatrix=: 2: = #@$

isdate=: 3 : 0
'y m d'=. y
b=. *./(y=<.y),(_1 0 0<y),12>:m
day=. (13|m){0 31 28 31 30 31 30 31 31 30 31 30 31
day=. day+(m=2)*-/0=4 100 400|/y
b*d<:day
)

isutf8=: (2=3!:0) *. 1:@(7&u:) :: 0:
isutf16=: (131072=3!:0) *. 1:@(8&u:) :: 0:
NB. general/misc/numeric.ijs
NB. Various numeric utilities
NB. version: 1.0.0
NB.
NB.  baserep        y in base x
NB.  clean          clean y to tolerance of x (default 1e_10)
NB.  colsum         sum data columns of matrix by key
NB.  groupndx       group indices of y in x
NB.  int01          interval in n steps from 0 to 1 (= steps 0 1,n)
NB.  linsert        linear insert x (default 2) steps into y
NB.  randomize      sets a random value into random link
NB.  range          range from a to b [in steps of c]
NB.  recur          solves recurrence r(i)=a(i)+r(i-1)*m(i-1)
NB.  round          round y to nearest x (e.g. 1000 round 12345)
NB.  roundbanker    round y to nearest x with bankers rounding
NB.  rounddist      round y to nearest x preserving total
NB.  rounddown      round y down to nearest x
NB.  roundint       round to nearest integer
NB.  roundup        round y up to nearest x
NB.  steps          steps from a to b in c steps

cocurrent 'z'

NB.*baserep v y in base x
baserep=: (&#.) (^:_1)

NB.*int01 v interval in n steps from 0 to 1 (= steps 0 1,n)
int01=: i.@(+ *) % |

NB.*linsert v linear insert x (default 2) steps into y
linsert=: 2&$: : ([: +/\ {.@] , [ # (}. - }:)@] % [)

NB.*round v round y to nearest x (e.g. 1000 round 12345)
round=: [ * [: <. 0.5 + %~

NB.*rounddown v round y down to nearest x (e.g. 1000 round 12345)
rounddown=: [ * [: <. %~

NB.*roundint v round to nearest integer
roundint=: <.@:+&0.5

NB.*roundup v round y up to nearest x (e.g. 1000 round 12345)
roundup=: [ * [: >. %~

NB. =========================================================
NB.*clean v clean y to tolerance of x (default 1e_10)
NB. form: tolerance (default 1e_10) clean numbers
NB. sets values less than tolerance to 0
clean=: 1e_10&$: : (4 : 0)
if. L. y do.
  x clean each y
else.
  if. (3!:0 y) e. 16 16384 do.
    j./"1 y * x <: | y=. +.y
  else.
    y * x <: |y
  end.
end.
)

NB. =========================================================
NB.*colsum v sum data columns of matrix by key
NB. form: key colsum mat
NB. sum data columns of matrix on key columns
NB. e.g. if column 2 of mat is age, then
NB.    2 colsum mat
NB. sums the remaining columns by age
colsum=: 4 : 0
nub=. ~. key=. x{"1 y
nub /:~ nub x}"_1 1 key +//. y
)

NB. =========================================================
NB.*groupndx v group indices of y in x
NB. Return group indices of elements of y
NB. x is an integer vector of the starting numbers of each group,
NB. assumed to be in ascending order.
NB. e.g.  0 0 0 1 1 1 2 2  =  0 3 6 groupndx i.8
NB. i.e.  <:@(+/@(<:/))
NB. groupndx=: 4 : '<: (#x) }. (+/\r<#x) /: r=. /: x,y'
groupndx=: [: <: I. + e.~

NB. =========================================================
NB.*randomize v sets a random value into random link
randomize=: 3 : 0
 try.
   require 'guid'
   tmp=. _2 (3!:4) , guids 1
 catch.             NB. general/misc/guid.ijs not available
   tmp=. >:<.0.8*0 60 60 24 31#.0 0 0 0 _1+|.<.}.6!:0 ''
 end.
 ([ 9!:1) {.^:(2~:9!:42'') tmp    NB. set random initial random seed
)

NB. =========================================================
NB.*range v range from a to b [in steps of c]
NB. range a,b[,c] = range from a to b [in steps of c]
range=: 3 : 0
'x y n'=. 3{.y,1
s=. _1^y<x
x+s*n*i.>:<.n%~|y-x
)

NB. =========================================================
NB.*recur v solves recurrence r(i)=a(i)+r(i-1)*m(i-1)
NB. form: r = m recur a
NB.   r(0) = a(0)
NB.   r(i) = a(i)+r(i-1)*m(i-1)
NB. e.g    1.05 1.10 recur 100 100 100
NB.     100 205 325.5
recur=: 4 : 'r*+/\y%r=.*/\1,x$~<:#y'

NB. =========================================================
NB.*roundbanker v round y to nearest x with bankers rounding
NB.
NB. round y to nearest x
NB.
NB. if y is a mid point, it is rounded up if even, down if odd
NB.
NB.    0.1 roundbanker 1.23 2.15 2.25 2.35 2.45
NB. 1.2 2.2 2.2 2.4 2.4
roundbanker=: 4 : 0
rd=. <. d=. 0.5 + y % x
x * rd - (rd = d) > 0 = 2 | d
)

NB. =========================================================
NB.*rounddist v round y to nearest x preserving total
NB. distributive rounding
NB.
NB. round y to nearest x preserving total to nearest x
NB.
NB. e.g.
NB.    0.1 rounddist 6$0.45
NB. 0.5 0.4 0.5 0.4 0.5 0.4
rounddist=: 4 : 0
($y) $ x * (- 0 , }:) <. 0.5 + +/\ y % x
)

NB. =========================================================
NB.*steps v steps from a to b in c steps
NB. form: steps a,b,c
steps=: {. + (1&{ - {.) * (i.@>: % ])@{:
coclass 'jzplot'
require 'graphics/afm graphics/color/colortab graphics/bmp graphics/png math/misc/trig'

3 : 0''
if. 0 ~: 4!:0 <'JHSOUTPUT' do. JHSOUTPUT=: 'canvas' end.
if. 0 ~: 4!:0 <'CONSOLEOUTPUT' do. CONSOLEOUTPUT=: 'pdf' end.
if. 0 ~: 4!:0 <'IFTESTPLOTJHS' do. IFTESTPLOTJHS_z_=: 0 end.
if. IFTESTPLOTJHS +. IFJHS do.
elseif. IFQT do.
  require 'graphics/gl2'
  coinsert 'jgl2'
elseif. IFJA do.
  require 'graphics/gl2'
  coinsert 'jgl2'
  CONSOLEOUTPUT=: 'android'
elseif. ('jwin32';'jjava') e.~ < (11!:0) ::0: 'qwd' do.
  require 'graphics/gl2'
  coinsert 'jgl2'
elseif. do.
  if. 0 < #1!:0 jpath '~addons/graphics/gl2/gl2.ijs' do.
    require 'graphics/gl2'
    coinsert 'jgl2'
  end.
end.
if. 0 < #1!:0 jpath '~addons/graphics/cairo/cairo.ijs' do.
  require 'graphics/cairo'
  coinsert 'jcairo'
end.
coinsert 'jafm'
''
)
NOAXES=: 'axes 0;boxed 0;frame 0;grids 0;labels 0;tics 0;'
NOFRAME=: 'axes 1;frame 0'

KEYWORDS=: 'noaxes';'noframe'
EMPTY=: i.0 0
alfndx=: 3 & u:
assign=: 4 : '".x,''=:y'''
average=: +/ % #
blockcount=: [: {. }:@$ , 1:
boxrows=: >@(,.&.>/)@:(;/&.>)
cile=: $@] $ ((* <.@:% #@]) /:@/:@,)
citemize=: ,:^:(2 > #@$)
cleanz=: * | >: 1e_10"_
cmatch=: (#@[) $ citemize@]
cross=: +/ .* (3 3 3$0 0 0 0 0 _1 0 1 0 0 0 1 0 0 0 _1 0 0 0 _1 0 1 0 0 0 0 0)&(+/ .*)
cutxyz=: <"2@(0 1&|:)
deb=: #~ (+. 1: |. (> </\))@(' '&~:)
det=: -/ .*
dim0=: ]`({."1) @. (2=#&$)
dim1=: ]`{. @. (2=#&$)
dist=: +/&.(*:"_)
dlb=: }.~ =&' ' i. 0:
dquote=: '"'&,@(,&'"')
dquoted=: 2+./\0,2|+/\@(=&'"')
drange=: {:-{.
each=: &.>
extbmp=: , ((0 < #) *. [: -. '.'"_ e. ]) # '.bmp'"_
extemf=: , ((0 < #) *. [: -. '.'"_ e. ]) # '.emf'"_
extjpf=: , ((0 < #) *. [: -. '.'"_ e. ]) # '.jpf'"_
extpng=: , ((0 < #) *. [: -. '.'"_ e. ]) # '.png'"_
findprefixes=: +./"1 @: ([ = (#@>@[) {.each ])"0 1
first=: >@{.
firstin=: e. {.@# [
firstones=: > 0: , }:
firstword=: {.~ i.&' '
fit01=: ((- <./@,) % (>./ - <./)@,) : ((] - {.@[) % -~/@[)
fitin=: {.@[ + ({: - {.)@[ * ((- <./@,) % (>./ - <./)@,)@]
fix=: _1&".
has=: [: +./ (e.~ boxopen f.)
head=: {.~ i.&' '
hostcmd=: [: 2!:0 '(' , ,&' || true)&'
index=: [ ((#@[ = ]) { ] , _1:) i.
int01=: i.@>: % ]
intersect=: e. # [
inxb=: <:@(+/\) i. i.@(+/)
isboxed=: 0 < L.
ischar=: 3!:0 e. 2 131072 262144"_
is1color=: 3 = */ @ $
iscomplexdata=: 3!:0 e. 16 16384"_
iscounter=: -: |@<.
isempty=: 0 e. $
isinteger=: -: <.
islinear=: *./@(= {.)@(}. - }:)
islocale=: {. @ (e. 18!:1 @ 1:)
lastone=: </\ &. |.
lastones=: > }. , 0:
log10=: 10&^.
lsfit=: {:@] %. {.@] ^/ i.@>:@[
matsize=: _2 {. 1 1 , $
mp=: +/ . *
nc=: 4!:0
packs=: (, ,&< ".) &>
pdefs=: 3 : '0 $ ({."1 y)=: {:"1 y'
pbuf=: 3 : 'buf=: buf,,y,"1 LF'
pick=: >@{
pickf=: 2 : 'u @ > @ (n&{)'
pow10=: 10&^
scale01=: (% {:) @: (0: , +/\)
splits=: i.&' ' ({.;}.@}.) ]
nthword=: +/\@(> 0 , }:)@(~:&' ')@] i. >:@[
partition=: 1 , [: -. }: -:"_1 }.
rank=: #@$
rank01=: 2 > [: # $
rfd=: *&1r180p1
rnd=: [ * [: <. 0.5"_ + %~
rndint=: <.@:+&0.5
rnddn=: [ * [: <. %~
rndup=: [ * [: >. %~
signal=: 13!:8&12
tail=: }.~ >:@(i.&' ')
tolist=: }.@;@:((10{a.)&,@,@":&.>)
tominus=: '-' & (([: I. ] e. '_'"_)})
towords=: ;: ^: _1
u2a=: (1 u: 7 u: ]) :: ]
unitvec=: % dist
zero=: * | >: 1e_10"_

sin=: 1&o.
cos=: 2&o.
boxarg=: 3 : 0
ws=. 8 9 10 13 32 44{a.
del=. 34 127{a.
dat=. ' ',y
b=. (dat e. ws) > ~:/\ dat e. del
dat=. (<'') -.~ b <;._1 dat
dat -. each <del
)

boxascii=: ]
check_epsreader=: 3 : 0
check_reader y
)
check_pdfreader=: 3 : 0
check_reader y
)
check_reader=: 3 : 0
ndx=. 1 i.~ ' -' E. y
flexist ndx {. y
)
comma2blank=: 3 : 0
' ' (I. y=',') } y
)
commasep=: 3 : 0
',' (I. y=' ') } y
)
chop=: 3 : 0
y chop~ (' ',LF) {~ LF e. ,y
:
if. 2>#$y
do.
  (<'') -.~ (y e.x) <;._2 y=. y,{.x
else.
  |: &.> y -. {: y=. (*./y e.x) <;._2 |: y=. y,"1 [ 2${.x
end.
)
cubicspline=: 3 : 0
diff=. }.-}:
'x y'=. y
h=. diff x
k=. diff y
w=. 3 * diff k % *: h
n=. +:(2}.x)-_2}.x
sm=. ,~_2+#x
m=. sm$}.,(sm+0 1){.(}:h),.n,.}.h
c=. 0,w %. m
a=. }:y
b=. (k%h) - h * ((+:c) + }.c,0) % 3
d=. (diff c,0) % 3 * h
(}:x);a,.b,.c,.d
)
interspline=: 4 : 0
'i m'=. x
n=. <: +/ i <:/ y
(n{m) p. y-n{i
)

cut=: 4 : 'a: -.~ (y e.x) <;._2 y=. y,{.x'
cutopen=: 3 : 0
y cutopen~ (' ',LF) {~ LF e. ,y
:
if. L. y do. y return. end.
if. 1 < #$y do. <"_1 y return. end.
(<'') -.~ (y e.x) <;._2 y=. y,{.x
)
dictget=: 4 : 0
(({."1 y) i. x) { ({:"1 y),<''
)
facenormal=: 4 : 0
norm=. x * unitvec (}:cross&(-/)}.) 3{.y
norm + (+/y) % #y
)
getangle=: arctan@% + o.@(] < 0:)
ifjwplot=: 3 : 0
('plot' -: PForm) *. 'jwplot' -: > coname''
)
ifparent=: 3 : 0
(<y) e. 1 {"1 pforms''
)
ifplotf=: 3 : 0
2 e. 3!:0 (S:0) _1 pick y
)
info=: 3 : 0
sminfo@('Plot'&;) :: smoutput y
)
interp01=: 3 : 0
y=. y * <: #x
b=. x {~ <.y
t=. x {~ >.y
k=. y - <.y
(t*k) + b*-.k
)
keyarg=: 3 : 0
dat=. ;: tolower y
msk=. dat e. KeyOpts
({. &> msk # dat), ;(-.msk) # dat
)
maxmask=: 4 : 0
rem=. y-x
if. 0 >: rem do. 1
elseif. rem <: x do.
  1 ,~ (<:y)$((rndint x%rem)$1),0
elseif. 1 do.
  1 ,~ (<:y)$1,(rndint rem%x)$0
end.
)
mfv=: 4 : 0
if. 2>#$y do.
  ];._2 y,x #~ x ~: _1{.x,y
else.
  y
end.
)
ncile=: 4 : 0
min=. <./,y
max=. >./,y
step=. }: min+(max-min)*(i.>:x)%x
<: +/ step <:/ y
)
plenfrom=: 4 : 0
x {.each (0,+/\}:x) }.each <y
)
pfmt=: 3 : 0
dat=. ": 0.0001 round y
txt=. ,dat
($dat) $ '-' (I. txt='_') } txt
)
pfmtjs=: 1&$: : (4 : 0)
dat=. 0.0001 round y
txt=. , dat=. commasep@(('('&,)@(,&')')^:x)@":"1 dat
($dat) $ '-' (I. txt='_') } txt
)
pforms=: 3 : 0
if. 0=# z=. <;._2;._2 @ wdqpx '' do. z=. 0 6$<'' end.
z
)
qchop=: 3 : 0
q=. dquoted y
s=. ' '=y
qs=. q*.s
y=. DEL (inxb qs)}y
dltb@unquot@((DEL,' ')&charsub)@deb each chop y
)
query=: 4 : 0
x ((wdquery 'Plot'&;) :: (1: smoutput)) y
)
range=: 3 : 0
'x y n'=. 3{.y,1
s=. _1^y<x
x+s*n*i.>:<.n%~|y-x
)
rotxy=: 4 : 0
rot=. 2 2$ 1 1 _1 1 * 0 1 1 0 { 2 1 o. x
rot +/ . * "2 1 y
)
smooth=: (cubicspline@:(,:~ i.@#) interspline i.&.(4&*)@#)"1
steps=: {. + (1&{ - {.) * (i.@>: % ])@{:
unquot=: 3 : 0
'" ' charsub y
)
selectpid=: 3 : 0
if. 0~: (0&". ::]) PIdhwnd do.
  glsel ":PIdhwnd
elseif. #PId do.
  glsel PId
end.
)
isigraph_event=: 4 : 0
evt=. >@{.y
syshandler=. PForm, '_handler'
sysevent=. PForm,'_',PId,'_', evt
sysdefault=. PForm, '_default'
if. 1=#y do.
  wdd=. ;: 'syshandler sysevent sysdefault'
elseif. 2=#y do.
  sysdata=. ": >1{y
  wdd=. ;: 'syshandler sysevent sysdefault sysdata'
elseif. 3=#y do.
  sysdata=. ": >1{y
  sysmodifiers=. ": >2{y
  wdd=. ;: 'syshandler sysevent sysdefault sysdata sysmodifiers'
end.
wdqdata=. (wdd ,. ".&.>wdd)
evthandler wdqdata
0
)
rectcenter=: 2&{. + -:@(2 3&{)
angle2=: [: r.^:_1 *@(j./)"1
g0=. }:"1
g1=. (1 2&{ - 0 0&{)"2
g2=. 0: < -/"1 @: ({. * |. @: {:)"2
facing=: g2 @: g1 @: g0 f.
boxrs2wh=: 3 : 0
a=. 2 {."1 y
b=. 2 }."1 y
(a <. b) ,"1 >: | a - b
)

boxwh2rs=: 3 : 0
a=. 2 {."1 y
b=. 2 }."1 y
a,"1 a + b
)
colorxy=: 4 : 0
x=. (i. >: x) % x
x=. x * <: #y
b=. y {~ <.x
t=. y {~ >.x
k=. x - <.x
<. 0.5 + 255 * (t*k) + b*-.k
)
fonargs=: 2 : 0
v (, (u&.>)`(u"0/&.>/)@.(<:@#))@(<^:(-.@*@L.)) y
:
x v (, (u&.>)`(u"0/&.>/)@.(<:@#))@(<^:(-.@*@L.)) y
)
getbandcolor=: 3 : 0
ndx=. y - <./ y
ndx=. <. 0.5 + ndx * (<:#BANDCOLOR) % >./ ndx
ndx { BANDCOLOR
)
getitemcolor=: 3 : 0
y $ DataNdx |. ITEMCOLOR
)
getsquarebox=: 3 : 0
'x y w h'=. y
min=. w <. h
x=. x + <. -: w - min
y=. y + <. -: h - min
x,y,min,min
)
getpieframes=: 3 : 0
'Fx Fy Fw Fh'=: Fxywh=: Lxywh
'Gx Gy Gw Gh'=: Gxywh=: Lxywh
)
grays=: 3 : 0
3#"0 [ 255<. <. (256&% * i.@>:) y
)
linepattern1=: 4 : 0
len=. - -/ y
n=. rndint (%: +/ *: len) % +/ x
if. n=0 do. y
else.
  j=. +/\ 0 , , n # ,: x
  |: ({.y) + len */ (}: % {:) j
end.
)
linepattern2=: 4 : 0
len=. - -/ y
n=. rndint (%: +/ *: len) % +/ x
if. n=0 do. y
else.
  j=. +/\ 0 , , n # ,: x
  |: ({.y) + len */ (% {:) }: j
end.
)
linepattern=: 4 : 0
nap=. ,`[@.('' -: ])`]@.('' -: [)
x=. > x
y=. _2 [\ y
if. x -: 1 0 do.
  <. 2 ,\ y
else.
  a=. ; 2 < @ (x&linepattern1) \ }: y
  <. _2 ,\ a nap x linepattern2 _2 {. y
end.
)
logcheck=: 4 : 0
if. x do. if. 1 e. 0 >: ,y do.
    signal 'Log argument to plot must be positive'
    signal 'plot error' end.
end.
y
)
numcheck=: 3 : 0
if. (ischar y) +: 0 e. $y do. y return. end.
if. ischar y
do. signal 'data should be numeric'
else. signal 'no data to plot'
end.
)
project=: 3 : 0
dat=. }:"1 (y,.1) mp Tfm
dist=. ViewDist-{:"1 dat
((ViewDist*}:"1 dat)%dist),.dist
)
rectoverlap1=: 4 : 0
'lx ly lw lh'=. x
'rx ry rw rh'=. y
((lx>:rx+rw)+.rx>:lx+lw) +: (ry<:ly-lh)+.ly<:ry-rh
)
rectoverlaps=: 3 : 0
'x y w h'=. |: y
xr=. x+w
yt=. y+h
((x>1|.xr)+.xr<1|.x) +: (yt>1|.y)+.y<1|.yt
)
setbox=: 3 : 0
Plot=: Plot,Ndx;0;'draw';'';'';BACKCOLOR;'';y;0
)
setbrush=: [: ';grgb '&, ": , ';gbrush'"_
setdxywh=: 3 : 0
'Dx Dy Dw Dh'=: Dxywh=: y
Gxywh=: Fxywh=: Lxywh=: y
)
setsubdxywh=: 3 : 0
setdxywh Sxywh makepos_xywh y
)
popsxywh=: 3 : 0
if. #SSxywh do.
  'm x s'=. {: SSxywh
  SSxywh=: }: SSxywh
  'Sx Sy Sw Sh'=: Sxywh=: s
  Mxywh=: m
  Mndx=: x
end.
)
pushsxywh=: 3 : 0
SSxywh=: SSxywh, Mxywh;Mndx;Sxywh
'mat win'=. y
'Sx Sy Sw Sh'=: Sxywh=: win
Mxywh=: mat
Mndx=: 0
)
setoutput=: 3 : 0
Poutput=: y
setsizes''
)
setgxywh=: 3 : 0
'Gx Gy Gw Gh'=: Gxywh=: y
)
setlxywh=: 3 : 0
'Lx Ly Lw Lh'=: Lxywh=: y
)
setpxywh=: 3 : 0
if. isempty Pxywh do. IPxywh=: y end.
'Px Py Pw Ph'=: Pxywh=: y
'Sx Sy Sw Sh'=: Sxywh=: y
'Dx Dy Dw Dh'=: Dxywh=: y
Mxywh=: i.0 0
Mndx=: 0
SSxywh=: i.0 3
)
setp=: 3 : 0
Plot=: Plot,Ndx;y
)
showboxes=: 3 : 0
a=. 'Pxywh','Dxywh','Oxywh','Lxywh','Fxywh','Gxywh',:'Kxywh'
b=. Pxywh,Dxywh,Oxywh,Lxywh,Fxywh,Gxywh,:Kxywh
b=. b ,. +/ "2 [ _2 ([\) "1 b
r=. a; b
(- 0 = +/Kxywh) }. each r
)
shownouns=: 3 : 0
rnd=. <.@:+&0.5&.(%&0.0001)
cat=. ,&,.&.|:
x=. (>:>./# &> y) {. each y
f=. ]`rnd @. (e.&8 @ (3!:0))
y=. ":@f@". each y
r=. x cat each y
> ,&.>/ r
)
showplot=: 3 : 0
hdr=. ;:'order type item value style fit pen brush pos'
itm=. tolower each }. each (;2 {"1 Plot) { ItemNames
dat=. itm 2 }"0 1 Plot
stk=. hdr,dat
tc=. 31&<.@$ {.!.'.' ({.~ 30&<.@$)
tc@": &.>stk
)

viewplot=: 3 : 'wdview boxascii showplot y'
showopts=: 3 : 0
shownounds DefOpts
)
showstate=: 3 : 0
(showboxes''),showopts''
)
shrinksquare=: 4 : 0
x + y * 1 1 _2 _2
)
shrinkrect=: 4 : 0
x + , 1 _1 * +/\ _2 [\ 4 $ y
)
stellate=: 4 : 0 "2
norm=. x * unitvec (}:cross&(-/)}.) 3{.y
norm=. norm + (+/y) % #y
2 (norm&,)\y,{.y
)
surfacerev=: 10&$: : (4 : 0)
'r z'=. |: y
ix=. i. x+2
'x y'=. 0 1 |: r */ +. r. ix * 2p1%x
x,"0 1 y,"0 z
)
straddle=: 3 : 0
y*1.1*(y<0),y>:0
)
c=. (}: ,:"1 }.)"2
d=. (}. ,:"1 }:)"2
tiles=: (c@}: ,"2 d@}.) f.
tilesum=: (1,:2 2)&(+/@,;._3)
". toupper COLORTABLE
STDCLR=: _3[\BLUE,RED,GREEN,PURPLE,FUCHSIA,OLIVE,TEAL,YELLOW,TAN,AQUA,BROWN,GRAY
CLR16=: RED,BLUE,GREEN,AQUA,FUCHSIA,LIME,YELLOW,BROWN,TEAL,MAROON,NAVY,OLIVE,SILVER,GRAY,BLACK,:WHITE
RBCLR=: 64 colorxy 1 0 0,:0.5 0 0.5
RGCLR=: 64 colorxy 0 0.5 0.5, 0 0.75 0 ,: 1 0 0
RGBCLR=: 64 colorxy |."1 #:7|3^i.6
BGCLR=: 64 colorxy 0.25 0.95 0.3 ,: 0.25 0.25 1
GRAYSCALE=: 1 (3&#)\ <. 0.5 + 255 * 0.01 * i.101
flexist=: 1:@(1!:4)@< :: 0:
flread=: 1!:1 @ <
flwrite=: (1!:2 <) :: _1:
flwrites=: (toHOST@[ 1!:2 <@]) :: _1:
flwritenew=: 4 : 0
dat=. ,x
if. -. dat -: flread :: 0: y do. dat flwrite y end.
EMPTY
)
fitframexy=: 3 : 0
s=. $y
(s $ Fx,Fy) + y * s $ Fw,Fh
)
fitgrafx=: 3 : 0
Gx + Gw * y
)
fitgrafxy=: 3 : 0
s=. $y
(s $ Gx,Gy) + y * s $ Gw,Gh
)
fitgrafxywh=: 3 : 0
s=. $y
(s $ Gx,Gy,0 0) + y * s $ Gw,Gh
)
fitgrafxy3d=: 3 : 0
Min3d=: Min3d <. <./y
Max3d=: Max3d >. >./y
fitgrafxy3d1 y
)
fitgrafy=: 3 : 0
Gy + Gh * y
)
fit3d=: 3 : 0
pos=. fitxyz y
pos=. }:"1 project pos
fitgrafxy3d1 pos
)
fitgrafxy3d1=: 3 : 0
(Gx,Gy) +"1 (y -"1 Min3d)*"1 (Gw,Gh) % Max3d-Min3d
)
flipyarc=: 3 : 0
y=. _8[\,y
c=. Ch - (+/"1 [ 1 3{"1 y) ,. 5 7{"1 y
($y) $ ,c 1 5 7}"1 y
)
flipxy=: 3 : 0
s=. $y
(s $ 0, Ch) + y * s $ 1 _1
)
flipyrect=: 3 : 0
y=. _4 [\, y
c=. Ch - +/"1 [ 1 3{"1 y
($y) $ ,c 1}"0 1 y
)
get01x=: 3 : '(y - XMin) % XMax-XMin'
get01y=: 3 : '(y - YMin) % YMax-YMin'
getgrafx=: fitgrafx @ get01x
getgrafy=: fitgrafy @ get01y
getgrafmat=: 3 : 0
'x y'=. 2 {. y { Data
,"2 (getgrafx x) ,."1 citemize getgrafy y
)
getgrafxy=: 3 : 0
'x y'=. 2 {. y { Data
(getgrafx x) ; getgrafy y
)
movepos=: [ + $@[ $ ]
scalepos=: [ * $@[ $ ]
text2utf8=: 3 : 0
if. isutf8 y do. y return. end.
if. 2 ~: 3!:0 y do. utf8 y return. end.
val=. a. i. y
msk=. 127 < val
uni=. 192 128 +"1 [ 0 64 #: msk # val
val=. val #~ 1 j. msk
ndx=. I. 127 < val
a. {~ uni (<"0 ndx +/ 0 1) } val
)
text2ascii8=: 3 : 0
if. isutf8 y do.
  1 u: ucp y
else.
  y
end.
)
baserep=: (&#.) (^:_1)
NB.!!!
linsert=: 2&$: : ([: +/\ {.@] , [ # (}. - }:)@] % [)
round=: [ * [: <. 0.5 + %~
rounddown=: [ * [: <. %~
roundint=: <.@:+&0.5
roundup=: [ * [: >. %~
clean=: 1e_10&$: : (4 : 0)
if. L. y do.
  x clean each y
else.
  if. (3!:0 y) e. 16 16384 do.
    j./"1 y * x <: | y=. +.y
  else.
    y * x <: |y
  end.
end.
)
colsum=: 4 : 0
nub=. ~. key=. x{"1 y
nub /:~ nub x}"_1 1 key +//. y
)
groupndx=: [: <: I. + e.~
randomize=: 3 : 0
([ 9!:1) >:<.0.8*0 60 60 24 31#.0 0 0 0 _1+|.<.}.6!:0 ''
)
range=: 3 : 0
'x y n'=. 3{.y,1
s=. _1^y<x
x+s*n*i.>:<.n%~|y-x
)
recur=: 4 : 'r*+/\y%r=.*/\1,x$~<:#y'
roundbanker=: 4 : 0
rd=. <. d=. 0.5 + y % x
x * rd - (rd = d) > 0 = 2 | d
)
rounddist=: 4 : 0
($y) $ x * (- 0 , }:) <. 0.5 + +/\ y % x
)
steps=: {. + (1&{ - {.) * (i.@>: % ])@{:
coclass 'jzplot'
create=: pdreset
destroy=: codestroy
IFJNET=: (IFJNET"_)^:(0=4!:0<'IFJNET')0
FontScale=: 1
FontSizeMin=: 0
MaxAxisInt=: 0.9
MaxData=: _
PCmd=: ''
Data=: ''
PForm=: 'plot'
Ch=: Cw=: 0
PId=: 'gs'
PIdhwnd=: 0
Plot=: i. 0 0
PFormhwnd=: 0[''
Poutput=: _1
Printer=: 0
PReset=: 0
PText=: ''
PTop=: 0
PShow=: 0
Pxywh=: ''
PStyle=: ''
TypeRest=: ''
('i',each ;: 'LEFT CENTER RIGHT')=: i. 3
j=. ;: ' EPS PDF CANVAS CAIRO ANDROID QT ISI'
('i' ,each j)=: i.#j
j=. 'i' ,each cutopen toupper 0 : 0
background
border
box
frame
gd
key
rule
subtitle
text
title
xaxis
xcaption
xgrid
xlabel
xtics
yaxis
ycaption
ygrid
ylabel
ytics
y2caption
y2label
y2tics
zaxis
zcaption
zgrid
zlabel
ztics
data
)

ItemNames=: j
(ItemNames)=: i.#ItemNames
readplotdefaults=: 3 : 0
MyPlotDefaults=: flread :: (''"_) jpath '~config/plotdefs.ijs'
)
setplotdefaults=: 3 : 0
select. y
fcase. 'plot' do.
  COLOR=: ''
  IfBar=: IfPie=: 0
  Ndx=: 1
  PCmd=: i.0 0
  PForm=: 'plot'
  Pxywh=: ''
  Types=: ''
fcase. 'new' do.
  IfInit=: 0
  IfMulti=: 0
  0!:100 PlotDefaults
  0!:100 MyPlotDefaults
  ((<'Y2') ,each AxisOpts)=: ". each 'Y' ,each AxisOpts
fcase. do.
  CLEAR=: 1
  BrushColor=: 255 255 255
  Data=: Frame=: Rule=: Text=: ''
  DataRep=: 1
  DimType=: 2
  Gcmd0=: i.0 0
  Gcmd1=: i.0 0
  Opts=: <i.0 0
  Pen=: 1 0
  PenColor=: 0 0 0
  PText=: i. 0 0
  XDiv=: YDiv=: Y2Div=: ZDiv=: 0
  XMax=: YMax=: Y2Max=: ZMax=: Max3d=: __
  XMin=: YMin=: Y2Min=: ZMin=: Min3d=: _
end.
if. -. IFTESTPLOTJHS +. IFJHS +. IFQT +. IFJA +. ('jwin32';'jjava') e.~ < (11!:0) ::0: 'qwd' do.
  if. IFQT do.
    r=. 'OUTPUT=: ''qt'''
  elseif. IFJA do.
    r=. 'OUTPUT=: ''android'''
  elseif. ('jwin32';'jjava') e.~ < (11!:0) ::0: 'qwd' do.
    r=. 'OUTPUT=: ''isi'''
  elseif. ('cairo' -: CONSOLEOUTPUT) do.
    r=. 'OUTPUT=: ''cairo'''
  elseif. do.
    r=. 'OUTPUT=: ''pdf'''
  end.
end.
EMPTY
)
opts=. ;: ;._2 (0 : 0)
ASPECT N
AXES V
AXISCOLOR X
BACKCOLOR X
BANDCOLOR Y
BARWIDTH N
BORDER N
BORDERSIZE N
BOXED N
CAPTIONCOLOR X
CAPTIONFONT F
CLEAR N
COLOR Y
CONTOURLEVELS N
EDGECOLOR X
EDGESIZE N
FONTSCALE N
FONTSIZEMIN N
FORECOLOR X
FRAME N
FRAMEBACKCOLOR X
FRAMESTYLE C
GRAPHBACKCOLOR X
GRIDCOLOR X
GRIDS V
GRIDPATTERN V
GUIDESIZE N
ITEMCOLOR Y
KEY A
KEYCOLOR Y
KEYFONT F
KEYMARKERS S
KEYPOS K
KEYSTYLE K
KEYTITLE M
LABELCOLOR X
LABELFONT F
LABELS V
MARKERS S
MARKERSIZE N
MESH N
ORIENTATION N
OUTPUT C
PENPATTERN W
PENSIZE N
PENSTYLE V
PIEPERCENT N
PLOTCAPTION C
POLAR N
PRINTMARGIN V
PRINTWINDOW C
PSHOW C
RTIC V
RULECOLOR X
RULESIZE N
SEPARATOR C
SHOWBOXES N
ORIGINXLABEL N
SINGTOLER N
SUBTITLE D
SUBTITLECOLOR X
SUBTITLEFONT F
SUBTITLESTYLE C
SYMBOLCOLOR X
SYMBOLFONT F
SYMBOLS C
TEXTCOLOR X
TEXTFONT F
TICMAJOR N
TICMINOR N
TICS V
TICSTYLE C
TITLE D
TITLECOLOR X
TITLEFONT F
TITLESTYLE C
TYPE B
VIEWCENTER V
VIEWPOINT V
VIEWSIZE V
VIEWUP V
VISIBLE N
XCAPTION C
XCAPTIONSTYLE C
XGRIDPATTERN V
XFUNCRES N
XINT N
XLABEL A
XLABELSTYLE C
XLOG N
XRANGE V
XGROUP V
XTIC V
XTICPOS V
Y2AXIS C
YCAPTION C
YCAPTIONSTYLE C
YGRIDPATTERN V
YFUNCRES N
YINT N
YLABEL A
YLABELSTYLE C
YLOG N
YRANGE V
YTIC V
YTICPOS V
Y2CAPTION C
Y2CAPTIONSTYLE C
Y2LABEL A
Y2LABELSTYLE C
Y2LOG N
Y2RANGE V
YGROUP V
Y2TIC V
Y2TICPOS V
ZCAPTIONSTYLE C
ZGRIDPATTERN V
ZINT N
ZLABEL A
ZLABELSTYLE C
ZLOG N
ZRANGE V
ZGROUP V
ZTIC V
ZTICPOS V
)

DefOpts=: {."1 opts
DefOptx=: ,>{:"1 opts

j=. {.&> DefOpts
AxisOpts=: }. each DefOpts #~ j e. 'X'
AxisCmds=: DefOpts #~ j e. 'XYZ'
PlotOpts=: <;._2 (0 : 0)
FONTSCALE
FONTSIZEMIN
KEY
KEYCOLOR
KEYFONT
KEYPOS
KEYSTYLE
KEYTITLE
SUBTITLE
SUBTITLECOLOR
SUBTITLEFONT
SUBTITLESTYLE
TITLE
TITLECOLOR
TITLEFONT
TITLESTYLE
VIEWCENTER
VIEWPOINT
VIEWSIZE
VIEWUP
VISIBLE
)
FontOpts=: <;._2 (0 : 0)
CAPTIONFONT
FONTSCALE
FONTSIZEMIN
KEYFONT
LABELFONT
SUBTITLEFONT
TITLEFONT
)
PDefNames=: <;._2 (0 : 0)
Data
DataRep
DimData
DimType
Frame
Gcmd0
Gcmd1
Opts
Rule
Text
Types
TypeMsk
YAxes
Y2Msk
ASPECT
AXES
CAPTIONFONT
FRAME
FRAMESTYLE
GRIDS
LABELFONT
LABELS
PIEPERCENT
RTIC
TICMAJOR
TICMINOR
TICS
TICSTYLE
TYPE
XCAPTION
XCAPTIONSTYLE
XINT
XLABEL
XLABELSTYLE
XLOG
XRANGE
XTIC
XTICPOS
Y2AXIS
YCAPTION
YCAPTIONSTYLE
YINT
YLABEL
YLABELSTYLE
YLOG
YRANGE
YTIC
YTICPOS
Y2CAPTION
Y2CAPTIONSTYLE
Y2LABEL
Y2LABELSTYLE
Y2LOG
Y2RANGE
YGROUP
Y2TIC
Y2TICPOS
ZCAPTIONSTYLE
ZINT
ZLABEL
ZLABELSTYLE
ZLOG
ZRANGE
ZGROUP
ZTIC
ZTICPOS
)

('p' ,each PDefNames)=: i.#PDefNames
PlotfNames=: <;._2 (0 : 0)
SINGTOLER
XFUNCRES
YFUNCRES
)
plotconvertstringtogerund_z_=: 3 : 0"0 _ 0
if. +./ ((,'y');'y.') e. ;: >y do.
  {. ''`(13 : (>y) f.)
else.
  {. ''`(13 : ('(' , (>y) , ') y') f.)
end.
:
if. +./ ((,'y');'y.') e. ;: >y do.
  {. ''`(13 : (>y) f.)
else.
  {. ''`(13 : ('x (' , (>y) , ') y') f.)
end.
)
plotdefverbm=: 4 : 0
locale=. x
if. 32 ~: 3!:0 gerund=. y do.
  boxs=. <@('`'"_^:(-.@*@#));._1@('`'&,) y
  specs=. (<@;;.1~ (1&(0}))@(*. |.!.0)@:(#@$@>)) boxs
  gerund=. plotconvertstringtogerund__locale specs
end.
locale ,&< gerund
)
plotdefverbd=: 4 : 0
locale=. x
if. 32 ~: 3!:0 gerund=. y do.
  boxs=. <@('`'"_^:(-.@*@#));._1@('`'&,) y
  specs=. (<@;;.1~ (1&(0}))@(*. |.!.0)@:(#@$@>)) boxs
  gerund=. '' plotconvertstringtogerund__locale specs
end.
locale ,&< gerund
)
plotsubd=: 3 : 0"1
(PlotfNames)=: PlotfDefs
origlocale=: 0 {:: > {: y
gerund=. 1 {:: > {: y
res=. 0$a:
if. 2 = #y do.
  y=. boxopen"1^:(3:<{:@$) 0 {:: y
  pfmody=: ]`(^.) @. XLOG
  pfmodz=: ]`(^.@:(0&>.)) @. YLOG
  for_n. gerund do.
    plotf_userverb_z_=: (; # (((%~,[) #) ($,) ]) (n`:6))
    d=. plotfn y
    if. (1 < #d) *. 0 = #YRANGE do.
      mtone1=. (<./@:((i.&0@:(2&(<:/\)) >. i.&0@:(2&(>:/\)))"1))@(1&{::)"1 d
      mtonen=. (>./@:((i:&0@:(0&,)@:(2&(<:/\)) <. i:&0@:(0&,)@:(2&(>:/\)))"1))@(1&{::)"1 d
      quintiles=. ((((+ {.)~ i.&1@:<: [) , ((-~ {:)~ i:&1@:>: [)) %&(1.01 >. SINGTOLER)@({:-{.))@(0&{::)"1 d
      intvl=. 0 _,."1 -~/\"1 (> 2{"1 d) {"0 1 (0 ,. {:@$@> 1{"1 d) ,"0 (mtone1,.mtonen) <.&.(1 _1&*"1) quintiles
      extremes=. (<./&.:(1 _1&*"1)) ; intvl <@:(((<./"1^:2 , >./"1^:2);.0 (1)&{::)"2 1) d
      allextremes=. (<./&.:(1 _1&*"1)) ; <@:((<./"1^:2 , >./"1^:2)@:(1&{::)"1) d
      if. allextremes >&(-~/) 2 * extremes do.
        oor=. (<extremes) +./@(<:/"1@:(<:"1 0))&.> 1{"1 d
        oormsk=. (2{"1 d) +:/@(*. (*./\ ,: *./\.))&.> oor
        d=. oormsk #"1&.>"0 1 (2){."1 d
      end.
    end.
    res=. res , < 2 {."1 d
  end.
else.
  x=. boxopen"1^:(3:<{:@$) 0 {:: y
  y=. boxopen"1^:(3:<{:@$) 1 {:: y
  pfmodx=: ]`(^.) @. XLOG
  pfmody=: ]`(^.) @. YLOG
  pfmodz=: ]`(^.) @. ZLOG
  for_n. gerund do.
    plotf_userverb_z_=: ([ ; ] ; (n`:6)"0 _)
    res=. res , < x plotfn y
  end.
end.
res
)
plotfn=: 3 : 0
if. 0 = L. y do.
  y=. ,:^:(2-#$y) y
  y=. (pfmody 2 {."1 y) ,"1 (2) }."1 y
  if. 0 = #yrange=. XRANGE do. yrange=. 0 1{"0 _1 (<./ ,: >./) y end.
  if. 0 = #sres=. XFUNCRES do. sres=. 2 * 2 { Dxywh end.
  pfresy=: (| -/ yrange) % sres
  ; <@plotfiy y
else.
  plotf_userverb__origlocale&> ,y
end.
:
x=. <@(pfmodx^:_1)@:steps@(pfmodx@(2&{.) , {.@(,&25)@(2&}.))"1^:(0:=L.) x
y=. <@(pfmody^:_1)@:steps@(pfmody@(2&{.) , {.@(,&25)@(2&}.))"1^:(0:=L.) y
; x plotf_userverb__origlocale&.>/ y
)
plotfiy=: 3 : 0 ("1)
if. 0 < 2 { y,0 do.
  (plotf_userverb__origlocale pfmody^:_1 steps y) , <0 0
else.
  pfrngz=: $ 0
  pfrngy=: 2 {. y
  plotfintvl (2 {. y),100
end.
)
plotfintvl=: 3 : 0"1
if. pfresy > -~/ 2 {. y do.
  'y res'=. plotf_userverb__origlocale pfmody^:_1 (2 {. y)
  (-. +./ res e. _ __) # (<@,"0 y) ,. (<"2@:|:@,: res) ,. 0 1;1 0
  return.
end.
'yvals zvals'=. plotf_userverb__origlocale pfmody^:_1 yscrn=. steps y
if. 0 = #pfrngz do.
  if. 0 = #pfrngz=: YRANGE do.
    pfrngz=: -~/ pfmodz (({~ , ({~ _1&-)) <.@(0.1&*)@#) /:~ ,zvals
  end.
  if. 0 = #sres=. YFUNCRES do. sres=. 2 * 3 { Dxywh end.
  pfresz=: pfrngz % sres
end.
if. 0.000001 < (-~ % 0.001&>.@|@[)/ 2 {. yvals do.
  intsize=. 2 -~/\ yvals
  'ylo zlo'=. plotf_userverb__origlocale ({.pfrngy) >. yvals - (,~ {.) 0.01 * intsize
  'yhi zhi'=. plotf_userverb__origlocale ({:pfrngy) <. yvals + (, {:) 0.01 * intsize
  secant=. (zhi-zlo) %"1 yhi-ylo
  fwdproj=. ({."1 zvals) ,"0 1 (}:"1 zvals) + (}:"1 secant) *"1 intsize
  bakproj=. ({:"1 zvals) ,~"0 1 (}."1 zvals) - (}."1 secant) *"1 intsize
  'intst inten'=. (+. (+. 1 _1&(|."0 1))@:|.) (+./ (zvals e. _ __)) +."1 +./"2 (| (bakproj,:fwdproj) -"2&:pfmodz zvals) > pfresz
  intervals=. (I. 2 </\ 0 , intst) ,. (I. 2 >/\ inten , 0)
  unsubint=. ,.@((-~ >:)/\)"1 (#~ ~:/"1) _2 ]\ 0 , (,intervals) , #yvals
  subres=. (unsubint <;.0 yvals) ,. (unsubint <@|:;.0 |: zvals) ,. <0 0
  if. #intervals do.
    subres=. /:~ subres , ; <@plotfintvl (intervals { yscrn) ,. +: >: -~/"1 intervals
  end.
  splitpoints=. _2 +./\ |.!.1 , , > 2{"1 subres
  merge=. ,@(1&((2 # (,}.)"1&.>/"1`'')`(<@(0 _1&{)@;);.1))@|:
  subres=. splitpoints merge;.1 subres
else.
  noninf=. -. +./ zvals e. _ __
  subres=. ,: (noninf#yvals) ; (noninf#"1 zvals) ; 0 0
end.
subres
)
plotshow=: 3 : 0
gtk_window_present_with_time_jgtk_ ((0&". ::]) PFormhwnd),GDK_CURRENT_TIME_jgtk_
selectpid''
gpinit''
make ''
gtk_show 1
)
PDFScale=: 0.5
Sizes=: ([:<i.&' '{.]);._2 (0 : 0)
KeyLen     key length
KeyPen     key pensize
MinMTic    minimum minor Tic distance
MinPie     minimum pie radius
MinTic     minimum major Tic distance
MKx        keybox x-margins
MKy        keybox y-margins
MLxy       labelbox margins (i.e. initial labelbox offset from drawbox)
MGxy       drawbox margins (i.e. initial grafbox offset from framebox)
MPie       pie label margin
MPieTic    pie tic size
MXlabel    xlabel margin (offset from bottom axis or frame)
MYlabel    ylabel margin (offset from left axis or frame)
MTitle     title margins (above and below)
MSubTitle  title margins (above and below)
MXCaption  X caption (above and below)
MYCaption  Y caption (left and right)
)

DefSizes=: 25 2 50 50 50 6 4 3 4 10 6 2 3 6 4 3 3
setsizes=: 3 : 0
s=. PDFScale ^ Poutput e. iEPS,iPDF,iCANVAS,iCAIRO
(Sizes)=: DefSizes * s
MarkerScale=: s
)
all=. 0 : 0
ASPECT=: 0
AXES=: 0
AXISCOLOR=: BLACK
BACKCOLOR=: WHITE
BANDCOLOR=: RGCLR
BARWIDTH=: 0.75
BORDER=: 0
BORDERSIZE=: 8
BOXED=: 1
CAPTIONCOLOR=: BLACK
CLEAR=: 1
CONTOURLEVELS=: 20
EDGECOLOR=: BLACK
EDGESIZE=: 1
FORECOLOR=: BLACK
FONTSCALE=: 0.75
FONTSIZEMIN=: 11
FRAME=: 1
FRAMEBACKCOLOR=: ''
FRAMESTYLE=: ''
GRAPHBACKCOLOR=: ''
GRIDCOLOR=: SILVER
GRIDPATTERN=: 1 0 0
GRIDS=: 1
GUIDESIZE=: 0.5
ITEMCOLOR=: STDCLR
KEY=: ''
KEYCOLOR=: ''
KEYMARKERS=: ''
KEYPOS=: ''
KEYSTYLE=: ''
KEYTITLE=: ''
LABELCOLOR=: BLACK
LABELS=: 1
MARKERS=: ''
MARKERSIZE=: 1
MESH=: 1
ORIENTATION=: 2
ORIGINXLABEL=: 0
PENPATTERN=: 1 0;12 6;2 4;12 6 2 4;12 6 2 4 2 4
PENSIZE=: 1
PENSTYLE=: 0
PIEPERCENT=: 0
PLOTCAPTION=: 'Plot'
POLAR=: 0
PRINTMARGIN=: 1440
PRINTWINDOW=: ''
PSHOW=: ''
RTIC=: ''
RULECOLOR=: BLACK
RULESIZE=: 1
SEPARATOR=: '|'
SHOWBOXES=: 0
SINGTOLER=: 10
SUBTITLE=: ''
SUBTITLECOLOR=: BLACK
SUBTITLESTYLE=: ''
SYMBOLCOLOR=: BLACK
SYMBOLS=: '■▲▼♣♦♥♠'
TEXTCOLOR=: BLACK
TICMAJOR=: 7
TICMINOR=: 4
TICS=: 1
TICSTYLE=: ''
TITLE=: ''
TITLECOLOR=: BLACK
TITLESTYLE=: ''
TYPE=: ''
VIEWCENTER=: 0 0 0
VIEWPOINT=: 1.6 _2.4 1.5
VIEWSIZE=: 1 1 0.5
VIEWUP=: 0 0 1
VISIBLE=: 1
XCAPTION=: ''
XCAPTIONSTYLE=: ''
XFUNCRES=: ''
XGRIDPATTERN=: 3 5
XINT=: ''
XLABEL=: ''
XLABELSTYLE=: ''
XLOG=: 0
XRANGE=: ''
XGROUP=: ''
XTIC=: ''
XTICPOS=: ''
Y2AXIS=: '0'
YCAPTION=: ''
YCAPTIONSTYLE=: ''
YFUNCRES=: ''
YGRIDPATTERN=: 3 5
YINT=: ''
YLABEL=: ''
YLABELSTYLE=: ''
YLOG=: 0
YRANGE=: ''
YGROUP=: ''
YTIC=: ''
YTICPOS=: ''
Y2CAPTION=: ''
Y2CAPTIONSTYLE=: ''
Y2LABEL=: ''
Y2LABELSTYLE=: ''
Y2LOG=: 0
Y2RANGE=: ''
Y2TIC=: ''
Y2TICPOS=: ''
ZCAPTIONSTYLE=: ''
ZGRIDPATTERN=: 3 5
ZINT=: ''
ZLABEL=: ''
ZLABELSTYLE=: ''
ZLOG=: 0
ZRANGE=: ''
ZGROUP=: ''
ZTIC=: ''
ZTICPOS=: ''
)
w32=. 0 : 0
CAPTIONFONT=: 'Arial 13'
KEYFONT=: 'Arial 9'
LABELFONT=: 'Arial 9'
SYMBOLFONT=: 'Arial 9'
TEXTFONT=: 'Arial 13'
SUBTITLEFONT=: 'Arial 14'
TITLEFONT=: 'Arial 15'
)

unx=. 0 : 0
CAPTIONFONT=: 'Sans 13'
KEYFONT=: 'Sans 10'
LABELFONT=: 'Sans 10'
SYMBOLFONT=: 'Monospace 10'
TEXTFONT=: 'Sans 13'
SUBTITLEFONT=: 'Sans 14'
TITLEFONT=: 'Sans 15'
)

all=. all, IFWIN pick unx;w32
PlotDefaults=: 3 : 0 all
if. IFTESTPLOTJHS +. IFJHS do.
  r=. 'OUTPUT=: JHSOUTPUT'
elseif. IFQT do.
  r=. 'OUTPUT=: ''qt'''
elseif. IFJA do.
  r=. 'OUTPUT=: ''android'''
elseif. ('jwin32';'jjava') e.~ < (11!:0) ::0: 'qwd' do.
  r=. 'OUTPUT=: ''isi'''
elseif. do.
  r=. 'OUTPUT=: CONSOLEOUTPUT'
end.
y,r,LF
)
TextTypes=: ;: 'text textc textr'
PlotTypes2d=: <;._2 (0 : 0)
area
bar
contour
density
dot
errorbar
fbar
fbarv
hilo
hist
line
marker
pie
poly
point
radar
sbar
sbarv
stick
symbol
)
PlotTypes3d=: <;._2 (0 : 0)
dot
line
poly
stick
surface
wire
)
j=. ;: 'contour density'
PlotData2d=: PlotTypes2d -. j
PlotData3d=: PlotTypes3d, j
PlotTypes=: ~. PlotTypes2d,PlotTypes3d

LineTypes=: ;:'dot errorbar hist line marker point poly radar stick symbol'
BarTypes=: ;:'bar fbar fbarv hist sbar sbarv'
PieTypes=: 'pie';'radar'
FrameTypes=: 'contour';'density'

BandTypes=: 'density';'surface';'wire'
SumXTypes=: ''
SumYTypes=: ;: 'fbar fbarv sbar sbarv'
SumZTypes=: ''
plot=: 3 : 0
'' plot y
:
opt=. x
dat=. y
if. #opt do.
  ndx=. opt i.';'
  first=. deb ndx{.opt
  ind=. <./ first i.', '
  if. (<ind {. first) e. PlotTypes do.
    opt=. 'type ',opt
  end.
end.

pd 'reset'
pd boxcmd opt
if. 1 < L. dat do.
  txy=. 1000 * > { int01 each |. $dat
  rec=. rndint (_1 _1 }. txy) ,"1 [ 1 1 }. txy
  rec=. ": ,/ |. 0 2 |: rec
  dat=. ,dat
  for_d. dat do.
    pd 'use ',d_index { rec
    pd > d
  end.
elseif. 3 = #$dat do.
  for_d. dat do.
    pd d
  end.
elseif. do.
  pd dat
end.

pd 'show'
EMPTY
)
coclass 'jzplot'
makegridpos=: 4 : 0
if. *./ 1 = GRIDPATTERN do.
  x;x+y return.
end.
step=. # GRIDPATTERN
len=. GRIDPATTERN i. 0
off=. - <. -: len
cnt=. >. y % step
px=. off + step * i.cnt
pr=. px + len
(x+0>.px);x+pr<.y
)
AxisIn=: ;: 'INT LABEL LOG Min Max RANGE TIC TICPOS'
AxisOut=: ;: 'Div Int Label Min Minor Max Step Tics TicPos'
getaxes=: 3 : 0
if. IfPie do. return. end.
getaxis 'X'
getaxis 'Y'
if. {:YAxes do.
  getaxis 'Y2'
else.
  Y2Tics=: ''
  if. DimType=3 do.
    getaxis 'Z'
  end.
end.
)
getaxis=: 3 : 0
pm=. y
wid=. ('Y'={.pm) { Lw,Lh
dat=. ". each (<pm) ,each AxisIn
dat=. dat,pm;wid;IfBar
((<pm) ,each AxisOut)=: getaxis1 dat
)
getaxis1=: 3 : 0
nms=. AxisIn,;:'pm wid ifbar'
(nms)=. y
Div=. 0
Tics=. $0
Int=. INT
Label=. LABEL
TicPos=. TICPOS
'Step Minor'=. TIC
wid=. wid - getplotfontsize LabelFontX
mtc=. <. wid % MinTic

if. #RANGE do.
  Min=. {.RANGE
  Max=. 1{RANGE,Max
end.

if. #Int do.
  Min=. Min <. Int
  Max=. Max >. Int
end.

if. #Label do.
  if. #TicPos do.
    if. (#TicPos) ~: #Label do.
      signal 'Number of labels and tic positions should be the same'
    end.
  else.
    TicPos=. Label getaxis_tics pm
  end.
end.

if. #TicPos do.
  Min=. Min <. <./TicPos
  Max=. Max >. >./TicPos
end.
if. ifbar *. pm = 'X' do.

  if. 0=#Label do.
    if. #TicPos do.
      Label=. ": each TicPos
    else.
      steps=. >./ # &> {."1 Data
      Label=. ": each >:i.steps
    end.
  end.

  if. 0 = #TicPos do.
    steps=. >./ # &> {."1 Data
    TicPos=. Min + (Max-Min)*int01 <: steps
  end.

  Div=. 0
  Int=. Min
else.

  if. ifbar do.
    select. 0 <: Min, Max
    case. 1 1 do.
      Min=. 0
    case. 0 0 do.
      Max=. 0
    end.
  end.

  if. #TicPos do.
    'Min Max Int'=. pm getminmax Int;TIC;TicPos;Min;Max;LOG
  else.
    'Step Min Max Int TicPos'=. pm getticpos Int;TIC;Min;Max;LOG;mtc
  end.
  Div=. zero (Int-Min)%Max-Min

end.
Tics=. 2 }. fit01 Min,Max,TicPos
Range=. Min,Max
if. Minor = _1 do.
  if. (0=#TICPOS) *. (Step > 0) *. 1 < #TicPos do.
    Minor=. Step getminor <. wid % MinMTic * <: #TicPos
  else.
    Minor=. 0
  end.

end.
". each AxisOut
)
getaxis_tics=: 4 : 0
labs=. x
select. {. y
case. 'X' do.
  dim0 (<0 0) pick Data
case. 'Y' do.
  dim1 (<0 1) pick Data
case. 'Y2' do.
  dim1 (<(PSDataY2 i.1);1) pick Data
case. 'Z' do.
  zdata=. ; ,each 2 {"1 Data
  n=. <./zdata
  x=. >./zdata
  steps n,x, <:#labs
end.
)
drawxaxis=: 3 : 0
if. 0={.AXES do. return. end.
if. FRAME *. YDiv e. 0 1 do. return. end.
y=. Gy + Gh * YDiv
pos=. Fx, y, (Fx + Fw), y
drawline iXAXIS;AXISCOLOR;GUIDESIZE;pos
)
drawxcaption=: 3 : 0
if. #XCAPTION do.
  x=. Xx + -: Xw
  y=. Xy + Xh - MXCaption
  drawtext iXCAPTION;iCENTER;CaptionFont;CAPTIONCOLOR;XCAPTION;x,y
end.
)
drawxgrid=: 3 : 0
if. 0={.GRIDS do. return. end.
if. {.YAxes do.
  ytics=. YTics
else.
  ytics=. Y2Tics
end.
if. #ytics do.
  ytics=. fitgrafy ytics
  'px pr'=. Gx makegridpos Gw
  len=. (#px) * #ytics
  ytics=. (#px) # ytics
  pos=. |: (len$px),ytics,(len$pr),:ytics
  drawline iXGRID;GRIDCOLOR;GUIDESIZE;pos
end.
)
drawxlabs=: 3 : 0
if. 0={.LABELS do. return. end.
if. 0=#XLabel do. return. end.
if. IfBar do.
  xpos=. fitgrafx }: (0.5&% + int01) # XLabel
  ypos=. (fitgrafy 0) - MXlabel + TICMAJOR
else.
  xpos=. fitgrafx XTics
  ypos=. (fitgrafy YDiv) - MXlabel
end.
if. FRAME do.
  ypos=. Fy - MXlabel + TICMAJOR * TicOut +. IfBar
end.
pos=. xpos,.ypos
drawtext iXLABEL;iCENTER;LabelFont;LABELCOLOR;XLabel;pos
)
drawxlabs3d=: 3 : 0
if. 0={.LABELS do. return. end.
if. 0=#XLabel do. return. end.

xpos=. XTics
ypos=. - (TICMAJOR * 1 + TicOut) % Gh
ndx=. Box3dL firstin 2 6 4 9
if. ndx e. 6 9 do. ypos=. -<:ypos end.

pos=. xpos,"0 1 ypos,ndx e. 4 9
pos=. fit3d pos
drawtext iXLABEL;iCENTER;LabelFont;LABELCOLOR;XLabel;pos
)
drawxtics=: 3 : 0

if. (0={.TICS) +. 0=#XTics do. return. end.
if. IfBar do.
  xpos=. }: (0.5&% + int01) # XLabel
  mark=. -TICMAJOR
  yint=. 0
else.
  'xpos mark'=. gettics XTics;XMinor;XMax;XMin;XLOG
  mark=. mark * _1 ^ TicOut +. (FRAME=0) *. YDiv >: MaxAxisInt
  yint=. YDiv
end.

if. FRAME do.
  h=. Fy - Gy
  pox=. (0,.h+mark),"1 [ 0,h
  pos=. pox +"1 fitgrafxy xpos,.0,.xpos,.0
  if. -. TicOut +. IfBar do.
    h=. (Gy + Gh) - Fy + Fh
    pox=. (0,.h+mark),"1 [ 0,h
    pos=. pos,(-pox) +"1 fitgrafxy xpos,.1,.xpos,.1
  end.
else.
  pox=. 0 0 0&, "0 +mark
  pos=. pox +"1 fitgrafxy xpos,.yint,.xpos,.yint
end.

drawline iXTICS;AXISCOLOR;GUIDESIZE;pos

)
drawxtics3d=: 3 : 0

if. 0={.TICS do. '' return. end.

step=. >:(>:XMinor)*<:#XLabel

mark=. step$(1,XMinor)#(TICMAJOR,TICMINOR)%Gh<.Gw
mark=. mark * _1 ^ TicOut
xpos=. int01 <: step
ypos=. ,0,.mark
ndx=. Box3dL firstin 2 4 6 9
if. ndx e. 6 9 do. ypos=. -.ypos end.

pos=. (2#xpos),.ypos,.ndx e. 4 9
pos=. fit3d pos

drawline iXTICS;AXISCOLOR;GUIDESIZE;_4[\,pos
)
drawyaxis=: 3 : 0
if. 0=1{AXES do. return. end.
if. FRAME *. XDiv e. 0 1 do. return. end.
x=. Gx + Gw * XDiv
pos=. x, Fy, x, Fy + Fh
drawline iYAXIS;AXISCOLOR;GUIDESIZE;pos
)
drawycaption=: 3 : 0
if. #YCAPTION do.
  x=. Yx + MYCaption
  y=. Yy + -: Yh
  if. 0~:{.0#CaptionFont do.
    font=. CaptionFont,' angle900'
  else.
    font=. 90 (3) } CaptionFont
  end.
  drawtext iYCAPTION;iCENTER;font;CAPTIONCOLOR;YCAPTION;x,y
end.
)
drawy2caption=: 3 : 0
if. #Y2CAPTION do.
  x=. Y2x + Y2w - MYCaption
  y=. Y2y + -: Y2h
  if. 0~:{.0#CaptionFont do.
    font=. CaptionFont,' angle2700'
  else.
    font=. 270 (3) } CaptionFont
  end.
  drawtext iY2CAPTION;iCENTER;font;CAPTIONCOLOR;Y2CAPTION;x,y
end.
)
drawygrid=: 3 : 0
if. IfBar +. (0=1{GRIDS) +. 0=#XTics do. return. end.
xtics=. fitgrafx XTics
'py ps'=. Gy makegridpos Gh
len=. (#py) * #xtics
xtics=. (#py) # xtics
pos=. |: xtics,(len$py),xtics,:len$ps
drawline iYGRID;GRIDCOLOR;GUIDESIZE;pos
)
drawylabs=: 3 : 0

if. 0=1{LABELS do. return. end.
if. 0=#YLabel do. return. end.

ypos=. <. (fitgrafy YTics) + -: YLabelHeight

tout=. TICMAJOR * TicOut

if. FRAME +. IfBar do.
  pos=. (Fx - MYlabel + tout) ,. ypos
  drawtext iYLABEL;iRIGHT;LabelFont;LABELCOLOR;YLabel;pos
else.
  if. XDiv < MaxAxisInt do.
    pos=. ((fitgrafx XDiv) - MYlabel + tout),.ypos
    drawtext iYLABEL;iRIGHT;LabelFont;LABELCOLOR;YLabel;pos
  else.
    pos=. ((fitgrafx XDiv) + MYlabel + tout),.ypos
    drawtext iYLABEL;iLEFT;LabelFont;LABELCOLOR;YLabel;pos
  end.
end.
)
drawy2labs=: 3 : 0
if. -. {:YAxes do. return. end.
if. (0=2{LABELS) +. 0=#Y2Label do. return. end.
ypos=. <. (fitgrafy Y2Tics) + -: YLabelHeight
pos=. (Fx + Fw + MYlabel) ,. ypos
drawtext iY2LABEL;iLEFT;LabelFont;LABELCOLOR;Y2Label;pos
)
drawylabs3d=: 3 : 0

if. 0=1{LABELS do. '' return. end.
if. 0=#YLabel do. return. end.

ypos=. YTics
xpos=. -(TICMAJOR +1 + TicOut) % Gw
ndx=. Box3dL firstin 1 8 3 10
if. ndx e. 8 10 do. xpos=. -<:xpos end.

pos=. xpos,.ypos,.ndx e. 3 10
pos=. fit3d pos

drawtext iYLABEL;iCENTER;LabelFont;LABELCOLOR;YLabel;pos
)
drawytics=: 3 : 0

if. 0=1{TICS do. return. end.
if. ({.YAxes) *. #YTics do.
  'ypos mark'=. gettics YTics;YMinor;YMax;YMin;YLOG
  mark=. <. mark * _1 ^ FRAME < TicOut +. XDiv >: MaxAxisInt
  if. FRAME +. IfBar do.
    w=. Fx - Gx
    pox=. ,&(0,w,0) "0 mark+w
    pos=. pox + fitgrafxy 0,.ypos,.0,.ypos
    if. FRAME > TicOut +. {:YAxes do.
      w=. (Fx + Fw) - Gx + Gw
      pox=. ,&(0,w,0) "0 w-mark
      pos=. pos,pox + fitgrafxy 1,.ypos,.1,.ypos
    end.
  else.
    pox=. 0,.0,.mark,.0
    pos=. pox + fitgrafxy XDiv,.ypos,.XDiv,.ypos
  end.

  drawline iYTICS;AXISCOLOR;GUIDESIZE;pos
end.
if. ({:YAxes) *. #Y2Tics do.
  'ypos mark'=. gettics Y2Tics;YMinor;Y2Max;Y2Min;Y2LOG
  w=. Fx - Gx
  pox=. ,&(0,w,0) "0 mark+w
  pos=. (-pox) + fitgrafxy 1,.ypos,.1,.ypos
  drawline iYTICS;AXISCOLOR;GUIDESIZE;pos
end.

)
drawy2tics=: 3 : 0
EMPTY
)
drawytics3d=: 3 : 0

if. 0=1{TICS do. '' return. end.

step=. >:(>:YMinor)*<:#YLabel
mark=. step$(1,YMinor)#(TICMAJOR,TICMINOR)%Gh<.Gw
mark=. mark * _1 ^ TicOut
ypos=. int01 <: step
xpos=. ,0,.mark
ndx=. Box3dL firstin 1 8 3 10
if. ndx e. 8 10 do. xpos=. -.xpos end.

pos=. (xpos),.(2#ypos),.ndx e. 3 10
pos=. fit3d pos
drawline iYTICS;AXISCOLOR;GUIDESIZE;_4[\,pos

)
drawzlabs3d=: 3 : 0

if. 0=2{LABELS do. '' return. end.
if. 0=#ZLabel do. return. end.

zpos=. ZTics
xpos=. - (TICMAJOR + 1 + TicOut) % Gh
ndx=. Box3dL firstin 0 5 7 11
if. ndx e. 7 11 do. xpos=. -<:xpos end.

end=. ndx e. 5 11
aln=. end { iRIGHT,iLEFT
pos=. xpos,.end,.zpos
pos=. fit3d pos
drawtext iZLABEL;aln;LabelFont;LABELCOLOR;ZLabel;pos
)
drawztics3d=: 3 : 0

if. 0=2{TICS do. '' return. end.

step=. >: (>:ZMinor) * <:#ZLabel
mark=. step$(1,ZMinor)#(TICMAJOR,TICMINOR) % Gh <. Gw
mark=. mark * _1 ^ TicOut

zpos=. int01 <: step
xpos=. ,0,.mark
ndx=. Box3dL firstin 0 5 7 11
if. ndx e. 7 11 do. xpos=. -. xpos end.

pos=. xpos,.(ndx e. 5 11),.2#zpos
pos=. fit3d pos
drawline iZTICS;AXISCOLOR;GUIDESIZE;_4[\,pos
)
drawpietics=: 3 : 0
rad=. <. -: <./ _2 {. Gxywh
ctr=. (Gx+-:Gw),Gy+-:Gh
xy=. rndint (rad * y),.(rad+MPieTic) * y
xy +"1 [ 4 $ ctr
)
coclass 'jzplot'
cfserr=: 3 : 0
signal 'need data matrix for 3d plot'
signal 'plot error'
)
conform3d=: 3 : 0
'x y z'=. y

shp=. $ each x;y;z
if2=. 2 = # &> shp

select. +/if2

case. 0 do.
  x=. ,:x
  y=. ,;y
  z=. ,:z
  rxy=. $z

case. 1 do.

  rxy=. ;(-.if2)#shp
  rmat=. ;if2#shp

  if. -. rxy -: rmat do.
    if. rxy -: |.rmat do.
      nm=. if2 # 'xyz'
      (nm)=. |:,nm~
    else. cfserr''
    end.
  end.

case. 2 do.
  rz=. ;(-.if2)#shp
  rs=. if2#shp
  rxy=. 0 pick rs
  if. (-:/rs) *: (rz e. rxy) do.
    cfserr''
  end.

case. 3 do.
  if. -. shp -: 3${.shp do.
    cfserr''
  end.
  rxy=. 0 pick shp
end.

'r c'=. rxy
if. 2>rank x do.
  x=. c#"1,.x
end.
if. 2>rank y do.
  y=. rxy$y
end.
if. 2>rank z do.
  z=. rxy$z
end.

x;y;z

)
getdata=: 4 : 0
dat=. y

if. 0 e. $ y do.
  '';(i.0 0);(i.0 0) return.
end.

if. iscomplexdata dat do.
  if. dat -: + dat do.
    dat=. {."1 dat
  else.
    if. 2 > #$dat do.
      dat=. ;/ |: +. dat
    else.
      dat=. ;/ 2 0 1 |: +. dat
    end.
  end.
end.

if. isboxed dat do.
  x getdata_boxed dat
else.
  x getdata_open dat
end.

)
getdata_boxed=: 4 : 0
select. (x=3),#y
case. 0 1 do.
  y=. citemize 0 pick y
  x=. i.{:$y
  x;y;0
case. 1 1 do.
  (i.#0 pick y);(i.{:$0 pick y);y
case. 1 2 do.
  (i.#1 pick y);y
case. do.
  3 {. y,<0
end.
)
getdata_open=: 4 : 0
if. x=2 do.
  y=. citemize y
  x=. i.{:$y
  x;y;0
else.
  z=. citemize y
  y=. i. {:$ z
  x=. i. # z
  x;y;z
end.
)
getmin=: 3 : 0
<./ &> ,each y
)
getmax=: 4 : 0
types=. x
'x y z'=. y
if. (1 e. types e. SumXTypes) do.
  mx=. >./, +/"1 x
else.
  mx=. >./, x
end.
if. (1 e. types e. SumYTypes) do.
  my=. >./, +/ y
else.
  my=. >./, y
end.
if. (1 e. types e. SumZTypes) do.
  mz=. >./, +/ z
else.
  mz=. >./, z
end.
mx,my,mz
)
getpolar=: 3 : 0
'x y z'=. y
(x * cos y) ; (x * sin y) ; z
)
getdatarange=: 3 : 0

'types dat y2msk yaxes'=. y

min=. getmin "1 dat
max=. types & getmax "1 dat

y2min=. y2max=. zmin=. zmax=. 0

select. yaxes

case. 1 0 do.
  'xmin ymin zmin'=. <./ min
  'xmax ymax zmax'=. >./ max
case. 0 1 do.
  'xmin y2min zmin'=. <./ min
  'xmax y2max zmax'=. >./ max
  ymin=. y2min
  ymax=. y2max
case. 1 1 do.
  lmsk=. -.y2msk
  rmsk=. y2msk

  'xln yln j'=. <./ lmsk # min
  'xlx ylx j'=. >./ lmsk # max
  'xrn yrn j'=. <./ rmsk # min
  'xrx yrx j'=. >./ rmsk # max

  xmin=. xln <. xrn
  xmax=. xlx >. xrx
  ymin=. yln
  ymax=. ylx
  y2min=. yrn
  y2max=. yrx
end.
if. (<'radar') e. types do.
  ymin=. 0 <. ymin
  ymax=. 1 >. ymax
end.

if. (<'density') e. types do.
  'xmin xmax ymin ymax'=. (xmin,xmax,ymin,ymax)+4$0.5*_1 1
end.
(xmin,xmax);(ymin,ymax);(y2min,y2max);zmin,zmax

)

coclass 'jzplot'
Box3d=: _3[\,".;._2 (0 : 0)
0 0 0 0 0 1
0 0 0 0 1 0
0 0 0 1 0 0
0 0 1 0 1 1
0 0 1 1 0 1
0 1 0 0 1 1
0 1 0 1 1 0
1 0 0 1 0 1
1 0 0 1 1 0
0 1 1 1 1 1
1 0 1 1 1 1
1 1 0 1 1 1
)
dofirst=: 1 : 0
Ndx=: Ndx-1
u y
Ndx=: Ndx+1
)
dolast=: 1 : 0
Ndx=: Ndx+1
u y
Ndx=: Ndx-1
)
drawborder=: 3 : 0
if. BORDER do.
  box=. PlotBox shrinkrect BORDERSIZE
  drawbox iBORDER;FORECOLOR;GUIDESIZE;box
end.
)
drawbox=: 3 : 0
'i c s p'=. y
'x y w h'=. p
xw=. x + w
yh=. y + h
drawline i;c;s;x,y,xw,y,xw,yh,x,yh,x,y
)
drawdot=: 3 : 0
'i c s p'=. y
setp 'dot';i;s;0;0;c;0;p
)
drawframebox=: 3 : 0
if. FRAME do.
  drawbox iBOX;AXISCOLOR;GUIDESIZE;Fxywh
end.
)
drawframebox3d=: 3 : 0
box=. (Box3d scalepos XYZDiff) movepos XYZMin
box=. project box
zbox=. {:"1 box
box=. }:"1 box
Box3dX=: /: _2 +/\ zbox
j=. <Box3dX /: 3#1 0 0 1
Box3dL=: j firstin &> 2 6 4 9 ;1 8 3 10 ;0 5 7 11
box=. fitgrafxy3d box
box=. 12 4$,box
box=. Box3dX{box
drawline iFRAME;AXISCOLOR;GUIDESIZE;box
drawline dolast iFRAME;AXISCOLOR;GUIDESIZE;3{.box
)
drawfxywh=: 3 : 0
setp 'fxywh';0;0;0;0;0;0;y#Fxywh
)
drawmarker=: 3 : 0
'i s c m p'=. y
setp 'marker';i;s;m;0;c;0;p
)

drawpline=: 3 : 0
'i t c s p'=. y
setp 'pline';i;s;t;0;c;0;p
)
drawtext=: 3 : 0
'i a f c t p'=. y
setp 'text';i;t;f;a;c;0;p
)
drawtitle=: 3 : 0
if. 0=#TITLE do. '' return. end.
x=. Tx + -: Tw
if. LF e. TITLE do.
  tit=. <;._2 TITLE,LF
  h=. (Th - +:MTitle) % #tit
  y=. Ty + Th - MTitle
  for_t. tit do.
    drawtext iTITLE;iCENTER;TitleFont;TITLECOLOR;t,<x,y
    y=. y - h
  end.
else.
  y=. Ty + Th - MTitle
  drawtext iTITLE;iCENTER;TitleFont;TITLECOLOR;TITLE;x,y
end.
)
drawsubtitle=: 3 : 0
if. 0=#SUBTITLE do. '' return. end.
x=. Vx + -: Vw
if. LF e. SUBTITLE do.
  tit=. <;._2 SUBTITLE,LF
  h=. (Vh - +:MSubTitle) % #tit
  y=. Vy + Vh - MSubTitle
  for_t. tit do.
    drawtext iSUBTITLE;iCENTER;SubTitleFont;SUBTITLECOLOR;t,<x,y
    y=. y - h
  end.
else.
  y=. Vy + Vh - MSubTitle
  drawtext iSUBTITLE;iCENTER;SubTitleFont;SUBTITLECOLOR;SUBTITLE;x,y
end.
)
draw1d=: 4 : 0
'i c s p'=. y
setp x;i;s;0;0;c;0;p
)
draw2d=: 4 : 0
'i e s c p'=. y
setp x;i;s;0;0;e;c;p
)
drawarc=: 'arc' & draw1d
drawline=: 'line' & draw1d
drawpie=: 'pie' & draw2d
drawpoly=: 'poly' & draw2d
drawrect=: 'rect' & draw2d
drawcircle=: 'circle' & draw2d
cube=: 3 : 0
v=. normalize 2 2 2#: i.8
ndx=. 0 2 6 4, 4 6 7 5, 1 5 7 3, 0 1 3 2, 2 3 7 6,: 0 4 5 1
ndx{v
)
dodecahedron=: 3 : 0
x=. 2 o. 1r5p1
y=. % <: +: x
a=. |: 2 1 o./ o. (+:i.5)%5
b=. |: 2 1 o./ o. (>:+:i.5)%5
v=. normalize (a,.0),((+:a*x),.1),((+:b*x),.y),b,.>:y
ndx=. 0 4 3 2 1, 0 1 6 10 5, 1 2 7 11 6, 2 3 8 12 7, 3 4 9 13 8
ndx=. ndx, 4 0 5 14 9, 5 10 15 19 14, 6 11 16 15 10, 7 12 17 16 11
ndx=. _5[\ ndx, 8 13 18 17 12, 9 14 19 18 13, 15 16 17 18 19
ndx{v
)
icosahedron=: 3 : 0
's c'=. 1 2 o. 1r5p1
x=. %: -. % 4 * *: s
y=. %: (1++:c) % 2++:c
a=. |: (2 1 o./ o. (+:i.5)%5) % +:s
b=. |: (2 1 o./ o. (>:+:i.5)%5) % +:s
v=. normalize 0,(a,.x),(b,.x+y),0 0,y++:x
ndx=. 0 2 1, 0 3 2, 0 4 3, 0 5 4, 0 1 5, 1 2 6, 2 3 7, 3 4 8
ndx=. ndx, 4 5 9, 5 1 10, 1 6 10, 2 7 6, 3 8 7, 4 9 8, 5 10 9
ndx=. _3[\ndx, 11 6 7, 11 7 8, 11 8 9, 11 9 10, 11 10 6
ndx{v
)
octahedron=: 3 : 0
v=. normalize 0 0 1, 1 0 0, 0 1 0, _1 0 0, 0 _1 0 ,: 0 0 _1
ndx=. 0 1 2, 0 2 3, 0 3 4, 0 4 1, 5 2 1, 5 3 2, 5 4 3,: 5 1 4
ndx{v
)
tetrahedron=: 3 : 0
r3=. -%%:3
r2=. %:2
r23=. %:2r3
v=. normalize (0,0,%:3), (0, (+:r23),r3), ((-r2),(-r23),r3),: r2,(-r23),r3
ndx=. 0 1 2, 0 2 3, 0 3 1,: 1 3 2
ndx{v
)
normalize=: 3 : 0
v=. (-"1 +/ % #) y
cleanz v % >./ dist"1 v
)
drawtrims=: 3 : 0

if. IfPie do. return. end.

if. DimType=2 do.
  drawframebox''

  drawxgrid''
  drawygrid''

  drawxaxis''
  drawyaxis''

  drawxtics''
  drawytics''

  drawxlabs''
  drawylabs''
  drawy2labs''

  drawxcaption''
  drawycaption''
  drawy2caption''

else.

  if. BOXED do.
    drawframebox3d''
    drawxtics3d''
    drawytics3d''
    drawztics3d''
    drawxlabs3d''
    drawylabs3d''
    drawzlabs3d''
  end.

end.
)
pclose_android=: 3 : 0
try.
  wd 'psel ',": PFormhwnd
  PFormhwnd=: 0
  if. ifjwplot'' do.
    wpsave_j_ :: 0: PForm
  end.
  wd 'pclose'
  pd 'reset'
catch. end.
0
)
popen_android=: 3 : 0
if. wdishandle ": (0&". ::]) PFormhwnd do.
  wd 'psel ', ": (0&". ::]) PFormhwnd
  glsel PId
  0 return.
end.
fm=. PForm,'_'
id=. fm,PId,'_'
(id,'paint')=: ppaint
(id,'mmove')=: ]

Pxywh=: ''
PShow=: 0
wd 'activity ', (>coname''), ' fs'
)

onStart=: 3 : 0
wd 'pc ',PForm,' closeok'
wd 'pn *',PLOTCAPTION
wd 'cc ',PId,' isigraph flush'
wd 'pas 0 0'
PFormhwnd=: wdqhwndp''
android_show2''
)
ptop_android=: 3 : 0
PTop=: -. PTop
wd 'ptop ',":PTop
)
3 : 0''
if. IFJA do.
  pclose=: pclose_android
  popen=: popen_android
  ppaint=: android_paint
  psize=: psize_android
  ptop=: ptop_android
end.
EMPTY
)
PMenu=: 0 : 0
menupop "&File";
menu clip "&Clip" "" "" "";
menusep;
menu saveeps "&Save EPS" "" "" "";
menusep;
menu savepdf "&Save PDF" "" "" "";
menusep;
menu print "&Print" "" "" "";
menusep;
menu exit "E&xit" "" "" "";
menupopz;
menupop "&Help";
menu help "&Plot Help" "" "" "";
menusep;
menu about "&About" "" "" "";
menupopz;
)
pclose_isi=: 3 : 0
try.
  wd 'psel ',PFormhwnd
  if. ifjwplot'' do.
    wpsave_j_ :: 0: PForm
  end.
  wd 'pclose'
  pd 'reset'
catch. end.
)
popen_isi=: 3 : 0
if. ifparent PFormhwnd do.
  wd 'psel ',PFormhwnd
  wd 'pactive'
  glsel PId
  glnodblbuf^:IFJNET 0
  0 return.
end.
if. IFJNET do.
  wd 'pc6j ',PForm,' closeok'
else.
  wd 'pc ',PForm,' closeok'
end.
wd 'menupop "&File";'
wd 'menu quit "&Quit" "Ctrl+Q" "" "";'
wd 'menupopz;'
PFormhwnd=: wd 'qhwndp'
(PForm,'_quit_button')=: wd bind 'pclose'
wd 'pn *',PLOTCAPTION
wd 'xywh 0 0 240 180'
wd 'cc ',PId,' isigraph rightmove bottommove'
wd 'pas 0 0'
glnodblbuf^:IFJNET 0

if. ifjwplot'' do.
  wpset_j_ :: 0: PForm
else.
  wdmove _1 0
end.
wdfit ''

fm=. PForm,'_'
id=. fm,PId,'_'
(id,'paint')=: ppaint
(id,'mmove')=: ]
Pxywh=: ''
PShow=: 0
)
isi_ppaint=: 3 : 0
cwh=. glqwh''
if. -. cwh -: Cw,Ch do.
  isi_show ''
end.
)
psize=: 3 : 0
if. #Plot do.
  isi_ppaint''
end.
)
ptop_isi=: 3 : 0
PTop=: -. PTop
wd 'ptop ',":PTop
)
pclose_qt=: 3 : 0
try.
  wd 'psel ',": PFormhwnd
  PFormhwnd=: 0
  if. ifjwplot'' do.
    wpsave_j_ :: 0: PForm
  end.
  wd 'pclose'
  pd 'reset'
catch. end.
0
)
popen_qt=: 3 : 0
if. #y do. size=. 0 ". y else. size=. QT_DEFSIZE end.

Poutput=: iQT
if. wdishandle ": (0&". ::]) PFormhwnd do.
  wd 'psel ', ": (0&". ::]) PFormhwnd
  glsel PId
  0 return.
end.
wd 'pc ',PForm,' closeok'
PFormhwnd=: wdqhwndp''
wd 'menupop "&File";'
wd 'menu quit "&Quit" "Ctrl+Q" "" "";'
wd 'menupopz;'
(PForm,'_quit_button')=: wd bind 'pclose'
wd 'pn *',PLOTCAPTION
wd 'minwh ',": size
wd 'cc ',PId,' isigraph flush'
wd 'pas 0 0'

fm=. PForm,'_'
id=. fm,PId,'_'
(id,'paint')=: ppaint
(id,'mmove')=: ]

Pxywh=: ''
PShow=: 0
)
ptop_qt=: 3 : 0
PTop=: -. PTop
wd 'ptop ',":PTop
)
3 : 0''
if. IFQT do.
  pclose=: pclose_qt
  popen=: popen_qt
  ppaint=: qt_paint
  psize=: psize_qt
  ptop=: ptop_qt
elseif. IFJA do.
  pclose=: pclose_android
  popen=: popen_android
  ppaint=: android_paint
  psize=: psize_android
  ptop=: ptop_android
elseif. ('jwin32';'jjava') e.~ < (11!:0) ::0: 'qwd' do.
  pclose=: pclose_isi
  popen=: popen_isi
  ppaint=: isi_paint
  psize=: psize_isi
  ptop=: ptop_isi
end.
EMPTY
)
fzskludge=: 4%3
pgetascender=: 3 : 0
if. Poutput = iANDROID do.
  glfontextent andfontdesc y
  1 { glqtextmetrics''
elseif. Poutput e. iQT do.
  glfontextent gtkfontdesc y
  1 { glqtextmetrics''
elseif. Poutput = iCAIRO do.
  FontScale * getascender y
elseif. Poutput = iCANVAS do.
  FontScale * getascender (FontSizeMin >. 2{y) 2 } y
elseif. Poutput=iISI do.
  glfont y
  1 { glqtextmetrics''
elseif. do.
  FontScale * getascender y
end.
)
pgetextent=: 4 : 0
select. Poutput
case. iANDROID do.
  glfontextent andfontdesc^:(0={.0#x) x
  |: glqextent &> y
case. iQT do.
  glfontextent gtkfontdesc^:(0={.0#x) x
  |: glqextent &> y
case. iCAIRO do.
  FontScale * fzskludge * x getextent y
case. iCANVAS do.
  FontScale * fzskludge * ((FontSizeMin >. 2{x) 2} x) getextent y
case. iISI do.
  glfont x
  |: glqextent &> y
case. do.
  FontScale * x getextent y
end.
)
pgetextent1=: 4 : 0
if. LF e. y do.
  r=. (<x) pgetextent1 &> <;._2 y,LF
  (>./{."1 r),+/{:"1 r return.
end.
select. Poutput
case. iANDROID do.
  glfontextent andfontdesc^:(0={.0#x) x
  glqextent y
case. iQT do.
  glfontextent gtkfontdesc^:(0={.0#x) x
  glqextent y
case. iCANVAS do.
  FontScale * fzskludge * ((FontSizeMin >. 2{x) 2} x) getextent1 y
case. iISI do.
  glfont x
  glqextent y
case. do.
  FontScale * x getextent1 y
end.
)
getfontsize=: 13 : '{.1{._1 -.~ _1 ". y'
getplotfontsize=: 3 : 0
if. 2 131072 262144 e.~ 3!:0 y do.
  FontScale * FontSizeMin >. getfontsize y
else.
  FontScale * FontSizeMin >. 2 { y
end.
)

pgetstringlen=: {. @ pgetextent
gtkfontdesc=: 3 : 0
'ind fst siz ang und'=. y
'ita bld'=. 2 2 #: fst
sty=. (bld#' bold'),(ita#' italic'),und#' underline'
('_' (I.@(' '&=)nam)} nam=. ind pick GTKFONTNAMES),sty,' ',":siz
)
setfonts=: 3 : 0

CaptionFontX=: getfontid CAPTIONFONT
KeyFontX=: getfontid KEYFONT
LabelFontX=: getfontid LABELFONT
SubTitleFontX=: getfontid SUBTITLEFONT
SymbolFontX=: getfontid SYMBOLFONT
TitleFontX=: getfontid TITLEFONT

if. Poutput e. iANDROID do.
  CaptionFont=: getgtkfontid CaptionFontX
  KeyFont=: getgtkfontid KeyFontX
  LabelFont=: getgtkfontid LabelFontX
  SubTitleFont=: getgtkfontid SubTitleFontX
  SymbolFont=: getgtkfontid SymbolFontX
  TitleFont=: getgtkfontid TitleFontX
elseif. Poutput e. iQT do.
  CaptionFont=: getgtkfontid CaptionFontX
  KeyFont=: getgtkfontid KeyFontX
  LabelFont=: getgtkfontid LabelFontX
  SubTitleFont=: getgtkfontid SubTitleFontX
  SymbolFont=: getgtkfontid SymbolFontX
  TitleFont=: getgtkfontid TitleFontX
elseif. Poutput = iISI do.
  CaptionFont=: getisifontid CaptionFontX
  KeyFont=: getisifontid KeyFontX
  LabelFont=: getisifontid LabelFontX
  SubTitleFont=: getisifontid SubTitleFontX
  SymbolFont=: getisifontid SymbolFontX
  TitleFont=: getisifontid TitleFontX
elseif. do.
  CaptionFont=: CaptionFontX
  KeyFont=: KeyFontX
  LabelFont=: LabelFontX
  SubTitleFont=: SubTitleFontX
  SymbolFont=: SymbolFontX
  TitleFont=: TitleFontX
end.

FontScale=: (Poutput e. iEPS,iPDF,iCAIRO) { 1,FONTSCALE
FontSizeMin=: (Poutput e. iCANVAS) { 0,FONTSIZEMIN
)
coclass 'jzplot'
gdxy=: 3 : 0
xy=. _2 [\ <;._1 ' ',deb y
,('x' gdxy1 {."1 xy),.'y' gdxy1 {:"1 xy
)
gdxy1=: 4 : 0
if. x='y' do.
  b=. Gy
  s=. Gh
  max=. YMax
  min=. YMin
else.
  b=. Gx
  s=. Gw
  max=. XMax+IfBar*1.5
  min=. XMin+IfBar*0.5
end.
np=. I. mp=. 'x' = {:&> y
nr=. I. mr=. 'r' = {:&> y
nm=. I. mm=. mr +: mp
y=. 0 ".&> (-mr+.mp) }. each y
y=. ((s%1000) * nm{y) nm}y
if. #np do.
  px=. np{y
  px=. (px<0) } px,:1 + s|px
  y=. px np}y
end.
if. #nr do.
  pr=. s * (max-min) %~ (nr{y) - min
  y=. pr nr}y
end.
b + rndint y
)
gdbrushcolor=: 3 : 0
BrushColor=: rndint _1 ". toupper y
)
gdlines=: 3 : 0
drawpline iGD;({:Pen);PenColor;({.Pen);gdxy y
)
gdpen=: 3 : 0
Pen=: 2 {. _1 ". y
)
gdpencolor=: 3 : 0
PenColor=: rndint _1 ". toupper y
)
gdrect=: 3 : 0
drawrect iGD;PenColor;({.Pen);BrushColor;gdxy y
)
drawgd=: 3 : 0
cmd=. ('Gcmd',":y)~
for_d. cmd do.
  'f v'=. d
  f~v
end.
)
coclass 'jzplot'
KeyOpts=: <;._2 (0 : 0)
bottom
boxed
center
combo
fat
horizontal
inside
left
marker
middle
open
outside
right
thin
top
vertical
)
drawkey=: 3 : 0

if. 0 = #KEY do. return. end.

len=. #KEY
if. #KEYCOLOR do.
  clr=. KEYCOLOR
else.
  clr=. ITEMCOLOR
end.
clr=. len $ clr
'hz rj'=. 'hr' e. KEYSTYLE

boxed=. -. 'o' e. KEYSTYLE
marker=. 1 e. 'mc' e. KEYSTYLE

if. marker do.
  if. #ndx=. KEYMARKERS,MARKERS do.
    markers=. ndx { KeyMarkerNames
  else.
    markers=. KeyMarkerNames
  end.
end.
'kx ky'=. ((boxed + 1) * MKx,MKy) + Kx,Ky
'tw th'=. KeyExtent
mtw=. >./tw
mth=. >./th
select. hz,rj
case. 0 0 do.
  gx=. 0
  gy=. ty=. |. +/\ th
  tx=. MKx + KeyLen
  ts=. iLEFT
case. 0 1 do.
  tx=. mtw
  gx=. tx + MKx
  gy=. ty=. |. +/\ th
  ts=. iRIGHT
case. 1 0 do.
  gy=. ty=. mth
  gx=. 0, +/\ }: tw + KeyLen + 3 * MKx
  tx=. gx + KeyLen + MKx
  ts=. iLEFT
case. 1 1 do.
  gy=. ty=. mth
  gx=. (+/\ tw) + (KeyLen + 3 * MKx) * i.#tw
  tx=. gx - MKx
  ts=. iRIGHT
end.

gx=. gx + kx
tx=. tx + kx
gy=. gy + ky
ty=. ty + ky
if. boxed do.
  rect=. boxwh2rs Kxywh shrinkrect MKx,MKy,MKx,MKy
  col=. ('o' e. KEYPOS) pick FrameBackColor;BACKCOLOR
  drawrect iKEY;AXISCOLOR;1;col;rect
end.
if. marker do.
  xy=. (gx + -: KeyLen),.ty - -: th
  for_i. i.#xy do.
    drawmarker iKEY;(MarkerScale*MARKERSIZE);(i{clr);(i{markers),<,:i{xy
  end.
  if. 'c' e. KEYSTYLE do.
    wh=. KeyLen,KeyPen
    xy=. gx,.ty - -: KeyPen + th
    dat=. xy ,"1 xy +"1 wh
    drawrect iKEY;AXISCOLOR;0;clr;dat
  end.
elseif. 'f' e. KEYSTYLE do.
  hit=. 0.5 * <./th
  ly=. ty + 1 - -: hit + th
  xy=. gx,.ly
  wh=. KeyLen,hit
  dat=. xy ,"1 xy +"1 wh
  drawrect iKEY;AXISCOLOR;0;clr;dat
elseif. do.
  ly=. ty + 1 - -: KeyPen + th
  xy=. gx,.ly
  wh=. KeyLen,KeyPen
  dat=. xy ,"1 xy +"1 wh
  drawrect iKEY;AXISCOLOR;0;clr;dat
end.
if. Poutput = iANDROID do.
  ty=. ty - <. 0.75 * {.th
elseif. Poutput e. iQT do.
end.
pos=. tx,.ty

drawtext dolast iKEY;ts;KeyFont;LABELCOLOR;KEY;pos
)
getinnerkeybox=: 3 : 0

if. 0 = #KEY do. return. end.

if. 'o' e. KEYPOS do. return. end.
if. 'h' e. KEYSTYLE do.
  if. 'r' e. KEYPOS do.
    x=. Gw - (+:MKx) + Kw
  elseif. 'c' e. KEYPOS do.
    x=. -: Gw - Kw
  elseif. do.
    x=. +:MKx
  end.
  if. 'b' e. KEYPOS do.
    y=. +:MKy
  else.
    y=. Gh - (+:MKy) + Kh
  end.
else.
  if. 'r' e. KEYPOS do.
    x=. Gw - (+:MKx) + Kw
  else.
    x=. +:MKx
  end.
  if. 'b' e. KEYPOS do.
    y=. +:MKy
  elseif. 'm' e. KEYPOS do.
    y=. -: Gh - Kh
  elseif. do.
    y=. Gh - (+:MKy) + Kh
  end.
end.

Kx=: x+Gx
Ky=: y+Gy
Kxywh=: Kx,Ky,Kw,Kh
)
ifouterkey=: 3 : 0
('o' e. KEYPOS) *. 0 < #KEY
)
getouterkeybox=: 3 : 0
if. -. ifouterkey'' do. return. end.

if. 'r' e. KEYPOS do.
  x=. Ox + Ow - Kw
elseif. 'c' e. KEYPOS do.
  x=. Ox + -: Ow - Kw
elseif. do.
  x=. Ox
end.

if. 'b' e. KEYPOS do.
  y=. Oy
elseif. 'm' e. KEYPOS do.
  y=. Oy + -: Oh - Kh
elseif. do.
  y=. Oy + Oh - Kh
end.

Kx=: x
Ky=: y
Kxywh=: Kx,Ky,Kw,Kh
)
getkeysize=: 3 : 0

if. 0 = #KEY do.
  'Kx Ky Kw Kh'=: Kxywh=: 4$0 return.
end.
len=. #KEY
KeyExtent=: KeyFont pgetextent KEY
'tw th'=. KeyExtent
if. 'h' e. KEYSTYLE do.
  kw=. (len * KeyLen + 3 * MKx) + +/tw
  kh=. (+:MKy) + >./th
else.
  kw=. (3 * MKx) + KeyLen + >./tw
  kh=. (+:MKy) + +/th
end.
if. -. 'o' e. KEYSTYLE do.
  kw=. kw + +: MKx
  kh=. kh + +: MKy
end.
'Kx Ky Kw Kh'=: Kxywh=: 0 0,kw,kh
)

coclass 'jzplot'
getaspect=: 3 : 0
if. ASPECT=0 do. return. end.
select. * ASPECT - Gh % Gw
case. _1 do.
  getaspecth''
case. 1 do.
  getaspectw''
end.
Gxywh=: Gx,Gy,Gw,Gh
Fxywh=: Fx,Fy,Fw,Fh
Lxywh=: Lx,Ly,Lw,Lh
)
getaspecth=: 3 : 0
new=. Gw * ASPECT
dh=. Gh - new
dy=. 0 >. (Dy - Gy) + -: Dh - new
Gh=: Gh - dh
Gy=: Gy + dy
Fh=: Fh - dh
Fy=: Fy + dy
Lh=: Lh - dh
Ly=: Ly + dy
if. (#KEY) *. 'o' e. KEYPOS do.
  Ky=: Ky + ('b' e. KEYPOS) { (dy-dh),dy
  Kxywh=: Kx,Ky,Kw,Kh
end.
if. #XCAPTION do.
  Xy=: Xy + dy
  Xxywh=: Xx, Xy, Xw, Xh
end.
if. #TITLE do.
  Ty=: Ty + dy - dh
  Txywh=: Tx, Ty, Tw, Th
end.
if. #SUBTITLE do.
  Vy=: Vy + dy - dh
  Vxywh=: Vx, Vy, Vw, Vh
end.
)
getaspectw=: 3 : 0
new=. Gh % ASPECT
dw=. Gw - new
dx=. 0 >. (Dx - Gx) + -: Dw - new
Gw=: Gw - dw
Gx=: Gx + dx
Fw=: Fw - dw
Fx=: Fx + dx
Lw=: Lw - dw
Lx=: Lx + dx
if. (#KEY) *. 'o' e. KEYPOS do.
  Kx=: Kx + ('r' e. KEYPOS) { dx,dx-dw
  Kxywh=: Kx,Ky,Kw,Kh
end.
if. (IfMulti >: IfPie) *. #YCAPTION do.
  Yx=: Yx + dx
  Yxywh=: Yx, Yy, Yw, Yh
end.
if. #Y2CAPTION do.
  Y2x=: Y2x + dx - dw
  Y2xywh=: Y2x, Y2y, Y2w, Y2h
end.
)
getframebox=: 3 : 0
if. 0 = #FRAMESTYLE do.
  FrameX=: -. IfBar
else.
  FrameX=: 'o' e. FRAMESTYLE
end.
if. #Frame do.
  'Fx Fy Fw Fh'=: Fxywh=: Frame return.
end.

if. 0 = #Data do. return. end.

x=. y=. r=. t=. 0
if. (YAxes -: 1 0) *. XDiv >: MaxAxisInt do.
  YAxes=: 0 1
  Y2Label=: YLabel
  Y2Tics=: YTics
  YTics=: YLabel=: ''
end.
if. #;XLabel do.
  mxlab=. MXlabel
  'xlw xlh'=. LabelFont pgetextent XLabel
  lx=. >.-:{.xlw
  lr=. 0 >. >.-:{:xlw
else.
  xlw=. xlh=. mxlab=. lx=. lr=. 0
end.
if. #;YLabel do.
  mylab=. MYlabel
  'ylw ylh'=. LabelFont pgetextent YLabel
  ly=. MGxy + (TICMAJOR * FrameX=0) + >.-:{.ylh
  lt=. 0 >. >.-:{:ylh
else.
  ylw=. ylh=. mylab=. ly=. lt=. 0
end.
YLabelHeight=: {. ylh
if. {:YAxes do.
  if. #;Y2Label do.
    mylab=. MYlabel
    'yrw yrh'=. LabelFont pgetextent Y2Label
    lr=. lr >. mylab + (>./ yrw)
    lt=. lt >. >.-:{:yrh
  else.
    ylw=. ylh=. mylab=. ly=. lt=. 0
  end.
end.
if. DimType=3 do.
  if. #;ZLabel do.
    'zlw zlh'=. LabelFont pgetextent ZLabel
    lx=. >./lx,zlw
    ly=. >./xlh,ylh,zlh
  end.
end.
if. FRAME +. XDiv=0 do.
  x=. lx >. mylab + >./ylw
else.
  x=. lx
end.
if. FRAME +. IfBar +. YDiv=0 do.
  y=. ly >. mxlab + {. >./xlh
else.
  y=. ly
end.
if. TicOut do.
  x=. x + TICMAJOR
  y=. y + TICMAJOR
  lr=. lr + TICMAJOR * {:YAxes
elseif. IfBar do.
  y=. y + TICMAJOR
end.
mrg=. rndint x,y,lr,lt
if. DimType=3 do.
  mrg=. 4 $ >./ mrg
end.
Fxywh=: Lxywh shrinkrect mrg
'Fx Fy Fw Fh'=: Fxywh
)
getminor=: 4 : 0
(y > 2) * 3 + 2 = (pow10 >. log10 x) % x
)
getminmax=: 4 : 0

'int tic ticpos min max log'=. y
if. log=1 do.
  dat=. (pow10 int);tic;(pow10 ticpos);(pow10 min);(pow10 max);2
  log10 each x getminmax dat return.
end.
min=. (10 ^ <. _2.9 + 10 ^. | min) rounddown min
max=. (10 ^ <. _2.9 + 10 ^. | max) roundup max
if. 0=#int do.
  if. max > 0 do.
    int=. 0 >. min
  else.
    int=. max
  end.
end.
min,max,int
)
gettfm=: 3 : 0
view=. VIEWPOINT-VIEWCENTER
ViewDist=: dist view
n=. view % ViewDist
v=. unitvec VIEWUP - n * n mp VIEWUP
t=. (v cross n),.v,.n
r=. -VIEWCENTER mp t
tfm=. (t,.0),r,1
XYZMin=: XMin,YMin,ZMin
XYZDiff=: (XMax,YMax,ZMax)-XYZMin
fitxyz=: [: movepos & XYZMin scalepos & XYZDiff
fit=. ((VIEWSIZE*=i.3)%XYZDiff),(-0.5+XYZMin%XYZDiff),1
Tfm=: fit mp tfm
)
getgrafbox=: 3 : 0
if. DimType=3 do.
  Gxywh=. Fxywh shrinkrect TICMAJOR * TicOut
else.
  if. FRAME *. FrameX do.
    Gxywh=: Fxywh shrinkrect TICMAJOR + MGxy
  else.
    Gxywh=: Fxywh
  end.
end.
'Gx Gy Gw Gh'=: Gxywh
)
lfmt=: 3 : 0
dat=. ": y
txt=. ,dat
($dat) $ '-' (I. txt='_') } txt
)
getlabelbox=: 3 : 0

lxywh=. Oxywh

if. ifouterkey'' do.

  'lx ly lw lh'=. lxywh
  lr=. lx + lw
  ls=. ly + lh

  if. 'h' e. KEYSTYLE do.
    if. 'b' e. KEYPOS do.
      ly=. Ky + Kh
    else.
      ls=. Ky
    end.
  else.
    if. 'r' e. KEYPOS do.
      lr=. Kx
    elseif. 'c' e. KEYPOS do.
      if. 'b' e. KEYPOS do.
        ly=. Ky + Kh
      else.
        ls=. Ky
      end.
    elseif. do.
      lx=. Kx + Kw
    end.
  end.
  lxywh=. lx,ly,(lr-lx),ls-ly

end.

'Lx Ly Lw Lh'=: Lxywh=: lxywh shrinkrect MLxy + MXlabel,MYlabel
)
getlabels=: 3 : 0

fm=. FRAME +. ORIGINXLABEL

if. (0=#XLabel) *. 0 { LABELS do.
  b=. (XInt=XTicPos) *. (XInt=0) >: YDiv e. 0 1
  ndx=. I. (DimType=2) *. fm<b
  XLabel=: (<'') ndx } lfmt each pow10 ^: XLOG XTicPos
end.
if. (0=#YLabel) *. 1 { LABELS do.
  b=. (YInt=YTicPos) *. (YInt=0) >: XDiv e. 0 1
  ndx=. I. (DimType=2) *. fm<b
  YLabel=: (<'') ndx } lfmt each pow10 ^: YLOG YTicPos
end.

if. DimType=2 do.
  if. {:YAxes do.
    if. (0=#Y2Label) *. 2 { LABELS do.
      b=. (Y2Int=Y2TicPos) *. (Y2Int=0) >: XDiv e. 0 1
      ndx=. I. (DimType=2) *. fm<b
      Y2Label=: (<'') ndx } lfmt each pow10 ^: Y2LOG Y2TicPos
    end.
  end.
  return.
end.
if. (0=#ZLabel) *. 2 { LABELS do.
  b=. (ZInt=ZTicPos) *. (ZInt=0) >: XDiv e. 0 1
  ndx=. I. (DimType=2) *. FRAME<b
  ZLabel=: (<'') ndx } lfmt each pow10 ^: ZLOG ZTicPos
end.
)
getinnerboxes=: 3 : 0
getframebox''
getgrafbox''
getaspect''
getinnerkeybox''
)
getouterlayout=: 3 : 0
if. IfPie do.
  setouterkey''
end.
getkeysize''
getouterboxes''
getouterkeybox''
)
getlayout=: 3 : 0
TicOut=: 'o' e. TICSTYLE
getouterlayout''
getlabelbox''
getaxes''
if. IfPie do.
  FRAME=: 0
  getpieframes'' return.
end.
if. 1 e. TYPE e. 'contour';'density' do.
  FRAME=: +./ AXES,FRAME
end.
getlabels''
getinnerboxes''
if. DimType=3 do.
  gettfm''
end.
)
getmultilayout=: 3 : 0
setouterkey''
getkeysize''
getouterboxes''
getouterkeybox''
getlabelbox''
)
setouterkey=: 3 : 0
KEYPOS=: ~.'o',KEYPOS -. 'i'
)
getouterboxes=: 3 : 0

'ox oy ow oh'=. Dxywh
or=. ox + ow
os=. oy + oh
if. #TITLE do.
  'Tw Th'=: (TitleFont pgetextent1 TITLE) + +: MTitle
  Tx=: Dx + -: Dw - Tw
  Ty=: Dy + Dh - Th
  Txywh=: Tx,Ty,Tw,Th
  os=. os <. Ty
else.
  'Tx Ty Tw Th'=: Txywh=: Dx,(Dy+Dh),0 0
end.
if. #SUBTITLE do.
  'Vw Vh'=: (SubTitleFont pgetextent1 SUBTITLE) + +: MSubTitle
  Vx=: Dx + -: Dw - Vw
  Vy=: Ty - Vh
  Vxywh=: Vx,Vy,Vw,Vh
  os=. os <. Vy
else.
  'Vx Vy Vw Vh'=: Vxywh=: Tx,Ty,0 0
end.
if. (-.IfPie) *. #YCAPTION do.
  'Yh Yw'=: (CaptionFont pgetextent1 YCAPTION) + +: MYCaption
  Yx=: Dx
  Yy=: Dy + -: Dh - Yh
  if. #TITLE,SUBTITLE do.
    if. (Tx<.Vx) < Yx+Yw do.
      Yy=: Dy >. Yy <. Vy - Yh
    end.
  end.
  Yxywh=: Yx,Yy,Yw,Yh
  ox=. ox >. Yx + Yw
else.
  'Yx Yy Yw Yh'=: Yxywh=: Dx,Dy,0 0
end.
if. #Y2CAPTION do.
  'Y2h Y2w'=: (CaptionFont pgetextent1 Y2CAPTION) + +: MYCaption
  Y2x=: Dx + Dw - Y2w
  Y2y=: Dy + -: Dh - Y2h
  if. #TITLE,SUBTITLE do.
    if. ((Tx+Tw)>.Vx+Vw) > Y2x do.
      Y2y=: Dy >. Y2y <. Vy - Y2h
    end.
  end.
  Y2xywh=: Y2x,Y2y,Y2w,Y2h
  or=. or <. Y2x
else.
  'Y2x Y2y Y2w Y2h'=: Y2xywh=: (Dx+Dw),Dy,0 0
end.
if. #XCAPTION do.
  'Xw Xh'=: (CaptionFont pgetextent1 XCAPTION) + +: MXCaption
  Xx=: Dx + -: Dw - Xw
  Xy=: Dy

  if. #YCAPTION do.
    if. Yy < Xy + Xh do.
      Xx=: Xx >. Yx + Yw
    end.
  end.

  if. #Y2CAPTION do.
    if. Y2y < Xy + Xh do.
      Xx=: 0 >. Xx <. Yx - Xw
    end.
  end.
  Xxywh=: Xx,Xy,Xw,Xh
  oy=. oy >. Xy + Xh
else.
  'Xx Xy Xw Xh'=: Xxywh=: Dx,Dy,0 0
end.
'Ox Oy Ow Oh'=: Oxywh=: ox,oy,(or-ox),os-oy
)
movepielabels=: 3 : 0

pos=. y
org=. y
len=. #pos
'Lmw Lmh'=: <. -: 2 3 { Lxywh
whilst. -. old -: pos do.

  old=. pos
  msk=. rectoverlaps pos
  if. -. 1 e. msk do.
    0;pos return.
  end.
  msk=. msk, 2 {. msk
  if. -. 0 e. msk do.
    pos=. moveoutpielabels pos continue.
  end.
  ndx=. 1 + I. 0 1 E. msk

  for_i. ndx do.
    'cur nxt'=. (len | i + 0 1) { pos
    if. (i+2) { msk do.
      new=. cur movepielabelback nxt
      pos=. new i } pos
    else.
      new=. cur separatepielabel nxt
      pos=. new (len | i + 0 1) } pos
    end.
    if. -. pos -: old do. break. end.
  end.

end.

(pos-:org);pos
)
moveoutpielabels=: 3 : 0
'x y w h'=. |: y
x=. x + * x
y=. y + * y
x=. (-Lmw) >. x <. Lmw - w
y=. (-Lmh) >. y <. Lmh - h
x,.y,.w,.h
)
movepielabelback=: 4 : 0

'lx ly lw lh'=. x
'rx ry rw rh'=. y
ox=. (lw+rw) + (lx<.rx) - (lx+lw)>.rx+rw
oy=. (lh+rh) + (ly<.ry) - (ly+lh)>.ry+rh
ox=. ox + 3
oy=. oy + 3
ang=. (ly - -: lh) getangle lx + -: lw
if. (ox % | cos ang) < oy % | sin ang do.
  mx=. ox
  my=. >. mx * | ly%lx
else.
  my=. oy
  mx=. >. my * | lx%ly
end.

mx=. mx * _1 ^ ly > 0
my=. my * _1 ^ lx < 0

lx=. lx + mx
ly=. ly + my

lx,ly,lw,lh
)

separatepielabel=: 4 : 0
'lx ly lw lh'=. x
'rx ry rw rh'=. y
ox=. (lw+rw) + (lx<.rx) - (lx+lw)>.rx+rw
oy=. (lh+rh) + (ly<.ry) - (ly+lh)>.ry+rh
ox=. >. 2 + -: ox
oy=. >. 2 + -: oy
ang=. (ly - -: lh) getangle lx + -: lw
rad=. -: Gh
if. rad < ly <. ry do.
  lx=. lx - ox
  rx=. rx + ox
elseif. rad < - (ly+lh) <. ry+rh do.
  lx=. lx + ox
  rx=. rx - ox
elseif. rad < rx <.ry do.
  ly=. ly - oy
  ry=. ry + oy
elseif. rad < - (rx+rw) <. ry+rw do.
  ly=. ly + oy
  ry=. ry - oy
elseif. do.
  if. (ox % | cos ang) < oy % | sin ang do.
    mx=. ox
    my=. >. mx * | ly%lx
  else.
    my=. oy
    mx=. >. my * | lx%ly
  end.
  mx=. mx * _1 ^ ly > 0
  my=. my * _1 ^ lx < 0
  lx=. lx + mx
  rx=. rx - mx
  ly=. ly + my
  ry=. ry - my
end.

lx=. (-Lmw) >. (lx + *lx) <. Lmw - lw
ly=. (-Lmh) >. (ly + *ly) <. Lmh - lh
rx=. (-Lmw) >. (rx + *rx) <. Lmw - rw
ry=. (-Lmh) >. (ry + *ry) <. Lmh - rh
(lx,ly,lw,lh),:rx,ry,rw,rh
)
rotxy=: 4 : 0
rot=. 2 2$ 1 1 _1 1 * 0 1 1 0 { 2 1 o. x
rot +/ . * "2 1 y
)
getticpos=: 4 : 0

'int tic min max log cnt'=. y

if. log do. x gettplog y return. end.
if. max ~: min do.
  nmm=. 10 ^ <. <: 10 ^. max - min
  min=. nmm rounddown min
  max=. nmm roundup max
end.

def=. cnt <. (DimType=3) { 10 6
step=. {.tic
wid=. max - min
if. wid=0 do.
  if. #int do.
    if. int=min do.
      'min max'=. straddle min
    else.
      'min max'=. sort int, min
    end.
  else.
    'min max'=. straddle int=. min
  end.
end.
if. #int do.
  max=. max >. int
  min=. min <. int
else.
  if. (min <: 0) *. max >: 0 do.
    int=. 0
  end.
end.
if. step > 0 do.
  s=. step * 1 + i.10
else.
  s=. 1 2 5 10 20 50 100 * pow10 <: <. log10 max - min
end.

if. min < 0 do.
  x=. s roundup min
else.
  x=. s rounddown min
end.
if. max > 0 do.
  y=. s rounddown max
else.
  y=. s roundup max
end.
c=. <. (y - x) % s
ndx=. (c <: def) i. 1
step=. ndx { s,0

if. (step=0) +. ndx = #x do.
  pos=. ''
else.
  pos=. (ndx{x) + step * i. 1 + ndx{c
  min=. min <. {. pos
  max=. max >. {: pos
end.
if. 0=#int do.
  if. max > 0 do.
    int=. 0 >. min
  else.
    int=. max
  end.
end.
step;min;max;int;pos
)
gettics=: 3 : 0
'tics minor max min log'=. y
if. (minor=0) +. 1 >: #tics do.
  tics;(#tics)$TICMAJOR return.
end.
if. log do.
  tics=. pow10 min + tics * max - min
  tmax=. pow10 max
  tmin=. pow10 min
  tics=. (tics - tmin) % tmax - tmin
  'pos mark'=. gettics tics;minor;0;0;0
  pos=. tmin + pos * tmax - tmin
  pos=. ((log10 pos) - min) % max - min
  pos;mark return.
end.
bgn=. {. tics
end=. {: tics
dif=. end - bgn

step=. minor + 1
len=. ((}.-}:) tics) % step
pos=. bgn + 0, +/\ step # len

if. dif = 1 do.
  mark=. (#pos) $ (1,minor) # TICMAJOR,TICMINOR
else.
  pos=. (bgn - +/\. minor # {. len), pos, end + +/\ minor # {:len
  mark=. ($pos) $ (minor,1) # TICMINOR,TICMAJOR
  msk=. (pos >: 0) *. pos <: 1
  pos=. msk # pos
  mark=. msk # mark
end.

pos;mark
)
gettplog=: 4 : 0
'int tic lmin lmax log cnt'=. y
def=. cnt <. (DimType=3) { 8 6
if. 2.9 < lmax-lmin do.
  max=. >.lmax
  min=. <.lmin
  step=. >.(max-min)%def
  if. 0=#int do.
    int=. min
  else.
    min=. min <. log10 int
  end.
  pos=. min+step*i.>:>.(max-min)%step
  step;min;max;int;pos return.
end.
min=. pow10 lmin
max=. pow10 lmax
if. max ~: min do.
  nmm=. 10 ^ <. <: 10 ^. max - min
  min=. nmm rounddown min
  max=. nmm roundup max
end.

step=. {.tic
wid=. max - min
if. wid=0 do.
  if. #int do.
    if. int=min do.
      'min max'=. straddle min
    else.
      'min max'=. sort int, min
    end.
  else.
    'min max'=. straddle int=. min
  end.
end.
if. #int do.
  max=. max >. int
  min=. min <. int
else.
  if. (min <: 0) *. max >: 0 do.
    int=. 0
  end.
end.
if. step > 0 do.
  s=. step * 1 + i.10
else.
  s=. 1 2 5 10 20 50 100 * pow10 <: <. log10 max - min
end.
x=. s rounddown min
y=. s rounddown max
c=. <. (y - x) % s
ndx=. (c <: def) i. 1
step=. ndx { s,0

if. (step=0) +. ndx = #x do.
  pos=. ''
else.
  pos=. (ndx{x) + step * i. 1 + ndx{c
  min=. min <. {. pos
  max=. max >. {: pos
end.
if. 0=#int do.
  int=. min
end.
if. min=0 do.
  pmin=. pow10 lmin
  min=. <. pmin
  if. min=0 do.
    p=. 10 ^ -i.15
    b=. 10 ^ - 1 i.~ pmin >: p
    min=. ({:p) >. b * <. pmin % b
  end.
  int=. int >. min
  pos=. pos >. min
end.

min=. log10 min
max=. log10 max
int=. log10 int
pos=. log10 pos

step;min;max;int;pos

)
coclass 'jzplot'
Y2Axis=: <'Y2AXIS'
j=. 'xint xmin xmax yint ymin ymax y2int y2min y2max zint zmin zmax'
SubCmds=: ;:'axes frame labels ',j
drawbackground=: 3 : 0
if. CLEAR do.
  drawrect iBACKGROUND;BACKCOLOR;1;BACKCOLOR;boxwh2rs Dxywh
  if. #FRAMEBACKCOLOR do.
    drawrect iBACKGROUND;FrameBackColor;1;FrameBackColor;boxwh2rs Fxywh
  end.
  if. #GRAPHBACKCOLOR do.
    drawrect iBACKGROUND;GraphBackColor;1;GraphBackColor;boxwh2rs Gxywh
  end.
  CLEAR=: 0
end.
)
getdeftype=: 3 : 0
t=. 0
if. (3 = #y) *. L. y do.
  t=. (ifplotf y) +. 2 = #$_1 pick y
end.
t { 'line';'surface'
)
getdims=: 3 : 0
'data types'=. y
if. 1 e. types e. PlotData3d -. PlotData2d do.
  dd=. 3
elseif. 1 e. types e. PlotData2d -. PlotData3d do.
  dd=. 2
elseif. do.
  dd=. >./ 2, getdim &> {:"1 data
end.
if. 1 e. types e. PlotTypes3d -. PlotTypes2d do.
  dt=. 3
elseif. 1 e. types e. PlotTypes2d -. PlotTypes3d do.
  dt=. 2
elseif. do.
  dt=. dd
end.

dd,dt
)

getdim=: [: # $^:(0 = L.)
getmulticmd=: 3 : 0
res=. i. 0 2
if. 0 e. $y do. return. end.
mat=. citemize y
for_m. mat do.
  'cmd dat'=. m
  'hdr cmd'=. pdcmdhdr boxcmd cmd
  cmd=. (1 + # &> hdr) }. each cmd
  cmd=. setoptions hdr,.cmd
  res=. res, cmd,'data';<dat
end.
)
getsubcmds=: 3 : 0
if. isboxed 0 pick y do.
  ;getsubcmds each y
else.
  'cmd dat'=. y
  if. #cmd do.
    cmd=. boxcmd cmd
    msk=. -. ({."1 cmd) e. SubCmds
    (msk # cmd), 'data';<dat
  else.
    ,:'data';<dat
  end.
end.
)
makepos_xy=: 3 : 0
'x y'=. y
if. 'p' e. x do.
  'x y'=. makepos_coords x;y
end.
tx=. (Dx,Dw) makepos1 x
ty=. (Dy,Dh) makepos1 y
tx,ty
)
makepos_coords=: 3 : 0
'x y'=. y
x=. roundint getgrafx 0 ". x -. 'p'
y=. getgrafy 0 ". y -. 'p'
y=. roundint y + -: {: (maketextfont TEXTFONT) pgetextent 'X'
(": each x,y) ,each 'x'
)
makepos_xywh=: 4 : 0

if. 0 = #y do. x return. end.

'Bx By Bw Bh'=. x
if. ischar y do.
  'x y r s'=. <;._1 ' ',deb y
  tx=. (Bx,Bw) makepos1 x
  tr=. (Bx,Bw) makepos1 r
  ty=. (By,Bh) makepos1 y
  ts=. (By,Bh) makepos1 s
  tx,ty,(tr-tx),ts-ty
else.
  (4 $ Bw,Bh) * (boxrs2wh y) % 1000
end.
)
makepos1=: 4 : 0
'b w'=. x
t=. 0 ". y -. 'x'
select. (0 > t), 'x' e. y
case. 0 0 do.
  b + w * t % 1000
case. 0 1 do.
  b + t
case. 1 0 do.
  b + w * (1 + 1000 | t) % 1000
case. 1 1 do.
  b + 1 + w | t
end.
)
settypeflags=: 3 : 0
types=. y
IfBar=: 1 e. types e. BarTypes
IfFrame=: 1 e. types e. FrameTypes
IfBand=: 1 e. types e. BandTypes
IfPie=: 1 e. types e. PieTypes
)
makedata_init=: 3 : 0
DataNdx=: 0
getlayout''
drawbackground''
drawtrims''
drawfxywh 1
drawgd 0
)
makenodata=: 3 : 0
getouterlayout''
drawbackground''
getinnerboxes''
drawgd 0
)
MultiDefs=: <;._2 (0 : 0)
BACKCOLOR
ITEMCOLOR
KEY
KEYSTYLE
KeyExtent
KeyFont
Kxywh
SUBTITLE
SUBTITLECOLOR
SUBTITLEFONT
SUBTITLESTYLE
SubTitleFont
TITLE
TITLECOLOR
TITLEFONT
TITLESTYLE
TitleFont
Txywh
Vxywh
XCAPTION
XCAPTIONSTYLE
Xxywh
Y2CAPTION
Y2CAPTIONSTYLE
YCAPTION
YCAPTIONSTYLE
Yxywh
ZCAPTION
ZCAPTIONSTYLE
)
definemultidefs=: 3 : 0
pdefs y
'Kx Ky Kw Kh'=: Kxywh
'Tx Ty Tw Th'=: Txywh
'Vx Vy Vw Vh'=: Vxywh
'Xx Xy Xw Xh'=: Xxywh
'Yx Yy Yw Yh'=: Yxywh
)
MultiGroups=: <;._2 (0 : 0)
XGROUP
YGROUP
ZGROUP
)
MultiHdrs=: MultiDefs,MultiGroups,<;._2 (0 : 0)
CLEAR
COLOR
OUTPUT
)
getxgroup=: 4 : 0
dat=. y
for_n. x </. i.#x do.
  ind=. > n
  dat=. (getxgroup1 ind { dat) ind } dat
end.
)
getxgroup1=: 3 : 0
dat=. y
if. 1 = #dat do. return. end.

if. 1 < # ~. (pDimData,pDimType) {"1 dat do.
  'Incompatible types in XGROUP' assert 0
end.

int=. ; pXINT {"1 dat
if. #int do.
  dat=. (< <./int) pXINT }"1 dat
end.

rng=. > pXRANGE {"1 dat
rng=. ({.<./rng),.{:>./rng
dat=. (<rng) pXRANGE }"1 dat

lab=. ~. (pXLABEL {"1 dat) -. a:
select. #lab
case. 0 do.
case. 1 do.
  dat=. lab pXLABEL }"1 dat
case. do.
  'Incompatible labels in XGROUP' assert 0
end.

dat

)
getygroup=: 4 : 0
dat=. y
for_n. x </. i.#x do.
  ind=. > n
  dat=. (getygroup1 ind { dat) ind } dat
end.
)

getygroup1=: 3 : 0
dat=. y
if. 1 = #dat do. return. end.

if. 1 < # ~. (pDimData,pDimType) {"1 dat do.
  'Incompatible types in YGROUP' assert 0
end.

int=. ; pYINT {"1 dat
if. #int do.
  dat=. (< <./int) pYINT }"1 dat
end.

rng=. > pYRANGE {"1 dat
rng=. ({.<./rng),.{:>./rng
dat=. (<rng) pYRANGE }"1 dat

lab=. ~. (pYLABEL {"1 dat) -. a:
select. #lab
case. 0 do.
case. 1 do.
  dat=. lab pYLABEL }"1 dat
case. do.
  'Incompatible labels in YGROUP' assert 0
end.

dat
)
make=: 3 : 0
'out xywh'=. y
setoutput out
setpxywh xywh
Plot=: i. 0 0
Ndx=: 1
cmd=. setoptions PCmd
makesub cmd
Plot=: Plot /: {."1 Plot
EMPTY
)
makemulti=: 3 : 0

setplotdefaults 'new'
setsubdxywh''

'cmd pos'=. {. y
dat=. }. y
if. 0 = #dat do.
  drawbackground '' return.
end.
if. ',' e. pos do.
  ndx=. pos i. ','
  pos=. (0 ". ndx {. pos) ; 0 ". (ndx + 1) }. pos
else.
  pos=. (0 ". pos) # each 1
end.
Shape=: # &> pos
len=. */ Shape
ndx=. ({."1 dat) i. <'data'
opts=. ndx {. dat
cmds=. getmulticmd each 1 pick ndx { dat
msk=. ({."1 e. FontOpts"_) each cmds
mopts=. ; msk #each cmds
cmds=. (-.each msk) # each cmds
mopts=. mopts ,~ (-. ({."1 opts) e. MultiHdrs) # opts
mopts=. (|. ~: |. {."1 mopts) # mopts
defineoptions opts
setfonts''
getmultilayout''
multidefs=. packs MultiDefs
multigroups=. packs MultiGroups
drawbackground''
setplotdefaults 'new'
pdefs multigroups
if. *./ (XGROUP;YGROUP;ZGROUP) e. '';i.len do.
  mxywh=. Lxywh makesubshape pos
  for_i. i.#cmds do.
    Sxywh=: i { mxywh
    cmd=. ('new';''), mopts
    cmd=. cmd, i pick cmds
    makenew cmd
  end.
else.
  mxywh=. makemultigroup mopts;cmds;<pos
end.
makemulti_fini multidefs;mxywh
)
makemultigroup=: 3 : 0
'opts cmds pos'=. y

if. Y2Axis e. ; {."1 each cmds do.
  signal 'Y2Axis not supported in grouped Multiplots'
end.

len=. */ 'rws cls'=. shape=. # &> pos
if. #XGROUP do.
  if. -. (#XGROUP) e. 1,cls,len do.
    signal 'Number of X groups should be one of 1, ',(":cls),', ',":len
  end.
else.
  XGROUP=: i.len
end.
if. #YGROUP do.
  if. -. (#YGROUP) e. 1,rws,len do.
    signal 'Number of Y groups should be one of 1, ',(":rws),', ',":len
  end.
else.
  YGROUP=: i.len
end.
XGroup=: i.~ len $ XGROUP
YGroup=: i.~ len $ ((len=#YGROUP) { cls,1) # YGROUP

IfMXlabs=: 1 = #~. shape $ XGroup
IfMYlabs=: 1 = #~. |: shape $ YGroup
def=. (". each PDefNames) & getpdef &> cmds
def=. XGroup getxgroup def
def=. YGroup getygroup def
mxywh=. Lxywh makesubshape pos
fxywh=. i. 0 4
for_i. i.#def do.
  setplotdefaults 'new'
  defineoptions opts
  setdxywh i { mxywh
  fxywh=. fxywh, getframesize i { def
end.

fxywh=. fitmulti fxywh
def=. (<"1 fxywh) pFrame }"0 1 def
for_i. i.#def do.
  setplotdefaults 'new'
  defineoptions opts
  setdxywh i { mxywh
  makepdef i { def
end.

mxywh
)
makemulti_fini=: 3 : 0
'defs mxywh'=. y
definemultidefs defs
drawtitle''
drawsubtitle''
drawmulticaptions mxywh
drawborder''
drawkey''
Ndx=: Ndx + 3
)
drawmulticaptions=: 3 : 0
mxywh=. Shape $ y
if. #XCAPTION do.
  xcap=. boxarg XCAPTION
  if. 1=#xcap do.
    drawxcaption''
  else.
    cls=. 1 { $ mxywh
    xcap=. cls {. xcap
    for_i. i.cls do.
      mat=. i {"2 mxywh
      Xx=: 0 { <./mat
      Xw=: 2 { >./mat
      XCAPTION=: i pick xcap
      drawxcaption''
    end.
  end.
end.
if. #YCAPTION do.
  ycap=. boxarg YCAPTION
  if. 1=#ycap do.
    drawycaption''
  else.
    rws=. {. $ mxywh
    ycap=. rws {. ycap
    for_i. i.rws do.
      mat=. i { mxywh
      Yy=: 1 { <./mat
      Yh=: 3 { >./mat
      YCAPTION=: i pick ycap
      drawycaption''
    end.
  end.
end.
)
getframesize=: 3 : 0
(PDefNames)=: y
if. 0=#Data do.
  Dxywh return.
end.
defineoptions 0 pick Opts
setfonts''
settypeflags ;Types
getlayout''
Fxywh
)
fitmulti=: 3 : 0
fxw=. 0 2 {"1 y
fyh=. 1 3 {"1 y

'r c'=. Shape
len=. r * c

if. #XGroup do.
  xg=. XGroup + len $ len * i.c
  fxw=. xg fitmulti1 fxw
end.

if. #YGroup do.
  yg=. YGroup + c # len * i.r
  fyh=. yg fitmulti1 fyh
end.

0 2 1 3 {"1 fxw,.fyh
)
fitmulti1=: 4 : 0
}."1 /:~ ; x fitmulti2 /. (i.#y),.y
)
fitmulti2=: 3 : 0
'i fx fw'=. |: y
fx=. >./fx
fw=. (<./fx+fw) - fx
<i,"0 1 fx,fw
)
setcolorrep=: 3 : 0
if. *./ 1 = DataRep do. return. end.
f=. 4 : 'y #~ 1 >. (#y) {. x'
COLOR=: DataRep f COLOR
BANDCOLOR=: DataRep f BANDCOLOR
ITEMCOLOR=: DataRep f ITEMCOLOR
)
defineoptions=: 3 : 0
if. #y do.
  ({."1 y)=: {:"1 y
end.
)
definecolor=: 3 : 0
if. #COLOR do.
  if. IfBand do.
    BANDCOLOR=: COLOR
  else.
    ITEMCOLOR=: COLOR
  end.
  COLOR=: ''
end.
if. #FRAMEBACKCOLOR do.
  FrameBackColor=: FRAMEBACKCOLOR
else.
  FrameBackColor=: BACKCOLOR
end.
if. #GRAPHBACKCOLOR do.
  GraphBackColor=: GRAPHBACKCOLOR
else.
  GraphBackColor=: FrameBackColor
end.
)
setoptions=: 3 : 0

if. 0 e. $y do. i.0 0 return. end.

mat=. citemize y

opt=. toupper each {."1 mat
if. 0 e. opt e. DefOpts,PDDefs,PDGD do.
  j=. tolower 0 pick opt -. DefOpts,PDDefs,PDGD
  signal 'option not found: ', j
end.

arg=. {:"1 mat

ndx=. I. opt e. DefOpts
def=. ndx { opt

if. Y2Axis e. def do.
  ind=. I. ('Y' = {.&> def) > +./\. Y2Axis = def
  new=. (<'Y2') ,each }. each ind { def
  def=. new ind } def
end.

val=. {:"1 ndx { mat
ind=. DefOpts i. def
typ=. ind { DefOptx

for_i. i.#def do.

  dat=. i pick val
  select. i{typ
  case. 'A' do.
    dat=. boxarg dat
  case. 'B' do.
    dat=. boxarg tolower dat
  case. 'C' do.
  case. 'D' do.
    dat=. dat rplc '<br/>';LF
  case. 'F' do.
    dat=. getfont dat
  case. 'K' do.
    dat=. keyarg dat
  case. 'M' do.
    dat=. SEPARATOR mfv dat
  case. 'N' do.
    dat=. {. fix dat
  case. 'T' do.
    dat=. +/ ". &> 'i'&, each boxarg toupper comma2blank dat
  case. 'U' do.
    dat=. toupper {. dat
  case. 'V' do.
    dat=. fix dat
  case. 'X' do.
    dat=. ".toupper dat
  case. 'Y' do.
    dat=. _3[\, rndint ".toupper dat
  case. 'S' do.
    select. i pick def
    case. 'MARKERS' do.
      dat=. MarkerNames setfixx dat
    case. 'KEYMARKERS' do.
      dat=. KeyMarkerNames setfixx dat
    case. do.
      signal 'plot option not supported'
    end.
  case. do.
    signal 'plot option not supported'
  end.
  val=. (<dat) i } val
end.

mat=. (def,.val) ndx } mat
)
setfixx=: 4 : 0
if. *./ y e. '0123456789 ' do.
  fix y
else.
  y=. ',',tolower y
  x i. a: -.~ (y e. ', ') <;._1 y
end.
)
makenew=: 3 : 0

dat=. y
'cmd rect'=. {. dat
dat=. }. dat

setplotdefaults cmd
setsubdxywh rect
if. (1 = #dat) *. 'BACKCOLOR' -: 0 pick {. dat do.
  defineoptions dat
  dat=. ''
end.
if. 0 = #dat do.
  drawbackground '' return.
end.
msk=. ({."1 dat) e. PlotOpts
defineoptions msk # dat
dat=. (-.msk) # dat
makepdef (". each PDefNames) getpdef dat
)
makepdef=: 3 : 0
(PDefNames)=: y

defineoptions 0 pick Opts
setfonts''
settypeflags ;Types
setcolorrep''
definecolor''
if. 0=#Data do.
  makenodata ''
else.
  makedata_init {.Y2Msk
  mat=. (Y2Msk ;&> i.#Y2Msk),.Opts,.Types
  for_m. mat do.
    maketype m
  end.
end.
makenew_fini''
)
makenew_fini=: 3 : 0
drawgd 1
drawfxywh 0
drawbackground''
maketext''
makerule''
drawtitle''
drawsubtitle''
drawborder''
drawkey''
if. SHOWBOXES do.
  drawbox iBOX;BLUE;GUIDESIZE;Lxywh
  drawbox iBOX;RED;GUIDESIZE;Fxywh
  drawbox iBOX;GREEN;GUIDESIZE;Gxywh
  dat=. Kxywh,Txywh,Xxywh,Yxywh,:Y2xywh
  dat=. dat #~ 0 < +/"1 dat
  for_d. dat do.
    drawbox iBOX;MAGENTA;GUIDESIZE;d
  end.
end.
Ndx=: Ndx + 3
)
getpdef=: 4 : 0

(PDefNames)=. x

cmd=. y
hdr=. {."1 cmd
msk=. hdr e. PDgd
if. 1 e. msk do.
  gl2=. msk#cmd
  ndx=. ({."1 gl2) i. <'gdend'
  Gcmd0=. ndx {. gl2
  Gcmd1=. (ndx+1) }. gl2
  cmd=. (-.msk) # cmd
  hdr=. {."1 cmd
end.
msk=. (4 {.each hdr) e. 'rule';'RULE'
if. 1 e. msk do.
  Rule=. msk#cmd
  cmd=. (-.msk) # cmd
  hdr=. {."1 cmd
end.
msk=. (4 {.each hdr) e. 'text';'TEXT'
if. 1 e. msk do.
  Text=. msk#cmd
  cmd=. (-.msk) # cmd
  hdr=. {."1 cmd
end.
if. -. (<'data') e. hdr do.
  (hdr)=. {:"1 cmd
  Opts=. < cmd #~ -. hdr e. PDefNames
  ". each PDefNames return.
end.
if. (<'TYPE') e. hdr do.
  type=. 1 pick (hdr i. <'TYPE') { cmd
else.
  if. #TYPE do.
    type=. TYPE
  else.
    type=. getdeftype 1 pick (hdr i. <'data') { cmd
  end.
end.
msk=. hdr e. DefOpts
def=. msk # cmd
({."1 def)=. {:"1 def
PlotfDefs=: ". each PlotfNames
msk=. hdr = <'data'
dat=. msk ((}:;{:@{:));.2 cmd
'dat rep'=. getverbres dat
DataRep=. rep
opts=. {."1 dat
hdrs=. {."1 each opts
dats=. {:"1 dat
hdrmsk=. -. each hdrs e. each <PDefNames
Opts=. hdrmsk #each opts
Types=. (<'TYPE')&dictget &> opts
if. 0 = # 0 pick Types do.
  Types=. (<type) 0 } Types
end.
'DimData DimType'=. getdims dats;<type

Data=. DimData getdata &> dats

if. 0 = +/ # &> {."1 Data do.
  Data=. 0 # Data
end.

if. POLAR *. DimType=2 do.
  Data=. getpolar "1 Data
end.
ndx=. i.#Data
ind=. (Y2Axis & e. &> hdrs) i. 1
Y2Msk=. ndx >: ind
if. (1 e. Y2Msk) *. DimData = 3 do.
  signal 'Two Y axes are not supported for 3D data.'
end.
YAxes=. (ind > {.ndx), ind <: {:ndx
if. (1 e. type e. FrameTypes) +. {:YAxes do.
  FRAME=. 1
end.
'XRANGE YRANGE Y2RANGE ZRANGE'=. getdatarange (;Types);Data;Y2Msk;YAxes
({."1 def)=. {:"1 def
if. XLOG do.
  Data=. (log10 each 0 {"1 Data) 0 }"0 1 Data
  XINT=. log10 XINT
  XRANGE=. log10 XRANGE
end.
if. YLOG do.
  ndx=. I. -. Y2Msk
  Data=. (log10 each (<ndx;1) { Data) (<ndx;1) } Data
  YINT=. log10 YINT
  YRANGE=. log10 YRANGE
end.
if. Y2LOG do.
  ndx=. I. Y2Msk
  Data=. (log10 each (<ndx;1) { Data) (<ndx;1) } Data
  Y2INT=. log10 Y2INT
  Y2RANGE=. log10 Y2RANGE
end.
if. ZLOG do.
  Data=. (log10 each 2 {"1 Data) 2 }"0 1 Data
  ZINT=. log10 ZINT
  ZRANGE=. log10 ZRANGE
end.
AXES=. 3$AXES
LABELS=. 3$LABELS
GRIDS=. 3$GRIDS
TICS=. 3$TICS

if. Y2Msk do.
  AXES=. 0 (1)} AXES
  GRIDS=. 0 (1)} GRIDS
  TICS=. 0 (1)} TICS
end.

XTIC=. XTIC,(#XTIC)}._1 _1
YTIC=. YTIC,(#YTIC)}._1 _1
Y2TIC=. Y2TIC,(#Y2TIC)}._1 _1
ZTIC=. ZTIC,(#ZTIC)}._1 _1
". each PDefNames
)
getverbres=: 3 : 0
r=. i. 0 2
s=. ''
for_d. y do.
  v=. _1 pick d
  if. 0 = #v do.
    r=. r,d
  elseif. ifplotf v do.
    v=. plotsubd v
    s=. s, # &> v
    r=. r,({.d),.<"1 ;v
  elseif. do.
    r=. r,d
    s=. s,1
  end.
end.
r;s
)
makerule=: 3 : 0

for_p. Rule do.
  cmd=. {.p
  arg=. 1 pick p
  if. -. cmd e. PDdefs do.
    (cmd)=. arg
  else.
    arg=. <;._2 (deb arg),' '
    pos1=. makepos_xy 2 {. arg
    pos2=. makepos_xy _2 {. arg
    drawline iRULE;RULECOLOR;RULESIZE;pos1,pos2
  end.
end.
)
cocurrent 'jzplot'

bSub=: <'sub'
bEndSub=: <'endsub'
makesub=: 3 : 0
pcmd=. y
ndx=. ({."1 pcmd) i. bSub
if. ndx do.
  makesubdo ndx {. pcmd
  pcmd=. ndx }. pcmd
end.
if. #pcmd do.
  cmds=. {."1 pcmd
  msk=. 1, 0 = }: +/\ (bSub=cmds)-bEndSub=cmds
  msk=. firstones msk
  pcmd=. msk <;.1 pcmd
  for_p. pcmd do.
    makesubin >p
  end.
end.
)
makesubdo=: 3 : 0
pcmd=. y
if. -. ({. {. pcmd) e. PDcmds do.
  pcmd=. ('new';''), pcmd
end.
msk=. ({."1 pcmd) e. PDcmds
pcmd=. msk <;.1 pcmd
for_p. pcmd do.
  p=. > p
  'cmd arg'=. {. p
  if. #Mxywh do.
    if. 0 = # arg do.
      Sxywh=: Mndx { Mxywh
      Mndx=: (#Mxywh) | Mndx + 1
    end.
  end.
  if. cmd -: 'multi' do.
    makemulti p
  else.
    makenew p
  end.
end.
)
makesubin=: 3 : 0
pcmd=. y
if. bSub = {. {. pcmd do.

  val=. 1 pick {. pcmd
  pcmd=. }. pcmd
  pcmd=. (- bEndSub={:pcmd) }. pcmd
  if. ',' e. val do.
    ndx=. val i. ','
    val=. (0 ". ndx {. val) ; 0 ". (ndx + 1) }. val
    smat=. Sxywh makesubshape val
    sxywh=. {. smat
  else.
    if. 2 = # 0 ". val do.
      smat=. Sxywh makesubshape (0 ". val) # each 1
      sxywh=. {. smat
    else.
      smat=. ''
      sxywh=. Sxywh makepos_xywh val
      if. 1 e. 1 >: _2 {. sxywh do. return. end.
    end.
  end.
  pushsxywh smat;sxywh
  makesub pcmd
  popsxywh ''
else.
  makesub pcmd
end.
)
makesubshape=: 4 : 0
xy=. 2 {. x
wh=. _2 {. x
txy=. > { (scale01 1 pick y);scale01 |. 0 pick y
txy=. xy +"1 txy *"1 wh
bl=. _1 _1 }. txy
tr=. 1 1 }. txy
rec=. rndint bl ,"1 tr - bl
,/ |. 0 2 |: rec
)
maketext=: 3 : 0

for_p. Text do.
  cmd=. {.p
  arg=. 1 pick p
  if. -. cmd e. TextTypes do.
    (cmd)=. arg
  else.
    arg=. <;._2 (deb arg),' '
    pos=. makepos_xy 2 {. arg
    text=. towords 2 }. arg
    align=. TextTypes i. cmd
    font=. maketextfont TEXTFONT
    drawtext iTEXT;align;font;TEXTCOLOR;text;pos
  end.

end.
)
maketextfont=: 3 : 0
font=. getfontid y
if. Poutput e. iANDROID do.
  font=. getgtkfontid font
elseif. Poutput e. iQT do.
  font=. getgtkfontid font
elseif. Poutput = iISI do.
  font=. getisifontid font
end.
)
maketype=: 3 : 0

'y2 ndx opt type'=. y

defineoptions opt
definecolor''

if. #type do.
  DataNdx=: 0
  TYPE=: type
end.
if. y2 do.
  sety2vals''
end.
p=. (DimType=3) { 'plot_';'plot3d_'
fns=. p ,each TYPE
for_f. fns do.
  (>f)~ndx
end.
if. 1 e. TYPE e. 'errorbar';'hilo' do.
  DataNdx=: DataNdx + 1
else.
  DataNdx=: DataNdx + # citemize (<ndx;1) pick Data
end.
)
sety2vals=: 3 : 0
((<'Y') ,each AxisOut)=: ". each (<'Y2') ,each AxisOut
)
coclass 'jzplot'
j=. 'data endsub multi new rule sub text textc textr type use'

PDdefs=: ;: j
PDDefs=: ;: toupper j
j=. 'brushcolor end lines pen pencolor rect'
PDgd=: 'gd'&, each ;: j
PDGD=: 'GD'&, each ;: toupper j
PDshow=: ;: 'cairo canvas eps android qt jpf pdf isi print show'
PDcopy=: ;: 'clip save get'
PDget=: ;: 'pdfr canvasr'
PDcmds=: ;: 'multi new use'
boxcmd=: 3 : 0
if. L. y do. y return. end.
if. 2 = #$y do.
  y=. ,y,.';'
end.
y=. y,';'
b=. (y e. ';',LF) > ~:/\ y e. '"'
a: -.~ b (<@dlb) ;._2 y
)
getoptions=: 3 : 0
cmd=. boxcmd y
hdr=. tolower each head each cmd
if. 1 e. b=. hdr e. KEYWORDS do.
  new=. boxcmd @ ". @ toupper each b # cmd
  cmd=. <S:0 new (I. b) } y
  hdr=. tolower each head each cmd
end.
hdr,.(1 + # &> hdr) }.each cmd
)
pdreset=: 3 : 0
readplotdefaults''
setplotdefaults 'plot'
if. #y do.
  if. 0=L. y do.
    PForm=: y
  else.
    if. 2~:#y do.
      sminfo 'invalid argument to pdreset' return.
    end.
    'f c'=. y
    p=. 2 {."1 wdforms''
    i=. <./ (|:p) i:"1 <f
    if. i=#p do.
      sminfo 'form not found: ',f return.
    end.
    'PForm PFormhwnd'=: i{p
    PId=: c
    if. IFQT do.
      ". PForm,'_',PId,'_paint__COCREATOR=: qt_paint_',(>coname''),'_'
    elseif. IFJA do.
      ". PForm,'_',PId,'_paint__COCREATOR=: android_paint_',(>coname''),'_'
    elseif. do.
      ". PForm,'_',PId,'_paint__COCREATOR=: isi_paint_',(>coname''),'_'
    end.
  end.
end.
PReset=: 1
pdcmdsave=: ''
pdcmdclip=: 0
pdcmdprint=: 0
EMPTY
)
pd=: 3 : 0

dat=. y

if. 0 = #dat do. return. end.

if. ischar dat do.
  pdcmd boxcmd dat return.
end.

if. isboxed dat do.
  if. 1 < #$dat do.
    dat=. pddefverb each <"1 dat
  elseif. ischar 0 pick dat do.
    pdcmd dat return.
  elseif. do.
    dat=. pddefverb dat
  end.
end.

if. -. PReset do. pdreset'' end.
PCmd=: PCmd,'data';<dat
EMPTY
)
pdcmd=: 3 : 0

cmd=. y
if. 0=#cmd do. EMPTY return. end.

'hdr cmd'=. pdcmdhdr cmd

len=. # hdr
cnt=. 1 + # &> hdr
if. len > ndx=. hdr i. <'reset' do.
  pdreset 6 }. ndx pick cmd
  pdcmd (ndx+1) }. cmd return.
end.
if. -. PReset do. pdreset'' end.
prm=. cnt }. each cmd
if. len = ndx=. <./ hdr i. PDshow,PDcopy,PDget do.
  PCmd=: PCmd, hdr ,. prm
else.
  PCmd=: PCmd, (ndx {. hdr) ,. ndx {. prm
  r=. ('pd_',ndx pick hdr)~ndx pick prm
  if. #r do. return. end.
  pdcmd (>:ndx) }. cmd
end.
EMPTY
)
pdcmdhdr=: 3 : 0
cmd=. y
hdr=. tolower each head each cmd
if. 1 e. b=. hdr e. KEYWORDS do.
  new=. boxcmd @ ". @ toupper each b # cmd
  cmd=. <S:0 new (I. b) } y
  hdr=. tolower each head each cmd
end.

hdr;<cmd
)
pddefverb=: 3 : 0
v=. _1 pick y
if. 2 ~: 3!:0 v do. y return. end.
v=. < caller plotdefverbm`plotdefverbd@.(3=#y) v
v _1 } y
)
pd_android=: android_show
pd_eps=: eps_show
pd_canvas=: canvas_show
pd_canvasr=: canvas_get
pd_cairo=: cairo_show
pd_qt=: qt_show
pd_pdf=: pdf_show
pd_pdfr=: pdf_get
pd_jpf=: pdf_jpf
pd_isi=: isi_show
pd_clip=: qt_clip`android_clip`isi_clip@.((IFQT,IFJA)&i.1)
pd_print=: qt_print`android_print`isi_print@.((IFQT,IFJA)&i.1)
pd_save=: qt_save`android_save`isi_save@.((IFQT,IFJA)&i.1)
pd_get=: qt_get`android_get`isi_get@.((IFQT,IFJA)&i.1)
pd_show=: 3 : 0
ndx=. ({."1 PCmd) i. <'output'
if. ndx < #PCmd do.
  OUTPUT=: 1 pick ndx{PCmd
end.
out=. dlb OUTPUT
fn=. 'pd_', tolower ' ' taketo out
arg=. ' ' takeafter out
fn~arg
EMPTY
)
coclass 'jzplot'
ANDROID_DEFSIZE=: 400 200
ANDROID_DEFFILE=: jpath '~temp/plot'
ANDROID_PENSCALE=: 0.4
fext=: 4 : 0
f=. deb y
f, (-. x -: (-#x) {. f) # x
)
gettemp=: 3 : 0
p=. jpath '~temp/'
d=. 1!:0 p,'*.',y
a=. 0, {.@:(0&".)@> _4 }. each {."1 d
a=. ": {. (i. >: #a) -. a
p,a,'.',y
)
andfontdesc=: 3 : 0
'ind fst siz ang und'=. y
'ita bld'=. 2 2 #: fst
sty=. (bld#' bold'),(ita#' italic'),und#' underline'
if. ' ' e. nam=. ind pick ANDFONTNAMES do. nam=. '"', nam, '"' end.
nam,sty,' ',":siz
)

android_getsize=: 3 : 0
if. -. wdishandle :: 0: ": PFormhwnd do. '' return. end.
wd 'psel ', ":PFormhwnd
s=. wdqchildxywh ::0: PId
if. s -: 0 0 0 0 do. '' return. end.
2 3 { s
)
output_parms=: 4 : 0
'size file'=. x
if. #y do.
  prm=. qchop y
  select. #prm
  case. 1 do.
    file=. 0 pick prm
  case. 2 do.
    size=. 0 ".&> prm
  case. 3 do.
    file=. 0 pick prm
    size=. 0 ". &> _2 {. prm
    if. 0 e. size do.
      size=. 0 ". &> 2 {. prm
      file=. 2 pick prm
    end.
  end.
else.
  if. #sz=. android_getsize'' do.
    size=. sz
  end.
end.
size;file
)
android_clip=: 3 : 0
if. -. IFWIN do.
  info 'Save plot to clipboard is only available in Windows'
  return.
end.
f=. gettemp 'emf'
android_emf dquote f
wd 'clipcopyx enhmetafile ',dquote f
1!:55 <f
)
android_gpcount=: ,"1~ 1 + [: {: 1 , $
android_gpcut=: 3 : 0
r=. ''
while. #y do.
  n=. {. y
  if. n=0 do.
    info 'zero length segment at: ',":#;r
    r
    return.
  end.
  r=. r, < n {. y
  y=. n }. y
end.
r
)
android_gpbuf=: 3 : 0
assert. 2 > #$y
buf=: buf,y
)
android_gpapply=: 3 : 0
rc=. glcmds buf
assert. 0=rc [ 'glcmds buf'
buf=: $0
)
android_gpflip=: flipxy @ rndint
android_gpfliplast=: 3 : 0
(<android_gpflip _1 pick y) _1 } y
)
android_gpinit=: 3 : 0
buf=: bufdef=: $0
r=. ''
r=. r,3 2003 1
r=. r,3 2071 1
buf=: r
)
android_gpbrushnull=: 3 : '2 2005'
android_gppens=: 4 : 0
y=. rndint y
5 2032,"1 x,"1 [ 4 2022,"1 y,.(y~:0){PS_NULL,PS_SOLID
)
android_gppen=: 4 : 0
y=. rndint y
5 2032,(,x),4 2022,y,(y~:0){PS_NULL,PS_SOLID
)
android_gppens1=: 3 : 0
5 2032,"1 y,"1 [ 4 2022 1,PS_SOLID
)
android_gppen1=: 3 : 0
5 2032,(,y),4 2022 1,PS_SOLID
)
android_gppenbrush1=: 3 : 0
5 2032,(,y),4 2022 1,PS_SOLID,2 2004
)
android_gppixel=: 3 : 0
's t f e c p'=. y
p=. android_gpcount 2024 ,"1 android_gpflip p
if. is1color e do.
  android_gpbuf e android_gppen 1
  android_gpbuf ,p
else.
  rws=. #p
  e=. rws $ citemize e
  pen=. e android_gppens 1
  android_gpbuf ,pen ,. p
end.
)
android_gppline=: 4 : 0
's t f e c p'=. y
if. (is1color e) *. 1 = #s do.
  android_gpbuf (,e) android_gppen s
  android_gpbuf ,android_gpcount x,"1 p
else.
  rws=. #p
  e=. rws $ citemize e
  s=. rws $ s
  pen=. e android_gppens s
  android_gpbuf ,pen ,. android_gpcount x,"1 p
end.
)
android_gppshape=: 4 : 0
'v s f e c p'=. y

if. v=0 do. e=. c end.

if. is1color e do.
  android_gpbuf e android_gppen v
  if. isempty c do.
    android_gpbuf android_gpbrushnull''
    android_gpbuf ,android_gpcount x,"1 p
  elseif. is1color c do.
    android_gpbuf 5 2032,(,c),2 2004
    android_gpbuf ,android_gpcount x,"1 p
  elseif. do.
    c=. (#p) $ c
    clr=. 5 2032 ,"1 c ,"1 [ 2 2004
    android_gpbuf , clr ,. android_gpcount x,"1 p
  end.
else.
  e=. (#p) $ e
  e=. e android_gppens v
  if. isempty c do.
    android_gpbuf android_gpbrushnull''
    android_gpbuf , e ,. android_gpcount x,"1 p
  elseif. is1color c do.
    android_gpbuf 5 2032,(,c),2 2004
    android_gpbuf , e ,. android_gpcount x,"1 p
  elseif. do.
    c=. (#p) $ c
    clr=. 5 2032 ,"1 c ,"1 [ 2 2004
    android_gpbuf , e ,. clr ,. android_gpcount x,"1 p
  end.

end.
)
androidarc=: 3 : '2001 android_gppline android_gpfliplast y'
androidline=: 3 : '2015 android_gppline android_gpfliplast y'
androidpie=: 3 : '2023 android_gppshape android_gpfliplast y'
androidpoly=: 3 : '2029 android_gppshape android_gpfliplast y'
androidcircle=: 3 : 0
p=. _1 pick y
ctr=. android_gpflip 0 1 {"1 p
rad=. rndint 2 {"1 p
xy=. ctr - rad
wh=. +: rad ,. rad
p=. xy ,. wh
2008 android_gppshape (<p) _1 } y
)
androiddot=: 3 : 0
'v s f e c p'=. y
select. v
case. 1 do.
  android_gppixel y
case. 2 do.
  p=. android_gpflip p
  p=. (p-1) ,"1 [ 2 2
  dat=. 1;0;0;e;e;p
  2031 android_gppshape dat
case. 3 do.
  h=. (p-"1[1 0) ,. p+"1[2 0
  v=. (p-"1[0 1) ,. p+"1[0 2
  androidline 1;0;0;e;e;h,v
case. do.
  o=. >. -: v
  p=. p ,"1 v,.v
  androidcircle 1;0;0;e;e;p
end.
)
androidfxywh=: 3 : 0
p=. _1 pick y
if. #p do.
  'x y w h'=. p
  xy=. _1 + <. x,Ch-y+h
  wh=. 2 + >. w,h
  android_gpbuf 6 2078,xy,wh
else.
  android_gpbuf 2 2079
end.
)
androidmarker=: 3 : 0
's m f e c p'=. y
p=. android_gpflip p
android_gpbuf android_gppenbrush1 e
s ('androidmark_',m)~ p
)
androidpie=: 3 : 0
p=. _1 pick y
ctr=. android_gpflip 0 1 {"1 p
rad=. 2 {"1 p
ang=. 3 4 {"1 p
xy=. ctr - rad
wh=. +: rad ,. rad
tx=. ({."1 ctr) + rad * sind ang
ty=. ({:"1 ctr) + rad * cosd ang
p=. rndint xy ,. wh ,. ,"2 tx ,"0 ty
2023 android_gppshape (<p) _1 } y
)
androidpline=: 3 : 0
's t f e c p'=. y
if. *./ t = 0 do.
  androidline y return.
end.
p=. android_gpflip p
t=. t { PENPATTERN
if. (is1color e) *. 1 = #s do.
  android_gpbuf 5 2032,(,e),4 2022,s,PS_SOLID
  pos=. t linepattern"0 1 p
  android_gpbuf ,android_gpcount 2015,"1 pos
else.
  rws=. #p
  e=. rws $ citemize e
  s=. rws $ s
  t=. rws $ t
  pen=. e android_gppens s
  for_i. i.#p do.
    android_gpbuf i{pen
    pos=. (i{t) linepattern i{p
    android_gpbuf ,android_gpcount 2015,"1 pos
  end.
end.
)
androidrect=: 3 : 0
p=. boxrs2wh^:1 android_gpflip _1 pick y
y=. (<p) _1 } y
2031 android_gppshape y
)
androidtext=: 3 : 0
't f a e c p'=. y

degree0=. 3{f
f=. andfontdesc^:(0={.0#f) f
p=. android_gpflip p
t=. text2utf8 each boxopen t
if. a do.
  glfontextent f
  off=. <. -: a * {."1 wh=. glqextent &> t
  if. (90=degree0)+.(1 e. 'angle900' E. f) do.
    p=. p +"1 [ ({:wh),.off
  elseif. (270=degree0)+.(1 e. 'angle2700' E. f) do.
    p=. p -"1 [ ({:wh),.off
  elseif. do.
    p=. p -"1 off,. - {:"1 wh
  end.
end.
'face size style degree'=. parseFontSpec f
android_gpbuf android_gpcount 2312,(<.size*10),style,(<.degree0*10),alfndx,face
if. is1color e do.
  android_gpbuf 5 2032,(,e),2 2040
  if. rank01 p do.
    android_gpbuf android_gpcount 2056,p
    android_gpbuf android_gpcount 2038,alfndx,>t
  else.
    t=. android_gpcount each 2038 ,each alfndx each t
    t=. (<"1 android_gpcount 2056 ,"1 p) ,each t
    android_gpbuf ; t
  end.
else.
  t=. android_gpcount each 2038 ,each alfndx each t
  t=. t ,each <"1 android_gpcount 2056 ,"1 p
  t=. (<"1 (5 2032 ,"1 e) ,"1 [ 2 2040) ,each t
  android_gpbuf ; t
end.

)
parseFontname=: 3 : 0
font=. ' ',y
b=. (font=' ') > ~:/\font='"'
a: -.~ b <@(-.&'"');._1 font
)
FontStyle=: ;:'regular bold italic underline strikeout'

parseFontSpec=: 3 : 0
'ns styleangle'=. 2 split parseFontname y
'face size'=. ns
size=. 12". size
style=. FontStyle i. tolower each styleangle
style=. <.+/2^<:(style ((> 0) *. <) #FontStyle) # style
if. 1 e. an=. ('angle'-:5&{.)&> styleangle do.
  degree=. 10%~ 0". 5}.>(an i. 1){styleangle
else.
  degree=. 0
end.
face;size;style;degree
)
androidmark_circle=: 4 : 0
s=. rndint x * 3
p=. (y - s) ,"1 >: +: s,s
android_gpbuf ,android_gpcount 2008 ,"1 p
)
androidmark_diamond=: 4 : 0
s=. rndint x * 4
'x y'=. |: y
p=. (x-s),.y,.x,.(y+s),.(x+s),.y,.x,.y-s
android_gpbuf ,android_gpcount 2029 ,"1 p
)
androidmark_line=: 4 : 0
'x y'=. , y
p=. >.(x--:KeyLen),(y--:KeyPen),<:KeyLen,KeyPen
android_gpbuf ,android_gpcount 2031 ,p
)
androidmark_plus=: 4 : 0
s=. rndint 4 1 * x
p=. (y -"1 s) ,"1 +: s
s=. |. s
p=. p , (y -"1 s) ,"1 +: s
android_gpbuf ,android_gpcount 2031 ,"1 p
)
androidmark_square=: 4 : 0
s=. rndint x * 3
p=. (y - s) ,"1 +: s,s
android_gpbuf ,android_gpcount 2031 ,"1 p
)
androidmark_times=: 4 : 0
if. x = 1 do.
  p=. (y - 3) ,. y + 4
  q=. (y - "1 [ 3 _3) ,. y +"1 [ 4 _4
  p=. p, (p +"1 [ 0 1 _1 0), p + "1 [ 1 0 0 _1
  q=. q, (q +"1 [ 0 _1 _1 0), q +"1 [ 1 0 0 1
  android_gpbuf ,android_gpcount 2015 ,"1 p,q
else.
  s=. rndint _1 + 3 * x
  n=. rndint 2 * x
  p=. (y - s) ,. y + s
  q=. (y - "1 s * 1 _1) ,. y +"1 s * 1 _1
  android_gpbuf 4 2022,n,PS_SOLID
  android_gpbuf ,android_gpcount 2015 ,"1 p,q
end.
)
androidmark_triangle=: 4 : 0
s=. rndint 2 * x
t=. rndint 4 * x
'x y'=. |: y
p=. rndint (x-t),.(y+s),.(x+t),.(y+s),.x,.y-t
android_gpbuf ,android_gpcount 2029 ,"1 p
)
PRINTP=: ''
android_print=: 3 : 0
if. PRINTP do. wd 'psel ',(":PRINTP),';pclose' end.
wd 'pc print;cc g canvas'
PRINTP=: wdqhwndp''
PRINTED=: 0
opt=. '"" "" "" orientation ',":ORIENTATION
glprint opt
)
print_g_print=: 3 : 0
'page pass'=. ". sysdata
select. pass
case. _1 do.
  PRINTP=: PRINTPXYWH=: 0
  wd 'pclose'
case. 0 do.
  glprintmore -.PRINTED
case. do.
  'Cw Ch'=: glqprintwh''
  android_paintit android_printwin''
  PRINTED=: 1
end.
)
android_printwin=: 3 : 0
'pw ph mw mh'=. 4 {. glqprintpaper''
mrg=. 0 >. PRINTMARGIN - mw,(ph - mh + Ch),(pw - mw + Cw),mh
xywh=. (0 0,Cw,Ch) shrinkrect mrg
if. 0 = #PRINTWINDOW do.
  xywh
else.
  if. 4 ~: #PRINTWINDOW do.
    info 'PRINTWINDOW should be of form: x y wh' return.
  end.
  'x y w h'=. xywh
  'px py pw ph'=. PRINTWINDOW%1000
  fx=. x + px * w
  fy=. y + py * h
  fw=. (x-fx) + pw * w
  fh=. (y-fy) + ph * h
  fx,fy,fw,fh
end.
)
android_bmp=: 3 : 0
if. #y do.
  arg=. qchop y
  num=. __ ". &.> arg
  msk=. __ e. &> num
  file=. > {. msk # arg
  wh=. >(-.msk) # num
  if. -. (#wh) e. 0 2 do.
    info 'invalid [w h] parameter in save bmp' return.
  end.
else.
  wh=. file=. ''
end.
file=. file,(0=#file)#android_DEFFILE
file=. jpath '.bmp' fext file
if. (2 = #wh) > wh -: Pw,Ph do.
  a=. cocreate''
  coinsert__a (,copath) coname''
  bitmap=. android_getbitmapwh__a wh
  coerase a
else.
  bitmap=. android_getbitmap''
end.
bitmap writebmp file
)
android_png=: 3 : 0
if. #y do.
  arg=. qchop y
  num=. __ ". &.> arg
  msk=. __ e. &> num
  file=. > {. msk # arg
  wh=. >(-.msk) # num
  if. -. (#wh) e. 0 2 do.
    info 'invalid [w h] parameter in save png' return.
  end.
else.
  wh=. file=. ''
end.
file=. file,(0=#file)#android_DEFFILE
file=. jpath '.png' fext file
if. (2 = #wh) > wh -: Pw,Ph do.
  a=. cocreate''
  coinsert__a (,copath) coname''
  bitmap=. android_getbitmapwh__a wh
  coerase a
else.
  bitmap=. android_getbitmap''
end.
bitmap writepng file
)
android_def=: 4 : 0
type=. x
file=. jpath ('.',type) fext (;qchop y),(0=#y) # android_DEFFILE
(android_getrgb'') writeimg file
)
android_defstr=: 4 : 0
type=. x
(android_getrgb'') putimg type
)
android_emf=: 3 : 0
file=. jpath '.emf' fext (;qchop y),(0=#y) # android_DEFFILE
wd 'psel ',": PFormhwnd
glsel PId
glfile file
glemfopen''
android_paint''
glemfclose''
)
android_getbitmap=: 3 : 0
wd 'psel ',": PFormhwnd
glsel PId
box=. wdqchildxywh PId
res=. glqpixels box
(3 2 { box) $ res
)
android_getbitmapwh=: 3 : 0
wd 'pc a owner;wh 480 300;cc g canvas;pas 0 0'
PFormhwnd=: wdqhwndp''
PId=: 'g'
wd 'set g wh ',":y
wd 'pshow'
glpaint''
res=. android_getbitmap''
wd 'pclose'
res
)
android_getrgb=: 3 : 0
wd 'psel ',": PFormhwnd
glsel PId
box=. wdqchildxywh PId
(3 2 { box) $ 256 256 256 #: glqpixels box
)
android_jpg=: 3 : 0
file=. ''
qual=. 100
if. #y do.
  arg=. qchop y
  num=. __ ". &.> arg
  msk=. +./ &> num = &.> __
  file=. > {. msk # arg
  qual=. <. {. (>(-.msk) # num),qual
end.
file=. jpath '.jpg' fext file,(0=#file) # android_DEFFILE
rgb=. android_getrgb''
rgb writeimg file
)
android_png=: 3 : 0
file=. ''
comp=. 9
if. #y do.
  arg=. qchop y
  num=. __ ". &.> arg
  msk=. +./ &> num = &.> __
  file=. > {. msk # arg
  comp=. <. {. (>(-.msk) # num),comp
end.
file=. jpath '.png' fext file,(0=#file) # android_DEFFILE
rgb=. android_getrgb''
rgb writeimg file
)
android_save=: 3 : 0
if. Poutput ~: iANDROID do.
  msg=. 'First display an canvas Plot.'
  info msg return.
end.
if. 0=#y do.
  android_clip'' return.
end.
type=. tolower firstword y
if. (<type) e. ;: 'gif jpg png tif gifr jpgr pngr tifr' do.
  af=. jpath '~addons/media/platimg/platimg.ijs'
  if. -. flexist af do.
    info 'Save to ',type,' requires the platimg addon.' return.
  end.
  require af
end.
('android_',type)~ (1+#type) }. y
)

android_get=: 3 : 0
if. #y do.
  type=. tolower firstword y
  if. (<type) e. ;: 'gif jpg png tif' do.
    y=. type,'r ', (#type)}. y
  end.
end.
android_save y
)
android_gif=: 'gif' & android_def
android_tif=: 'tif' & android_def
android_pngr=: 'png' & android_defstr
android_jpgr=: 'jpg' & android_defstr
android_gifr=: 'gif' & android_defstr
android_tifr=: 'tif' & android_defstr
android_show=: 3 : 0
popen_android''
)
android_show2=: 3 : 0
if. 0~: 4!:0 <'VISIBLE' do. '' return. end.
if. PShow=0 do.
  if. VISIBLE do.
    wd 'pshow ',PSHOW
  else.
    wd 'pshow hide'
  end.
  wd 'ptop ',":PTop
  PShow=: 1
else.
  if. VISIBLE do.
    wd 'ptop'
  end.
end.
''
)
android_paint=: 3 : 0
selectpid''
'Cw Ch'=: glqwh''
android_paintit 0 0,Cw,Ch
glpaintx''
0
)
android_paintit=: 3 : 0
android_gpinit''
try.
  make iANDROID;y
catch.
  PCmd=: Plot=: i.0 0
  info ({.~i.&LF) 13!:12''
end.
if. 0=#Plot do. return. end.
ids=. 1 {"1 Plot
fns=. 'android'&, each ids
dat=. 3 }."1 Plot
for_d. dat do.
  (>d_index{fns)~d
end.
android_gpapply''
)
coclass 'jzplot'
CAIRO_DEFSIZE=: 400 300
CAIRO_DEFFILE=: jpath '~temp/plot.png'
CAIRO_PENSCALE=: 0.4

plotcs=: plotcr=: 0
cairo_getparms=: 3 : 0
(CAIRO_DEFSIZE;CAIRO_DEFFILE) output_parms y
)
cairo_write=: 3 : 0
file=. y
assert. 0~:plotcr
while. 0 ~: cairo_surface_write_to_png_jcairo_ (cairo_get_target_jcairo_ plotcr) ; file do.

  msg=. 'Unable to write to file: ',file,LF,LF
  if. #d=. 1!:0 file do.
    msg=. msg, 'If the file is open in a viewer, close the file and try again.'
    if. 1 query msg do. return. end.
  else.
    info msg,'The file name is invalid.' return. end.
end.
if. (VISIBLE > IFJHS) do.
  viewimage_j_ file
end.
EMPTY
)
cairo_color=: 4 : 0
assert. 0~:plotcr
assert. 3=#,y
cairo_set_source_rgb_jcairo_ plotcr ; ;/ ,y%256
EMPTY
)
cairo_makerect=: 3 : 0
'x y r s'=. y
cairo_drawline (_2 [\ flipxy x,y,x,s,r,s,r,y,x,y)
EMPTY
)
cairo_drawline=: 3 : 0
assert. 0~:plotcr
assert. 1<$$y
cairo_move_to_jcairo_ plotcr ; ;/ {.y
for_p. }.y do.
  cairo_line_to_jcairo_ plotcr ; ;/ p
end.
EMPTY
)
cairo_makelines=: 3 : 0
len=. -: {: $ y
if. len = 0 do. i.0 0 return. end.
if. 2 > #$y do.
  cairo_drawline _2 [\ flipxy y
else.
  cairo_drawline "2 (_2 [\"1 flipxy y)
end.
EMPTY
)
cairo_pens=: 4 : 0
assert. 0 [ 'cairo_pens not implemented'
EMPTY
)
cairo_pen=: 4 : 0
assert. 0~:plotcr
0 cairo_color x
cairo_set_line_width_jcairo_ plotcr ; (1>.CAIRO_PENSCALE*y)
EMPTY
)
cairo_lines=: 3 : 0
(cairo_stroke_jcairo_ bind plotcr)@cairo_makelines"1 y
EMPTY
)
cairo_text=: 3 : 0
'fnt txt pos align rot und'=. y
pos=. citemize pos
txt=. ,each boxxopen txt
txt=. utf8 each txt
te=. (5*8)$(2.2-2.2)
te=. _1{:: cairo_font_extents_jcairo_ plotcr; te
of=. - 0 , <. {.te
if. und +. align e. iCENTER, iRIGHT do.
  len=. fnt pgetstringlen txt
end.
if. 1=#txt do. txt=. (#pos)#{.txt end.

select. rot
case. 0 do.
  select. align
  case. iCENTER do.
    pos=. pos -"1 (-:len),.0
  case. iRIGHT do.
    pos=. pos -"1 len,.0
  end.
  for_i. i.#pos do.
    cairo_move_to_jcairo_ plotcr ; <"0 flipxy of + i{pos
    cairo_show_text_jcairo_ plotcr;(,>i{txt)
  end.
case. 1 do.
  select. align
  case. iCENTER do.
    pos=. pos -"1 [ 0,.-:len
  case. iRIGHT do.
    pos=. pos -"1 [ 0,.len
  end.
  for_i. i.#pos do.
    cairo_save_jcairo_ plotcr
    cairo_move_to_jcairo_ plotcr ; <"0 flipxy of + i{pos
    cairo_rotate_jcairo_ plotcr ; - 0.5p1
    cairo_show_text_jcairo_ plotcr;(,>i{txt)
    cairo_restore_jcairo_ plotcr
  end.
case. 2 do.
  select. align
  case. iCENTER do.
    pos=. pos +"1 [ 0,.-:len
  case. iRIGHT do.
    pos=. pos +"1 [ 0,.len
  end.
  for_i. i.#pos do.
    cairo_save_jcairo_ plotcr
    cairo_move_to_jcairo_ plotcr ; <"0 flipxy of + i{pos
    cairo_rotate_jcairo_ plotcr ; 0.5p1
    cairo_show_text_jcairo_ plotcr;(,>i{txt)
    cairo_restore_jcairo_ plotcr
  end.
end.

if. -. und do. EMPTY return. end.
pos=. citemize pos
len=. , len
off=. <. -/ 2 0{te

select. rot
case. 0 do.
  bgn=. 0 >. pos -"1 [ 0,.-off
  end=. bgn + len,.0
case. 1 do.
  bgn=. 0 >. pos -"1 off,.0
  end=. bgn + 0,.len
case. 2 do.
  bgn=. 0 >. pos +"1 off,.0
  end=. bgn - 0,.len
end.

for_p. bgn,.end do.
  cairo_makelines p
  cairo_stroke_jcairo_ plotcr
end.

EMPTY
)
cairocircle=: 3 : 0
'v s f e c p'=. y
if. isempty c do.
  if. is1color e do.
    e cairo_pen v
    for_i. i.#p do.
      cairo_new_sub_path_jcairo_ plotcr
      cairo_arc_jcairo_ plotcr ; ;/ (flipxy 2{.i{p) , (2{i{p), 0, 2p1
      cairo_stroke_jcairo_ plotcr
    end.
  else.
    for_i. i.#p do.
      cairo_new_sub_path_jcairo_ plotcr
      cairo_arc_jcairo_ plotcr ; ;/ (flipxy 2{.i{p) , (2{i{p), 0, 2p1
      (i{e) cairo_pen (i{v)
      cairo_stroke_jcairo_ plotcr
    end.
  end.
else.
  p=. citemize p
  c=. p cmatch c
  e=. p cmatch e
  v=. p cmatch v
  for_i. i.#p do.
    cairo_new_sub_path_jcairo_ plotcr
    cairo_arc_jcairo_ plotcr ; ;/ (flipxy 2{.i{p) , (2{i{p), 0, 2p1
    (i{e) cairo_pen (i{v)
    cairo_stroke_preserve_jcairo_ plotcr
    1 cairo_color i{c
    cairo_fill_jcairo_ plotcr
  end.
end.
)
cairodot=: 3 : 0
'v s f e c p'=. y
p=. citemize p
v=. v * CAIRO_PENSCALE
if. is1color e do.
  1 cairo_color e
  for_i. i.#p do.
    cairo_new_sub_path_jcairo_ plotcr
    cairo_arc_jcairo_ plotcr ; ;/ (flipxy i{p) , v, 0, 2p1
    cairo_fill_jcairo_ plotcr
  end.
else.
  e=. p cmatch e
  for_i. i.#p do.
    1 cairo_color i{e
    cairo_new_sub_path_jcairo_ plotcr
    cairo_arc_jcairo_ plotcr ; ;/ (flipxy i{p) , v, 0, 2p1
    cairo_fill_jcairo_ plotcr
  end.
end.
)
cairofxywh=: 3 : 0
''return.
p=. _1 pick y
if. #p do.
  CLIP=: >: CLIP
  'x y w h'=. p
  rect=. cairo_makerect x,y,(x+w),y+h
  pbuf 'gsave ',rect,' clip newpath'
else.
  if. CLIP do.
    CLIP=: <: CLIP
    pbuf 'grestore'
  end.
end.
)
cairoline=: 3 : 0
'v s f e c p'=. y
if. (is1color e) *. 1 = #s do.
  pbuf e cairo_pen v
  pbuf cairo_lines p
else.
  rws=. #p
  e=. rws $ citemize e
  v=. rws $ v
  for_i. i. rws do.
    pbuf (i{e) cairo_pen i{v
    pbuf cairo_lines i{p
  end.
end.
)
cairomarker=: 3 : 0
('cairomark_',1 pick y)~ y
)
cairopie=: 3 : 0
'v s f e c p'=. y
pen=. e cairo_pen v
p=. citemize p
ctr=. 0 1 {"1 p
rad=. 2 {"1 p
ang=. 360 %~ 2p1 * 90 - 3 4 {"1 p
clr=. cmatch c
for_i. i.#p do.
  cairo_move_to_jcairo_ plotcr ; ;/ (flipxy i{ ctr)
  cairo_arc_negative_jcairo_ plotcr ; ;/ (flipxy i{ ctr) , (i{rad), (i{ang)
  cairo_close_path_jcairo_ plotcr
  cairo_stroke_preserve_jcairo_ plotcr
  1 cairo_color i{clr
  cairo_fill_jcairo_ plotcr
end.
)
cairopline=: 3 : 0
'v s f e c p'=. y
if. *./ s = 0 do.
  cairoline y return.
end.
s=. s { PENPATTERN
if. (is1color e) *. 1 = #v do.
  pos=. s linepattern"0 1 p
  cairoline (<pos) _1 } y
else.
  rws=. #p
  e=. rws $ citemize e
  v=. rws $ v
  s=. rws $ s
  for_i. i.#p do.
    (i{e) cairo_pen i{v
    pos=. (i{s) linepattern i{p
    cairoline (i{v);0;0;(i{e);0;pos
  end.
end.
)
cairopoly=: 3 : 0
'v s f e c p'=. y
p=. citemize p
if. v=0 do. e=. c end.
c=. p cmatch c
e=. p cmatch e
if. +/v do.
  v=. p cmatch v
  for_i. i.#p do.
    cairo_makelines i{p
    cairo_close_path_jcairo_ plotcr
    (i{e) cairo_pen i{v
    cairo_stroke_preserve_jcairo_ plotcr
    1 cairo_color i{c
    cairo_fill_jcairo_ plotcr
  end.
else.
  for_i. i.#p do.
    cairo_makelines i{p
    cairo_close_path_jcairo_ plotcr
    1 cairo_color i{c
    cairo_stroke_preserve_jcairo_ plotcr
    cairo_fill_jcairo_ plotcr
  end.
end.
)
cairorect=: 3 : 0
assert. 0~:plotcr
'v s f e c p'=. y
p=. citemize p
if. v=0 do. e=. c end.
c=. p cmatch c
e=. p cmatch e
if. +/v do.
  v=. p cmatch v
  for_i. i.#p do.
    cairo_makerect i{p
    (i{e) cairo_pen i{v
    cairo_stroke_preserve_jcairo_ plotcr
    1 cairo_color i{c
    cairo_fill_jcairo_ plotcr
  end.
else.
  for_i. i.#p do.
    cairo_makerect i{p
    1 cairo_color i{c
    cairo_fill_jcairo_ plotcr
  end.
end.
)
cairotext=: 3 : 0
't f a e c p'=. y
'fnx fst fsz fan und'=. f
rot=. 3 | 0 90 270 i. fan
asc=. _0.2 * pgetascender f
fnm=. getfntname fnx,fst
bold=. italic=. 0
if. (1 e. '-Oblique' E. fnm)+.(1 e. '-Bold' E. fnm)+.(1 e. '-Italic' E. fnm) do.
  bold=. (1 e. 'Bold' E. fnm)
  italic=. ((1 e. 'Oblique' E. fnm)+.(1 e. 'Italic' E. fnm))
  fnm=. ({.~ i:&'-') fnm
end.

cairofontangle=: <.fan*10
cairounderline=: Underline
cairo_select_font_face_jcairo_ plotcr ; fnm ; (italic{CAIRO_FONT_SLANT_NORMAL,CAIRO_FONT_SLANT_ITALIC); (bold{CAIRO_FONT_WEIGHT_NORMAL,CAIRO_FONT_WEIGHT_BOLD)
cairo_set_font_size_jcairo_ plotcr; getplotfontsize f
select. rot
case. 0 do. p=. 0 >. p -"1 [ 0, asc
case. 1 do. p=. p +"1 asc, 0
case. 2 do. p=. p -"1 asc, 0
end.
if. is1color e do.
  1 cairo_color e
  for_i. i.#p do.
    cairo_text f;t;p;a;rot;und
  end.
else.
  for_i. i.#e do.
    1 cairo_color i{e
    cairo_text f;(i{t);(i{p);a;rot;und
  end.
end.
)
cairomark_circle=: 3 : 0
's m f e c p'=. y
p=. citemize p
v=. 8 * s * CAIRO_PENSCALE
1 cairo_color e
for_i. i.#p do.
  cairo_new_sub_path_jcairo_ plotcr
  cairo_arc_jcairo_ plotcr ; ;/ (flipxy i{p) , v, 0, 2p1
  cairo_fill_jcairo_ plotcr
end.
)
cairomark_diamond=: 3 : 0
's m f e c p'=. y
p=. 8 $"1 citemize p
d=. (3.5 * s) * _1 0 0 1 1 0 0 _1
p=. p +"1 d
for_i. i.#p do.
  cairo_makelines i{p
  cairo_close_path_jcairo_ plotcr
  1 cairo_color e
  cairo_fill_jcairo_ plotcr
end.
)
cairomark_line=: 3 : 0
's m f e c p'=. y
p=. ,p
s=. -:KeyLen,KeyPen
p=. (p - s) , p + s
cairo_makerect p
cairo_close_path_jcairo_ plotcr
1 cairo_color e
cairo_fill_jcairo_ plotcr
)
cairomark_plus=: 3 : 0
's m f e c p'=. y
s=. s * 4
t=. s, 0
e cairo_pen s
p=. citemize p
d=. (p -"1 t) ,. p +"1 t
t=. |. t
d=. d, (p -"1 t) ,. p +"1 t
cairo_lines d
)
cairomark_square=: 3 : 0
's m f e c p'=. y
p=. citemize p
s=. 3 * s
p=. (p - s) ,"1 p + s
for_i. i.#p do.
  cairo_makerect i{p
  cairo_close_path_jcairo_ plotcr
  1 cairo_color e
  cairo_fill_jcairo_ plotcr
end.
)
cairomark_times=: 3 : 0
's m f e c p'=. y
e cairo_pen 4 * s
t=. _1 + s * 3
r=. (p - t) ,. p + t
s=. (p +"1 t * 1 _1) ,. p +"1 t * _1 1
cairo_lines r,s
)
cairomark_triangle=: 3 : 0
's m f e c p'=. y
p=. 6 $"1 citemize p
d=. (4 * s) * , (sin,.cos) 2p1 * 0 1 2 % 3
p=. p +"1 d
for_i. i.#p do.
  cairo_makelines i{p
  cairo_close_path_jcairo_ plotcr
  1 cairo_color e
  cairo_fill_jcairo_ plotcr
end.
)
JSESC0=: LF,CR,TAB,FF,(8{a.),'\''"'
JSESC1=: 'nrtfb\''"'
jsesc=: 3 : 0
txt=. y
msk=. txt e. JSESC0
if. 1 e. msk do.
  ndx=. , ((I. msk) + i. +/ msk) +/ 0 1
  new=. ,'\',.JSESC1 {~ JSESC0 i. msk#txt
  txt=. new ndx } (1 + msk) # txt
end.

txt
)
cairo_show=: 3 : 0
'size file'=. 2{. cairo_getparms y
res=. cairo_make size;file
cairo_write file
unrefcairo ''
if. IFJHS do. plotcairo__'' end.
EMPTY
)
cairo_make=: 3 : 0
'size file'=. y
make iCAIRO;0 0,size
fns=. 'cairo'&, each 1 {"1 Plot
dat=. 3 }."1 Plot
buf=: ''
'Cw Ch'=: size
CLIP=: 0
initcairo size
for_d. dat do.
  (>d_index{fns)~d
end.
EMPTY
)

initcairo=: 3 : 0
if. 0~:plotcr do. plotcr=: 0 [ cairo_destroy_jcairo_ plotcr end.
if. 0~:plotcs do. plotcs=: 0 [ cairo_surface_destroy_jcairo_ plotcs end.
plotcs=: cairo_image_surface_create <"0 CAIRO_FORMAT_ARGB32, y
plotcr=: cairo_create plotcs
cairo_set_source_rgb_jcairo_ plotcr ; 1 ; 1 ; 1
cairo_rectangle_jcairo_ plotcr ; 0 ; 0 ; ;/ y
cairo_fill_jcairo_ plotcr
EMPTY
)

unrefcairo=: 3 : 0
if. 0~:plotcr do. plotcr=: 0 [ cairo_destroy_jcairo_ plotcr end.
if. 0~:plotcs do. plotcs=: 0 [ cairo_surface_destroy_jcairo_ plotcs end.
EMPTY
)
coclass 'jzplot'
CANVAS_DEFSHOW=: 'jijx'
CANVAS_DEFSIZE=: 400 200
CANVAS_DEFFILE=: jpath '~temp/plot.html'
CANVAS_PENSCALE=: 0.4
canvas_getparms=: 3 : 0
(CANVAS_DEFSIZE;CANVAS_DEFFILE) output_parms y
)
canvas_write=: 4 : 0
dat=. x
'file ctx'=. y
while. _1 -: dat flwrites file do.
  msg=. 'Unable to write to file: ',file,LF,LF
  if. #d=. 1!:0 file do.
    msg=. msg, 'If the file is open in a viewer, close the file and try again.'
    if. 1 query msg do. return. end.
  else.
    info msg,'The file name is invalid.' return. end.
end.
if. (VISIBLE > IFJHS) *. '<!DOCTYPE html>' -: 15{.x do.
  viewimage_j_ file
end.
)
canvas_build=: 4 : 0
if. #x do.
  'function(ctx){',LF,y,'}',LF
else.
  canvas_wrap (canvas_header''),LF,'function drawPlot(ctx) {',LF,y,'}',LF
end.
)
canvas_header=: 3 : 0
r=. ('80';(pfmt 0{Pxywh);'40';(pfmt 1{Pxywh)) stringreplace canvas_template
r=. ('<1>';IFJHS{::'';'<!--[if lt IE 9]><script src="/~addons/ide/jhs/js/excanvas.js" type="text/javascript"></script><![endif]-->') stringreplace canvas_template
)

canvas_template=: 0 : 0
<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset=utf-8>
	<title>J Plot</title>
	<style>
		#canvas1 { margin-left:80px; margin-top:40px; }
	</style>

  <1>
	<script type="text/javascript">
		function graph() {
			var graphCanvas = document.getElementById('canvas1');
			// ensure that the element is available within the DOM
			if (graphCanvas && graphCanvas.getContext) {
				// open a 2D context within the canvas
				var context = graphCanvas.getContext('2d');
				// draw
				drawPlot(context);
			}
		}
)
CANVAS_TRL=: 0 : 0
	</script>
</head>
<body onLoad="graph();">
	<article>
		<h1>plot</h1>
		<canvas id="canvas1" width="800" height="400"></canvas>
	</article>
</body>
</html>
)
canvas_wrap=: 3 : 0
y, ('800';(pfmt 2{Pxywh);'400';(pfmt 3{Pxywh)) stringreplace CANVAS_TRL
)
canvas_color=: 4 : 0
if. x do.
  'ctx.fillStyle= "rgb',"1 (pfmtjs y),"1 '";'
else.
  'ctx.strokeStyle= "rgb',"1 (pfmtjs y),"1 '";'
end.
)
canvas_makerect=: 3 : 0
'x y r s'=. y
r=. (pfmtjs _2 [\ flipxy x,y,x,s,r,s,r,y,x,y) ,.~ 1 4 # ' ctx.moveTo',:' ctx.lineTo'
(,r,"1 ';')
)
canvas_makelines=: 3 : 0
len=. -: {: $ y
if. len = 0 do. i.0 0 return. end.
opr=. (1,len-1) # 'ctx.moveTo',:'ctx.lineTo'
if. 2 > #$y do.
  , ((pfmtjs _2 [\ flipxy y) ,.~ opr) ,. ';'
else.
  ,"2 ((pfmtjs _2 [\"1 flipxy y) ,."2~ opr) ,."2 ';'
end.
)
canvas_pens=: 4 : 0
assert. 0 [ 'canvas_pens not implemented'
(0 canvas_color x) ,"1 'ctx.lineWidth="',"1 (":1>.CANVAS_PENSCALE*y),"1 '";'
)
canvas_pen=: 4 : 0
(0 canvas_color x) , 'ctx.lineWidth="',(":1>.CANVAS_PENSCALE*y),'";'
)
canvas_lines=: 3 : 0
'ctx.beginPath();' ,"1 (canvas_makelines y) ,"1 'ctx.stroke();ctx.closePath();'
)
canvas_text=: 3 : 0
'fnt txt pos align rot und'=. y
pos=. citemize pos
txt=. ,each boxxopen txt
txt=. utf8@('"'&,)@(,&'"')@jsesc each txt

if. 1=#txt do. txt=. (#pos)#{.txt end.

fn=. 'ctx.textBaseline= "middle";ctx.textAlign= "', (align{:: 'left';'center';'right'), '";'

select. rot
case. 0 do.
  res=. tolist (<fn) ,each (<'ctx.fillText(') ,each txt ,each (<',') ,each (<("1) 0&pfmtjs flipxy pos >. 0) ,each <');'
case. 1 do.
  r=. ''
  for_i. i.#pos do.
    s=. 'ctx.save();ctx.translate', (pfmtjs flipxy 0 >. i{pos), ';ctx.rotate(-Math.PI/2);'
    r=. r, <s, fn, 'ctx.fillText(' , (i pick txt), ',0,0);ctx.restore();'
  end.
  res=. tolist r
case. 2 do.
  r=. ''
  for_i. i.#pos do.
    s=. 'ctx.save();ctx.translate', (pfmtjs flipxy 0 >. i{pos), ';ctx.rotate(Math.PI/2);'
    r=. r, <s, fn, 'ctx.fillText(' , (i pick txt), ',0,0);ctx.restore();'
  end.
  res=. tolist r
end.

if. -. und do. res return. end.
wid=. ,{. fnt pgetextent txt
'off lwd'=. getunderline fnt
res=. res, LF, 'ctx.lineWidth="', (":1>.lwd) ,'";'

select. rot
case. 0 do.
  bgn=. pos - (wid * -: align),.-off
  end=. bgn + wid,.0
case. 1 do.
  bgn=. pos - off,.wid * -: align
  end=. bgn + 0,.wid
case. 2 do.
  bgn=. pos + off,.wid * -: align
  end=. bgn - 0,.wid
end.

bgn=. 'ctx.beginPath();ctx.moveTo' ,"1 (pfmtjs flipxy bgn >. 0) ,"1 ';'
end=. 'ctx.lineTo' ,"1 (pfmtjs flipxy end >. 0) ,"1 ';ctx.stroke();ctx.fill();ctx.closePath();'
lin=. ,LF,.bgn,.end

res,lin
)
canvascircle=: 3 : 0
'v s f e c p'=. y
if. isempty c do.
  if. is1color e do.
    pbuf e canvas_pen v
    pbuf 'ctx.beginPath();ctx.arc(' ,"1 (0&pfmtjs flipxy 2{."1 p) ,"1 ',' ,"1 (0&pfmtjs 2{"1 p) ,"1 ',0,2*Math.PI,1);ctx.stroke();ctx.closePath();'
  else.
    for_i. i.#p do.
      pbuf (i{e) canvas_pen i{v
      pbuf 'ctx.beginPath();ctx.arc(' ,"1 (0&pfmtjs flipxy 2{.i{p) ,"1 ',' ,"1 (0&pfmtjs 2{i{p) ,"1 ',0,2*Math.PI,1);ctx.stroke();ctx.closePath();'
    end.
  end.
else.
  p=. citemize p
  c=. p cmatch c
  e=. p cmatch e
  v=. p cmatch v
  for_i. i.#p do.
    pbuf 'ctx.beginPath();ctx.arc(' , (0&pfmtjs flipxy 2{.i{p) , ',' , (0&pfmtjs 2{i{p) , ',0,2*Math.PI,1);'
    pbuf (1 canvas_color i{c) ,((i{e) canvas_pen i{v), 'ctx.stroke();ctx.fill();ctx.closePath();'
  end.
end.
)
canvasdot=: 3 : 0
'v s f e c p'=. y
p=. citemize p
v=. v * CANVAS_PENSCALE
if. is1color e do.
  pbuf 1 canvas_color e
  pbuf 'ctx.beginPath();ctx.arc(' ,"1 (0&pfmtjs flipxy p) ,"1 ',' ,"1 (0&pfmtjs v) ,"1 ',0,2*Math.PI,1);ctx.fill();ctx.closePath();'
else.
  e=. p cmatch e
  for_c. p do.
    pbuf 1 canvas_color c_index { e
    pbuf 'ctx.beginPath();ctx.arc(' , (0&pfmtjs flipxy c) , ',' , (0&pfmtjs v) , ',0,2*Math.PI,1);ctx.fill();ctx.closePath();'
  end.
end.
)
canvasfxywh=: 3 : 0
''return.
p=. _1 pick y
if. #p do.
  CLIP=: >: CLIP
  'x y w h'=. p
  rect=. canvas_makerect x,y,(x+w),y+h
  pbuf 'gsave ',rect,' clip newpath'
else.
  if. CLIP do.
    CLIP=: <: CLIP
    pbuf 'grestore'
  end.
end.
)
canvasline=: 3 : 0
'v s f e c p'=. y
if. (is1color e) *. 1 = #s do.
  pbuf e canvas_pen v
  pbuf canvas_lines p
else.
  rws=. #p
  e=. rws $ citemize e
  v=. rws $ v
  for_i. i. rws do.
    pbuf (i{e) canvas_pen i{v
    pbuf canvas_lines i{p
  end.
end.
)
canvasmarker=: 3 : 0
('canvasmark_',1 pick y)~ y
)
canvaspie=: 3 : 0
'v s f e c p'=. y
pen=. e canvas_pen v
p=. citemize p
ctr=. 0 1 {"1 p
rad=. 2 {"1 p
ang=. 360 %~ 2p1 * 360 + 90 + - 3 4 {"1 p
clr=. cmatch c
for_i. i.#p do.
  pbuf 'ctx.beginPath();', 'ctx.moveTo', (pfmtjs flipxy i { ctr), ';'
  pbuf 'ctx.arc(', (0&pfmtjs flipxy (i { ctr) ,(i{rad)), ',', (0&pfmtjs 0{i{ang), ',', (0&pfmtjs 1{i{ang), ',1);'
  pbuf (1 canvas_color i{clr) ,pen,'ctx.stroke();ctx.fill();ctx.closePath();'
end.
)
canvaspline=: 3 : 0
'v s f e c p'=. y
if. *./ s = 0 do.
  canvasline y return.
end.
s=. s { PENPATTERN
if. (is1color e) *. 1 = #v do.
  pos=. s linepattern"0 1 p
  canvasline (<pos) _1 } y
else.
  rws=. #p
  e=. rws $ citemize e
  v=. rws $ v
  s=. rws $ s
  for_i. i.#p do.
    pbuf (i{e) canvas_pen i{v
    pos=. (i{s) linepattern i{p
    canvasline (i{v);0;0;(i{e);0;pos
  end.
end.
)
canvaspoly=: 3 : 0
'v s f e c p'=. y
p=. citemize p
if. v=0 do. e=. c end.
c=. p cmatch c
e=. p cmatch e
if. +/v do.
  v=. p cmatch v
  for_i. i.#p do.
    pbuf 'ctx.beginPath();', (canvas_makelines i{p), (1 canvas_color i{c), ((i{e) canvas_pen i{v), 'ctx.stroke();ctx.fill();ctx.closePath();'
  end.
else.
  for_i. i.#p do.
    pbuf 'ctx.beginPath();', (canvas_makelines i{p), (0 canvas_color i{c), (1 canvas_color i{c), 'ctx.stroke();ctx.fill();ctx.closePath();'
  end.
end.
)
canvasrect=: 3 : 0
'v s f e c p'=. y
p=. citemize p
if. v=0 do. e=. c end.
c=. p cmatch c
e=. p cmatch e
if. +/v do.
  v=. p cmatch v
  for_i. i.#p do.
    pbuf 'ctx.beginPath();', (canvas_makerect i{p) , (1 canvas_color i{c) ,((i{e) canvas_pen i{v) , 'ctx.stroke();ctx.fill();ctx.closePath();'
  end.
else.
  for_i. i.#p do.
    pbuf 'ctx.beginPath();', (canvas_makerect i{p) ,(1 canvas_color i{c) ,'ctx.fill();ctx.closePath();'
  end.
end.
)
canvastext=: 3 : 0
't f a e c p'=. y
'fnx fst fsz fan und'=. f
rot=. 3 | 0 90 270 i. fan
asc=. pgetascender f
fnm=. getfntname fnx,fst
bold=. italic=. ''
if. (1 e. '-Oblique' E. fnm)+.(1 e. '-Bold' E. fnm)+.(1 e. '-Italic' E. fnm) do.
  bold=. (1 e. 'Bold' E. fnm)#'bold '
  italic=. ((1 e. 'Oblique' E. fnm)+.(1 e. 'Italic' E. fnm))#'italic '
  fnm=. ({.~ i:&'-') fnm
end.
pbuf 'ctx.font= "', italic, bold, (": getplotfontsize f), 'pt \"', fnm,'\"";'
select. rot
case. 0 do. p=. 0 >. p -"1 [ 0, asc
case. 1 do. p=. p +"1 asc, 0
case. 2 do. p=. p -"1 asc, 0
end.
if. is1color e do.
  pbuf 1 canvas_color e
  pbuf canvas_text f;t;p;a;rot;und
else.
  for_i. i.#e do.
    pbuf 1 canvas_color i{e
    pbuf canvas_text f;(i{t);(i{p);a;rot;und
  end.
end.
)
canvasmark_circle=: 3 : 0
's m f e c p'=. y
p=. citemize p
v=. 8 * s * CANVAS_PENSCALE
pbuf 1 canvas_color e
pbuf 'ctx.moveTo', (pfmtjs flipxy {.p), ';'
pbuf 'ctx.beginPath();ctx.arc(' ,"1 (0&pfmtjs flipxy p) ,"1 ',' ,"1 (0&pfmtjs v) ,"1 ',0,2*Math.PI,1);ctx.stroke();ctx.fill();ctx.closePath();'
)
canvasmark_diamond=: 3 : 0
's m f e c p'=. y
e=. 1 canvas_color e
p=. 8 $"1 citemize p
d=. (3.5 * s) * _1 0 0 1 1 0 0 _1
p=. p +"1 d
pbuf 'ctx.beginPath();'
for_i. i.#p do.
  pbuf canvas_makelines i{p
  pbuf e,'ctx.fill();ctx.closePath();'
end.
)
canvasmark_line=: 3 : 0
's m f e c p'=. y
e=. 1 canvas_color e
p=. ,p
s=. -:KeyLen,KeyPen
p=. (p - s) , p + s
pbuf 'ctx.beginPath();'
pbuf canvas_makerect p
pbuf e,'ctx.fill();ctx.closePath();'
)
canvasmark_plus=: 3 : 0
's m f e c p'=. y
s=. s * 4
t=. s, 0
pbuf e canvas_pen s
p=. citemize p
d=. (p -"1 t) ,. p +"1 t
t=. |. t
d=. d, (p -"1 t) ,. p +"1 t
pbuf canvas_lines d
)
canvasmark_square=: 3 : 0
's m f e c p'=. y
e=. 1 canvas_color e
p=. citemize p
s=. 3 * s
p=. (p - s) ,"1 p + s
pbuf 'ctx.beginPath();'
for_i. i.#p do.
  pbuf canvas_makerect i{p
  pbuf e,'ctx.fill();ctx.closePath();'
end.
)
canvasmark_times=: 3 : 0
's m f e c p'=. y
pbuf e canvas_pen 4 * s
t=. _1 + s * 3
r=. (p - t) ,. p + t
s=. (p +"1 t * 1 _1) ,. p +"1 t * _1 1
pbuf canvas_lines r,s
)
canvasmark_triangle=: 3 : 0
's m f e c p'=. y
e=. 1 canvas_color e
p=. 6 $"1 citemize p
d=. (4 * s) * , (sin,.cos) 2p1 * 0 1 2 % 3
p=. p +"1 d
pbuf 'ctx.beginPath();'
for_i. i.#p do.
  pbuf canvas_makelines i{p
  pbuf e,'ctx.fill();ctx.closePath();'
end.
)
JSESC0=: LF,CR,TAB,FF,(8{a.),'\''"'
JSESC1=: 'nrtfb\''"'
jsesc=: 3 : 0
txt=. y
msk=. txt e. JSESC0
if. 1 e. msk do.
  ndx=. , ((I. msk) + i. +/ msk) +/ 0 1
  new=. ,'\',.JSESC1 {~ JSESC0 i. msk#txt
  txt=. new ndx } (1 + msk) # txt
end.

txt
)
canvas_get=: 3 : 0
'size file ctx'=. 3{. canvas_getparms y
res=. canvas_make size;file;ctx
)
canvas_show=: 3 : 0
'size file ctx'=. 3{. canvas_getparms y
res=. canvas_make size;file;ctx
res canvas_write file;ctx
if. IFJHS do. plotcanvas__'' end.
i.0 0
)
canvas_make=: 3 : 0
'size file ctx'=. y
make iCANVAS;0 0,size
fns=. 'canvas'&, each 1 {"1 Plot
dat=. 3 }."1 Plot
buf=: ''
'Cw Ch'=: size
CLIP=: 0
for_d. dat do.
  (>d_index{fns)~d
end.
ctx canvas_build buf
)
coclass 'jzplot'
EPS_DEFSIZE=: 480 360
EPS_DEFFILE=: jpath '~temp/plot.eps'
EPS_PENSCALE=: 0.4
eps_getparms=: 3 : 0
(EPS_DEFSIZE;EPS_DEFFILE) output_parms y
)
getarcangles=: 3 : 0
ang=. dfr arctan | %~/"1 y
quad=. (#. y < 0) { 0 3 1 2
(quad { 0 180 180 360) + ang * quad { 1 _1 1 _1
)
eps_write=: 4 : 0
dat=. x
file=. y
while. _1 -: dat flwrites file do.
  msg=. 'Unable to write to file: ',file,LF,LF
  if. #d=. 1!:0 file do.
    msg=. msg, 'If the file is open in a viewer, close the file and try again.'
    if. 1 query msg do. return. end.
  else.
    info msg,'The file name is invalid.' return. end.
end.
if. 0 = 4!:0 <'EPSReader_j_' do.
  if. check_EPSReader ::0: EPSReader_j_ do.
    fork_jtask_ (dquote EPSReader_j_),' ',dquote file
  else.
    info 'File written: ',file
  end.
end.
)
EPS_DEFS=: 0 : 0
/showc {dup stringwidth pop neg 2 div 0 rmoveto show } bind def
/showr {dup stringwidth pop neg 0 rmoveto show } bind def
)
eps_build=: 3 : 0
eps_wrap (eps_header''),LF,y
)

eps_header=: 3 : 0
r=. ''
r=. r,<'%!PS-Adobe-3.0 EPSF-3.0'
r=. r,<'%%Creator: J Plot'
r=. r,<'%%CreationDate: ','20', ; _2 {.each '0' ,each ": each <. 6!:0''
r=. r,<'%%BoundingBox: ',pfmt Pxywh
r=. r,<''
r=. r,<EPS_DEFS
tolist r
)
EPS_TRL=: 0 : 0
grestore
showpage
%%EOF
)
eps_wrap=: 3 : 0
y,EPS_TRL
)
eps_color=: 3 : 0
(": y % 255) ,"1 ' setrgbcolor '
)
eps_makerect=: 3 : 0
'x y r s'=. y
r=. (pfmt _2 [\ x,y,x,s,r,s,r,y) ,. 1 3 # ' moveto',:' lineto'
(,r,.LF),'closepath'
)
eps_makelines=: 3 : 0
len=. -: {: $ y
if. len = 0 do. i.0 0 return. end.
opr=. (1,len-1) # ' moveto',:' lineto'
if. 2 > #$y do.
  , ((pfmt _2 [\ y) ,. opr) ,. LF
else.
  ,"2 ((pfmt _2 [\"1 y) ,."2 opr) ,."2 LF
end.
)
eps_pens=: 4 : 0
(eps_color x) ,"1 (":,.EPS_PENSCALE*y) ,"1 ' setlinewidth '
)
eps_pen=: 4 : 0
(eps_color ,x), (":EPS_PENSCALE*y) ,' setlinewidth '
)
eps_lines=: 3 : 0
(eps_makelines y) ,"1 'stroke'
)
eps_text=: 3 : 0
'fnt txt pos align rot und'=. y
pos=. citemize pos
txt=. ,each boxxopen txt
txt=. pdfesc each txt

fn=. 'show',align{' cr'

select. rot
case. 0 do.
  res=. (<' moveto (') ,each txt ,each <') ',fn
  res=. tolist (<"1 pfmt pos >. 0) ,each res
case. 1 do.
  r=. ''
  for_i. i.#pos do.
    s=. 'save ',(pfmt 0 >. i{pos), ' translate 90 rotate',LF
    r=. r, <s, '0 0 moveto (' ,(i pick txt) , ') ',fn,' restore'
  end.
  res=. tolist r
case. 2 do.
  r=. ''
  for_i. i.#pos do.
    s=. 'save ',(pfmt 0 >. i{pos), ' translate 270 rotate',LF
    r=. r, <s, '0 0 moveto (' ,(i pick txt) , ') ',fn,' restore'
  end.
  res=. tolist r
end.

if. -. und do. return. end.
wid=. ,{. fnt pgetextent txt
'off lwd'=. getunderline fnt
res=. res, LF, (":lwd) ,' setlinewidth '

select. rot
case. 0 do.
  bgn=. pos - (wid * -: align),.-off
  end=. bgn + wid,.0
case. 1 do.
  bgn=. pos - off,.wid * -: align
  end=. bgn + 0,.wid
case. 2 do.
  bgn=. pos + off,.wid * -: align
  end=. bgn - 0,.wid
end.

bgn=. (": bgn >. 0) ,"1 ' moveto '
end=. (": end >. 0) ,"1 ' lineto stroke'
lin=. ,LF,.bgn,.end

res,lin

)
epscircle=: 3 : 0
'v s f e c p'=. y
if. isempty c do.
  txt=. (pfmt p ,"1[ 0 360) ,"1 ' arc stroke'
  if. is1color e do.
    pbuf e eps_pen v
    pbuf txt
  else.
    pbuf (e eps_pens v) ,. txt
  end.
else.
  p=. citemize p
  c=. p cmatch c
  e=. p cmatch e
  v=. p cmatch v
  for_i. i.#p do.
    pbuf (pfmt (i{p) ,"1[ 0 360) ,"1 ' arc'
    pbuf 'gsave ',(eps_color i{c),' fill grestore'
    pbuf ((i{e) eps_pen i{v),' stroke'
  end.
end.
)
epsdot=: 3 : 0
'v s f e c p'=. y
p=. citemize p
v=. v * EPS_PENSCALE
if. is1color e do.
  pbuf eps_color e
  pbuf (pfmt p,.v) ,"1 ' 0 360 arc fill'
else.
  e=. p cmatch e
  for_c. p do.
    pbuf eps_color c_index { e
    pbuf (pfmt c,.v) ,"1 ' 0 360 arc fill'
  end.
end.
)
epsfxywh=: 3 : 0
p=. _1 pick y
if. #p do.
  CLIP=: >: CLIP
  'x y w h'=. p
  rect=. eps_makerect x,y,(x+w),y+h
  pbuf 'gsave ',rect,' clip newpath'
else.
  if. CLIP do.
    CLIP=: <: CLIP
    pbuf 'grestore'
  end.
end.
)
epsline=: 3 : 0
'v s f e c p'=. y
if. (is1color e) *. 1 = #s do.
  pbuf e eps_pen v
  pbuf eps_lines p
else.
  rws=. #p
  e=. rws $ citemize e
  v=. rws $ v
  for_i. i. rws do.
    pbuf (i{e) eps_pen i{v
    pbuf eps_lines i{p
  end.
end.
)
epsmarker=: 3 : 0
('epsmark_',1 pick y)~ y
)
epspie=: 3 : 0
'v s f e c p'=. y
pen=. e eps_pen v
p=. citemize p
ctr=. 0 1 {"1 p
rad=. 2 {"1 p
ang=. 360 + _90 + 3 4 {"1 p
clr=. cmatch c
for_i. i.#p do.
  pbuf 'newpath'
  pbuf (pfmt i { ctr),' moveto'
  pbuf (pfmt (i { ctr),(i{rad),i{ang),' arc closepath'
  pbuf 'gsave ',(eps_color i{clr),' fill grestore'
  pbuf pen,' stroke'
end.
)
epspline=: 3 : 0
'v s f e c p'=. y
if. *./ s = 0 do.
  epsline y return.
end.
s=. s { PENPATTERN
if. (is1color e) *. 1 = #v do.
  pos=. s linepattern"0 1 p
  epsline (<pos) _1 } y
else.
  rws=. #p
  e=. rws $ citemize e
  v=. rws $ v
  s=. rws $ s
  for_i. i.#p do.
    pos=. (i{s) linepattern i{p
    epsline (i{v);0;0;(i{e);0;pos
  end.
end.
)
epspoly=: 3 : 0
'v s f e c p'=. y
p=. citemize p
if. v=0 do. e=. c end.
c=. p cmatch c
e=. p cmatch e
if. +/v do.
  v=. p cmatch v
  for_i. i.#p do.
    pbuf eps_makelines i{p
    pbuf 'gsave ',(eps_color i{c),' fill grestore'
    pbuf ((i{e) eps_pen i{v),' stroke'
  end.
else.
  for_i. i.#p do.
    pbuf eps_makelines i{p
    pbuf (eps_color i{c),' fill'
  end.
end.
)
epsrect=: 3 : 0
'v s f e c p'=. y
p=. citemize p
if. v=0 do. e=. c end.
c=. p cmatch c
e=. p cmatch e
if. +/v do.
  v=. p cmatch v
  for_i. i.#p do.
    pbuf eps_makerect i{p
    pbuf 'gsave ',(eps_color i{c),' fill grestore'
    pbuf ((i{e) eps_pen i{v),' stroke'
  end.
else.
  for_i. i.#p do.
    pbuf eps_makerect i{p
    pbuf (eps_color i{c),' fill'
  end.
end.
)
epstext=: 3 : 0
't f a e c p'=. y
'fnx fst fsz fan und'=. f
rot=. 3 | 0 90 270 i. fan
asc=. pgetascender f
fnm=. getfntname fnx,fst
pbuf '/',fnm,' findfont'
pbuf (": getplotfontsize f),' scalefont setfont'
select. rot
case. 0 do. p=. 0 >. p -"1 [ 0, asc
case. 1 do. p=. p +"1 asc, 0
case. 2 do. p=. p -"1 asc, 0
end.
if. is1color e do.
  pbuf eps_color e
  pbuf eps_text f;t;p;a;rot;und
else.
  for_i. i.#e do.
    pbuf eps_color i{e
    pbuf eps_text f;(i{t);(i{p);a;rot;und
  end.
end.
)
epsmark_circle=: 3 : 0
's m f e c p'=. y
p=. citemize p
v=. 8 * s * EPS_PENSCALE
pbuf eps_color e
pbuf (pfmt {.p), ' moveto'
pbuf (pfmt p,.v) ,"1 ' 0 360 arc fill'
)
epsmark_diamond=: 3 : 0
's m f e c p'=. y
e=. eps_color e
p=. 8 $"1 citemize p
d=. (3.5 * s) * _1 0 0 1 1 0 0 _1
p=. p +"1 d
for_i. i.#p do.
  pbuf eps_makelines i{p
  pbuf e,' fill'
end.
)
epsmark_line=: 3 : 0
's m f e c p'=. y
e=. eps_color e
p=. ,p
s=. -:KeyLen,KeyPen
p=. (p - s) , p + s
pbuf eps_makerect p
pbuf e,' fill'
)
epsmark_plus=: 3 : 0
's m f e c p'=. y
s=. s * 4
t=. s, 0
pbuf e eps_pen s
p=. citemize p
d=. (p -"1 t) ,. p +"1 t
t=. |. t
d=. d, (p -"1 t) ,. p +"1 t
pbuf eps_lines d
)
epsmark_square=: 3 : 0
's m f e c p'=. y
e=. eps_color e
p=. citemize p
s=. 3 * s
p=. (p - s) ,"1 p + s
for_i. i.#p do.
  pbuf eps_makerect i{p
  pbuf e,' fill'
end.
)
epsmark_times=: 3 : 0
's m f e c p'=. y
pbuf e eps_pen 4 * s
t=. _1 + s * 3
r=. (p - t) ,. p + t
s=. (p +"1 t * 1 _1) ,. p +"1 t * _1 1
pbuf eps_lines r,s
)
epsmark_triangle=: 3 : 0
's m f e c p'=. y
e=. eps_color e
p=. 6 $"1 citemize p
d=. (4 * s) * , (sin,.cos) 2p1 * 0 1 2 % 3
p=. p +"1 d
for_i. i.#p do.
  pbuf eps_makelines i{p
  pbuf e,' fill'
end.
)
eps_show=: 3 : 0
'size file ctx'=. 3{. eps_getparms y
make iEPS;0 0,size
fns=. 'eps'&, each 1 {"1 Plot
dat=. 3 }."1 Plot
buf=: ''
CLIP=: 0
for_d. dat do.
  (>d_index{fns)~d
end.
res=. eps_build buf
res eps_write file
)
ISI_DEFFILE=: '~temp/plot'
fext=: 4 : 0
f=. deb y
f, (-. x -: (-#x) {. f) # x
)
gettemp=: 3 : 0
p=. jpath '~temp/'
d=. 1!:0 p,'*.',y
a=. 0, {.@:(0&".)@> _4 }. each {."1 d
a=. ": {. (i. >: #a) -. a
p,a,'.',y
)
isi_getsize=: 3 : 0
if. -. wdishandle :: 0: PFormhwnd do. '' return. end.
wd 'psel ',PFormhwnd
s=. wd :: 0: 'qchildxywhx ',PId
if. s -: 0 do. '' return. end.
2 3 { 0 ". s
)
output_parms=: 4 : 0
'size file'=. x
if. #y do.
  prm=. qchop y
  select. #prm
  case. 1 do.
    file=. 0 pick prm
  case. 2 do.
    size=. 0 ".&> prm
  case. 3 do.
    file=. 0 pick prm
    size=. 0 ". &> _2 {. prm
    if. 0 e. size do.
      size=. 0 ". &> 2 {. prm
      file=. 2 pick prm
    end.
  end.
else.
  if. #sz=. isi_getsize'' do.
    size=. sz
  end.
end.
size;file
)
isi_clip=: 3 : 0
if. -. IFWIN+.IFJNET do.
  info 'Save plot to clipboard is only available in Windows'
  return.
end.
if. IFJNET do.
  f=. gettemp 'png'
  isi_png dquote f
  wd 'clipcopyx image ',dquote f
else.
  f=. gettemp 'emf'
  isi_emf dquote f
  wd 'clipcopyx enhmetafile ',dquote f
end.
1!:55 <f
)
gpcount=: ,"1~ 1 + [: {: 1 , $
gpcut=: 3 : 0
r=. ''
while. #y do.
  n=. {. y
  if. n=0 do.
    info 'zero length segment at: ',":#;r
    r
    return.
  end.
  r=. r, < n {. y
  y=. n }. y
end.
r
)
gpbuf=: 3 : 0
assert. 2 > #$y
buf=: buf,y
)
gpapply=: 3 : 0
glcmds buf
buf=: $0
)
gpflip=: flipxy @ rndint
gpfliplast=: 3 : 0
(<gpflip _1 pick y) _1 } y
)
gpinit=: 3 : 0
buf=: bufdef=: $0
r=. ''
r=. r,3 2003 1
r=. r,3 2071 1
gpapply''
)
gpbrushnull=: 3 : '2 2005'
gppens=: 4 : 0
y=. rndint y
5 2032,"1 x,"1 [ 4 2022,"1 y,.(y~:0){PS_NULL,PS_SOLID
)
gppen=: 4 : 0
y=. rndint y
5 2032,(,x),4 2022,y,(y~:0){PS_NULL,PS_SOLID
)
gppens1=: 3 : 0
5 2032,"1 y,"1 [ 4 2022 1,PS_SOLID
)
gppen1=: 3 : 0
5 2032,(,y),4 2022 1,PS_SOLID
)
gppenbrush1=: 3 : 0
5 2032,(,y),4 2022 1,PS_SOLID,2 2004
)
gppixel=: 3 : 0
's t f e c p'=. y
p=. gpcount 2024 ,"1 gpflip p
if. is1color e do.
  gpbuf e gppen 1
  gpbuf ,p
else.
  rws=. #p
  e=. rws $ citemize e
  pen=. e gppens 1
  gpbuf ,pen ,. p
end.
)
gppline=: 4 : 0
's t f e c p'=. y
if. (is1color e) *. 1 = #s do.
  gpbuf (,e) gppen s
  gpbuf ,gpcount x,"1 p
else.
  rws=. #p
  e=. rws $ citemize e
  s=. rws $ s
  pen=. e gppens s
  gpbuf ,pen ,. gpcount x,"1 p
end.
)
gppshape=: 4 : 0
'v s f e c p'=. y

if. v=0 do. e=. c end.

if. is1color e do.
  gpbuf e gppen v
  if. isempty c do.
    gpbuf gpbrushnull''
    gpbuf ,gpcount x,"1 p
  elseif. is1color c do.
    gpbuf 5 2032,(,c),2 2004
    gpbuf ,gpcount x,"1 p
  elseif. do.
    c=. (#p) $ c
    clr=. 5 2032 ,"1 c ,"1 [ 2 2004
    gpbuf , clr ,. gpcount x,"1 p
  end.
else.
  e=. (#p) $ e
  e=. e gppens v
  if. isempty c do.
    gpbuf gpbrushnull''
    gpbuf , e ,. gpcount x,"1 p
  elseif. is1color c do.
    gpbuf 5 2032,(,c),2 2004
    gpbuf , e ,. gpcount x,"1 p
  elseif. do.
    c=. (#p) $ c
    clr=. 5 2032 ,"1 c ,"1 [ 2 2004
    gpbuf , e ,. clr ,. gpcount x,"1 p
  end.

end.
)
isiarc=: 3 : '2001 gppline gpfliplast y'
isiline=: 3 : '2015 gppline gpfliplast y'
isipie=: 3 : '2023 gppshape gpfliplast y'
isipoly=: 3 : '2029 gppshape gpfliplast y'
isicircle=: 3 : 0
p=. _1 pick y
ctr=. gpflip 0 1 {"1 p
rad=. rndint 2 {"1 p
xy=. ctr - rad
wh=. +: rad ,. rad
p=. xy ,. wh
2008 gppshape (<p) _1 } y
)
isidot=: 3 : 0
'v s f e c p'=. y
select. v
case. 1 do.
  gppixel y
case. 2 do.
  p=. gpflip p
  p=. (p-1) ,"1 [ 2 2
  dat=. 1;0;0;e;e;p
  2031 gppshape dat
case. 3 do.
  h=. (p-"1[1 0) ,. p+"1[2 0
  v=. (p-"1[0 1) ,. p+"1[0 2
  isiline 1;0;0;e;e;h,v
case. do.
  o=. >. -: v
  p=. p ,"1 v,.v
  isicircle 1;0;0;e;e;p
end.
)
isifxywh=: 3 : 0
p=. _1 pick y
if. #p do.
  'x y w h'=. p
  xy=. _1 + <. x,Ch-y+h
  wh=. 2 + >. w,h
  gpbuf 6 2078,xy,wh
else.
  gpbuf 2 2079
end.
)
isimarker=: 3 : 0
's m f e c p'=. y
p=. gpflip p
gpbuf gppenbrush1 e
s ('isimark_',m)~ p
)
isipie=: 3 : 0
p=. _1 pick y
ctr=. gpflip 0 1 {"1 p
rad=. 2 {"1 p
ang=. 3 4 {"1 p
xy=. ctr - rad
wh=. +: rad ,. rad
tx=. ({."1 ctr) + rad * sind ang
ty=. ({:"1 ctr) + rad * cosd ang
p=. rndint xy ,. wh ,. ,"2 tx ,"0 ty
2023 gppshape (<p) _1 } y
)
isipline=: 3 : 0
's t f e c p'=. y
if. *./ t = 0 do.
  isiline y return.
end.
p=. gpflip p
t=. t { PENPATTERN
if. (is1color e) *. 1 = #s do.
  gpbuf 5 2032,(,e),4 2022,s,PS_SOLID
  pos=. t linepattern"0 1 p
  gpbuf ,gpcount 2015,"1 pos
else.
  rws=. #p
  e=. rws $ citemize e
  s=. rws $ s
  t=. rws $ t
  pen=. e gppens s
  for_i. i.#p do.
    gpbuf i{pen
    pos=. (i{t) linepattern i{p
    gpbuf ,gpcount 2015,"1 pos
  end.
end.
)
isirect=: 3 : 0
p=. boxrs2wh gpflip _1 pick y
if. IFJAVA do.
  if. 0 = 1 pick y do.
    p=. 1 1 _2 _2 +"1 p
  end.
end.
y=. (<p) _1 } y
2031 gppshape y
)
isitext=: 3 : 0
't f a e c p'=. y

p=. gpflip p
t=. text2utf8 each boxopen t
if. a do.
  glfont f
  off=. <. -: a * {."1 glqextent &> t
  if. 1 e. 'angle900' E. f do.
    p=. p +"1 [ 0,.off
  elseif. 1 e. 'angle2700' E. f do.
    p=. p -"1 [ 0,.off
  elseif. do.
    p=. p -"1 off,.0
  end.
end.
gpbuf gpcount 2012,alfndx,f
if. is1color e do.
  gpbuf 5 2032,(,e),2 2040
  if. rank01 p do.
    gpbuf gpcount 2056,p
    gpbuf gpcount 2038,alfndx,>t
  else.
    t=. gpcount each 2038 ,each alfndx each t
    t=. (<"1 gpcount 2056 ,"1 p) ,each t
    gpbuf ; t
  end.
else.
  t=. gpcount each 2038 ,each alfndx each t
  t=. t ,each <"1 gpcount 2056 ,"1 p
  t=. (<"1 (5 2032 ,"1 e) ,"1 [ 2 2040) ,each t
  gpbuf ; t
end.
)
isimark_circle=: 4 : 0
s=. rndint x * 3
p=. (y - s) ,"1 >: +: s,s
gpbuf ,gpcount 2008 ,"1 p
)
isimark_diamond=: 4 : 0
s=. rndint x * 4
'x y'=. |: y
p=. (x-s),.y,.x,.(y+s),.(x+s),.y,.x,.y-s
gpbuf ,gpcount 2029 ,"1 p
)
isimark_line=: 4 : 0
'x y'=. , y
p=. >.(x--:KeyLen),(y--:KeyPen),<:KeyLen,KeyPen
gpbuf ,gpcount 2031 ,p
)
isimark_plus=: 4 : 0
s=. rndint 4 1 * x
p=. (y -"1 s) ,"1 +: s
s=. |. s
p=. p , (y -"1 s) ,"1 +: s
gpbuf ,gpcount 2031 ,"1 p
)
isimark_square=: 4 : 0
s=. rndint x * 3
p=. (y - s) ,"1 +: s,s
gpbuf ,gpcount 2031 ,"1 p
)
isimark_times=: 4 : 0
if. x = 1 do.
  p=. (y - 3) ,. y + 4
  q=. (y - "1 [ 3 _3) ,. y +"1 [ 4 _4
  p=. p, (p +"1 [ 0 1 _1 0), p + "1 [ 1 0 0 _1
  q=. q, (q +"1 [ 0 _1 _1 0), q +"1 [ 1 0 0 1
  gpbuf ,gpcount 2015 ,"1 p,q
else.
  s=. rndint _1 + 3 * x
  n=. rndint 2 * x
  p=. (y - s) ,. y + s
  q=. (y - "1 s * 1 _1) ,. y +"1 s * 1 _1
  gpbuf 4 2022,n,PS_SOLID
  gpbuf ,gpcount 2015 ,"1 p,q
end.
)
isimark_triangle=: 4 : 0
s=. rndint 2 * x
t=. rndint 4 * x
'x y'=. |: y
p=. rndint (x-t),.(y+s),.(x+t),.(y+s),.x,.y-t
gpbuf ,gpcount 2029 ,"1 p
)
PRINTP=: ''
isi_print=: 3 : 0
if. #PRINTP do. wd 'psel ',PRINTP,';pclose' end.
if. IFJENT do.
  wd 'pc print;cc g isiprint j6'
else.
  wd 'pc print;cc g isigraph'
end.
PRINTP=: wd 'qhwndp'
PRINTED=: 0
opt=. '"" "" "" orientation ',":ORIENTATION
glprint opt
)
print_g_print=: 3 : 0
'page pass'=. ". sysdata
select. pass
case. _1 do.
  PRINTP=: PRINTPXYWH=: ''
  wd 'pclose'
case. 0 do.
  glprintmore -.PRINTED
case. do.
  'Cw Ch'=: glqprintwh''
  isi_paintit isi_printwin''
  PRINTED=: 1
end.
)
isi_printwin=: 3 : 0
'pw ph mw mh'=. 4 {. glqprintpaper''
mrg=. 0 >. PRINTMARGIN - mw,(ph - mh + Ch),(pw - mw + Cw),mh
xywh=. (0 0,Cw,Ch) shrinkrect mrg
if. 0 = #PRINTWINDOW do.
  xywh
else.
  if. 4 ~: #PRINTWINDOW do.
    info 'PRINTWINDOW should be of form: x y wh' return.
  end.
  'x y w h'=. xywh
  'px py pw ph'=. PRINTWINDOW%1000
  fx=. x + px * w
  fy=. y + py * h
  fw=. (x-fx) + pw * w
  fh=. (y-fy) + ph * h
  fx,fy,fw,fh
end.
)
isi_bmp=: 3 : 0
if. #y do.
  arg=. qchop y
  num=. __ ". &.> arg
  msk=. __ e. &> num
  file=. > {. msk # arg
  wh=. >(-.msk) # num
  if. -. (#wh) e. 0 2 do.
    info 'invalid [w h] parameter in save bmp' return.
  end.
else.
  wh=. file=. ''
end.
file=. file,(0=#file)#ISI_DEFFILE
file=. jpath '.bmp' fext file
if. (2 = #wh) > wh -: Pw,Ph do.
  a=. cocreate''
  coinsert__a (,copath) coname''
  bmp=. isi_getbmpwh__a wh
  coerase a
else.
  bmp=. isi_getbmp''
end.
bmp writebmp file
)
isi_png=: 3 : 0
if. #y do.
  arg=. qchop y
  num=. __ ". &.> arg
  msk=. __ e. &> num
  file=. > {. msk # arg
  wh=. >(-.msk) # num
  if. -. (#wh) e. 0 2 do.
    info 'invalid [w h] parameter in save bmp' return.
  end.
else.
  wh=. file=. ''
end.
file=. file,(0=#file)#ISI_DEFFILE
file=. jpath '.png' fext file
if. (2 = #wh) > wh -: Pw,Ph do.
  a=. cocreate''
  coinsert__a (,copath) coname''
  bmp=. isi_getbmpwh__a wh
  coerase a
else.
  bmp=. isi_getbmp''
end.
bmp writepng file
)
isi_def=: 4 : 0
type=. x
file=. jpath ('.',type) fext (;qchop y),(0=#y) # ISI_DEFFILE
if. IFJNET do.
  writeimg_jnet_ (isi_getrgb'') ; file
else.
  (isi_getrgb'') writeimg file
end.
)
isi_defstr=: 4 : 0
type=. x
if. IFJNET do.
  putimg_jnet_ (isi_getrgb'') ; type
else.
  (isi_getrgb'') putimg type
end.
)
isi_emf=: 3 : 0
file=. jpath '.emf' fext (;qchop y),(0=#y) # ISI_DEFFILE
wd 'psel ',PFormhwnd
glsel PId
glfile file
glemfopen''
isi_paint''
glemfclose''
)
isi_getbmp=: 3 : 0
wd 'psel ',PFormhwnd
glsel PId
box=. 0 ". wd 'qchildxywhx ',PId
res=. glqpixels box
(3 2 { box) $ res
)
isi_getbmpwh=: 3 : 0
wd 'pc a owner;xywh 0 0 240 200;cc g isigraph rightmove bottommove;pas 0 0'
PFormhwnd=: wd 'qhwndp'
PId=: 'g'
wd 'setxywhx g 0 0 ',":y
isi_paint''
glpaint''
res=. isi_getbmp''
wd 'pclose'
res
)
isi_getrgb=: 3 : 0
wd 'psel ',PFormhwnd
glsel PId
box=. 0 ". wd 'qchildxywhx ',PId
if. IFJNET do.
  (3 2 { box) $ glqpixels box
else.
  (3 2 { box) $ 256 256 256 #: glqpixels box
end.
)
isi_jpg=: 3 : 0
file=. ''
qual=. 100
if. #y do.
  arg=. qchop y
  num=. __ ". &.> arg
  msk=. +./ &> num = &.> __
  file=. > {. msk # arg
  qual=. <. {. (>(-.msk) # num),qual
end.
file=. jpath '.jpg' fext file,(0=#file) # ISI_DEFFILE
rgb=. isi_getrgb''
if. IFJNET do.
  writeimg_jnet_ rgb ; file
else.
  rgb writeimg file
end.
)
isi_png=: 3 : 0
file=. ''
comp=. 9
if. #y do.
  arg=. qchop y
  num=. __ ". &.> arg
  msk=. +./ &> num = &.> __
  file=. > {. msk # arg
  comp=. <. {. (>(-.msk) # num),comp
end.
file=. jpath '.png' fext file,(0=#file) # ISI_DEFFILE
rgb=. isi_getrgb''
if. IFJNET do.
  writeimg_jnet_ rgb ; file
else.
  rgb writeimg file
end.
)
isi_save=: 3 : 0
if. Poutput ~: iISI do.
  msg=. 'First display an isigraph Plot.'
  info msg return.
end.
if. 0=#y do.
  isi_clip'' return.
end.
type=. tolower firstword y
if. IFJNET < (<type) e. ;: 'gif jpg png tif gifr jpgr pngr tifr' do.
  af=. jpath '~addons/media/platimg/platimg.ijs'
  if. -. flexist af do.
    info 'Save to ',type,' requires the platimg addon.' return.
  end.
  require af
end.
('isi_',type)~ (1+#type) }. y
)

isi_get=: 3 : 0
if. #y do.
  type=. tolower firstword y
  if. (<type) e. ;: 'gif jpg png tif' do.
    y=. type,'r ', (#type)}. y
  end.
end.
isi_save y
)
isi_gif=: 'gif' & isi_def
isi_tif=: 'tif' & isi_def
isi_pngr=: 'png' & isi_defstr
isi_jpgr=: 'jpg' & isi_defstr
isi_gifr=: 'gif' & isi_defstr
isi_tifr=: 'tif' & isi_defstr
isi_show=: 3 : 0
popen_isi''
isi_paint`]@.IFJNET ''
if. PShow=0 do.
  if. VISIBLE do.
    wd 'pshow ',PSHOW
  else.
    wd 'pshow sw_hide'
  end.
  wd 'ptop ',":PTop
  PShow=: 1
else.
  if. VISIBLE do.
    wd 'ptop'
  end.
end.
)
isi_paint=: 3 : 0
glsel PId
'Cw Ch'=: glqwh''
isi_paintit 0 0,Cw,Ch
)
isi_paintit=: 3 : 0
gpinit''
make iISI;y
ids=. 1 {"1 Plot
fns=. 'isi'&, each ids
dat=. 3 }."1 Plot
for_d. dat do.
  (>d_index{fns)~d
end.
gpapply''
)
coclass 'jzplot'
PDF_DEFSIZE=: 480 360
PDF_DEFFILE=: jpath '~temp/plot.pdf'
JPF_DEFFILE=: jpath '~temp/plot.jpf'
PDF_PENSCALE=: 0.4

CIDFONTS=: 'MSung-Light';'STSong-Light'
endian=. ({.a.)={. 1&(3!:4) 1
toucodem=: ''&,@(1&(3!:4))@(3&u:)@u:
toucoder=: ''&,@:,@:(|."1@(_2: ]\ 1&(3!:4)))@(3&u:)@u:
toucode1=: toucodem`toucoder@.(-.endian) f.
4!:55 <'endian'
jpf_getparms=: 3 : 0
(PDF_DEFSIZE;JPF_DEFFILE) output_parms y
)
pdf_boxrs2wh=: 3 : 0
a=. 2 {."1 y
b=. 2 }."1 y
(a <. b) ,"1 | a - b
)
pdf_getparms=: 3 : 0
(PDF_DEFSIZE;PDF_DEFFILE) output_parms y
)
pdf_dict=: 3 : 0
if. L. y do.
  s=. ; y ,each <LF
else.
  s=. y , (LF ~: {: y) # LF
end.
'<<',LF,s,'>>',LF
)
pdf_rotxy=: 3 : 0
if. ROT do.
  'px py'=. y
  (Sh-py),px
else.
  y
end.
)
pdf_rotxym=: 3 : 0
if. ROT do.
  'px py'=. |:y
  (Sh-py),.px
else.
  y
end.
)
pdf_wraptext=: 3 : 0
'BT ',y,' ET '
)
pdf_write=: 4 : 0
dat=. x
file=. y
while. _1 -: dat flwrite file do.
  msg=. 'Unable to write to file: ',file,LF,LF
  if. #d=. 1!:0 file do.
    msg=. msg, 'If the file is open in Adobe, close the file and try again.'
    if. 1 query msg do. return. end.
  else.
    info msg,'The file name is invalid.' return. end.
end.
if. VISIBLE do.
  viewpdf_j_ file
end.
)
bezierarc=: 3 : 0
'x y h a b'=. y
off=. 90
t1=. rfd 360 | a - off
t2=. rfd 360 | b - off
th=. 6 %~ 2p1 | t2 - t1
'c c1 s s1'=. (cos , sin) th,t1
x0=. x1=. 1 [ y0=. 0
'x3 y3'=. c,s
x2=. 3%~ (8*cos-:th)-x0+x3+3*x1
y2=. y3-(-x2-x3)%-tan th
y1=. 3%~ (8*sin-:th)-y0+y3+3*y2
r=. (x0,x1,x2,x3),:y0,y1,y2,y3
r=. r +/ . *~ (c1,-s1),:s1,c1
r=. r (+/ . *)^:(i.6)~ (c,-s),:s,c
,@|:"2 (x,y)+"2 h*r
)
PDF_FONTOBJ=: 0 : 0
<<
/Type /Font
/Subtype /Type1
/Name /FXX
>>
)
PDF_TRAILER=: 0 : 0
trailer
<<
/Size {z}
/Info 1 0 R
/Root 2 0 R
>>
startxref
)
pdf_build=: 3 : 0
PDFFontpages=: pdf_fontpages ''
pdf_wrap (pdf_header''),pdf_page y
)
pdf_creationdate=: 3 : 0
t=. '20', ; _2 {.each '0' ,each ": each <. 6!:0''
'/CreationDate (D:',t,')'
)
pdf_cidfont=: 4 : 0
txt=. LF;<;.2 ". toupper y -. '-'
msk=. 1 = #&> txt
txt=. msk<@;;._1 txt
txt=. (<'<<',LF) ,each txt ,each <'>>',LF
'a b c'=. txt
prev=. x { 3 + 0 0, +/\PDFFontpages
b=. b rplc '%prev';":prev
c=. c rplc '%prev';":prev+1
c=. c rplc '/Name /F';'/Name /F',":x
a;b;c
)
pdf_fonts=: 3 : 0
ndx=. 1 i.~ 'XX' E. PDF_FONTOBJ
hdr=. ndx {. PDF_FONTOBJ
ftr=. (ndx+2) }. PDF_FONTOBJ
r=. ''
for_f. PDFFonts do.
  if. f e. CIDFONTS do.
    r=. r, ( 1+f_index) pdf_cidfont >f
  else.
    fnt=. (": 1 + f_index),LF,'/BaseFont /', >f
    fnt=. fnt,LF,'/Encoding /WinAnsiEncoding'
    r=. r, <hdr, fnt, ftr
  end.
end.
)
pdf_fontpages=: 3 : 0
1 + 2 * PDFFonts e. CIDFONTS
)
pdf_header=: 3 : 0
t=. '/Title (Plot)'
a=. '/Author (',(9!:14''),')'
p=. '/Producer (J Plot)'
d=. pdf_creationdate''
tit=. pdf_dict t;a;p;d
pag=. ": 3 + +/ PDFFontpages
cat=. pdf_dict '/Type /Catalog',LF,'/Pages ',pag,' 0 R',LF
fnt=. pdf_fonts ''
tit;cat;fnt
)
pdf_page=: 3 : 0
kp=. 4 + +/ PDFFontpages
r=. '/Type /Pages',LF
r=. r, pdf_pageheader''
r=. r, '/MediaBox [',(pfmt Pxywh),']',LF
r=. r,'/Kids [',(":kp),' 0 R]',LF
r=. r, '/Count 1',LF
res=. pdf_dict r
r=. '/Type /Page',LF
r=. r,'/Parent ',(":kp-1),' 0 R',LF
r=. r,'/Contents ',(":kp+1),' 0 R',LF
res=. res ; pdf_dict r
t=. y
s=. '<< /Length ',(":#t),' >>',LF
res ,< s,'stream',LF,t,'endstream',LF
)
pdf_pageheader=: 3 : 0
r=. '/Resources',LF,'<<',LF,' /ProcSet [/PDF /Text]',LF
r=. r,' /Font <<',LF
fx=. ' /F'&, &> ": each 1 + i.#PDFFonts
px=. ' ',. ": &> 2 + +/\ PDFFontpages
r=. r, ,fx ,"1 px ,"1 ' 0 R',LF
r=. r,' >>',LF,'>>',LF
)
pdf_wrap=: 3 : 0
z=. ": 1 + #y
r=. '%PDF-1.3',LF
r=. r, '%', (a. {~128 + a. i. 'elmo'),LF
s=. 'xref',LF,'0 ',z,LF
s=. s,(10#'0'),' 65535 f ',LF

for_i. i.#y do.
  s=. s,(_10 {.!.'0' ": #r),' 00000 n ',LF
  c=. LF,(>i{y)
  r=. r,(":1+i),' 0 obj',c,'endobj',LF,LF
end.
ndx=. I. '{z}' E. PDF_TRAILER
tr=. (ndx {. PDF_TRAILER), z, (ndx+3) }. PDF_TRAILER
r,s,LF,tr,(":#r),LF,'%%EOF'
)
MSUNGLIGHT=: 0 : 0
/Type /FontDescriptor
/FontName /MSung-Light
/Flags 5
/FontBBox [ -260 -174 1043 826 ]
/MissingWidth 600
/StemV 93
/ItalicAngle 0
/CapHeight 625
/Ascent 826
/Descent -174

/Type /Font
/Subtype /CIDFontType0
/BaseFont /MSung-Light
/FontDescriptor %prev 0 R
/CIDSystemInfo << /Registry (Adobe)/Ordering (CNS1)/Supplement 4 >>
/DW 1200
/W [ 1 255 600 ]

/Type /Font
/Subtype /Type0
/Name /F
/BaseFont /MSung-Light
/DescendantFonts [ %prev 0 R ]
/Encoding /UniCNS-UTF16-H
)
STSONGLIGHT=: 0 : 0
/Type /FontDescriptor
/FontName /STSong-Light
/Flags 5
/FontBBox [ -260 -174 1043 826 ]
/MissingWidth 600
/StemV 93
/ItalicAngle 0
/CapHeight 625
/Ascent 826
/Descent -174

/Type /Font
/Subtype /CIDFontType0
/BaseFont /STSong-Light
/FontDescriptor %prev 0 R
/CIDSystemInfo << /Registry (Adobe)/Ordering (GB1)/Supplement 4 >>
/DW 1200
/W [ 1 255 600 ]

/Type /Font
/Subtype /Type0
/Name /F
/BaseFont /STSong-Light
/DescendantFonts [ %prev 0 R ]
/Encoding /UniGB-UTF16-H
)
pdf_circle=: 3 : 0
'x y r'=. y
arc=. _2 [\ 0 1 2 1 1 2 1 0 { 0 1, 4r3*<:%:2
arr=. |."1 arc *"1 [ _1 1
mat=. _4 ,\ arc,arr,-arc,arr
(mat * r) + ($mat) $ x,y
)

pdf_colorstroke=: 3 : 0
(": y % 255),"1 ' RG '
)
pdf_colorfill=: 3 : 0
(": y % 255),"1 ' rg '
)
pdf_color=: 3 : 0
clr=. ": y % 255
clr ,"1 ' RG ' ,"1 clr ,"1 ' rg '
)
pdf_makelines=: 3 : 0
if. 2 > #$y do.
  ,: (pfmt 2 {. y),' m ',,(pfmt _2 [\ 2 }. y) ,"1 ' l '
else.
  mov=. (pfmt 2 {."1 y) ,"1 ' m '
  lns=. ,"2 (pfmt _2 [\"1 [ 2 }."1 y) ,"1 ' l '
  mov,.lns
end.
)
pdf_pens=: 4 : 0
(pdf_color x) ,"1 (":,.PDF_PENSCALE*y) ,"1 ' w '
)
pdf_pen=: 4 : 0
(pdf_color ,x), (":PDF_PENSCALE*y) ,' w '
)
pdf_lines=: 3 : 0
(pdf_makelines y) ,"1 ' S'
)
pdf_text=: 4 : 0
0 pdf_text y
:
'fnt clr txt pos align rot und'=. y

clr=. pdf_color clr

txt=. ,each boxopen txt
if. und +. align e. iCENTER, iRIGHT do.
  len=. fnt pgetstringlen txt
end.
if. x do.
  txt=. toucode1@(7&u:) each txt
else.
  tx=. 0$<''
  for_t. txt do.
    if. 0-: t1=. 7&u: ::0: t=. >t do.
      tx=. tx, <u2a t
    else.
      if. *./ 256 > 3&u: t1 do.
        tx=. tx, < 1&u: t1
      else.
        tx=. tx, <u2a t
      end.
    end.
  end.
  txt=. tx
end.

txt=. pdfesc each txt
select. rot

case. 0 do.
  select. align
  case. iCENTER do.
    pos=. pos -"1 (-:len),.0
  case. iRIGHT do.
    pos=. pos -"1 len,.0
  end.
  txt=. (<' Tm (') ,each txt ,each <') Tj '
  res=. clr,(<"1 '1 0 0 1 ' ,"1 pfmt pos >. 0) ,&> txt
case. 1 do.
  select. align
  case. iCENTER do.
    pos=. pos -"1 [ 0,.-:len
  case. iRIGHT do.
    pos=. pos -"1 [ 0,.len
  end.
  txt=. (<' Tm (') ,each txt ,each <') Tj '
  res=. clr,(<"1 '0 1 -1 0 ' ,"1 pfmt pos >. 0) ,&> txt
case. 2 do.
  select. align
  case. iCENTER do.
    pos=. pos +"1 [ 0,.-:len
  case. iRIGHT do.
    pos=. pos +"1 [ 0,.len
  end.
  txt=. (<' Tm (') ,each txt ,each <') Tj '
  res=. clr,(<"1 '0 -1 1 0 ' ,"1 pfmt pos >. 0) ,&> txt
end.
if. -. und do. res;'' return. end.
pos=. citemize pos
len=. , len

'off lwd'=. getunderline fnt
lin=. clr,' ',(":lwd) ,' w '

select. rot
case. 0 do.
  bgn=. 0 >. pos -"1 [ 0,.-off
  end=. bgn + len,.0
case. 1 do.
  bgn=. 0 >. pos -"1 off,.0
  end=. bgn + 0,.len
case. 2 do.
  bgn=. 0 >. pos +"1 off,.0
  end=. bgn - 0,.len
end.

lin=. lin,(pdf_makelines bgn,.end) ,"1 ' b'
res;lin

)
pdfcircle=: 3 : 0
'v s f e c p'=. y
if. isempty c do.
  if. is1color e do.
    pbuf e pdf_pen v
    clr=. (#p) $ citemize pdf_color e
    for_i. i.#p do.
      pbuf i{clr
      pos=. pdf_circle i{p
      mov=. (pfmt 2 {. {. pos) , ' m '
      pbuf mov
      crv=. (pfmt 2 }."1 pos) ,"1 ' c '
      pbuf crv
      pbuf 'S'
    end.
  end.
end.
)
pdfdot=: 3 : 0
'v s f e c p'=. y
pbuf e pdf_pen v
for_i. i.#p do.
  pos=. pdf_circle (i{p), v
  pbuf (pfmt 2 {. {. pos) , ' m '
  pbuf (pfmt 2 }."1 pos) ,"1 ' c '
  pbuf 'B'
end.
)
pdffxywh=: 3 : 0
p=. _1 pick y
if. #p do.
  PDFClip=: >: PDFClip
  pbuf 'q ',(":p),' re W n'
else.
  if. PDFClip do.
    PDFClip=: <: PDFClip
    pbuf 'Q'
  end.
end.
)
pdfline=: 3 : 0
'v s f e c p'=. y
if. (is1color e) *. 1 = #s do.
  pbuf e pdf_pen v
  pbuf pdf_lines p
else.
  rws=. #p
  e=. rws $ citemize e
  v=. rws $ v
  pen=. e pdf_pens v
  pbuf pen ,. pdf_lines p
end.
)
pdfmarker=: 3 : 0
's m f e c p'=. y
pbuf e pdf_pen 1
s ('pdfmark_',m)~ citemize p
)
pdfpie=: 3 : 0
'v s f e c p'=. y
pbuf e pdf_pen v
clr=. (pdf_colorfill c),"1 pdf_colorstroke e
clr=. (#p) $ citemize clr
for_i. i.#p do.
  pbuf i{clr
  pos=. bezierarc i{p
  pbuf (pfmt 2{.i{p), ' m ',(pfmt 2{.{.pos),' l '
  pbuf (pfmt 2}."1 pos),"1 ' c '
  pbuf 'b'
end.
)
pdfpline=: 3 : 0
'v s f e c p'=. y
if. *./ s = 0 do.
  pdfline y return.
end.
s=. s { PENPATTERN
if. (is1color e) *. 1 = #v do.
  pos=. s linepattern"0 1 p
  pdfline (<pos) _1 } y
else.
  rws=. #p
  e=. rws $ citemize e
  v=. rws $ v
  s=. rws $ s
  for_i. i.#p do.
    pos=. (i{s) linepattern i{p
    pdfline (i{v);0;0;(i{e);0;pos
  end.
end.
)
pdfpoly=: 3 : 0
'v s f e c p'=. y
if. v=0 do. e=. c end.
c=. citemize c
e=. citemize e
pbuf ({.e) pdf_pen v
pos=. (pdf_makelines p) ,"1 (v=0) pick ' b';' h f'
if. (1 = # ~.e) *. 1 = # ~.c do.
  pbuf (pdf_colorfill {.c), pdf_colorstroke {.e
  pbuf pos
else.
  c=. pos cmatch pdf_colorfill c
  e=. pos cmatch pdf_colorstroke e
  pbuf c,.e,.pos
end.
)
pdfrect=: 3 : 0
'v s f e c p'=. y
p=. pdf_boxrs2wh p
if. v=0 do.
  clr=. (pdf_colorfill c),"1 pdf_colorstroke c
else.
  pbuf e pdf_pen v
  clr=. (pdf_colorfill c),"1 pdf_colorstroke e
end.
pbuf clr ,"1 (pfmt p) ,"1 ' re B'
)
pdftext=: 3 : 0
't f a e c p'=. y
'fnx fst fsz fan und'=. f
rot=. 3 | 0 90 270 i. fan
asc=. pgetascender f
fnm=. <getfntname fnx,fst
PDFFonts=: ~. PDFFonts,fnm
fnx=. 1 + PDFFonts i. fnm
txt=. '/F',(":fnx),' ',(": getplotfontsize f),' Tf '
select. rot
case. 0 do. p=. 0 >. p -"1 [ 0, asc
case. 1 do. p=. p +"1 asc, 0
case. 2 do. p=. p -"1 asc, 0
end.

lin=. ''
if. is1color e do.
  'rtxt rlin'=. (fnm e. CIDFONTS) pdf_text f;e;t;p;a;rot;und
  txt=. txt,,LF ,"1 rtxt
  lin=. lin,rlin,(0<#rlin)#LF
else.
  for_i. i.#e do.
    'rtxt rlin'=. (fnm e. CIDFONTS) pdf_text f;(i{e);(i{t);(i{p);a;rot;und
    txt=. txt,,LF ,"1 rtxt
    lin=. lin,rlin,(0<#rlin)#LF
  end.
end.
pbuf pdf_wraptext txt
pbuf rlin
)
PDFESC0=: LF,CR,TAB,FF,(8{a.),'\()'
PDFESC1=: 'nrtfb\()'
PDFASC=: PDFESC0,32}.127{.a.
pdfesc=: 3 : 0
txt=. y
msk=. txt e. PDFESC0
if. 1 e. msk do.
  ndx=. , ((I. msk) + i. +/ msk) +/ 0 1
  new=. ,'\',.PDFESC1 {~ PDFESC0 i. msk#txt
  txt=. new ndx } (1 + msk) # txt
end.
msk=. -. txt e. PDFASC
if. 1 e. msk do.
  new=. 1 ": 8 8 8 #: a. i. msk # txt
  ndx=. ,((I. msk) + 3 * i. +/ msk) +/ i. 4
  txt=. (,'\',"1 new) ndx } (1 + msk * 3) # txt
end.

txt
)
pdfmark_circle=: 4 : 0
s=. 3.5 * x
p=. y ,. s
for_d. p do.
  pos=. pdf_circle d
  pbuf (pfmt 2 {. {. pos) , ' m '
  pbuf (pfmt 2 }."1 pos) ,"1 ' c '
  pbuf 'B'
end.
)
pdfmark_diamond=: 4 : 0
p=. 8 $"1 y
d=. (3.5 * x) * _1 0 0 1 1 0 0 _1
p=. p +"1 d
pbuf (pdf_makelines p) ,"1 ' b'
)
pdfmark_line=: 4 : 0
'x y'=. , y
p=. (x--:KeyLen),(y--:KeyPen),KeyLen,KeyPen
pbuf (pfmt p) ,"1 ' re B'
)
pdfmark_plus=: 4 : 0
s=. 0, x * 4
t=. |. s
p=. (y -"1 t) ,. y +"1 t
p=. p, (y -"1 s) ,. y +"1 s
pbuf (":PDF_PENSCALE * 5 * x) , ' w '
pbuf (pdf_makelines p) ,"1 ' b'
)
pdfmark_square=: 4 : 0
s=. 3 * x
p=. (y - s) ,"1 +: s,s
pbuf (pfmt p) ,"1 ' re B'
)
pdfmark_times=: 4 : 0
s=. _1 + 3 * x
p=. y
r=. (p - s) ,. p + s
s=. (p +"1 s * 1 _1) ,. p +"1 s * _1 1
pbuf (":PDF_PENSCALE * 5 * x) , ' w '
pbuf (pdf_makelines r,s) ,"1 ' b'
)
pdfmark_triangle=: 4 : 0
p=. 6 $"1 y
d=. (4 * x) * , (sin,.cos) 2p1 * 0 1 2 % 3
p=. p +"1 d
pbuf (pdf_makelines p) ,"1 ' b'
)
pdf_get=: 3 : 0
'size file ctx'=. 3{. pdf_getparms y
pdf_make size
)
pdf_jpf=: 3 : 0
'size file ctx'=. 3{. jpf_getparms y
txt=. pdf_make size
size=. ":size
fnt=. ; PDFFonts ,each ','
top=. ; (size;fnt) ,each ';'
txt=. top,LF,txt
res=. txt flwritenew file
if. _1 -: res do.
  info 'Unable to write to file: ',file
end.
)
pdf_show=: 3 : 0
'size file ctx'=. 3{. pdf_getparms y
res=. pdf_make size
res=. pdf_build res
res pdf_write file
)
pdf_make=: 3 : 0
make iPDF;0 0,y
fns=. 'pdf'&, each 1 {"1 Plot
dat=. 3 }."1 Plot
buf=: ''
PDFFonts=: ,<'Helvetica'
PDFClip=: 0
for_d. dat do.
  (>d_index{fns)~d
end.
dtbs buf
)
coclass 'jzplot'
QT_DEFSIZE=: (UNAME-:'Android'){::480 360;400 300
QT_DEFFILE=: jpath '~temp/plot'
QT_PENSCALE=: 0.4
fext=: 4 : 0
f=. deb y
f, (-. x -: (-#x) {. f) # x
)
gettemp=: 3 : 0
p=. jpath '~temp/'
d=. 1!:0 p,'*.',y
a=. 0, {.@:(0&".)@> _4 }. each {."1 d
a=. ": {. (i. >: #a) -. a
p,a,'.',y
)
qtfontdesc=: 3 : 0
'ind fst siz ang und'=. y
'ita bld'=. 2 2 #: fst
sty=. (bld#' bold'),(ita#' italic'),und#' underline'
if. ' ' e. nam=. ind pick QTFONTNAMES do. nam=. '"', nam, '"' end.
nam,' ',(":siz),sty
)

qt_getsize=: 3 : 0
if. -. wdishandle :: 0: ": PFormhwnd do. '' return. end.
wd 'psel ', ":PFormhwnd
s=. wdqchildxywh ::0: PId
if. s -: 0 0 0 0 do. '' return. end.
2 3 { s
)
output_parms=: 4 : 0
'size file'=. x
if. #y do.
  prm=. qchop y
  select. #prm
  case. 1 do.
    file=. 0 pick prm
  case. 2 do.
    size=. 0 ".&> prm
  case. 3 do.
    file=. 0 pick prm
    size=. 0 ". &> _2 {. prm
    if. 0 e. size do.
      size=. 0 ". &> 2 {. prm
      file=. 2 pick prm
    end.
  end.
else.
  if. #sz=. qt_getsize'' do.
    size=. sz
  end.
end.
size;file
)
qt_clip=: 3 : 0
if. -. IFWIN do.
  info 'Save plot to clipboard is only available in Windows'
  return.
end.
f=. gettemp 'emf'
qt_emf dquote f
wd 'clipcopyx enhmetafile ',dquote f
1!:55 <f
)
qt_gpcount=: ,"1~ 1 + [: {: 1 , $
qt_gpcut=: 3 : 0
r=. ''
while. #y do.
  n=. {. y
  if. n=0 do.
    info 'zero length segment at: ',":#;r
    r
    return.
  end.
  r=. r, < n {. y
  y=. n }. y
end.
r
)
qt_gpbuf=: 3 : 0
assert. 2 > #$y
buf=: buf,y
)
qt_gpapply=: 3 : 0
rc=. glcmds buf
assert. 0=rc [ 'glcmds buf'
buf=: $0
)
qt_gpflip=: flipxy @ rndint
qt_gpfliplast=: 3 : 0
(<qt_gpflip _1 pick y) _1 } y
)
qt_gpinit=: 3 : 0
buf=: bufdef=: $0
)
qt_gpbrushnull=: 3 : '2 2005'
qt_gppens=: 4 : 0
y=. rndint y
5 2032,"1 x,"1 [ 4 2022,"1 y,.(y~:0){PS_NULL,PS_SOLID
)
qt_gppen=: 4 : 0
y=. rndint y
5 2032,(,x),4 2022,y,(y~:0){PS_NULL,PS_SOLID
)
qt_gppens1=: 3 : 0
5 2032,"1 y,"1 [ 4 2022 1,PS_SOLID
)
qt_gppen1=: 3 : 0
5 2032,(,y),4 2022 1,PS_SOLID
)
qt_gppenbrush1=: 3 : 0
5 2032,(,y),4 2022 1,PS_SOLID,2 2004
)
qt_gppixel=: 3 : 0
's t f e c p'=. y
p=. qt_gpcount 2024 ,"1 qt_gpflip p
if. is1color e do.
  qt_gpbuf e qt_gppen 1
  qt_gpbuf ,p
else.
  rws=. #p
  e=. rws $ citemize e
  pen=. e qt_gppens 1
  qt_gpbuf ,pen ,. p
end.
)
qt_gppline=: 4 : 0
's t f e c p'=. y
if. (is1color e) *. 1 = #s do.
  qt_gpbuf (,e) qt_gppen s
  qt_gpbuf ,qt_gpcount x,"1 p
else.
  rws=. #p
  e=. rws $ citemize e
  s=. rws $ s
  pen=. e qt_gppens s
  qt_gpbuf ,pen ,. qt_gpcount x,"1 p
end.
)
qt_gppshape=: 4 : 0
'v s f e c p'=. y

if. v=0 do. e=. c end.

if. is1color e do.
  qt_gpbuf e qt_gppen v
  if. isempty c do.
    qt_gpbuf qt_gpbrushnull''
    qt_gpbuf ,qt_gpcount x,"1 p
  elseif. is1color c do.
    qt_gpbuf 5 2032,(,c),2 2004
    qt_gpbuf ,qt_gpcount x,"1 p
  elseif. do.
    c=. (#p) $ c
    clr=. 5 2032 ,"1 c ,"1 [ 2 2004
    qt_gpbuf , clr ,. qt_gpcount x,"1 p
  end.
else.
  e=. (#p) $ e
  e=. e qt_gppens v
  if. isempty c do.
    qt_gpbuf qt_gpbrushnull''
    qt_gpbuf , e ,. qt_gpcount x,"1 p
  elseif. is1color c do.
    qt_gpbuf 5 2032,(,c),2 2004
    qt_gpbuf , e ,. qt_gpcount x,"1 p
  elseif. do.
    c=. (#p) $ c
    clr=. 5 2032 ,"1 c ,"1 [ 2 2004
    qt_gpbuf , e ,. clr ,. qt_gpcount x,"1 p
  end.

end.
)
qtarc=: 3 : '2001 qt_gppline qt_gpfliplast y'
qtline=: 3 : '2015 qt_gppline qt_gpfliplast y'
qtpie=: 3 : '2023 qt_gppshape qt_gpfliplast y'
qtpoly=: 3 : '2029 qt_gppshape qt_gpfliplast y'
qtcircle=: 3 : 0
p=. _1 pick y
ctr=. qt_gpflip 0 1 {"1 p
rad=. rndint 2 {"1 p
xy=. ctr - rad
wh=. +: rad ,. rad
p=. xy ,. wh
2008 qt_gppshape (<p) _1 } y
)
qtdot=: 3 : 0
'v s f e c p'=. y
select. v
case. 1 do.
  qt_gppixel y
case. 2 do.
  p=. qt_gpflip p
  p=. (p-1) ,"1 [ 2 2
  dat=. 1;0;0;e;e;p
  2031 qt_gppshape dat
case. 3 do.
  h=. (p-"1[1 0) ,. p+"1[2 0
  v=. (p-"1[0 1) ,. p+"1[0 2
  qtline 1;0;0;e;e;h,v
case. do.
  o=. >. -: v
  p=. p ,"1 v,.v
  qtcircle 1;0;0;e;e;p
end.
)
qtfxywh=: 3 : 0
p=. _1 pick y
if. #p do.
  'x y w h'=. p
  xy=. _1 + <. x,Ch-y+h
  wh=. 2 + >. w,h
  qt_gpbuf 6 2078,xy,wh
else.
  qt_gpbuf 2 2079
end.
)
qtmarker=: 3 : 0
's m f e c p'=. y
p=. qt_gpflip p
qt_gpbuf qt_gppenbrush1 e
s ('qtmark_',m)~ p
)
qtpie=: 3 : 0
p=. _1 pick y
ctr=. qt_gpflip 0 1 {"1 p
rad=. 2 {"1 p
ang=. 3 4 {"1 p
xy=. ctr - rad
wh=. +: rad ,. rad
tx=. ({."1 ctr) + rad * sind ang
ty=. ({:"1 ctr) + rad * cosd ang
p=. rndint xy ,. wh ,. ,"2 tx ,"0 ty
2023 qt_gppshape (<p) _1 } y
)
qtpline=: 3 : 0
's t f e c p'=. y
if. *./ t = 0 do.
  qtline y return.
end.
p=. qt_gpflip p
t=. t { PENPATTERN
if. (is1color e) *. 1 = #s do.
  qt_gpbuf 5 2032,(,e),4 2022,s,PS_SOLID
  pos=. t linepattern"0 1 p
  qt_gpbuf ,qt_gpcount 2015,"1 pos
else.
  rws=. #p
  e=. rws $ citemize e
  s=. rws $ s
  t=. rws $ t
  pen=. e qt_gppens s
  for_i. i.#p do.
    qt_gpbuf i{pen
    pos=. (i{t) linepattern i{p
    qt_gpbuf ,qt_gpcount 2015,"1 pos
  end.
end.
)
qtrect=: 3 : 0
p=. boxrs2wh^:1 qt_gpflip _1 pick y
y=. (<p) _1 } y
2031 qt_gppshape y
)
qttext=: 3 : 0

't f a e c p'=. y

degree0=. 3{f
f=. qtfontdesc^:(0={.0#f) f
p=. qt_gpflip p
t=. text2utf8 each boxopen t
if. a do.
  glfontextent f
  off=. <. -: a * {."1 wh=. glqextent &> t
  if. (90=degree0)+.(1 e. 'angle900' E. f) do.
    p=. p + "1 <. (0.2*{:wh),.off
  elseif. (270=degree0)+.(1 e. 'angle2700' E. f) do.
    p=. p - "1 <. (0.2*{:wh),.off
  elseif. do.
    p=. p -"1 off,. 0
  end.
end.
'face size style degree'=. parseFontSpec f
qt_gpbuf qt_gpcount 2312,(<.size*10),style,(<.degree0*10),alfndx,face
if. is1color e do.
  qt_gpbuf 5 2032,(,e),2 2040
  if. rank01 p do.
    qt_gpbuf qt_gpcount 2056,p
    qt_gpbuf qt_gpcount 2038,alfndx,>t
  else.
    t=. qt_gpcount each 2038 ,each alfndx each t
    t=. (<"1 qt_gpcount 2056 ,"1 p) ,each t
    qt_gpbuf ; t
  end.
else.
  t=. qt_gpcount each 2038 ,each alfndx each t
  t=. t ,each <"1 qt_gpcount 2056 ,"1 p
  t=. (<"1 (5 2032 ,"1 e) ,"1 [ 2 2040) ,each t
  qt_gpbuf ; t
end.

)
parseFontname=: 3 : 0
font=. ' ',y
b=. (font=' ') > ~:/\font='"'
a: -.~ b <@(-.&'"');._1 font
)
FontStyle=: ;:'regular bold italic underline strikeout'
parseFontSpec=: 3 : 0
'ns styleangle'=. 2 split parseFontname y
'face size'=. ns
size=. 12". size
style=. FontStyle i. tolower each styleangle
style=. <.+/2^<:style #~ style e. i.#FontStyle
if. 1 e. an=. ('angle'-:5&{.)&> styleangle do.
  degree=. 10%~ 0". 5}.>(an i. 1){styleangle
else.
  degree=. 0
end.
face;size;style;degree
)
qtmark_circle=: 4 : 0
s=. rndint x * 3
p=. (y - s) ,"1 >: +: s,s
qt_gpbuf ,qt_gpcount 2008 ,"1 p
)
qtmark_diamond=: 4 : 0
s=. rndint x * 4
'x y'=. |: y
p=. (x-s),.y,.x,.(y+s),.(x+s),.y,.x,.y-s
qt_gpbuf ,qt_gpcount 2029 ,"1 p
)
qtmark_line=: 4 : 0
'x y'=. , y
p=. >.(x--:KeyLen),(y--:KeyPen),<:KeyLen,KeyPen
qt_gpbuf ,qt_gpcount 2031 ,p
)
qtmark_plus=: 4 : 0
s=. rndint 4 1 * x
p=. (y -"1 s) ,"1 +: s
s=. |. s
p=. p , (y -"1 s) ,"1 +: s
qt_gpbuf ,qt_gpcount 2031 ,"1 p
)
qtmark_square=: 4 : 0
s=. rndint x * 3
p=. (y - s) ,"1 +: s,s
qt_gpbuf ,qt_gpcount 2031 ,"1 p
)
qtmark_times=: 4 : 0
if. x = 1 do.
  p=. (y - 3) ,. y + 4
  q=. (y - "1 [ 3 _3) ,. y +"1 [ 4 _4
  p=. p, (p +"1 [ 0 1 _1 0), p + "1 [ 1 0 0 _1
  q=. q, (q +"1 [ 0 _1 _1 0), q +"1 [ 1 0 0 1
  qt_gpbuf ,qt_gpcount 2015 ,"1 p,q
else.
  s=. rndint _1 + 3 * x
  n=. rndint 2 * x
  p=. (y - s) ,. y + s
  q=. (y - "1 s * 1 _1) ,. y +"1 s * 1 _1
  qt_gpbuf 4 2022,n,PS_SOLID
  qt_gpbuf ,qt_gpcount 2015 ,"1 p,q
end.
)
qtmark_triangle=: 4 : 0
s=. rndint 2 * x
t=. rndint 4 * x
'x y'=. |: y
p=. rndint (x-t),.(y+s),.(x+t),.(y+s),.x,.y-t
qt_gpbuf ,qt_gpcount 2029 ,"1 p
)
PRINTP=: ''
qt_print=: 3 : 0
if. PRINTP do. wd 'psel ',(":PRINTP),';pclose' end.
wd 'pc print;cc g canvas'
PRINTP=: wdqhwndp''
PRINTED=: 0
opt=. '"" "" "" orientation ',":ORIENTATION
glprint opt
)
print_g_print=: 3 : 0
'page pass'=. ". sysdata
select. pass
case. _1 do.
  PRINTP=: PRINTPXYWH=: 0
  wd 'pclose'
case. 0 do.
  glprintmore -.PRINTED
case. do.
  'Cw Ch'=: glqprintwh''
  qt_paintit qt_printwin''
  PRINTED=: 1
end.
)
qt_printwin=: 3 : 0
'pw ph mw mh'=. 4 {. glqprintpaper''
mrg=. 0 >. PRINTMARGIN - mw,(ph - mh + Ch),(pw - mw + Cw),mh
xywh=. (0 0,Cw,Ch) shrinkrect mrg
if. 0 = #PRINTWINDOW do.
  xywh
else.
  if. 4 ~: #PRINTWINDOW do.
    info 'PRINTWINDOW should be of form: x y wh' return.
  end.
  'x y w h'=. xywh
  'px py pw ph'=. PRINTWINDOW%1000
  fx=. x + px * w
  fy=. y + py * h
  fw=. (x-fx) + pw * w
  fh=. (y-fy) + ph * h
  fx,fy,fw,fh
end.
)
QT_SAVES=: (,,&'r'each) ;: 'bmp jpg png tif'
qt_bmp=: 3 : 0
if. #y do.
  arg=. qchop y
  num=. __ ". &.> arg
  msk=. __ e. &> num
  file=. > {. msk # arg
  wh=. >(-.msk) # num
  if. -. (#wh) e. 0 2 do.
    info 'invalid [w h] parameter in save bmp' return.
  end.
else.
  wh=. file=. ''
end.
file=. 'bmp' qt_getfile file
if. (2 = #wh) > wh -: Pw,Ph do.
  a=. cocreate''
  coinsert__a (,copath) coname''
  bitmap=. qt_getbitmapwh__a wh
  coerase a
else.
  bitmap=. qt_getbitmap''
end.
bitmap writebmp file
)

qt_png=: 3 : 0
if. #y do.
  arg=. qchop y
  num=. __ ". &.> arg
  msk=. __ e. &> num
  file=. > {. msk # arg
  wh=. >(-.msk) # num
  if. -. (#wh) e. 0 2 do.
    info 'invalid [w h] parameter in save png' return.
  end.
else.
  wh=. file=. ''
end.
file=. 'png' qt_getfile file
if. (2 = #wh) > wh -: Pw,Ph do.
  a=. cocreate''
  coinsert__a (,copath) coname''
  bitmap=. qt_getbitmapwh__a wh
  coerase a
else.
  bitmap=. qt_getbitmap''
end.
bitmap writepng file
)
qt_def=: 4 : 0
file=. x qt_getfile ;qchop y
(qt_getrgb'') qt_writeimg file
)
qt_defstr=: 4 : 0
type=. x
(qt_getrgb'') putimg type
)
qt_get=: 3 : 0
if. #y do.
  type=. tolower firstword y
  if. (<type) e. ;: 'gif jpg png tif' do.
    y=. type,'r ', (#type)}. y
  end.
end.
qt_save y
)
qt_getbitmap=: 3 : 0
wd 'psel ',": PFormhwnd
glsel PId
box=. 0 0,2}.wdqchildxywh PId
res=. glqpixels box
(3 2 { box) $ res
)
qt_getbitmapwh=: 3 : 0
wd 'pc a owner;wh 480 400;cc g canvas;pas 0 0'
PFormhwnd=: wdqhwndp''
PId=: 'g'
wd 'set g wh ',":y
wd 'pshow'
glpaint''
res=. qt_getbitmap''
wd 'pclose'
res
)
qt_getfile=: 4 : 0
jpath ('.',x) fext y,(0=#y) # QT_DEFFILE
)
qt_getrgb=: 3 : 0
wd 'psel ',": PFormhwnd
glsel PId
box=. 0 0,2}.wdqchildxywh PId
(3 2 { box) $ 256 256 256 #: glqpixels box
)
qt_jpg=: 3 : 0
file=. ''
qual=. 100
if. #y do.
  arg=. qchop y
  num=. __ ". &.> arg
  msk=. +./ &> num = &.> __
  file=. > {. msk # arg
  qual=. <. {. (>(-.msk) # num),qual
end.
file=. 'jpg' qt_getfile file
rgb=. qt_getrgb''
rgb qt_writeimg file
)
qt_png=: 3 : 0
file=. ''
comp=. 9
if. #y do.
  arg=. qchop y
  num=. __ ". &.> arg
  msk=. +./ &> num = &.> __
  file=. > {. msk # arg
  comp=. <. {. (>(-.msk) # num),comp
end.
file=. 'png' qt_getfile file
rgb=. qt_getrgb''
rgb qt_writeimg file
)
qt_save=: 3 : 0
if. Poutput ~: iQT do.
  msg=. 'First display a Plot.'
  info msg return.
end.
if. 0=#y do.
  qt_clip'' return.
end.
type=. tolower firstword y
if. (<type) e. QT_SAVES do.
  ('qt_',type)~ (1+#type) }. y
else.
  info 'Save to type not supported:',type
end.
)
qt_writeimg=: 4 : '(256 #. 255 ,"0 1 x) writeimg_jqtide_ y'
qt_gif=: 'gif' & qt_def
qt_tif=: 'tif' & qt_def
qt_pngr=: 'png' & qt_defstr
qt_jpgr=: 'jpg' & qt_defstr
qt_gifr=: 'gif' & qt_defstr
qt_tifr=: 'tif' & qt_defstr
qt_show=: 3 : 0
popen_qt y
glpaintx''
if. 0~: 4!:0 <'VISIBLE' do. '' return. end.
if. PShow=0 do.
  if. VISIBLE do.
    wd 'pshow ',PSHOW
  else.
    wd 'pshow hide'
  end.
  wd 'ptop ',":PTop
  PShow=: 1
else.
  if. VISIBLE do.
    wd 'ptop'
  end.
end.
''
)
qt_paint=: 3 : 0
selectpid''
'Cw Ch'=: glqwh''
qt_paintit 0 0,Cw,Ch
0
)
qt_paintit=: 3 : 0
qt_gpinit''
try.
  make iQT;y
catch.
  PCmd=: Plot=: i.0 0
  echo  13!:12''
end.
if. 0=#Plot do. return. end.
try.
ids=. 1 {"1 Plot
fns=. 'qt'&, each ids
dat=. 3 }."1 Plot
for_d. dat do.
  (>d_index{fns)~d
end.
qt_gpapply''
catch.
echo 13!:12''
end.
)
coclass 'jzplot'
plot_area=: 3 : 0

'x y'=. 2 {. y { Data

if. 1 e. 0 > ,y do.
  signal 'area plot y-values should not be negative'
end.

x=. get01x x
y=. get01y y
clr=. getitemcolor #y

for_d. y do.
  pts=. fitgrafxy x makearea d
  drawpoly iDATA;EDGECOLOR;EDGESIZE;(d_index{clr);,pts
end.

)
makearea=: 4 : 0
(x ,. y),1 0,0 0,:0,{.y
)
plot_bar=: 3 : 0
'x y'=. 2 {. y { Data
dat=. citemize y
pos=. makebar dat
pos makedrawbar dat
)
plot_fbar=: 3 : 0
'x y'=. 2 {. y { Data
dat=. citemize y
pos=. makestackbar dat
pos=. ({:$dat) }. pos
dat=. }. dat
pos makedrawbar dat
)
plot_fbarv=: 3 : 0
'x y'=. 2 {. y { Data
dat=. citemize y
pos=. makestackbar |. dat
pos=. ({:$dat) }. pos
dat=. }. dat
pos makedrawbarv dat
)
plot_sbar=: 3 : 0
'x y'=. 2 {. y { Data
dat=. citemize y
pos=. makestackbar dat
pos makedrawbar dat
)
plot_sbarv=: 3 : 0
'x y'=. 2 {. y { Data
dat=. citemize y
pos=. makestackbar |.dat
pos makedrawbarv dat
)
makedrawbar=: 4 : 0
pos=. x
dat=. y
'r c'=. $dat
if. r=1 do.
  drawrect iDATA;EDGECOLOR;EDGESIZE;(ITEMCOLOR {~ 0 >, dat);pos
else.
  clr=. r $ ITEMCOLOR
  pos=. (-c) ,\ pos
  for_p. pos do.
    drawrect iDATA;EDGECOLOR;EDGESIZE;(p_index{clr);_4 [\ p
  end.
end.
)
makedrawbarv=: 4 : 0
pos=. x
dat=. y
'r c'=. $dat
if. r=1 do.
  drawrect iDATA;EDGECOLOR;EDGESIZE;(|.ITEMCOLOR {~ 0 >, dat);pos
else.
  clr=. |. r $ ITEMCOLOR
  pos=. (-c) ,\ pos
  for_p. pos do.
    drawrect iDATA;EDGECOLOR;EDGESIZE;(p_index{clr);_4 [\ p
  end.
end.
)
makebar=: 3 : 0
dat=. ,y
'r c'=. $y
w=. Gw * BARWIDTH % r * c
t=. Gw * -: (-.BARWIDTH) % c
if. r=1 do.
  x=. Gw * }: int01 c
else.
  x=. ,(w * i.r) +/ Gw * }: int01 c
end.
x=. Gx + x + t
if. YDiv=0 do.
  h=. (dat-YMin) % YMax-YMin
elseif. YDiv=1 do.
  h=. (dat-YMax) % YMax-YMin
elseif. do.
  h=. dat % (YMax%1-YDiv) >. |YMin%YDiv
end.
h=. Gh * h
y=. Gy + Gh * YDiv
x,.y,.(x+w),.y+h
)
makestackbar=: 3 : 0
dat=. ,y
if. 1 e. 0 > dat do.
  signal 'stackbar values should not be negative'
end.
'r c'=. $y
wid=. BARWIDTH
w=. Gw * wid % c
t=. Gw * -: (-.wid) % c
h=. Gh * y % YMax
y=. Gy + ,+/\ h
x=. Gx + ($y) $ t + Gw * }: int01 c
x,.y,.(x+w),.y-,h
)
CONTRI=: 0 1 4, 0 2 4, 1 4 3,: 2 4 3
CONPTS=: 0 0 1 0 0.5 0.5, 0 0 0 1 0.5 0.5, 1 0 0.5 0.5 1 1,: 0 1 0.5 0.5 1 1
plot_contour=: 3 : 0

'x y z'=. y { Data

signal^:(2 ~: #$z) 'need data matrix for contour plot'

dat=. |: z
'rws cls'=. shape=. $dat
dat=. ,dat
min=. <./dat
max=. >./dat
dat=. (CONTOURLEVELS + 1) * (dat - min) % max - min
ndx=. ,/ 2 2 ,;._3 i. shape
dat=. |: ndx { dat
lvl=. *./ dat ="1 <.{. dat
dat=. dat, (lvl * 0.001) + 0.25 * +/ dat
dat=. ,/ 0 1 |: CONTRI { dat
xy=. 4 # ((#ndx) $ (i.cls-1)),.(cls-1) # i.rws-1
txy=. xy,.(#dat) $ 0 1 2 3
msk=. +./"1 (~:{."1) <. dat
txy=. msk # txy
dat=. msk # dat
mat=. (<.dat),.dat,.txy
res=. i.0 0
for_m. mat do.
  res=. res, contri m
end.
lvl=. {."1 res
pos=. }."1 res
pos=. pos % ($pos) $ <: |. shape
pos=. fitgrafxy pos
clr=. getbandcolor lvl
drawline iDATA;clr;PENSIZE;pos
)
contri=: 3 : 0
'l0 l1 l2 v0 v1 v2 x y i'=. y
pts=. i { CONPTS
min=. <./ l0,l1,l2
max=. >./ l0,l1,l2
lvl=. min + 1 + i. max-min
ndx=. (#. lvl >:/ v0,v1,v2) { 0 0 1 2 2 1 0 3
res=. i.0 5
for_lv. lvl do.
  select. lv_index { ndx
  case. 0 do.
    res=. res, contri1 lv,v0,v1,v2,pts
  case. 1 do.
    res=. res, contri1 lv,v0,v2,v1,0 1 4 5 2 3 { pts
  case. 2 do.
    res=. res, contri1 lv,v1,v2,v0,2 3 4 5 0 1 { pts
  case. 3 do.
  end.
end.
res + 0 ,. (0 _1 + $res) $ x,y
)
contri1=: 3 : 0
'lvl v0 v1 v2 x0 y0 x1 y1 x2 y2'=. y
p=. (lvl - v0) % v2 - v0
q=. (lvl - v1) % v2 - v1
lvl, ((p * x2,y2) + (-.p) * x0,y0), (q * x2,y2) + (-.q) * x1,y1
)
plot_density=: 3 : 0

'x y z'=. y { Data

signal^:(2 ~: #$z) 'need data matrix for density plot'

j=. {(int01 #x);int01 #y
pos=. fitgrafxy ,/ ,"2 tiles >j

j=. (#BANDCOLOR) ncile ,z
clr=. j { BANDCOLOR
drawpoly iDATA;EDGECOLOR;(EDGESIZE*MESH);clr;pos
)
plot_dot=: 3 : 0
dat=. getgrafmat y
clr=. getitemcolor #dat
for_d. dat do.
  drawdot iDATA;(d_index{clr);PENSIZE;_2[\d
end.
)

plot_point=: plot_dot
plot_errorbar=: 3 : 0

'x y'=. getgrafxy y
'r c'=. $y

if. r ~: 3 do.
  signal 'errorbar data should have 3 rows'
end.

'hi mid lo'=. y
j=. ,./x,."1 [ hi ,: lo
k=. _3 0 3 0 +"1 ,.~ _2[\,j
errorbar=. j,k

xm=. ,x,.mid

clr=. getitemcolor 1
drawline iDATA;clr;PENSIZE;xm
drawline iDATA;clr;PENSIZE;errorbar
)
plot_hilo=: 3 : 0
'x y'=. getgrafxy y
'r c'=. $y
ifclose=. 3=r
'hi lo close'=: 3$y
clr=. getitemcolor 2
hilo=. ,./x,."1 [ 2{.y
drawline iDATA;({.clr);PENSIZE;hilo
if. ifclose do.
  close=. ,x,.{:y
  drawline iDATA;({.clr);PENSIZE;close
end.
)
plot_hist=: 3 : 0
'x y'=. 2 {. y { Data
dat=. citemize y
'r c'=. $dat
if. r ~: 1 do.
  signal 'Histogram should have only one data set.'
end.
pos=. makehist dat
drawrect iDATA;EDGECOLOR;EDGESIZE;(ITEMCOLOR {~ 0 >, dat);pos
)
makehist=: 3 : 0
dat=. ,y
'r c'=. $y
w=. Gw % c
x=. Gw * }: int01 c
x=. Gx + x
if. YDiv=0 do.
  h=. (dat-YMin) % YMax-YMin
elseif. YDiv=1 do.
  h=. (dat-YMax) % YMax-YMin
elseif. do.
  h=. dat % (YMax%1-YDiv) >. |YMin%YDiv
end.
h=. Gh * h
y=. Gy + Gh * YDiv
x,.y,.(x+w),.y+h
)
plot_line=: 3 : 0
dat=. getgrafmat y
clr=. getitemcolor #dat
if. *./ PENSTYLE=0 do.
  drawline iDATA;clr;PENSIZE;dat
else.
  sty=. PENSTYLE $~ #dat
  drawpline iDATA;sty;clr;PENSIZE;dat
end.
)
MarkerNames=: ;: 'diamond square circle triangle plus times'
KeyMarkerNames=: MarkerNames,<'line'
plot_marker=: 3 : 0
dat=. getgrafmat y
clr=. getitemcolor #dat
if. #MARKERS do.
  nms=. MARKERS { MarkerNames
else.
  nms=. MarkerNames
end.
mrk=. ((#nms) | i. #dat) { nms
for_d. dat do.
  drawmarker iDATA;(MarkerScale*MARKERSIZE);(d_index{clr);(d_index{mrk),<_2 [\ d
end.
)
plot_pie=: 3 : 0
YCaption=: ; YCAPTION
'x y'=. 2 {. y { Data
if. 1 = #y do.
  plot_pied y
else.
  plot_piem y
end.
)
plot_pied=: 3 : 0
dat=. 360 | 90 - 0, 360 * (%{:) +/\ , y
if. PIEPERCENT *. 0=#XLABEL do.
  XLabel=: getpiepercent ,y
else.
  XLabel=: XLABEL
end.
if. #YCaption do.
  'w h'=. CaptionFont pgetextent1 YCaption
  cx=. Lx + -: Lw - w
  cy=. Ly + Lh - MSubTitle
  setgxywh Gxywh shrinkrect 0 0 0,h+3*MSubTitle
end.
if. #XLabel do.
  'pxy tic'=. makefitpie dat
  drawtext iXLABEL;iLEFT;LabelFont;BLACK;XLabel;pxy
  drawline iXTICS;BLACK;GUIDESIZE;tic
end.
rad=. -: Gw <. Gh
org=. (Gx,Gy) + -: Gw,Gh
dat=. (org, rad),"1 [ 2 |.\ dat
clr=. getitemcolor #dat
drawpie iDATA;EDGECOLOR;EDGESIZE;clr;dat
if. #YCaption do.
  xlab=. (0<#XLabel) * MSubTitle + {: LabelFont pgetextent1 'X'
  xcap=. {: CaptionFont pgetextent1 'X'
  cy=. cy <. ({:org) + rad + MPie + xlab + xcap
  drawtext iYCAPTION;iLEFT;CaptionFont;BLACK;YCaption;cx,cy
end.
)
makefitpie=: 3 : 0
dat=. rfd y
'lw lh'=. LabelFont pgetextent XLabel
lh=. {.lh
bgn=. }: dat
end=. }. dat
mid=. -: bgn + end - 2p1 * end > bgn
rhw=. |."1 +. r. mid
'rw rh'=. 1 _1 * |: rhw
pos=. 2 {."1 fitpie lw;lh;rw;rh;mid
tic=. drawpietics rw,.rh
pos;tic
)
fitpie=: 3 : 0

'lw lh rw rh mid'=. y
while. 1 do.
  rad=. <. -: <./ _2 {. Gxywh
  pad=. rad + MPie

  msk=. MPie <: (-:lh) + | pad * -. cos mid
  int=. lw * (-:-.msk) + msk * (mid<0) +. mid>1p1
  px=. (Gx+-:Gw) + (rw * pad) - int
  py=. (Gy+-:Gh) + (rh * pad) - -:lh
  pos=. px,.py,.lw,.lh
  if. 1 = fitpielabels pos do. continue. end.
  'rc pos'=. movepielabels pos
  if. rc do.
    if. 1 = fitpielabels pos do. continue. end.
  end.
  break.
end.
(0,lh,0 0) +"1 pos
)
fitpielabels=: 3 : 0
'x y w h'=. |: y

bx=. 0 >. Lx - <./x
ex=. 0 >. (>./x+w) - Lx + Lw
by=. 0 >. Ly - <./y
ey=. 0 >. (>./y+h) - Ly + Lh

be=. bx,by,ex,ey
if. 0 = +/be do. 0 return. end.

mw=. 0 >. Gw - MinPie
if. mw < bx + ex do.
  'bx ex'=. (bx,ex) * mw % bx + ex
end.

mh=. 0 >. Gh - MinPie
if. mh < by + ey do.
  'by ey'=. (by,ey) * mh % by + ey
end.

be=. bx,by,ex,ey
if. 0 = +/be do. 0 return. end.

setgxywh Gxywh shrinkrect >. be

1
)
getpiepercent=: 3 : 0
dat=. 100 * y % +/y
val=. 1 rounddist dat
txt=. (":each val) ,each '%'
)
plot_piem=: 3 : 0

dat=. y
if. #YCAPTION do.
  ycap=. boxarg YCAPTION
  if. 1=#ycap do.
    ycap=. (#dat) $ ycap
  else.
    if. (#dat) ~: #ycap do.
      info 'Y Captions do not match number of pie charts' return.
    end.
  end.
  'cw ch'=. CaptionFont pgetextent ycap
  cw=. >./cw
  ch=. ({.ch) + +: MSubTitle
else.
  cw=. ch=. 0
  ycap=. (#dat) # <''
end.
len=. #dat
rws=. 1 + i. len
cls=. >. len % rws
msk=. cw <: Lw % cls
rws=. msk#rws
cls=. msk#cls
ndx=. (i.>./) (Lw%cls) <. Lh%rws
rws=. ndx{rws
cls=. ndx{cls
wid=. <. Lw % cls
hit=. <. Lh % rws
OLxywh=: Lxywh
xy=. ((rws*cls)$Lx + wid*i.cls),.cls#Ly + hit*i.-rws
lxywh=. len {. xy,"1 wid,hit
lxywh=. lxywh shrinkrect"1 MPie
if. PIEPERCENT < 0 = #XLABEL do.
  gxywh=. lxywh shrinkrect"1 [ 0 0 0,ch
else.
  setlxywh {. lxywh
  getpieframes''
  setgxywh Lxywh shrinkrect 0 0 0,ch
  r=. i. 0 4
  for_d. dat do.
    deg=. 360 | 90 - 0, 360 * (%{:) +/\ d
    if. PIEPERCENT do.
      XLabel=: getpiepercent d
    else.
      XLabel=: XLABEL
    end.
    makefitpie deg
    r=. r,Gxywh
  end.
  xy=. >./2 {."1 r
  off=. xy - 2 {. Lxywh
  wh=. (<./(2 {."1 r) + 2 }."1 r) - xy
  gxywh=. (off +"1 [ 2 {."1 lxywh) ,"1 wh
end.
for_d. dat do.
  YCaption=: d_index pick ycap
  setlxywh d_index { lxywh
  getpieframes''
  setgxywh d_index { gxywh
  plot_pied d
end.
Lxywh=: OLxywh
)
plot_poly=: 3 : 0
dat=. getgrafmat y
clr=. getitemcolor #dat
drawpoly iDATA;EDGECOLOR;EDGESIZE;clr;dat
)
plot_radar=: 3 : 0

dat=. 1 pick y { Data
dat=. YRANGE fit01"1 dat

rad=. -: Gw <. Gh
org=. (Gx,Gy) + -: Gw,Gh

RTIC=: 2{. RTIC,(#RTIC)}.3 1

if. {.GRIDS do.
  grd=. org ,"1 0 [ rad * }. int01 {.RTIC
  drawcircle iXGRID;GRIDCOLOR;EDGESIZE;'';grd
end.

if. {.AXES do.
  pts=. fitgrafxy makeradaraxes dat
  drawline iXAXIS;FORECOLOR;EDGESIZE;pts
end.

pts=. fitgrafxy makeradar dat
clr=. getitemcolor #pts
sty=. PENSTYLE $~ #pts
drawpline iDATA;sty;clr;PENSIZE;pts
)
makeradar=: 3 : 0
dat=. |:y
xy=. cleanz (cos ,. sin) +: o. int01 #dat
r=. ,"2 [ 0 1 |: xy */"1 dat, {. dat
0.5 * 1 + r
)
makeradaraxes=: 3 : 0
if. {.TICS do.
  'maj min'=. RTIC
  len=. maj * >: min
  pos=. }.int01 len
  tic=. TICMINOR,(0={.GRIDS)*TICMAJOR
  mark=. len$(min,1)#500 %~ tic
  pts=. 0 0 0 1, 0 ,. pos ,. mark,. pos
else.
  pts=. ,:0 0 0 1
end.
f=. ((cos,sin),:-@sin,cos)"0
s=. f o. +: }:int01 {:$y
pts=. ,/ ,"2 [ 1 |: s mp 0 1 |: _2 [\"1 pts
pts=. 0.5 * 1 + pts
)
plot_stick=: 3 : 0
dat=. getgrafmat y
dat=. _2 (4&$)\ ,dat
ydiv=. fitgrafy YDiv
dat=. ydiv 3 }"1 dat
drawline iDATA;(getitemcolor #dat);PENSIZE;dat
)
plot_symbol=: 3 : 0
dat=. getgrafmat y
clr=. getitemcolor #dat
font=. SymbolFont
if. Poutput e. iANDROID,iQT,iCANVAS,iCAIRO,iISI do.
  sym=. utf8 each ucp text2utf8 SYMBOLS
else.
  sym=. <&> text2ascii8 SYMBOLS
end.

off=. 0,.-:{:SymbolFont pgetextent sym
dat=. dat + ({:$dat) $"1 (#dat)$off
chr=. (#dat)$sym
for_d. dat do.
  drawtext iDATA;iCENTER;font;(d_index{clr);(d_index{chr),<_2 [\ d
end.
)
coclass 'jzplot'
plot3d_dot=: 3 : 0

'x y z'=. y { Data

dat=. 1 |: (x ,: y),"2 1 citemize z
dat=. }:"1 project dat
dat=. ,"2 dat

rws=. #dat
cls=. {:$dat
clr=. getitemcolor #dat

rws=. 1

while. #dat do.
  drawcircle iDATA;({.clr);4;({.clr);1;_2[\{.dat
  dat=. }.dat
  clr=. 1|.clr
end.
)

plot3d_point=: plot3d_dot
plot3d_line=: 3 : 0

'x y z'=. y { Data

dat=. 1 |: (x ,: y),"2 1 citemize z
shape=. $dat
dat=. shape $ , project ,/dat
dat=. _2[\ ,}:"1 dat
dat=. fitgrafxy3d dat
dat=. (-+:1{shape) [\ ,dat

clr=. getitemcolor #dat

if. *./ PENSTYLE=0 do.
  drawline iDATA;clr;PENSIZE;dat
else.
  sty=. PENSTYLE $~ #dat
  drawpline iDATA;sty;clr;PENSIZE;dat
end.
)
plot3d_poly=: 3 : 0

'x y z'=. y { Data

dat=. x ,"0 1 y ,"0 z
vert=. 1{$dat
dat=. ($dat) $ , project ,/dat
dat=. dat #~ facing dat

dist=. {:"1 dat
dat=. }:"1 dat

near=. ~.(<.-:#,dist){.sort ,dist

ndx=. /: +/"1 dist e. near
dat=. ndx{dat
dist=. ndx{dist

ndx=. \:+/"1 dist
dist=. ndx{dist
dat=. ndx{dat

dat=. ,/ dat
dat=. fitgrafxy3d dat
dat=. (-vert),\ dat


clr=. getitemcolor blockcount dat
drawpoly iDATA;EDGECOLOR;EDGESIZE;clr;dat
)
plot3d_stick=: 3 : 0

'x y z'=. conform3d y { Data
dat=. x ,"0 1 y ,"0 z
minz=. ZInt <. <./ , {:"1 dat
bas=. minz 2}"1 dat
dat=. bas ,"1 dat
dat=. ,/ _3 [\"1 dat
dat=. project ,/dat
dat=. fitgrafxy3d }:"1 dat
dat=. _2 ,\ dat
drawline iDATA;(getitemcolor'');PENSIZE;dat
)
plot3d_surface=: 3 : 0
'x y z'=. conform3d y { Data
pos=. x ,"0 1 y ,"0 z
pos=. ($pos) $ ,project ,/ pos
zpos=. ,tilesum z
dpos=. ,tilesum {:"1 pos
ndx=. \:dpos
pos=. ,/,/ tiles }:"1 pos
pos=. fitgrafxy3d pos
pos=. _8[\,pos
pos=. ndx{pos

j=. ndx { (#BANDCOLOR) ncile zpos
clr=. j { BANDCOLOR

drawpoly iDATA;EDGECOLOR;(MESH*EDGESIZE);clr;pos
)
plot3d_wire=: 3 : 0
'x y z'=. conform3d y { Data
pos=. x ,"0 1 y ,"0 z
if. PStyle has 'clear' do.
  pos=. pos,0 2 |: pos
  shape=. $pos
  pos=. shape $ ,project ,/ pos
  pos=. _2[\ ,}:"1 pos
  pos=. fitgrafxy3d pos
  pos=. (-+:1{shape) [\ ,pos
  drawline iDATA;(getitemcolor 1);EDGESIZE;pos

else.
  pos=. ($pos) $ ,project ,/ pos
  zpos=. ,tilesum z
  dpos=. ,tilesum {:"1 pos
  ndx=. \:dpos
  pos=. ,/,/ tiles }:"1 pos
  pos=. fitgrafxy3d pos
  pos=. _8[\,pos
  pos=. ndx{pos

  j=. ndx { (#BANDCOLOR) ncile zpos
  clr=. j { BANDCOLOR
  drawpoly iDATA;clr;EDGESIZE;BACKCOLOR;pos

end.

)

NB. =========================================================
NB. web/gethttp
NB. J interface for Wget/cURL to retrieve files using http, ftp, https

require 'task strings socket'

coclass 'wgethttp'

3 : 0 ''

  IFWGET=: 0
  HTTPCMD=: ''
  select. <UNAME
  case. 'Android' do.
    if. 1=ftype f=. '/system/xbin/wget' do.  NB. android busybox
      IFWGET=: 1
      HTTPCMD=: f
    elseif. 1=ftype f=. '/system/bin/wget' do.  NB. alternate location
      IFWGET=: 1
      HTTPCMD=: f
    end.
  case. 'Win' do.
    if. fexist f=. jpath '~addons/web/gethttp/bin/curl.exe' do.
      HTTPCMD=: f
    elseif. 1=ftype f=. (2!:5'SystemRoot'),'\System32\curl.exe' do. NB. inside C:\Windows\System32 for windows 10 or newer
      HTTPCMD=: f
    elseif. fexist f=. jpath '~tools/ftp/wget.exe' do.
      IFWGET=: 1
      HTTPCMD=: f
    end.
  case. 'Darwin' do.
    HTTPCMD=: 'curl'
  case. do.   NB. Linux
    try.
      2!:0'which curl 2>/dev/null'
      HTTPCMD=: 'curl'
    catch.
      try.
        2!:0'which wget 2>/dev/null'
        IFWGET=: 1 [ HTTPCMD=: 'wget'
      catch. end.
    end.
  end.
  if. IFUNIX do.   NB. fix task.ijs definition of spawn on mac/unix
    quot=: '"','"',~rplc&(,(];'\',])"0'\$"')
    spawn=: [: 2!:0 '(' , ' || true)' ,~ ]
  else.
    quot=: ]
    spawn=: spawn_jtask_
  end.
  ''
)

NB. ---------------------------------------------------------
NB. Utility verbs
safe=. (33}.127{.a.)-.'=&%+'
encode=:  [: toupper ('%',(I.'6'=,3!:3'f') {&, 3!:3)
nvp=: >@{.,'=',urlencode@":@>@{:
args=: [: }.@; ('&'<@,nvp)"1

NB. ---------------------------------------------------------
NB. Public verbs

NB.*urlencode v Encode string as valid url
urlencode=:  [: ; encode^:(safe -.@e.~ ])&.>

NB.*urlquery v Creates urlencoded string of namevalue pairs.
NB. returns: urlencoded string of namevalue pairs for appending to url
NB. y is: rank 1 or 2 array of boxed namevalue pairs
NB.        rank 1 assumes name;value;name;value...
NB.        rank 2 assumes 0{"1 is names & 1{"1 is values
NB. eg: urlquery ('action';'query'),('name';'S&P Inc'),:('format';'json')
urlquery=: 3 : 0
  if. 0 e. $y do. '' return. end.
  'arg should be boxed' assert 32 = 3!:0 y
  'arg should be rank 1 or 2' assert 1 2 e.~ rnk=. #$y
  if. rnk = 1 do.
    'arg should be name-value pairs' assert 0 = 2|#y
    y=. _2]\ y
  else. 'arg should only have 2 cols' assert 2 = {:$y end.
  args y
)

NB.*gethttp v Retrieve URI using Wget/cURL tools
NB. [option] gethttp uri
NB. result: depends on options, Default is URI contents
NB. y is: URI to retrieve
NB. x is: Optional retrieval options. One of:
NB.       'stdout' (Default)
NB.       'help'
NB.       'file' or ('file';jpath '~temp/myfile.htm')
NB.       Anything else is assumed to be a valid Wget/cURL option string
NB. eg: 'file' gethttp 'http://www.jsoftware.com'
NB. eg: ('-o - --stderr ',jpath '~temp/gethttp.log') gethttp 'http://www.jsoftware.com'
gethttp=: 3 : 0
  'stdout' gethttp y
:
  url=. y
  'jopts fnme'=. 2{. boxopen x
  if. IFIOS +. HTTPCMD-:'' do.
    if. 'http://'-.@-:7{.url do.
      'only http:// supported' return.
    end.
    output=. 0
    fil=. ''
    select. jopts
    case. 'stdout' do.  NB. content retrieved from stdout, log suppressed
    case. 'help' do.    NB. help
      'no help available' return.
    case. 'file' do.
      output=. 1
      if. #fnme do.     NB. save as filename
        fil=. fnme
      end.
    end.
    server=. ({.~ i.&'/') (7}.url)
    aurl=. }.(}.~ i.&'/') (7}.url)
    try.
    'header data'=. jwget server;aurl
    catch.
    'getHTTP error' return.
    end.
    if. 0=output do.
      data return.
    else.
      if. #fil do.
        if. '/' e. fil=. jpathsep fil do. mkdir_j_ ({.~ i:&'/') fil end.
        data fwrite fil
      else.
        fil=. }:^:('/'={:) aurl
        fil=. (}.~ i:&'/') fil
        fil=. }.^:('/'={.) fil
        if. 0=#fil do. fil=. 'httpresult' end.
        data fwrite fil
      end.
      '' return.
    end.
  end.
  select. jopts
  case. 'stdout' do.  NB. content retrieved from stdout, log suppressed
    opts=. IFWGET{:: '-o - -s -S';'-O - -q'
  case. 'file' do.
    if. #fnme do.     NB. save as filename
      opts=. IFWGET{:: '--stderr - -o ';'-O '
      opts=. opts,fnme
    else.             NB. copy file to current dir
      opts=. IFWGET{:: '-O --stderr -';' '
    end.
  case. 'help' do.    NB. help
    opts=. '--help'
  case. do.           NB. custom option string?
    if. 2 131072 262144 e.~ 3!:0 x do. opts=. utf8 x
    else. 'Invalid left argument for getHTTP' return. end.
  end.
  NB. curl: follow redirects (wget does by default); wget: decompress transport-level gzip (curl does by default)
  opts=. ' ',opts,IFWGET{:: ' -L ';' --compression=auto '
  spawn HTTPCMD , opts , quot url
)

NB. =========================================================
NB.! does not work when server response with HTTP 1.1

NB.! following code should be made as robust and general as possible
NB.  it should then be refactored into JHS (where it came from)

NB. send socket data
NB. return count of bytes sent
NB. errors: timeout, socket error, no data sent (disconnect)
ssend=: 4 : 0
'socket timeout'=. y
z=. sdselect_jsocket_ '';socket;'';timeout
'server send not ready' assert socket=>2{z
'c r'=. x sdsend_jsocket_ socket,0
('server send error: ',sderror_jsocket_ c) assert 0=c
'server send no data' assert 0<r
r
)

NB. data putdata socket,timeout
putdata=: 4 : 'while. #x do. x=. (x ssend y)}.x end.'

ssrecv=: 3 : 0
'socket timeout bufsize'=. y
z=. sdselect_jsocket_ socket;'';'';timeout
'server recv timeout' assert  socket e.>1{z  NB.0;'';'';'' is a timeout
'server recv not ready' assert socket=>1{z
'c r'=. sdrecv_jsocket_ socket,bufsize,0
('server recv error: ',sderror_jsocket_ c) assert 0=c
'server recv no data'       assert 0<#r
r
)

NB. get/post data - headers end with CRLF,CRLF
NB. post has Content-Length: bytes after the header
NB. listen and read until a complete request is ready
getdata=: 3 : 0
'socket timeout bufsize'=. y
h=. d=. ''
cl=. 0
while. (0=#h)+.cl>#d do. NB. read until we have header and all data
 r=. ssrecv socket,timeout,bufsize
 d=. d,r
 if. 0=#h do. NB. get headers
  i=. (d E.~ CRLF,CRLF)i.1 NB. headers CRLF delimited with CRLF at end
  if. i<#d do. NB. have headers
   i=. 4+i
   h=. i{.d NB. headers
   d=. i}.d
   i=. ('Content-Length:'E. h)i.1
   if. i<#h do.
    t=. (15+i)}.h
    t=. (t i.CR){.t
    cl=. _1".t
    assert _1~:cl
   else.
    cl=._1
   end.
  end.
 end.
end.
h;d
)

RECVBUFSIZE=: 50000
SENDTIMEOUT=: 20*60*1000 NB. 20 minutes for a send
TIMEOUT=: 20*60*1000 NB. 20 minutes for a response

jwget=: 3 : 0
'server url'=. y
i=. server i.':'
server=. i{.server
port=. {. 0".(>:i)}.server
port=. (0=port){port,80
if. #server-.'0123456789.' do.
  ip=. >2{sdgethostbyname_jsocket_ server
else.
  ip=. server
end.
try.
 t=. gettemplate rplc '<SERVER>';server;'<URL>';url
 sk=. >0{sdcheck_jsocket_ sdsocket_jsocket_''
NB. sdcheck_jsocket_ sdioctl_jsocket_ sk,FIONBIO_jsocket_,1
 sdcheck_jsocket_ sdconnect_jsocket_ sk;AF_INET_jsocket_;ip;port
 t putdata sk,SENDTIMEOUT
 hd=. getdata sk,RECVBUFSIZE,TIMEOUT
catch.
 sdclose_jsocket_ sk
 (13!:12'') assert 0
end.
sdclose_jsocket_ sk
hd
)

gettemplate=: toCRLF 0 : 0
GET /<URL> HTTP/1.0
User-Agent: Mozilla/5.0 (Linux; Android 4.4; Nexus 5 Build/_BuildID_) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/30.0.0.0 Mobile Safari/537.36
Accept: */*
Host: <SERVER>
Connection: Keep-Alive

)

NB. =========================================================
NB. Export z locale

gethttp_z_ =: gethttp_wgethttp_
urlencode_z_=: urlencode_wgethttp_
urlquery_z_=: urlquery_wgethttp_
NB. mreq.ijs
NB. utility functions

coclass 'z'

NB. addspc replaces each space with x spaces, default 5
addspc=: 3 : 0
5 addspc y
:
y rplc ' ';x#' '
)

NB. approx does what =!.t should do
NB. x is tol (default 0.01)
NB. y is vector of two or more values
approx=: 3 : 0
0.01 approx y
:
min=. <./y
tol=. x*min
*./((min+tol)>y),(min-tol)<y
)

NB. bfmt - Reformat boxed output by eliminating box characters
NB. x is  a 3 element vector, with the first two the ": x argument (default 0 0) 
NB. and the last is 0 or 1 (default), indicating 2 extra spaces between columns
bfmt=: 3 : 0
0 0 1 bfmt y
:
BOXCHARS=. 9!:6''
arg=. x,0
fmt=. 2{. arg
spc=. 2{ arg
d=. _2{BOXCHARS
t=. fmt ": y
t=. }."1 }:"1 t  NB. strip first and last column
t=. vfm (-. *./"1 t e. BOXCHARS)#t
if. spc do. t=. d spdelim t end.
(d,' ') charsub t
)

NB. blist - Converts set of boxed strings to comma-separated list
blist=: 3 : 0
(LF,',') charsub vfm >y
)

NB. boxfont - boxes font name
boxfont=: 3 : 0
font=. ' ',y
b=. (font=' ') > ~:/\font='"'
a: -.~ b <;._1 font
)

NB. bxv - monadic makes a vector of boxed atoms
NB. dyadic places x items in each box (less than full boxes are dropped)
NB. specialized (faster) code used if x is an atom
bxv=: 3 : 0
boxopen ;/y
:
if. 1=#x do.
  b=. , , each boxcols |:((<.(#y)%x),x)$y
else.
  k=.#x
  i=.0
  b=.''
  while. i < k do.
    if. (i{x)>#y do. break. end.
    b=.b,<(i{x){.y
    y=.(i{x)}. y
    i=.i+1
  end.
end.
b
)

citemize=: ,:^:(2: > #@$)

collapsenull=: 1: , 2: +./\ ]

cut=: 2 : ';@(<@x;.y)'

NB. dbrow removes blank row from character matrix
dbrow=:  ] -. [: {. ' '"_ , ]

NB. debqtcm - remove quoted commas and leading/trailing blanks
debqtcm=: 3 : 0
q=. qt y
c=. ',' = y
qc=. q *. c
r=. (-.qc)#y
deb r -. '"'
)

NB. deball - remove all blanks
deball=: 3 : 0
y rplc ' ';''
)

NB. deLF - remove all line feeds and replace with x (default '')
deLF=: 3 : 0
'' deLF y
:
y rplc LF;x
)

divis=: 4 : 0
NB. returns true if x is divisible by y
(x%y)=(<.x%y)
)

NB. dqlabel - for y boxed array of strings,
NB. return string with each boxed element
NB. double quoted and separated by spaces
dqlabel=: 3 : 0
q=. dquot each y
(LF,' ') charsub vfm >q
)

NB. dquot - place double quotes around string y
dquot=: 3 : 0
'"',y,'"'
)

NB. dquots - place double quotes and space around string y
dquots=: 3 : 0
' "',y,'" '
)

NB. eqvec test if items of vector are equal
eqvec=: >./=<./	

NB. even - Tests if y is even number
even=: 3 : 0
(y%2) = <.y%2
)

NB. diagonal reflect
drefl=: hr@vr

NB. font2css
NB. convert mb font result to css
font2css=: 3 : 0
'font sz wt'=. 3{.(boxfont y),<''
r=. 'font: ',sz,'pt ',font,'; '
if. 0<#wt do.
  r=. r,'font-weight: ',wt,';'
end.
r
)



NB. ft - Formats numerical value to x significant figures
NB. SIGFIG (if defined) or 6 are defaults
ft=: 3 : 0
if. 0 = 4!:0<'SIGFIG__' do.
  s=. SIGFIG__
else.
  s=. 6
end.
s ft y
:
if. isnum ,y do.
  '_-' charsub ":!.x y
else.
  y
end.
)

ftrue=: ] i. 1: NB. inx of first 1

getwin=: 3 : 0
> <;._2 each <;._2 wd'qpx'
)

getwinname=: 3 : 0
{."1 getwin''
)

getwinpid=: 3 : 0
1{"1 getwin''
)

GetCWD=: (,&'/')@jpath@(1!:43)
SetCWD=: 1!:44

hasties=: 3 : 0
-.(#~. y)=#y
)

NB. horizontal reflect
hr=: |.@]

NB. identity matrix
id=: =@i.

indxbyy=: /:@:{ { [	

NB. inx index of x in y
inx=: e.~&, # i.@#@]

NB. inxlastr index of last occurrence of y in x from rear
inxlastr=: |.@[ i. ]

NB. inxb return indices for true values
NB. inxb=: <:@(+/\) i. i.@(+/)
inxb=: I.

NB. isalpha - Tests for alpha only
isalpha=: 3 : 0
lc=.'abcdefghijklmnopqrstuvwxyz'
uc=.'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
1>+/-.y e. lc,uc
)

NB. isalphanum - Tests for alphanumeric
isalphanum=: 3 : 0
lc=.'abcdefghijklmnopqrstuvwxyz'
uc=.'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
num=.'0123456789'
1>+/ -. y e. lc,uc,num,'_'
)

NB. isnonnegint - Tests if y is integer and >=0
isnonnegint=: 3 : 0
(nonneg y) *. isinteger y
)

NB. isnum - Tests if y is a finite number
isnum=: 3 : 0
(-. __ e. y) *. isnumeric y
)

ispos=: 3 : 0
-. 1 e. 0>:y
)

isposint=: 3 : 0
(ispos y) *. isinteger y
)

ixfmax=: i.>./
ixfmin=: i. <./

ixmax=: 3 : 0
I. y= >./y
)

ixmin=: 3 : 0
I. y= <./y
)


NB. listsort--case insensitive sort of boxed literals followed
NB.   by conversion to LF separated vector
listsort=: vfm@(>@sortupci)

log10=: 10&^.

NB. makescale - make a scale from x to y
makescale=: 4 : 0
i=. x
s=. ''
max=. x+ y
while. max>i do.
  if. i divis 10 do.
    s=. s, ft i
    i=. i+ #":i
    continue.
  end.
  if. i divis 5 do.
    s=. s,'+'
    i=. i+1
  else.
    s=. s,'.'
    i=. i+1
  end.
end.
y{.s
)


NB. mbAsk - Yes/No/Cancel msgbox
NB. y is dialog title;error message
mbAsk=: 3 : 0
'title message'=. y
wd 'mb query mb_yes mb_no mb_cancel "',title,'" "',message,'"'
)

NB. mbError - Error msgbox
NB. y is dialog title;error message
mbError=: 3 : 0
'title message'=. y
wd 'mb warn "',title,'" "',message,'"'
)

NB. mbInfo - Info msgbox
mbInfo=: 3 : 0
'title message'=. y
wd 'mb info "',title,'" "',message,'"'
)

NB. mbQuery - Yes/No msgbox
NB. y is dialog title;error message
mbQuery=: 3 : 0
'title message'=. y
wd 'mb query mb_yes mb_no "',title,'" "',message,'"'
)

mbfont=: 3 : 0
NB. calls font chooser with y as starting point
res=.wd 'mb font ',y
NB. fix for Segoe UI
if. UNAME -: 'Win' do.
  bxf=. boxfont res
  if. (<'"Segoe UI Semibold"')={.bxf do.
    bxf=. bxf -. <'bold'
    res=. unchop bxf
  end.
end.
res
)

merge=: /:@/:@[ { ] NB. see phrasebook

nonneg=: 3 : 0
NB. Tests if y>=0
-.1 e. 0>y
)

nubcount=: ({.;#)/.~   NB. nub;number of obs.

openvec=: ((,&:>)/)@((<'')&,)   NB. boxed vector to single vector, now works with 1 element

parentdir=: 3 : 0
,>{. pathname }: y
)


parseV=: 3 : 0
dat=. chop (LF,' ',TAB,' ') charsub y
datsimp=. -. (<__)=(__&".) each dat
sdat=. (__&".) each datsimp#dat
jdat=. (-.datsimp)#dat
jdat=. jeval each jdat
openvec datsimp merge jdat,sdat 
)

jeval=: 3 : 0
try. r=. ". y catch. r=.__ end.
if. 0=#r do. r=.__ end.
r
)

pow10=: 10&^

qchop=: 3 : 0
NB. preserves double quoted strings while chopping
NB. double quotes removed from output
q=. qt y
s=. ' '=y
qs=. q*.s
y=. EAV (inxb qs)}y
deb each unquot each ((EAV,' ')&charsub) each chop y
)

NB. qt mark quoted substrings in string
qt=: 2:+./\0:,2:|+/\@(=&'"')

rmnull=: 3 : 0
NB. removes null boxes
((<'')~:y)#y
)

rmsqt=: 3 : 0
y rplc '''';''
)

rnddn=: [ * [: <. %~
rndup=: [ * [: >. %~

samprep=: ?@#

scriptn=: 0!:0

slt=: >/~@i.

sortdown=: \:~
sortdownrow=: (\:"1)~
sortup=: /:~
sortuprow=: (/:"1)~

sortupci=: 3 : 0
NB. case-insensitive sort of boxed literals
(/: tolower each y){y
)

sortdownci=: 3 : 0
NB. case-insensitive sort of boxed literals
(\: tolower each y){y
)

spdelim=: 3 : 0
NB. flank delimiter x in string y with spaces
:
y rplc x;' ',x,' '
)

td=: 4 : 0
NB. x, y are two 6!:0 times
tc=. 3600 60 1
(+/tc*_3{.y)-+/tc*_3{.x
)

toalphanum=: 3 : 0
NB. deletes non-alphanum characters from string
lc=.'abcdefghijklmnopqrstuvwxyz'
uc=.'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
num=.'0123456789'
an=. y e. lc,uc,num
an#y
)

toN=: 3 : 0
NB. Converts items of y to numbers
__
if. 0=#y do.
  return.
end.
__".y
)

NB. udir change \ to / in a directory
udir=: ('\/'&charsub)

ufread=: 3 : 0
dat=. fread y
if. (dat -: _1) +. 0=#dat do. return. end.
NB. u16 marker:
if. (255 254 { a.) -: 2 {. dat do.
  dat=. utf8 6 u: 2 }. dat
NB. u8 marker:
elseif. (239 187 191 { a.) -: 3 {. dat do.
  dat=. 3 }. dat
NB. ansi codepage:
elseif. 0 -: 7 u: :: 0: dat do.
  val=. a. i. dat
  msk=. 127 < val
  uni=. 192 128 +"1 [ 0 64 #: msk # val
  val=. val #~ 1 j. msk
  ndx=. I. 127 < val
  dat=. a. {~ uni (ndx +/ 0 1) } val
end.
)

NB. utob remove underscores from string
utob=: ('_ '&charsub)

unbox0=: 3 : 0
NB. converts boxed numeric vectors to single concatenated vector
,>y
)

unbox=: 3 : 0
NB. converts boxed numeric vectors to single concatenated vector
". unchop ": each y
)

unchop=: 3 : 0
NB. reformats boxed output as if unboxed
NB. x is the separator character for the boxed elements, default space
NB. null x concatenates the opened boxes
' ' unchop y
:
if. 1 < #y do. t=. vfm > y else. t=. ,>y end.
if. 0=#x do.
  t=. LF delstring vfm >y
else.
  t=. (LF,x) charsub t
end.
)


unquot=: 3 : 0
NB. remove double quotes
'" ' charsub y
)

NB. =========================================================
NB.*av v convert between characters and indices
NB. e.g.   av 'abcde'
av=: 3 : '({&a.)`(a.&i.) @. (2&=@(3!:0)) y'

NB. =========================================================
NB.*vfm v vector from matrix
NB. vector from matrix, lines separated by LF
vfm=: 3 : '}:(,|."1 [ 1,.-. *./\"1 |."1 y='' '')#,y,.LF'

NB. =========================================================
NB.*boxcols v box columns of matrix
NB. y is a matrix
NB. x indicates partitions
NB.   - a single integer is size of each partition
NB.   - a boolean is beginning of each partition
NB. examples:
NB.    boxcols i.3 4
NB.
NB.    3 boxcols i.3 7
NB. +--------+--------+--+
NB. | 0  1  2| 3  4  5| 6|
NB. | 7  8  9|10 11 12|13|
NB. |14 15 16|17 18 19|20|
NB. +--------+--------+--+
NB.
NB.    1 0 1 0 0 0 1 boxcols i.3 7
NB. +-----+-----------+--+
NB. | 0  1| 2  3  4  5| 6|
NB. | 7  8| 9 10 11 12|13|
NB. |14 15|16 17 18 19|20|
NB. +-----+-----------+--+
boxcols=: 3 : 0
('';1) <;.1 y
:
if. 0 e. x e. 0 1 do.
  ('';({:$y) $ x {. 1) <;.1 y
else.
  ('';x) <;.1 y
end.
)

NB. vertical reflect
vr=: |."_1@]

NB. =========================================================
NB.*chop v chop array into boxed list
NB. chop character vector or matrix into boxed list.
NB. x is optional delimiter, default LF if in text, else blank.
NB. If a matrix, the delimiter must be vertically aligned,
NB. otherwise use chop"1 to chop each row of the matrix.
NB. e.g.  chop ": 10 20 30
NB.       chop ": i. 5 4
chop=: 3 : 0
y chop~ (' ',LF) {~ LF e. ,y
:
if. 2>#$y
do.
  (<'') -.~ (y e.x) <;._2 y=. y,{.x
else.
  |: &.> y -. {: y=. (*./y e.x) <;._2 |: y=. y,"1 [ 2${.x
end.
)

PATHSEP_j_=:'/'
pathname=: ({. ; }.)~ (0: i.~ +./\.@(=&'/'))
NB. about.ijs
NB. about dialog

NB.require'gl2'
NB.require'graphics/bmp'
NB.require'task'

coclass 'about'
(;:'jgl2 base z') copath 'about'

NB. pc about escclose closeok dialog nosize;pn "About Mstat";
ABOUT=: 0 : 0
pc about dialog nosize ptop;pn "About Mstat";
bin vh;
minwh 112 112;cc pic image;
minwh 280 112;cc l1 static sunken center;
bin z;
bin h s2;
cc web button;cn "&Visit web site";
cc ok button default;cn "&Close";
pcenter;
)

author=: 0 : 0
N. Drinkwater
McArdle Laboratory for Cancer Research
School of Medicine and Public Health
University of Wisconsin-Madison
)

open=: 3 : 0
vinfo=. 'Mstat ',VERSION__,' (',VERSIONDATE__,')',LF,author
wd ABOUT
wd 'set l1 text ',vinfo
wd 'set pic image *',Resdir__,'mca.bmp'
wd 'pshow;'
)

close=: 3 : 0
wd 'psel about;pclose'
)

about_web_button=: 3 : 0
select. UNAME
  case. 'Win' do.
    fork'explorer ',MSTATSITE__
  case. 'Darwin' do.
    2!:1 BROWSER__,' ',MSTATSITE__,' &'
  case. 'Linux' do.
    2!:1 BROWSER__,' ',MSTATSITE__,' &'
end.
close''
)


about_ok_button=: about_cancel=: close

about_octrl_fkey=: about_ok_button
about_ictrl_fkey=: about_web_button
NB. advpref.ijs
NB. browser and pdfviewer prefs

coclass'advpref'

(;:'base z') copath 'advpref'

ADVVN=: 'BROWSER';'PDFVIEWER'

ADVPREF=: 0 : 0
pc advpref dialog nosize owner escclose closeok;
pn "Viewer preferences";
bin vh;
minwh 100 20;cc labelb static right;cn "Browser";
minwh 280 24;cc br edit;
cc brchange button;cn "Change";
bin z;
bin vh;
minwh 100 20;cc labelp static right;cn "PDF viewer";
minwh 280 24;cc pdf edit;
cc pdfchange button;cn "Change";
bin z;
bin vh s2;
cc ok button;cn "&OK";
cc cancel button;cn "&Cancel";
pcenter;ptop;
)

open=: 3 : 0
wd ADVPREF
wd 'set br text *',SETBROWSER__
wd 'set pdf text *',SETPDFVIEWER__
wd 'pshow;'
)

close=: 3 : 0
wd 'pclose'
)

advpref_cancel_button=: advpref_cancel=: close

advpref_ok_button=: 3 : 0
SETBROWSER__=: deb br
SETPDFVIEWER__=: deb pdf
close''
setadv''
writepref''
)

advpref_brchange_button=: 3 : 0
fn=. wd 'mb open1 "Default browser" ""'
wd 'set br text *',fn
)

advpref_pdfchange_button=: 3 : 0
fn=. wd 'mb open1 "Default PDF viewer" ""'
wd 'set pdf text *',fn
)

advpref_octrl_fkey=: advpref_ok_button
NB. bin.ijs
NB. form for histogram

coclass 'bin'

('base';'z') copath <'bin'

shplot=: 1
shfreq=: 1

BIN=: 0 : 0
pc bin dialog nosize escclose closeok ptop;pn "Bin data";
bin vh;
minwh 124 24;cc Varlabel static right;cn "Variable(s) to bin";
minwh 300 24;cc Var edit readonly;
bin z;
bin g;
grid cell 0 0;
groupbox "Interval type";
cc Rb0 radiobutton;cn "&Equal size";
cc Rb1 radiobutton group;cn "&Specify upper bounds";
groupboxend;
grid cell 0 1;
groupbox "Equal size";
bin vh;
minwh 120 24;cc label static right;cn "Upper bound bin 1";
cc Equ edit; set Equ wh 60 _1;
bin z;
bin vh;
minwh 120 24;cc label static right;cn "Interval width";
cc Eqs edit; set Eqs wh 60 _1;
bin z;
bin vh;
minwh 120 24;cc label static right;cn "Number of bins";
cc Eqn edit;set Eqn wh 60 _1;
bin z;
groupboxend;
grid cell 1 0 4;
bin v;
cc Ck1 checkbox;cn "Show &frequencies";
cc Ck0 checkbox;cn "Show &graph";
bin z;
grid cell 1 1 36;
cc bwp checkbox;cn "Black and white";
bin z;
bin v;
cc label static;cn "Interval upper bounds";
minwh 424 24;cc Sped edit;
bin hs2;
cc Ok button;cn "&OK";
cc Cancel button;cn "&Cancel";
pcenter;
)

open=: 3 : 0
if. 0=#MSvar__ do. return. end.
wd BIN
wd 'set Var text *',unchop MSvar__
wd 'set Rb0 value 1'
wd 'set Sped enable 0;set Equ enable 1;set Eqs enable  1;set Eqn enable 1'
wd 'set Ck0 value ',":shplot
wd 'set Ck1 value ',":shfreq
wd 'set bwp value ',":PlotBW__
wd 'set Var stylesheet background-color:#eeeeee'
wd 'pshow;'
wd 'set Equ focus'
if. HELP__ do.
   update_hlp_ <'bin'
   wd 'psel bin; pactive; set Equ focus'
end.
)

close=: 3 : 0
wd 'psel bin;pclose'
)

bin_Cancel_button=: bin_close=: bin_cancel=: close

bin_Rb0_button=: 3 : 0
wd 'set Sped enable  0;set Equ enable  1;set Eqs enable  1;set Eqn enable  1'
wd 'set Equ focus'
)

bin_Rb1_button=: 3 : 0
wd 'set Sped enable  ;set Equ enable 0;set Eqs enable 0;set Eqn enable 0'
wd 'set Sped focus'
)

bin_Ok_button=: 3 : 0
shfreq=: ". Ck1
shplot=: ". Ck0
PlotBW__=: ".bwp
data=. ". each (,&'_v_') each MSvar__
if. (". Rb0) do.
  u=. __ ". Equ
  s=. __ ". Eqs
  n=. __ ". Eqn
  if. __ e. (u,s,n) do.
    mbError 'Invalid parameter';'Non-numeric value in data field.'
    wd 'set Equ focus'
    return.
  end.
  if. -. s>0 do.
    mbError'Invalid parameter';'Interval width must be greater than 0.'
    wd 'set Eqs focus; set Eqs select'
    return.
  end.
  if. -. n>1 do.
    mbError'Invalid parameter';'Number of bins must be greater than 1.'
    wd 'set Eqn focus; set Eqn select'
    return.
  end.
  b=. u+s*i.n
else.
  b=. ~. sortup __ ". Sped
  if. __ e. b do.
    mbError 'Invalid parameter';'Non-numeric value in data field.'
    wd 'set Sped focus'
    return.
  end.
  n=. #b
end.
dist=. (b&bindata) each data
fdist=. binfreq each dist
close''
tout 'Distribution(s) for ',(unchop MSvar__),LF
ns=. #MSvar__
ncol=. 1+shfreq
dout=. (1,1+ns*ncol)$(<''),ncol#MSvar__
dout=. dout,(<'x'),,>ns#<ncol{.'N';'Freq.'
datout=. bxv each dist
if. shfreq do. datout=. datout,.bxv each fdist end.
bounds=. ft each bxv b
if. ({:b) < >./ ,> >./ each data do.
  bounds=. (}: bounds), < '>', >{:}:bounds
end.
dout=. dout,bounds,. ft each |:((ns*ncol),n)$,>datout
tout bfmt dout
tout LF,LF
view''
if. shplot do.
  LOGX__=: LOGY__=: 0
  if. shfreq do.
    'hist' makeplot bounds;<fdist
  else.
    'hist' makeplot bounds;<dist
  end.
end.
)

bin_Equ_button=: 3 : 0
wd 'set Eqs focus'
)

bin_Eqs_button=: 3 : 0
s=. __ ". Eqs
if. -. s>0 do.
  mbError'Invalid parameter';'Interval width must be greater than 0.'
  wd 'set Eqs focus; set Eqs select'
  return.
end.
data=. ,>". each (,&'_v_') each chop Var
max=. >./data
u=. __ ". Equ
if. __ e. (u,s) do. return. end.
n=. 2+>.(max-u)%s
wd 'set Eqn text ',":n
wd 'set Eqn focus; set Eqn select'  NB. Jwdp fix
)

bin_Eqn_button=: bin_Eqs_button

bin_dlghlp=: 3 : 0
if. HELP__ do.
   HELP__=: 0
   wd 'psel hlp; pclose; psel mstat; set DHlp 0'
else.
   HELP__=: 1
   open_hlp_ <'bin'
   wd 'psel mstat; set DHlp 1;'
end.
wd 'psel bin;pactive;set Equ focus'
)

bin_octrl_fkey=: bin_Ok_button
bin_lctrl_fkey=: bin_dlghlp
NB. binci.ijs
NB. form for binomial confidence intervals

coclass 'binci'

(;:'base z') copath 'binci'

ACI=: 95

NB. base form 

BINCI=: 0 : 0
pc binci dialog nosize escclose closeok;pn "Binomial confidence intervals";
bin vh;
cc labelci static right;cn "Conf. interval size (%)";
cc Ci edit;set Ci wh 80 _1;
bin z;
cc labeled static center;cn "Enter x (num. successes) N (num. trials)";
cc Ed editm ;
bin hs2;
cc Ok button;cn "&OK";
cc Cancel button;cn "&Cancel";
pcenter;
)

open=: 3 : 0
wd BINCI
wd 'set Ci text ',":ACI
wd 'set Ed focus '
wd 'pshow;'
if. HELP__ do.
   update_hlp_ <'binci'
   wd 'psel binci; pactive; set  Ed focus'
end.
)

close=: 3 : 0
wd 'psel binci;pclose'
)

binci_Cancel_button=: binci_cancel=: binci_close=: close

binci_Ok_button=: 3 : 0
if. 0=#Ed do. 
  close''
  return.
end.
ACI=: __".Ci
if. (ACI<50)+.ACI>:100 do.
   mbError 'Value error';'Size should be greater than 50% and less than 100%.'
   wd 'set Ci focus '
   return.
end.
alpha=. ACI%100
d=. chop (LF,' , ',TAB,' ') charsub Ed
d=. openvec ,toN each d
if. +/-. isnonnegint d do.
   mbError 'Value error';'Only non-negative integers are allowed.'
   wd 'set Ed focus '
   return.
end.
n=.0.5*#d
if. -. isinteger n do.
   mbError 'Value error';'Pairs of x,N data are required.'
   wd 'set Ed focus '
   return.
end.
d=.(n,2)$d
if. +/1 < %/"1 d do.
   mbError 'Value error';'For x,N pairs, x must be less than or equal to N.'
   wd 'set Ed focus '
   return.
end.
for_sn. d do.
   's n'=.,>sn
   'pl pu'=. alpha cibin s,n
   tout 'Binomial ',(":100*alpha),'% confidence interval',LF
   tout 'x = ',(":s),', N = ',(":n),LF
   tout 'p = ',(ft s%n),' (',(ft pl),', ',(ft pu),')',LF,LF
end.
close''
view''
)

binci_dlghlp=: 3 : 0
if. HELP__ do.
   HELP__=: 0
   wd 'psel hlp; pclose; psel mstat; set DHlp 0; psel binci; pactive; set Ed focus'
else.
   HELP__=: 1
   open_hlp_ <'binci'
   wd 'psel mstat; set DHlp 1; psel binci; pactive; set Ed focus'
end.
)

binci_octrl_fkey=: binci_Ok_button
binci_lctrl_fkey=: binci_dlghlp
NB. byind.ijs
NB. parse variable by an indicator variable

coclass 'byind'

('base';'z') copath <'byind'

BYIND=: 0 : 0
pc byind dialog nosize escclose closeok;pn "Classify by indicator";
bin g;
grid cell 0 0 2;
bin h;
cc vt0 radiobutton;cn "Variables";
cc vt1 radiobutton group;cn "Indicators";
bin z;
grid cell 0 1;
cc Var combolist;
grid cell 1 0 2;
cc labeli static right;cn "By Indicator ";
grid cell 1 1;
cc Indic combolist;
grid cell 2 0;
bin v;
cc label static center;cn "Available types";
cc Types editm readonly;set Types stylesheet background-color:#eeeeee;
set Types wh 200 100;set Types wrap 0;
bin hs2;
cc each button;cn "&Each";
bin z;
bin s;
bin z;
grid cell 2 1 36;
bin v;
cc label static center;cn "Groups";
cc Grps editm;set Grps wh 200 160;
bin s;
bin z;
grid cell 4 0 1 2;
bin h;
cc Class button;cn "&Classify";
bin s;
cc ok button;cn "&Done";
cc cancel button;cn "Cancel";
bin z;
pcenter;
)

open=: 3 : 0
IndN=: nl_i_''
VarN=: nl_v_''
wd BYIND
if. 0<#VarN do.
  wd 'set vt0 value 1'
  byind_vt0_button''
else.
  wd 'set vt1 value 1'
  wd 'set vt0 enable  0'
  byind_vt1_button''
end.
wd 'set Indic items ',vfm >IndN
if. 0<#IndN do.
  wd 'set Indic select  0'
  ishow >{.IndN
end.
wd 'pshow;'
if. HELP__ do.
   update_hlp_ <'byind'
   wd 'psel byind; pactive; set Var focus '
end.
)

close=: 3 : 0
wd 'psel byind;pclose'
)

byind_cancel_button=: byind_close=: byind_cancel=: close

byind_ok_button=: 3 : 0
res=. byind_Class_button''
if. res do.
  close''
  wd 'psel mstat'
  wd 'set sbar setlabel nvar *',(":numvar''),' variables defined'
end.
)

byind_vt0_button=: 3 : 0
wd 'set Var items ',vfm >VarN
wd 'set Var select  0'
)

byind_vt1_button=: 3 : 0
wd 'set Var items ',vfm >IndN
wd 'set Var select  0'
)

byind_Class_button=: 3 : 0
res=.0
if. 0=#Grps do.
  res=. 1
  return.
end.
vtype=. ". vt0
if. vtype do. inv=. Var,'_v_' else. inv=. Var,'_i_' end.
if. -.(#".inv) = #".Indic,'_i_' do.
  mbError 'Unequal sizes';'The variable and the indicator must have the same number of values.'
  res
  return.
end.
typs=. ~.". Indic,'_i_'
NB.itypes =. chop each chop Grps
itypes=. qchop (LF,' ') charsub Grps
if. -. *./ itypes e. typs do.
  mbError'Group error';'Groups do not match available types.'
  res
  return.
end.
if. vtype do.
  data=. bxv ".Var,'_v_'
else.
  data=. ".Var,'_i_'
end.
indvar=. ". Indic,'_i_'
vn=. Var,'_',Indic,'_'
for_i. itypes do.
  ti=.>i
  di=.(i inx indvar){data
  vni=. vn,toalphanum ti
NB.  vni=.vn,(LF,'_') charsub vfm >ti
  if. vtype do.
    ". vni,'_v_=: ',":,>di
  else.
    ". vni,'_i_=: di'
end.
end.
wd 'set Grps text *'
Ddirty__=: 1
mbInfo 'Classify succeeded';'Classify yielded ',(":#itypes),' new variables.'
res=. 1
)

byind_each_button=: 3 : 0
typs=. ~.". Indic,'_i_'
if. +./ ,>(' '&e.) each typs do. 
  wd 'set Grps text ', dquot vfm >dquot each typs
else.
  wd 'set Grps text *', unchop typs
end.
)

byind_Indic_select=: 3 : 0
NB.wd 'set Types *', unchop ~.". Indic,'_i_'
ishow Indic
wd 'set Grps text '
)

ishow=: 3 : 0
typs=. ~. ". y,'_i_'
if. +./ ,>(' '&e.) each typs do. 
  wd 'set Types text *', dquot vfm >dquot each typs
else.
  wd 'set Types text *', unchop typs
end.
)


byind_Indic_button=: byind_Indic_select

byind_dlghlp=: 3 : 0
if. HELP__ do.
   HELP__=: 0
   wd 'psel hlp; pclose; psel mstat; set DHlp 0; psel byind; pactive; set Var focus'
else.
   HELP__=: 1
   open_hlp_ <'byind'
   wd 'psel mstat; set DHlp 1; psel byind; pactive; set Var focus'
end.
)

byind_octrl_fkey=: byind_ok_button
byind_lctrl_fkey=: byind_dlghlp
byind_ectrl_fkey=: byind_each_button

NB. chsqdist.ijs
NB. form for chi-square distribution

coclass 'chsqdist'

(;:'base z') copath 'chsqdist'

NB. base form 

DF=: 1

CHSQDIST=: 0 : 0
pc chsqdist dialog nosize escclose closeok;pn "Chi-square distribution";
bin v;
cc s1 static center;cn "Upper tail of chi-square distribution";
bin g;
grid cell 0 0 2;
cc labeldf static right;cn "d.f.";
grid cell 0 1;
cc df edit; set df wh 60 _1;
grid cell 1 0 34;
cc labelch static right;cn "Chi-square";
grid cell 1 1;
cc x editm;set x wh 200 100;
bin z;
bin hs2;
cc ok button;cn "&OK";
cc cancel button;cn "&Cancel";
pcenter;
)

open=: 3 : 0
wd CHSQDIST
wd 'set df text ',":DF
wd 'set x focus'
wd 'pshow;'
if. HELP__ do.
   update_hlp_ <'chsqdist'
   wd 'psel chsqdist; pactive; set x focus'
end.
)

close=: 3 : 0
wd 'psel chsqdist;pclose'
)

chsqdist_ok_button=: 3 : 0
DF=: _1 ". df
if. (0>:DF) +. -. isinteger DF  do.
  mbError 'Chi-square';'df must be a positive integer.'
  wd 'setfocus df; setselect df 0 ',(":#df)
  return.
end.
x2=., _1 ". (LF,' ') charsub x
nx2=.#x2
if.  (0=nx2) +. +/0>x2 do.
  mbError 'Chi-square';'X2 must be a non-negative number.'
  wd 'setfocus x; setselect x 0 ',(":#x)
  return.
end.
close''
p=. DF chisq x2
tout 'Chi-square distribution (',(":DF),' df)',LF
dat=. (<'X2'),(boxcols (1,nx2)$x2),(<' p (upper tail)'),ft each boxcols (1,nx2)$p
tout (bfmt |: (2,1+nx2)$dat),LF,LF
view''
)

chsqdist_cancel_button=: close

chsqdist_dlghlp=: 3 : 0
if. HELP__ do.
   HELP__=: 0
   wd 'psel hlp; pclose; psel mstat; set DHlp 0; psel chsqdist; pactive; set x focus'
else.
   HELP__=: 1
   open_hlp_ <'chsqdist'
   wd 'psel mstat; set DHlp 1; psel chsqdist; pactive; set x focus'
end.
)

chsqdist_octrl_fkey=: chsqdist_ok_button
chsqdist_lctrl_fkey=: chsqdist_dlghlp
NB. comp.ijs
NB. form for combining p-values

coclass 'comp'

(;:'base z') copath 'comp'

COMP=: 0 : 0
pc comp dialog nosize escclose closeok;pn "Combine P-values";
cc label static center;cn "Enter P-values to be combined";
cc ed editm;set ed wh 200 100;
bin hs;
cc ok button;cn "&OK";
cc cancel button;cn "&Cancel";
bin z;
pcenter;
)

open=: 3 : 0
wd COMP
wd 'set ed font  ',Vfont__
wd 'set ed focus '
wd 'pshow;'
if. HELP__ do.
   update_hlp_ <'comp'
   wd 'psel comp; pactive; set ed focus'
end.
)

close=: 3 : 0
wd 'psel comp; pclose'
)

comp_cancel_button=: comp_close=: comp_cancel=: close

comp_ok_button=: 3 : 0
Vd=. , _1 ". (LF,' ') charsub ed
if. (#Vd)=0 do.
  mbError 'No data';'You need to enter values in the data entry field.'
  wd 'set ed focus'
  return.
end.
if. (+/0>Vd)++/1<Vd do.
  mbError 'Check data';'Data must be numeric values between 0 and 1.'
  wd 'set ed focus'
  return.
end.
close''
fisherp Vd
)

comp_dlghlp=: 3 : 0
if. HELP__ do.
   HELP__=: 0
   wd 'psel hlp; pclose; psel mstat; set DHlp 0; psel comp; pactive; set ed focus'
else.
   HELP__=: 1
   open_hlp_ <'comp'
   wd 'psel mstat; set DHlp 1; psel comp; pactive; set ed focus'
end.
)

comp_octrl_fkey=: comp_ok_button
comp_lctrl_fkey=: comp_dlghlp
NB.  dedit.ijs
NB.  edit variable definition

coclass 'dedit'

(;:'base z') copath 'dedit'

VarType=: 'v'

DEDIT=: 0 : 0
pc dedit dialog escclose closeok;pn "Edit variable definition";
bin vhv;
groupbox "Variable type";
cc rb0 radiobutton;cn "&Variables";
cc rb1 radiobutton group;cn "&Tables";
cc rb2 radiobutton group;cn "&Indicators";
groupboxend;
bin zsz;
cc typelabel static;cn "Variables";
cc name listbox;set name wh _1 100;
bin h;
minwh 90 24;cc labelv static right;cn "Values for ";
cc vn edit;
bin z;
cc vncb checkbox;cn "&Edit variable name";
cc data editm;set data minwh 300 200;set data wrap 0;
bin hs;
cc ok button;cn "&Done";
cc change button;cn "C&hange";
cc cancel button;cn "&Cancel";
pcenter;
)

open=: 3 : 0
wd DEDIT
vt=. ":VarType inx 'vti'
wd 'set rb',vt,' 1'
if. 1=vt do. wd'set data wrap 0' else. wd'set data wrap 1' end.
wd 'set name items ',vfm >".'nl_',VarType,'_'''''
wd 'set name select -1'
wd 'set data font ',Vfont__
wd 'set name focus'
wd 'set vn enable  0'
wd 'set vncb value 0'
wd 'set vncb enable  0'
wd 'set data enable  0'
wd 'pshow;'
if. HELP__ do.
   update_hlp_ <'dedit'
   wd 'psel dedit; pactive; set name focus'
end.
)

close=: 3 : 0
wd 'pclose'
)

dedit_cancel=: dedit_close=: dedit_cancel_button=: close

dedit_name_button=: 3 : 0
if. 0=#name do. return. end.
wd 'set vn text ',name
wd 'set vncb value 0'
wd 'set vncb enable  1'
wd 'set vn enable  0'
wd 'set data enable  1'
vnm=.name,'_',VarType,'_'
OldName=: name
if. (".rb1) do.
  wd 'set data text ',bfmt ".vnm
elseif. (".rb2) do.
  if. +./ ,> (' '&e.) each ". vnm do.
    wd 'set data text ', dqlabel ".vnm
  else.
    wd 'set data text ', unchop ".vnm
  end.
elseif. do.
  wd 'set data text ', '_-' charsub ": ". vnm
end.
)


dedit_ok_button=: 3 : 0
if. 0<$vn do.
   if. -. dedit_change_button'' do. return. end.
end.
close''
)

dedit_change_button=: 3 : 0
if. 0=#vn do.
  mbError 'Choose variable';'You must choose a variable to edit.'
  wd 'set vn focus '
  res=. 0
  return.
end.
if. (".vncb) *. (-.(<vn)=(<OldName)) do.
  if. e=.VarType invalidVn vn do.
    vnError e
    wd 'set vn focus; set vn select'
    res=. 0
    return.  
  end.
end.
if. (".rb1) do.
  Vd=. parsetab data
  if. 0=#Vd do.
    wd 'set data focus'
    res=. 0
    return.
  end.
  ". vn,'_',VarType,'_=: Vd'
elseif. (".rb2) do.
  Vd=. qchop (LF,' ',TAB,' ') charsub data
  ". vn,'_',VarType,'_=: Vd'
elseif. do.
  Vd=. __ ". (LF,' ',TAB,' ',',',' ') charsub data
  if. __ e. Vd do. Vd=. parseV data end.
  if. invaldat Vd do.
    wd 'set data focus '
    res=. 0
    return.
  end.
  ". vn,'_',VarType,'_=: Vd'
  Ddirty=: 1
end.
if. -.(<vn)=(<OldName) do.
  erase OldName,'_',VarType,'_'
end.
wd 'set vn text; set data text '
if. vncb do.
  wd 'set vncb value 0'
  wd 'set vncb enable  0'
  wd 'set vn enable  0'
  wd 'set data enable  0'
  wd 'set name items ',vfm >".'nl_',VarType,'_'''''
end.  
wd 'setfocus name'
res=.1
)

dedit_enter=:dedit_name_button


dedit_name_select=: 3 : 0
if. 0=#name do. return. end.
wd 'set vn text ',name
wd 'set vncb value 0'
wd 'set vncb enable  1'
wd 'set vn enable  0'
wd 'set data enable  1'
vnm=.name,'_',VarType,'_'
OldName=: name
if. (".rb1) do.
  wd 'set data text ',bfmt ".vnm
elseif. (".rb2) do.
  if. +./ ,> (' '&e.) each ". vnm do.
    wd 'set data text ', dquot dqlabel ".vnm
  else.
    wd 'set data text ', unchop ".vnm
  end.
elseif. do.
  wd 'set data text ', '_-' charsub ": ". vnm
end.
)

dedit_rb0_button=: 3 : 0
VarType=:'v'
wd 'set name items ',vfm >nl_v_''
wd 'set name select -1'
wd 'set data text *'
wd 'set vn text *'
wd 'set vn enable 0'
wd 'set vncb value 0'
wd 'set vncb enable  0; set data enable  0'
wd 'set data wrap 1'
)

dedit_rb1_button=: 3 : 0
VarType=:'t'
wd 'set name items *',vfm >nl_t_''
wd 'set name select -1'
wd 'set data text *'
wd 'set vn text *'
wd 'set vn enable 0'
wd 'set vncb value 0'
wd 'set vncb enable  0; set data enable  0'
wd 'set data wrap 0'
)

dedit_rb2_button=: 3 : 0
VarType=:'i'
wd 'set name items ',vfm >nl_i_''
wd 'set name select -1'
wd 'set data text *'
wd 'set vn text *'
wd 'set vn enable 0'
wd 'set vncb value 0'
wd 'set vncb enable  0; set data enable  0'
wd 'set data wrap 1'
)


dedit_vncb_button=: 3 : 0
if. ".vncb do.
  wd 'set vn enable  1'
else.
  wd 'set vn enable  0'
  wd 'set vn text *',OldName
end.
)

dedit_dlghlp=: 3 : 0
if. HELP__ do.
   HELP__=: 0
   wd 'psel hlp; pclose; psel mstat; set DHlp 0; psel dedit; pactive; set name focus'
else.
   HELP__=: 1
   open_hlp_ <'dedit'
   wd 'psel mstat; set DHlp 1; psel dedit; pactive; set name focus'
end.
)

dedit_lctrl_fkey=: dedit_dlghlp
dedit_hctrl_fkey=: dedit_change_button
dedit_octrl_fkey=: dedit_ok_button
NB. discrete.ijs
NB. form for discrete distribution

coclass 'discrete'

(;:'base z') copath 'discrete'

F=: 1
CDF=: 0
CCDF=: 0
DOPLOT=: 1

DISCRETE=: 0 : 0
bin g;
grid cell 0 0;
groupbox "Values to show";
cc rbr0 radiobutton;cn "&0 to n";
cc rbr1 radiobutton group;cn "&Specific values";
bin h;
minwh 40 24;cc rlab static right;cn "n";
cc e3 edit;
bin z;
groupboxend;
grid cell 0 1;
groupbox "Show distribution";
cc cbs0 checkbox;cn "&Freq.";
cc cbs1 checkbox;cn "C&DF";
cc cbs2 checkbox;cn "&1 - CDF";
groupboxend;
bin z;
bin vh;
cc plot checkbox;cn "&Plot";
cc bwp checkbox;cn "Black and white";
bin s;
cc ok button;cn "&OK";
cc cancel button;cn "&Cancel";
pcenter;
)

POISS=: 0 : 0
pc discrete dialog nosize escclose closeok;
bin v;
groupbox "Poisson parameter";
bin h;
minwh 30 24;cc e2l static right;cn "m";
cc e2 edit;set e2 wh 100 _1;
bin sz;
groupboxend;
)

BINOM=: 0 : 0
pc discrete dialog nosize escclose closeok;
bin v;
groupbox "Binomial parameters";
bin h;
minwh 30 24;cc e2l static right;cn "N";
cc e2 edit;set e2 wh 60 _1;
minwh 30 24;cc e1l static right;cn "p";
cc e1 edit;set e1 wh 60 _1;
bin sz;
groupboxend;
)

NEGBIN=: 0 : 0
pc discrete dialog nosize escclose closeok;
bin v;
groupbox "Negative binomial parameters";
bin h;
minwh 30 24;;cc e2l static right;cn "m";
cc e2 edit;set e2 wh 60 _1;
minwh 30 24;cc e1l static right;cn "k";
cc e1 edit;set e1 wh 60 _1;
bin sz;
groupboxend;
)

HYPERG=: 0 : 0
pc discrete dialog nosize escclose closeok;
bin v;
groupbox "Hypergeometric parameters";
bin h;
minwh 30 24;cc e2l static right;cn "N";
cc e2 edit;set e2 wh 60 _1;
minwh 30 24;cc e1l static right;cn "p";
cc e1 edit;set e1 wh 60 _1;
minwh 30 24;cc e0l static right;cn "k";
cc e0 edit;set e0 wh 60 _1;
bin sz;
groupboxend;
)

open=: 3 : 0
select. Tlast__
  case. cPOISS do.
    wd POISS,DISCRETE
    wd 'pn "Poisson distribution"'
    dist=: 'poiss'
  case. cBINOM do.
    wd BINOM,DISCRETE
    wd 'pn "Binomial distribution"'
    dist=: 'binom'
  case. cNEGBIN do.
    wd NEGBIN,DISCRETE
    wd 'pn "Negative binomial distribution"'
    dist=: 'negbin'
  case. cHYPERG do.
    wd HYPERG,DISCRETE
    wd 'pn "Hypergeometric distribution"'
    dist=: 'hyperg'
end.
if. F do. wd 'set cbs0 value 1' end.
if. CDF do. wd 'set cbs1 value 1' end.
if. CCDF do. wd 'set cbs2 value 1' end.
if. DOPLOT do. wd 'set plot value 1' end.
if. PlotBW__ do. wd 'set bwp value 1' end.
wd 'set rbr0 value 1' 
wd 'pshow;'
wd 'set e2 focus'
if. HELP__ do.
   update_hlp_ dist;'discrete'
   wd 'psel discrete; pactive; set e2 focus'
end.
)

close=: 3 : 0
wd 'psel discrete;pclose'
)

discrete_cancel_button=: discrete_cancel=: close

discrete_rbr0_button=: 3 : 0
if. (".rbr0) do. 
  wd 'set rlab text *n '
else. 
  wd 'set rlab text *Values '
end.
)

discrete_rbr1_button=: discrete_rbr0_button

discrete_ok_button=: 3 : 0
DOPLOT=: ". plot
PlotBW__=: ". bwp
xv=. ,toN e3
if. 0=#e3 do.
  mbError 'Values to show';'No values in data field.'
  wd 'set e3 focus'
  return.
end.
if. __ e. xv do.
  mbError 'Values to show';'Non-numeric value in data field.'
  wd 'set e3 focus'
  return.
end.
if. -. (isinteger xv) *. (nonneg xv) do.
  mbError 'Values to show';'Values must be non-negative integers.'
  wd 'set e3 focus'
  return.
end.
rorv=. ".rbr0
if. rorv do. xv=. i. 1+1{. xv end.
if. (". cbs0) do. F=: 1 else. F=: 0 end.
if. (". cbs1) do. CDF=: 1 else. CDF=: 0 end.
if. (". cbs2) do. CCDF=: 1 else. CCDF=: 0 end.
ndist=. F+CDF+CCDF
if. 0=ndist do.
  mbError 'Distributions to show';'You must choose at least one of the distribution types.'
  return.
end.
max=. >./ xv
xlab=. ": each bxv xv{i. 1+max
select. Tlast__
  case. cPOISS do.
    if. InvalPoiss e2 do. return. end.
    m=. ". e2
    fdist=. m poissonm i. 1+max
    tout 'Poisson distribution',LF,'m = ',(":m),LF
    if. DOPLOT do. 
      MSvar__=: ": each bxv m
     'hist' makeplot xlab;xv{"1 fdist
    end.
  case. cBINOM do.
    if. InvalBinom e2;e1;max do. return. end.
    N=. ". e2
    p=. ". e1
    fdist=. (N;p) binomm i. 1+max
    tout 'Binomial distribution',LF,'N = ',(":N),'  p = ',(":p),LF
    if. DOPLOT do.
      MSvar__=: ": each bxv p
      'hist' makeplot xlab;xv{"1 fdist
    end.
  case. cNEGBIN do.
    if. InvalNB e2;e1 do. return. end.
    m=. ". e2
    k=. ". e1
    fdist=. (m;k) nbdm i. 1+max
    tout 'Negative binomial distribution',LF,'m = ',(":m),'  k = ',(":k),LF
    if. DOPLOT do.
      mk=. m;k
      mvi=. {.(>./,># each mk) inx ,># each mk
      MSvar__=: ": each bxv > mvi{mk
      'hist' makeplot xlab;xv{"1 fdist
    end.
  case. cHYPERG do.
    if. InvalHG e2;e1;e0;max do. return. end.
    'N p k'=. par=. (". e2);(". e1); (". e0)
    fdist=. par hypergm i. 1+max
    tout 'Hypergeometric distribution',LF,'N = ',(":N),'  p = ',(ft p),'  k = ',(":k),LF
    if. DOPLOT do.
      mvi=. {.(>./,># each par) inx ,># each par
      MSvar__=: ": each bxv >mvi{par
      'hist' makeplot xlab;xv{"1 fdist
    end.
end.
dist=. ''
if. F do.
  dist=. dist,(<' f(x)'),< ft xv{|:fdist
end.
if. CDF do.
  dist=. dist,(<' F(x)'),< ft xv{|: +/\"1 fdist
end.
if. CCDF do.
  dist=. dist,(<' 1-F(x)'),<ft xv{|:  0>.1-+/\"1 fdist
end.
dist=. |:(ndist,2)$dist
nv=.#xv
close''
dat=. (2 1 $(<'x'),< ft |: citemize xv),. dist
tout (bfmt dat),LF,LF
view''
)

InvalPoiss=: 3 : 0
if. 0=#y do.
  mbError 'Parameters';'You must enter a value for the Poisson parameter.'
  wd 'set e2 focus'
  1 return.
end.
m=. __ ". y
if. __ e. m do.
  mbError 'Parameters';'Non-numeric value in parameter field.'
  wd 'set e2 focus; set e2 select'
  1 return.
end.  
if. -. nonneg m do.
  mbError 'Parameters';'Parameter must be non-negative.'
  wd 'set e2 focus; set e2 select'
  1 return.
end.
0
)

InvalBinom=: 3 : 0
'N p'=. (__&".) each 2{.y
max=. >{:y
if. (0=#N)+.(0=#p) do.
  mbError 'Parameters';'You must enter the number of trials and success probability.'
  wd 'set e2 focus'
  1 return.
end.
if. (1<#N) do.
  mbError'Multiple values';'Multiple values only allowed in p.'
  wd 'set e2 focus'
  1 return.
end.
if. -. (isinteger N) *. nonneg N do.
  mbError 'Parameters';'N must be a non-negative integer.'
  wd 'set e2 focus; set e2 select'
  1 return.
end.
if. (0>:p) +. (1<:p) do.
  mbError 'Parameters';'The value of p must be between 0 and 1.'
  wd 'set e1 focus; set e1 select'
  1 return.
end.
if. -. (0,N) inrange max do.
  mbError 'Parameters';'Values out of parameter range.'
  wd 'set e3 focus; set e3 select'
  1 return.
end.
0
)

InvalNB=: 3 : 0
'm k'=. (__&".) each y
if. (0=#m)+.(0=#k) do.
  mbError 'Parameters';'You must enter values for m and k.'
  wd 'set e2 focus'
  1 return.
end.
if. (1<#m)*.(1<#k) do.
  mbError'Multiple values';'Multiple values allowed in only one of m,k'
  wd 'set e2 focus'
  1 return.
end.
if. __ e. m,k do.
  mbError 'Parameters';'Non-numeric value in parameter field.'
  wd 'set e2 focus'
  1 return.
end.  
if. -.  (0<m)*.(0<k) do.
  mbError 'Parameters';'Parameters must be greater than 0.'
  wd 'set e2 focus'
  1 return.
end.
0
)

InvalHG=: 3 : 0
'N p k'=. (__&".) each 3{.y
max=. >{:y
if. (0=#N)+.(0=#p)+.(0=#k) do.
  mbError 'Parameters';'You must enter values for N, p, and k.'
  wd 'set e2 focus'
  1 return.
end.
if. (0>p) +. (1<p) do.
  mbError 'Parameters';'The value of p must be between 0 and 1.'
  wd 'set e1 focus;set e1 select'
  1 return.
end.
if. (k>N) +. (k<0) do.
  mbError'Parameters';'The value of k must be less than or equal to N'
  wd 'set e0 focus;set e0 select'
  1 return.
end.
if. -. (0,k) inrange max do.
  mbError 'Parameters';'Values out of parameter range.'
  wd 'set e3 focus;set e3 select'
  1 return.
end.
0
)

discrete_dlghlp=: 3 : 0
if. HELP__ do.
   HELP__=: 0
   wd 'psel hlp; pclose; psel mstat; set DHlp 0; psel discrete; pactive; set e2 focus'
else.
   HELP__=: 1
   open_hlp_ dist;'discrete'
   wd 'psel mstat; set DHlp 1; psel discrete; pactive; set e2 focus'
end.
)

discrete_lctrl_fkey=: discrete_dlghlp
discrete_octrl_fkey=: discrete_ok_button
NB. dnew.ijs
NB. Define new variable

coclass 'dnew'

(;:'base z') copath 'dnew'

VarType=: 'v'

DNEW=: 0 : 0
pc dnew dialog escclose closeok;pn "Define new variable";
bin vh;
cc labelv static right;cn "Variable name";
cc vname edit;
bin z;
groupbox "Variable type";
cc type0 radiobutton;cn "&Variable";
cc type1 radiobutton group;cn "&Table";
cc type2 radiobutton group;cn "&Indicator";
groupboxend;
cc label static;cn "Values";
cc data editm;set data wrap 0;
bin hs;
cc ok button;cn "&Done";
cc add button;cn "&Add";
cc cancel button;cn "&Cancel";
bin zz;
pcenter;
)

open=: 3 : 0
wd DNEW
wd 'set vname focus'
wd 'set data font  ',Vfont__
vt=. VarType inx 'vti'
wd 'set type',(":vt),' value 1'
if. 1=vt do.
  wd'set data wrap 0'
else.
  wd'set data wrap 1'
end.
wd 'pshow;'
if. HELP__ do.
   update_hlp_ <'dnew'
   wd 'psel dnew; pactive; set vname focus'
end.
)

close=: 3 : 0
wd 'psel dnew;pclose'
)

dnew_cancel_button=: dnew_cancel=: close

dnew_vname_button=: 3 : 0
VarType=: (". type0,' ',type1,' ',type2)#'vti'
if. e=. VarType invalidVn deb vname do.
  vnError e
  wd 'set vname focus; set vname select'
  return.  
end.
wd 'set data focus '
)

dnew_type0_button=: dnew_type2_button=: 3 : 0
wd  'set data wrap 1'
settype''
)

dnew_type1_button=: 3 : 0
wd 'set data wrap 0'
settype''
)


settype=: 3 : 0
if. 0=#vname do.
  wd 'set vname focus'
else.
  wd 'set data focus'
end.
)

dnew_ok_button=: 3 : 0
Vn=. vname
VarType=: (". type0,' ',type1,' ',type2)#'vti'
if. 0<$Vn do.
  if. -. dnew_add_button'' do. return. end.
end.
close''
wd 'psel mstat'
wd 'set sbar setlabel nvar *',(":numvar''),' variables defined'
)
 

dnew_add_button=: 3 : 0
Vn=. deb vname
VarType=: (". type0,' ',type1,' ',type2)#'vti'
if. e=.VarType invalidVn Vn do.
  vnError e
  wd 'set vname focus; set vname select'
  res=.0
  return.
end.
select. VarType
  case. ,'v' do.
    Vd=. __ ". (LF,' ',TAB,' ',',',' ') charsub data
    if. __ e. Vd do. Vd=. parseV data end.
    if. invaldat Vd do.
      wd 'set data focus '
      res=.0
      return.
    end.
    ". Vn,'_v_=: Vd'
    Ddirty__=: 1
  case. ,'t' do.
    Vd=. parsetab data
    if. 0=#Vd do.
      wd 'set data focus '
      res=.0
      return.
    end.
    ". Vn,'_t_=: Vd'
    Ddirty__=: 1
  case. ,'i' do.
    if. +./(LF,TAB) e. data do.
      Vd=. LF chop (TAB,LF) charsub data
    else.
      Vd=. qchop data
    end.
    if. 0=#Vd do.
      mbError 'No data';'You need to enter values in the data entry field.'
      wd 'set data focus '
      res=.0
      return.
    end.
    ". Vn,'_i_=: Vd'
    Ddirty__=: 1
end.
wd 'set vname focus ;set vname text ;set data text ;'
res=.1
)

dnew_dlghlp=: 3 : 0
if. HELP__ do.
   HELP__=: 0
   wd 'psel hlp; pclose; psel mstat; set DHlp 0; psel dnew; pactive; set vname focus'
else.
   HELP__=: 1
   open_hlp_ <'dnew'
   wd 'psel mstat; set DHlp 1; psel dnew; pactive; set vname focus'
end.
)


dnew_octrl_fkey=: dnew_ok_button
dnew_dctrl_fkey=: dnew_add_button
dnew_lctrl_fkey=: dnew_dlghlp
NB. export.ijs
NB. Export variables as CSV file

coclass 'export'

(;:'base z') copath 'export'

SOH=: 1{a.
toSOH=: [:;(SOH,~":)each

EXPORT=: 0 : 0
pc export dialog nosize escclose closeok;
pn "Export variables as CSV file";
bin g;
grid cell 0 0 1 2;
bin v;
cc label1 static center;cn "Choose the samples in order";
cc vlab static center;cn "(Variables: name_v_ - Indicators: name_i_)";
bin z;
grid cell 1 0;
bin v;
cc label2 static center;cn "Available";
cc avlist listbox drag drop multiple;set avlist wh 180 120;
bin z;
grid cell 1 1;
bin v;
cc label3 static center;cn "To export";
cc tlist listbox drag drop multiple;set tlist wh 180 120;
bin z;
grid cell 2 0;
bin h;
cc flab static;cn "File";
cc fname edit readonly;set fname stylesheet background-color:#eeeeee;
bin z;
grid cell 2 1;
bin h;
cc fbrowse button;cn "Browse";
bin sz;
grid cell 3 1;
bin hs2;
cc done button;cn "&Done";
cc cancel button;cn "&Cancel";
bin zz;
pcenter;
)

open=: 3 : 0
VarN=: locv each nl_v_''
IndN=: loci each nl_i_''
wd EXPORT
wd 'pn "Export variables as CSV file"'
wd 'set tlist stylesheet *QPlainTextEdit {background-color:#eeeeee};'
Avail=: VarN,IndN
Totest=:0#Avail
Avail0=:Avail
export_write Avail;<''
wd 'pshow;'
if. HELP__ do.
   update_hlp_ <'export'
   wd 'psel export; pactive; set avlist focus'
end.
)


close=: 3 : 0
wd 'pclose'
)

export_write=: 3 : 0
'fm to' =. y
wd'set avlist items ', ; fm ,each SOH
wd'set tlist items ', ; to ,each SOH
)

export_read=: 3 : 0
(<;._2 wd 'get avlist allitems');<<;._2 wd 'get tlist allitems'
)

export_avlist_button=: 3 : 0
'fm to'=. export_read''
n=. ".avlist_select
to=. to,n{fm
fm=. (<<<n){fm
export_write fm;<to
)

export_tlist_button=: 3 : 0
'fm to'=. export_read''
n=. ". tlist_select
fm=. fm,n{to
to=. (<<<n){to
export_write fm;<to
)

export_fbrowse_button=: 3 : 0
Fn=. wd 'mb save "Export variables to CSV file" "',Dpath__,'"  "CSV files (*.csv)"'
if. 0=#Fn do. 
  wd 'set fname text *'
  return.
end.
fullpath=. pathname Fn
Dpath__=: >0{fullpath
if. -. '.csv' -: _4{.Fn do. Fn=. Fn,'.csv' end.
wd 'set fname text ',Fn
)

export_done_button=: 3 : 0
Fn=. fname
if. 0=#Fn do.
  mbError'File name required';'You must choose a file name for export.'
  return.
end.
outvar=. >{: export_read''
if. 0=#outvar do.
  mbError'No variables';'You must choose one or more variables for export.'
  return.
end.
close''
dat=. varconv each outvar
maxlen=. >/ ,># each dat
dat=. (maxlen&varlen) each dat
dat=. >dat
if. 1=#$dat do. dat=. citemize dat end.
(|:dat) writecsv Fn
mbInfo'CSV file written';'CSV file saved to ',Fn
)

varconv=: 3 : 0
vn=. _3}.y
vd=. ". y
if. '_v_' -: _3{.y do. vd=. bxv vd end.
(<vn),vd
)

varlen=: 4 : 0
len=. #y
d=. y
if. len<x do.
  d=. d,((len-x)#<'')
end.
d
)

export_cancel_button=: 3 : 0
close''
)

export_cancel=: export_cancel_button

export_dlghlp=: 3 : 0
if. HELP__ do.
   HELP__=: 0
   wd 'psel hlp; pclose; psel mstat; set DHlp 0; psel export; pactive; set avlist focus'
else.
   HELP__=: 1
   open_hlp_ <'export'
   wd 'psel mstat; set DHlp 1; psel export; pactive; set avlist focus'
end.
)

export_octrl_fkey=: export_done_button
export_lctrl_fkey=: export_dlghlp


NB. fdr.ijs
NB. Compute adjusted p-values

coclass 'fdr'
(;:'base z') copath 'fdr'

CSV=: 0
SOURCE=: 1

FDR=: 0 : 0
pc fdr dialog nosize escclose closeok ptop;
pn "Adjust p-values for multiple comparisons";
bin g;

grid cell 0 0;
groupbox "Source";
bin v;
cc srb0 radiobutton;cn "&Existing variables";
cc srb1 radiobutton group;cn "&New data";
bin z;
groupboxend;

grid cell 1 0;
bin v;
cc label1 static center;cn "Labels";
cc lab listbox;set lab wh 180 140;
bin z;

grid cell 1 1;
bin v;
cc label2 static center;cn "P-values";
cc pval listbox;set pval wh 180 140;
bin z;

grid cell 2 0 1 2;
cc ptab table;
set ptab wh _1 140;
set ptab shape 25 2;
set ptab hdr "Labels" "P-values";

grid cell 3 0;
cc exp checkbox;cn "Export as csv";

grid cell 4 0 1 2;
bin h;
cc flab static right;cn "File";
cc fname edit readonly;set fname stylesheet background-color:#eeeeee;
cc fbrowse button;cn "Browse";
bin z;

grid cell 5 0 1 2;
bin hs;
cc ok button;cn "&OK";
cc cancel button;cn "&Cancel";
bin z;

bin zz;
pcenter;
)

open=: 3 : 0
VarN=: nl_v_''
VarI=: nl_i_''
wd FDR
if. (0=#VarI) +. (0=#VarN) do.
  source 1
  wd 'set srb0 enable 0;set srb1 enable 0;'
else.
  wd 'set lab items ',vfm >VarI
  wd 'set pval items ',vfm >VarN
  source 0
end.
wd 'set exp value ',":CSV
wd 'pshow;'
if. HELP__ do.
   update_hlp_ <'fdr'
   wd 'psel fdr; pactive; set lab focus'
else.
   wd 'psel fdr; pactive; set lab focus'
end.
)

close=: 3 : 0
wd 'pclose'
)

fdr_cancel_button=: fdr_cancel=: close

source=: 3 : 0
wd 'set ptab data ""'
wd 'set ptab block 0 0; set ptab colwidth 180;'
SOURCE=: y
if. SOURCE do.
  wd 'set srb1 value 1'
  wd 'set lab enable 0;set pval enable 0;set label1 enable 0; set label2 enable 0'
  wd 'set ptab enable 1;set ptab focus'
else.
  wd 'set srb0 value 1'
  wd 'set ptab enable 0'
  wd 'set lab enable 1;set pval enable 1;set label1 enable 1; set label2 enable 1'
end.
)

fdr_srb0_button=: 3 : 0
source 0
)

fdr_srb1_button=: 3 : 0
source 1
)

fdr_lab_select=: 3 : 0
lv=. lab
if. 0=#lv do. return. end.
lvd=. ". loci lv
if. 25<#lvd do. lvd=. 25{.lvd end.
ldat=. dquot each lvd
0 settextcol 25{.ldat,25#<'""'
)

fdr_lab_button=: fdr_lab_select

fdr_pval_select=: 3 : 0
pv=. pval
if. 0=#pv do. return. end.
pvd=. ".locv pv
if. 25<#pvd do. pvd=.25{.pvd end.
pdat=. ": each bxv pvd
1 settextcol 25{.pdat,25#<'""'
)

fdr_pval_button=: fdr_pval_select

settextcol=: 4 : 0
NB. x is stab column number, y is boxed cell values
nrow=. #y
for_r. i.nrow do.
  wd 'set ptab cell ',(":r,x),' ',>r{y
end.
)

fdr_ok_button=: 3 : 0
CSV=: ".exp
Fn=. fname
if. CSV *. (0=#Fn) do.
  mbError'File name missing';'A file name is needed to save as csv.'
  wd 'set fbrowse focus'
  return.
end.
if. SOURCE do.
  tab=. 25 2$ <;._2 wd 'get ptab table'
  ldat=. 0{"1 tab
  ldat=. (0< ,># each ldat)#ldat
  pdat=. toN each 1{"1 tab
  if. -.(+/ __< ,> pdat) = +/0<,># each 1{"1 tab do.
    mbError'Non-numeric data';'Non-numeric data in p-value column.'
    wd 'set ptab focus'
    return.
  end.
  pdat=. (__< ,> pdat)#pdat
  pdat=. ,>pdat
  if. -. (#ldat)=(#pdat) do.
    mbError'Data mismatch';'The number of labels and p-values must be the same.'
    wd 'set ptab focus'
    return.
  end.
  tout'Adjustment of p-values for multiple comparisons',LF
else.
  if. (-. 0<#lab) +. (-. 0<#pval) do.
    mbError'Choose variables';'Variables for both labels and p-values must be selected.'
    wd 'set lab focus'
    return.
  end.
  ldat=. ". loci lab
  pdat=. ". locv pval
  if. -. (#ldat)=(#pdat) do.
    mbError'Data mismatch';'The number of labels and p-values must be the same.'
    wd 'set lab focus'
    return.
  end.
  tout'Adjustment of p-values for multiple comparisons',LF
  tout'Labels: ',lab,'; P-values: ',pval,LF
end.
if. -. (*./ pdat>:0) *. (-. +./ pdat>1) do.
  mbError'Invalid data';'All p-values must be between 0 and 1.'
  return.
end.
wd 'pclose'
psi=. /:pdat
psort=. psi{pdat
lsort=. psi{ldat
bnfadj=. (#psort) bonf psort
fdadj=. fdr psort
hdr=. 'Comparison';'p';'Bonf. p';'fdr'
dat=. lsort,.(ft each bxv psort),.(ft each bxv bnfadj),.ft each bxv fdadj
if. (#dat)>50 do.
  tout'Top 50 corrected p-values',LF
  tout bfmt hdr, 50{.dat
else.
  tout bfmt hdr,dat
end.
tout LF,LF
view''
if. CSV do.
  (hdr,dat) writecsv Fn
  mbInfo'CSV file written';'CSV file saved to ',Fn
end.
)

fdr_fbrowse_button=: 3 : 0
Fn=. wd 'mb save "Export variables to CSV file" "',Dpath__,'"  "CSV files (*.csv)"'
if. 0=#Fn do. 
  wd 'set fname text *'
  return.
end.
fullpath=. pathname Fn
Dpath__=: >0{fullpath
if. -. '.csv' -: _4{.Fn do. Fn=. Fn,'.csv' end.
wd 'set fname text ',Fn
)

fdr_dlghlp=: 3 : 0
if. HELP__ do.
   HELP__=: 0
   wd 'psel hlp; pclose; psel mstat; set DHlp 0; psel fdr; pactive'
else.
   HELP__=: 1
   open_hlp_ <'fdr'
   wd 'psel mstat; set DHlp 1; psel fdr; pactive'
end.
)

fdr_lctrl_fkey=: fdr_dlghlp
fdr_octrl_fkey=: fdr_ok_button
NB. hlp.ijs
NB. form-specific help window

coclass 'hlp'
('base';'z') copath <'hlp'

HLP=: 0 : 0
pc hlp;
minwh 256 700;cc txt edith flush;
)

open=: 3 : 0
if. 0=#y do. ht=. <'main' else. ht=. y end.
wd HLP
NB.setIcon''
wd 'pn *Help on Mstat'
wd 'set txt stylesheet *QTextEdit {background-color:#ffffee;',(font2css Dfont__),'}'
'sw sh'=: 2 3{". wd 'qscreen'
wd 'pshow'
'fw fh'=: DSCALE* 256 700
fh=: fh<.sh
wd 'pmove ',":(sw-fw+20),0,fw,fh
update ht
)

update=: 3 : 0
HTXT=: ''
for_h. y do.
  hvar=. >h
  if. ('_') = {:hvar do. hvar=. }:hvar end.
    HTXT=: HTXT,".hvar
end.
wd 'psel hlp;set txt text *',HTXT
wd 'psel mstat;pactive;set Em1 focus'
)

close=: 3 : 0
HELP__=:0
wd 'psel hlp; pclose; psel mstat; set DHlp 0;'
)

hlp_close=: hlp_cancel=: hlp_break=: close

hlp_hctrl_fkey=: hlp_lctrl_fkey=: close


main=: 0 : 0
<p><b><i>Mstat dialog help.</i></b> </p>
<p> Context-specific help will be displayed 
in this window. Press Ctrl-L to close.</p>
)

bar_plot=: 0 : 0
<p><b><i>Bar graph.</i></b> </p>
<p>Generates a bar graph for the selected variables. Four bar graph 
types are available: Grouped, Stacked, Area, and Floating. For 
the first three, the order of the selected variables determines 
the order on the graph (left to right or bottom to top). For 
a Floating Bar graph, the first variable chosen determines 
the position of the base of the bar. You can change the 
order of the bars by checking the <i>Order bars</i> box 
and choosing <i>Ascending</i> or <i>Descending</i> based 
on the magnitude of the first variable (Grouped bars) 
or the total across all of the variables.</p>
<p>Labels for the X-axis may be chosen (from among indicator 
variables) using the dropbox at the lower left. If "None" 
is selected, the bars will be labeled from 0 to the number of 
data points. </p>
<p>The number of values in each selected variable 
must be the same.</p>
)

sbar_plot=: fbar_plot=: abar_plot=: bar_plot

barnt=: 0 : 0
<p><b><i>Barnard's exact test</i></b> </p>
<p>Choose the desired tables from the 
<i>Available</i> list by highlighting them and 
pressing the <i>Add</i> button or by double-clicking 
the name. Use the radiobutton to choose a one- or 
two-sided test. This test applies to 2x2 tables 
with one fixed margin. All of the selected 
tables must have fixed row or column totals; select 
the appropriate radiobutton. If the largest fixed total 
is 25 or less, an iterative method is used for defining 
the critical region for the test (CSM method). If either 
fixed total exceeds 25, Fisher's exact test is used to 
define the critical region.</p>
)

bin=: 0 : 0
<p><b><i>Bin data.</i></b> </p>
<p>Computes the distribution for one or more variables using either equally spaced or 
arbitrary intervals. A frequency plot can also be generated.</p>
<p>The chosen variables are listed at the top of the form.</p>
<p>Select the type of intervals (bins) you want using the radiobuttons.</p>
<p>For equally spaced intervals (e.g., 5-10-15-20-...), select <i>Equal size</i>. 
For arbitrary intervals (e.g., 0-10-25-50-100), select <i>Specify upper bounds</i>.</p>
<p>Define your intervals (your choice of radiobuttons will enable the appropriate edit boxes).</p>
<p><i>Equal sized</i>: enter the  upper bound  for the first interval in the first 
edit box, the desired width for each interval in the second, and the number of 
intervals in the third. After specifying the upper bound of bin 1 and the interval width, 
press the <i>Enter</i> key (while the cursor is in the interval width or number of bins edit 
boxes); the program will suggest a number of bins such that the largest observation is 
placed in the second last bin. </p>
<p><i>Arbitrary</i>: enter the upper bounds for each interval in the edit box.</p>
<p>The distributions for the variables will be shown in the Mstat window. 
For each entry, the upper bound for the interval will be shown, followed by 
the number of observations that are less than or equal to the upper bound and 
larger than the preceding upper bound. 
You can also have the frequency of each class shown by checking the 
<i>Show frequencies</i> box.</p>
<p>A graph of the distributions will be shown if you check the <i>Show graph box</i>.</p>
)

binci=: 0 : 0
<p><b><i>Binomial confidence intervals.</i></b> </p>
<p>Computes the confidence interval for a binomial success probability, given the number 
of observed successes and the number of trials.</p>
<p>Enter the desired interval size (<i>e.g.</i>, 95) in the uppermost edit box.</p>
<p>In the edit window, enter the number of successes and number of trials, separated 
by a space on a single line. You may enter multiple x N pairs.</p>
)

binom=: 0 : 0
<p><b><i>Binomial distribution.</i></b> </p>
<p>Computes binomial probabilities or the cumulative distribution function.</p>
<p>Enter the parameters for the binomial distribution in the appropriate edit boxes.</p>
<p>Multiple values of <i>p</i> can be entered.</p>
)

bmod=: 0 : 0
<p><b><i>Bayesian predictive value</i></b> </p>
<p>Estimates the positive predictive value (PPV) and negative predictive value 
(NPV) for a diagnostic or screening test as a function of the prevalence of 
the disease and the sensitivity and specificty of the test.</p>
<p>To determine PPV and NPV for single values of prevalence, sensitivity, 
and specificity, make sure the <i>Enable range</i> box is unchecked and 
enter the appropriate values in the <i>Value</i> box in each section of the
dialog. You can also determine PPV and NPV for a range of any of the three 
parameters by checking the <i>Enable range</i> box and selecting the 
appropriate radiobutton. Then enter the minimum, maximum, and step size 
for the desired parameter, and the fixed values for the other two.</p>
<p>If you are evaluating a range for one of the parameters, you can 
plot the results by checking the <i>Show plot</i> box. Select the 
checkboxes for <i>Plot PPV</i> and/or <i>Plot NPV</i> as desired.</p>
<p>Press the <i>OK</i> button to close the dialog and obtain the
results.</p>
)

bootci=: 0 : 0
<p><b><i>Bootstrap confidence interval</i></b> </p>
<p>Estimates the confidence interval(s) for the mean, median, and/or variance
of the selected variables using the bootstrap method. Enter the desired size (%) of the 
confidence interval (<i>e.g.</i>, 95) and the number of bootstrap trials in the 
indicated list boxes. The desired parameters are selected using the checkboxes at 
the lower left.</p>
)

byind=: 0 : 0
<p><b><i>Classify</i></b> </p>
<p>Use an indicator variable to create new variables from a data set. 
The new variables are named as Variable_Indicator_IndicatorType.  
Both the variable and the indicator variable must have the same number of values. </p>
<p>Choose the desired variable and indicator variable from the drop-down listboxes.</p>
<p>The set of unique values in the indicator variable is shown in the edit 
box on the left.</p>
<p>To create a new variable for all of the indicator types, press the <i>Each</i> button. 
To use only a subset of the types, enter each desired type, separated by a space or 
newline, in the edit box on the right.</p>
<p>To create the new variables, press the <i>Classify <i>button (leaving the dialog box 
open), or the <i>Done</i> button, if no further variables will be classified by an indicator.</p>
)

chsqdist=: 0 : 0
<p><b><i>Chi-square distribution.</i></b> </p>
<p>Computes the upper tail probability for the Chi-square distribution.</p>
<p>Enter the number of degrees of freedom in the upper edit box.</p>
<p>Enter desired values of x (separated by a space or newline) in 
the edit box.</p>
)

chsqp=: 0 : 0
<p><b><i>Partition r x c table.</i></b> </p>
<p>Partitions an <i>r</i> x <i>c</i> contingency table into (<i>r</i> -1) x 
(<i>c</i> -1) tests each with 1 degree of freedom. The first partition corresponds 
to the 2 x 2 table in the upper left. The partitions are expanded first row-wise 
and then column-wise to yield 2 x 2 tables such that each cell is individually used 
(<i>i.e.</i>, not as a sum with other cell values) only once.</p>
<p>Either the Chi-square or likelihood ratio test may be selected with the 
appropriate radio button. The Chi-square test is preferable if the cell values 
are small (one or more cells less than 5). However, in contrast to the 
likelihood ratio test, the sum of the test statistics for the partitions will 
not exactly equal the test statistic for the table as a whole. </p>
<p>One or more tables may be chosen for analysis.</p>
)

chsqt=: 0 : 0
<p><b><i>Chi-square test.</i></b> </p>
<p>Tests the null hypothesis that the row and column classifications 
of an <i>r</i> x <i>c</i> contingency table are independent.</p>
)

cochran=: 0 : 0
<p><b><i>Cochran-Armitage test.</i></b> </p>
<p>Tests the null hypothesis that the success probabilities, <i>p</i> for an ordered 
set of <i>r</i> rows are identical against the alternative that there is a 
linear trend in <i>p</i> . The total Chi-square for the <i>r</i> x 2 table is 
partitioned into a 1 df test for a linear trend in the row proportions and 
a <i>r</i> -2 df test for goodness of fit to the linear model. </p>
<p>If the row labels are numerical, these values are used as the <i>x</i> 
variates; otherwise, the integers from 0 to <i>r</i> -1 are used. This test may also 
be applied to a 2 x <i>c</i> table with ordered columns.</p>
)

comp=: 0 : 0
<p><b><i>Combine p-values.</i></b> </p>
<p>Computes a combined p-value for a set of related experiments, using the 
method of Fisher.</p>
<p>Enter the p-values to be combined, separated by a space or 
newline, in the edit box.</p>
)

conover=: 0 : 0
<p><b><i>Conover test.</i></b> </p>
<p>Test the null hypothesis that a set of <i>k</i> 
variables are identical in dispersion against the alternative 
hypothesis that at least one pair of variables differ in 
dispersion. </p>
<p>The output consists of a table with the number 
of observations, mean, and standard deviation of each group. 
The value of the test statisic (which follows a chi-square 
distribution), the number of degrees of freedom, and the 
two-sided <i>P</i>-value are shown.</p>
)

ddel=: 0 : 0
<p><b><i>Delete variables.</i></b> </p>
<p>Deletes variables from memory.</p>
<p>Choose the variable type by selecting the appropriate 
radio button.</p>
)

dedit=: 0 : 0
<p><b><i>Edit variables.</i></b> </p>
<p>Edit the data (or name) for a variable, table, or indicator.</p>
<p>Choose the type of variable by selecting the appropriate radio button.</p>
<p>Select the desired variable from the list box. The variable name will 
be shown in the edit box labeled <i>Values for</i> and the data for the variable will 
be shown in the large edit box.</p>
<p>To change the name of the variable, click on the <i>Edit variable name</i> 
checkbox. The edit box above can now be changed to the new name. You can not choose a 
name that is already in use.</p>
<p>To alter the data, make the desired changes in the large edit window.</p>
<p>No changes are made until you select the Change button, which leaves the 
dialog box open, or the Done button.</p>
)

desc=: 0 : 0
<p><b><i>Descriptive statistics.</i></b> </p>
<p>Computes various descriptive statistics for a variable. </p>
<p>To compute quantiles for the data, check the <i>n-tiles</i> box 
and enter the desired number of quantiles in the edit box 
labelled <i>n</i>. For example, enter 2 for the median, 4 for quartiles, 
etc.</p>
<p>A table will be shown in the output window, with each row consisting 
of the variable name, number (N) of observations, mean, standard 
deviation, quantiles (if desired), and the minimum and maximum values.</p>
)

discrete=: 0 : 0
<p>In the <i>Values to show</i> group, you can choose to compute the distribution for 
either a range of x (number of successes or observations) by selecting <i>0 to n</i> or 
for <i>Specific values</i> of x. In the edit box, enter the maximum value of x 
or the specific values, respectively.</p>
<p>In the <i>Show distribution</i> group, select at least one of the frequency (Freq.), the 
cumulative probability (CDF), or the complement of the cumulative probability (1 - CDF).</p>
<p>Check the Plot box to display a graph of the frequency distribution(s).</p>
)

dnew=: 0 : 0
<p><b><i>Add new variable.</i></b> </p>
<p>Enter data for a new variable, table, or indicator. </p>
<p>Enter the new variable name in the edit box at the top 
of the form.</p>
<p>Select the appropriate radiobutton for the desired Variable type.</p>
<p>Enter the data for the variable in the edit window. For variables and 
indicators, values may be separated by spaces or newlines. Any legal J expression 
can be used to input the values for a variable. For example:</p>
<p>1 2 3,(5#0),(4#6)</p>
<p>assigns 1 2 3 0 0 0 0 0 6 6 6 6 to the variable.</p>
<p>Tables consist of a line 
containing the column names (optionally including a heading for the rows) separated by 
spaces, followed by one line for each row. Each row consists of a row name followed by 
the data values for the row. Note that neither column nor row names can contain spaces 
and that multiple spaces are treated as a single space. For example:</p>
<table>
<tr><td>Rows</td><td>Col1</td><td>Col2</td><td>Col3</td></tr>
<tr><td>Row1</td><td>1</td><td>2</td><td>3</td></tr>
<tr><td>Row2</td><td>4</td><td>5</td><td>6</td></tr>
</table>
)

dot_plot=: 0 : 0
<p><b><i>Dot plot of data.</i></b> </p>
<p>Shows a dot plot for one or more variables.</p>
<p>To have the y-axis start at 0, check the <i>Range includes 0</i> box. 
If this box is not checked, the minimum value on the y-axis will correspond 
to the smallest observation to be plotted.</p>
<p>To plot the positions of the median and first and third quartiles for 
each data set, check the <i>Show quartiles</i> box. An open bar indicating the 
values for the median and first and third quartiles will be placed to 
the left of each data set.</p>
)

export=: 0 : 0
<p><b><i>Export data as csv file.</i></b></p>
<p>Choose the desired regular variables (suffix _v_) 
and indicator variables (suffix _i_) from the 
<i>Available</i> list by highlighting them and 
pressing the <i>Add</i> button or by double-clicking 
the name. Use the <i>Browse</i> button to select the 
output file name. Press <i>Done</i> to save the 
exported file.
)

fdr=: 0 : 0
<p><b><i>Adjust p-values for multiple comparisons</i></b></p>
<p>Matched lists of labels and per-comparison p-values are required. 
If these already exist as variables, choose the <i>Existing variables</i> 
radiobutton from the <i>Source</i> group. Then select the appropriate 
variable names from the <i>Labels</i> and <i>P-values</i> list boxes. 
To input new data, choose the <i>New data</i> radiobutton and enter the 
values in the table at the bottom of the dialog.</p>
<p>If you want to save the table of adjusted p-values, select the
<i>Export as csv</i> checkbox and use the <i>Browse</i> button to 
select a file name.</p>
<p>Press <i>OK</i> to output the table of adjusted p-values to 
the <i>Mstat</i> window.</p>
)

fishert=: 0 : 0
<p><b><i>Fisher's exact test.</i></b> </p>
<p>Tests the null hypothesis that the row and column classifications 
are independent for one or more 2 x 2 contingency tables. Fisher's exact test may also 
be applied to testing the null hypothesis that two experimental groups have 
identical binomial <i>success</i> probabilities.</p>
<p>Choose one or more tables as described below.</p>
<p>Select the appropriate radio button for one-sided or two-sided alternatives. </p>
)

gfit=: 0 : 0
<p><b><i>Goodness of Fit test.</i></b> </p>
<p>Tests the null hypothesis that a set of observed frequencies or counts agree 
with those that were expected. The variable containing the Observed 1 x <i>c</i> table 
is selected in the left list box. The Expected variable may contain either the expected 
number of observations in each cell or the expected frequencies, as indicated by the 
radiobutton below. The number of parameters estimated from the data is indicated in the 
edit box.</p>
)

hyperg=: 0 : 0
<p><b><i>Hypergeometric distribution.</i></b> </p>
<p>Computes hypergeometric probabilities or the cumulative distribution function.</p>
<p>Enter the parameters for the hypergeometric distribution in the appropriate edit boxes.</p>
<p>Multiple values of either N or p (but not both) are allowed.</p>
<p>See help file for alternate parameterization.</p>
)

impfil=: 0 : 0
<p><b><i>Import data file</i></b> </p>
<p>Imports a tab-delimited or comma separated variable (CSV) file. 
Both of these file types can be generated by Excel (or other spreadsheet 
programs) or in a text editor. </p>
<p>The two edit boxes show the name of the file to be imported and 
the data in the file. </p>
<p>The file type, either tab-delimited or CSV, is chosen based on the file contents 
and is indicated in the <i>Delimiter</i> group of radio buttons. </p>
<p>To convert the rows or columns of data to variables (numeric or indicator), choose the appropriate 
radio button in the <i>Data by</i> group. The first row or column will be used to 
generate the variable name. If necessary, blanks are removed from the variable 
name. You will be asked to change any variable names that are still invalid. 
If the variable name is not included in the 
file as the first row or column, respectively, check the <i>No var. names</i> box. 
Variable names with the form "file_1", "file_2", etc., will be generated. </p>
<p>To import the entire table as a table variable, choose the <i>Table</i> 
radiobutton. For an imported table in which all entries in a column except 
for the first are numeric data, the values will automatically be converted to 
numbers in the imported table. To leave all entries in the table as text, 
select the <i>No numeric conv.</i> checkbox.
<p>Press the next button to proceed to the next step.</p>
)

jonckt=: 0 : 0
<p><b><i>Jonchkeere-Terpstra test.</i></b> </p>
<p>Test the null hypothesis that a set of <i>k</i> 
variables are identical in location against the alternative 
that the magnitudes of the variables follow a specified order. For a 
one-sided test, choose the variables in order of <i>increasing</i> magnitude 
under the alternative hypothesis. Select the <i>Two-sided</i> radio button 
if the desired alternative includes both <i>increasing or decreasing</i> order
are of interest.</p>
<p>The output consists of a table with the number 
of observations, mean, and standard deviation of each group. The normalized 
test statistic and <i>P</i>-value are shown.</p>
)

kaplan=: 0 : 0
<p><b><i>Kaplan-Meier survival analysis.</i></b> </p>
<p>For one or more sets of survival data, estimate 
the survival distributions using the product-limit 
method of Kaplan and Meier. The event times and 
censoring times are selected for each group as 
described below. </p>
<p>To display a plot of the survival curves, 
check the <i>Show plot</i> box. To estimate the 
median survival and its confidence limits (by 
the bootstrap method), check the <i>Median</i> 
box. Then fill in the desired number of bootstrap 
samples and size of the confidence interval in 
the appropriate edit boxes.  </p>
)

ken=: 0 : 0
<p><b><i>Kendall's rank correlation test.</i></b> </p>
<p>For a set of paired observations, tests the null hypothesis that the 
orderings by magnitude of the two variates are independent.</p>
)

kwal=: 0 : 0
<p><b><i>Kruskal-Wallis test.</i></b> </p>
<p>Test the null hypothesis that a set of <i>k</i> 
variables are identical in location against the alternative 
hypothesis that at least one pair of variables differ in 
location. </p>
<p>The output consists of a table with the number 
of observations, mean, and standard deviation of each group. 
The value of the test statisic (which follows a chi-square 
distribution), the number of degrees of freedom, and the 
two-sided <i>P</i>-value are shown.</p>
)

logrank=: 0 : 0
<p><b><i>Logrank test.</i></b> </p>
<p>Tests the null hypothesis that two or more 
survival distributions are identical against the 
alternative hypothesis that at least one of them 
is different using the logrank test. </p>
<p>Choose the event and censoring times for each 
group as described below. If a group does not include 
any censored observations, choose <i>(None)</i> from 
the right listbox. </p>
<p>The output includes the number of observed 
and expected events for each group, the hazard ratio 
(relative risk) relative to the first group, as well 
as the value of the test statistic and P-value.</p>
)

mantel=: 0 : 0
<p><b><i>Mantel-Haenszel test.</i></b> </p>
<p>Tests the null hypothesis that the success probabilities for two 
treatments are identical in a set of two or more replicate 2 x 2 
tables against either the one- or two-sided alternatives. </p>
<p>The tables included in the test must be identical in structure.</p>
)

mcnemt=: 0 : 0
<p><b><i>McNemar's test.</i></b> </p>
<p>Tests the null hypothesis that two treatments or conditions have 
identical binomial <i>success</i> probabilities for paired data (<i>e.g.</i>, 
a case-control study). </p>
<p>Choose one or more tables as described below.</p>
<p>Select the appropriate radio button for one-sided or two-sided alternatives.</p>
<p>Because of the pairing within the data, the format of the table differs from 
that used for Fisher's exact test or the Chi-square test:
<table>
<tr><td>&nbsp;</td><td>&nbsp;</td><td colspan=2>Controls</td></tr>
<tr><td>&nbsp;</td><td>&nbsp;</td><td>Pos.</td><td>Neg.</td></tr>
<tr><td rowspan=2 valign=middle>Cases</td><td>Pos.</td><td><i>a</i></td><td><i>b</i></td></tr>
<tr><td>Neg.</td><td><i>c</i></td><td><i>d</i></td></tr>
</table>
<p>In the above table, <i>a</i> represents the number of pairs in which 
a <i>Positive</i> outcome was observed for both the case and the control.</p>
)

miller=: 0 : 0
<p><b><i>Miller jackknife test.</i></b> </p>
<p>Tests the null hypothesis that two variables have identical 
variances (dispersions). Select 
the appropriate radio button for the one- or two-sided alternative. For the 
one-sided alternative, select the sample with the lesser magnitude in the 
<i>Sample 1</i> list box.</p>
<p>The output consists of a table with the number 
of observations, mean, and standard deviation of each group. 
The variance ratio, the value of the test statisic 
(which follows a normal distribution), and the 
 <i>P</i>-value are shown. The direction of the one-sided test 
is indicated by the variance ratio.</p>

)

modplot=: 0 : 0
<p><b><i>Modify plot parameters.</i></b> </p>
<p>Choose the appropriate tab to modify various aspects of 
the plot, as indicated below. Press the <i>Apply</i> button to 
update the graph with any changes you have made. The <i>Done</i> 
button will update the graph and close the dialog, while <i>Cancel</i> 
closes the dialog without making any further changes.</p>
<p><b><i>Size/Labels</i></b> </p>
<p>You can change the width and height of the plot by entering 
the desired values in the appropriate edit boxes. The dimensions 
of the plot include any axis labels and the plot title, if present.</p>
<p>The Title and Captions for the X and Y axes may be entered 
or modified in the appropriate edit boxes. Font sizes for these elements 
may be set in the edit boxes labeled "Size". For dot plots and bar graphs 
an additional edit box provides the X axis labels. Edit these as needed, 
placing quotes around any labels containing a space.</p>
<p><b><i>Axes</i></b> </p>
<p>Tics may be placed inside or outside the axes by choosing the 
appropriate radio button. The thickness for the axes, frame, and tics 
is entered in the edit box labeled "Line weight". The length of major 
tics is entered in "Tic size". The "Offset" check box will displace 
the origin from the smallest label.</p>
<p>For each axis, the range and tic intervals are entered in the 
appropriate edit boxes. A grid of lines at the major tic marks will 
be drawn if the Grid checkbox is selected. If all values are greater 
than 0, a Log axis may be chosen with the appropriate check box.</p>
<p><b><i>Symbols</i></b> </p>
<p>For bar graphs, the relative width of the bars (up to 100%, values 0 to 1) may 
be entered in the appropriate edit box. For X-Y plots, the "Line weight" 
(in pt) and "Marker size" are shown in the labeled edit boxes. For Marker 
size, a value of 1 is equivalent to approximately 5 pt. For plots with 
standard deviations, the SD line may extend above or below the markers 
(or both) depending on the radiobutton selected. </p>
<p>The table at the bottom of the tab, allows selection (where 
relevant) of the color, marker type, or line style from the 
appropriate dropboxes.</p>
<p><b><i>Key</i></b> </p>
<p>A key is shown on the graph by default if two or more variables 
are plotted. To add or remove a key, use the "Show key" checkbox. The font 
size for the key may be entered in the edit box at the top, right. Names 
for each variable in the key may be entered in the edit box labeled 
"Key names", in the same order as the variables listed immediately above. 
The position of the key as well as aspects of its style may be chosen using 
the radio buttons at the bottom of the form. Experiment with these choices 
to give the effect that you desire.</p>
)

mspref=: 0 : 0
<p><b><i>Set Mstat preferences.</i></b> </p>
<p>Change the fonts used by Mstat or the number of 
significant figures shown for numerical output.</p>
<p>The current fonts for data output, printing,  
dialog boxes, and plots are shown in the edit windows. To switch to 
a different font for any of these, press the corresponding 
<i>Change</i> button.</p>
<p>Note that saved plots will use Helvetica as the type face, so choose 
a plot font with similar metrics (<i>e.g.,</i> Arial).</p>
<p>The current number of significant figures displayed for 
numerical data is shown in the edit box. You can set this value 
to any integer from 2 through 9.</p>
<p>Pressing the <i>Advanced</i> button will open a dialog box 
that allows you to change the default web browser or pdf viewer. 
To return to the default applications, delete the contents of 
the two edit boxes. </p>
)

mulsmp=: 0 : 0
<p>The available variables are shown in the list box at 
the left. To choose the desired variables in a specific order, 
double-click on each in turn in the <i>Available</i> list, which 
will move the variable name to the window on the right, or drag 
the variable to the right hand list box. You can also select multiple 
variable names and press Enter or drag the to the right box. The 
variables in the right list box can be reordered by dragging and 
dropping within the list box. To de-select a variable, drag it 
back to the left list box.</p>
<p>When you have finished selecting variables, press the 
<i>Done</i> button.</p>
)

multex=: 0 : 0
<p><b><i>Multiple experiments.</i></b> </p>
<p>Perform a joint analysis of replicate experiments, each consisting of two 
samples, x and y. An exact test is done if the maximum value across the experiments of 
N!/nx!(N-nx)! is less than 200,000 (where nx is the number of x observations and 
N is the total number of observations in the experiment). Otherwise, Lehman's 
approximate test is used.</p>
<p>Choose the x and y values for each experiment in turn, i.e., x1,y1,x2,y2,...</p>
)

negbin=: 0 : 0
<p><b><i>Negative binomial distribution.</i></b> </p>
<p>Computes negative binomial probabilities or the cumulative distribution function.</p>
<p>Enter the parameters for the negative binomial distribution in the appropriate edit boxes. 
Multiple values of m or k are allowed.</p>
<p>See help file for alternate parameterization.</p>
)

normdist=: 0 : 0
<p><b><i>Normal distribution.</i></b> </p>
<p>Computes the tail or cumulative probability for specified values 
of <i>z</i> using the normal distribution.</p>
<p>Enter the desired values of <i>z</i> in the edit window, separated by 
spaces or newlines.</p>
<p>Depending on the radio button, either the tail probability (the integral from 
<i>z</i> to infinity or from -infinity to <i>z</i> for positive or negative values 
of <i>z</i>, respectively) or the cumulative probability (the integral from 
-infinity to <i>z</i>) will be shown in the output window. Checking the 
<i>log P</i> box will output the log of the tail probability, or the 
log of its upper bound when <i>z</i> is greater than 37.</p>
)

onesmp=: 0 : 0
<p>Either select the desired variable in the list box and press the <i>Done</i> button or 
double-click on the variable name.</p>
)

open_bin=: 0 : 0
<p><b><i>Bin data</i></b></p>
<p>Choose samples for binning.</p>
)

open_toord=: 0 : 0
<p><b><i>Convert ordered table to variables</i></b> </p>
<p>Converts a table with columns that follow a natural order 
into a set of variables corresponding to each row of the table.</p>
<p>After conversion, these variables may be tested for 
differences in location using the Wilcoxon rank sum, 
Jonckheere-Terpstra, or Kruskal-Wallis test.</p>
)

ord=: 0 : 0
<p><b><i>Convert ordered table to variables</i></b> </p>
<p>The selected table is shown in the edit window. Each row will 
be converted to a variable. The variable names will have the form 
TableName_RowName. You should edit the row names to yield unique, legal 
variable names, if necessary.</p>
<p>For the <i>c</i> columns, the observations will be assigned values 
ranging from 0 to (<i>c</i> -1). If the <i>Increasing</i> radio button 
is selected, the observations in column 1 will have the value 0. Conversely, 
if the <i>Decreasing</i> radio button is selected, column 1 observations will be 
assigned the value <i>c</i> -1.</p>
)

pairsmp=: 0 : 0
<p>The available variables are shown in the list boxes at 
the top. For each paired sample, choose the appropriate 
variable from the left and right list boxes. Press the 
Add button, and the selected pair will be shown in the 
window below.</p>
<p>You can start the selection process over by pressing the 
<i>Reset</i> button.</p>
<p>When you have finished selecting variables, press the 
<i>Done</i> button.</p>
)

pairwise=: 0 : 0
<p><b><i>Perform all pairwise tests.</i></b></p>
<p>Choose the desired regular variables from the 
<i>Available</i> list by highlighting them and 
pressing Enter or dragging them to the <i>To test</i> 
list box, or by double-clicking 
each name. Choose the appropriate test (Wilcoxon, Spearman, 
or Kendall) from the <i>Test</i> list. For the two rank 
correlation tests, all variables must have the same 
number of observations. If you want to 
save the results as a CSV file, check the <i>Export</i> 
box and use the <i>Browse</i> button to select the 
output file name. </p>
)

parseimport=: 0 : 0
<p><b><i>Import data file</i></b> </p>
<p>The data file (converted to a table) is shown in the 
edit window at the left of the dialog box. </p>
<p>The variable names for the data table are shown in the 
<i>Available</i> list. To import variables from this list, either 
select the names of the desired variables and press the <i>Add</i> 
button, or double-click on individual variable names to move 
them to the <i>Import</i> list. If you want to restart the variable 
selection process, press the <i>Reset</i> button. The 
<i>Variable name</i> list shows the variable to which 
the import column will be assigned.</p>
<p>Numerical data will be stored as regular variables. Columns 
or rows containing non-numeric characters will be saved as 
indicator variables. </p>
<p>When you have finished selecting variables to import, 
press the <i>Done</i> button.</p>
)

tableimport=: 0 : 0
<p><b><i>Import table</i></b></p>
<p>A portion of the table to be imported is shown in the edit 
window at the top of the dialog.</p>
<p>Enter the variable name for the imported table in the 
<i>Table name</i> edit box.</p>
<p>Press the <i>Done</i> button to import the table.</p>
)

poiss=: 0 : 0
<p><b><i>Poisson distribution.</i></b> </p>
<p>Computes Poisson probabilities or the cumulative distribution function.</p>
<p>Enter the mean for the Poisson distribution in the edit box labeled m. 
Multiple values of m are allowed.</p>
)

ratio=: 0 : 0
<p><b><i>Ratio of variables.</i></b> </p>
<p>Computes the means and standard deviations for the ratios 
of one or more variables to another.</p>
<p>The variables for the numerators are selected as described below. 
Choose the denominator from the combo-box in the lower part of the dialog.</p>
)

regress=: 0 : 0
<p><b><i>Regression analysis.</i></b> </p>
<p>Performs linear regression analysis. </p>
<p>Choose the desired model (straight 
line, polynomial, or multiple) by selecting the appropriate radio button. 
If a constant term should be included in the model, select the <i>Constant</i> 
check box. For polynomial regression, enter the order of the model in the 
edit box.</p>
<p>The variable corresponding the to <i>Y</i> values is selected in the combo box. 
The variable(s) for the <i>X</i> values are chosen by selecting the appropriate 
entries in the <i>Available Variables</i> list and pressing Enter or dragging them 
to the <i>X variables</i> list box, or by double-clicking on 
each variable name. Multiple X variables can be chosen for multiple regression, 
but only a single variable may be selected for linear or polynomial regression.</p>
<p>For linear and polynomial regression, select the <i>Plot</i> check box and 
a plot of the observations and regression line will be shown.</p>
)

rescale=: 0 : 0
<p><b><i>Rescale variables.</i></b></p>
<p>Applies a common divisor to a group of variables.</p>
<p>This function is a convenience for changing the scale for multiple 
variables which is useful for plotting. Enter the divisor in the <i>Divisor</i> 
edit box and a suitable label in the <i>Label</i> edit box. For example, 
entering "1e6" as the divisor and "m" as the label will yield a new set 
of variables (listed in "Variables to rescale") with values divided by 
1,000,000 assigned to varname_m.</p>
)

sen=: 0 : 0
<p><b><i>Sen-Adichie test for parallelism.</i></b> </p>
<p>Tests the null hypothesis that two lines share a common slope. This test 
provides a convenient approach to the double-ratio problem, in which the 
desired comparison is for the relative responses to treatment of two samples. </p>
)

show=: 0 : 0
<p><b><i>Show variables.</i></b> </p>
<p>Show the contents of variables in the output window. </p>
<p>Choose the variable type by selecting the appropriate 
radio button.</p>
)

spad=: 0 : 0
<p><b><i>Scratchpad</i></b> </p>
<p>Enter a valid J 
expression in the edit 
box and press the return 
key. The expression 
will be displayed 
indented in the edit 
window followed by 
its result. For example, 
entering 4+2 in the 
edit box displays</p>
<p>   4+2</p>
<p>6</p>
<p>in the edit window. </p>
<p>See the help file for a 
brief summary of J notation.</p>
)

spear=: 0 : 0
<p><b><i>Spearman's rank correlation test.</i></b> </p>
<p>Tests the null hypothesis of independence for a set of paired observations. </p>
)

srank=: 0 : 0
<p><b><i>Wilcoxon signed rank test.</i></b> </p>
<p>Tests the null hypothesis that the difference, Y-X, for paired 
samples (X,Y) is equal to zero. Select 
the appropriate radio button for the one- or two-sided alternative. For the 
one-sided alternative, select the sample with the lesser magnitude in the 
<i>Sample 1</i> list box.</p>
)

ssfish=: 0 : 0
<p><b><i>Sample size for Fisher's exact test.</i></b> </p>
<p>Computes the sample sizes required for Fisher's exact test 
as a function of the desired significance level (alpha), power (1-beta), 
and the success probabilities under the alternative hypothesis.</p>
<p>In the <i>Significance Level</i> group at the upper left, enter the 
desired significance level in the <i>alpha</i> edit box and choose a one-sided 
or two-sided test.</p>
<p>For a single estimate of sample size, enter the desired power 
in the <i>Value</i> edit box within the <i>Power</i> group, and the lower and upper 
binomial success probabilities under the alternative hypothesis 
in the two edit boxes in the lower part of the dialog box.</p>
<p>You can also investigate the required sample sizes as a 
function of power, or either of the binomial success probabilities. 
Select the <i>Enable Range</i> check box and the appropriate <i>Range</i> 
radio button. The fill in the <i>Min</i>, <i>Max</i>, and <i>Num. Steps</i> 
edit boxes in that group. Note that you may need to explicitly 
select one of the <i>Range</i> buttons in order to enable the edit boxes.</p>
<p>Families of power curves can be estimated by entering multiple 
values in the appropriate edit box. Multiple values are allowed in one 
of Power, Lower proportion, or Higher proportion as long as Range is not 
enabled for that parameter.</p>
<p>To plot the power curve(s), select the <i>Plot</i> check box.</p>
)

ssmcn=: 0 : 0
<p><b><i>Sample size for McNemar's test.</i></b> </p>
<p>Computes the sample sizes required for McNemar's test for case-control studies 
as a function of the desired significance level (alpha), power (1-beta), 
the probability of "exposure" for the control patients and the 
odds ratio under the alternative hypothesis.</p>
<p>In the <i>Significance Level</i> group at the upper left, enter the 
desired significance level in the <i>alpha</i> edit box and choose a one-sided 
or two-sided test.</p>
<p>For a single estimate of sample size, enter the desired power 
in the <i>Value</i> edit box within the <i>Power</i> group, the probability of 
"exposure" for controls (Control Proportion), and the odds ratio in 
the appropriate edit boxes. The number of controls matched to each 
case and the correlation coefficient for "exposure" between cases 
and controls are entered in the edit boxes at the lower right 
of the dialog box. </p>
<p>You can also investigate the required sample sizes as a 
function of power, the control proportion, or the odds ratio. 
Select the <i>Enable Range</i> check box and the appropriate <i>Range</i> 
radio button. The fill in the <i>Min</i>, <i>Max</i>, and <i>Num. Steps</i> 
edit boxes in that group. Note that you may need to explicitly 
select one of the <i>Range</i> buttons in order to enable the edit boxes.</p>
<p>Families of power curves can be estimated by entering multiple 
values in the appropriate edit box. Multiple values are allowed in one 
of Power, Control proportion, Odds ratio, Num. matched controls, 
or Case-control correlaton as long as Range is not 
enabled for that parameter.</p>
<p>To plot the power function, select the <i>Plot</i> check box.</p>
)

sswil=: 0 : 0
<p><b><i>Sample size for the Wilcoxon rank sum test.</i></b> </p>
<p>Computes the sample sizes required for the Wilcoxon rank sum test 
as a function of the desired significance level (alpha), power (1-beta), 
and the distributions of the observations under the alternative hypothesis.</p>
<p>In the <i>Significance Level</i> group at the upper left, enter the 
desired significance level in the <i>alpha</i> edit box and choose a one-sided 
or two-sided test.</p>
<p>In the group labeled <i>Model</i>, choose the radio button corresponding 
to the distribution of the data for your experiment (or the best 
approximation to it). If you choose the negative binomial model, you will 
need to enter the value for the parameter, <i>k</i> in the edit box.</p>
<p>For a single estimate of sample size, enter the desired power 
in the <i>Value</i> edit box within the <i>Power</i> group, and the parameters 
of the distribution of the data for the lower and upper 
groups under the alternative hypothesis 
in the two groups of edit boxes in the lower part of the dialog box.</p>
<p>You can also investigate the required sample sizes as a 
function of power, or the means of either of the two experimental groups. 
Select the <i>Enable Range</i> check box and the appropriate <i>Range</i> 
radio button. Then fill in the <i>Min</i>, <i>Max</i>, and <i>Num. Steps</i> 
edit boxes in that group. Note that you may need to explicitly 
select one of the <i>Range</i> buttons in order to enable the edit boxes.</p>
<p>Families of power curves can be estimated by entering multiple 
values in the appropriate edit box. Multiple values are allowed in one 
of Power, Lower mean, or Upper mean as long as Range is not 
enabled for that parameter. For the Negative binomial distribution, 
multiple values of k are also allowed.</p>
<p>To plot the power function, select the <i>Plot</i> check box.</p>
)

toind=: 0 : 0
<p><b><i>Convert Variable to Indicator</i></b> </p>
<p>Converts a numeric variable to an indicator variable. Note that 
this conversion is probably not worthwhile unless the variable contains 
a limited set of integer values.</p>
)

tovar=: 0 : 0
<p><b><i>Convert Indicator to Variable</i></b> </p>
<p>Converts an indicator variable to a numeric variable. Note that 
the conversion will not be allowed if the indicator variable contains values 
that can not sensibly be converted to numbers.</p>
)


transf=: 0 : 0
<p><b><i>Transform variable.</i></b> </p>
<p>Generates a new variable that contains transformed values from an 
existing variable.</p>
<p>Choose the variable to be transformed from the list box in the 
upper left. Double-clicking on the variable name will show the data 
for the variable in the <i>Current data</i> window.</p>
<p>Choose the type of transformation by selecting the appropriate 
radio button. For Add, Multiply, or Power, enter the operand in the 
edit box below. For example, to transform a variable by multiplying 
by 20, select the <i>Multiply</i> radio button and enter 20 in the edit 
box. No operand is required for the inverse or natural log (log(e)) 
transformations.</p>
<p>You can use any valid J expression as a transformation by selecting 
the <i>J</i> radio button and placing the expression in the edit box. Some 
examples of useful J transformations (where <i>x</i> is the variable):</p>
<table>
<tr><td>Function&nbsp;&nbsp;&nbsp;</td><td>J expression</td></tr>
<tr><td>log(x)</td><td>(10&^.)</td></tr>
<tr><td>ln(x+1)</td><td>^.@(1&+)</td></tr>
<tr><td>log(x+1)</td><td>(10&^.)@(1&+)</td></tr>
<tr><td>sin(x)</td><td>(1&o.)</td></tr>
<tr><td>cos(x)</td><td>(2&o.)</td></tr>
</table>
<p>To see the results of the transformation, press the 
<i>Show</i> button.</p>
<p>Enter a name in the <i>New variable name</i> edit box. Press the 
<i>Done</i> button to generate the new variable.</p>
)

tripsmp=: 0 : 0
<p>The available variables are shown in the three list boxes at 
the top. For each sample group, choose the appropriate 
variable from the left, middle, and right list boxes. Press the 
Add button, and the selected group will be shown in the 
window below.</p>
<p>You can start the selection process over by pressing the 
<i>Reset</i> button.</p>
<p>When you have finished selecting variables, press the 
<i>Done</i> button.</p>
)

twosmp=: 0 : 0
<p>Select a variable name in each of the two list boxes and press 
the <i>OK</i> button.</p>
)

wil=: 0 : 0
<p><b><i>Wilcoxon rank sum test.</i></b> </p>
<p>Tests the null hypothesis that two variables have identical locations 
(magnitudes). Select 
the appropriate radio button for the one- or two-sided alternative. For the 
one-sided alternative, select the sample with the lesser magnitude in the 
<i>Sample 1</i> list box.</p>
<p>The output consists of a table with the number 
of observations, mean, and standard deviation of each group. The 
value of the test statistic, it's normalized value (W*), and 
the <i>P</i>-value are shown.</p>
)

xy_plot=: 0 : 0
<p><b><i>X-Y scatter plot.</i></b> </p>
<p>Shows a scatter plot for selected pairs of X and Y variables. 
Depending on the menu choice, the plots include markers, lines, or both, 
but these choices may be modified for each group after the plot 
is generated. Choose "Modify plot" from the Edit menu on the 
plot window.</p>
<p>When multiple observations within a group have the 
same X value, the line is drawn from the average of the Y values, 
with the individual values shown. Checking <i>Plot mean, s.d.</i> 
will plot the mean and standard deviation for the Y values 
at each X value.</p>
<p>Variables may be plotted against two independent Y axes by 
checking the <i>Dual Y axes</i> box. Choose all of the X-Y pairs 
to be plotted on the left Y axis first, and then choose all of the 
pairs to be plotted on the right Y axis. Indicate the number of 
X-Y pairs to be plotted on the left axis in the <i>Left first</i> 
edit box.</p>
<p>Both variables in each group must contain the same number of 
observations. </p>
<p>The X and Y axis captions are taken from the names of the 
variables in the first group.</p>
<p>The check boxes at the bottom of the dialog allow log plots 
for the X and Y axes. If any of the groups contain values of 0, 
selecting log for the relevant axis is ignored.</p>
)

xyb_plot=: 0 : 0
<p><b><i>X-Y band plot.</i></b></p>
<p>For variables with multiple observations for each X-value, plots 
markers at the central Y-value (median or mean) for each X-value. A 
shaded band is also shown around the resulting line that represents 
the first-third quartile range (choose <i>Quartile</i> radiobutton) 
or the specified confidence interval (choose <i>CI</i> radiobutton). 
The desired confidence interval is chosen by entering the appropriate 
value in the <i>% CI</i> edit box. The color of the band for each 
X-Y pair is a lighter version of the color for the plotted line.<p>
)

xys_plot=: 0 : 0
<p><b><i>X-Y scatter plot.</i></b> </p>
<p>Shows a scatter plot for selected pairs of X and Y variables, 
with the standard deviation for each point indicated. 
By default, the plots include only markers with the associated 
standard deviation, but lines may be added for each group after the plot 
is generated.  Choose "Modify plot" from the Edit menu on the 
plot window.</p>
<p>The three variables in each group must contain the same number of 
observations. </p>
<p>The X and Y axis captions are taken from the names of the 
variables in the first group.</p>
<p>The check boxes at the bottom of the dialog allow log plots 
for the X and Y axes. If any of the groups contain values of 0, 
selecting log for the relevant axis is ignored.</p>
)
NB. import.ijs
NB. import data from tab or comma-delimited text files
NB. modified to allow use of gz files

coclass 'import'

(;:'base z') copath 'import'

IMF_type=: 'c'
IMF_file=: 'c'
MAXTAB=: 1000000
FileTypes=: 'csv';'txt';'gz'
NULL=: {. a. 

PIZERO=: 0

open=: 3 : 0
Fn=: impfn Dpath__
if. 0 = #Fn do.
  return.
end.
fullpath=. pathname Fn
Dpath__=: >0{fullpath
fname=. (>1{fullpath)
if. '.' e. fname do. ext=. (-(>1{fullpath) inxlastr '.'){.fname else. ext=. '' end.
if. #et=. (<ext) inx FileTypes do. IMF_file=: et{'ctg' else. IMF_file=: 'c' end.
IMF_name=: fname
impfil_run Fn
)

close_impfil=: 3 : 0
wd 'pclose'
)

impfn=: 3 : 0
ft=. ,>(IMF_file inx 'ctg'){FileTypes
wd 'mb open1 "Open data file" "',(y,'*.',ft),'"  "Comma separated (*.csv)|Tab delimited (*.txt)|Compressed (*.gz)|All files (*.*)";'
)

NB. base form

IMPFIL=: 0 : 0
pc impfil dialog nosize escclose closeok;pn "Import data file";
bin g;
grid cell 0 0;
bin v;
bin h;
cc imflb1 static right;cn "File";
cc imfe2 edit readonly;
bin z;
cc imfed editm readonly;set imfed wh 300 150;set imfed wrap 0;
bin hs;
cc imfcancel button;cn "&Cancel";
cc imfnext button;cn "&Next >";
bin szz;
grid cell 0 1;
bin v;
groupbox "Delimiter";
cc imfrb00 radiobutton;cn "&Tab";
cc imfrb01 radiobutton group;cn "Co&mma";
groupboxend;
groupbox "Data by";
cc imfrb10 radiobutton;cn "&Rows";
cc imfrb11 radiobutton group;cn "Co&lumns";
cc imfrb12 radiobutton group;cn "T&able";
groupboxend;
cc imfck checkbox;cn "No &var. names";
bin z;
pcenter;
)

impfil_run=: 3 : 0
isTab=: isCSV=: 0
f=. toJ tzread y
if. 0=#f do.
  mbError 'Not text file';'This file is not a text file and cannot be imported.'
  return.
end.
if. (#f)>2000 do. ff=. 2000{.f else. ff=. f end.
wd IMPFIL
wd 'set imfed stylesheet *QPlainTextEdit {background-color:#eeeeee;',(font2css Vfont__),'}'
ntab=. +/TAB=ff
ncom=. +/','=ff
isTab=: ntab>ncom
isCSV=: (-.isTab) *. ',' e. ff
if. isTab do.
  wd 'set imfrb00 value 1'
else.
  if. -. isCSV do.
    mbError 'Not delimited file';'Neither comma or tab delimiters are present in this file.',LF,'It can not be imported.'
    return.
  end.
  wd 'set imfrb01 value 1'
end.
wd 'set imfed text ', ff
".'impfil_imfrb1',(":IMF_type inx 'rct'),'_button'''''
wd 'set imfed font  ',Vfont
wd 'set imfe2 text *',y
wd 'set imfnext focus '
wd 'set imfrb00 enable  0; set imfrb01 enable  0'
wd 'pshow;'
if. HELP__ do.
  update_hlp_ <'impfil'
  wd 'psel impfil; pactive; set imfnext focus '
end.
IMF_rec=: f
if. -. LF={:IMF_rec do. IMF_rec=: IMF_rec,LF end.
DLM=: isTab{(',',TAB)
NCELL=: +/DLM=IMF_rec
LGTAB=: NCELL>MAXTAB
ROWS=: +/LF=IMF_rec
COLS=: +/DLM= LF taketo IMF_rec
)

impfil_imfcancel_button=: impfil_cancel=: impfil_close=: close_impfil


impfil_imfnext_button=: 3 : 0
select. IMF_type
  case. 'c' do.
    if. ROWS<COLS do.
      r=. mbQuery'Row/Column check';'You indicated data by columns, but there are fewer rows than columns.',LF,LF,'Proceed anyway?'
      if. r -: 'no' do. return. end.
    end.
  case. 'r' do.
    if. COLS<ROWS do.
      r=. mbQuery'Row/Column check';'You indicated data by rows, but there are fewer columns than rows.',LF,LF,'Proceed anyway?'
      if. r -: 'no' do. return. end.
    end.
end.
NAMES=: -. TEXTONLY=: ".imfck
close_impfil''
if. IMF_type='t' do.
  tableimport_run''
else.
  parseimport_run''
end.
)


impfil_imfrb10_button=: 3 : 0
wd 'set imfrb10 value 1'
wd 'set imfck text "No variable names"'
IMF_type=: 'r'
)

impfil_imfrb11_button=: 3 : 0
wd 'set imfrb11 value 1'
wd 'set imfck text "No variable names"'
IMF_type=: 'c'
)

impfil_imfrb12_button=: 3 : 0
wd 'set imfrb12 value 1'
wd 'set imfck text "No numeric conv.  "'
IMF_type=: 't'
)

impfil_dlghlp=: 3 : 0
if. HELP__ do.
  HELP__=: 0
  wd 'psel hlp; pclose; psel mstat; set DHlp 0; psel impfil; pactive; set imfnext focus'
else.
  HELP__=: 1
  open_hlp_ <'impfil'
  wd 'psel mstat; set DHlp 1; psel impfil; pactive; set imfnext focus'
end.
)

impfil_nctrl_fkey=: impfil_imfnext_button
impfil_lctrl_fkey=: impfil_dlghlp

TABLEIMPORT=: 0 : 0
pc tableimport dialog nosize escclose closeok;pn "Import table";
bin v;
cc labeltd static;cn "Data";
cc tiData editm readonly;set tiData wh 600 200;set tiData wrap 0;
bin h;
cc labelti static right;cn "Table name";
cc tiName edit;set tiName wh 200 _1;
bin z;
bin hs;
cc tiDone button;cn "&Done";
cc tiCancel button;cn "&Cancel";
bin z;
bin z;
)

tableimport_run=: 3 : 0
if. isTab do.
  IMF_rec=: chop IMF_rec
  IMF_rec=: >(TAB&chop) each IMF_rec
else.
  IMF_rec=: fixcsv IMF_rec
end.
wd TABLEIMPORT
wd 'set tiData stylesheet *QPlainTextEdit {background-color:#eeeeee;',(font2css Vfont__),'}'
tdisp=. (20<.{.$IMF_rec){.IMF_rec
wd'set tiData text *',bfmt tdisp
wd'pshow'
if. HELP__ do.
  update_hlp_ <'tableimport'
  wd 'psel tableimport; pactive; set tiName focus'
end.
)

tableimport_tiCancel_button=: close_timp

close_timp=: 3 : 0
wd 'pclose'
)

tableimport_tiDone_button=: 3 : 0
tname=. tiName
if. e=.'t' invalidVn tname do.
  vnError e
  wd 'set tiName focus; set tiName select'
  res=.0
  return.
end.
if. -. TEXTONLY do.
  ft=. tabnum''
else.
  ft=. IMF_rec
end.
". tname,'_t_=: ft'
close_timp''
wd 'psel mstat'
wd 'set sbar setlabel nvar "',(":numvar''),' variables defined"'
Ddirty__=: 1
)

tableimport_tiName_button=: tableimport_tiDone_button

tableimport_dlghlp=: 3 : 0
if. HELP__ do.
  HELP__=: 0
  wd 'psel hlp; pclose; psel mstat; set DHlp 0; psel parseimport; pactive; set piList focus'
else.
  HELP__=: 1
  open_hlp_ <'parseimport'
  wd 'psel mstat; set DHlp 1; psel parseimport; pactive; set piList focus'
end.
)

tableimport_lctrl_fkey=: tableimport_dlghlp

tabnum=: 3 : 0
tdim=. $IMF_rec
rt=. ,IMF_rec
tc=. (__&".) each rt
tt=. >(__&e.) each tc
tc=. ((I. tt){rt) (I. tt)}tc
tdim$tc
)

PARSEIMPORT=: 0 : 0
pc parseimport dialog nosize escclose closeok;pn "Import data";
bin g;
grid cell 0 0 1 3;
bin v;
cc labeld static;cn "Data";
cc piData table;
bin z;

grid cell 1 0;
bin v;
cc labela static center;cn "Available";
cc piList listbox multiple;set piList wh 150 150;
bin hs;
cc piAdd button;cn "&Add";
bin zz;

grid cell 1 1;
bin v;
cc labeli static center;cn "Import";
cc piImport editm readonly;set piImport wh 150 150;
bin h;
cc piReset button;cn "&Reset";
bin szz;

grid cell 1 2;
bin v;
cc labelv static center;cn "Variable name";
cc piVarN editm;set piVarN wh 150 150;set piVarN wrap 0;
bin sz;

grid cell 2 0 1 3;
bin h;
cc piZero checkbox;cn "Treat blank as zero for numeric variable";
bin sz;

grid cell 3 0 1 2;
bin h;
cc labelp static right; cn "Prefix ";
cc piPrefix edit;
bin z;

grid cell 3 2;
bin hs;
cc piDone button;cn "&Done";
cc piCancel button;cn "&Cancel";
bin z;
pcenter;
)

parseimport_run=: 3 : 0
if. -. LGTAB do.
  if. isTab do.
    IMF_rec=: chop IMF_rec
    IMF_rec=: >(TAB&chop) each IMF_rec
  else.
    IMF_rec=: fixcsv IMF_rec
  end.
  if. IMF_type='r' do.
    IMF_rec=: |:IMF_rec
  end.
else.
  IMF_rec=: chop IMF_rec
end.
IMF_colnm=: getvn''
emptycol=.(<0)= # each IMF_colnm
wd PARSEIMPORT
PIavail0=: PIavail=: (-. emptycol)#IMF_colnm
PIuse=: 0#PIavail
wd 'pn *Import data'
NB. limit display to 20 lines
if. -. LGTAB do.
  datdisp=. (20<.{.$IMF_rec){.IMF_rec
else.
  if. 'c'=IMF_type do.
    datdisp=. > (DLM&chop) each 20{.IMF_rec
  else.
    datdisp=. ''
    nr=. 20<.{.$IMF_rec
    nc=. 20<.+/DLM= ,>{.IMF_rec
    for_i. i. nr do.
      datdisp=. datdisp, nc{. ,DLM chop >i{IMF_rec
    end.
    datdisp=. (nr,nc)$datdisp
  end.
end.
datdisp=. (-.emptycol) #"1 datdisp
wd 'set piData shape ',":(_1+{.$datdisp),#PIavail
wd 'set piData hdr *',vfm >PIavail
wd 'set piData data *',(vfm >,}.datdisp),((<'')={:{:datdisp)#LF
wd 'set piList items ', vfm > PIavail
wd 'set piImport stylesheet *QPlainTextEdit {background-color:#eeeeee;}'
wd 'set piPrefix text '
wd 'set labeld text ','Data ',IMF_name
wd 'set piZero value ',":PIZERO
wd 'pshow;'
if. HELP__ do.
  update_hlp_ <'parseimport'
  wd 'psel parseimport; pactive; set piList focus'
end.
)

getvn=: 3 : 0
if. -. LGTAB do.
  if. NAMES do.
    vn=. 0{IMF_rec
  else.
    nv=. {:$IMF_rec
    vn=. ('v'&,)each chop ": i.nv
  end.
else.
  if. NAMES do.
    if. 'c'=IMF_type do.
      if. isTab do. vn=. DLM chop >{.IMF_rec else. vn=. , fixcsv (>{.IMF_rec),LF end.
    else.
      vn=. getrowvn''
    end.
  else.
    if. 'c'=IMF_type do.
      nv=. +/DLM= >{.IMF_rec
    else.
      nv=. #IMF_rec
    end.
    vn=. ('v'&,)each chop ": i.nv
  end.
end.
vn=. deb each vn
)

getrowvn=: 3 : 0
PR=: conew'progress'
create__PR'Getting variable names by row';#IMF_rec
vn=. ''
for_r. IMF_rec do.
  if. isTab do. vr=. {. TAB chop >r else. vr=. {. , fixcsv (>r),LF end.
  vn=. vn,vr
  tick__PR''
end.
destroy__PR''
vn
)

parseimport_piCancel_button=: close_parse

close_parse=: 3 : 0
wd 'pclose'
)

parseimport_piDone_button=: 3 : 0
impvar=. PIuse inx IMF_colnm
if. 0=#impvar do.
  mbError 'Choose variables';'You must choose one or more variables to import.'
  PIuse=: 0#PIavail
  wd 'set piList focus '
  return.
end.
varname=. <;._2 piVarN,LF
nvar=. #impvar
nind=. 0
PIZERO=: ".piZero
close_parse''
if. -. LGTAB do.
  for_i. i.nvar do.
    vn=. >i{varname
    dat=. openvec __ ". each }.(i{impvar){"1 IMF_rec
    if. __ e. dat do.
      idat=. }.(i{impvar){"1 IMF_rec
      idat=. (0< ,> # each idat)#idat
      vn newind idat
      nind=. nind+1
    else.
      if. PIZERO do.
        dat=. ,> __ ". each }.(i{impvar){"1 IMF_rec
      end.
      vn newvar dat
    end.
  end.
else.
  nind=. parselgtab impvar;<varname
end.
wd 'psel mstat'
wd 'set sbar setlabel nvar "',(":numvar''),' variables defined"'
Ddirty__=: 1
if. 0<nind do.
  mbError 'Indicator variables';(":nind),' data sets saved as Indicator variables.'
end.
)

parselgtab=: 3 : 0
'impvar vname'=. y
nind=. 0
nrow=. #IMF_rec
PR=: conew'progress'
if. IMF_type='c' do.
  vdat=. ''
  maxprog=. <.0.0001*#IMF_rec
  incprog=. <.(#IMF_rec)%maxprog
  create__PR'Extracting data from table';maxprog
  for_r. i.#IMF_rec do.
    if. isTab do.
      vdat=. vdat, ,(>impvar{ TAB chop >r{IMF_rec),. LF
    else.
      vdat=. vdat, ,(>impvar{ , fixcsv (>r{IMF_rec),LF),.LF
    end.
    if. 0 = incprog | r do. 
      tick__PR''
    end.
  end.
  destroy__PR''
  vdat=. |:(nrow,#vname)$ chop vdat
  PR=: conew'progress'
  create__PR'Assigning variables';#vname
  for_i. i. #vname do.
    vn=. >i{vname
    vd=. }. i{vdat
    dat=. (__&".) each vd
    if. (<__) e. dat do.
      idat=. deb each vd
      idat=. (0< ,> # each idat)#idat
      vn newind idat
      nind=. nind+1
    else.
      vn newvar ,>dat
    end.
    tick__PR''
  end.
  destroy__PR''
else.
  create__PR'Extracting data from table';#impvar
  for_r. impvar do.
    rdat=. r{IMF_rec
    if. isTab do. rdat=. TAB chop >rdat else. rdat=. , fixcsv (>rdat),LF end.
    vn=. >r{vname
    dat=. (__&".) each }.rdat
    if. (<__) e. dat do.
      idat=. deb each rdat
      idat=. (0< ,> # each idat)#idat
      vn newind idat
      nind=. nind+1
    else.
      vn newvar ,>dat
    end.
    tick__PR''
  end.
  destroy__PR''
end.
nind
)

parseimport_piAdd_button=: 3 : 0
selected=. <;._2 wd 'get piList items'
last=. ". piList_select
if. 0<#selected do.
  PIavail=: PIavail-.selected
  PIuse=: PIuse,selected
  if. 0=#PIavail do. wd 'set piList items ' else. wd 'set piList items ',vfm >PIavail end.
  wd 'set piImport text ',vfm >PIuse
  if. 0<#piPrefix do. vnuse=. ((piPrefix,'_')&,) each PIuse else. vnuse=. PIuse end.
  vnuse=. fixvn each vnuse
  wd 'set piVarN text ',vfm > vnuse
  wd 'set piList select ',":(1+last-#selected)<._1+#PIavail
end.
empty''
)

parseimport_piReset_button=: 3 : 0
PIavail=: PIavail0
PIuse=: 0#PIavail
wd 'set piList items ', vfm > PIavail
wd 'set piImport text *'
wd 'set piVarN text *'
)

parseimport_piList_button=: 3 : 0
parseimport_piAdd_button''
)

newvar=: 3 : 0
:
". x,'_v_=: y'
)

newind=: 3 : 0
:
". x,'_i_=: y'
)

parseimport_dlghlp=: 3 : 0
if. HELP__ do.
  HELP__=: 0
  wd 'psel hlp; pclose; psel mstat; set DHlp 0; psel parseimport; pactive; set piList focus'
else.
  HELP__=: 1
  open_hlp_ <'parseimport'
  wd 'psel mstat; set DHlp 1; psel parseimport; pactive; set piList focus'
end.
)

parseimport_dctrl_fkey=: parseimport_piAdd_button
parseimport_rctrl_fkey=: parseimport_piReset_button
parseimport_octrl_fkey=: parseimport_piDone_button
parseimport_lctrl_fkey=: parseimport_dlghlp

toutf8=: 3 : 0
dat=. y
val=. a. i. dat
msk=. 127 < val
uni=. 192 128 +"1 [ 0 64 #: msk # val
val=. val #~ 1 j. msk
ndx=. I. 127 < val
dat=. a. {~ uni (ndx +/ 0 1) } val
)
NB. mdef.ijs
NB. defaults and global variables

coclass 'base'

TestN=:'Descriptive';'Wilcoxon';'Signed Rank';'Kruskal-Wallis';'Jonckheere';'Fisher''s exact';'Chi-square';'Kendall';'Combine p';'Transform';'Ratio';'Show';'Bin data'
TestN=:TestN,('Regression';'Dot Plot data';'XY Marker Plot';'Wilcoxon Sample Size';'Fisher Sample Size';'Fisher''s exact test';'Chi-square test';'Chi-square partition')
TestN=:TestN,('Binom. CI';'Mantel-Haenszel';'Spearman';'Sen-Adichie';'To ordinal';'Delete variables';'McNemar''s test';'Chi-square dist.')
TestN=:TestN,('Normal dist.';'Binomial dist.';'Poisson dist.';'Goodness of fit';'Bootstrap C.I.')
TestN=:TestN,('Cochran-Armitage';'Negative binomial dist.';'Hypergeometric dist.';'Multiple experiments';'McNemar sample size')
TestN=:TestN,('Kaplan-Meier';'Log Rank';'Bar Graph';'Stacked Bar Graph';'Floating Bar Graph';'Area Plot')
TestN=:TestN,('XY Line Plot';'XY Marker/Line Plot';'XY Marker/SD Plot';'Bar SD graph')
TestN=:TestN,('Pairwise';'Barnard';'Adjusted p-values';'Rescale';'XY Band Plot';'Bayesian Predictive Value')
TestN=:TestN,('Miller Jackknife';'Conover')
SidedN=:'';'one-sided';'two-sided'
Sided=: 2
RC=: 0

cDESC=:0
cWIL=:1
cSRANK=:2
cKWAL=:3
cJONCKT=:4
cFISHR=:5
cCHSQ=:6
cKEN=:7
cCOMP=:8
cTRANSF=:9
cRATIO=:10
cSHOW=:11
cBIN=:12
cREG=:13
cDOTPLOT=:14
cXYM=:15
cSSWIL=:16
cSSFISH=:17
cFISHRT=:18
cCHSQT=:19
cCHSQP=:20
cBINCI=:21
cMANTEL=:22
cSPEAR=:23
cSEN=:24
cTOORD=:25
cDDEL=:26
cMCNEMT=:27
cCHID=:28
cNORM=:29
cBINOM=:30
cPOISS=:31
cGFIT=:32
cBOOTCI=:33
cCOCHR=:34
cNEGBIN=:35
cHYPERG=:36
cMULTEX=:37
cSSMCN=:38
cKAPM=: 39
cLOGRANK=: 40
cBARPLOT=: 41
cSBARPLOT=: 42
cFBARPLOT=: 43
cABARPLOT=: 44
cXYL=: 45
cXYLM=: 46
cXYS=: 47
cBARSD=: 48
cPAIR=: 49
cBARN=: 50
cFDR=: 51
cRESCALE=: 52
cXYB=: 53
cBPRED=: 54
cMILLER=: 55
cCONOVER=: 56

SIGFIG=:4

VNMISSING=:1
VNFIRST=:2
VNALPHNUM=:3
VNDUP=:4
VNRESERV=: 5
VNUNDER=: 6

VNERROR=:'';'Missing variable name.';'First character must be a letter.';'Only letters, numbers, or underscore allowed.';'Name already in use.';'Reserved names (x,y) can not be used as variable names.';'Variable name can not end in or contain repeated underscores.'

NB. Set RNG
9!:43 (4)

NB. mplotdef.ijs
NB. Constant defs for mplot

coclass'mplot'

PMarker=: 'circle';'diamond';'square';'triangle';'plus';'times';'vbar';'opencircle';'opendiamond';'opensquare';'opentriangle';'none'

NB.PLine=: 'none';'solid';'dash';'dot';'dashdot';'dashdotdot'
PLine=: 'none';'solid';'dash';'dot';'-.';'-..'
PLineReg=: 'solid';'dot'

PColor=: chop 0 : 0
Black
Red
Blue
Green
Yellow
Cyan
Magenta
DarkGray
DarkRed
DarkBlue
DarkGreen
Gold
DarkCyan
DarkMagenta
LightGray
LightPink
LightBlue
LightGreen
LightYellow
LightCyan
Thistle
White
)


PColorB=: chop 0 : 0
LightGray
LightPink
LightBlue
LightGreen
LightYellow
LightCyan
Thistle
LightGray
LightPink
LightBlue
LightGreen
LightYellow
LightCyan
Thistle
DarkGray
Red
Blue
Green
Yellow
Cyan
Magenta
White
)

PColorBWB=: chop 0 : 0
Black
White
DarkGray
LightGray
)

PColorBW=: chop 0 : 0
Black
DarkGray
LightGray
)

PLOTVN=: chop 0 : 0
DFace
DFont
TITLEFONT
CAPTIONFONT
LABELFONT
KEYFONT
SUBTITLEFONT
TITLE
XCAPTION
YCAPTION
MARKERS
TICSTYLE
GUIDESIZE
EDGESIZE
TICMAJOR
TICMINOR
PENSIZE
MARKERSIZE
FRAMESTYLE
XMIN
XMAX
YMIN
YMAX
XMAJOR
XMINOR
YMAJOR
YMINOR
ITEMCOLOR
LINESTYLE
GRIDS
KEYSHOW
KEYPOS
KEYSTYLE
KEYNAMES
BARWIDTH
NOMARKER
NOLOGX
NOLOGY
SDTYPE
PLOT_PARAM
PLOT_NEW
PLOT_TYPE
YNAMES
XNAMES
ZeroOrigin
LOGX
LOGY
BarOrd
BarOrdDir
PSIZE
NOKEY
FRAME
LOGY2
NOLOGY2
Y2MIN
Y2MAX
Y2MAJOR
Y2MINOR
Y2CAPTION
PLOTWH
)
NB. mplotreq.ijs
NB. base locale functions

coclass 'base'

makeplot=: 3 : 0
:
PLOT_TYPE__=: x
PLOT_PARAM__=: y
PO=. conew 'mplot'
PO__=: PO
create__PO''
)

load_plot=: 3 : 0
'load' makeplot y
)


bar_plot=: 3 : 0
if. 0 = $MSvar__ do.
  empty''
  return.
end.
lab=. {: MSvar__
MSvar__=: }: MSvar__
LOGX__=: LOGY__=: 0
if. -. lab=<'' do. lab=. ".(>lab),'_i_' end.
'bar' makeplot (<lab),<". each (,&'_v_') each MSvar__
)

barsd_plot=: 3 : 0
if. 0 = #PSvar__ do.
  empty''
  return.
end.
lab=. {.>{:PSvar__
vn=. >PSvar__=: }:PSvar__
LOGX__=: LOGY__=: 0
if. -. lab=<'' do. lab=. ". (>lab),'_i_' end.
yv=. ". each locv each {."1 vn
sv=. ". each locv each {:"1 vn
'barsd' makeplot (<lab),(<yv),(<sv)
)

sbar_plot=: 3 : 0
if. 0 = $MSvar__ do.
  empty''
  return.
end.
lab=. {: MSvar__
MSvar__=: }: MSvar__
LOGX__=: LOGY__=: 0
if. -. lab=<'' do. lab=. ".(>lab),'_i_' end.
'sbar' makeplot (<lab),<". each (,&'_v_') each MSvar__
)

fbar_plot=: 3 : 0
if. 0 = $MSvar__ do.
  empty''
  return.
end.
lab=. {: MSvar__
MSvar__=: }: MSvar__
LOGX__=: LOGY__=: 0
if. -. lab=<'' do. lab=. ".(>lab),'_i_' end.
'fbar' makeplot (<lab),<". each (,&'_v_') each MSvar__
)

abar_plot=: 3 : 0
if. 0 = $MSvar__ do.
  empty''
  return.
end.
lab=. {: MSvar__
MSvar__=: }: MSvar__
LOGX__=: LOGY__=: 0
if. -. lab=<'' do. lab=. ".(>lab),'_i_' end.
'area' makeplot (<lab),<". each (,&'_v_') each MSvar__
)

dot_plot=: 3 : 0
if. 0 = $MSvar__ do.
  empty''
  return.
end.
LOGX__=: LOGY__=: 0
'dot' makeplot ". each (,&'_v_') each MSvar__
)

xy_plot=: 3 : 0
if. 0 = $PSvar__ do.
  empty''
  return.
end.
'logx logy plotbw dosd axes'=. y
if. dosd do.
  dat=. ". each locv each >PSvar__
  res=. meansd dat
NB.  TPvar__=. (,&<'') each PSvar__
  TPvar__=. PSvar__
  if. Tlast__ e. cXYL,cXYLM do. 'xysl' makeplot y,<res else. 'xys' makeplot y,<res end.
else.
  pt=. ,>(inxb Tlast__=(cXYM,cXYL,cXYLM)){'xym';'xyl';'xylm'
  pt makeplot y,<". each locv each >PSvar__
end.
)

xyb_plot=: 3 : 0
if. 0 = $PSvar__ do.
  empty''
  return.
end.
'type ci'=. y
dat=. ". each locv each >PSvar__
res=. y
tout 'Band plot - '
if. type do.
  tout (":ci),'% Confidence interval',LF
  h=. 1 3$'x';'n';'Lower  Mean  Upper'
else.
  tout 'Quartiles',LF
  h=. 1 3$'x';'n';'First  Median  Third'
end.
for_d. i.#dat do.
  'xv yv'=. >d{dat
  xg=. sortup ~.xv
  dgm=. xg =/ xv
  nx=. +/"1 dgm
  dg=. bxv dgm
  yg=. ''
  for_g. dg do.
    yg=. yg,< (>g)#yv
  end.
  tout 'x,y ', ( bfmt d{PSvar__),LF
  if. 0=type do.
    res=. res, <xg,. >> (4&ntile) each yg
    tout bfmt h,(bxv xg),.(bxv nx),. >(4&ntile) each yg
  else.
    res=. res, <xg,. >(ci&meanci) each yg
  end.
  tout LF,LF
end.
view''
'xyb' makeplot res
)

xys_plot=: 3 : 0
if. 0 = $TPvar__ do.
  empty''
  return.
end.
'xys' makeplot ". each locv each >TPvar__
)

ploadfn=: 3 : 0
wd 'mb open1 "Open graph file" "',Dpath__,'" "Graph files (*.ijg)|All files (*.*)"'
)

meansd=: 3 : 0
r=. ''
for_s. y do.
  'xv yv'=. s
  uv=. ~. xv
  xvm=. uv =/ xv
  nval=. +/"1 xvm
  ym=. (+/"1 xvm * ($xvm)$yv) % nval
  y2=. (+/"1 xvm * ($xvm)$*:yv) % nval
  yvar=. y2-*:ym
  ysd=. %: yvar * nval%nval-1
  r=. r, citemize uv;ym;ysd
end.
}.r
)

  
  
NB. mplot.ijs
NB. class for mstat plots

coclass 'mplot'
NB. corequire 'jzplot'

(;:'base z') copath 'mplot'

PLOTWH=: 600 400 

MPLOT=: 0 : 0
pc mplot nosize;pn "Mstat Plot";
menupop "&File";
menu save "&Save..." "Ctrl+S";
menu saveas "&Save as..." "Ctrl+A";
menu print "&Print" "Ctrl+P";
menusep;
menu exit "&Close" "Ctrl+Q";
menupopz;
menupop "&Edit";
menu modify "&Modify plot..." ;
menupopz;
minwh 300 32; cc tb toolbar;
minwh 300 200;cc mp isigraph flush;
)

mptb=: 3 : 0
wd 'set tb add print "Print plot" "',TBP__,'printer.png"'
wd 'set tb addsep'
wd 'set tb add save "Save plot" "',TBP__,'disk.png"'
wd 'set tb add saveas "Save plot as" "',TBP__,'document-pdf.png"'
wd 'set tb addsep'
wd 'set tb add modify "Modify plot" "',TBP__,'chart.png"'
)

create=: 3 : 0
PLOT_NUM=: PLOT_NUM__=: 1+PLOT_NUM__
PLOT_TYPE=: PLOT_TYPE__
PLOT_PARAM=: PLOT_PARAM__
PLOT_NEW=: 1
MO=: ''
PO=: PO__
TSvar=: TSvar__
MSvar=: MSvar__
PSvar=: PSvar__
TPvar=: TPvar__
ZeroOrigin=: ZeroOrigin__
LOGX=: LOGY=: 0
BarOrd=: BarOrd__
BarOrdDir=: BarOrdDir__
PlotBW=: PlotBW__
PLOTDAT=: ''
NOKEY=: 0
wd MPLOT
mptb''
wd 'pn "Mstat Plot ',(":PLOT_NUM),'"'
NB.setIcon''
wd'set mp wh ',":PLOTWH
formhwnd=: wd 'qhwndp'
'px py pw ph'=. ". wd 'qform'
'sw sh'=. 2 3{ ". wd 'qscreen'
wd 'pmove ',":(sw-pw+20),0,pw,ph
NB.MP =: ('mplot';'mp') conew 'jzplot'
MP=: (formhwnd;'mp') conew 'jzplot'
PForm__MP=: 'mplot'
PFormhwnd__MP=: wd 'qhwndp'
PId__MP=: 'mp'
PLOTWH__MP=: PLOTWH
PLOTDIRTY=: 1
plot_init''
setplot''
)

plot_init=: 3 : 0
DFace=: (>{. boxfont Dfont__),' '
DFont=: DFace,'12'
TITLEFONT=: CAPTIONFONT=: LABELFONT=: KEYFONT=: SUBTITLEFONT=: DFont
TITLE=:''
XCAPTION=:''
YCAPTION=: Y2CAPTION=: ''
TICSTYLE=: 'out'
GUIDESIZE=: EDGESIZE=: 1
TICMAJOR=: 8
TICMINOR=: 5
PENSIZE=: 2
MARKERSIZE=: 1
FRAMESTYLE=: 'in'
XMIN=: XMAX=: XMAJOR=: XMINOR=: ''
YMIN=: YMAX=: YMAJOR=: YMINOR=: Y2MIN=: Y2MAX=: Y2MAJOR=: Y2MINOR=: ''
GRIDS=: 0 0
KEYSHOW=: 0
KEYPOS=: 'rti'
KEYSTYLE=: 'lbvf'
KEYNAMES=: ''
BARWIDTH=: 0.9
NOMARKER=: 0
NOLOGX=: 0
NOLOGY=: NOLOGY2=: 0
SDTYPE=: 'b'
YNAMES=: XNAMES=: ''
PSIZE=: ''
FRAME=: 1
Y2=: 0
)


destroy=: 3 : 0
if. PLOTDIRTY do.
  q=. mbAsk'Close without saving?';'Do you want to close the plot without saving?'
  if. (q-:'no') do. save_plot'' end.
  if. (q-:'cancel') do. return. end.
end.
wd 'pclose'
if. 0<#MO do. destroy__MO'' end.
coerase MP
codestroy''
)

mplot_qctrl_fkey=: 3 : 0
destroy''
)

mplot_cancel=:mplot_cancel_button=:mplot_close=:mplot_exit_button=:mplot_close=: destroy

formselect=: 3 : 'wd''psel '',formhwnd'

setplot=: 3 : 0
select. PLOT_TYPE
  case. 'hist' do. histplot''
  case. 'reg' do. regplot''
  case. 'dot' do. dotplot''
  case. 'pow' do. powplot''
  case. 'bpv' do. bpvplot''
  case. 'xym';'xyl';'xylm';'xys';'xysl' do. xyplot''
  case. 'xyb' do. xybplot''
  case. 'km' do. kmplot''
  case. 'bar';'sbar';'fbar';'area' do. barplot''
  case. 'barsd' do. barsdplot''
  case. 'load' do. open_plot''
  case. do.
    if. 3=nc <PLOT_TYPE do. ". PLOT_TYPE,'''''' end.
end.
)

mplot_print_button=: 3 : 0
print_plot''
)

mplot_pctrl_fkey=: 3 : 0
mplot_print_button''
)

mplot_saveas_button=: 3 : 0
saveas_plot''
)

mplot_actrl_fkey=: 3 : 0
mplot_saveas_button''
)

mplot_save_button=: 3 : 0
save_plot''
)

mplot_sctrl_fkey=: 3 : 0
mplot_save_button''
)

mplot_cctrl_fkey=: 3 : 0
empty''
)

mplot_modify_button=: 3 : 0
if. 0=#MO do.
  MO=: conew'modplot'
  create__MO PO
else.
  raise__MO''
end.
)

disablemp=: 3 : 0
win=. > (<;._2) each <;._2 wd 'qpx'
MPWIN=: ((<'mplot')={."1 win)#1{"1 win
for_m. MPWIN do.
  wd 'psel ',(,>m),';set mp enable 0'
end.
)

enablemp=: 3 : 0
for_m. MPWIN do.
  wd 'psel ',(,>m),';set mp enable 1'
end.
)

barplot=: 3 : 0
msplot_default''
'lab dat'=. PLOT_PARAM
dat=. , each dat
if. BarOrd do.
  if. ((<PLOT_TYPE)=<'bar') +. 1=#dat do. orddat=. ,>{. dat else. orddat=. +/ >dat end.
  if. BarOrdDir do. sortdir=. \: else. sortdir=. /: end.
  dat=. ((sortdir orddat)&{) each dat
end.
if. PLOT_NEW do.
  if. (<PLOT_TYPE)=<'fbar' do. YNAMES=: }. MSvar else. YNAMES=: MSvar end.
  nvar=. #YNAMES
  ITEMCOLOR=: nvar pchoose 'b'
  MARKERS=: nvar#<'none'
  LINESTYLE=: nvar#<'none'
  if. (<PLOT_TYPE)=<'bar' do. yall=. ,>dat else. yall=. ,+/\ >dat end.
  ymin=. <./yall
  ymax=. >./yall
  if. -. 0<ymin do. NOLOGY=: 1 else. NOLOGY=: 0 end.
  'YMIN YMAX YMAJOR YMINOR'=: axisrange ymin,ymax
  NOLOGX=: 1
  EDGESIZE=: 0.5
  if. 0=#>lab do. XNAMES=: ": i.#,>{.dat else. XNAMES=: dqlabel lab end.
end.
pd__MP'itemcolor ',colorlist ITEMCOLOR
pd__MP'type ',PLOT_TYPE
pd__MP'barwidth ',":BARWIDTH
pd__MP'ycaption ',YCAPTION
pd__MP'yrange ',":YMIN,YMAX
pd__MP'ytic ',":YMAJOR,YMINOR
pd__MP'xlabel ',XNAMES
pd__MP'edgesize ',":EDGESIZE
if. KEYSHOW do.
  pd__MP'key ', KEYNAMES
  pd__MP'keycolor ',colorlist ITEMCOLOR
  pd__MP'keypos ',KEYPOS
  pd__MP'keystyle ',KEYSTYLE
  pd__MP'keyfont ',KEYFONT
end.
if. (<PLOT_TYPE)=<'area' do. pd__MP |.+/\>dat else. pd__MP >dat end.
PLOT_NEW=: 0
wd 'pshow'
pd__MP'show'
)

barsdplot=: 3 : 0
msplot_default''
'lab yv sv'=. PLOT_PARAM
if. PLOT_NEW do.
  YNAMES=: {."1 >PSvar
  nvar=. #YNAMES
  ITEMCOLOR=: nvar pchoose 'b'
  MARKERS=: nvar#<'none'
  LINESTYLE=: nvar#<'none'
  yall=. openvec yv
  sall=. openvec sv
  ymin=. <./yall
  ymax=. >./yall+sall
  if. -. 0<ymin do. NOLOGY=: 1 else. NOLOGY=: 0 end.
  'YMIN YMAX YMAJOR YMINOR'=: axisrange ymin,ymax
  nbar=. # ,>{.yv
  'XMIN XMAX XMAJOR'=: 3 {.axisrange 0,nbar
  NOLOGX=: 1
  PENSIZE=: 1
  EDGESIZE=: 0.5
  if. 0=#>lab do. XNAMES=: ": 1+i.#,>{.yv else. XNAMES=: dqlabel lab end.
  if. 1<nvar do.
    KEYSHOW=: 1
    KEYNAMES=: dqlabel YNAMES
  end.
else.
  nvar=.#YNAMES
  nbar=. #,>{.yv
end.
if. 1=nbar do. yv=. citemize each yv end.
pd__MP'itemcolor ',colorlist ITEMCOLOR
pd__MP'type bar'
pd__MP'barwidth ',":BARWIDTH
pd__MP'ycaption ',YCAPTION
pd__MP'yrange ',":YMIN,YMAX
pd__MP'ytic ',":YMAJOR,YMINOR
pd__MP'xlabel ',XNAMES
pd__MP'edgesize ',":EDGESIZE
if. KEYSHOW do.
  pd__MP'key ', KEYNAMES
  pd__MP'keycolor ',colorlist ITEMCOLOR
  pd__MP'keypos ',KEYPOS
  pd__MP'keystyle ',KEYSTYLE
  pd__MP'keyfont ',KEYFONT
end.
pd__MP >yv
pd__MP'type line'
pd__MP'itemcolor black'
pd__MP'xrange ',":0,nbar
pd__MP'pensize ',":PENSIZE
bw=. BARWIDTH%nvar
if. even nvar do.
  ofs=. -:bw+1-nvar*bw
else.
  ofs=. 0.5-bw*-:nvar-1
end.
ofs=. ofs+bw*i.nvar
sxv=. ,|:(i.nbar)+/ ofs
syv=. (,>yv),.,(>yv)+>sv
pd__MP (|:2#citemize sxv);syv
cyv=. |:2#citemize,(>yv)+>sv
cxv=. (sxv-0.25*BARWIDTH%nvar),.(sxv+0.25*BARWIDTH%nvar)
pd__MP cxv;cyv
PLOT_NEW=: 0
wd 'pshow'
pd__MP'show'
)

histplot=: 3 : 0
msplot_default''
'xl dat'=. PLOT_PARAM
XLABEL=: dqlabel xl
if. PLOT_NEW do.
  if. 2<+/,>{.dat do. YCAPTION=: 'Number of Observations' else. YCAPTION=: 'Frequency' end.
  YNAMES=: MSvar
  nvar=. #YNAMES
  ITEMCOLOR=: nvar pchoose 'b'
  MARKERS=: nvar#<'none'
  LINESTYLE=: nvar#<'none'
  yall=. ,>dat
  ymin=. <./yall
  ymax=. >./yall
  if. -. 0<ymin do. NOLOGY=: 1 else. NOLOGY=: 0 end.
  'YMIN YMAX YMAJOR YMINOR'=: axisrange ymin,ymax
  NOLOGX=: 1
  EDGESIZE=: 0.5
  if. 1<#YNAMES do. 
    KEYSHOW=: 1
    KEYNAMES=: dqlabel YNAMES
  end.
end.
pd__MP'itemcolor ',colorlist ITEMCOLOR
pd__MP'xlabel ',XLABEL
if. 1=#YNAMES do.
  pd__MP'type hist'
else.
  pd__MP'type bar'
end.
pd__MP'ycaption ',YCAPTION
pd__MP'yrange ',":YMIN,YMAX
pd__MP'ytic ',": YMAJOR,YMINOR
pd__MP'barwidth ',":BARWIDTH
pd__MP'edgesize ',":EDGESIZE
pd__MP >dat
if. KEYSHOW do.
  pd__MP 'key ',KEYNAMES
  pd__MP 'keycolor ',colorlist ITEMCOLOR
  pd__MP 'keypos ',KEYPOS
  pd__MP 'keystyle ',KEYSTYLE
  pd__MP 'keyfont ',KEYFONT
end.
wd 'pshow'
PLOT_NEW=: 0
pd__MP'show'
pd__MP'show'
)

regplot=: 3 : 0
msplot_default''
'xl yl xv yv xt yt c'=. PLOT_PARAM
if. PLOT_NEW do.
  NOKEY=: 1
  XCAPTION=: xl
  YCAPTION=: yl
  pd__MP 'xcaption ',XCAPTION,'; ycaption ',YCAPTION
  xmin=. <./xv
  xmax=. >./xv
  ymin=. <./yv
  ymax=. >./yv
  if. -. 0<ymin do. NOLOGY=: 1 else. NOLOGY=: 0 end.
  if. -. 0<xmin do. NOLOGX=: 1 else. NOLOGX=: 0 end.
  'XMIN XMAX XMAJOR XMINOR'=: axisrange (<./xv),>./xv
  'YMIN YMAX YMAJOR YMINOR'=: axisrange (<./yv),>./yv
  YNAMES=: <yl
  LINESTYLE=: <'solid'
  MARKERS=: {.PMarker
  ITEMCOLOR=: {.PColor
  FRAMESTYLE=:'in'
end.
pd__MP'xrange ',":XMIN,XMAX
pd__MP'xtic ',":XMAJOR,XMINOR
pd__MP'yrange ',":YMIN,YMAX
pd__MP'ytic ',":YMAJOR,YMINOR
pd__MP 'markersize ',":MARKERSIZE
pd__MP'itemcolor ',colorlist ITEMCOLOR
pd__MP'xlog ',":LOGX
pd__MP'ylog ',":LOGY
if. -. (<'none')=MARKERS do.
  pd__MP 'type marker'
  pd__MP 'markers ',unchop MARKERS
  pd__MP xv;yv
end.
pd__MP 'type line'
pst=. _1+({.LINESTYLE) inx PLine
pd__MP'penstyle ',":pst
if. 0=pst do.
  pd__MP xt;yt
else.
  pd__MP (|:xt,.xt);|:yt,.yt
end.
PLOT_NEW=: 0
wd 'pshow'
pd__MP'show'
)

dotplot=: 3 : 0
msplot_default''
ydat=. PLOT_PARAM
if. PLOT_NEW do.
  NOKEY=: 1
  XNAMES=: dqlabel MSvar
  nvar=. #MSvar
  YNAMES=: MSvar
  gmin=. <./ openvec ydat
  gmax=. >./ openvec ydat
  if. ZeroOrigin do.
    gmin=. 0<.gmin
    gmax=. 0>.gmax
  end.
  if. -. 0<gmin do. NOLOGY=: 1 else. NOLOGY=: 0 end.
  'YMIN YMAX YMAJOR YMINOR'=: axisrange gmin,gmax
  NOLOGX=: 1
  KEYSHOW=: 0
  MARKERS=: {.PMarker
  ITEMCOLOR=: nvar#{.PColor
  LINESTYLE=: <'none'
end.
ns=. # qchop XNAMES
if. -.(#ITEMCOLOR )=ns do. ITEMCOLOR=: ns#ITEMCOLOR end. NB. fix for old dot plots
pd__MP 'qt'
pd__MP 'xrange 0 ',":2*ns
pd__MP 'xlabel ', XNAMES
pd__MP 'ytic ',":YMAJOR,YMINOR
pd__MP 'yrange ',":YMIN,YMAX
pd__MP 'xticpos ',":1+2*i.ns
pd__MP 'markersize ',":MARKERSIZE
pd__MP 'xcaption ',XCAPTION
pd__MP 'ycaption ',YCAPTION
if. -. (<'none')={.MARKERS do.
NB.  'w h'=. _2{. Gxywh__MP
  'w h'=. PLOTWH__MP
  ssz=. 2+MARKERSIZE*(({.MARKERS) inx PMarker){7 9 7 7 8 7 7 7 9 7 7
  nbin=. <.h%ssz
  swd=. (3+MARKERSIZE*(({.MARKERS) inx PMarker){7 9 7 9 8 7 7 7 9 7 9)%w
  s=. (YMAX-YMIN)%nbin
  b=. ,(YMIN+s)+/(,s*/i.nbin)
  d=. (b&bindata) each ydat
  pd__MP 'type marker'
  pd__MP 'markers ',>{.MARKERS
  for_i. i.ns do.
    yc=. ,>i{d
    yv=. yc#b
    yv=. ,yv-/-:s
    xv=. (i;swd*2*ns) spreadx2 yc
    pd__MP 'itemcolor ', > i{ ITEMCOLOR
    pd__MP xv;yv
  end.
end.
if. Quart__ do.
NB.  'gx gy gw gh'=. Gxywh__MP
  'gw gh'=. PLOTWH__MP
  q=.qtile each ydat
  xval=. 0.5+2*i.ns
  bw=. (2*ns%gw)*10
  for_v. q,.bxv2 xval do.
    'yv xv'=. v
    pd__MP'type line'
    pd__MP'itemcolor ',>{.ITEMCOLOR
    pd__MP'pensize 1'
    pd__MP (3#xv);yv
    pd__MP (3#xv+bw);yv
    pd__MP (3#citemize xv,xv+bw);yv,.yv
    ITEMCOLOR=: 1 |. ITEMCOLOR
  end.
end.
PLOT_NEW=: 0
wd 'pshow'
pd__MP'show'
)

powplot=: 3 : 0
msplot_default''
'names xdat ydat XCAPTION YCAPTION Title'=. PLOT_PARAM
'TITLE SUBTITLE'=. chop Title
if. PLOT_NEW do.
  NOLOGX=: NOLOGY=: 1
  'XMIN XMAX XMAJOR XMINOR'=: axisrange (<./,xdat),(>./,xdat)
  'YMIN YMAX YMAJOR YMINOR'=: axisrange 0,(>./,ydat)
  YNAMES=: chop ,names
  nvar=. #YNAMES
  ITEMCOLOR=: nvar pchoose 'c'
  LINESTYLE=: nvar#<'solid'
  MARKERS=: nvar#<'none'
  if. 1<#YNAMES do.
    KEYSHOW=: 1
    KEYNAMES=: dqlabel YNAMES
    KEYSTYLE=: 'lbvt'
  end.
end.
pd__MP 'type line'
pd__MP'xcaption ',XCAPTION
pd__MP'ycaption ',YCAPTION
pd__MP'title ',TITLE
pd__MP'subtitle ',SUBTITLE
pd__MP'xrange ',":XMIN,XMAX
pd__MP'yrange ',":YMIN,YMAX
pd__MP'xtic ',":XMAJOR,XMINOR
pd__MP'ytic ',":YMAJOR,YMINOR
if. KEYSHOW do.
  pd__MP'key ',KEYNAMES
  pd__MP'keymarkers ',unchop (#YNAMES)#<'square'
  pd__MP'keycolor ',colorlist ITEMCOLOR
  pd__MP'keystyle ',KEYSTYLE
  pd__MP'keypos ',KEYPOS
  pd__MP'keyfont ',KEYFONT
end.
for_yl. ydat do.
  if. -.(<'none')={.LINESTYLE do. 
    pd__MP 'itemcolor ',>{.ITEMCOLOR
    pst=. _1+({.LINESTYLE) inx PLine
    if. pst>0 do. pst=. 2 end.
    pd__MP 'penstyle ',":pst
    if. 0=pst do.
      pd__MP xdat;yl
    else.
      pd__MP (|:xdat,.xdat);|:yl,.yl
    end.
  end.
  ITEMCOLOR=: 1 |. ITEMCOLOR
  LINESTYLE=: 1 |. LINESTYLE
end.
PLOT_NEW=: 0
wd 'pshow'
pd__MP'show'
)

bpvplot=: 3 : 0
msplot_default''
'names xdat ydat pv XCAPTION YCAPTION TITLE'=. PLOT_PARAM
ydat=. pv#ydat
if. PLOT_NEW do.
  NOLOGX=: NOLOGY=: 1
  'XMIN XMAX XMAJOR XMINOR'=: axisrange (<./,xdat),(>./,xdat)
  'YMIN YMAX YMAJOR YMINOR'=: axisrange (<./,ydat),(>./,ydat)
  YNAMES=: pv#chop ,names
  nvar=. #YNAMES
NB.  ITEMCOLOR=: nvar pchoose 'c'
  ITEMCOLOR=: pv#'DarkGreen';'DarkRed'
  LINESTYLE=: nvar#<'solid'
  MARKERS=: nvar#<'none'
  KEYSHOW=: 1
  KEYNAMES=: dqlabel YNAMES
  KEYSTYLE=: 'lbvt'
end.
pd__MP 'type line'
pd__MP'xcaption ',XCAPTION
pd__MP'ycaption ',YCAPTION
pd__MP'title ',TITLE
pd__MP'xrange ',":XMIN,XMAX
pd__MP'yrange ',":YMIN,YMAX
pd__MP'xtic ',":XMAJOR,XMINOR
pd__MP'ytic ',":YMAJOR,YMINOR
if. KEYSHOW do.
  pd__MP'key ',KEYNAMES
  pd__MP'keymarkers ',unchop (#YNAMES)#<'square'
  pd__MP'keycolor ',colorlist ITEMCOLOR
  pd__MP'keystyle ',KEYSTYLE
  pd__MP'keypos ',KEYPOS
  pd__MP'keyfont ',KEYFONT
end.
for_yl. ydat do.
  if. -.(<'none')={.LINESTYLE do. 
    pd__MP 'itemcolor ',>{.ITEMCOLOR
    pst=. _1+({.LINESTYLE) inx PLine
    if. pst>0 do. pst=. 2 end.
    pd__MP 'penstyle ',":pst
    if. 0=pst do.
      pd__MP xdat;yl
    else.
      pd__MP (|:xdat,.xdat);|:yl,.yl
    end.
  end.
  ITEMCOLOR=: 1 |. ITEMCOLOR
  LINESTYLE=: 1 |. LINESTYLE
end.
PLOT_NEW=: 0
wd 'pshow'
pd__MP'show'
)

xyplot=: 3 : 0
msplot_default''
if. 1<$$PLOT_PARAM do. 
  PLOT_PARAM=: LOGX;LOGY;0;0;(({.$PLOT_PARAM)#0);<PLOT_PARAM 
  LOGY2=: NOLOGY2=: Y2MIN=: Y2MAX=: Y2MAJOR=: Y2MINOR=: Y2CAPTION=: ''
end.
'logx logy PlotBW XYSD AXES PLOTDAT'=: PLOT_PARAM
if. 0=+/AXES do. Y2=: 0 else. Y2=: 1 end.
AXISL=: -. AXES
AXISR=: AXES
if. PLOT_NEW do.
  LOGX=: logx
  LOGY=: logy
  LOGY2=: LOGY
  if. (<PLOT_TYPE) e. 'xys';'xysl' do. Vname=. TPvar else. Vname=. PSvar end.
  xall=. openvec 0{"1 PLOTDAT
  XCAPTION=: >{.,>Vname
  xmin=. <./xall
  xmax=. >./xall
  if. -. 0<xmin do. 
    LOGX=: 0
    NOLOGX=: 1
  end.
  'XMIN XMAX XMAJOR XMINOR'=: LOGX axisrange xmin,xmax
  YNAMES=: 1{"1 >Vname
  nvar=. #YNAMES
  ITEMCOLOR=: nvar pchoose 'c'
  if. (<PLOT_TYPE) e. 'xyl';'xylm';'xysl' do. LINESTYLE=: nvar#<'solid' else. LINESTYLE=: nvar#<'none' end.
  if. (<PLOT_TYPE)= <'xyl' do. MARKERS=: nvar#<'none' else. MARKERS=: nvar pchoose 'm' end.
  yall=. openvec 1{"1 AXISL#PLOTDAT
  YCAPTION=: >1{,>AXISL#Vname
  if. (<PLOT_TYPE) e. 'xys';'xysl' do. sall=. openvec 2{"1 AXISL#PLOTDAT end.
  if. (<PLOT_TYPE) e. 'xys';'xysl' do.
    select. SDTYPE
      case. 'u' do.
        ymin=. <./yall
        ymax=. >./yall+sall
      case. 'l' do.
        ymin=. <./yall-sall
        ymax=. >./yall
      case. 'b' do.
        ymin=. <./yall-sall
        ymax=. >./yall+sall
    end.
  else.
    ymin=. <./yall
    ymax=. >./yall
  end.
  if. -. 0<ymin do. 
    LOGY=: 0
    NOLOGY=: 1
  end.
  'YMIN YMAX YMAJOR YMINOR'=: LOGY axisrange ymin,ymax
  if. Y2 do.
    yall=. openvec 1{"1 AXISR#PLOTDAT
    Y2CAPTION=: >1{,>AXISR#Vname
    if. (<PLOT_TYPE) e. 'xys';'xysl' do. sall=. openvec 2{"1 AXISR#PLOTDAT end.
    if. (<PLOT_TYPE) e. 'xys';'xysl' do.
      select. SDTYPE
        case. 'u' do.
          ymin=. <./yall
          ymax=. >./yall+sall
        case. 'l' do.
          ymin=. <./yall-sall
          ymax=. >./yall
        case. 'b' do.
          ymin=. <./yall-sall
          ymax=. >./yall+sall
        end.
    else.
      ymin=. <./yall
      ymax=. >./yall
    end.
    if. -. 0<ymin do. 
      LOGY2=: 0
      NOLOGY2=: 1
    end.
    'Y2MIN Y2MAX Y2MAJOR Y2MINOR'=: LOGY2 axisrange ymin,ymax
  end.
end.
if. KEYSHOW do.
  pd__MP'key ',KEYNAMES
  pd__MP'keycolor ',colorlist ITEMCOLOR
  pd__MP'keystyle ',KEYSTYLE
  kmk=. (<'square') (inxb (<'none')=MARKERS)}MARKERS
  pd__MP'keymarkers ',unchop kmk
  pd__MP'keypos ',KEYPOS
  pd__MP'keyfont ',KEYFONT
end.
pd__MP'xcaption ',XCAPTION
pd__MP'xrange ',": XMIN,XMAX
pd__MP'xtic ', ": XMAJOR,XMINOR
pd__MP'markersize ',":MARKERSIZE
pd__MP'xlog ',":LOGX
pd__MP'ycaption ',YCAPTION
pd__MP'yrange ',":YMIN,YMAX
pd__MP'ytic ',": YMAJOR,YMINOR
pd__MP'ylog ',":LOGY
for_p. AXISL#PLOTDAT do.
  if. (<PLOT_TYPE) e. 'xys';'xysl' do. 'xdat ydat sdat'=. p else. 'xdat ydat'=. p end.
  pd__MP 'itemcolor ',>{.ITEMCOLOR
  if. -. (<'none')={.MARKERS do.
    pd__MP 'type marker'
    pd__MP 'markers ',>{.MARKERS
    pd__MP xdat;ydat
  end.
  if. (<PLOT_TYPE) e. 'xys';'xysl' do.
    pd__MP 'type errorbar'
    select. SDTYPE 
      case. 'u' do. pd__MP xdat;(ydat+sdat),:ydat
      case. 'l' do. pd__MP xdat;ydat,:(ydat-sdat)
      case. 'b' do. pd__MP xdat;(ydat+sdat),:(ydat-sdat)
    end.
  end.
  if. -. (<'none')={.LINESTYLE do.
    xv=. sortup ~. xdat
    xind=. xv=/xdat
    yl=.''
    for_xi. xind do.
      yl=.yl,mean xi#ydat
    end.
    pd__MP 'type line'
    pst=. _1+({.LINESTYLE) inx PLine
    pd__MP 'penstyle ',":pst
    if. 0=pst do. 
      pd__MP xv;yl
    else.
      pd__MP (|:xv,.xv);|:yl,.yl
    end.
  end.
  MARKERS=: 1 |. MARKERS
  ITEMCOLOR=: 1 |. ITEMCOLOR
  LINESTYLE=: 1 |. LINESTYLE
end.
if. Y2 do.
  pd__MP'y2axis'
  pd__MP'ycaption ',Y2CAPTION
  pd__MP'yrange ',":Y2MIN,Y2MAX
  pd__MP'ytic ',": Y2MAJOR,Y2MINOR
  pd__MP'ylog ',":LOGY2
  for_p. AXISR#PLOTDAT do.
    if. (<PLOT_TYPE) e. 'xys';'xysl' do. 'xdat ydat sdat'=. p else. 'xdat ydat'=. p end.
    pd__MP 'itemcolor ',>{.ITEMCOLOR
    if. -. (<'none')={.MARKERS do.
      pd__MP 'type marker'
      pd__MP 'markers ',>{.MARKERS
      pd__MP xdat;ydat
    end.
    if. (<PLOT_TYPE) e. 'xys';'xysl' do.
      pd__MP 'type errorbar'
      select. SDTYPE 
        case. 'u' do. pd__MP xdat;(ydat+sdat),:ydat
        case. 'l' do. pd__MP xdat;ydat,:(ydat-sdat)
        case. 'b' do. pd__MP xdat;(ydat+sdat),:(ydat-sdat)
      end.
    end.
    if. -. (<'none')={.LINESTYLE do.
      xv=. sortup ~. xdat
      xind=. xv=/xdat
      yl=.''
      for_xi. xind do.
        yl=.yl,mean xi#ydat
      end.
      pd__MP 'type line'
      pst=. _1+({.LINESTYLE) inx PLine
      pd__MP 'penstyle ',":pst
      if. 0=pst do. 
        pd__MP xv;yl
      else.
        pd__MP (|:xv,.xv);|:yl,.yl
      end.
    end.
    MARKERS=: 1 |. MARKERS
    ITEMCOLOR=: 1 |. ITEMCOLOR
    LINESTYLE=: 1 |. LINESTYLE
  end.
end.
PLOT_NEW=: 0
wd 'pshow'
pd__MP'show'
)

xybplot=: 3 : 0
msplot_default''
'type ci'=. 2{.PLOT_PARAM
dat=. 2}.PLOT_PARAM
if. PLOT_NEW do.
  xall=. ,0{"1 >dat
  yall=. ,1 2 3{"1 >dat
  Vname=. PSvar
  'XCAPTION YCAPTION'=. 2{.,>Vname
  if. 0=type do.
    YCAPTION=. YCAPTION,' (Quartiles)'
  else.
    YCAPTION=. YCAPTION,' (',(":ci),'% CI)'
  end.
  xmin=. <./xall
  xmax=. >./xall
  if. -. 0<xmin do. 
    LOGX=: 0
    NOLOGX=: 1
  end.
  'XMIN XMAX XMAJOR XMINOR'=: LOGX axisrange xmin,xmax
    ymin=. <./yall
    ymax=. >./yall
  if. -. 0<ymin do. 
    LOGY=: 0
    NOLOGY=: 1
  end.
  'YMIN YMAX YMAJOR YMINOR'=: LOGY axisrange ymin,ymax
  YNAMES=: 1{"1 >Vname
  nvar=. #YNAMES
  ITEMCOLOR=: nvar pchoose 'c'
  LINESTYLE=: nvar#<'solid'
  MARKERS=: nvar pchoose 'm'
end.
pd__MP'xcaption ',XCAPTION,'; ycaption ',YCAPTION
pd__MP'xrange ',": XMIN,XMAX
pd__MP'xtic ', ": XMAJOR,XMINOR
pd__MP'yrange ',":YMIN,YMAX
pd__MP'ytic ',": YMAJOR,YMINOR
pd__MP'markersize ',":MARKERSIZE
pd__MP'xlog ',":LOGX
pd__MP'ylog ',":LOGY
if. KEYSHOW do.
  pd__MP'key ',KEYNAMES
  pd__MP'keycolor ',colorlist ITEMCOLOR
  pd__MP'keystyle ',KEYSTYLE
  kmk=. (<'square') (inxb (<'none')=MARKERS)}MARKERS
  pd__MP'keymarkers ',unchop kmk
  pd__MP'keypos ',KEYPOS
  pd__MP'keyfont ',KEYFONT
end.
itemcolor0=. ITEMCOLOR
for_p. dat do.
  pdat=. >p
  xdat=. 0{"1 pdat
  yl=. 1{"1 pdat
  yh=. 3{"1 pdat
  icolor=. {.ITEMCOLOR
  bcolor=. (icolor inx PColor) {PColorB
  pd__MP 'type poly'
  pd__MP 'itemcolor ',,>bcolor
  pd__MP 'edgecolor ',,>bcolor
  xv=. xdat,(|.xdat)
  yv=. yl,(|.yh)
  pd__MP xv;yv
  ITEMCOLOR=: 1 |. ITEMCOLOR
end.
for_p. dat do.
  pdat=. >p
  xdat=. 0{"1 pdat
  ydat=. 2{"1 pdat
  pd__MP 'itemcolor ',>{.ITEMCOLOR
  if. -. (<'none')={.LINESTYLE do.
    pd__MP 'type line'
    pst=. _1+({.LINESTYLE) inx PLine
    pd__MP 'penstyle ',":pst
    if. 0=pst do.
      pd__MP xdat;ydat
    else.
      pd__MP (|:xdat,.xdat);|:ydat,.ydat
    end.
  end.
  if. -. (<'none')={.MARKERS do.
    pd__MP 'penstyle 0'
    pd__MP 'type marker'
    pd__MP 'markers ',>{.MARKERS
    pd__MP xdat;ydat
  end.
  ITEMCOLOR=: 1 |. ITEMCOLOR
  MARKERS=: 1 |. MARKERS
  LINESTYLE=: 1 |. LINESTYLE
end.
PLOT_NEW=: 0
wd'pshow'
pd__MP'show'



)

kmplot=: 3 : 0
msplot_default''
xydat=. >PLOT_PARAM
xall=. openvec 0{"1 xydat
yall=. openvec 1{"1 xydat
if. KINV_pairsmp_ do. yall=. 1-yall end.
if. PLOT_NEW do.
  XCAPTION=: 'Time'
  if. KINV_pairsmp_ do. YCAPTION=:'Cum. death rate' else. YCAPTION=: 'Survival' end.
  YNAMES=: {."1 >PSvar
  nvar=. #YNAMES
  xmax=. >./xall
  ymin=. <./yall
  'XMIN XMAX XMAJOR XMINOR'=: axisrange 0,xmax
  'YMIN YMAX YMAJOR YMINOR'=: axisrange ymin,1.0
  LINESTYLE=: nvar#<'solid'
  ITEMCOLOR=: nvar pchoose 'c'
  MARKERS=: nvar#<'vbar'
  if. 1<#YNAMES do.
    KEYSHOW=: 1
    KEYNAMES=: dqlabel YNAMES
    KEYSTYLE=:'lbvt'
  end.
  FRAMESTYLE=: 'in'
end.    
pd__MP'xcaption ',XCAPTION
pd__MP'ycaption ',YCAPTION
pd__MP'xrange ',":XMIN,XMAX
pd__MP'yrange ',":YMIN,YMAX
pd__MP'xtic ',":XMAJOR,XMINOR
pd__MP'ytic ',":YMAJOR,YMINOR
if. KEYSHOW do.
  pd__MP'key ',KEYNAMES
  pd__MP'keycolor ',colorlist ITEMCOLOR
  pd__MP'keystyle ',KEYSTYLE
  pd__MP'keypos ',KEYPOS
  pd__MP'keypos ',KEYPOS
  pd__MP'keyfont ',KEYFONT
  pd__MP'keymarkers ',unchop MARKERS
end.
for_s. xydat do.
  'xv yv xc yc'=. s
  if. KINV_pairsmp_ do.
    yv=. 1-yv
    yc=. 1-yc
  end.
  pd__MP'type line'
  pd__MP'itemcolor ',>{.ITEMCOLOR
  pst=. _1+({.LINESTYLE) inx PLine
  pd__MP'penstyle ',":pst
  if. 0=pst do. pd__MP xv;yv else. pd__MP (|:xv,.xv);|:yv,.yv end.
  if. 0<#xc do.
    pd__MP'type marker'
    pd__MP 'markers ',>{.MARKERS
    pd__MP xc;yc
  end.
  ITEMCOLOR=: 1 |. ITEMCOLOR
  LINESTYLE=: 1 |. LINESTYLE
  MARKERS=: 1 |. MARKERS
end.
PLOT_NEW=: 0
wd 'pshow;pshow'
pd__MP'show'
)

pchoose=: 4 : 0
select. y 
  case. 'c' do. 
    if. PlotBW do. par=. PColorBW else. par=. }:PColor end.
  case. 'b' do. 
    if. PlotBW do. par=. PColorBWB else. par=. PColor end.
  case. 'm' do. par=. }:PMarker
  case. 'l' do. par=. }.PLine
end.
x{.,> (>.x%#par)#<par
)

axisrange=: 3 : 0
0 axisrange y
:
'min max'=. y
axlog=. x
if. max=min do. min=. pow10 <. log10 min end. NB. may happen with sbar, area
wid=. max - min
t=. 0.5 1 2 5 10 20 * pow10 <: <. log10 wid
NB. ndx =. +/ 9 <wid%t  Change for behavior consistent with jzplot
ndx=. +/ 5 <wid%t
stp=. ndx{t
stpm=. ndx{ 4 4 3 4 4 3
maxr=. stp rndup max
minr=. stp rnddn min
if. axlog *. 0=minr do. minr=. 10 ^ <. 10 ^. min end.
minr,maxr,stp,stpm
)

spreadx2=: 4 : 0
xs=. ''
'i wid'=. x
or=. 1+2*i
xv=. ;/y
xm=. (0.5&*) each (_1&+) each xv
xi=. ?~ each xv
xd=. (openvec xi)-(>xv)#>xm
,or+wid*/xd
)

bxv2=: 3 : 0
if. 1=#y do. r=. <y else. r=. ;/y end.
)

spreadx=: 3 : 0
:
n=. #y
xs=. ''
for_i. i. n do.
  or=. 1+2*i
  xv=. ". each chop ": >i{y
  xm=. (0.5&*) each (_1&+) each xv
  xi=. ?~ each xv
  xd=. (openvec xi)-(>xv)#>xm
  xs=. xs,,or+x*/xd
end.
)

msplot_default=: 3 : 0
pd__MP 'reset'
if. FRAME do. pd__MP 'frame 1; axes 0 0' else. pd__MP'frame 0; axes 1 1' end.
pd__MP 'orientation 2'
pd__MP 'fontscale 1'
EPS_PENSCALE__MP=: 1
PDF_PENSCALE__MP=: 1
pd__MP 'edgecolor BLACK; backcolor WHITE; forecolor BLACK; textcolor BLACK'
pd__MP 'labelfont ', LABELFONT
pd__MP 'captionfont ', CAPTIONFONT
pd__MP 'textfont ', CAPTIONFONT
pd__MP 'titlefont ', TITLEFONT
pd__MP 'subtitlefont ',SUBTITLEFONT
pd__MP 'keyfont ',KEYFONT
pd__MP 'symbolfont ',LABELFONT
pd__MP 'grids ',":GRIDS
pd__MP 'ticstyle ',TICSTYLE
pd__MP 'framestyle ',FRAMESTYLE
pd__MP 'itemcolor black'
pd__MP 'guidesize ',":GUIDESIZE
pd__MP 'ticmajor ',":TICMAJOR
pd__MP 'ticminor ',":TICMINOR
pd__MP 'pensize ',":PENSIZE
pd__MP 'markersize ',":MARKERSIZE
pd__MP 'xcaption ',XCAPTION,'; ycaption ',YCAPTION,'; title ',TITLE
)

print_plot=: 3 : 0
TMPCOUNT__=: TMPCOUNT__+1
fn=. Tempdir__,'ms6tmp',(":TMPCOUNT__),'.pdf'
'x y w h'=. ".wd 'psel ',(":PFormhwnd__MP),';qchildxywh mp'
pd__MP 'pdf "',fn,'" ',": 0.75*w,h
select. UNAME
  case. 'Win' do.
    if. -. (6{.PDFVIEWER)-:'rundll' do. fn=. dquots fn end. 
      fork PDFVIEWER__,fn
  case. 'Darwin' do.
    2!:1 PDFVIEWER__,(dquots fn),'&'
  case. 'Linux' do.
    2!:1 PDFVIEWER__,(dquots fn),'&'
end.
)

save_plot=: 3 : 0
Fn=. wd 'mb save "Save plot" "',Dpath__,'" "Graph files (*.ijg)|All files (*.*)"'
if. 0=#Fn do.
  return.
end.
fullpath=. pathname Fn
path=. >0{fullpath
Dpath__=: path
gfn=. >1{fullpath
if. -. '.' e. gfn do. gfn=. gfn,'.ijg' end.
Fn=. path,gfn
PSIZE=: wd 'psel ',(":PFormhwnd__MP),';qform'
dout=. 'NB. ijg file',LF
ls=. >(] , '=:' "_) each PLOTVN
rs=. 5!:5 PLOTVN
dout=. dout,deb vfm ls,.rs
dout fwrites Fn
PLOTDIRTY=: 0
)

open_plot=: 3 : 0
scriptn PLOT_PARAM
NB.if. 0<#PSIZE do. wd 'pmove ',PSIZE end.
PLOTDIRTY=: 0
wd'set mp wh ',":PLOTWH__PO
setplot''
)

saveas_plot=: 3 : 0
Fn=. mbsave '"Save plot as pdf or eps (specify by extension)" "',Dpath__,'" "All files (*.*)|*.*"'
if. 0=#Fn do.
   return.
end.
fullpath=. pathname Fn
path=. >0{fullpath
Dpath__=: path
gfn=. >1{fullpath
ext=. <_4{. tolower gfn
select. ext
  case. '.pdf' do.
    ft=. 'p'
  case. '.eps' do.
    ft=. 'e'
  case. do.
    res=. mbQuery'File type not specified';'Save as pdf?'
    if. res-:'no' do.
      gfn=. gfn,'.eps'
      ft=. 'e'
    else.
      gfn=. gfn,'.pdf'
      ft=. 'p'
    end.
end.
Fn=.path,gfn
'x y w h'=. ".wd 'psel ',(":PFormhwnd__MP),';qchildxywh mp'
select. ft
  case. 'p' do.
    pd__MP 'pdf "',Fn,'" ',": 0.75*w,h
  case. 'e' do.
    pd__MP 'eps "',Fn,'" ',": 0.75*w,h
end.
mbInfo 'File saved';'File written: ',Fn
)



NB. required functions

citemize=: ,:^:(2: > #@$)
cexpand=: #^:(> #)
getfontsz=: {.@:(#~ ~:&_1)@:(_1&".&>)@;:


pow10=: 10&^

log10=: 10&^.

rnddn=: [ * [: <. %~
rndup=: [ * [: >. %~

sortup=: /:~

bindata=: 3 : 0
NB. bins data (y) according to
NB.   closed interval upper bounds (x)
:
n=.#x
ix=.(n-1)<.+/"1 y >/ x
dst=.(i.n)=/ix
if. 1<#y do.
  +/"1 dst
end.
)

colorlist=: 3 : 0
}: unchop (,&',') each y
)

openvec=: 3 : 0
n=. # y
res=. ''
for_i. i. n do.
   res=.res,>i{y
end.
)

dqlabel=: 3 : 0
NB. for y boxed array of strings,
NB. return string with each boxed element
NB. double quoted and separated by spaces
q=. dquot each y
(LF,' ') charsub vfm >q
)

dquot=: 3 : 0
NB. place double quotes around string y
'"',y,'"'
)

ft=: 3 : 0
NB. Formats numerical value to SIGFIG
SIGFIG__ ft y
:
if. isnum ,y do.
  '_-' charsub ":!.x y
else.
  y
end.
)

inx=: e.~&, # i.@#@]

isnum=: 3 : 0
NB. Tests if y is a finite number
(-. __ e. y) *. isnumeric y
)

mean=: 3 : 0
NB. Computes the mean of a vector, y
   (+/y)%#y
)

mbfont=: 3 : 0
if. #y do.
y=. boxfont y
y=. ({.y), tolower each }.y
y=. y -. 'ansi';'oem';'default'
y=. }: ; ,&' ' &.> y
end.
wd 'mbfont ',y
)

boxfont=: 3 : 0
font=. ' ',y
b=. (font=' ') > ~:/\font='"'
a: -.~ b <;._1 font
)

qchop=: 3 : 0
NB. preserves double quoted strings while chopping
NB. double quotes removed from output
q=. qt y
s=. ' '=y
qs=. q*.s
y=. EAV (inxb qs)}y
deb each unquot each ((EAV,' ')&charsub) each chop y
)

NB. qt mark quoted substrings in string
qt=: 2:+./\0:,2:|+/\@(=&'"')

NB. inxb return indices for true values
inxb=: <:@(+/\) i. i.@(+/)

unquot=: 3 : 0
NB. remove double quotes
'" ' charsub y
)

qtile=: 3 : 0
ny=.#y
yv=.sort y
t=.}.((ny-1)%4)*i.4
0.5*((<.t){yv)+(>.t){yv
)

sdif=: 3 : 0
n=. # y
({.y),}:(1|.y)-y
)


NB. mplot-redef.ijs
NB. modifications to jzplot

NB. changes to jzplot
coclass'mplot'

MarkerNames_jzplot_=: ;: 'diamond square circle triangle plus times vbar opencircle opendiamond opensquare opentriangle'

KeyMarkerNames_jzplot_=: MarkerNames_jzplot_,<'line'

qtmark_opencircle_jzplot_=: 4 : 0
s=. rndint x * 3
p=. (y - s) ,"1 >: +: s,s
qt_gpbuf , qt_gpbrushnull''
qt_gpbuf ,qt_gpcount 2008 ,"1 p
)

qtmark_opendiamond_jzplot_=: 4 : 0
s=. rndint x * 4
'x y'=. |: y
p=. (x-s),.y,.x,.(y+s),.(x+s),.y,.x,.y-s
qt_gpbuf , qt_gpbrushnull''
qt_gpbuf ,qt_gpcount 2029 ,"1 p
)

qtmark_opensquare_jzplot_=: 4 : 0
s=. rndint x * 3
p=. (y - s) ,"1 +: s,s
qt_gpbuf , qt_gpbrushnull''
qt_gpbuf ,qt_gpcount 2031 ,"1 p
)

qtmark_opentriangle_jzplot_=: 4 : 0
s=. rndint 2 * x
t=. rndint 4 * x
'x y'=. |: y
p=. rndint (x-t),.(y+s),.(x+t),.(y+s),.x,.y-t
qt_gpbuf , qt_gpbrushnull''
qt_gpbuf ,qt_gpcount 2029 ,"1 p
)

qtmark_vbar_jzplot_=: 4 : 0
s=. rndint 4 0.5 * x
NB.s=. rndint 4 1 * x
NB.p=. (y -"1 s) ,"1 +: s
s=. |. s
NB.p=. p , (y -"1 s) ,"1 +: s
p=.  (y -"1 s) ,"1 +: s
qt_gpbuf ,qt_gpcount 2031 ,"1 p
)

qtmark_plus_jzplot_=: 4 : 0
s=. rndint 4 0.5 * x
p=. (y -"1 s) ,"1 +: s
s=. |. s
p=. p , (y -"1 s) ,"1 +: s
qt_gpbuf ,qt_gpcount 2031 ,"1 p
)

qtmark_times_jzplot_=: 4 : 0
if. x = 1 do.
  p=. (y - 3) ,. y + 4
  q=. (y - "1 [ 3 _3) ,. y +"1 [ 4 _4
  p=. p, (p +"1 [ 0 1 _1 0), p + "1 [ 1 0 0 _1
  q=. q, (q +"1 [ 0 _1 _1 0), q +"1 [ 1 0 0 1
  qt_gpbuf ,qt_gpcount 2015 ,"1 p,q
  
else.
  s=. rndint _1 + 3 * x
NB.  n=. rndint 2 * x
  n=. rndint  x
  p=. (y - s) ,. y + s
  q=. (y - "1 s * 1 _1) ,. y +"1 s * 1 _1
  qt_gpbuf 4 2022,n,0
  qt_gpbuf ,qt_gpcount 2015 ,"1 p,q
end.
)

epsmark_vbar_jzplot_=: 3 : 0
's m f e c p'=. y
s=. s * 6
t=. s, 0
NB.pbuf e eps_pen s
pbuf e eps_pen 1.5
p=. citemize p
NB.d=. (p -"1 t) ,. p +"1 t
t=. |. t
NB.d=. d, (p -"1 t) ,. p +"1 t
d=.  (p -"1 t) ,. p +"1 t
pbuf eps_lines d
)

epsmark_circle_jzplot_=: 3 : 0
's m f e c p'=. y
p=. citemize p
NB. v=. 8 * s * EPS_PENSCALE
v=. 5 * s
pbuf eps_color e
pbuf (pfmt {.p), ' moveto'
pbuf (pfmt p,.v) ,"1 ' 0 360 arc fill'
)

epsmark_opencircle_jzplot_=: 3 : 0
's m f e c p'=. y
p=. citemize p
NB. v=. 8 * s * EPS_PENSCALE
v=. 5 * s
pbuf eps_color e
pbuf (pfmt {.p), ' moveto'
pbuf (pfmt p,.v) ,"1 ' 0 360 arc stroke'
)

epsmark_diamond_jzplot_=: 3 : 0
's m f e c p'=. y
e=. eps_color e
p=. 8 $"1 citemize p
d=. (5 * s) * _1 0 0 1 1 0 0 _1
p=. p +"1 d
for_i. i.#p do.
  pbuf eps_makelines i{p
  pbuf e,' fill'
end.
)

epsmark_opendiamond_jzplot_=: 3 : 0
's m f e c p'=. y
e=. eps_color e
p=. 8 $"1 citemize p
d=. (5 * s) * _1 0 0 1 1 0 0 _1
p=. p +"1 d
for_i. i.#p do.
  pbuf eps_makelines i{p
  pbuf ' closepath'
  pbuf e,' stroke'
end.
)

epsmark_square_jzplot_=: 3 : 0
's m f e c p'=. y
e=. eps_color e
p=. citemize p
s=. 4.5 * s
p=. (p - s) ,"1 p + s
for_i. i.#p do.
  pbuf eps_makerect i{p
  pbuf e,' fill'
end.
)

epsmark_opensquare_jzplot_=: 3 : 0
's m f e c p'=. y
e=. eps_color e
p=. citemize p
s=. 4.5 * s
p=. (p - s) ,"1 p + s
for_i. i.#p do.
  pbuf eps_makerect i{p
  pbuf e,' stroke'
end.
)

epsmark_triangle_jzplot_=: 3 : 0
's m f e c p'=. y
e=. eps_color e
p=. 6 $"1 citemize p
d=. (5.8 * s) * , (sin,.cos) 2p1 * 0 1 2 % 3
p=. p +"1 d
for_i. i.#p do.
  pbuf eps_makelines i{p
  pbuf e,' fill'
end.
)

epsmark_opentriangle_jzplot_=: 3 : 0
's m f e c p'=. y
e=. eps_color e
p=. 6 $"1 citemize p
d=. (5.8 * s) * , (sin,.cos) 2p1 * 0 1 2 % 3
p=. p +"1 d
for_i. i.#p do.
  pbuf eps_makelines i{p
  pbuf ' closepath'
  pbuf e,' stroke'
end.
)

epsmark_plus_jzplot_=: 3 : 0
's m f e c p'=. y
s=. s * 6
t=. s, 0
NB.pbuf e eps_pen s
pbuf e eps_pen 1.5
p=. citemize p
d=. (p -"1 t) ,. p +"1 t
t=. |. t
d=. d, (p -"1 t) ,. p +"1 t
pbuf eps_lines d
)

epsmark_times_jzplot_=: 3 : 0
's m f e c p'=. y
NB.pbuf e eps_pen 4 * s
pbuf e eps_pen 1.5
t=. _1 + s * 7
r=. (p - t) ,. p + t
s=. (p +"1 t * 1 _1) ,. p +"1 t * _1 1
pbuf eps_lines r,s
)

pdfmark_vbar_jzplot_=: 4 : 0
s=. 0, x * 6
t=. |. s
NB.p=. (y -"1 t) ,. y +"1 t
NB.p=. p, (y -"1 s) ,. y +"1 s
p=.  (y -"1 s) ,. y +"1 s
NB.pbuf (":PDF_PENSCALE * 5 * x) , ' w '
pbuf (":PDF_PENSCALE * 1.5) , ' w '
pbuf (pdf_makelines p) ,"1 ' b'
)

pdfmark_circle_jzplot_=: 4 : 0
s=. 5 * x
p=. y ,. s
for_d. p do.
  pos=. pdf_circle d
  pbuf (pfmt 2 {. {. pos) , ' m '
  pbuf (pfmt 2 }."1 pos) ,"1 ' c '
  pbuf 'B'
end.
)

pdfmark_opencircle_jzplot_=: 4 : 0
s=. 5 * x
p=. y ,. s
for_d. p do.
  pos=. pdf_circle d
  pbuf (pfmt 2 {. {. pos) , ' m '
  pbuf (pfmt 2 }."1 pos) ,"1 ' c '
  pbuf 'S'
end.
)

pdfmark_diamond_jzplot_=: 4 : 0
p=. 8 $"1 y
d=. (5 * x) * _1 0 0 1 1 0 0 _1
p=. p +"1 d
pbuf (pdf_makelines p) ,"1 ' b'
)

pdfmark_opendiamond_jzplot_=: 4 : 0
p=. 8 $"1 y
d=. (5 * x) * _1 0 0 1 1 0 0 _1
p=. p +"1 d
pbuf (pdf_makelines p) ,"1 ' s'
)

pdfmark_square_jzplot_=: 4 : 0
s=. 4.5 * x
p=. (y - s) ,"1 +: s,s
pbuf (pfmt p) ,"1 ' re B'
)

pdfmark_opensquare_jzplot_=: 4 : 0
s=. 4.5 * x
p=. (y - s) ,"1 +: s,s
pbuf (pfmt p) ,"1 ' re S'
)

pdfmark_triangle_jzplot_=: 4 : 0
p=. 6 $"1 y
d=. (5.8 * x) * , (sin,.cos) 2p1 * 0 1 2 % 3
p=. p +"1 d
pbuf (pdf_makelines p) ,"1 ' b'
)

pdfmark_opentriangle_jzplot_=: 4 : 0
p=. 6 $"1 y
d=. (5.8 * x) * , (sin,.cos) 2p1 * 0 1 2 % 3
p=. p +"1 d
pbuf (pdf_makelines p) ,"1 ' s'
)

pdfmark_plus_jzplot_=: 4 : 0
s=. 0, x * 6
t=. |. s
p=. (y -"1 t) ,. y +"1 t
p=. p, (y -"1 s) ,. y +"1 s
pbuf (":PDF_PENSCALE * 1.5) , ' w '
pbuf (pdf_makelines p) ,"1 ' b'
)

pdfmark_times_jzplot_=: 4 : 0
NB.s=. _1 + 3 * x
s=. 5.25 * x
p=. y
r=. (p - s) ,. p + s
s=. (p +"1 s * 1 _1) ,. p +"1 s * _1 1
pbuf (":PDF_PENSCALE * 1.5) , ' w '
pbuf (pdf_makelines r,s) ,"1 ' b'
)

pdf_write_jzplot_=: 4 : 0
dat=. x
file=. y
while. _1 -: dat flwrite file do.
  msg=. 'Unable to write to file: ',file,LF,LF
  if. #d=. 1!:0 file do.
    msg=. msg, 'If the file is open in Adobe, close the file and try again.'
    if. 1 query msg do. return. end.
  else.
    info msg,'The file name is invalid.' return. end.
end.
)

eps_write_jzplot_=: 4 : 0
dat=. x
file=. y
while. _1 -: dat flwrites file do.
  msg=. 'Unable to write to file: ',file,LF,LF
  if. #d=. 1!:0 file do.
    msg=. msg, 'If the file is open in a viewer, close the file and try again.'
    if. 1 query msg do. return. end.
  else.
    info msg,'The file name is invalid.' return. end.
end.
)

bx=: I.
getlabels_jzplot_=: 3 : 0
NB.getlab=: 3 : 0
fm=. FRAME +. ORIGINXLABEL
if. (0=#XLabel) *. 0 { LABELS do.
  b=. (XInt=XTicPos) *. (XInt=0) >: YDiv e. 0 1
  ndx=. I. (DimType=2) *. fm<b NB. I. for bx
NB.  XLabel=: (<'') ndx } lfmt each pow10 ^: XLOG XTicPos
  XLabel=: lfmt each pow10 ^: XLOG XTicPos
end.
if. (0=#YLabel) *. 1 { LABELS do.
  b=. (YInt=YTicPos) *. (YInt=0) >: XDiv e. 0 1
  ndx=. I. (DimType=2) *. fm<b
NB.  YLabel=: (<'') ndx } lfmt each pow10 ^: YLOG YTicPos
  YLabel=: lfmt each pow10 ^: YLOG YTicPos
end.
if. DimType=2 do.
  if. {:YAxes do.
    if. (0=#Y2Label) *. 2 { LABELS do.
      b=. (Y2Int=Y2TicPos) *. (Y2Int=0) >: XDiv e. 0 1
      ndx=. I. (DimType=2) *. fm<b
      Y2Label=: (<'') ndx } lfmt each pow10 ^: Y2LOG Y2TicPos
    end.
  end.
  return.
end.
if. (0=#ZLabel) *. 2 { LABELS do.
  b=. (ZInt=ZTicPos) *. (ZInt=0) >: XDiv e. 0 1
  ndx=. I. (DimType=2) *. FRAME<b
  ZLabel=: (<'') ndx } lfmt each pow10 ^: ZLOG ZTicPos
end.
)

plot_errorbar_jzplot_=: 3 : 0
NB. modified to display only verticals
NB. requires two rows (hi and lo)
'x y'=. getgrafxy y
'hi lo'=. y
errorbar=. ,./x,."1 [ hi ,: lo
clr=. getitemcolor 1
drawline iDATA;clr;PENSIZE;errorbar
)

drawytics_jzplot_=: 3 : 0
NB.dt=: 3 : 0
if. 0=1{TICS do. return. end.
if. ({.YAxes) *. #YTics do.
  'ypos mark'=. gettics YTics;YMinor;YMax;YMin;YLOG
  mark=. <. mark * _1 ^ FRAME < TicOut +. XDiv >: MaxAxisInt
  if. FRAME  do.
    w=. Fx - Gx
    if. TicOut do.
      pox=. ,&(0,w,0) "0 w-mark  NB. gives outside tics at left
    else.
      pox=. ,&(0,w,0) "0 mark+w
    end.
    pos=. pox + fitgrafxy 0,.ypos,.0,.ypos
NB.    if. FRAME > TicOut +. {:YAxes do.
NB.      w=. (Fx + Fw) - Gx + Gw
NB.      pox=. ,&(0,w,0) "0 w-mark
NB.      pos=. pos,pox + fitgrafxy 1,.ypos,.1,.ypos
NB.    end.
  else.
    pox=. 0,.0,.mark,.0
    pos=. pox + fitgrafxy XDiv,.ypos,.XDiv,.ypos
  end.
  drawline iYTICS;AXISCOLOR;GUIDESIZE;pos
end.
if. ({:YAxes) *. #Y2Tics do.
  'ypos mark'=. gettics Y2Tics;YMinor;Y2Max;Y2Min;Y2LOG
  w=. Fx - Gx
NB.  pox=. ,&(0,w,0) "0 mark+w
  if. TicOut do.
    pox=. ,&(0,w,0) "0 w-mark
  else.
    pox=. ,&(0,w,0) "0 mark+w
  end.
  pos=. (-pox) + fitgrafxy 1,.ypos,.1,.ypos
  drawline iYTICS;AXISCOLOR;GUIDESIZE;pos
end.
)

drawy2labs_jzplot_=: 3 : 0
if. -. {:YAxes do. return. end.
if. (0=2{LABELS) +. 0=#Y2Label do. return. end.
ypos=. <. (fitgrafy Y2Tics) + -: YLabelHeight
tout=. TICMAJOR * TicOut
pos=. (Fx + Fw + tout+ MYlabel) ,. ypos
drawtext iY2LABEL;iLEFT;LabelFont;LABELCOLOR;Y2Label;pos
)

drawy2caption_jzplot_=: 3 : 0
if. #Y2CAPTION do.
  x=. Y2x - Y2w - MYCaption + TICMAJOR*TicOut
  y=. Y2y + -: Y2h
  if. 0~:{.0#CaptionFont do.
    font=. CaptionFont,' angle900'
  else.
    font=. 90 (3) } CaptionFont
  end.
  drawtext iY2CAPTION;iCENTER;font;CAPTIONCOLOR;Y2CAPTION;x,y
end.
)

drawxlabs_jzplot_=: 3 : 0
if. 0={.LABELS do. return. end.
if. 0=#XLabel do. return. end.
if. IfBar do.
  xpos=. fitgrafx }: (0.5&% + int01) # XLabel
  ypos=. (fitgrafy 0) - MXlabel + TICMAJOR
else.
  xpos=. fitgrafx XTics
  ypos=. (fitgrafy YDiv) - MXlabel
end.
NB.if. FRAME do.
  ypos=. Fy - MXlabel + TICMAJOR * TicOut +. IfBar
NB.end.
pos=. xpos,.ypos
drawtext iXLABEL;iCENTER;LabelFont;LABELCOLOR;XLabel;pos
)

NB. modplot.ijs
NB. class for plot parameter dialog

coclass 'modplot'

(;:'base z') copath 'modplot'

PLOTPAR=: chop 0 : 0
pwid
pht
title
tfsize
cfsize
lfsize
xcap
ycap
y2cap
tsrb0
tsrb1
lwaxis
tsize
tmsize
fstyle
frame
ymin
ymax
ymajor
yminor
ygrid
y2min
y2max
y2major
y2minor
xmin
xmax
xmajor
xminor
xgrid
gpname
logy
logx
barsz
sdrb0
sdrb1
sdrb2
mksz
lnwt
kshow
kfsize
kname
kpxrb0
kpxrb1
kpxrb2
kpyrb0
kpyrb1
kpyrb2
ksxrb0
ksxrb1
ksyrb0
ksyrb1
kssrb0
kssrb1
kssrb2
kssrb3
ksbox
dotmark
)

MODPLOT=: 0 : 0
pc modplot dialog nosize;
bin v;
bin hs;
cc apply button;cn "&Apply";
cc close button;cn "Cl&ose";
cc cancel button;cn "&Cancel";
bin z;
)

MPEND=: 0 : 0
bin s;
bin z;
)

create=: 3 : 0
PO=: y
MP=: MP__PO
PLOT_TYPE=: PLOT_TYPE__PO
Y2=: Y2__PO
wd MODPLOT
if. UNAME -: 'Darwin' do. wd 'cc param tab;' else. wd 'cc param tab documentmode;' end.
wd 'pn "Parameters for Mstat Plot ',(":PLOT_NUM__PO),'"'
mplabel_init''
mpaxis_init''
mpsymbol_init''
mpkey_init''
wd 'tabend; pas 6 6; pcenter'
PFormID=: wd 'qhwndp'
wd 'pshow;'
wd 'psel ',PFormID,';set param active 2;set symtab resizecol;set param active 0'
wd 'setfocus title'
InitSym=: getsymtab''
wd 'pactive'
InitDat=: wd 'psel ',PFormID,';qd'
if. HELP__ do.
  update_hlp_ <'modplot'
  wd 'psel modplot;'
end.
)

destroy=: 3 : 0
MO__PO=: ''
wd 'psel ',PFormID,';pclose'
codestroy''
)

modplot_close_button=: 3 : 0
modplot_apply_button''
wd 'psel ',PFormID
destroy''
)


modplot_cancel_button=: modplot_cancel=: modplot_close=: destroy


modplot_apply_button=: 3 : 0
ModDat=: wd 'psel ',PFormID,';qd'
ModSym=: getsymtab''
modsym=. updsym''
modpar=. updpar''
if. modsym +. modpar do.
  if. PRESIZE do.
     wd'psel ',PFormhwnd__MP,';set mp wh ',":PLOTWH__MP
     PRESIZE=: 0
  end.
  setplot__PO''
  PLOTDIRTY__PO=: 1
NB.  mplot_mp_paint__PO''
end.
wd 'psel ',PFormID
)

getsymtab=: 3 : 0
((#YNAMES__PO),#SCOL)$ <;._2 wd 'psel ',PFormID,';get symtab table'
)

updsym=: 3 : 0
mod=. (+./ -. InitSym=ModSym) # SCOL{'variable';'color';'marker';'line'
if. 0=#mod do. 0 return. end.
for_s. mod do.
  select. s
    case. 'color' do.
      ITEMCOLOR__PO=: , 1{"1 ModSym
    case. 'marker' do.
      if. (<PLOT_TYPE__PO) e. XYGROUP,'reg';'dot';'km' do.
        MARKERS__PO=: ,2{"1 ModSym
      end.
    case.'line' do.
      if. (<PLOT_TYPE__PO) e. XYGROUP,'km';'reg' do.
        LINESTYLE__PO=: ,3{"1 ModSym
      else.
        LINESTYLE__PO=: ,2{"1 ModSym
      end.
  end.
end.
InitSym=: ModSym
1
)

updpar=: 3 : 0
modqd=. (-.({:"1 InitDat)=({:"1 ModDat))#{."1 ModDat
mod=. (modqd e. PLOTPAR) # modqd
if. 0=#mod do. 0 return. end.
for_p. mod do.
  select. p
    case. 'pwid';'pht' do.
      pw=. __ ". pwid
      ph=. __ ". pht
      if. -. 300 1000 inrange pw,ph do.
        mbError 'Plot size error';'Plot width and height should be between 300 and 1000'
        wd'psel ',PFormID,';setfocus pwid;setselect pwid'
        return.
      end.
      PLOTWH__PO=: PLOTWH__MP=: pw,ph
      PRESIZE=: 1
    case. 'title' do.
      TITLE__PO=: ';,' charsub title
    case. 'tfsize' do.
      tsz=. __ ". tfsize
      if. -. 4 72 inrange tsz do.
        mbError 'Font size error';'Font sizes should be between 4 and 72'
        wd 'psel ',PFormID,';setfocus tfsize; setselect tfsize'
        return.
      else.
        TITLEFONT__PO=: SUBTITLEFONT__PO=: DFace__PO,":tsz
      end.
    case. 'cfsize' do.
      csz=. __ ". cfsize
      if. -. 4 72 inrange csz do.
        mbError 'Font size error';'Font sizes should be between 4 and 72'
        wd 'psel ',PFormID,';setfocus cfsize; setselect cfsize'
        return.
      else.
        CAPTIONFONT__PO=: DFace__PO,":csz
      end.
    case. 'lfsize' do.
      lsz=. __ ". lfsize
      if. -. 4 72 inrange lsz do.
        mbError 'Font size error';'Font sizes should be between 4 and 72'
        wd 'psel ',PFormID,';setfocus lfsize; setselect lfsize'
        return.
      else.
        LABELFONT__PO=: DFace__PO,":lsz
      end.
    case. 'xcap' do.
      XCAPTION__PO=: ';,' charsub xcap
    case. 'ycap' do.
      YCAPTION__PO=: ';,' charsub ycap
    case. 'y2cap' do.
      Y2CAPTION__PO=: ';,' charsub y2cap
    case. 'tsrb0';'tsrb1' do.
      if. (".tsrb1) do. TICSTYLE__PO=:'out' else. TICSTYLE__PO=:'in' end.
    case. 'lwaxis' do.
      gsz=. __ ". lwaxis
      if. -. 0.2 8 inrange gsz do.
        mbError 'Stroke width error';'Pen sizes should be between 0.2 and 8'
        wd 'psel ',PFormID,';setfocus lwaxis;setselect lwaxis'
        return.
      else.
        GUIDESIZE__PO=: gsz
      end.
    case. 'tsize' do.
      tsz=. __ ". tsize
      if. -. 2 20 inrange tsz do.
        mbError 'Tic size error';'Tic length should be between 2 and 20'
        wd 'psel ',PFormID,';setfocus tsize;setselect tsize'
        return.
      else.
        TICMAJOR__PO=: tsz
      end.
    case. 'tmsize' do.
      tmsz=. __ ". tmsize
      if. -. 2 20 inrange tmsz do.
        mbError 'Tic size error';'Tic length should be between 2 and 20'
        wd 'psel ',PFormID,';setfocus tmsize;setselect tmsize'
        return.
      else.
        TICMINOR__PO=: tmsz
      end.
    case. 'fstyle' do.
      if. (".fstyle) do. FRAMESTYLE__PO=: 'out' else. FRAMESTYLE__PO=: 'in' end.
    case. 'frame' do.
      if. (".frame) do. FRAME__PO=: 1 else. FRAME__PO=: 0 end.
    case. 'ymin' do.
      ymn=. __ ". ymin
      if. -. (isnum ymn)*.(1=#ymn) do.
        mbError'Non-numeric value';'Y axis min should be a single number'
        return.
      else.
        YMIN__PO=: ymn
      end.
    case. 'ymax' do.
      ymx=. __ ". ymax
      if. -. (isnum ymx)*.(1=#ymx) do.
        mbError'Non-numeric value';'Y axis max should be a single number'
        return.
      else.
        YMAX__PO=: ymx
      end.
    case. 'ymajor' do.
      ymr=. __ ". yminor
      ymj=. __ ". ymajor
      if. -. (isnum ymj)*.(1=#ymj)*.((0<ymj)*.(ymr<ymj)) do.
        mbError'Non-numeric value';'Y tic interval should be numeric, greater than 0, and with Minor<Major.'
        wd 'psel ',PFormID,';setfocus ymajor;setselect ymajor'
        return.
      else.
        YMAJOR__PO=: ymj
      end.
    case. 'yminor' do.
      ymr=. __ ". yminor
      ymj=. __ ". ymajor
      if. -. (isnum ymr)*.(1=#ymr)*.(isnum ymj)*.(1=#ymj)*.((0<ymr)*.(ymr<ymj)) do.
        mbError'Non-numeric value';'Y tic interval should be numeric, greater than 0, and with Minor<Major.'
        wd 'psel ',PFormID,';setfocus yminor;setselect yminor'
        return.
      else.
        YMINOR__PO=: _1+ymj%ymr
      end.
    case. 'y2min' do.
      ymn=. __ ". y2min
      if. -. (isnum ymn)*.(1=#ymn) do.
        mbError'Non-numeric value';'Y right axis min should be a single number'
        return.
      else.
        Y2MIN__PO=: ymn
      end.
    case. 'y2max' do.
      ymx=. __ ". y2max
      if. -. (isnum ymx)*.(1=#ymx) do.
        mbError'Non-numeric value';'Y right axis max should be a single number'
        return.
      else.
        Y2MAX__PO=: ymx
      end.
    case. 'y2major' do.
      ymr=. __ ". y2minor
      ymj=. __ ". y2major
      if. -. (isnum ymj)*.(1=#ymj)*.((0<ymj)*.(ymr<ymj)) do.
        mbError'Non-numeric value';'Y right tic interval should be numeric, greater than 0, and with Minor<Major.'
        wd 'psel ',PFormID,';setfocus y2major;setselect y2major'
        return.
      else.
        Y2MAJOR__PO=: ymj
      end.
    case. 'y2minor' do.
      ymr=. __ ". yminor
      ymj=. __ ". ymajor
      if. -. (isnum ymr)*.(1=#ymr)*.(isnum ymj)*.(1=#ymj)*.((0<ymr)*.(ymr<ymj)) do.
        mbError'Non-numeric value';'Y right tic interval should be numeric, greater than 0, and with Minor<Major.'
        wd 'psel ',PFormID,';setfocus y2minor;setselect y2minor'
        return.
      else.
        Y2MINOR__PO=: _1+ymj%ymr
      end.
    case. 'ygrid' do.
      if. (".ygrid) do. GRIDS__PO=: (1) 0}GRIDS__PO else. GRIDS__PO=: (0) 0}GRIDS__PO end.
    case. 'xmin' do.
      xmn=. __ ". xmin
      if. -. (isnum xmn)*.(1=#xmn) do.
        mbError'Non-numeric value';'X axis min should be a single number'
        return.
      else.
        XMIN__PO=: xmn
      end.
    case. 'xmax' do.
      xmx=. __ ". xmax
      if. -. (isnum xmx)*.(1=#xmx) do.
        mbError'Non-numeric value';'X axis max should be a single number'
        return.
      else.
        XMAX__PO=: xmx
      end.
    case. 'xmajor' do.
      xmr=. __ ". xminor
      xmj=. __ ". xmajor
      if. -. (isnum xmj)*.(1=#xmj)*.((0<xmj)*.(xmr<xmj)) do.
        mbError'Non-numeric value';'X tic interval should be numeric, greater than 0, and with Minor<Major.'
        wd 'psel ',PFormID,';setfocus xmajor;setselect xmajor'
        return.
      else.
        XMAJOR__PO=: xmj
      end.
    case. 'xminor' do.
      xmr=. __ ". xminor
      xmj=. __ ". xmajor
      if. -. (isnum xmr)*.(1=#xmr)*.(isnum xmj)*.(1=#xmj)*.((0<xmr)*.(xmr<xmj)) do.
        mbError'Non-numeric value';'X tic interval should be numeric, greater than 0, and with Minor<Major.'
        wd 'psel ',PFormID,';setfocus xminor;setselect xminor'
        return.
      else.
        XMINOR__PO=: _1+xmj%xmr
      end.
    case. 'xgrid' do.
      if. (".xgrid) do. GRIDS__PO=: (1) 1}GRIDS__PO else. GRIDS__PO=: (0) 1}GRIDS__PO end.
    case. 'gpname' do.
        XNAMES__PO=: gpname
    case. 'mktype' do.
      MARKERS__PO=: chop mktype
    case. 'mkcol' do.
      ITEMCOLOR__PO=: chop mkcol
    case. 'mksz' do.
      msz=. __ ". mksz
      if. -. 0.1 10 inrange msz do.
        mbError 'Marker size error';'Marker sizes should be between 0.1 and 10'
        wd 'psel ',PFormID,';setfocus mksz; setselect mksz'
        return.
      else.
        MARKERSIZE__PO=: msz
      end.
    case. 'lnwt' do.
      lnw=. __ ". lnwt
      if. -. 0.5 10 inrange lnw do.
        mbError'Line weight error';'Line weights should be between 0.5 and 10'
        wd 'psel ',PFormID,';setfocus lnwt;setselect lnwt'
        return.
      else.
        PENSIZE__PO=: lnw
      end.
    case. 'lntype' do.
      LINESTYLE__PO=: chop lntype
    case. 'kshow' do.
      KEYSHOW__PO=: ".kshow
    case. 'kfsize' do.
      ksz=. __ ". kfsize
      if. -. 4 72 inrange ksz do.
        mbError 'Font size error';'Font sizes should be between 4 and 72'
        wd 'psel ',PFormID,';setfocus kfsize; setselect kfsize'
        return.
      else.
        KEYFONT__PO=: DFace__PO,":ksz
      end.
    case. 'kname' do.
      kn=. qchop kname
      if. (#kn) = # YNAMES__PO do.
        KEYNAMES__PO=: kname
      else.
        mbError 'Key names error';'Number of key names should equal number of variables plotted'
        wd 'psel ',PFormID,';setfocus kname;setselect kname'
        return.
      end.
    fcase. 'kpxrb0';'kpxrb1' do.
      empty''
    case. 'kpxrb2' do.
      px=. {.(inxb (".kpxrb0),(".kpxrb1),(".kpxrb2)){'lcr'
      KEYPOS__PO=: (px) 0}KEYPOS__PO
    fcase. 'kpyrb0';'kpyrb1' do.
      empty''
    case. 'kpyrb2' do.
      py=. {.(inxb (".kpyrb0),(".kpyrb1),(".kpyrb2)) { 'tmb'
      KEYPOS__PO=: (py) 1}KEYPOS__PO  
    fcase. 'ksxrb0' do.
      empty''
    case. 'ksxrb1' do.
      if. (".ksxrb0) do. sx=.'l' else. sx=.'r' end.
      KEYSTYLE__PO=: (sx) 0}KEYSTYLE__PO
    fcase. 'ksyrb0' do.
      empty''
    case. 'ksyrb1' do.
      if. (".ksyrb0) do. sy=.'v' else. sy=.'h' end.
      KEYSTYLE__PO=: (sy) 2}KEYSTYLE__PO
    fcase. 'kssrb0';'kssrb1';'kssrb2' do.
      empty''
    case. 'kssrb3' do.
      ks=. {.(inxb (".kssrb0),(".kssrb1),(".kssrb2),(".kssrb3)) { 'tfmc'
      KEYSTYLE__PO=: (ks) 3}KEYSTYLE__PO
    case. 'ksbox' do.
      if. (".ksbox) do. kb=.'b' else. kb=.'o' end.
      KEYSTYLE__PO=: (kb) 1}KEYSTYLE__PO
    case. 'barsz' do.
      bsz=. __ ". barsz
      if. -. 0 1 inrange bsz do.
        mbError 'Bar width error';'Bar width must be between 0 and 1'
        wd 'psel ',PFormID,';setfocus barsz; setselect barsz'
        return.
      else.
        BARWIDTH__PO=: bsz
      end.
    case. 'logx' do.
      lxt=. ". logx
      if. lxt *. (0>:XMIN__PO) do.
        mbError'X axis range';'For log plot, X axis minimum must be greater than 0.'
        wd 'psel ',PFormID,';set logx 0'
        return.
      end.
      LOGX__PO=: ".logx
    case. 'logy' do.
      lyt=. ".logy
      if. lyt *. 0>:YMIN__PO do. 
        mbError'Y axis range';'For log plot, Y axis minimum must be greater than 0.'
        wd 'psel ',PFormID,';set logy 0'
        return.
      end.
      LOGY__PO=: ".logy
    case. 'logy2' do.
      lyt=. ".logy2
      if. lyt *. 0>:Y2MIN__PO do. 
        mbError'Y right axis range';'For log plot, Y right axis minimum must be greater than 0.'
        wd 'psel ',PFormID,';set logy 0'
        return.
      end.
      LOGY2__PO=: ".logy2
    fcase. 'sdrb0';'sdrb1' do.
      empty''
    case. 'sdrb2' do.
      st=. {.(inxb (".sdrb0),(".sdrb1),(".sdrb2)) {'ulb'
      SDTYPE__PO=: st
    case. 'dotmark' do.
      MARKERS__PO=: <dotmark
  end.
end.
InitDat=: ModDat
1
)

modplot_dlghlp=: 3 : 0
if. HELP__ do.
   HELP__=: 0
   wd 'psel hlp; pclose; psel mstat; set DHlp 0; psel modplot; pactive;'
else.
   HELP__=: 1
   open_hlp_ <'modplot'
   wd 'psel mstat; set DHlp 1; psel modplot; pactive; pshow'
end.
)

raise=: 3 : 0
wd 'psel modplot; ptop;'
)


modplot_pctrl_fkey=: modplot_apply_button
modplot_octrl_fkey=: modplot_close_button
modplot_lctrl_fkey=: modplot_dlghlp
NB. modplotaxis.ijs
NB. axis tab for modplot

coclass 'modplot'

MPAXIS=: 0 : 0
tabnew Axes;
bin v;
cc spclab static;cn "";set spclab wh 100 10;
groupbox "Tic/frame style";
bin v;
bin h;
minwh 80 32;cc tsrb0 radiobutton;cn "Inner";
minwh 120 32;cc lwlab static right;cn "Line weight ";
cc lwaxis edit;set lwaxis wh 60 _1;
bin sz;
bin h;
minwh 80 32;cc tsrb1 radiobutton group;cn "Outer";
minwh 120 32;cc tszlab static right;cn "Tic size major ";
cc tsize edit;set tsize wh 60 _1;
bin sz;
bin h;
minwh 80 32;cc frame checkbox;cn "Frame";
minwh 120 32;cc tszmlab static right;cn "Tic size minor ";
cc tmsize edit;set tmsize wh 60 _1;
bin sz;
minwh 80 32;cc fstyle checkbox;cn "Offset";
bin z;
groupboxend;


cc spclab static;cn "";set spclab wh 100 10;

groupbox "Y axis";
bin v;
bin h;
minwh 80 32;cc yrangelab static;cn "Range";
minwh 60 32;cc yminlab static right;cn "Min ";
cc ymin edit;set ymin wh 60 _1;
minwh 60 32;cc ymaxlab static right;cn "Max ";
cc ymax edit;set ymax wh 60 _1;
bin sz;
bin h;
minwh 80 32;cc yticlab static;cn "Tic interval";
minwh 60 32;cc ymajlab static right;cn "Major ";
cc ymajor edit;set ymajor wh 60 _1;
minwh 60 32;cc yminorlab static right;cn "Minor ";
cc yminor edit;set yminor wh 60 _1;
bin sz;
bin h;
minwh 80 32;cc ygrid checkbox;cn "Grid";
cc logy checkbox;cn "Log Y";
bin sz;
bin z;
groupboxend;
)

MPAXISY2=: 0 : 0
groupbox "Y right axis";
bin v;
bin h;
minwh 80 32;cc y2rangelab static;cn "Range";
minwh 60 32;cc y2minlab static right;cn "Min ";
cc y2min edit;set y2min wh 60 _1;
minwh 60 32;cc y2maxlab static right;cn "Max ";
cc y2max edit;set y2max wh 60 _1;
bin sz;
bin h;
minwh 80 32;cc y2ticlab static;cn "Tic interval";
minwh 60 32;cc y2majlab static right;cn "Major ";
cc y2major edit;set y2major wh 60 _1;
minwh 60 32;cc y2minorlab static right;cn "Minor ";
cc y2minor edit;set y2minor wh 60 _1;
bin sz;
bin h;
cc logy2 checkbox;cn "Log Y";
bin sz;
bin z;
groupboxend;
)


MPAXISX=: 0 : 0
cc spclab static;cn "";set spclab wh 100 10;
groupbox "X axis";
bin v;
bin h;
minwh 80 32;cc xrangelab static;cn "Range";
minwh 60 32;cc xminlab static right;cn "Min ";
cc xmin edit;set xmin wh 60 _1;
minwh 60 32;cc xmaxlab static right;cn "Max ";
cc xmax edit;set xmax wh 60 _1;
bin sz;
bin h;
minwh 80 32;cc xticlab static;cn "Tic interval";
minwh 60 32;cc xmajlab static right;cn "Major ";
cc xmajor edit;set xmajor wh 60 _1;
minwh 60 32;cc xminorlab static right;cn "Minor ";
cc xminor edit;set xminor wh 60 _1;
bin sz;
bin h;
minwh 80 32;cc xgrid checkbox;cn "Grid";
cc logx checkbox;cn "Log X";
bin sz;
bin z;
groupboxend;
)


mpaxis_init=: 3 : 0
wd MPAXIS
if. (<'in')=<TICSTYLE__MP do. wd 'set tsrb0 value 1;tsrb1 value 0' else. wd 'set tsrb0 value 0;set tsrb1 value 1' end.
wd 'set lwaxis text ',":GUIDESIZE__PO
wd 'set tsize text ',":TICMAJOR__PO
wd 'set tmsize text ',":TICMINOR__PO
if. (<'out')=<FRAMESTYLE__PO do. wd 'set fstyle value 1' else. wd 'set fstyle value 0' end.
if. FRAME__PO do. wd 'set frame value 1; set fstyle enable 1' else. wd 'set frame value 0;set fstyle enable 0' end.
wd 'set ymin text ',ft YMIN__PO
wd 'set ymax text ',ft YMAX__PO
wd 'set ymajor text ',":YMAJOR__PO
wd 'set yminor text ',":YMAJOR__PO%(1+YMINOR__PO)
if. (1{GRIDS__PO) do. wd 'set ygrid value 1' else. wd 'set ygrid value 0' end.
if. NOLOGY__PO do. wd 'set logy 0;set logy enable 0' else. wd 'set logy value ',":LOGY__PO end.
if. Y2 do.
  wd MPAXISY2
  wd 'set y2min text ',ft Y2MIN__PO
  wd 'set y2max text ',ft Y2MAX__PO
  wd 'set y2major text ',":Y2MAJOR__PO
  wd 'set y2minor text ',":Y2MAJOR__PO%(1+Y2MINOR__PO)
  if. NOLOGY2__PO do. wd 'set logy2 0;set logy2 enable 0' else. wd 'set logy2 value ',":LOGY2__PO end.
end.
if. -.(<PLOT_TYPE) e. 'dot';'hist';'bar';'sbar';'fbar';'area';'barsd' do. 
  wd MPAXISX 
  wd 'set xmin text ',ft XMIN__PO
  wd 'set xmax text ',ft XMAX__PO
  'xmj xmn'=. XTIC__MP
  wd 'set xmajor text ',":XMAJOR__PO
  wd 'set xminor text ',":XMAJOR__PO%(1+XMINOR__PO)
  if. NOLOGX__PO do. wd 'set logx value 0;set logx enable 0' else. wd 'set logx value ',":LOGX__PO end.
  if. ({.GRIDS__PO) do. wd 'set xgrid value 1' else. wd 'set xgrid value 0' end.
end.
wd 'bin s;bin z;'
)

mpaxis_frame_button=: 3 : 0
if. (".frame) do. wd 'set fstyle enable 1' else. wd 'set fstyle enable 0' end.
)
NB. modplotlabel.ijs
NB. label tab for modplot

coclass 'modplot'


MPLABEL=: 0 : 0
tabnew Size/Labels;
bin v;
cc spclab static;cn "";set spclab wh 100 10;
groupbox "Plot size";
bin h;
cc pwlabel static right;cn "Width";
cc pwid edit; set pwid wh 52 _1;
cc phlabel static right;cn "   Height";
cc pht edit; set pht wh 52 _1;
bin sz;
groupboxend;

cc spclab2 static;cn "";set spclab2 wh 100 10;


groupbox "Labels";
bin v;
bin h;
minwh 100 32;cc titlelab static;cn "Title";
cc tsizelab static right;cn "Size ";
cc tfsize edit;set tfsize wh 52 _1;
bin sz;
minwh 400 _1;cc title edit;
cc spclab static;cn "";set spclab wh 100 10;
bin h;
minwh 100 32;cc caplab static;cn "Captions";
cc capsizelab static right;cn "Size ";
cc cfsize edit;set cfsize wh 52 _1;
bin sz;
bin h;
minwh 100 32;cc xcaplab static right;cn "X axis ";
cc xcap edit;
bin z;
bin h;
minwh 100 32;cc ycaplab static right;cn "Y axis ";
cc ycap edit;
bin z;
)

MPLABELY2=: 0 : 0
bin h;
minwh 100 32;cc y2caplab static right;cn "Y right axis ";
cc y2cap edit;
bin z;
)

MPLABELEND=: 0 : 0
cc spclab static;cn "";set spclab wh 100 10;
bin h;
minwh 100 32;cc labellab static;cn "Axis labels";
cc labsizelab static right;cn "Size ";
cc lfsize edit;set lfsize wh 52 _1;
bin sz;
groupboxend;
)

MPLABELDOT=: 0 : 0
minwh 100 _1;cc gpnlabel static;cn "Group names";
cc gpname edit;
)

mplabel_init=: 3 : 0
'pw ph'=. PLOTWH__PO
wd MPLABEL
if. Y2 do. wd MPLABELY2 end.
wd MPLABELEND
wd 'set pwid text ',":pw
wd 'set pht text ',":ph
wd 'set title text *',TITLE__MP
wd 'set tfsize text ',":2{TITLEFONT__MP
wd 'set cfsize text ',":2{CAPTIONFONT__MP
wd 'set lfsize text ',":2{LABELFONT__MP
wd 'set xcap text *',XCAPTION__MP
wd 'set ycap text *',YCAPTION__MP
if. Y2 do. 
  wd'set y2cap text *',Y2CAPTION__MP 
end.
if. (<PLOT_TYPE) e. 'dot';'bar';'sbar';'fbar';'area';'barsd' do. 
  wd MPLABELDOT 
  wd 'set gpname text *',dquot dqlabel__PO XLABEL__MP
end.
if. (<PLOT_TYPE)-:<'pow' do.
  wd 'set title enable 0; set xcap enable 0; set ycap enable 0'
end.
wd 'bin s;bin z;'
PRESIZE=: 0
)

NB. modplotsymbol.ijs
NB. symbol tab for modplot

coclass 'modplot'

VCML=: 0 1 2 3
VCM=: 0 1 2
VCL=: 0 1 3
VC=: 0 1


MPSYMBOL=: 0 : 0
tabnew Symbols;
bin v;
cc spclab static;cn "";set spclab wh 100 10;
)

MPSYM=: 0 : 0
bin h;
minwh 80 36;cc szlabel static right;cn "Marker size  ";
cc mksz edit;set mksz wh 60 _1;
bin sz;
)


MPDOT=: 0 : 0
bin h;
cc szlabel static;cn "Marker size  ";
cc mksz edit;set mksz wh 60 _1;
minwh 120 _1;cc dmlabel static right;cn "Marker type  ";
cc dotmark combolist;set dotmark wh 120 _1;
bin sz;
)

MPBAR=: 0 : 0
bin h;
cc barszlab static;cn "Bar width  ";
cc barsz edit;set barsz wh 60 _1;
bin sz;
)

MPSD=: 0 : 0
groupbox "SD type";
bin h;
cc sdrb0 radiobutton;cn "Upper";
cc sdrb1 radiobutton group;cn "Lower";
cc sdrb2 radiobutton group;cn "Both";
bin sz;
groupboxend;
cc spcsd static;cn "";set spcsd; wh 100 10;
)

MPLINE=: 0 : 0
bin h;
minwh 80 36;cc lnwtlab static right;cn "Line weight ";
cc lnwt edit;set lnwt wh 60 _1;
bin sz;
)

MPTABLE=: 0 : 0
cc symtab table;
)

XYGROUP=: 'xym';'xyl';'xylm';'xys';'xysl';'xyb'

mpsymbol_init=: 3 : 0
wd MPSYMBOL
if. (<PLOT_TYPE__PO) e. XYGROUP,'reg';'km' do.
  wd MPSYM
  wd 'set mksz text ',":MARKERSIZE__PO
end.
if. (<PLOT_TYPE__PO) e. XYGROUP,'km';'pow';'bpv';'reg';'barsd' do.
  wd MPLINE
  wd 'set lnwt text ',":PENSIZE__PO
end.
if. (<PLOT_TYPE__PO)=<'dot' do.
  wd MPDOT
  wd 'set mksz text ',":MARKERSIZE__PO
  wd 'set dotmark items ',unchop PMarker__PO
  wd 'set dotmark select  ',": PMarker__PO i. MARKERS__PO
end.
if. (<PLOT_TYPE__PO)=<'xys' do.
  wd MPSD
  wd 'set sdrb0 value 0;set sdrb',(":inxb SDTYPE__PO='ulb'),' value 1'
end.
if. (<PLOT_TYPE__PO) e. 'bar';'fbar';'sbar';'barsd' do.
  wd MPBAR
  wd 'set barsz text ',":BARWIDTH__PO
end.
if. (PLOT_TYPE__PO-:'hist') *. 1<#YNAMES__PO do.
  wd MPBAR
  wd 'set barsz text ',":BARWIDTH__PO
end.

wd MPTABLE
NB. initialize table
nrow=. #YNAMES__PO
select. PLOT_TYPE__PO
  case. 'dot';'bar';'fbar';'sbar';'hist';'area';'barsd' do.
    SCOL=: VC
    wd 'set symtab shape ',":nrow,2
    wd 'set symtab hdr Variable Color'
    wd 'set symtab protect 1 0'
    wd 'set symtab type 0 200'
    0 settextcol YNAMES__PO
    1 setlistcol (PColor__PO i. ITEMCOLOR__PO);PColor__PO
  case. 'pow';'bpv' do.
    SCOL=: VCL
    wd 'set symtab shape ',": nrow,3
    wd 'set symtab hdr Variable Color Line'
    wd 'set symtab type 0 200 200'
    0 settextcol , each YNAMES__PO
    1 setlistcol (PColor__PO i. ITEMCOLOR__PO);PColor__PO
    2 setlistcol (PLine__PO i. LINESTYLE__PO);PLine__PO
  case. XYGROUP,<'km' do.
    SCOL=: VCML
    wd 'set symtab shape ',": nrow,4
    wd 'set symtab hdr Variable Color Marker Line'
    wd 'set symtab type 0 200 200 200'
    0 settextcol YNAMES__PO
    1 setlistcol (PColor__PO i. ITEMCOLOR__PO);PColor__PO
    2 setlistcol (PMarker__PO i. MARKERS__PO);PMarker__PO
    3 setlistcol (PLine__PO i. LINESTYLE__PO);PLine__PO
  case. 'reg' do.
    SCOL=: VCML
    wd 'set symtab shape ',": nrow,4
    wd 'set symtab hdr Variable Color Marker Line'
    wd 'set symtab type 0 200 200 200'
    0 settextcol YNAMES__PO
    1 setlistcol (PColor__PO i. ITEMCOLOR__PO);PColor__PO
    2 setlistcol (PMarker__PO i. MARKERS__PO);PMarker__PO
    3 setlistcol (PLineReg__PO i. LINESTYLE__PO);PLineReg__PO
end.
wd 'bin s;bin z;'
)


setlistcol=: 4 : 0
NB. x is stab column number
NB. y is (<indices),boxed combolist items
ind=. ,>{.y
items=. }.y
nrow=. #ind
itemlist=. vfm >items
for_r. i.nrow do.
  wd 'set symtab cell ',(":r,x),' *',(":r{ind),LF,itemlist
end.
)

settextcol=: 4 : 0
NB. x is stab column number, y is boxed cell values
nrow=. #y
for_r. i.nrow do.
  wd 'set symtab cell ',(":r,x),' ',>r{y
end.
)
NB. modplotkey.ijs
NB. key tab for modplot

coclass 'modplot'

MPKEY=: 0 : 0
tabnew Key;
bin v;
cc spclab static;cn "";set spclab wh 100 10;

bin h;
cc kshow checkbox;cn "Show key";
minwh 200 _1;cc kfszlabel static right;cn "Key font size  ";
cc kfsize edit;set kfsize wh 60 _1;
bin sz;

minwh _1 32;cc kvarlab static;cn "Variables";
cc kynames edit readonly;set kynames stylesheet background-color:#eeeeee;

minwh _1 32;cc knamelab static;cn "Key names";
cc kname edit;

cc spclab static;cn "";set spclab wh 100 10;

groupbox "Key position";
bin v;
bin h;
cc kpxrb0 radiobutton;cn "Left";
cc kpxrb1 radiobutton group;cn "Center";
cc kpxrb2 radiobutton group;cn "Right";
bin sz;
bin h;
cc kpyrb0 radiobutton;cn "Top";
cc kpyrb1 radiobutton group;cn "Middle";
cc kpyrb2 radiobutton group;cn "Bottom";
bin sz;
bin z;
groupboxend;

cc spclab static;cn "";set spclab wh 100 10;

groupbox "Key style";
bin v;
bin h;
cc ksxrb0 radiobutton;cn "Left";
cc ksxrb1 radiobutton group;cn "Right";
bin sz;
bin h;
cc ksyrb0 radiobutton;cn "Vertical";
cc ksyrb1 radiobutton group;cn "Horizontal";
bin sz;
bin h;
cc kssrb0 radiobutton;cn "Thin";
cc kssrb1 radiobutton group;cn "Fat";
cc kssrb2 radiobutton group;cn "Marker";
cc kssrb3 radiobutton group;cn "Combo";
bin sz;
cc ksbox checkbox;cn "Boxed";
bin z;
groupboxend;
)


mpkey_init=: 3 : 0
wd MPKEY
wd 'set kshow value ',":KEYSHOW__PO
wd 'set kfsize text ',":2{KEYFONT__MP
wd 'set kynames text *',unchop YNAMES__PO
wd 'set kname text *',dquot KEYNAMES__PO
'px py'=. 2{.KEYPOS__PO
wd 'set kpxrb0 value 0;set kpyrb0 value 0'
wd 'set kpxrb',(":inxb px='lcr'),' value 1'
wd 'set kpyrb',(":inxb py='tmb'),' value 1'
'sx sb sy ss'=. KEYSTYLE__PO
wd 'set ksxrb0 value 0; set ksyrb0 value 0; set kssrb0 value 0'
wd 'set ksxrb',(":inxb sx='lr'),' value 1'
wd 'set ksyrb',(":inxb sy='vh'),' value 1'
wd 'set kssrb',(":inxb ss='tfmc'),' value 1'
wd 'set ksbox ',":sb='b'
if. NOKEY__PO do.
  wd 'set kshow 0;set kshow enable 0'
end.
wd 'bin s;bin z;'
)

mpkey_close=: 3 : 0
wd 'pclose'
)
NB. mspref.ijs
NB. form for mstat preferences

coclass 'mspref'

(;:'base z') copath 'mspref'

NB. base form 

MSPREF=: 0 : 0
pc mspref dialog nosize escclose closeok owner;
pn "Preferences";
bin v;
bin h;
minwh 100 24;cc labelvf static right;cn "Output font";
minwh 200 24;cc vfe edit readonly;set vfe stylesheet background-color:#eeeeee;
cc vfchange button;cn "Change";
bin z;
bin h;
minwh 100 24;cc labelff static right;cn "Form font";
minwh 200 24;cc ffe edit readonly;set ffe stylesheet background-color:#eeeeee;
cc ffchange button;cn "Change";
bin z;
bin h;
minwh 100 24;cc labelsf static right;cn "Signif. figures";
cc sf edit;set sf wh 50 _1;
bin s;
cc autoup checkbox;cn "Check for updates to Mstat";
bin z;
bin h;
cc adv button;cn "&Viewers";
cc pr button;cn "&Printer";
bin s2;
cc ok button;cn "&OK";
cc cancel button;cn "&Cancel";
bin zz;
pcenter;
)

open=: 3 : 0
wd MSPREF
wd 'set vfe text *',Vfont__
wd 'set ffe text *',Ffont__
wd 'set sf text *',":SIGFIG__
wd 'set autoup value ',":AUTOUPDATE__
wd 'setfocus cancel'
wd 'pshow;'
if. HELP__ do.
   update_hlp_ <'mspref'
   wd 'psel mspref; pactive; set vfchange focus'
end.
)

close=: 3 : 0
wd 'pclose'
)


mspref_ffchange_button=: 3 : 0
ff=. (mbfont Ffont__)
if. 0 = #ff do.
   return.
end.
Ffont__=: ff
wd 'psel mspref;set ffe text *',ff
)

mspref_vfchange_button=: 3 : 0
vf=. (mbfont Vfont__)
if. 0 = #vf do.
   return.
end.
Vfont__=: vf
wd 'psel mspref; set vfe text *',vf
)

mspref_ok_button=: 3 : 0
s=.<.__".sf
if. -.(s>1)*.s<10 do.
  mbError 'Significant figures';'The number of significant figures must be between 2 and 9'
  wd 'set sf focus; set sf select'
  return.
end.
SIGFIG__=: s
AUTOUPDATE__=: ".autoup
close''
writepref''
wd'psel mstat'
wd'fontdef ',Ffont__
wd 'set Em1 stylesheet *QPlainTextEdit {background-color:#eeeeee;',(font2css Vfont),'}'
view''
)

mspref_cancel_button=: mspref_cancel=: close

mspref_adv_button=: 3 : 0
open_advpref_''
)

mspref_pr_button=: 3 : 0
open_printpref_''
)

mspref_dlghlp=: 3 : 0
if. HELP__ do.
   HELP__=: 0
   wd 'psel hlp; pclose; psel mstat; set DHlp 0; psel mspref; pactive; set vfchange focus'
else.
   HELP__=: 1
   open_hlp_ <'mspref'
   wd 'psel mstat; set DHlp 1; psel mspref; pactive'
end.
)

mspref_lctrl_fkey=: mspref_dlghlp
mspref_octrl_fkey=: mspref_ok_button
mspref_ictrl_fkey=: mspref_adv_button
mspref_pctrl_fkey=: mspref_pr_button
NB. msreq.ijs
NB. required functions for Mstat

require'general/misc/validate'

coclass 'base'

ddel=: 3 : 0
NB. Delete variables listed in MSvar__
NB. y is variable type
if. 0=#MSvar__ do.
  return.
end.
if. 1=#MSvar__ do.
  msg=.'this variable?'
else.
  msg=. 'these ',(":#MSvar__),' variables?'
end.
r=. mbQuery 'Delete variables';'Do you want to delete ',msg
if. 'N'={.r do.
  return.
end.
select. y
   case. 'R' do.
      var=. locv each MSvar__
   case. 'T' do.
      var=. loct each MSvar__
   case. 'I' do.
      var=. loci each MSvar__
end.
erase each var
Ddirty__=: 1
wd 'psel mstat'
wd 'set sbar setlabel nvar *',(":numvar''),' variables defined'
)

dloadfn=: 3 : 0
f=. wd 'mb open1 "Open variable definitions file" "',Dpath__,'" "Data files (*.ijd)|All files (*.*)"'
jpath f
)

dsavfn=: 3 : 0
Fn=. wd 'mb save "Save variable definitions to file" "',(Dpath__,Dfn__),'" "Data files (*.ijd)|All files (*.*)"'
if. 0=#Fn do.
   return.
end.
fullpath=. pathname Fn
Dpath__=: >0{fullpath
Dfn__=: >1{fullpath
if. -. '.' e. Dfn__ do.
   Dfn__=.Dfn__,'.ijd'
end.
Fn=.Dpath__,Dfn__
)

dwrite=: 3 : 0
Dout=.'NB. ijd file',LF
v=. (locv each nl_v_''),(loct each nl_t_''),loci each nl_i_''
ls=. >(] , '=:' "_) each v
rs=. 5!:5 v
Dout=. Dout,deb vfm ls,.rs
Dout fwrites y
)

ed_check=: 3 : 0
if. Ed__ do.
   end_edit''
end.
)

end_edit=: 3 : 0
wd'set Em1 readonly 1; set Eannot checked 0; set Eundo enable 0;'
wd'set mtb checked Eannot 0;set mtb enable Eundo 0;'
wd'set Em1 stylesheet *QPlainTextEdit {background-color:#eeeeee; border: 1px solid gray;',(font2css Vfont__),'}'
Out__=: Em1
Out__=: Out__,LF,LF
Ed__=: 0
)

fixvn=: 3 : 0
vn=. deb y
lc=.'abcdefghijklmnopqrstuvwxyz'
uc=.'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
num=.'0123456789'
if. ({.vn) e. num do. vn=. 'n',vn end.
if. (vn='x') +. (vn='y') do. vn=. 'v',vn end.
notanum=. inxb -. vn e. lc,uc,num,'_'
vn=. '_' notanum } vn
vn=. (collapsenull -.('_'=vn)) #vn
if. ('_'={:vn) do. vn=. }:vn end.
vn
)

fsavfn=: 3 : 0
NB. returns name of file for saving
Fn=. wd 'mb save "Save analysis to file" "',Dpath__,'" "Text files (*.txt)|All files (*.*)"'
if. 0=#Fn do.
   return.
end.
fullpath=. pathname Fn
Dpath__=: >0{fullpath
Ofn__=: >1{fullpath
if. -. '.' e. Ofn do.
   Ofn__=.Ofn__,'.txt'
end.
Fn=. Dpath__,Ofn__
)

getPlugins=: 3 : 0
NB.plug=. 0{"1 fdir jpath_z_ Bdir__,'plug-in\*.ij?'
plug=. 0{"1 fdir Plugdir__,'*.ij?'
if. 0<#plug do.
   PMENU=.'menupop "P&lug-ins";',LF
   PMENU=.PMENU,'menu Sload "&Load script..."; menusep;',LF
   for_p. plug do.
      pname=. '.' taketo >p
NB.      script <Bdir__,'plug-in\',(>p)
      scriptn <Plugdir__,(>p)
      PMENU=.PMENU,(".'MENU_',pname,'_')
   end.
   PMENU=.PMENU,'menusep;',LF
else.
   PMENU=.'menupop "&Plug-ins";',LF
   PMENU=.PMENU,'menu Sload "&Load script..."; menusep;',LF
NB.   PMENU=.PMENU,'menupopz;',LF

end.
PMENU
)

hlpopen=: 3 : 0
(<'hlp') e. getwinname''
)

invaldat=: 3 : 0
NB. Tests data in dnew, dedit, tovar dialogs for validity.
1
if. (#y)=0 do.
  mbError 'No data';'You need to enter values in the data entry field.'
  return.
end.
if. __ e. y do.
  mbError 'Data values';'Non-numeric value in data field.'
  return.
end.
0
)

invalidVn=: 3 : 0
NB. tests y as valid variable name
'v' invalidVn y
:
Vt=.'_',x,'_'
Vn=. ,y
if. Vrep__ do.
  Vrep__=: 0
  return.
end.
if. (<Vn) e. , each 'x';'y' do.
  VNRESERV__
  return.
end.
if. 0=$Vn do.
  VNMISSING__
  return.
end.
if. -. isalpha 0{Vn do.
  VNFIRST__
  return.
end.
if. -. isalphanum Vn do.
  VNALPHNUM__
  return.
end.
if. ((<Vn) e. ". 'nl',Vt,'''''')  do.
  VNDUP__
  return.
end.
if. ('_'={:Vn) +. (0<;# '__' ss Vn) do.
  VNUNDER__
  return.
end.
0
)

invalidVnOW=: 3 : 0
NB. tests y as valid variable name, but allows overwrite
'v' invalidVn y
:
Vn=. ,y
if. (<Vn) e. , each 'x';'y' do.
  VNRESERV__
  return.
end.
if. 0=$Vn do.
  VNMISSING__
  return.
end.
if. -. isalpha 0{Vn do.
  VNFIRST__
  return.
end.
if. -. isalphanum Vn do.
  VNALPHNUM__
  return.
end.
0
)

iscontab=: 3 : 0
t=. ,}. }."1 y
r=. *./>isinteger each t
if. r do. r=. nonneg r end.
r
)

load_legacy_file=: 3 : 0
D=. chop y
Nv=.#D
I=.1
while. I < Nv do.
   if. 3=+/'NB.' e. >I{D do.
      I=.I+1
      continue.
   end.
   Vn=. '=:' taketo >I{D
   Dat=. '=:' takeafter >I{D
   ". 'tv=.',Dat
   Type=. '_v_=:'
   if. 32 = 3!:0 tv do.
     if. 1 < $$tv do.
       Type=. '_t_=:'
     else.
       Type=. '_i_=:'
     end.
   end.
   ". Vn,Type,Dat
   I=.I+1
end.
wd 'sbarset statusnvar -1 *',(":numvar''),' variables defined'
)

NB. qualifies variable name by locale
locv=: ,&'_v_'
loct=: ,&'_t_'
loci=: ,&'_i_'

loc=: 3 : 0
'_',y,'_'
:
x,'_',y,'_'
)

numvar=: 3 : 0
NB. number of variables defined
#(nl_t_''),(nl_v_''),(nl_i_'')
)

parsetab=: 3 : 0
NB. parses tables in new, edit, import and totab dialogs
if. (#y)=0 do.
  mbError 'No data';'You need to enter values in the data entry field.'
  t=.''
  return.
end.
t=. chop each chop (TAB,' ') charsub y
colnames=. >0{t
maxcol=. >./>#each }.t
if. 1 = (maxcol-#colnames) do.
   colnames=.(<''),colnames
   t=. (<colnames) 0}t
end.
if. ((#t)<3) +. (>./>#each t)<3 do.
  mbError 'Improper table';'You need to enter row and column names and table must be at least 2x2.'
  t=.''
  return.
end.
if. -.eqvec >#each t do.
  mbError 'Improper table';'Number of columns not same for all rows (no spaces allowed in column names).'
  t=.''
  return.
end.
t=.>t
'r c'=.($t)-1
di=. (<(1+i.r);1+i.c)
d=.di{t
d=. toN each d
if. (<__) e. ,d do.
  mbError 'Improper table';'Non-numeric value in data fields.'
  t=.''
  return.
end.
t=. d di}t
)

readpref=: 3 : 0
fn=. Profdir__,'mstat7.ini'
if. 0=#dir fn do.
  defpref''
  writepref''
else.
  try. (scriptn freads fn)
  catch.
    mbError'File error';'Mstat.ini file is corrupt or missing, using defaults.'
    defpref''
    writepref''
  end.
end.
)

rescale=: 3 : 0
nvn=. MSvar__
name=. '_',RSCName__
nvn=. (,&name) each nvn
ls=. (,&'=:') each locv each nvn
rs=. (%&RSCDiv__) each ". each locv each MSvar
for_i. ls,.rs do.
  l=.>{.i
  r=. >{:i
  ". l,'r'
end.
)

setIcon=: 3 : 0
if. UNAME-:'Linux' do.
  wd 'picon "',TBP__,'mstat.png"'
end.
)

setTlast=: 3 : 0
wd 'psel mstat'
wd 'set sbar setlabel tlast *',>y{TestN
Tlast__=:y
)

show=: 3 : 0
NB. shows variable to output window
if. 0=$MSvar__ do.
   empty''
   return.
end.
select. y
   case. 'R' do.
      loc=. '_v_'
   case. 'I' do.
      loc=. '_i_'
   case. 'T' do.
      loc=. '_t_'
end.
N=. # MSvar__
I=.0
while. I < N do.
   nam=.I{MSvar__
   if. y='T' do.
      tout 'Table ',(>nam),LF
      tout (bfmt ". (>nam),loc),LF
   elseif. y='I' do.
      tout 'Indicator ',(>nam),': ',(":#~. ".(>nam),loc),' types',LF
      if. +./ ,>(' '&e.) each ". (>nam),loc do.
        tout (50 foldtext dqlabel ". (>nam),loc),LF
      else.
        tout (50 foldtext unchop ". (>nam),loc),LF
      end.
   elseif.  do.
      tout (>nam),LF
      tout ,vfm 50 list ft ". (>nam),loc
      tout LF
   end.
   tout LF
   I=.I+1
end.
view''
)

sloadfn=: 3 : 0
f=. wd 'mb open1 "Load script file" "',Dpath__,'" "Script files (*.ijs)|All files (*.*)"'
jpath f
)

toind=: 3 : 0
NB. converts variable to indicator
Vn=. >OSvar__
Vd=. ".locv Vn
r=. mbQuery 'Change variable';'Do you want to change variable ',(>Vn),' to an Indicator?'
if. 'N'={.r do.
  return.
end.
if. (<Vn) e. nl_i_'' do.
  r=. mbQuery 'Variable already exists';'Do you want to overwrite the Indicator ',(>Vn),'?'
  if. 'N'={.r do.
    return.
  end.
end.
4!:55 <locv Vn
". (loci Vn),'=: chop ":Vd'
Ddirty__=: 1
)

tout=: 3 : 0
Out__=:Out__, y
)

tovar=: 3 : 0
NB. converts indicator to variable
Vn=. >OSvar__
r=. mbQuery 'Change indicator';'Do you want to change Indicator ',(>Vn),' to a variable?'
if. 'N'={.r do.
  return.
end.
Vd=. , __ ". unchop ". loci Vn
if. __ e. Vd do.
  mbError 'Invalid data';'Non-numeric data in this indicator prevent its conversion to a variable.'
  return.
end.
if. (<Vn) e. nl_v_'' do.
  r=. mbQuery 'Variable already exists';'Do you want to overwrite the variable ',(>Vn),'?'
  if. 'N'={.r do.
    return.
  end.
end.
4!:55 <loci Vn
". Vn,'_v_=: Vd' 
Ddirty__=: 1
)

varexist=: 3 : 0
1 varexist y
:
r=. 1
vt=. boxopen y
for_t. vt do.
  select. t
    case. <'A' do.
      r=. r*(-.x>numvar'')
    case. <'T' do.
      r=. r*(-.x>#nl_t_'')
    case. <'R' do.
      r=. r*(-.x>#nl_v_'')
    case. <'I' do.
      r=. r*(-.x>#nl_i_'')
  end.
end.
r
)

view=: 3 : 0
wd 'psel mstat;'
wd 'set Em1 text *',Out__
wd 'set Em1 scroll max'
Odirty__=:1
)

vnError__=: 3 : 0
NB. Display message box for variable name error
select. y
  case. VNMISSING__ do.
    mbError 'Variable name';'You need to provide a variable name.'
  case. VNFIRST__ do.
    mbError 'Variable name';'Variable names must begin with a letter.'
  case. VNALPHNUM__ do.
    mbError 'Variable name';'Variable names can only contain letters or ',LF,'numbers (no spaces or special characters except underscore).'
  case. VNDUP__ do.
    mbError 'Variable name';'This name is already in use.'
  case. VNRESERV__ do.
    mbError 'Variable name';'Reserved names (x,y) can not be used as variable names.'
  case. VNUNDER__ do.
    mbError 'Variable name';'Variable name can not end in',LF,' or contain repeated underscores.'
end.
)

writepref=: 3 : 0
fn=. Profdir__,'mstat7.ini'
q=. ''''
d=. 'NB. mstat.ini',LF,'NB. Automatically generated, do not edit.',LF
d=. d,'Vfont__=: ',q,Vfont__,q,LF
d=. d,'Ffont__=: ',q,Ffont__,q,LF
d=. d,'Pfont__=: ',q,Vfont__,q,LF
d=. d,'Dfont__=: ',q,Dfont__,q,LF
d=. d,'SIGFIG__=: ',(":SIGFIG__),LF
d=. d,'Dpath__=: ',q,Dpath__,q,LF
d=. d,'SETBROWSER__=: ',q,SETBROWSER__,q,LF
d=. d,'SETPDFVIEWER__=: ',q,SETPDFVIEWER__,q,LF
d=. d,'MARGIN__=: ',(":MARGIN__),LF
d=. d,'ORIENT__=: ',(":ORIENT__),LF
d=. d,'AUTOUPDATE__=: ',(":AUTOUPDATE__),LF
d=. d,'LASTUPDATE__=: ',(":LASTUPDATE__),LF
d fwrites fn
)
NB. mstatfn.ijs
NB. statistical functions

coclass 'base'

alltab=: 3 : 0
't1 t2'=. y
r1=. |. (i.t1+1),.(t1-i.t1+1)
r2=. (i.t2+1),.(t2-i.t2+1)
t=.''
for_i. r1 do.
  for_j. r2 do.
    t=. t,<(,:i),j
  end.
end.
t
)

barnard=: 3 : 0
NB. y is a 2x2 table, default is 2-sided
2 barnard y
:
sided=. x
tobs=. y
if. >/ +/"1 tobs do. tobs=. hr tobs end.
if. </ {.tobs do. tobs=. vr tobs end.
if. (=/ +/"1 tobs) *. (</ {."1 tobs) do. tobs=. hr tobs end.
g2o=. xs2 tobs
rt=. +/"1 tobs
if. =/ ({."1 tobs)%rt do.
  P=. sided*0.5
  return.
end.
tall=. alltab rt
g2all=. ,> xs2 each tall
ncr=. <. 0.5 * +/ g2o<:g2all
cr=. 1 (<0 0) } (1+rt)$0
ixtobs=. I. (<tobs)=tall
crdone=. 0
PR=: conew'progress'
create__PR 'Finding critical region for Barnard';ncr
while. -. crdone do.
NB.  if. (<tobs) e. (I. ,cr){tall do.
  if. +./((vr tobs);tobs) e. (I. ,cr){tall do.
    crdone=. 1
    continue.
  end.
  crnext=. crtest cr
  crnexti=. I. ,crnext
  if. (sided=2) *. -. =/rt do. 
    crti=. I. ,cr +. drefl cr
    crnexti=. crnexti,. |. I. ,drefl crnext
  else. 
    crti=. I. ,cr 
  end.
  pnew=. ''
  for_t. crnexti do.
    pnew=. pnew, maxp (crti{tall),t{tall
  end.
  if. (sided=2) *. -. =/rt do.
    cradd=. (ixmin pnew){ {."1 crnexti
  else.
    cradd=. (ixmin pnew){crnexti
  end.
  cr=. (1+rt)$ 1 (cradd)},cr
  tick__PR''
end.
destroy__PR''
if. (sided=2) *. -. =/rt do. crt=. cr +. drefl cr else. crt=. cr end.
P=. maxph (I. ,crt){tall
if. (sided=2) *. =/rt do. P=. 1<.2*P end.
P
)

barnardf=: 3 : 0
NB. y is a 2x2 table, default is 2-sided
2 barnardf y
:
tobs=. y
fo=. fisher ,tobs
rt=. +/"1 tobs
lt=. </({."1 tobs)%rt
PR=: conew'progress'
create__PR 'Finding critical region for Barnard';3
tall=. alltab rt
tick__PR''
if. (1=x) do. 
  ltall=. ,> plower each tall
  if. lt do. tall=. ltall#tall else. tall=. (-.ltall)#tall end. 
end.
fall=. ,>fisher each , each tall
tick__PR''
tall=. (fall <: fo) # tall
P=. maxph tall
destroy__PR''
P
)

plower=: 3 : 0
</({."1 y)%+/"1 y
)

barnt=: 3 : 0
for_t. MSvar__ do.
  tab=. ". (>t),'_t_'
  d=. >}."1 }. tab
  rs=.+/"1 d
  cs=.+/ d
  nt=.+/rs
  if. RC__ do. d=. |:d end.
  csm=. 25 >: >./ +/"1 d
  if. csm do. pv=. Sided__ barnard d else. pv=. Sided__ barnardf d end.
  tab=.tab,.(<'Total'),bxv rs
  tab=.tab,(<'Total'),bxv cs,nt  
  tout 'Barnard''s exact test (',(>csm{'F';'CSM'),'-order)',LF
  tout 'Table ',(>t),LF
  tout 'Fixed ',(,>RC{'rows';'columns'),LF
  tout (bfmt tab),LF
  tout 'P(',(>Sided__{'';'one';'two'),'-sided) = ',(ft pv),LF
  if. 1=Sided__ do.
    ps=. (0{"1 d)%rs
    direc=. >(</ps){' > ';' < '
    if. RC__ do.
      succt=. (<1 0) { tab
      rn=. }.0{ tab
    else.
      succt=. (<0 1) { tab
      rn=. }.0{"1 tab
    end.
    tout 'One-sided alternative:',LF,'Proportion of ',(>succt),': ',(>0{rn),direc,(>1{rn),LF,LF
  else.
    tout LF
  end.
end.
view''
)

crtest=: 3 : 0
NB. y is current cr
crd=. $y
newr=. y +. _1|.y
newd=. y +. _1|."1 y
new=. newr+.newd
crt=. new-(new*.y)
NB.if. =/ crd do. crt=. crt* hr slt {.crd end.
NB.crt
)

maxp=: 3 : 0
NB. y is set of tables in CR
tcr=. y
pt=. pv=. ''
n=. +/rt=. +/"1 >{.tcr
nt=. #tcr
xi=. {."1 each tcr
cn=. */"1 (>xi)!(nt,2)$rt
r=. ,>{. each ct=. +/ each tcr
nmr=. n-r
for_p. 0.01*i.100 do.
  pv=. pv, +/ cn*(p^r)*(1-p)^n-r
  pt=. pt,p
end.
pm=. (ixfmax pv){pt
pt=. pv=. ''
for_p. (pm-0.01)+0.001*i.21 do.
  pv=. pv, +/ cn*(p^r)*(1-p)^n-r
  pt=. pt,p
end.
ix=. ixfmax pv
ix{pv
)


maxph=: 3 : 0
NB. y is set of tables in CR
NB. high precision maxp
tcr=. y
pt=. pv=. ''
n=. +/rt=. +/"1 >{.tcr
nt=. #tcr
xi=. {."1 each tcr
cn=. +/"1 (>xi) lnc (nt,2)$rt
r=. ,>{. each ct=. +/ each tcr
nmr=. n-r
for_p. 0.001*i.1000 do.
  pv=. pv, +/  ^cn+ (r*^.p)+(n-r)*^.(1-p)
  pt=. pt,p
end.
pm=. (ixfmax pv){pt
pt=. pv=. ''
for_p. (pm-0.001)+0.0001*i.21 do.
  pv=. pv, +/  ^cn+ (r*^.p)+(n-r)*^.(1-p)
  pt=. pt,p
end.
ix=. ixfmax pv
ix{pv
)

bayes=: 4 : 0
NB. x, prevalence; y sensitivity;specificity
prev=. x
'sens spec'=. y
ppv=. (prev*sens)%(prev*sens)+(1-prev)*(1-spec)
npv=. ((1-prev)*spec)%((1-prev)*spec)+prev*1-sens
ppv;npv
)

bindata=: 3 : 0
NB. bins data (y) according to
NB.   closed interval upper bounds (x)
NB. default is dist. for integers 0...ceiling of max of y
m=. >. >./y
(i.m+1) bindata y
:
n=.#x
ix=.(n-1)<.+/"1 y >/ x
dst=.(i.n)=/ix
if. 1<#y do.
  +/"1 dst
end.
)

binfreq=: 3 : 0
NB. frequencies for bindata output
n=. +/y
y%n
)

binomm=: 3 : 0
NB. binomial distribution
NB. x is N;p and y is obs. successes
NB. p may be a vector
:
'N p'=. x
q=. 1-p
if. N<100 do.
  a=. citemize (p^/y)*q^/N-y
  c=. citemize y!N
  r=. a*(#a)#c
else.
  a=. citemize ((^.p)*/y)+(^.q)*/(N-y)
  c=. citemize (lnf N)-(lnf y)+lnf N-y
  r=. ^a+(#a)#c
end.
)

binom=: 3 : 0
NB. binomial distribution
NB. x is N;p and y is obs. successes
:
'N p'=. x
q=. 1-p
if. N<100 do.
   (y ! N)*(p^y)*q^N-y
else.
   ^((lnf N)-(lnf y)+lnf N-y)+(y*^.p)+(N-y)*^.q
end.
)

bonf=: 4 : 0
NB. x is number of comparisons
NB. y is unadjusted p-values
NB. returns Dunn-Sidak adjusted p for p>1e_10,
NB. otherwise simple bonferroni
ps=. y<1e_10
pcs=. x*ps*y
pcl=. 1-(1-((-.ps)*y))^x
pcs+pcl
)

bootci=: 3 : 0
NB. Computes bootstrap confidence intervals
for_v. MSvar do.
  tout 'Bootstrap ',(":<.100*BSInt__),'% confidence interval, ',(":BSTrial__),' trials',LF
  tout 'Sample: ',(>v),LF
  dat=. ". locv >v
  n=. #dat
  ll=. <.(0.5*1-BSInt__)*BSTrial__
  ul=. BSTrial__-ll
  trials=. (BSTrial__,n)$ ((BSTrial__*n) samprep n){dat
  if. BSMedian__ do.
    medtr=. sortup median trials
    tout 'Median   ',(ft median dat),' (',(ft ll{medtr),', ',(ft ul{medtr),')',LF
  end.
  if. BSMean__ do.
    meantr=. sortup mmean trials
    tout 'Mean     ',(ft mean dat),' (',(ft ll{meantr),', ',(ft ul{meantr),')',LF
  end.
  if. BSVar__ do.
    vartr=. sortup mvar trials
    tout 'Variance ',(ft var dat),' (',(ft ll{vartr),', ',(ft ul{vartr),')',LF
  end.
  tout LF
end.
tout LF
view''
)

chisq=: 3 : 0
NB. Computes upper tail of Chi-square Dist.
NB. x is degrees of freedom, y is a vector
NB. of chi-square values
NB. 
:
if. even x do.
   p=. ^-y%2
   i=. 4
else.
   p=. 2* normal y^0.5
   i=. 3
end.
while. i <: x do.
   p=. p + (((y%2)^(i-2)%2)*^-y%2)% fac (i%2)-1
   i=. i+2
end.
p
)
 
chsqp=: 3 : 0
if. PartTest__ do.
   tname=. 'LR'
   partstat=. rxclr
else.
   tname=. 'X2'
   partstat=. rxcchsq
end.
for_t. MSvar__ do.
  tab=. ".(>t),'_t_'
  'r c'=.($tab)-1
  di=. (<(1+i.r);1+i.c)
  d=.>di{tab
  lr=.partstat d
  p=. ((r-1)*c-1) chisq lr
  rs=.+/"1 d
  cs=.+/ d
  nt=.+/rs
  tab=.tab,.(<'Total'),bxv rs
  tab=.tab,(<'Total'),bxv cs,nt  
  tout 'rxc ',tname,' test',LF
  tout 'Table ',(>t),LF
  tout (bfmt tab),LF
  tout tname,' = ',(ft lr),', P = ',(ft p),'(',(":(r-1)*c-1),' df)',LF,LF
  tout 'Partitions',LF,LF
  lrpart d
end.
view''
) 

chsqt=: 3 : 0
for_t. MSvar__ do.
  tab=. ".(>t),'_t_'
  'r c'=.($tab)-1
  di=. (<(1+i.r);1+i.c)
  d=. >di{tab
  x2=. rxcchsq d
  df=. (r-1)*c-1
  p=. df chisq x2
  rs=.+/"1 d
  cs=.+/ d
  nt=.+/rs
  tab=.tab,.(<'Total'),bxv rs
  tab=.tab,(<'Total'),bxv cs,nt  
  tout 'Chi-square test',LF
  tout 'Table ',(>t),LF
  tout (bfmt tab),LF
  tout 'X2 = ',(ft x2),', P = ',(ft p),' (',(":df),' df)',LF,LF
end.
view'' 
)

cibin=: 3 : 0
NB. Binomial confidence interval
NB. x is 1-alpha; y is s n
0.95 cibin y
:
a=.0.5*1-x
's n'=. y
if. s=0 do.
   0,1-a^%n
   return.
end.
if. s = n do.
   (a^%n),1
   return.
end.
'pl pu'=. x cibinz y
min=. 0
max=. 1
e=. a-lbpcibin s,n,pl
while. (1e_6<|e)  do.
  if. e<0 do.
    max=. pl
  else.
    min=. pl
  end.
  pl=. 0.5*min+max
  e=. a-lbpcibin s,n,pl
end.    
min=. 0
max=. 1
e=. a-ubpcibin s,n,pu
while. (1e_6<|e)  do.
  if. e<0 do.
    min=. pu
  else.
    max=. pu
  end.
  pu=. 0.5*min+max
  e=. a-ubpcibin s,n,pu
end.
pl,pu
)

cibinz=: 3 : 0
NB. Normal approx. to 95% binomial confidence interval
NB. x is 1-alpha; y is s n
0.95 cibinz y
:
z=.invnorm 0.5*1-x
's n'=. y
a=. n*n+z^2
s=.(s-0.5),s+0.5
b=.-n*(2*s)+z^2
c=.s^2
q=.(b^2)-4*a*c
(-b%2*a)+(_1 1)*(q^0.5)%2*a
)

cocharm=: 3 : 0
NB. Cochran-Armitage test
xi=. 0{"1 y
t=. }."1 y
nip=. +/"1 t
n=. +/nip
p1i=. (0{"1 t)%nip
pp1=. (+/ 0{"1 t)%n
xb=. (+/nip*xi)%n
b=. (+/nip*(p1i-pp1)*(xi-xb))%+/nip*(xi-xb)^2
ph1i=. pp1+b*(xi-xb)
x2t=. ((b^2)%(pp1*1-pp1))*+/nip*(xi-xb)^2
x2m=. (%pp1*1-pp1)*+/nip*(p1i-ph1i)^2
x2t,x2m,b
)

cochran=: 3 : 0
for_t. MSvar__ do.
  tab=. ".(>t),'_t_'
  if. (</$tab) do. tab=. |:tab end.
  'r c'=.($tab)-1
  di=. (<(1+i.r);1+i.c)
  d=.>di{tab
  xi=. __ ". >}.0{"1 tab
  if. __ e. xi do. xi=. i.r end.
  'x2t x2m b'=. cocharm xi,.d
  pt=. 1 chisq x2t
  pm=. (r-2) chisq x2m
  rs=.+/"1 d
  cs=.+/ d
  nt=.+/rs
  tab=.tab,.(<'Total'),bxv rs
  tab=.tab,(<'Total'),bxv cs,nt  
  tout 'Cochran-Armitage test',LF
  tout 'Table ',(>t),LF
  tout (bfmt tab),LF
  tout 'X2 (trend) = ',(ft x2t),', P = ',(ft pt),' (1 df)',LF
  tout 'X2 (model) = ',(ft x2m),', P = ',(ft pm),' (',(":r-2),' df)',LF
  tout 'Slope ',(ft b),LF,LF
end.
view'' 
)

comb=: 4 : 0
NB. Combinations algorithm from R. Hui
NB. returns matrix of all possible combinations choosing x from y
z=.1 0$k=.i.#c=.1,~(y-x)$0
for. i.x do. z=.;k,.&.>(-c=.+/\.c){.&.><1+z end.
)

conover2=: 3 : 0
tout'Conover squared-rank test for variances',LF
tout 'Samples: ',(>{.TSvar__),', ',(>{: TSvar__),LF
'x y'=. ". each locv each TSvar__
'T T1 p'=. x con2 y
tout'T = ',(ft T),'  T1 = ',(ft T1),LF
tout 'P(',(>Sided__{SidedN__),') = ',(ft 1<.Sided__*p),LF
if. 1=Sided__ do.
  direc=. >(T1<0){' > ';' < '
  tout 'One-sided alternative: ',(>0{TSvar__),direc,(>1{TSvar__),LF,LF
else.
  tout LF
end.
view''
)

conover=: 3 : 0
NB. Conover k-sample test
y=.". each locv each MSvar__
ni=. ,># each y
N=. +/ni
dout=. 'Group';'N';'Mean';'S.D.'
i=. 0
s=. $y
while. i < s do.
   dout=. dout,(i{MSvar__),dstt >i{y
   i=. i+1
end.
dout=.((s+1),4)$dout
tout 'Conover k-sample test',LF
tout bfmt ft each dout
tout LF
't2 p df'=. conk y
tout ('X2 = '), (ft t2),'   df = ',(":df),'   P = ', (ft p),LF,LF
view''
)

con2med=: 4 : 0
NB. Conover test
NB. x and y are samples
NB. result is T; T*; one-sided P
n=. #x
m=. #y
N=. n+m
xm=. median x
ym=. median y
U=. |x-xm
V=. |y-ym
R=. rank U,V
RU=. n{.R
T=. +/RU^2
R2m=. (+/R^2)%N
T1=. (T-n*R2m)% %:(((n*m)%N*N-1)*+/R^4)-((n*m)%N-1)*R2m^2
p=. normal T1
T;T1;p
)

con2=: 4 : 0
NB. Conover test based on mean
NB. x and y are samples
NB. result is T; T*; one-sided P
n=. #x
m=. #y
N=. n+m
xm=. mean x
ym=. mean y
U=. |x-xm
V=. |y-ym
R=. rank U,V
RU=. n{.R
T=. +/RU^2
R2m=. (+/R^2)%N
T1=. (T-n*R2m)% %:(((n*m)%N*N-1)*+/R^4)-((n*m)%N-1)*R2m^2
p=. normal T1
T;T1;p
)

conk=: 3 : 0
NB. Conover test for k samples
NB. y is boxed data
NB. result is T2; p; df
NB.y=. ". each locv each MSvar__
yd=. adiff each y
ni=. ,># each y
nii=. %ni
N=. +/ni
ry=. ni bxv rank ;yd
s=. ;(+/) each *: each ry
sm=. (+/ s)%N
t2=. (+/(*:s)%ni) - N*sm^2
d2=. ((+/(;ry)^4)-N*sm^2)%N-1
t2=. t2%d2
t2;((_1+#y) chisq t2);_1+#y
)

conkm=: 3 : 0
NB. Conover test for k samples, based on mean
NB. y is boxed data
NB. result is T2; p; df
NB.y=. ". each locv each MSvar__
yd=. adiffm each y
ni=. ,># each y
nii=. %ni
N=. +/ni
ry=. ni bxv rank ;yd
s=. ;(+/) each *: each ry
sm=. (+/ s)%N
t2=. (+/(*:s)%ni) - N*sm^2
d2=. ((+/(;ry)^4)-N*sm^2)%N-1
t2=. t2%d2
t2;((_1+#y) chisq t2);_1+#y
)

adiff=: 3 : 0
ym=. median y
|y-ym
)

adiffm=: 3 : 0
ym=. mean y
|y-ym
)

NB. Combinations sum algoritm from R. Hui, choosing x from y
cs2=: 4 : '((2!x)+i.0>.1+x*y-x) ,. x cs2a y'

cs2a=: 4 : 0 M.
 if. (x>:y)+.1>:x do. ((y*1=x)>.x<:y)$1 
 else. (m{.x cs2a&<:y) + (-m){.x cs2a y-1 [ m=. 1+x*y-x end.
)

desc=: 3 : 0
Var=.locv each MSvar__
Nsmp=.#MSvar__
if. 0=Ntile__ do.
  nthead=.''
else.
  nthead=.(":Ntile__),'-tile'
end.
if. 2=Ntile__ do.
  nthead=.'Median'
end.
datout=.'Sample';'N';'Mean';'Std. dev.';nthead;'Min';'Max'
I=.0
while. I < Nsmp do.
   dat=.".>I{Var
   datout=.datout,(I{MSvar__),(dstt dat),(Ntile__ ntile dat),(<<./dat),(<>./dat)
   I=.I+1
end.
datout=.((Nsmp+1),7)$datout
tout 'Descriptive statistics',LF
tout (bfmt ft each datout),LF,LF
view''
)

desct=: 3 : 0
Var=.locv each MSvar__
Nsmp=.#MSvar__
if. 0=Ntile__ do.
  nthead=.''
else.
  nthead=.(":Ntile__),'-tile'
end.
if. 2=Ntile__ do.
  nthead=.'Median'
end.
datout=.'Sample';'N';'Mean';'Std. dev.';'Total';nthead;'Min';'Max'
I=.0
while. I < Nsmp do.
   dat=.".>I{Var
   datout=.datout,(I{MSvar__),(dstt dat),(<+/dat),(Ntile__ ntile dat),(<<./dat),(<>./dat)
   I=.I+1
end.
datout=.((Nsmp+1),8)$datout
tout 'Descriptive statistics',LF
tout (bfmt ft each datout),LF,LF
view''
)

diag=: (<0 1)&|:	
mp=: +/ . *	

dstt=: 3 : 0
NB. Returns the number, mean, and st. dev. of vector
n=.#y
n;(mean y);((n%n-1)*var y)^0.5
)

fac=:^&lnf

fdr=: 3 : 0
NB. returns q-values for ordered list of p-values
NB. bounded by 1
m=. #y
1<.m*y%(1+i.m)
)

fisher=: 3 : 0
NB. Computes p-value for one-sided
NB. Fisher's exact test, 
NB. where table is 2 2$a,b,c,d
NB. y is a,b,c,d
'a b c d'=. y
p=. 0
if. (a*d) > (b*c) do.
   v=. 1 _1 _1 1
else.
   v=. _1 1 1 _1
end.
while. (<./ y) >: 0 do.
   p=. p + hyg y
   y=. y + v
end.
p
)

fisher2=: 3 : 0
NB. Computes two-sided p-value for
NB. Fisher's exact test,
NB. where table is 2 2$a,b,c,d
NB. y is a,b,c,d
'a b c d'=. y
a0=.a
p1=. fisher y
pt=. hyg y
r1=.a+b
r2=.c+d
c1=.a+c
c2=.b+d
if. (r1=r2) +. (c1=c2) do.
   1<.2*p1
   return.
end.
if. (a*d) > b*c do.
   if. a > d do.
      d=. 0
      c=. r2
      b=. c2
      a=. r1 - b
   else.
      a=. 0
      b=. r1
      c=. c1
      d=. r2 - c
   end.
else.
   if. b > c do.
      c=. 0
      a=. c1
      d=. r2
      b=. r1 - a
   else.
      b=. 0
      a=. r1
      d=. c2
      c=. r2 - d
   end.
end.
if. (a*d) < (b*c) do.
   v=. 1 _1 _1 1
else.
   v=. _1 1 1 _1
end.
y=. a,b,c,d
p=. hyg y
p2=.0
while. (p <: pt) *. (a0 ~: 0{y) do.
   p2=. p2 + p
   y=. y + v
   p=. hyg y
end.
p2+p1
)

fisherp=: 3 : 0
NB. Combines p values from distinct experiments
NB. into a single Chi-square value by the method
NB. of Fisher.  y is a vector of p-values.
n=. $y
x2=.-2 * +/^. y
tout 'Fisher''s method for combining P-values',LF
tout 'P-values:  ', (": y), LF
tout 'X2 = ',(ft x2),' (',(":2*n),' df)','   P = ',(ft (2*n) chisq x2),LF
tout LF,LF
view''
)

fisherss=: 3 : 0
NB. Fisher sample size per Casagrande et al.
NB. y is alpha;sided;beta;p1;p2 (p1>p2)
'a s b p1 p2'=. y
if. s=2 do.
  a=.a%2
end.
za=. invnorm a
zb=. invnorm b
A=. ((za*(2*(0.5*p1+/p2)*1-0.5*p1+/p2)^0.5) +zb*((p1*1-p1)+/p2*1-p2)^0.5)^2
A*((1+(1+(4*p1-/p2)%A)^0.5)^2)%4*(p1-/p2)^2
)

fishrt=: 3 : 0
Var=. loct each MSvar__
for_t. MSvar__ do.
  tab=. ".(>t),'_t_'
  'r c'=.($tab)-1
  di=. (<(1+i.r);1+i.c)
  d=.>di{tab
  if. Sided__=1 do.
    p=.fisher ,d
  else.
    p=.fisher2 ,d
  end.
  rs=.+/"1 d
  cs=.+/ d
  nt=.+/rs
  tab=.tab,.(<'Total'),bxv rs
  tab=.tab,(<'Total'),bxv cs,nt  
  tout 'Fisher''s exact test',LF
  tout 'Table ',(>t),LF
  tout (bfmt tab),LF
  tout 'P(',(>Sided__{SidedN__),') = ',(ft p),LF
  if. 1=Sided__ do.
    ps=. (0{"1 d)%rs
    direc=. >(</ps){' > ';' < '
    succt=. (<0 1) { tab
    rn=. }.0{"1 tab
    tout 'One-sided alternative:',LF,'Proportion of ',(>succt),': ',(>0{rn),direc,(>1{rn),LF,LF
  else.
    tout LF
  end.
end.
view'' 
)

gam=: ^&lng

gfit=: 3 : 0
'obs exp'=. ". each locv each TSvar__
'freq pdf'=. y
no=. +/obs
if. freq do.
  exp=. no*exp
end.
x2=. +/((obs-exp)^2)%exp
df=. (#obs)-pdf+1
tout 'Chi-square goodness of fit test',LF
tout (bfmt |: ((<(,>{.TSvar__),' (Observed)'),bxv obs),.(<(,>}.TSvar__),' (Expected)'),bxv exp),LF
tout 'X2 = ',(ft x2),' P = ',(ft df chisq x2),' (',(":df),' degrees of freedom)',LF,LF
view''
)

hyg=: 3 : 0
NB. Computes probability for a 2x2 table
NB. where the table is 2 2$a,b,c,d
NB. y is a,b,c,d
'a b c d'=. y
n=. +/y
p=. (lnf(a+b))+(lnf(c+d))+(lnf(a+c))+lnf(b+d)
p=. p - (lnf(a))+(lnf(b))+(lnf(c))+(lnf(d))+lnf(n)
^p
)

hyperg=: 4 : 0
NB. Hypergeometric distribution
NB. x is N;p;k
NB. y is s
'N p k'=. x
f=. (lnf(p*N))+(lnf(N*1-p))+(lnf(k))+lnf(N-k)
f=. f - (lnf y)+(lnf((N*p)-y))+(lnf(k-y))+(lnf(N*1-p)-(k-y))+lnf N
^ f
)

hypergm=: 4 : 0
NB. Hypergeometric distribution
NB. x is N;p;k with N or p (but not both) vectors
'N p k'=. x
a=. y!/N*p
b=. (k-y)!/N*1-p
c=. citemize k!N
f=.(a*b)%(#a)#c
if. 2>$$f do. f=. citemize f else. f=. |:f end.
)


hypergm1=: 4 : 0
NB. Hypergeometric distribution
NB. x is N;p;k with p or k (not both) vectors
NB. y is s
'N p k'=. x
q=. 1-p
n=. (lnf(p*N))+(lnf(N*q))+(lnf(k))+lnf(N-k)
d1=. citemize (lnf N)+/lnf y
d2=. citemize lnf (N*p)-/y
d3=. citemize lnf k-/y
if. (1<#p) +. (1<#N) do. 
  d4=. d2+((#d2)#d3) + lnf (N*q) -/ (k-y)
elseif. 1<#k do.
  d4=. d3+((#d3)#d2) + lnf (N*q)- (k-/y) 
elseif. do.
  d4=. d3+d2+ citemize lnf (N*q)-(k-y)
end.
if. 1<#N do. d=. d4+d1 else. d=. d4+((#d4)#d1) end.
^(($d)$({:$d)#n)-d
)

invnorm=: 3 : 0
NB. Inverse normal (from Abramowitz and Stegun)
NB. y is scalar or vector of alpha (upper tail)
s=.(y>0.5)
a=.|s-y
t=.(^.%a^2)^0.5
n=. 2.515517+(0.802853*t)+0.010328*t^2
d=.1+(1.432788*t)+(0.189269*t^2)+0.001308*t^3
z=.t-n%d
((-.s)*z)-s*z
)

invt=: 4 : 0
NB. Inverse t dist (Hill ACM 296)
NB. x is df;y is two-tailed p;both scalars
n=.x
if. 1=n do.
  t=. % 3 o. (o. y%2)
  return. 
end.
if. 2=n do.
  t=. %: (2%(y*2-y))-2
  return.
end.
a=. %n-0.5
b=. 48%a^2
c=. 96.36+((((20700*a%b)-98)*a)-16)*a
d=. (1+((94.5%b+c)-3)%b)*(%:a*o. 0.5)*n
xx=. d*y
yy=. xx^2%n
if. yy>0.05+a do.
  xx=. invnorm 0.5*y
  yy=. xx^2
  if. n<5 do. c=. c+ 0.3*(n-4.5)*xx+0.6 end.
  c=. b+c+ _2+xx*_7+xx*_5+0.05*d*xx
  yy=. xx*1+  (((94.5+yy*36+y*(6.3+yy*0.4))%c)-yy+3)%b
  yy=. a*yy^2
NB.  if. yy>0.002 do. yy=. _1+^yy else. yy=. yy+0.5*yy^2 end.
  if. yy>0.1 do. yy=. _1+^yy else. yy=. yy+(yy%24)*yy*12+yy*4+yy end.
else.
  yy=. (%yy)+((n+1)%n+2)* _1+yy* %((((n+6)%n*yy)-(0.89*d)+0.822)*(n+2)*3)+%2*n+4
end.
t=. %:n*yy
)

jacobi=: 3 : 0
NB. jacobi's method for eigenvalues and vectors
NB. form: [tolerance] jacobi mat
NB. default tolerance 1e_5
NB. returns: eigenvalues;eigenvectors
1e_5 jacobi y
:
r=. y
'argument should be a matrix' assert 2=#$r
'argument should be symmetric' assert r -: |: r
'argument should be real' assert r -: + r
ir=. i.#r
q=. id=. =ir
diag=. (<0 1)&|:
len=. +/&.(*:"_)
imax=. i.>./
utm=. ,</~ir
mp=. +/ .*
ndx=. ,{;~ir
perm=. 0 0&{ ; ] ; |. ; 1 1&{  
sign=. _1: ^ <&0
count=. 0 
while. 
  big=. imax utm * |,r
  ind=. big { ndx
  p=. -ind { r 
  (x < |p) *. big > 0
do.
  u=. -: -/ (>ind) { diag r
  v=. len p,u
  cos=. %: (v+|u) % +:v
  sin=. (sign u) * p % +: v * cos
  s=. ((cos,-sin),sin,cos) (perm >ind) } id
  r=. s mp r mp |:s
  q=. q mp |:s
  count=. >:countW
end.
r=. diag r
inx=. \:r
(inx{r);inx{"1 q
)

jonckt=: 3 : 0
NB. Jonckheere-Terpstra test
y=. ". each locv each MSvar__
s=. $y
i=. 0
W=. 0
while. i < (s-1) do.
   Xi=. >i{y
   j=.i+1
   while. j < s do.
      Xj=. >j{y
      W=. W + +/+/"1 Xi </ Xj
      W=. W + 0.5*+/+/"1 Xi =/ Xj
      j=. j+1
   end.
   i=. i+1
end.
N=. +/ ni=. ,>$&.>y
EW=. 0.25 * ((N^2) - +/ni^2)
tj=. ties openvec y
VW=. ((N*(N-1)*5+2*N)-(+/ni*(ni-1)*5+2*ni)++/tj*(tj-1)*5+2*tj)%72
VW=. VW+((+/ni*(ni-1)*ni-2)*(+/tj*(tj-1)*tj-2))%36*N*(N-1)*N-2
VW=. VW+((+/ni*ni-1)*+/(tj*tj-1)%8*N*N-1)
z=.(W - EW)%VW^0.5
p1=. normal z
dout=. 'Group';'N';'Mean';'St. Dev.'
i=. 0
while. i < s do.
   dout=. dout,(i{MSvar__),dstt >i{y
   i=. i+1
end.
dout=.((s+1),4)$dout
tout 'Jonckheere-Terpstra test',LF
tout bfmt ft each dout
tout LF,'W* = ',(ft z),'     P(',(>Sided__{SidedN__),') = ',(ft Sided__*p1),LF
if. 1=Sided__ do.
  direc=. >(z<0){'increasing';'decreasing'
  tout 'One-sided alternative: ',(blist MSvar__),' in ',direc,' order',LF,LF
else.
  tout LF
end.
view''
)

ken=: 3 : 0
NB. Computes Kendall's rank correlation statistic
'x y'=. ". each locv each TSvar__
nx=.#x
ny=.#y
xs=. sortup x
ys=. ((i.#y) indxbyy x){y
k=.0.5*+/,*(x-/x)*(y-/y)
t=. 2 * k % nx * nx-1
tx=. ties x
ty=. ties y
vk=. (%18)*(nx*(nx-1)*5+2*nx)-(+/tx*(tx-1)*(5+2*tx))++/ty*(ty-1)*5+2*ty
vk=. vk+(%9*nx*(nx-1)*(nx-2))*(+/tx*(tx-1)*(tx-2))*+/ty*(ty-1)*ty-2
vk=. vk+(%2*nx*nx-1)*(+/tx*tx-1)*(+/ty*ty-1)
z=.k%vk^0.5
tout 'Kendall''s rank correlation test',LF
if. Concord__ do.
  dout=.(0{TSvar__),(ft each boxcols (1,nx)$xs),(1{TSvar__),ft each boxcols (1,nx)$ys
  tout bfmt |:(2,nx+1)$dout
else.
  tout bfmt (<'Variables: '),TSvar__
end.
tout LF,'K = ',(ft k),'   K* = ',(ft z),'   N = ',(":nx),LF
tout 'tau = ',(ft t),'     P (',(>Sided__{SidedN__),') = ',(ft Sided__*normal z),LF
if. 1=Sided__ do.
  direc=. >(z<0){' positively ';' negatively '
  tout 'One-sided alternative: ',LF,(>0{TSvar__),' and ',(>1{TSvar__),direc,'correlated',LF,LF
else.
  tout LF,LF
end.
view''
)

kaplan=: 3 : 0
NB. Kaplan-Meier survival analysis
'kp km kbs kci kcn'=. y
pldat=. ''
for_s. PSvar__ do.
  var=. >s
  if. (<'(None)') e. var do.
    var=. locv each var
    nd=. (<'(None)_v_')=var 
    dat=. ". each (<'') (inxb nd)}var
  else.
    dat=. ". each locv each var
  end.
  tout 'Kaplan-Meier survival',LF
  tout 'Events: ',(,>{.>s),LF
  tout 'Censored: ',(,>}.>s),LF
  tab=. 1 4$'Time';'Events';'At risk';'Survival'
  'et ct'=. dat
  't d n sur tmax'=. kmsurv dat
  if. 0=#t do.
    if. kp do.
      xv=. 0 0, 2#>./,>dat
      yv=. 4# 1
      pldat=. pldat,<xv;yv
    end.
    tout LF,LF
  else.
    res=. (bxv t),.(bxv d),.(bxv n),.(ft each bxv sur)
    tab=. tab,res
    tout bfmt tab
    tout LF
    if. km do.
      'med lb ub'=. ((kci%100);kbs) kmboot dat
      tout 'Median survival (',(":kci),'% CI; ',(":kbs),' samples): ',(":med),' (',(":lb),',',(":ub),')',LF,LF
    else.
      tout LF
    end.
    if. kp do.
      xv=.  0, ,t,.t
      yv=. }:(1 1), ,sur,.sur
      if. tmax>{:t do.
        xv=. xv,tmax
        yv=. yv,{:sur
      end.
      if. kcn *. 0<#ct do.
        xi=. +/ xv </ ct
        yc=. ,xi{yv
        xc=. ,ct
      else.
        xc=. yc=. ''
      end.
      pldat=. pldat,<xv;yv;xc;yc
    end.
  end.
end.
view''
if. kp do.
  'km' makeplot pldat
end.
)
  

kmboot=: 3 : 0
NB. CI for KM median
NB. x is (1-alpha);bootstrap samples
NB. y deaths;censored
NB. returns median;lb;ub
(0.95;1000) kmboot y
:
'ci ntrial'=. x
'd c'=. y
tm=. d,c
if. 0.5>(#d)%#tm do.
  res=. _;_;_
  return.
end.
'etime nd n surv tmax'=. kmsurv d;c
etime=. ,etime
surv=. ,surv
if. 0.5 e. surv do.
  is50=. ftrue 0.5=surv
  if. 1<#is50  do. med=. 0.5*(is50{etime)+((1+is50){etime) else. med=. is50{etime end.
else.
  med=. (ftrue 0.5>surv){etime
end.
del=. ((#d)#1),((#c)#0)
samp=. , each ,boxcols |:tm,.del
n=. #samp
trials=. (ntrial,n)$ ((ntrial*n) samprep n){samp
medtr=. ''
for_t. trials do.
  dat=: >t
  dtime=. ({:"1 dat)#{."1 dat
  ctime=. (-.{:"1 dat)#{."1 dat
  if. 0.5>:(#dtime)%#dat do.
    medtr=. medtr,_
    continue.
  end.
  'etime nd n surv tmax'=. kmsurv dtime;ctime
  etime=. ,etime
  surv=. ,surv
  if. 0.5 e. surv do.
    is50=. ftrue 0.5=surv
    medtr=. medtr, 0.5*(is50{etime)+((1+is50){etime)
  else.
    medtr=. medtr, (ftrue 0.5>surv){etime
  end.
end.
medtr=. sortup medtr
ll=. <.(0.5*1-ci)*ntrial
ul=. ntrial-ll
med;(ll{medtr);(ul{medtr)
)

kmsurv=: 3 : 0
NB. computes Kaplan-Meier survival prob.
NB. input is deaths;censored
NB. output is time;deaths;at risk;survival p
'dt ct'=. y
evt=. dt,ct
tm=. >./evt
devnt=. nubcount sortup dt
dtime=. >{."1 devnt
di=. >{:"1 devnt
ni=. +/ evt >:/ dtime
p=. */\1-di%ni
dtime;di;ni;p;tm
)

kwal=: 3 : 0
NB. Kruskal Wallis test
y=.". each locv each MSvar__
ni=. ,># each y
N=. +/ni
rx=. ni bxv rank ;y
R=. >+/ each rx
S2=. ((+/(;rx)^2) - 0.25*N*(N+1)^2)%N-1
T=. ((+/ (R^2)%ni)-0.25*N*(N+1)^2)%S2
p=. ((#ni)-1) chisq T
dout=. 'Group';'N';'Mean';'S.D.'
i=. 0
s=. $y
while. i < s do.
   dout=. dout,(i{MSvar__),dstt >i{y
   i=. i+1
end.
dout=.((s+1),4)$dout
tout 'Kruskal-Wallis Test',LF
tout bfmt ft each dout
tout LF
tout ('X2 = '), (ft T),'   df = ',(":(#ni)-1),'   P = ', (ft p),LF,LF
view''
)

lbpcibin=: 3 : 0
NB. compute binomial p for lower bound of ci
's n pl'=: y
if. 0.5<s%n do.
  +/(n,pl) binom s+i.1+n-s
else.
  1-+/(n,pl) binom i.s
end.
)

lehman=: 3 : 0
NB. Lehman's method for combining rank sum tests
NB. y is set of sample pairs corresponding to one or more experiments
NB. returns 1-sided p-value
dat=. ((-:#y),2) $ y
W=. EW=. VW=. 0
for_e. dat do.
  'a b'=. e
  na=. #a
  N=. na+nb=. #b
  r=. rank a,b
  W=. W+(+/ na{.r)%N+1
  EW=. EW+(-:na*N+1)%N+1
  VW=. VW+((na*nb*(+/r^2)%N*N-1)-(na*nb*(N+1)^2)%4*N-1)%(N+1)^2
end.
normal (W-EW)%%:VW
)

lnc=: 4 : 0
(lnf y)-(lnf x)+lnf y-x
)

lnf=: 3 : 0
NB. Uses Lanczos' approximation to the gamma
NB.  function to compute the ln of !y
NB. From Numerical Recipes, Press et al.
r=. ((y+0.5)*^. y+5.5)-(y+5.5)
s=. 1.0 + (76.18009173%y+1) + (_86.50532033%y+2)
s=. s + (24.01409822%y+3) +(_1.231739516%y+4)
s=. s + (0.120858003e_2%y+5) + (_0.536382e_5%y+6)
r + ^. 2.50662827465*s
)

lng=: 3 : 0
NB. Uses Lanczos' approximation to the gamma
NB.  function 
y=. y-1
r=. ((y+0.5)*^. y+5.5)-(y+5.5)
s=. 1.0 + (76.18009173%y+1) + (_86.50532033%y+2)
s=. s + (24.01409822%y+3) +(_1.231739516%y+4)
s=. s + (0.120858003e_2%y+5) + (_0.536382e_5%y+6)
r + ^. 2.50662827465*s
)

logrank=: 3 : 0
ngrp=. #PSvar__
samp=. >PSvar__
dt=. locv each {."1 samp
if. (<'(None)_v_') e. dt do.
  nd=. (<'(None)_v_')=dt
  dt=. (<'') (inxb nd) } dt
end.
dt=. ". each dt
ct=. locv each {:"1 samp
if. (<'(None)_v_') e. ct do.
  nd=. (<'(None)_v_')=ct
  ct=. (<'') (inxb nd) } ct
end.
ct=. ". each ct
dat=. |:dt,.ct
's Oi Ei'=. lgrnk , each boxcols dat
tout 'Logrank Test',LF
tout bfmt 'Samples (event,cens.): ';> ',' unchop each PSvar__
tout LF,LF
oe1=. ({.Oi)%{.Ei
oe=. (Oi%Ei)%oe1
evname=. >{. each PSvar__
out=. 1 4$'';'Observed';'Expected';'Hazard Ratio'
out=. out,'Group';'events';'events';'(rel. group 1)'
out=. out,(>evname);(> ": each bxv Oi);(> ft each bxv Ei);(>ft each bxv oe)
tout (bfmt out),LF
if. Sided__=1 do.
  s=. {. s
  tout 'M = ',(ft s),', P(one-sided) = ',(ft normal s),LF
  direc=. >(s<0){' > ';' < '
  evname
  tout 'One-sided alternative: ',(>0{evname),direc,(>1{evname),LF,LF
 
else.
  tout 'X2 (',(":ngrp-1),' df): ',(ft s),', P(two-sided) = ',(ft (ngrp-1) chisq s),LF,LF
end.
view''
)

lgrnk=: 3 : 0
NB. logrank test
NB. y is (event1;cen1);(event2;cen2);...
NB. returns X2;Oi;Ei
ngrp=. # y
samp=. >y
dt=. {."1 samp
devnt=. nubcount sortup unbox dt
dtime=. >{."1 devnt
K=. #dtime
dk=. >{:"1 devnt
evti=. unbox each y
ni=. >+/ each (>:/&dtime) each evti
Nk=. +/ (unbox evti) >:/dtime
di=. >+/ each (=/&dtime) each dt
Oi=. +/"1 di
Ei=. +/"1 ni*(ngrp,K)$dk%Nk
if. 1=Sided__ do.
  vi=. (dk*(Nk-dk)**/ni)%(Nk^2)*(Nk-1)
  m=. (Oi-Ei)%%:+/vi
  r=. m;Oi;Ei
else.
  x2=. +/ ((Oi-Ei)^2)%Ei
  r=. x2;Oi;Ei
end.
r
)

lrpart=: 3 : 0
tab=. y
'r c'=. $tab
d=. (<(i.2);i.2){tab
lrpout d
for_i. 2+i.r-2 do.
  r1=. +/ (<(i. i);0 1){tab
  r2=. (<i;0 1){tab
  d=. (,:"1 r1),r2
  lrpout d
end.
for_j. 2+i.c-2 do.
  c1=. +/"1 (<0 1;i.j){tab
  c2=. (<0 1;j){tab
  d=. c1,.c2
  lrpout d
end.
for_i. 2+i.r-2 do.
  for_j. 2+i.c-2 do.
    x00=.+/+/(<(i.i);i.j){tab
    x01=.+/(<(i.i);j){tab
    x10=.+/(<i;i.j){tab
    x11=.(<i;j){tab
    lrpout 2 2$x00,x01,x10,x11
  end.
end.
)

lrpout=: 3 : 0
if. PartTest__ do.
   tname=. 'G2'
   partstat=. rxclr
else.
   tname=. 'X2'
   partstat=. rxcchsq
end.
lr=. partstat y
tout bfmt (":y);tname,' = ',(ft lr),', P = ',(ft 1 chisq lr)
tout LF,LF
)

mantel=: 3 : 0
NB. Mantel-Haenszel test
xi=. ri=. ci=. Ni=. ''
out=. 'Mantel-Haenszel test',LF,(":#MSvar),' tables.',LF
for_t. MSvar__ do.
  tab=. ".loct >t
  'r c'=.($tab)-1
  di=. (<(1+i.r);1+i.c)
  d=. >di{tab
  rs=.+/"1 d
  cs=.+/ d
  nt=.+/rs
  tab=.tab,.(<'Total'),bxv rs
  tab=.tab,(<'Total'),bxv cs,nt  
  xi=. xi,(< 0 0){d
  ri=. ri,0{rs
  ci=. ci,0{cs
  Ni=. Ni,nt
  out=. out,'Table ',(>t),LF
  out=. out,(bfmt tab),LF,LF
end.
M=. ((+/xi)-+/ri*ci%Ni)%(+/(ri*ci*(Ni-ri)*Ni-ci)%Ni^3)^0.5
out=. out,'M = ',(ft M),'  P(',(>Sided__{SidedN__),') = ',(ft Sided__*normal M),LF
tout out
if. 1=Sided__ do.
  ps=. (0{"1 d)%rs
  direc=. >(</ps){' > ';' < '
  succt=. (<0 1) { tab
  rn=. }.0{"1 tab
  tout 'One-sided alternative:',LF,'Proportion of ',(>succt),': ',(>0{rn),direc,(>1{rn),LF,LF
else.
  tout LF
end.
view''
)


mcnemar=: 3 : 0
NB. McNemar's test for paired data
NB. y is table 2 2$a b c d
NB. where a and d represent concordant observations
NB. exact p value
NB. returns lower tail value
'a b c d'=. y
n=. b+c
x=. b<.c
+/ (n,0.5) binom i.x+1
)


mcnemss=: 3 : 0
NB. McNemar sample size per Dupont
NB. y is alpha;sided;beta;p0;OR;Corr;M
NB. if Corr and M are elided, they are assumed to be 0 and 1
'a s b p0 o c M'=. 7{. y,(0;1)
if. s=2 do.
  a=.a%2
end.
za=. invnorm a
zb=. invnorm b
q0=. 1-p0
p1=. (2*o*p0*q0+o*p0)+(p0*q0**:c*o-1)-c*p0*q0*(o-1)*%:(4*o)+*:c*o-1
p1=. p1%2*(*:q0+o*p0)+p0*q0**:c*o-1
q1=. 1-p1
p0p=. p0+c*%:q1*p0*q0%p1
p0m=. p0-c*%:p1*p0*q0%q1
q0p=. 1-p0p
q0m=. 1-p0m
m=. 1+i.M
tm=. ((p1*/((m-1)!M))*(p0p^/m-1)*q0p^/1+M-m)+(q1*/(m!M))*(p0m^/m)*q0m^/M-m
om=. o*/m
eo=. +/"1 tm*($tm)$,om%om+($om)$1+M-m
e1=. +/"1 tm*($tm)$m%1+M
vo=. +/"1 tm*($tm)$,(om*($om)$1+M-m)%*:om+($om)$1+M-m
v1=. +/"1 tm*($tm)$(m*1+M-m)%*:1+M
*:((zb*%:vo)+za*%:v1)%e1-eo
)

mcnemt=: 3 : 0
Var=. loct each MSvar__
for_t. MSvar__ do.
  tab=. ".(>t),'_t_'
  'r c'=.($tab)-1
  di=. (<(1+i.r);1+i.c)
  d=.>di{tab
  p=. Sided__*mcnemar ,d
  n01=. (<0 1){d
  n10=. (<1 0){d
  OR=. n01%n10
  CI=. cibin n01,n01+n10
  CI=. CI%1-CI
  rs=.+/"1 d
  cs=.+/ d
  nt=.+/rs
  tab=.tab,.(<'Total'),bxv rs
  tab=.tab,(<'Total'),bxv cs,nt  
  tout 'McNemar''s test',LF
  tout 'Table ',(>t),LF
  tout (bfmt tab),LF
  tout 'P(',(>Sided__{SidedN__),') = ',(ft p),LF
  if. 1=Sided__ do.
    direc=. >(OR>1){'<';'>'
    tout 'One-sided alternative (Proportion of ',(>(<1 0){tab),'): rows ',direc,' columns',LF
  end.
  tout 'OR = ',(ft OR),'; 95% Conf. limits (',(ft 0{CI),', ',(ft 1{CI),')',LF,LF
end.
view'' 
)

mean=: 3 : 0
NB. Computes the mean of a vector, y
   (+/y)%#y
)

meanci=: 4 : 0
NB. x is CI;y is data
NB. returns lb,mean,ub for x% CI
'n m s'=. dstt y
t=. (n-1) invt 0.01*100-x
dif=. t*s%%:n
(m-dif),m,m+dif
)

median=: 3 : 0
NB. median for vector or for each row of a matrix
s=. sortuprow y
n=. {:$ s
if. even n do.
  m=. 0.5*+/"1 ((<:-:n),-:n){"1 s
else.
  m=. (-:<:n){"1 s
end.
)

miller=: 3 : 0
tout 'Miller variance jackknife test',LF
NB.tout 'Samples: ',(>{.TSvar__),', ',(>{: TSvar__),LF
'x y'=. ". each locv each TSvar__
'VR q p1'=. x millert y
res=.3 4$('Sample';'N';'Mean';'St. dev.'),((>0{TSvar__);ft each dstt x),((>1{TSvar__);ft each dstt y)
tout (bfmt res),LF
tout 'Variance ratio = ',(ft VR),'   Q = ',(ft q),LF
tout 'P(',(>Sided__{SidedN__),') = ',(ft 1<.Sided__*p1),LF
if. 1=Sided__ do.
  direc=. >(VR<1){' > ';' < '
  tout 'One-sided alternative: ',(>0{TSvar__),direc,(>1{TSvar__),LF,LF
else.
  tout LF
end.
view''
)

millert=: 4 : 0
NB. Miller jackknife variance test
NB. x and y are vectors of observations
NB. returns Variance ratio; Q; one-sided p-value
nx=. #x
ny=. #y
incx=. (-. id nx)#x
incy=. (-. id ny)#y
di2=. ((+/"1 (incx^2)) - ((+/"1 incx)^2)%nx-1)%nx-2
ej2=. ((+/"1 (incy^2)) - ((+/"1 incy)^2)%ny-1)%ny-2
si=. ^. di2
tj=. ^. ej2
s0=. ^. (nx%nx-1) * var x
t0=. ^. (ny%ny-1) * var y
A=. (nx*s0) - (nx-1)*si
B=. (ny*t0) - (ny-1)*tj
Am=. (+/A)%nx
Bm=. (+/B)%ny
v1=. +/ ((A-Am)^2)%nx*nx-1
v2=. +/ ((B-Bm)^2)%ny*ny-1
Q=. (Am-Bm) % %:v1+v2
(^Am-Bm);Q;normal Q
)

mmean=: 3 : 0
NB. mean for vector or each row of a matrix
n=. {:$y
(+/"1 y)%n
)

MAXPERMTEST=: 1.6e28
multex=: 3 : 0
NB. should rewrite for new PSvar
dat=.". each locv each ,>PSvar__
exp=. -:# dat
N=. +/"1 n=. (exp,2)$> # each dat
nx=. {."1 n
NB.tv=. +./ ,> hasties each , each > each 2 bxv dat
tv=. +./ ,> hasties each , each unbox each 2 bxv dat
ExTst=. (-. tv) *. MAXPERMTEST > */ nx!N
if. ExTst do.
  try.
    pval=. permtest dat
    tout 'Multiple experiments: Permutation test',LF
  catch.
    pval=. lehman dat
    tout 'Multiple experiments: Lehman''s test',LF
  end.
else.
  pval=. lehman dat
  tout 'Multiple experiments: Lehman''s test',LF
end.
res=. '';'';'';'';'X';'';'';'';'Y';''
res=. res,'Expt.';'W';'Sample';'N';'Mean';'S.D.';'Sample';'N';'Mean';'S.D.'
for_e. (bxv 1+i.exp),.(exp,4)$,(,>PSvar__),.dat do.
  'ex lx x ly y'=. e
  w=. +/(#x){. rank x,y
  res=. res,(<":ex),(<":w),(<lx),(ft each dstt x),(<ly),ft each dstt y
end.
tout bfmt ((exp+2),10)$res
tout LF,'Overall P-value (',(>Sided__{SidedN__),') = ',(ft 1<.Sided__*pval),LF,LF
view''
)

mvar=: 3 : 0
NB. variance for vector or each row of a matrix
n=. {:$y
((+/"1 y^2)%n)-(mmean y)^2
)

nbd=: 3 : 0
NB. Negative binomial probabilities
NB. x is m,k; y is vector of i; returns probabilities
:
'm k'=.x
((k%m+k)^k)*^(y*(^.m%m+k))+(lng k+y)-(lng k)+(lnf y)
)

nbdm=: 3 : 0
NB. Negative binomial probabilities
NB. x is m;k - y is vector of i - returns probabilities
NB. either m or k (but not both) can be vectors
:
'm k'=. x
a=. ((k%m+k)^k)
b=. citemize ((^.m%m+k)*/y)
c=. citemize (lng k+/y)-(lng k) +/ (lnf y)
if. 1<#m do. d=. ^b+(#b)#c else. d=. ^b+c end.
d*($d)$({:$d)#a
)

norm=: 3 : 0
NB. 1-F(y) for normal distribution
gz=. y> 0
|gz-normal y
)

normal=: 3 : 0
NB. Normal tail probability
NB. y is a scalar or vector of x-values; returns upper (or lower) tail probability
NB. uses normhart
if. 1=#y do.
  p=. normhart y
else.
  p=. ,> normhart each bxv y
end.
p
)

normas=: 3 : 0
NB. Normal tail probability
NB. y is a scalar or vector of x-values; returns upper (or lower) tail probability
NB. Approximation is from Abramowitz and Stegun
NB.   formula 26.2.17
NB. Accuracy to ~ 7.5e_8
y=. |y
b=.0.31938153 _0.356563782 1.781477937 _1.821255978 1.330274429
t=. %1+0.2316419*y
z=. ((2p1)^_0.5)*^_0.5**:y
p=. (0.31938153*t)+(_0.356563782*t^2)+(1.781477937*t^3)+(_1.821255978*t^4)+(1.330274429*t^5)
z*p
)

normhart=: 3 : 0
y=. |y
if. y>37 do.
  p=. 0
  return.
end.
ex=. ^-0.5**:y
if. y<7.071067812 do.
  'p0 p1 p2 p3 p4 p5 p6'=. 220.2068679123761 221.2135961699311 112.0792914978709 33.91286607838300 6.373962203531650 0.7003830644436881 0.03526249659989109
  'q0 q1 q2 q3 q4 q5 q6 q7'=. 440.4137358247522 793.8265125199484 637.3336333788311 296.5642487796737 86.78073220294608 16.06417757920695 1.755667163182642 0.08838834764831844
  num=. p0+y*p1+y*p2+y*p3+y*p4+y*p5+p6*y
  den=. q0+y*q1+y*q2+y*q3+y*q4+y*q5+y*q6+q7*y
  p=. ex*num%den
else.
  pd=. ex%%:o.2
  p=. pd%(y+1.0%(y+2.0%(y+3.0%(y+4.0%(y+0.65)))))
end.
p
)

normlog=: 3 : 0
y=. |y
if. y>37 do.
  p=. normub y
else.
  p=. 10^. normhart y
end.
p
)

normlb=: 3 : 0
y=. |y
lnp=. (^.y)-(^.1+*:y)+(0.5**:y)+(^.%:o.2)
lnp*10^.^1
)

normub=: 3 : 0
y=. |y
lnp=. -(0.5**:y)+(^.%:o.2)+(^.y)
NB.lnp*10^.^1
lnp*10^.^1
)

ntile=: 3 : 0
:
ny=. #y
y=. sort y
t=. }.((ny-1)%x)*i.x
<0.5*((<.t){y)+(>.t){y
)

permtest=: 3 : 0
NB. permutation test for difference in location
NB. y is set of sample pairs corresponding to one or more experiments
NB. returns 1-sided p-value
dat=. ((-:#y),2)$y
'x y'=. {.dat
nx=. #x
n=. nx+ny=. #y
W=. +/ nx{. rank x,y
NB.rs=. (+/"1 (1+ nx comb n))%n+1
NB.rsv=. ~. rs
NB.prsv=. (+/"1 rsv =/ rs)%(nx!n)
csv=. nx cs2 n
rsv=. (nx+ {."1 csv)%n+1
prsv=. ({:"1 csv)%nx!n
ersv=. rsv
eprsv=. prsv
eW=. W%n+1
for_s. }. dat do.
  'x y'=. s
  nx=. #x
  n=. nx+ny=. #y
  W=. +/ nx{. rank x,y
NB.  rs=. (+/"1 (1+ nx comb n))%n+1
NB.  rsv=. ~. rs
NB.  prsv=. (+/"1 rsv =/ rs)%(nx!n)
  csv=. nx cs2 n
  rsv=. (nx+ {."1 csv)%n+1
  prsv=. ({:"1 csv)%nx!n
  trs=. ersv +/ rsv
  tprs=. eprsv */ prsv
  ersv=. ~.,trs
  m=. ersv =/ ,trs
  eprsv=. +/"1 m*($m)$,tprs
  eW=. eW+W%n+1 
end.
if. eW>(-: ({.ersv)+{:ersv) do. tail=. eW<:ersv else. tail=. eW>:ersv end.
p=. +/ tail#eprsv
)

pgnbd=: 4 : 0
NB. prob. that X>Y for two nbd rv
NB. x is k, y is m1;m2 (m1>m2)
'm1 m2'=. y
k=. x
mm1=. >./m1
max=. 50>.>.mm1+7*%:mm1+mm1*mm1%k
p=.''
t=.''
for_m1i. m1 do.
  xd=. (m1i,k) nbd i. max
  for_m2i. m2 do.
    yd=. (m2i,k) nbd i. max
    fyd=. }:0,+/\yd
    p=. p,(+/xd*fyd)+0.5*+/xd*yd
    t=. t,+/(xd+yd)^3
  end.
end.
sh=. (#m1),#m2
if. 1=<./sh do.
  (citemize p);citemize t
else.
  (sh$p);sh$t
end.
)

pgnbdmk=: 4 : 0
NB. prob. that X>Y for two nbd rv
NB. x is k, y is m1;m2 (m1>m2)
'm1 m2'=. y
k=. x
mm1=. >./m1
max=. 50>.>.mm1+7*%:mm1+mm1*mm1%<./k
p=.''
t=.''
for_ki. k do.
  for_m1i. m1 do.
    xd=. (m1i,ki) nbd i. max
    for_m2i. m2 do.
      yd=. (m2i,ki) nbd i. max
      fyd=. }:0,+/\yd
      p=. p,(+/xd*fyd)+0.5*+/xd*yd
      t=. t,+/(xd+yd)^3
    end.
  end.
end.
sh=. (#k),(#m1),(#m2)
if. 1<+/sh>1 do. sh=. (sh>1)#sh else. sh=. }:sh end.
NB.if. 1=<./sh do.
NB.  (citemize p);citemize t
NB. else.
  (sh$p);sh$t
NB.end.
)

pgnorm=: 4 : 0
NB. prob. that X>Y for two normals
NB. x is m1;v1, y is m2;v2 (m1>m2)
'm1 v1'=. x
'm2 v2'=. y
p=. (1-normal (|:m2-/m1)%%:v1+v2)
sh=. (#m1),#m2
if. 1=<./sh do.
  (citemize p);citemize (#p)#0
else.
  (sh$,p);sh$0
end.
)

pgpoiss=: 4 : 0
NB. prob. that X>Y for two Poisson rv
NB. x is m1, y is m2, m1>m2
m1=. x
m2=. y
mm1=. >./m1
max=. 20>.>.mm1+6*%:mm1
p=.''
t=.''
for_m1i. m1 do.
  xd=. m1i poisson i. max
  for_m2i. m2 do.
    yd=. m2i poisson i.max
    fyd=.}:0,+/\yd
    t=.t,+/(xd+yd)^3
    p=.p,(+/xd*fyd)+0.5*+/xd*yd
  end.
end.
sh=. (#m1),#m2
if. 1=<./sh do.
  (citemize p);citemize t
else.
  (sh$p);sh$t
end.
)

poisson=: 3 : 0
:
^((y*^.x)-x+lnf y)
)

poissonm=: 3 : 0
NB. matrix version of poisson
NB. x is mean, y is number of events
:
d=. citemize x +/ lnf y
n=. citemize (^.x)*/y
r=. ^n-d
NB.^((y*^.x)-x+lnf y)
)

rand01=: ?@$ 0:             NB. generate y random numbers in interval (0,1)

rank=: 3 : 0
NB. Returns ranks for a vector, using midranks for ties
r=.+&1@/:@/:
0.5*(r y) + |. r |. y
)

rankm=: 3 : 0
NB. Returns ranks for rows of a matrix, using midranks for ties
r=.+&1@/:"1 @/:"1
0.5*(r y) + |."1 r |."1 y
)


ratio=: 3 : 0
NB. Computes the mean and sd of ratios of variables
NB. y is denominator
NB. numerators from MSvar
i=.0
den=. y
y=.".locv deb y
ny=. #y
ey=.mean y
vy=. (ny%ny-1)*var y
NumerN=. MSvar__
Nsmp=.#NumerN
dout=.'Numerator';'Mean';'Std. dev.'
while. i < Nsmp do.
  x=.".locv >i{NumerN
  nx=. #x
  ex=.mean x
  vx=.(nx%nx-1)*var x
  er=.ex%ey
  vr=.(er^2)*(vx%ex^2)+vy%ey^2
  dout=.dout,(i{NumerN),(<ft er),<ft vr^0.5
  i=.i+1
end.
dout=.((Nsmp+1),3)$dout
tout 'Ratio of variables',LF
tout 'Denominator is ',den,LF
tout bfmt dout
tout LF,LF
view''
)

reg=: 3 : 0
:
'u w v'=. svd x
k=. {.$v
w=. (k,1)$w
b=. |:(|:((|:u) mp y)%w) mp |:v
yh=.x mp b
sse=. +/((,yh) - mean ,y)^2
mse=.sse%k-1
ssu=. ((|:y) mp y) - (|:b) mp (|:x) mp y
msu=.ssu%(#y)-k+1
s2=. sse%(#y)-1+k
r2=.sse % (sse+ssu)
f=. mse%msu
df=. (k-1),(#y)-k+1
var=. +/"1 (v%(k,k)$,w)^2
out=. 'Parameter';'std. dev.';(b);((k,1)$(var*s2)^0.5);'';'';'s2';(s2);'R2';(r2);'N';":#y
6 2$out
)

rxcchsq=: 3 : 0
NB. rxc contingency table
NB. y is table, returns Chi-sq p value
tab=. y
'r c'=. $tab
rt=.+/"1 tab
ct=.+/tab
n=.+/ct
exp=.(rt*/ct)%n
+/,((tab-exp)^2)%exp
)

rxclr=: 3 : 0
NB. rxc contingency table 
NB. y is table, returns Chi-sq (lr)
tab=. y
'r c'=. $tab
rt=.+/"1 tab
ct=.+/tab
n=.+/ct
exp=.(rt*/ct)%n
2*+/+/tab*^.tab%exp
)

samprep=: ?@#   NB. x random values from sampling with replacement of i.y

sen=: 3 : 0
data=. ". each locv each >PSvar__
samples=. >PSvar__
nlines=. #PSvar__
bnum=. 0#0
c2=. 0#0
for_s. data do.
  'x y'=.s
  xb=. mean x
  c2=. c2,+/(x-xb)^2
  bnum=. bnum,+/y*x-xb
end.
b=. (+/bnum)%+/c2
t=. 0#0
for_s. data do.
  'x y'=. s
  ys=. y-b*x
  r=. rank ys
  t=. t, (+/r*x-mean x)%1+#x
end.
v=. 12*+/(t^2)%c2
df=. nlines-1
p=. df chisq v
tout 'Sen-Adichie test for parallelism',LF
tout (bfmt ('X';'Y'),samples),LF
tout 'Common slope = ',(ft b),LF
tout 'V = ',(ft v),'   P = ',(ft p),' (',(":df),' degrees of freedom)',LF
tout LF,LF
view''
)

spear=: 3 : 0
NB. Computes Spearman's rank correlation statistic
'x y'=. ". each locv each TSvar__
xs=. sortup x
ys=. ((i.#y) indxbyy x){y
rx=. rank x
ry=. rank y
n=. #rx
z=. n*(0.5*n+1)^2
rho=. ((+/rx*ry)-z)%(((+/rx^2)-z)^0.5)*((+/ry^2)-z)^0.5
p=. normal rho*(n-1)^0.5
tout 'Spearman''s rank correlation test',LF
if. Concord__ do.
  dout=.(0{TSvar__),(ft each boxcols (1,n)$xs),(1{TSvar__),ft each boxcols (1,n)$ys
  tout bfmt |:(2,n+1)$dout
else.
  tout bfmt (<'Variables:'),TSvar__
end.
tout LF,'N = ',(ft n),'    rho = ',(ft rho),LF
tout 'P (',(>Sided__{SidedN__),') = ',(ft Sided__*p),LF
if. 1=Sided__ do.
  direc=. >(rho<0){' positively ';' negatively '
  tout 'One-sided alternative: ',LF,(>0{TSvar__),' and ',(>1{TSvar__),direc,'correlated',LF,LF
else.
  tout LF,LF
end.
view''
)

srank=: 3 : 0
NB. Wilcoxon signed rank test
'x y'=. ". each locv each TSvar__
Ny=.#y
Nx=.#x
d=. y - x
dn=. (-.d=0)#d
r=.(*dn)*rank |dn
t=.(+/r)%(+/r^2)^0.5
dat=.|:3 2$(>0{TSvar__);(ft (Nx,1)$x);(1{>TSvar__);(ft (Nx,1)$y);'Diff. ';ft (Nx,1)$d
tout 'Wilcoxon signed rank test',LF
tout (bfmt dat),LF
tout ('T = '),(ft t),'    P(',(>Sided__{SidedN__),') = ',(ft Sided__*normal t),LF
if. 1=Sided__ do.
  direc=.>(t<0){' < ';' > '
  tout 'One-sided alternative: ',(>0{TSvar__),direc,(>1{TSvar__),LF,LF
else.
  tout LF
end.
view''
)

svd=: 3 : 0
NB. singular value decomposition
NB. returns:  left eigenvectors;singular values;right eigenvectors
if. b=. </$y do. y=. |:y end.
'r s'=. jacobi (|:y) mp y 
t=. %:r
u=. (y mp s) %"1 t
|.^:b u;t;s
)

ties=: #/.~

ubpcibin=: 3 : 0
NB. compute binomial p for upper bound of ci
'x n pu'=. y
if. 0.5 < x%n do.
  1-+/(n,pu) binom (x+1)+i.n-x
else.
  +/(n,pu) binom i.x+1
end.
)

ud=: 4 : 0
NB. cdf (to u) for sum of m uniform distr. var
NB. x is m, y is u
k=. <. y
i=. i. k+1
+/(% (!i)*!x-i)*(_1^i)*(y-i)^x
)

var=: 3 : 0
NB. Computes the variance of a vector, y
   ((+/y^2)%#y)-(mean y)^2
)

wil=: 3 : 0
tout 'Wilcoxon rank sum test',LF
'x y'=. ". each locv each TSvar__
NB.w=. +/(#x){. rank x,y
NB.z=. x wilcox y
'w z p1 meth'=. x wilcox y
NB.p1=. normal z
res=.3 4$('Sample';'N';'Mean';'St. dev.'),((>0{TSvar__);ft each dstt x),((>1{TSvar__);ft each dstt y)
tout (bfmt res),LF
tout 'W = ',(":w),'   W* = ',(ft z),LF
tout meth,', P(',(>Sided__{SidedN__),') = ',(ft 1<.Sided__*p1),LF
if. 1=Sided__ do.
  direc=. >(z<0){' > ';' < '
  tout 'One-sided alternative: ',(>0{TSvar__),direc,(>1{TSvar__),LF,LF
else.
  tout LF
end.
view''
)

wilcox=: 4 : 0
NB. Wilcoxon rank sum test
NB. x and y are vectors of observations
NB. returns W; z-value; 1-sided P; method
nx=. #x
n=. nx+ ny=. #y
nv=. nx,ny
W=. +/ nx{. R=. rank x,y
E=. 0.5 * nx * n + 1
V=. (((nx*ny)%n*n-1)*+/R^2)-(nx*ny*(n+1)^2)%4*n-1
WE=. W-E
zc=. (WE-0.5**WE)%%:V
k=. (20*nx*ny*n+1) % (+/ *:nv)+(nx*ny)++/nv
s=. *:zc
t1=. s-3
t2=. ((155**:s)-(416*s)+195)%42
c=. 1+ (t1%k)+t2%*:k
z=. zc*c
if. (hasties x,y) +. n>200 do.
  if. n<:20 do.
    meth=.'CondExact'
    p=. nx condexact R
  else.
    meth=. 'Approx'
    p=. normal z
  end.
else. 
  meth=.'Exact'
  p=. (nx,ny) wilexact W
end.
W;z;p;meth
)

wilexact=: 4 : 0
NB. Exact, one-sided p-value for WRS
NB. x is nx,ny
NB. y is W
'nx ny'=. x
n=. nx+ny
if. y <: 0.5*nx*n+1 do. w=. y else. w=. (nx*n+1)-y end.
rs=. nx cs2 n
lt=. +/(nx+{."1 rs)<:w
rsn=. +/ lt{. {:"1 rs
p=. rsn%(nx!n)
)

condexact=: 4 : 0
NB. Conditional exact, one-sided p-value for WRS with ties
NB. x is nx
NB. y is rank(x,y)
n=. #y
c=. x comb n
r=. c{y
rw=. +/"1 r
W=. +/ x{.y
if. W <: 0.5*x*n+1 do. tail=. >: else. tail=. <: end.
rwd=. +/"1 (~.rw)=/rw
p=. +/ (W tail (~.rw))#rwd
p=. p% +/rwd
)

wilcoxp=: 3 : 0
NB. Returns one-sided p-value(s) for WRS
NB. x is a, all; n, normal approx; e, exact; u, uniform
NB. y is group1;group2
'a' wilcoxp y
:
'g1 g2'=. y
nx=. #g1
n=. nx+ ny=. #g2
nv=. nx,ny
W=. +/ nx{. R=. rank g1,g2
p=. <W
if. (x='a') +. 'n' e. x do.
  p=. p, <nv wilnorm R
end.
if. (x='a') +. 'e' e. x do.
  if. hasties R do.
    if. n<:20 do. pe=. nx condexact R else. pe=. '' end.
  else.
    if. n<:200 do. pe=. nv wilexact W else. pe=. '' end.
  end.
  p=. p,<pe
end.
if. (x='a') +. 'u' e. x do.
  if. nx <: ny do. pu=. g1 wud g2 else. pu=. g2 wud g1 end.
  p=. p,<pu
end.
p
)

wud=: 4 : 0
NB. nx<:ny
nx=. #x
n=. nx+ ny=. #y
xy=. x,y
w=. +/nx{. rank xy
d=. ~. xy
TF=. 0
if. -.(#d)=(#xy) do.
  for_i. d do.
    ti=. +/ i=xy
    TF=. TF+(ti^3)-ti
  end.
end.
if. w>0.5*nx*n+1 do. w=. (nx*n+1)-w end.
a=. % %: (ny*n+1)-ny*TF%(n)*n-1
b=. 0.5*nx*1-a*(n+1)
u=. b+a*w+0.5
p=. nx ud u
)

wilss=: 3 : 0
NB. Wilcoxon sample size (normal approx.)
NB. y is alpha;sided;beta;p;t
'a s b p t'=. y
if. s=2 do.
  a=. a%2
end.
z=. (invnorm a) + invnorm b
(2-t%4)*(z^2)%12*(p-0.5)^2
)

xs2=: 3 : 0
NB. y is 2x2 table
n=. +/ nr=. +/"1 y
nc=. +/ y
'a b c d'=. ,y
n*(((a*d)-b*c)^2)%*/nr,nc
)

NB. mssysdep.ijs
NB. system dependent functions

coclass'base'

defpref=: 3 : 0
os=. (<UNAME) inx 'Win';'Darwin';'Linux'
Ffont__=: ,>os{ '"Segoe UI Semibold" 10';'"Lucida Grande" 12';'"sans-serif" 10'
Vfont__=: ,>os{ 'Consolas 12';'"Monaco" 12';'"monospace" 10'
Pfont__=: ,>os{ 'Consolas 12';'"Monaco" 12';'"monospace" 10'
Dfont__=: ,>os{ '"Arial" 12';'"Helvetica" 14';'"sans-serif" 12'
SIGFIG__=: 4
Dpath__=: (jpath'~home'),'/'
SETBROWSER__=: ''
SETPDFVIEWER__=: ''
AUTOUPDATE__=: 0
LASTUPDATE__=: 0
ORIENT__=: 0
MARGIN__=: 10
)


initdir=: 3 : 0
DBG__=: 0
Bdir__=: (wd'qpath'),'/'
Appdir__=: getappdir''
NB. Kludge to facilitate debugging
if. (<'j9.5') e. '/' chop Appdir do.
  Appdir__=: 'c:/Dev/Mstat 8.0/'
  DBG__=: 1
end.
Resdir__=: Appdir,'Resources/'
Plugdir__=: Appdir,'plug-in','/'
TBP__=: Resdir,'icons/'
Homedir__=: (jpath'~home'),'/'
Profdir__=: jpath'~user','/'
Tempdir__=: jpath'~temp','/'
)

setadv=: 3 : 0
if. 0=#SETBROWSER__ do.
  select. UNAME
    case. 'Win' do.
NB.      BROWSER__=: 'rundll32.exe url.dll,FileProtocolHandler '
      BROWSER__=: 'explorer.exe'
    case. 'Darwin' do.
      BROWSER__=: 'open'
    case. 'Linux' do.
      if. 0<#dir'/usr/bin/firefox' do.
        BROWSER__=: '/usr/bin/firefox'
      elseif. 0<#dir'/usr/bin/htmlview' do.
        BROWSER__=: '/usr/bin/htmlview'
      elseif. 0<#dir'/opt/kde3/bin/konqueror' do.
        BROWSER__=: '/opt/kde3/bin/konqueror'
      end.
  end.
else.
  select. UNAME
    case. 'Darwin' do.
      BROWSER__=: 'open -a "',SETBROWSER__,'"'
    case. 'Win';'Linux' do.
      BROWSER__=: SETBROWSER__
  end.
end.
if. 0=#SETPDFVIEWER__ do.
  select. UNAME
    case. 'Win' do.
      PDFVIEWER__=: 'rundll32.exe url.dll,FileProtocolHandler file:///'
    case. 'Darwin' do.
      PDFVIEWER__=: 'open'
    case. 'Linux' do.
      if. 0<#dir'/usr/bin/evince' do.
        PDFVIEWER__=: '/usr/bin/evince'
      elseif. 0<#dir'/opt/kde3/bin/kpdf' do.
        PDFVIEWER__=: '/opt/kde3/bin/kpdf'
      elseif. 0<#dir'/usr/bin/xpdf' do.
        PDFVIEWER__=:'usr/bin/xpdf'
      end.
  end.
else.
  select. UNAME
    case. 'Darwin' do.
      PDFVIEWER__=: 'open -a "',SETPDFVIEWER__,'"'
    case. 'Win';'Linux' do.
      PDFVIEWER__=: SETPDFVIEWER__
  end.
end.
)

getappdir=: 3 : 0
select. UNAME
  case. 'Darwin' do.
    ('/Mstat.app' taketo Bdir__),'/'
  case. 'Win';'Linux' do.
    ('/bin' taketo Bdir__),'/'
end.
)

GetEnv=: 2!:5


fork_z_=: fork_jtask_
spawn_z_=: spawn_jtask_
NB. msupdate.ijs
NB. Checks for updates to Mstat

coclass'msupdate'
(;:'base z') copath 'msupdate'


open=: 3 : 0
NB. y is 'm' for call from menu, 'a' for autocheck
if. UNAME -: 'Win' do. HTTPCMD_wgethttp_=: 'curl.exe' end.
now=. todayno 3{. 6!:0''
if. y='m' do. silent=. 0 else. silent=. 1 end.
if. y='a' do. 
  if. -.7 < now-LASTUPDATE__ do. return. end.
  LASTUPDATE__=: now
  writepref''
end.
wver=. gethttp MSTATSITE__,'download/mstatver.txt'
if. 0=#wver do.
  if. -. silent do. mbError'Update check';'Can''t connect to Mstat website, try later.' end.
  return.
end.
'wvl wvm wvr'=. wver=. ,> ". each '.' chop LF taketo toJ wver
'cvl cvm cvr'=. cver=. ,> ". each '.' chop VERSION__
if. cver -: wver do.
  if. -. silent do. mbInfo'Update check';'Mstat is already up-to-date.' end.
  return.
end.
if. (wvl>cvl) +. ((wvl>:cvl)*.(wvm>cvm)) do. 
  updatemajor''
  return.
end.
if. (wvr>cvr)*.(wvm=cvm) do.
  if. (UNAME-:'Darwin' do. updatemajor'' else. updateminor'' end.
else.
  mbInfo'Update check';'Older version on the website.'
end.
)

updateminor=: 3 : 0
res=. mbQuery'Minor update available';'Do you want to install the updated version of Mstat?'
if. 'no' -: res do. return. end.
NB. if. IFWIN do. sname=.'profile' else. sname=. 'mstat' end.
sname=.'profile' 
lastver=. freads Bdir__,sname,'.ijs'
a32=.  ". ,> chop toJ gethttp MSTATSITE__,'download/mstat.crc.txt'
wgout=. ('file';'"',Tempdir__,'mstat.ijs.gz"') gethttp MSTATSITE__,'download/mstat.ijs.gz'
newver=. toJ zread Tempdir__,'mstat.ijs.gz'
newa32=. zadler newver
if. -. a32 = newa32 do.
  mbError'Update error';'Error downloading new mstat file. Try again later.'
  return.
end.
lastver fwrites Profdir__,sname,'.ijs.old'
res=. newver fwrites Bdir__,sname,'.ijs'
if. 0<res do.
  mbInfo'Update successful';'Mstat updated and will now close. Please restart program.'
else.
  mbInfo'Update failed';'Run Mstat as administrator to allow updating.'
end.
mstat_Fexit_button__''
)

updatemajor=: 3 : 0
plat=. gethttp MSTATSITE__,'download/platforms.txt'
if. 0=#plat do.
  mbError'Update check';'Can''t connect to Mstat website, try later.'
  return.
end.
res=. mbQuery'Major update available';'Do you want to download the updated version of Mstat?'
if. 'no' -: res do. return. end.
os=. (<UNAME) inx 'Win';'Darwin';'Linux'
if. (2=os)*.-.IF64 do. os=. os+1 end.
dldir=. Homedir__,'Downloads'
dldir=. wd'mb dir "Folder for Mstat download" "',dldir,'"'
plat=. chop plat
dlplat=. ,>os{plat
cout=. ('file';'"',dldir,'/',dlplat,'"') gethttp MSTATSITE__,'download/',dlplat
if. fexist (dldir,'/',dlplat) do.
  mbInfo'Mstat download';'Download successful'
else.
  mbinfo'Mstat download';'Download failed.',LF,' Go to Mstat website.'
end.
)
NB. mulsmp.ijs
NB. form for multiple sample selection

coclass 'mulsmp'

(;:'base z') copath 'mulsmp'

ShowType=: 'R'
SOH=: 1{a.
toSOH=: [:;(SOH,~":)each


MULSMP=: 0 : 0
pc mulsmp dialog nosize escclose closeok;
bin g;
grid cell 0 0 1 2;
cc label1 static center;cn "Choose the samples in order";
grid cell 1 0;
cc label2 static center;cn "Available";
grid cell 1 1;
cc label3 static center;cn "To test";
grid cell 2 0;
cc avlist listbox drag drop multiple;set avlist wh 180 120;
grid cell 2 1;
cc tlist listbox drag drop multiple;set tlist wh 180 120;
)

MULSMPEND=: 0 : 0
grid cell 5 1;
bin hs2;
cc done button;cn "&Done";
cc cancel button;cn "&Cancel";
bin zz;
pcenter;
)

SIDEDCONTROL=: 0 : 0
grid cell 3 0 4;
bin v;
cc sidedrb0 radiobutton;cn "&One-sided";
cc sidedrb1 radiobutton group;cn "&Two-sided";
bin z;
)

DOTCONTROL=: 0 : 0
grid cell 3 0 4;
bin v;
cc rangecb checkbox;cn "Range includes &0";
cc quartcb checkbox;cn "Show &quartiles";
bin z;
)

DESCCONTROL=: 0 : 0
grid cell 3 0;
bin h;
cc ntck checkbox;cn "&n-tiles";
minwh 40 32;cc ntlabel static right;cn "n  ";
cc nt edit;set nt wh 60 _1;
bin sz;
)

TYPECONTROL=: 0 : 0
grid cell 3 0 1 2 4;
bin h;
cc trb0 radiobutton;cn "&Variables";
cc trb1 radiobutton group;cn "&Tables";
cc trb2 radiobutton group;cn "&Indicators";
bin z;
)

PARTCONTROL=: 0 : 0
grid cell 3 0 4;
bin v;
cc part0 radiobutton;cn "Chi-&square test";
cc part1 radiobutton group;cn "&Likelihood ratio test";
bin z;
)

RATIOCONTROL=: 0 : 0
grid cell 3 0;
bin v;
cc label4 static center;cn "Denominator";
cc denom combolist;
bin z;
)

BOOTCICONTROL=: 0 : 0
grid cell 3 0 4;
bin v;
cc bcicb0 checkbox;cn "&Mean";
cc bcicb1 checkbox;cn "Me&dian";
cc bcicb2 checkbox;cn "&Variance";
bin z;
grid cell 3 1;
bin v;
bin h;
minwh 120 32;cc bcilab1 static right;cn "Conf. interval (%) ";
cc bcisize edit;set bcisize wh 60 _1;
bin z;
bin h;
minwh 120 32;cc bcilab2 static right;cn "Number of trials ";
cc bcitrial edit;set bcitrial wh 60 _1;
bin zz;
)

BARCONTROL=: 0 : 0
grid cell 3 0 2;
cc barord checkbox; cn "Order bars";
grid cell 3 1;
bin v;
cc bordrb0 radiobutton; cn "Ascending";
cc bordrb1 radiobutton group; cn "Descending";
bin z;
bin z;
grid cell 4 0;
bin v;
cc indvlabel static center;cn "Labels";
cc indvlist combolist;
bin z;
grid cell 4 1 64;
cc bwp checkbox;cn "Black and white"; 
)

BARNCONTROL=: 0 : 0
grid cell 3 0;
bin v;
groupbox "Fixed totals";
cc rcrb0 radiobutton;cn "Ro&ws";
cc rcrb1 radiobutton group;cn "Co&lumns";
groupboxend;
bin z;
grid cell 3 1;
bin v;
groupbox "Test";
cc sidedrb0 radiobutton;cn "&One-sided";
cc sidedrb1 radiobutton group;cn "&Two-sided";
groupboxend;
bin z;
)

RESCALECONTROL=: 0 : 0
grid cell 3 0 4;
bin v;
bin h;
minwh 120 32;cc rsclab1 static right;cn "Divisor";
cc rscdiv edit;set rscdiv wh 60 _1;
bin z;
bin h;
minwh 120 32;cc rsclab2 static right;cn "Label";
cc rscnam edit;set rscnam wh 60 _1;
bin z;
bin z;
)

open=: 3 : 0
'R' open y
:
VarN=: nl_v_''
IndN=: nl_i_''
TabN=: nl_t_''
Avail=:''
wd MULSMP
wd 'pn "',y,'"'
Type=: x
select. Tlast__
  case. cJONCKT;cFISHRT;cMCNEMT;cMANTEL do.
    wd SIDEDCONTROL
    wd 'set sidedrb',(":Sided__-1),' value 1'
  case. cDOTPLOT do.
    wd DOTCONTROL
    wd 'set rangecb value ',":ZeroOrigin__
    wd 'set quartcb value ',":Quart__
  case. cDESC do.
    wd DESCCONTROL
    if. 0<Ntile__ do.
      wd 'set nt enable 1; set ntck 1; set nt text ',":Ntile__
    else.
      wd 'set nt enable 0; set ntck 0; set nt text 2'
    end.
  case. cSHOW;cDDEL do.
    wd TYPECONTROL
    wd 'set trb0 value 1'
  case. cCHSQP do.
    wd PARTCONTROL
    wd 'set part',(":PartTest__),' value 1'
  case. cRATIO do.
    wd RATIOCONTROL 
    wd 'set denom items *',vfm >VarN
  case. cBOOTCI do.
    wd BOOTCICONTROL
    wd 'set bcicb0 value ',":BSMean__
    wd 'set bcicb1 value ',":BSMedian__
    wd 'set bcicb2 value ',":BSVar__
    wd 'set bcisize text *',":100*BSInt__
    wd 'set bcitrial text *',":BSTrial__
  case. cBARPLOT;cSBARPLOT;cFBARPLOT;cABARPLOT do.
    wd BARCONTROL
    wd 'set indvlist items *',vfm >(<'None'),IndN
    wd 'set indvlist select 0'
    wd 'set bwp value ',":PlotBW__
    if. BarOrd__ do. wd 'set barord 1' else. wd 'set barord 0' end.
    wd 'set bordrb',(":BarOrdDir__),' value 1'
  case. cBARN do.
    wd BARNCONTROL
    wd 'set sidedrb',(":Sided__-1),' value 1'
    wd 'set rcrb',(": RC__),' value 1'
  case. cRESCALE do.
    wd RESCALECONTROL
    wd 'set rscdiv text *',":RSCDiv__
    wd 'set rscnam text ',RSCName__
end.
wd MULSMPEND
select. Type
   case. 'A' do.
      if. Tlast=cSHOW do.
        wd 'set label3 text Show'
      else.
        wd 'set label3 text Delete'
      end.
      select. ShowType
        case. 'R' do.
          if. 0=VarN do.
            if. 0=TabN do. ShowType=:'I' else. ShowType=:'T' end.
          end.
        case. 'T' do.
          if. 0=TabN do.
            if. 0=VarN do. ShowType=:'I' else. ShowType=:'R' end.
          end.
        case. 'I' do.
          if. 0=IndN do.
            if. 0=VarN do. ShowType=:'T' else. ShowType=:'R' end.
          end.
      end.
      ".'mulsmp_trb',(":ShowType inx 'RTI'),'_button'''''
   case. 'R' do.
      if. Tlast=cRATIO do.
         wd 'set label3 text Numerator'
      elseif. (<Tlast) e. cDOTPLOT;cBARPLOT;cSBARPLOT;cABARPLOT do.
         wd 'set label3 text Variables to plot'
      elseif. Tlast=cRESCALE do.
         wd 'set label3 text Variables to rescale'
      elseif. do.
         wd 'set label3 text Variables to test'
      end.
      Avail=:VarN
   case. 'T' do.
      wd 'set label3 text Tables to test'
      Avail=:TabN
end.
mulsmp_write Avail;<''
wd 'pshow;'
if. HELP__ do.
   update_hlp_ Test__;'mulsmp'
   wd 'psel mulsmp; pactive; set avlist focus '
end.
)

mulsmp_write=: 3 : 0
'fm to' =. y
wd'set avlist items ', ; fm ,each SOH
wd'set tlist items ', ; to ,each SOH
)

mulsmp_read=: 3 : 0
(<;._2 wd 'get avlist allitems');<<;._2 wd 'get tlist allitems'
)

mulsmp_avlist_button=: 3 : 0
'fm to'=. mulsmp_read''
n=. ".avlist_select
to=. to,n{fm
fm=. (<<<n){fm
mulsmp_write fm;<to
)

mulsmp_tlist_button=: 3 : 0
'fm to'=. mulsmp_read''
n=. ". tlist_select
fm=. fm,n{to
to=. (<<<n){to
mulsmp_write fm;<to
)

initType=: 3 : 0
select. y
   case. 'A' do.
      Avail=:VarN
      wd 'set label3 text Show'
   case. 'R' do.
      wd 'set label3 text Variables to use'
      Avail=:VarN
   case. 'T' do.
      wd 'set label3 text Tables to use'
      Avail=:TabN
end.
)

close=: 3 : 0
wd 'pclose'
)

mulsmp_ntck_button=: 3 : 0
if. ".ntck do.
  wd 'set nt enable'
else.
  wd 'set nt enable 0'
  Ntile__=: 0
end.
)

mulsmp_trb0_button=: 3 : 0
wd 'set trb0 1'
ShowType=: Type=: 'R'
Avail=: VarN
mulsmp_write Avail;<''
)

mulsmp_trb1_button=: 3 : 0
wd 'set trb1 value 1'
ShowType=: Type=: 'T'
Avail=: TabN
mulsmp_write Avail;<''
)

mulsmp_trb2_button=: 3 : 0
wd 'set trb2 value 1'
ShowType=: Type=: 'I'
Avail=: IndN
mulsmp_write Avail;<''
)

mulsmp_part0_button=: 3 : 0
wd 'set part0 value 1'
PartTest__=: 0
)

mulsmp_part1_button=: 3 : 0
wd 'set part1 value 1'
PartTest__=: 1
)

mulsmp_done_button=: 3 : 0
MSvar__=: >{: mulsmp_read''
if. Tlast e. cJONCKT,cMANTEL,cCHSQ,cKWAL,cMULTEX,cCONOVER do.
  emsg=. 'two samples.'
  nsamp=. 2
else.
  nsamp=. 1
  emsg=. 'one sample.'
end.
if. ((#MSvar__) < nsamp) do.
  mbError 'Too few samples';'You should select at least ',emsg
  return.
end.
tstvar=.''
select. Tlast__
  case. cJONCKT do.
    Sided__=:1+".sidedrb1
  case. cFISHRT;cBARN;cMANTEL;cMCNEMT do.
    Sided__=:1+".sidedrb1
    if. Tlast__=cBARN do. RC__=: ".rcrb1 end.
    for_t. MSvar__ do.
      tab=. ".(>t),'_t_'
      'r c'=. ($tab)-1
      if. (2~:r) +. 2~: c do.
        mbError 'Table dimensions';'Table ',(>t),' is not 2x2.'
        return.
      end.  
      if. -. iscontab tab do.
        mbError 'Not contingency table'; 'Table ',(>t),' is not a contingency table.'
        return.
      end.
    end.
  case. cCHSQT do.
    for_t. MSvar__ do.
      tab=. ".(>t),'_t_'
      if. -. iscontab tab do.
        mbError 'Not contingency table'; 'Table ',(>t),' is not a contingency table.'
        return.
      end.
    end.
  case. cDOTPLOT do.
    ZeroOrigin__=: ".rangecb
    Quart__=: ".quartcb
  case. cDESC do.
    if. ".ntck do.
      ntil=. __ ".nt
      if. (0=#ntil) +. -. ((ntil>1) *. (isposint ntil)) do.
        mbError 'n-tile error';'n must be a positive integer greater than 1.'
        wd 'set nt focus '
        return.
      end.
      Ntile__=: ntil
    else.
      Ntile__=: 0
    end.
  case. cSHOW;cDDEL do.
    tstvar=. Type
  case. cRATIO do.
    if. 0=#denom do.
      mbError 'Choose denominator';'You must select a variable for the denominator.'
      wd 'set denom focus '
      return.
    end.
    tstvar=. denom
  case. cBOOTCI do.
    BSMean__=: ".bcicb0
    BSMedian__=: ".bcicb1
    BSVar__=: ".bcicb2
    if. 0= +./BSMedian__,BSMean__,BSVar__ do.
      mbError'No parameter';'You must select at least one of Mean, Median, and/or Variance.'
      return.
    end.
    bcint=. __ ". bcisize    
    if. (50>bcint)+.(100<bcint) do.
      mbError 'Interval size error';'Confidence interval size must be between 50 and 100.'
      wd 'set bcisize focus ; set bcisize select'
      return.
    end.
    bctrial=. __ ". bcitrial
    if. -. isposint bctrial do.
      mbError 'Invalid parameter';'Number of trials must be a positive integer.'
      wd 'set bcitrial focus ; set bcitrial select'
      return.
    end.
    if. bctrial<(100*%1-bcint%100) do.
      mbError 'Too few trials';'For this size interval, at least ',(":100*%1-bcint%100),' trials should be performed.'
      wd 'set bcitrial focus ; set bcitrial select'
      return.
    end.
    BSInt__=: bcint%100
    BSTrial__=: bctrial
  case. cCOCHR do.
    for_t. MSvar__ do.
      tab=. ".(>t),'_t_'
      if. (</$tab) do. tab=. |:tab end.
      'r c'=. ($tab)-1
      if. -. (2=c) *. (2<r) do.
        mbError 'Table dimensions';'Table ',(>t),' is not rx2 or 2xr.'
        return.
      end.
      if. -. iscontab tab do.
        mbError 'Not contingency table'; 'Table ',(>t),' is not a contingency table.'
        return.
      end.
    end.
  case. cBARPLOT;cSBARPLOT;cFBARPLOT;cABARPLOT do.
    if. (Tlast__=cFBARPLOT) *. 2>#MSvar__ do.
      mbError 'Number of samples';'You must choose at least two variables for the floating bar plot.'
      return.
    end.
    nval=. # each ". each (,&'_v_') each MSvar__
    lvar=. <indvlist
    er=. 0
    PlotBW__=: ".bwp
    BarOrd__=: ".barord
    BarOrdDir__=: ".bordrb1
    if. -. (<'None')=lvar do. er=. -. eqvec ,>nval,<#".(indvlist,'_i_') else. er=. -.eqvec ,>nval end.
    if. er do.
      mbError'Sample numbers';'The number of observations in each sample (label) must be the same.'
      return.
    end.
    if. -. (<'None')=lvar do. MSvar__=: MSvar__,lvar else. MSvar__=: MSvar__,<'' end.
  case. cRESCALE do.
    div=. __".rscdiv
    if. (-. isnum div)+.(0=div) do.
      mbError 'Value error';'Divisor must be a non-zero number.'
      wd 'set rscdiv focus; set rscdiv select'
      return.
    end.
    if. 0=#rscnam do. 
      RSCName__=: fixvn 'd',":div
    else.
      RSCName__=. fixvn rscnam
    end.
    RSCDiv__=: div
    mbInfo 'Rescale';'Rescaled ',(":#MSvar__),' variables with label ',RSCName__,'.'
end.
close''
". Test__,' ''',tstvar,''''
)

mulsmp_cancel_button=: 3 : 0
close''
MSvar__=:''
)

mulsmp_cancel=: mulsmp_cancel_button

mulsmp_dlghlp=: 3 : 0
if. HELP__ do.
   HELP__=: 0
   wd 'psel hlp; pclose; psel mstat; set DHlp 0; psel mulsmp; pactive; set avlist focus'
else.
   HELP__=: 1
   open_hlp_ Test__;'mulsmp'
   wd 'psel mstat; set DHlp 1; psel mulsmp; pactive; set  avlist focus'
end.
)

mulsmp_octrl_fkey=: mulsmp_done_button
mulsmp_lctrl_fkey=: mulsmp_dlghlp

NB.  normdist.ijs
NB. form for normal distribution

coclass 'normdist'

(;:'base z') copath 'normdist'

NB. base form 


NORMDIST=: 0 : 0
pc normdist dialog nosize escclose closeok;pn "Normal distribution";
bin v;
cc label static;cn "Z-values";
cc ndz editm;set ndz wh 240 80;
bin h;
cc rb0 radiobutton;cn "&Upper (lower) tail prob.";
cc logp checkbox;cn "log P";
bin z;
cc rb1 radiobutton group;cn "&F(z)";
bin hs;
cc ok button;cn "&OK";
cc cancel button;cn "&Cancel";
pcenter;
)

open=: 3 : 0
wd NORMDIST
wd 'set ndz focus '
wd 'set rb0 value 1'
wd 'set logp enable 1'
wd 'pshow;'
if. HELP__ do.
   update_hlp_ <'normdist'
   wd 'psel normdist; pactive; set ndz focus'
end.
)

close=: 3 : 0
wd 'pclose'
)
normdist_cancel_button=: normdist_cancel=: close

normdist_rb0_button=: 3 : 0
wd 'set logp enable 1'
)

normdist_rb1_button=: 3 : 0
wd 'set logp enable 0'
)


normdist_ok_button=: 3 : 0
z=., __ ". (LF,' ') charsub ndz
nz=. #z
if. 0=nz do.
  mbError 'Z values';'No values in data field.'
  wd 'set ndz focus ;'
  return.
end.
if. __ e. z do.
  mbError 'Z values';'Z must be a real number.'
  wd 'set ndz focus '
  return.
end.
cdf=.". rb1
col=.' Tail p';'log Tail P';' F(z)'
if. cdf do.
   p=. ((z<0)*normal z)+(z>:0)*1-normal z
   coln=. 2{col
else.
  if. ".logp do.
    p=. ,> normlog each bxv z
    coln=. 1{col
  else.
    p=. normal z
    coln=. {.col
  end.
end.
close''
tout 'Normal distribution',LF
dat=.(<'z'),(ft each boxcols (1,nz)$z),(coln),ft each boxcols (1,nz)$p
tout (bfmt |:(2,1+nz)$dat),LF,LF
view''
)

normdist_dlghlp=: 3 : 0
if. HELP__ do.
   HELP__=: 0
   wd 'psel hlp; pclose; psel mstat; set DHlp 0; psel normdist; pactive; set ndz focus'
else.
   HELP__=: 1
   open_hlp_ <'normdist'
   wd 'psel mstat; set DHlp 1; psel normdist; pactive; set ndz focus'
end.
)

normdist_octrl_fkey=: normdist_ok_button
normdist_lctrl_fkey=: normdist_dlghlp
NB. onesmp.ijs
NB. choose one sample and perform test

coclass 'onesmp'

(;:'base z') copath 'onesmp'

ONESMP=: 0 : 0
pc onesmp dialog nosize escclose closeok;
bin v;
cc label static;
cc lb listbox;set lb wh 220 120;
bin hs;
cc done button;cn "&OK";
cc cancel button;cn "&Cancel";
bin zz;
pcenter;
)

open=: 3 : 0
'R' open y
:
VarN=: nl_v_''
IndN=: nl_i_''
TabN=: nl_t_''
wd ONESMP
vtype=: x
wd 'pn "',y,'"'
select. x
  case. 'R' do.
    wd 'set lb items ',vfm >VarN
    wd 'set label text *Choose a variable'
  case. 'I' do.
    wd 'set lb items ',vfm >IndN
    wd 'set label text *Choose an indicator'
  case. 'T' do.
    wd 'set lb items ',vfm >TabN
    wd 'set label text *Choose a table'
end.
wd 'set lb select  0; set lb focus '
wd 'pshow;'
if. HELP__ do.
   update_hlp_ Test__;'onesmp'
   wd 'psel onesmp; pactive; set lb focus ; set lb select  0'
end.
)

close=: 3 : 0
wd 'pclose'
)

onesmp_cancel_button=: onesmp_cancel

onesmp_cancel=: 3 : 0
OSvar__=: ''
close''
)

onesmp_lb_button=: onesmp_done_button

onesmp_done_button=: 3 : 0
vtype=: ''
OSvar__=: <lb
close''
". Test__,''''''
)

onesmp_dlghlp=: 3 : 0
if. HELP__ do.
   HELP__=: 0
   wd 'psel hlp; pclose; psel mstat; set DHlp 0; psel onesmp; pactive; set lb focus '
else.
   HELP__=: 1
   open_hlp_ Test__;'onesmp'
   wd 'psel mstat; set DHlp 1; psel onesmp; pactive; set lb focus '
end.
)

onesmp_octrl_fkey=: onesmp_done_button
onesmp_lctrl_fkey=: onesmp_dlghlp
NB. pairsmp.ijs
NB. form for paired sample selection

coclass 'pairsmp'

KPLOT=: 1
KMED=: 1
KBS=: 1000
KCI=: 95
KCEN=: 1
KINV=: 0

XYBTYPE=: 0
XYBCI=: 95
XY2=: 0
XY2N=: ''
XYSD=: 0
LOGX=: LOGY=: 0

(;:'base z') copath 'pairsmp'


PAIRSMP=: 0 : 0
pc pairsmp dialog nosize escclose closeok;
bin g;
grid cell 0 0;
cc llab static center;cn "X values";
grid cell 0 1;
cc rlab static center;cn "Y values";
grid cell 1 0;
cc llist listbox ;set llist wh 180 120;
grid cell 1 1;
cc rlist listbox;set rlist wh 180 120;
grid cell 2 0;
bin hs;
cc add button;cn "&Add";
bin z;
grid cell 2 1;
bin h;
cc reset button;cn "&Reset";
bin s;
bin z;
grid cell 3 0 1 2 4;
cc plab static center;cn "X,Y pairs";
grid cell 4 0 1 2 4;
cc pairs editm readonly;set pairs wh 360 120;set pairs wrap 0;
set pairs stylesheet *QPlainTextEdit {background-color:#eeeeee};
)

PAIREND=: 0 : 0
grid cell 6 1;
bin hs2;
cc done button;cn "&Done";
cc cancel button;cn "&Cancel";
bin zz;
pcenter;
)

XYCONTROL=: 0 : 0
grid cell 5 0;
bin vh;
cc xlog checkbox;cn "Log &X";
cc ylog checkbox;cn "Log &Y";
bin z;
cc y2 checkbox;cn "Dual Y axes";
bin h;
cc y2nlab static;cn "Left first";
cc y2n edit;set y2n wh 40 _1;
bin szz;
grid cell 5 1;
cc bwp checkbox;cn "Black and white";
)

XYSDCONTROL=: 0 : 0
grid cell 5 0;
bin vh;
cc xlog checkbox;cn "Log &X";
cc ylog checkbox;cn "Log &Y";
bin z;
cc y2 checkbox;cn "Dual Y axes";
bin h;
cc y2nlab static;cn "Left first";
cc y2n edit;set y2n wh 40 _1;
bin szz;
grid cell 5 1;
bin v;
cc xysd checkbox;cn "Plot mean,s.d.";
cc bwp checkbox;cn "Black and white";
bin sz;
)

XYBCONTROL=: 0 : 0
grid cell 5 0 4;
bin v;
cc xlog checkbox;cn "Log &X";
cc ylog checkbox;cn "Log &Y";
cc bwp checkbox;cn "Black and white";
bin z;
grid cell 5 1;
bin v;
groupbox Band;
cc xybrb0 radiobutton;cn "Quartile";
cc xybrb1 radiobutton;cn "CI";
groupboxend;
bin h;
cc xybci edit;set xybci wh 40 _1;
cc xybcilb static;cn " % CI";
bin zz;
)

SIDEDCONTROL=: 0 : 0
grid cell 5 0 1 1 4;
groupbox Test;
cc sidedrb0 radiobutton;cn "&One-sided";
cc sidedrb1 radiobutton group;cn "&Two-sided";
groupboxend;
)

KMCONTROL=: 0 : 0
grid cell 5 0 4;
bin v;
cc kmed checkbox;cn "&Median";
cc kcen checkbox;cn "Show &censored";
cc kplot checkbox;cn "Show &plot";
cc kinv checkbox;cn "&Inverse";
cc bwp checkbox;cn "Black and white";
bin z;
grid cell 5 1;
bin g;
grid size 2 2;
cc kbslab static right;cn "Bootstrap samp.";
cc kmedbs edit;set kmedbs wh 80 _1;
cc kcilab static right;cn "Conf. interval (%)";
cc kbsci edit;set kbsci wh 80 _1;
bin z;
)

BARCONTROL=: 0 : 0
grid cell 5 0 4;
bin v;
cc indvlabel static;cn "Labels";
minwh 160 24;cc indvlist combolist;
bin z;
grid cell 5 1;
cc bwp checkbox;cn "Black and white";
)

BWCONTROL=: 0 : 0
grid cell 5 1;
cc bwp checkbox;cn "Black and white";
)

open=: 3 : 0
VarN=: nl_v_''
IndN=: nl_i_''
PAIRLIST=: ''
wd PAIRSMP
wd 'pn "',y,'"'
wd 'set llist items ',vfm >VarN
wd 'set rlist items ',vfm >VarN
if. -.Tlast__=cKAPM do. wd 'set llist select 0; set rlist select 1' end.
select. Tlast__
  case. cMULTEX do.
    wd SIDEDCONTROL
    wd 'set sidedrb',(":Sided__-1),' value 1'
  case. cKAPM do.
    wd KMCONTROL
    wd 'set kplot value ',":KPLOT
    wd 'set kinv value ',":KINV
    wd 'set kmed value ',":KMED
    wd 'set kmedbs text ',":KBS
    wd 'set kbsci text ',":KCI
    wd 'set kmedbs enable ',":KMED
    wd 'set kbsci enable ',":KMED
    wd 'set kcen value ',":KCEN
    wd 'set bwp value ',":PlotBW__
    kmLabel''
  case. cLOGRANK do.
    wd SIDEDCONTROL
    wd 'set sidedrb',(":Sided__-1),' value 1'
    kmLabel''
  case. cXYL do.
    wd XYCONTROL
    LOGX=: LOGY=: XY2=: 0
    wd 'set xlog value ',":LOGX
    wd 'set ylog value ',":LOGY
    wd 'set bwp value ',":PlotBW__
    wd 'set y2 value ',":XY2
    wd 'set y2n text *'
    wd 'set y2n enable 0'
    wd 'set y2nlab enable 0'
  case. cXYM;cXYLM do.
    wd XYSDCONTROL
    LOGX=: LOGY=: XY2=: 0
    wd 'set xlog value ',":LOGX
    wd 'set ylog value ',":LOGY
    wd 'set bwp value ',":PlotBW__
    wd 'set xysd value ',":XYSD
    wd 'set y2 value ',":XY2
    wd 'set y2n text *'
    wd 'set y2n enable 0'
    wd 'set y2nlab enable 0'
  case. cXYB do.
    wd XYBCONTROL
    LOGX__=: LOGY__=: 0
    wd 'set xlog value ',":LOGX
    wd 'set ylog value ',":LOGY
    wd 'set bwp value ',":PlotBW__
    wd 'set xybrb',(":XYBTYPE),' value 1'
    wd 'set xybci text ',":XYBCI
  case. cBARSD do.
    wd BARCONTROL
    wd 'set indvlist items ',vfm >(<'None'),IndN
    wd 'set indvlist select 0'
    wd 'set llab text Y values; set rlab text SD values; set plab text Y,SD pairs'
    wd 'set bwp value ',":PlotBW__
end.
wd PAIREND
wd 'pshow;'
if. HELP__ do.
  update_hlp_ Test__;'pairsmp'
  wd 'psel pairsmp; pactive; set llist focus'
end.
)

close=: 3 : 0
wd 'pclose'
)

pairsmp_cancel=: pairsmp_cancel_button

pairsmp_cancel_button=: 3 : 0
close''
PSvar__=: ''
)

kmLabel=: 3 : 0
wd 'set llab text Event times'
wd 'set rlab text Censor times'
wd 'set plab text Event, Censor pairs'
wd 'set rlist items ',vfm >(<'(None)'),VarN
wd 'set llist items ',vfm >(<'(None)'),VarN
wd 'set rlist select 0; set llist select 0;'
)

pairsmp_add_button=: 3 : 0
lv=. llist
rv=. rlist
if. (0=#lv)+.(0=#rv) do.
  mbError'Select pair';'Select a variable from both the left and right lists.'
  return.
end.
if. (<lv)=(<rv) do.
  mbError'Select pair';'You must select different variables from the left and right lists.'
  return.
end.
PAIRLIST=: PAIRLIST,(<lv;rv)
wd 'set pairs text *',vfm (>{."1 >PAIRLIST),.';',.' ',.(>{:"1 >PAIRLIST)
)

pairsmp_reset_button=: 3 : 0
PAIRLIST=: ''
wd 'set pairs text ',PAIRLIST
)

pairsmp_kmed_button=: 3 : 0
KMED=: -. KMED
wd 'set kmed value ',":KMED
wd 'set kmedbs enable ',":KMED
wd 'set kbsci enable ',":KMED
)

pairsmp_kinv_button=: 3 : 0
KINV=: -. KINV
wd'set kinv value ',":KINV
)

pairsmp_kplot_button=: 3 : 0
KPLOT=: -. KPLOT
wd 'set kplot value ',":KPLOT
)

pairsmp_y2_button=: 3 : 0
XY2=: -. XY2
wd'set y2 value ',":XY2
if. XY2 do.
  wd'set y2n enable 1;set y2nlab enable 1'
else.
  wd'set y2n enable 0;set y2nlab enable 0'
end.
)



pairsmp_done_button=: 3 : 0
exec=. ''
PSvar__=: PAIRLIST
select. Tlast__
  case. cSEN do.
    if. 2>#PAIRLIST do.
      mbError 'Too few pairs';'Two or more X-Y pairs must be chosen for the Sen-Adichie test.'
      PSvar__=: ''
      return.
    end.
    if. -. (#~. {:"1 >PAIRLIST)=#PAIRLIST do.
      mbError 'Sample pairs';'Each Y value must be unique.'
      PSvar__=: ''
      return.
    end.
    data=. ". each locv each >PSvar__
    for_s. data do.
      if. 0 = (=/>#each s) do.
        mbError 'Unequal sample sizes';'Equal numbers of X and Y values are required for each sample pair.'
        return.
      end.
    end.
    exec=. Test__,''''''
  case. cMULTEX do.
    if. 2>#PAIRLIST do.
      mbError'Too few pairs';'Two or more X-Y pairs must be chosen.'
      PSvar__=: ''
      return.
    end.
    if. -. (#~.,>PAIRLIST)=2*#PAIRLIST do.
      mbError'Sample pairs';'Each sample must be chosen once.'
      PSvar__=: ''
      return.
    end.
    Sided__=: 1+".sidedrb1
    exec=. Test__,''''''
  case. cKAPM do.
    if. 1>#PAIRLIST do.
      mbError 'Too few pairs';'One or more X-Y pairs must be chosen for Kaplan-Meier analysis.'
      PSvar__=: ''
      return.
    end.
    nocen=. +/ (<'(None)')= ,>,PAIRLIST
    if. -. (((nocen>:1)*nocen-1)+#~.,>PAIRLIST)=2*#PAIRLIST do.
      mbError'Sample pairs';'Each sample must be chosen once.'
      PSvar__=: ''
      return.
    end.
    kp=. ". kplot
    km=. ". kmed
    PlotBW__=: ".bwp
    kbs=. KBS
    kci=. KCI
    kcn=. ". kcen
    if. km do.
      kbs=. __ ". kmedbs
      if. -. (isposint kbs) *. 1000<: kbs do.
        mbError 'Invalid parameter';'Number of bootstrap samples must be an integer greater than or equal to 1000'
        wd 'setfocus kmedbs; setselect kmedbs 0 ',(":#kmedbs)
        return.
      end.
      kci=. __ ". kbsci
      if. -. (isposint kci) *. (50<: kci) *. (100>kci) do.
        mbError'Invalid parameter';'Confidence interval must be an integer between 50 and 100.'
        wd 'setfocus kbsci; setselect kbsci 0 ',(":#kbsci)
        return.
      end.
    KBS=: kbs
    KCI=: kci
    KCEN=: kcn
    end.
    exec=. Test__,' kp;km;kbs;kci;kcn'
  case. cLOGRANK do.
    if. 2>#PAIRLIST do.
      mbError 'Too few pairs';'Two or more event,censor pairs must be chosen for the logrank test.'
      PSvar__=: ''
      return.
    end.
    nocen=. +/ (<'(None)')= ,>,PAIRLIST
    if. -. (((nocen>:1)*nocen-1)+#~.,>PAIRLIST)=2*#PAIRLIST do.
      mbError'Sample pairs';'Each sample must be chosen once.'
      PSvar__=: ''
      return.
    end.
    Sided__=:1+".sidedrb1
    exec=. Test__,''''''
  case. cXYM;cXYL;cXYLM;cXYB do.
    if. 1>#PAIRLIST do.
      mbError 'Too few pairs';'One or more X-Y pairs must be chosen for plotting.'
      PSvar__=: ''
      return.
    end.
    data=. ". each locv each >PSvar__
    for_s. data do.
      if. 0 = (=/>#each s) do.
        mbError 'Unequal sample sizes';'Equal numbers of X and Y values are required for each sample pair.'
        return.
      end.
    end.
    LOGX=: ".xlog
    LOGY=: ".ylog
    PlotBW__=: ".bwp
    if. Tlast__ e. cXYM,cXYLM do. XYSD=: ". xysd end.
    if. -. Tlast=cXYB do.
      yaxes=. (#PAIRLIST)#0
      XY2=: ".y2
      if. XY2 do.
        XY2N=: __ ". y2n
        if. (XY2N<1)+.XY2N>(#PAIRLIST)-1 do.
          mbError 'Dual Y axis error';'Left first must be between 1 and one less than the number of pairs.'
          return.
        end.
        yaxes=. (XY2N#0),((#PAIRLIST)-XY2N)#1
      end.
      xyres=. LOGX;LOGY;PlotBW__;XYSD;yaxes
    else.
      XYBTYPE=: ".xybrb1
      XYBCI=: __ ". xybci
      xyres=. XYBTYPE;XYBCI
    end.
    exec=. Test__,' xyres'
  case. cBARSD do.
    if. 1>#PAIRLIST do.
      mbError 'Too few pairs';'One or more X-Y pairs must be chosen for plotting.'
      PSvar__=: ''
      return.
    end.
    lvar=. <indvlist
    data=. ". each locv each >PSvar__
    PlotBW__=: ".bwp
    for_s. data do.
      if. 0 = (=/>#each s) do.
        mbError 'Unequal sample sizes';'Equal numbers Y and SD values are required for each sample pair.'
        return.
      end.
    end.
    if. -. (<'None')=lvar do. PSvar__=: PSvar__,<lvar,<'' else. PSvar__=: PSvar__,<'';'' end.
    exec=. Test__,''''''
end.
close''
".exec
)

pairsmp_dlghlp=: 3 : 0
if. HELP__ do.
   HELP__=: 0
   wd 'psel hlp; pclose; psel mstat; set DHlp 0; psel pairsmp; pactive; set llist focus'
else.
   HELP__=: 1
   open_hlp_ Test__;'mulsmp'
   wd 'psel mstat; set DHlp 1; psel pairsmp; pactive; set llist focus'
end.
)

pairsmp_dctrl_fkey=: pairsmp_add_button
pairsmp_rctrl_fkey=: pairsmp_reset_button
pairsmp_octrl_fkey=: pairsmp_done_button
pairsmp_lctrl_fkey=: pairsmp_dlghlp

NB. pairwise.ijs
NB. Perform pair-wise tests on a set of samples

coclass'pairwise'

(;:'base z') copath 'pairwise'


TESTS=: 'Wilcoxon rank sum';'Spearman rank correlation';'Kendall rank correlation'
PTEST=: 0
EXP=: 0
CTYPE=: 0
SOH=: 1{a.
toSOH=: [:;(SOH,~":)each

PAIRWISE=: 0 : 0
pc pairwise dialog nosize escclose closeok;
pn "Pairwise test of multiple samples";
bin g;
grid cell 0 0 4;
bin v;
cc rb0 radiobutton;cn "All &pairs";
cc rb1 radiobutton group;cn "&Versus control";
bin z;
grid cell 0 1;
bin v;
cc lbcon static;cn "Control";
cc clcon combolist;set clcon wh 180 _1;
bin z;
grid cell 1 0 1 2;
minwh _1 32;cc label1 static center;cn "Choose the samples for pairwise testing";
grid cell 2 0;
cc label2 static center;cn "Available";
grid cell 2 1;
cc label3 static center;cn "To test";
grid cell 3 0;
cc avlist listbox drag drop multiple;set avlist wh 180 120;
grid cell 3 1;
cc tlist listbox drag drop multiple;set tlist wh 180 120;
grid cell 5 0 1 2 1;
bin h;
minwh _1 32;cc testlab static right;cn "Test ";
cc test combolist;set test wh 240 _1;
bin z;
grid cell 6 0 4;
cc export checkbox;cn "&Export as csv file";
grid cell 7 0 1 2 1;
bin h;
minwh _1 32;cc flab static right;cn "File ";
cc fname edit readonly;set fname wh 240 _1;set fname stylesheet background-color:#eeeeee;
cc fbrowse button;cn "&Browse";
bin sz;
grid cell 8 1;
bin hs2;
cc done button;cn "&Done";
cc cancel button;cn "&Cancel";
bin zz;
set tlist stylesheet *QPlainTextEdit {background-color:#eeeeee};
set fname stylesheet *background-color:#eeeeee;
pcenter;
)

open=: 3 : 0
VarN=: nl_v_''
wd PAIRWISE
Avail=: VarN
Totest=:0#Avail
Avail0=:Avail
wd 'setselect avlist 0'
wd 'set test items ',vfm > TESTS
wd 'set test select ',":PTEST
wd 'set export value ',":EXP
if. CTYPE do. pairwise_rb1_button'' else. pairwise_rb0_button'' end.
wd 'pshow;'
if. HELP__ do.
   update_hlp_ <'pairwise'
   wd 'psel pairwise; pactive; set avlist focus'
end.
)


close=: 3 : 0
wd 'pclose'
)

pairwise_rb0_button=: 3 : 0
wd 'set rb0 value 1'
wd 'set lbcon enable 0; set clcon enable 0'
pairwise_write Avail;<''
CTYPE=: 0
)

pairwise_rb1_button=: 3 : 0
wd 'set rb1 value 1'
wd 'set lbcon enable 1; set clcon enable 1'
wd 'set clcon items ',vfm >VarN
pairwise_write Avail;<''
CTYPE=: 1
)

pairwise_write=: 3 : 0
'fm to' =. y
wd'set avlist items ', ; fm ,each SOH
wd'set tlist items ', ; to ,each SOH
)

pairwise_read=: 3 : 0
(<;._2 wd 'get avlist allitems');<<;._2 wd 'get tlist allitems'
)

pairwise_avlist_button=: 3 : 0
'fm to'=. pairwise_read''
n=. ".avlist_select
to=. to,n{fm
fm=. (<<<n){fm
pairwise_write fm;<to
)

pairwise_tlist_button=: 3 : 0
'fm to'=. pairwise_read''
n=. ". tlist_select
fm=. fm,n{to
to=. (<<<n){to
pairwise_write fm;<to
)

pairwise_fbrowse_button=: 3 : 0
if. -.(".export) do. 
  mbError'Export not checked';'Select the export checkbox to save results.'
  return.
end.
Fn=. wd 'mb save "Export results to CSV file" "',Dpath__,'" "CSV files (*.csv)"'
if. 0=#Fn do. 
  wd 'set fname text *'
  return.
end.
fullpath=. pathname Fn
Dpath__=: >0{fullpath
if. -. '.csv' -: _4{.Fn do. Fn=. Fn,'.csv' end.
wd 'set fname text ',Fn
)

pairwise_done_button=: 3 : 0
varname=. >{: pairwise_read''
if. 3>#varname do.
  mbError'To few variables';'You must choose at least three variables.'
  return.
end.
EXP=: ".export
if. EXP do.
  Fn=. fname
  if. 0=#Fn do.
    mbError'File name required';'You must choose a file name for export.'
    return.
  end.
  if. 0<#dir Fn do.
    select. mbAsk 'File exists';'File ',y,' exists. Overwrite?'
       case. 'cancel';'no' do.
          return.
       end.
  end.
end.
PTEST=: (<test) inx TESTS
if. CTYPE do.
  cname=. <clcon
  if. -. cname e. Avail0 do.
    mbError'Choose control';'You must choose the control group.'
    return.
  end.
  if. cname e. varname do. 
    varname=. (-.cname=varname)#varname 
  end.
  varname=. cname,varname
end.
vardat=. ". each locv each varname
if. (0<PTEST)*.(1< # ~.# each vardat) do.
  mbError'Variables don''t match';'All variables must have the same number of observations',LF,'for correlation tests.'
  return.
end.
close''
nsamp=. #varname
if. CTYPE do.
  prsamp=. ((nsamp-1)#0),. (1+i.nsamp-1)
  ncomb=. nsamp-1
else.
  prsamp=. 2 comb nsamp
  ncomb=. #prsamp
end.
hdr=. 'Sample 1';'Sample 2'
hdr=. hdr,,>PTEST{(<<'W*'),(<'rho';'rho*'),(<'tau';'K*')
hdr=. hdr,<'P-value'
dat=. (0,#hdr)$<''
PR=: conew'progress'
create__PR 'Performing pair-wise tests';ncomb
psided=. 2-CTYPE
for_c. prsamp do.
  's1 s2'=. c
  datc=. c{varname
  select. PTEST
    case. ,0 do.
      res=. wilcox2 c{vardat
      datc=. datc,res;(psided* normal res)
    case. ,1 do.
      res=. spear2 c{vardat
      datc=. datc,res,(<psided*normal >{:res)
    case. ,2 do.
      res=. kend2 c{vardat
      datc=. datc,res,(< psided*normal >{:res)
  end.
  dat=. dat, citemize datc
  tick__PR''
end.
destroy__PR''
pv=. ,> {:"1 dat
pord=. /: pv
dat=. pord{dat
pv=. pord{pv
bp=. ncomb bonf pv
qv=. fdr pv
dat=. dat,. bxv bp
dat=. dat,. bxv qv
hdr=. hdr,('Bonf. P';'FDR')
if. CTYPE do.
  hdr=. hdr,<'Direction'
  dat=. dat,. ((>2{"1 dat)<0){'Sample 1>Sample 2';'Sample 1<Sample 2'
end.
tout 'Pair-wise ',(,>PTEST{TESTS),' tests, ',(>CTYPE{'two';'one'),'-sided',LF
tout bfmt hdr,ft each dat
tout LF,LF
view''   
if. EXP do.
  (hdr,dat) writecsv Fn
  mbInfo'CSV file written';'CSV file saved to ',Fn
end.
)

pairwise_cancel_button=: pairwise_cancel=: close

wilcox2=: 3 : 0
'a b'=. y
'w z p meth'=. a wilcox b
z
)

spear2=: 3 : 0
'a b'=. y
as=. sortup a
bs=. ((i.#b) indxbyy a){b
ra=. rank a
rb=. rank b
n=. #ra
z=. n*(0.5*n+1)^2
rho=. ((+/ra*rb)-z)%(((+/ra^2)-z)^0.5)*((+/rb^2)-z)^0.5
rho;rho*(n-1)^0.5
)

kend2=: 3 : 0
'a b'=. y
na=.#a
nb=.#b
as=. sortup a
bs=. ((i.#b) indxbyy a){b
k=.0.5*+/,*(a-/a)*(b-/b)
t=. 2 * k % na * na-1
ta=. ties a
tb=. ties b
vk=. (%18)*(na*(na-1)*5+2*na)-(+/ta*(ta-1)*(5+2*ta))++/tb*(tb-1)*5+2*tb
vk=. vk+(%9*na*(na-1)*(na-2))*(+/ta*(ta-1)*(ta-2))*+/tb*(tb-1)*tb-2
vk=. vk+(%2*na*na-1)*(+/ta*ta-1)*(+/tb*tb-1)
z=.k%vk^0.5
t;z
)

pairwise_dlghlp=: 3 : 0
if. HELP__ do.
   HELP__=: 0
   wd 'psel hlp; pclose; psel mstat; set DHlp 0; psel pairwise; pactive; set avlist focus'
else.
   HELP__=: 1
   open_hlp_ <'pairwise'
   wd 'psel mstat; set DHlp 1; psel pairwise; pactive; set avlist focus'
end.
)

pairwise_dctrl_fkey=: pairwise_add_button
pairwise_rctrl_fkey=: pairwise_reset_button
pairwise_octrl_fkey=: pairwise_done_button
pairwise_lctrl_fkey=: pairwise_dlghlp



NB. printpref.ijs
NB. printer prefs

coclass'printpref'

(;:'base z') copath 'printpref'

PRDEF=: ''

PRINTPREF=: 0 : 0
pc printpref dialog owner nosize escclose closeok;
pn "Printer preferences";
bin g;
grid cell 0 0 1 2 2;
bin hs;
cc labelp static right;cn "Printer";
minwh 280 24;cc pr combolist;
bin z;
grid cell 1 0 1 1 4;
groupbox Orientation;
bin h;
cc orbt0 radiobutton;cn "Portrait";
cc orbt1 radiobutton group;cn "Landscape";
bin z;
groupboxend;
grid cell 1 1 1 1 132;
bin hs;
cc lbmar static right;cn "Margin (mm)";
cc mg edit;set mg wh 60 _1;
bin sz;
grid cell 2 1;
bin h s2;
cc ok button;cn "&OK";
cc cancel button; cn "&Cancel";
bin z;
pcenter;
)

open=: 3 : 0
wd PRINTPREF
prnames=. <;._2 (wd'qprinters')
if. (#prnames)<3 do.
  mbError'Printer error';'No printers defined for this system'
  return.
end.
PRDEF=: {.prnames
prav=. 2}.prnames
wd 'set pr items ',vfm > prav
wd 'set pr select ',": prav i. PRDEF
wd 'set orbt',(":ORIENT__),' value 1'
wd 'set mg text ',":MARGIN__
if. UNAME -: 'Darwin' do.
  if. 10.7>".wd'qosver' do. wd'set prchange enable 0' end.
end.
wd 'pshow;'
)

close=: 3 : 0
wd 'pclose'
)

printpref_cancel_button=: close

printpref_ok_button=: 3 : 0
mgn=. __ ". mg
if. -. ispos mgn do.
  mbError'Value error';'Margin must be a positive number.'
  return.
end.
ORIENT__=: ".orbt1
MARGIN__=: mgn
prnew=. pr
close''
if. -. (<prnew) = PRDEF do.
  PRDEF=: (<prnew)
  wd 'defprint printer *',prnew
end.
writepref''
)


advpref_octrl_fkey=: advpref_ok_button
NB. progress.ijs
NB. progress bar dialog class
NB. Copyright (c) 2013 Norman Drinkwater
NB. Provisions of Artistic License 2.0 apply

coclass'progress'

PROGRESS=: 0 : 0
pc progress dialog nosize;pn "Please wait...";
cc prog progressbar;
pcenter;
set prog wh 300 _1;
)

create=: 3 : 0
wd PROGRESS
NB. initialize form here
'Message Total'=: y
wd 'pn "',Message,' ... please wait."'
State=: 0
wd'set prog min 0'
wd'set prog max ',":Total
wd 'pshow;'
)

destroy=: 3 : 0
wd'pclose'
codestroy''
)

tick=: 3 : 0
State=: State+1
wd'msgs'
wd'set prog pos ',":State
)

set=: 3 : 0
wd 'set prog pos ',":y
)

msg=: 3 : 0
Message=: y
wd 'pn "',Message,' ... please wait."'
)
NB.  regress.ijs
NB.  form for regression analysis

coclass 'regress'

(;:'base z') copath 'regress'

SOH=: 1{a.
toSOH=: [:;(SOH,~":)each

NB. base form 

REGRESS=: 0 : 0
pc regress dialog nosize escclose closeok;
pn "Regression analysis";
bin g;
grid cell 0 0 2 1;
bin v;
groupbox "Regression type";
cc RB0 radiobutton;cn "&Line";
bin h;
cc RB1 radiobutton;cn "Pol&ynomial";
minwh 60 _1;cc Ordlab static right;cn "Order ";
cc Pord edit;set Pord wh 60 _1;
bin z;
cc RB2 radiobutton group;cn "&Multiple";
cc Const checkbox;cn "Con&stant";
cc Plot checkbox;cn "&Plot";
groupboxend;
bin z;

grid cell 0 1 1 2 4;
bin v;
cc labely static;cn "Y variable";
cc Y combolist;set Y wh 200 _1;
bin z;

grid cell 1 1;
bin v;
cc labelx static;cn "X variable(s)";
cc Xvar listbox drag drop multiple;set Xvar wh 160 100;
bin z;

grid cell 1 2;
bin v;
cc labela static;cn "Available variables";
cc Avail listbox drag drop multiple;set Avail wh 160 100;
bin z;

grid cell 3 2;
bin hs2;
cc OK button;cn "&OK";
cc Cancel button;cn "&Cancel";
bin z;
bin z;
set Xvar stylesheet *QPlainTextEdit {background-color:#eeeeee};
pcenter;
)

open=: 3 : 0
VarN=: nl_v_''
wd REGRESS
XAvail=: VarN
wd 'set Y items ',vfm >VarN
wd 'setselect Y 0'
regress_RB0_button''
regress_write XAvail;<''
wd 'pshow;'
if. HELP__ do.
   update_hlp_ <'regress'
   wd 'psel regress; pactive; set Avail focus'
end.
)

close=: 3 : 0
wd 'pclose'
)

regress_Cancel_button=: regress_cancel=: close

regress_write=: 3 : 0
'fm to' =. y
wd'set Avail items ', ; fm ,each SOH
wd'set Xvar items ', ; to ,each SOH
)

regress_read=: 3 : 0
(<;._2 wd 'get Avail allitems');<<;._2 wd 'get Xvar allitems'
)

regress_Avail_button=: 3 : 0
'fm to'=. regress_read''
n=. ".Avail_select
to=. to,n{fm
fm=. (<<<n){fm
regress_write fm;<to
)

regress_Xvar_button=: 3 : 0
'fm to'=. regress_read''
n=. ". Xvar_select
fm=. fm,n{to
to=. (<<<n){to
regress_write fm;<to
)


regress_RB0_button=: 3 : 0
wd 'set RB0 value 1'
wd 'set Const value 1; set Pord enable 0;set Ordlab enable 0;set Plot enable 1;set Plot value 1'
NB.regress_write XAvail;<''
)

regress_RB1_button=: 3 : 0
wd 'set RB1 value 1'
wd 'set Const value 1; set Pord enable 1;set Ordlab enable 1;set Plot enable 1;set Plot value 1'
NB.regress_write XAvail;<''
)

regress_RB2_button=: 3 : 0
wd 'set RB2 value 1'
wd 'set Const value 1; set Pord enable 0;set Ordlab enable 0;set Plot enable 0;set Plot value 0'
NB.regress_write XAvail;<''
)

regress_OK_button=: 3 : 0
Type=. (". RB0,' ',RB1,' ',RB2)#0 1 2
Xtest=. >{: regress_read''
yv=. ". Y,'_v_'
ny=. #yv
if. (#Xtest) = 0 do.
  mbError 'X variables';'You must select one (or more) x variables.'
  return.
end.
if. (Type<2)*.(1<#Xtest) do.
  mbError'Number of variables';'Only one x variable may be chosen for linear',LF,'or polynomial regression.'
  return.
end.  
xv=. ". each locv each Xtest
nx=. # each xv
if. -. eqvec >nx do.
  mbError 'X variables';'All x variables must have the same number of values.'
  regress_write XAvail;<''
  return.
end.
nx=. >0{nx
if. nx ~: ny do.
  mbError 'X and Y variables';'X and Y variables must have same number of values.'
  wd 'set Y focus'
  return.
end.
y=. (ny,1)$yv
if. ". Const do.
  p=. 0
  cf=.<'c0'
else.
  p=. ''
  cf=. <''
end.
select. Type
case. ,0 do.
  x=. (,>xv) ^/ p,1
  ord=.1
  tout 'Linear regression',LF
  cf=. cf,<'c1'
case. ,1 do.
  ord=. __ ". Pord
  if. -.(isinteger ord) *. (1<ord) do.
    mbError 'Order';'Polynomial order must be a positive integer greater than 1.'
    wd 'setfocus Pord'
    return.
  end.
  x=. (,>xv) ^/ p,1+i. ord
  tout 'Polynomial regression, order ',(":ord),LF
  cf=. cf,chop vfm ((ord,1)$'c'),.(":(ord,1)$1+i.ord),.LF 
case. ,2 do.
  nc=. # xv
  if. ". Const do.
    xv=. (<nx#1),xv
  end.
  x=. |: >xv
  tout 'Multiple regression',LF
  cf=. cf,chop vfm ((nc,1)$'c'),.(":(nc,1)$1+i.nc),.LF
end.
tout 'Y: ',Y,'  X: ',(blist Xtest),LF
tout (Type showeqn cf),LF
res=. x reg y
nc=. #cf
ct=.6 1$'c';(>cf);' ';' ';' ';' '
tout LF
tout bfmt ct,. ft each res
tout LF,LF
close''
view''  
if. ". Plot do.
  xv=.,>xv
  xt=. steps (<./xv),(>./xv),99
  c=. ,>0{1{res
  yt=. (xt ^/p,1+i. ord) mp >0{1{res
  'reg' makeplot (,>Xtest);(,Y);xv;yv;xt;(,yt);c
end.
)

showeqn=: 3 : 0
:
nc=.#y
cf=. (nc,1)$y
pl=.(nc,1)$(<''),(nc-1)#<' + '
const=.(<'c0')e.,cf
ord=. nc - const
if. const do.
  cx=.<''
else.
  cx=.''
end.
select. x
  case. ,0 do.
    cx=.(nc,1)$cx,<'*X'
  case. ,1 do.
    cxp=. (nc,1)$cx,ord#<'*X'
    cxp=. cxp,.(nc,1)$cx,(<''),(ord-1)#(<'^')
    cxp=. cxp,.(nc,1)$cx,(<''),": each bxv 2+i.ord-1
    cx=. cxp
  case. ,2 do.
    cxp=. (nc,1)$cx,ord#<'*X'
    cxp=. cxp,.(nc,1)$cx,": each bxv 1+i.ord
    cx=. cxp
end.
'y = ',openvec ,pl,.cf,.cx
)

regress_dlghlp=: 3 : 0
if. HELP__ do.
   HELP__=: 0
   wd 'psel hlp; pclose; psel mstat; set DHlp 0; psel regress; pactive; set Avail focus'
else.
   HELP__=: 1
   open_hlp_ <'regress'
   wd 'psel mstat; set DHlp 1; psel regress; pactive; set Avail focus'
end.
)

regress_dctrl_fkey=: regress_Add_button
regress_rctrl_fkey=: regress_Clear_button
regress_octrl_fkey=: regress_OK_button
regress_lctrl_fkey=: regress_dlghlp

NB. spad.ijs
NB. Scratchpad for J calculations

coclass 'spad'

('base';'z') copath <'spad'

Sout=: ''


SPAD=: 0 : 0
pc spad escclose dialog;pn "Scratchpad";
bin v;
bin hs;
cc ok button;cn "&Done";
cc reset button;cn "&Reset";
cc hlp button;cn "&Help";
bin sz;

cc ed edit;
minwh 200 400;cc edout editm readonly;
)

open=: 3 : 0
wd SPAD
wd 'set ed font ',Vfont__
wd 'set edout stylesheet *QPlainTextEdit {background-color:#eeeeee;',(font2css Vfont__),'}'
sview''
wd 'set ed focus'
wd 'pshow;'
if. HELP__ do.
  update_hlp_ <'spad'
  wd 'psel spad; pactive; set ed focus'
end.
)

close=: 3 : 0
wd 'psel spad;pclose'
PAD__=: 0
wd 'psel mstat; ptop;'
)

spad_ed_button=: 3 : 0
exec=. ed
try. res=. ".exec
catch.
  mbError 'Invalid expression';'This J expression is not valid'
  wd 'setfocus ed; setselect ed 0 ',(":#ed)
  return.
end.
if. isboxed res do.
  res=. bfmt res
else.
  res=. ":res
end.
if. 1<$$res do.
  res=. vfm res
end.
Sout=: Sout,'    ',exec,LF
Sout=: Sout,res,LF
wd 'set ed text *'
sview''
)

spad_reset_button=: 3 : 0
wd 'set ed text *'
Sout=: ''
sview''
)

spad_ok_button=: spad_cancel=: spad_close=: close

sview=: 3 : 0
wd 'psel spad'
nl=.+/LF=Sout
wd 'set edout text *',Sout
wd 'set edout scroll max'
)

spad_hlp_button=: 3 : 0
Sout=: Sout,LF,(spadhlp),LF
wd 'set ed text *'
sview''
)

isboxed=: 32&=@(3!:0)

spadhlp=: 0 : 0
Scratchpad help
Enter a valid J 
expression in the edit
box and press the return
key. The expression
will be displayed 
indented in the edit
window followed by 
its result. For example, 
entering 4+2 in the
edit box displays
    4+2
6
in the edit window. See 
the help file for a 
brief summary of J notation.
)

spad_dlghlp=: 3 : 0
if. HELP__ do.
   HELP__=: 0
   wd 'psel hlp; pclose; psel mstat; set DHlp 0; psel spad; pactive; set ed focus'
else.
   HELP__=: 1
   open_hlp_ <'spad'
   wd 'psel mstat; set DHlp 1; psel spad; pactive; set ed focus'
end.
)

spad_octrl_fkey=: spad_ok_button
spad_lctrl_fkey=: spad_dlghlp
spad_rctrl_fkey=: spad_reset_button
spad_hctrl_fkey=: spad_hlp_button
NB. bayesmod.ijs
NB. form for modeling Bayes' theorem

coclass 'bmod'

(;:'base z') copath 'bmod'

RBM=: 1
PBM=: 1
PPPV=: 1
PNPV=: 1

PRANGE=: 1
SERANGE=: 2
SPRANGE=: 3
RTYPE=: PRANGE

PREV=: 0.01
SENS=: SPEC=: 0.95
PREVM=: PREVS=: SENSM=: SENSS=: SPECM=: SPECS=: ''

BMOD=: 0 : 0
pc bmod dialog nosize escclose closeok;
pn "Bayes' theorem modeling";
bin g;

grid cell 0 0;
groupbox "Prevalence";
bin v;
bin h;
cc R0 radiobutton;cn "Range";set R0 wh 70 _1;
cc PLL static right;cn "Value ";set PLL wh 100 _1;
cc PL edit;set PL wh 80 _1;
bin z;
bin h;
cc ls1 static staticbox;set ls1 wh 70 _1;
cc PUL static right;cn "Max ";set PUL wh 100 _1;
cc PU edit;set PU wh 80 _1;
bin z;
bin h;
cc ls1a static staticbox;set ls1a wh 70 _1;
cc PSL static right;cn "Step size ";set PSL wh 100 _1;
cc PS edit;set PS wh 80 _1;
bin z;
bin z;
groupboxend;

grid cell 0 1;
groupbox "";
bin v;
cc R checkbox;cn "Enable &range";
cc Plot checkbox;cn "Show &plot";
cc Pppv checkbox;cn "Plot PPV";
cc Pnpv checkbox;cn "Plot NPV";
bin z;
groupboxend;

grid cell 1 0;
groupbox "Sensitivity";
bin v;
bin h;
cc R1 radiobutton;cn "Range";set R1 wh 70 _1;
cc SLL static right;cn "Value ";set SLL wh 100 _1;
cc SL edit;set SL wh 80 _1;
bin z;
bin h;
cc ls2 static staticbox;set ls2 wh 70 _1;
cc SUL static right;cn "Max ";set SUL wh 100 _1;
cc SU edit;set SU wh 80 _1;
bin z;
bin h;
cc ls2a static staticbox;set ls2a wh 70 _1;
cc SSL static right;cn "Step size ";set SSL wh 100 _1;
cc SS edit;set SS wh 80 _1;
bin z;
bin z;
groupboxend;

grid cell 1 1;
groupbox "Specificity";
bin v;
bin h;
cc R2 radiobutton group;cn "Range";set R2 wh 70 _1;
cc CLL static right;cn "Value ";set CLL wh 100 _1;
cc CL edit;set CL wh 80 _1;
bin z;
bin h;
cc ls3 static staticbox;set ls3 wh 70 _1;
cc CUL static right;cn "Max ";set CUL wh 100 _1;
cc CU edit;set CU wh 80 _1;
bin z;
bin h;
cc ls3a static staticbox;set ls3a wh 70 _1;
cc CSL static right;cn "Step size ";set CSL wh 100 _1;
cc CS edit;set CS wh 80 _1;
bin z;
bin z;
groupboxend;

grid cell 2 1;
bin hs2;
cc OK button;cn "&OK";
cc Cancel button;cn "&Cancel";
bin z;

pcenter;
)

open=: 3 : 0
wd BMOD
wd'set PL text ',":PREV
wd'set PU text ',":PREVM
wd'set PS text ',":PREVS
wd'set SL text ',":SENS
wd'set SU text ',":SENSM
wd'set SS text ',":SENSS
wd'set CL text ',":SPEC
wd'set CU text ',":SPECM
wd'set CS text ',":SPECS
". 'bmod_R',(":RTYPE-1),'_button'''''
if. RBM do.
  wd'set R value 1'
  Renable''
else.
  wd'set R value 0'
  Rdisable''
end.
wd'set Pppv value ',":PPPV
wd'set Pnpv value ',":PNPV
wd'pshow;'
wd'set PL focus'
if. HELP__ do.
  update_hlp_<'bmod'
  wd'psel bmod; pactive; set PL focus'
end.
)

close=: 3 : 0
wd'pclose'
)

bmod_Cancel_button=: bmod_cancel=: close

bmod_OK_button=: 3 : 0
RBM=: ".R
PPPV=: ".Pppv
PNPV=: ". Pnpv
if. RBM do. RTYPE=: {.(". R0,' ',R1,' ',R2)#1 2 3 end.
doPlot=. PBM=: ".Plot
if. Invalid'' do.
  return.
end.
PREV=: toN PL
SENS=: toN SL
SPEC=: toN CL
tout 'Bayesian modeling',LF
tout 'PPV, Positive Predictive Value; NPV, Negative Predictive Value',LF
if. RBM do.
  select. RTYPE
    case. PRANGE do.
      prevmin=. PREV
      PREVM=: prevmax=. ".PU
      PREVS=: prevst=. ".PS
      tout 'Sensitivity = ',(ft SENS),'; Specificity = ',(ft SPEC),LF
      dtab=. 1 3$'Prevalence';'PPV';'NPV'
      pi=. range prevmin,prevmax,prevst
      pv=. ft each >bxv each pi bayes SENS;SPEC
      dtab=. dtab,|:(bxv pi),pv
      tout bfmt dtab
      tout LF,LF
      if. doPlot do.
        px=. range prevmin,prevmax,0.01*prevmax-prevmin
        py=. >px bayes SENS;SPEC
        plabel=. 'Prevalence';'Predictive value';'Sensitivity = ',(ft SENS),', Specificity = ',(ft SPEC)
      end.
    case. SERANGE do.
      semin=. SENS
      SENSM=: semax=. ".SU
      SENSS=: sest=. ".SS
      tout 'Prevalence = ',(ft PREV),'; Specificity = ',(ft SPEC),LF
      dtab=. 1 3$'Sensitivity';'PPV';'NPV'
      si=. range semin,semax,sest
      pv=. ft each >bxv each PREV bayes si;SPEC
      dtab=. dtab,|:(bxv si),pv
      tout bfmt dtab
      tout LF,LF
      if. doPlot do.
        px=. range semin,semax,0.01*semax-semin
        py=. >PREV bayes px;SPEC
        plabel=. 'Sensitivity';'Predictive value';'Prevalence = ',(ft PREV),', Specificity = ',(ft SPEC)
      end.
    case. SPRANGE do.
      spmin=. SPEC
      SPECM=: spmax=. ".CU
      SPECS=: spst=. ".CS
      tout 'Prevalence = ',(ft PREV),'; Sensitivity = ',(ft SENS),LF
      dtab=. 1 3$'Specificity';'PPV';'NPV'
      si=. range spmin,spmax,spst
      pv=. ft each >bxv each PREV bayes SENS;si
      dtab=. dtab,|:(bxv si),pv
      tout bfmt dtab
      tout LF,LF
      if. doPlot do.
        px=. range spmin,spmax,0.01*spmax-spmin
        py=. >PREV bayes SENS;px
        plabel=. 'Specificity';'Predictive value';'Prevalence = ',(ft PREV),', Sensitivity = ',(ft SENS)
      end.
  end.
else.
  tout 'Prevalence = ',(ft PREV),', Sensitivity = ',(ft SENS),', Specificity = ',(ft SPEC),LF
  pv=. PREV bayes SENS;SPEC
  tout 'PPV = ',(ft >{.pv),LF
  tout 'NPV = ',(ft >{:pv),LF,LF
end.      
close''
view''
if. doPlot do.
  'bpv' makeplot (<'PPV NPV'),(<px),(<py),(<PPPV,PNPV),plabel
end.
)


bmod_R0_button=: 3 : 0
wd'set R0 value 1;set R1 value 0;set R2 value 0'
wd'set PLL text "Min ";set PUL enable 1;set PU enable 1;set PSL enable 1;set PS enable 1'
wd'set SLL text "Value ";set SUL enable 0;set SU enable 0;set SSL enable 0;set SS enable 0'
wd'set CLL text "Value ";set CUL enable 0;set CU enable 0;set CSL enable 0;set CS enable 0'
RTYPE=: PRANGE
)

bmod_R1_button=: 3 : 0
wd'set R0 value 0;set R1 value 1;set R2 value 0'
wd'set SLL text "Min ";set SUL enable 1;set SU enable 1;set SSL enable 1;set SS enable 1'
wd'set PLL text "Value ";set PUL enable 0;set PU enable 0;set PSL enable 0;set PS enable 0'
wd'set CLL text "Value ";set CUL enable 0;set CU enable 0;set CSL enable 0;set CS enable 0'
RTYPE=: SERANGE
)

bmod_R2_button=: 3 : 0
wd'set R0 value 0;set R1 value 0;set R2 value 1'
wd'set CLL text "Min ";set CUL enable 1;set CU enable 1;set CSL enable 1;set CS enable 1'
wd'set SLL text "Value ";set SUL enable 0;set SU enable 0;set SSL enable 0;set SS enable 0'
wd'set PLL text "Value ";set PUL enable 0;set PU enable 0;set PSL enable 0;set PS enable 0'
RTYPE=: SPRANGE
)

bmod_R_button=: 3 : 0
if. ".R do. Renable'' else. Rdisable'' end.
)

Renable=: 3 : 0
wd'set R0 enable 1;set R1 enable 1;set R2 enable 1'
wd'set Plot enable 1;set Pppv enable 1;set Pnpv enable 1'
wd'set Plot value ',":PBM
wd'set Pppv value ',":PPPV
wd'set Pnpv value ',":PNPV
". 'bmod_R',(":RTYPE-1),'_button'''''
RBM=: 1
)

Rdisable=: 3 : 0
wd'set R0 enable 0;set R1 enable 0;set R2 enable 0'
wd'set Plot enable 0;set Pppv enable 0;set Pnpv enable 0'
wd'set Plot value 0;set Pppv value 0;set Pnpv value 0'
wd'set PLL text "Value ";set PUL enable 0;set PU enable 0;set PSL enable 0;set PS enable 0'
wd'set SLL text "Value ";set SUL enable 0;set SU enable 0;set SSL enable 0;set SS enable 0'
wd'set CLL text "Value ";set CUL enable 0;set CU enable 0;set CSL enable 0;set CS enable 0'
RBM=: 0
)

bmod_Plot_button=: 3 : 0
if. ".Plot do. PBM=: 1 else. PBM=: 0 end.
)

Invalid=: 3 : 0
v=. (toN PL),(toN SL),(toN CL)
if. (+./ 0>/v) +. +./1</v do.
  mbError'Value error';'Inital values for prevalence, sensitivity, and specificity must be between 0 and 1.'
  1 return.
end.
if. -.RBM do. 0 return. end.
t=. RTYPE{' PSC'
max=. ".'toN ',t,'U'
if. (+./ 0>/max) +. +./1</max do.
  mbError'Value error';'Max value for ',(,>(RTYPE-1){'Prevalence';'Sensitivity';'Specificity'),' must be between 0 and 1.'
  1 return.
end.
st=. ".'toN ',t,'S'
if. (+./ 0>/st) +. +./1</st do.
  mbError'Value error';'Step size for ',(,>(RTYPE-1){'Prevalence';'Sensitivity';'Specificity'),' must be between 0 and 1.'
  1 return.
end.
0
)

bmod_dlghlp=: 3 : 0
if. HELP__ do.
   HELP__=: 0
   wd 'psel hlp; pclose; psel mstat; set DHlp 0; psel bmod; pactive; set PL focus'
else.
   HELP__=: 1
   open_hlp_ <'bmod'
   wd 'psel mstat; set DHlp 1; psel bmod; pactive; set PL focus'
end.
)

citemize=: ,:^:(2: > #@$)


bmod_octrl_fkey=: bmod_OK_button
bmod_lctrl_fkey=: bmod_dlghlp
NB. ssfish.ijs
NB. form for fisher sample size

coclass 'ssfish'

(;:'base z') copath 'ssfish'

RSSF=: 1
PSSF=: 1
SSSF=: 1
beta=: 0.10
alpha=: 0.05
ALPHA=: 0.05
PRANGE=: 1
LRANGE=: 2
URANGE=: 3
RTYPE=: URANGE
POWER=: 0.9
POWERM=: POWERS=: ''
LOWER=: LOWERM=: LOWERS=: ''
HIGHER=: HIGHERM=: HIGHERS=: ''

SSFISH=: 0 : 0
pc ssfish dialog nosize escclose closeok;
pn "Sample size for Fisher's exact test";
bin g;

grid cell 0 0;
bin v;
groupbox "Significance level";
bin v;
bin h;
cc label static right;cn "alpha ";set label wh 60 _1;
cc P edit;set P wh 80 _1;
bin sz;
bin h;
cc ls1 static staticbox;set ls1 wh 60 _1;
cc Sided0 radiobutton;cn "o&ne-sided";
bin z;
bin h;
cc ls1a static staticbox;set ls1a wh 60 _1;
cc Sided1 radiobutton group;cn "&two-sided";
bin z;
bin z;
groupboxend;
cc R checkbox;cn "Enable &range";
bin z;

grid cell 0 1;
groupbox "Power";
bin v;
bin h;
cc R0 radiobutton;cn "Range";set R0 wh 70 _1;
cc PLL static right;cn "Value ";set PLL wh 100 _1;
cc PL edit;set PL wh 80 _1;
bin z;
bin h;
cc ls2 static staticbox; set ls2 wh 70 _1;
cc PUL static right;cn "Max ";set PUL wh 100 _1;
cc PU edit;set PU wh 80 _1;
bin z;
bin h;
cc ls2a static staticbox; set ls2a wh 70 _1;
cc PSL static right;cn "Num. steps ";set PSL wh 100 _1;
cc PS edit;set PS wh 80 _1;
bin z;
bin z;
groupboxend;

grid cell 1 0;
groupbox "Lower proportion";
bin v;
bin h;
cc R1 radiobutton;cn "Range";set R1 wh 70 _1;
cc LLL static right;cn "Value ";set LLL wh 100 _1;
cc LL edit;set LL wh 80 _1;
bin z;
bin h;
cc ls3 static staticbox; set ls3 wh 70 _1;
cc LUL static right;cn "Max ";set LUL wh 100 _1;
cc LU edit;set LU wh 80 _1;
bin z;
bin h;
cc ls3a static staticbox; set ls3a wh 70 _1;
cc LSL static right;cn "Num. steps ";set LSL wh 100 _1;
cc LS edit;set LS wh 80 _1;
bin zz;
groupboxend;

grid cell 1 1;
groupbox "Higher proportion";
bin v;
bin h;
cc R2 radiobutton group;cn "Range";set R2 wh 70 _1;
cc ULL static right;cn "Value ";set ULL wh 100 _1;
cc UL edit;set UL wh 80 _1;
bin z;
bin h;
cc ls4 static staticbox; set ls4 wh 70 _1;
cc UUL static right;cn "Max ";set UUL wh 100 _1;
cc UU edit;set UU wh 80 _1;
bin z;
bin h;
cc ls4a static staticbox; set ls4a wh 70 _1;
cc USL static right;cn "Num. steps ";set USL wh 100 _1;
cc US edit;set US wh 80 _1;
bin zz;
groupboxend;

grid cell 2 0;
bin h;
cc Plot checkbox;cn "&Plot";
cc bwp checkbox;cn "Black and white";
bin z;

grid cell 2 1;
bin hs2;
cc OK button;cn "&OK";
cc Cancel button;cn "&Cancel";
bin z;

pcenter;

)

open=: 3 : 0
beta=: 0.1
wd SSFISH
wd 'set P text ',":ALPHA
wd 'set PL text *',":POWER
wd 'set PU text ',":POWERM
wd 'set PS text ',":POWERS
wd 'set LL text *',":LOWER
wd 'set LU text ',":LOWERM
wd 'set LS text ',":LOWERS
wd 'set UL text *',":HIGHER
wd 'set UU text ',":HIGHERM
wd 'set US text ',":HIGHERS
wd 'set bwp value ',":PlotBW__
if. RSSF do.
  wd 'set R value 1'
  Renable''
  select. RTYPE
    case. PRANGE do.
      ssfish_R0_button''
    case. LRANGE do.
      ssfish_R1_button''
    case. URANGE do.
      ssfish_R2_button''
  end.
  if. PSSF do.
    wd 'set Plot value 1'
  else.
    wd 'set Plot value 0'
  end.
else.
  Rdisable''
  wd 'set R value 0'
  wd 'set R0 value 0; set R',(":RTYPE-1),' value 1'
end.
if. SSSF do.
   wd 'set Sided1 value 1'
else.
   wd 'set Sided0 value 1'
end.
wd 'pshow;'
wd 'set LL focus'
if. HELP__ do.
   update_hlp_ <'ssfish'
   wd 'psel ssfish; pactive; set LL focus'
end.
)

close=: 3 : 0
wd 'pclose'
)

ssfish_Cancel_button=: ssfish_cancel=: close

ssfish_OK_button=: 3 : 0
if. RSSF do.
  RTYPE=: {.(". R0,' ',R1,' ',R2)#1 2 3
end.
if. Invalid RTYPE*RSSF do.
  return.
end.
alpha=. ALPHA=: toN P
SSSF=: ".Sided1
s=. 1+SSSF
Sd=.>s{'';'one';'two'
PlotBW__=: ".bwp
POWER=: toN PL
beta=: 1- POWER
p2=. LOWER=: toN LL
p1=. HIGHER=: toN UL
tout 'Sample size for Fisher''s exact test.',LF
doPlot=. PSSF=: ".Plot
mvname=. ''
mvtype=. _1
nval=. ,># each beta;p1;p2
if. +/nval>1 do.
  mvtype=. inxb nval>1
  mvname=. mvtype{beta;p1;p2
  if. 0=mvtype do. mvname=. ": 1->mvname else. mvname=. ":>mvname end.
else.
  mvname=. ": 1-beta
end.
if. RSSF do.
  select. RTYPE
    case. PRANGE do.
      maxb=. 1-POWERM=: toN PU
      stpb=. POWERS=: toN PS
      bi=. range beta,maxb,-(maxb-beta)%stpb
      nb=. #bi
      n=. (<'N/group'),bxv >.fisherss alpha;s;bi;(nb# citemize p1);p2
      if. doPlot do.
        px=. 1-range beta,maxb,-(maxb-beta)%100
        nb=. #px
        if. 0<mvtype do.
          py=. |:fisherss alpha;s;(1-px);(nb#citemize p1);p2
        else.
          py=. fisherss alpha;s;(citemize 1-px);(p1);p2
        end.
        plabel=. 'Power';'Number per group';'Fisher''s exact test: alpha=',(":alpha),' (',Sd,'-sided)',LF,'p(lower)=',(":p2),', p(upper)=',(":p1)
      end.
      dtab=. |: (2,1+#bi)$(<'Power'),(ft each bxv 1-bi),n
      tout 'alpha=',(":alpha),'(',Sd,'-sided)',LF
      tout 'p(lower)=',(":p2),', p(upper)=',(":p1),LF
      tout bfmt dtab
      tout LF,LF
    case. LRANGE do.
      maxp2=. LOWERM=: toN LU
      stpp2=. LOWERS=: toN LS
      pi=. range p2,maxp2,(maxp2-p2)%stpp2
      nb=.#beta
      if. 1=mvtype do.
        n=. (<'N/group'), , each boxcols >.,.fisherss alpha;s;beta;p1;nb#citemize pi
      else.
        n=. (<'N/group'), , each boxcols >.fisherss alpha;s;beta;p1;nb#citemize pi
      end.
      if. doPlot do.
        px=. range p2,maxp2,(maxp2-p2)%100
        if. 1=mvtype do.
          py=. ,.fisherss alpha;s;beta;p1;nb#citemize px
        else.
          py=. fisherss alpha;s;beta;p1;nb#citemize px
        end.
        plabel=. 'p(lower)';'Number per group';'Fisher''s exact test: alpha=',(":alpha),' (',Sd,'-sided)',LF,'Power=',(":1-beta),', p(upper)=',(":p1)
      end.
      tout 'alpha=',(":alpha),'(',Sd,'-sided), power=',(":1-beta),LF
      tout 'p(upper)=',(":p1),LF
      dtab=. |: (2,1+#pi)$(<'p(lower)'),(ft each bxv  pi),n
      tout bfmt dtab
      tout LF,LF
    case. URANGE do.
      maxp1=. HIGHERM=: toN UU
      stpp1=. HIGHERS=: toN US
      pi=. range p1,maxp1,(maxp1-p1)%stpp1
      nb=.#beta
      n=. (<'N/group'), , each boxcols >.fisherss alpha;s;beta;(nb#citemize pi);p2
      if. doPlot do.
        px=. range p1,maxp1,(maxp1-p1)%100
        if. 2=mvtype do.
          py=. |: {. fisherss alpha;s;beta;(nb#citemize px);p2
        else.
          py=. fisherss alpha;s;beta;(nb#citemize px);p2
        end.
        plabel=. 'p(upper)';'Number per group';'Fisher''s exact test: alpha=',(":alpha),' (',Sd,'-sided)',LF,' Power=',(":1-beta),', p(lower)=',(":p2)
      end.
      tout 'alpha=',(":alpha),' (',Sd,'-sided), power=',(":1-beta),LF
      tout 'p(lower)=',(":p2),LF
      dtab=. |: (2,1+#pi)$(<'p(upper)'),(ft each bxv pi),n
      tout bfmt dtab
      tout LF,LF
  end.
else.
  n=. >.fisherss alpha;s;beta;p1;p2
  tout 'alpha=',(":alpha),'(',Sd,'-sided), power=',(":1-beta),LF
  tout 'p(lower)=',(":p2),', p(upper)=',(":p1),LF
  tout 'n = ',(":n),' per group.',LF,LF
end.
close''
view''
if. doPlot do.
  'pow' makeplot (<mvname),(<px),(<py),plabel
end.
)

Invalid=: 3 : 0
1
'a b p2 p1'=. v=. (toN P);(toN PL);(toN LL);toN UL
v=. ,>v
nval=. ,># each b;p2;p1
if. 0<+/nval>1 do.
  if. 1<+/nval>1 do.
    mbError'Multiple value error';'Multiple values allowed in only one of Power, lower proportion, upper proportion.'
    return.
  end.
  if. (inxb nval>1)=RTYPE-1 do.
    mbError'Multiple value error';'Multiple values allowed only where range not enabled.'
    return.
  end.
end.
if. (+./0>/v) +. +./1</v do.
  mbError 'Value error';'Values for alpha, power, and proportions must be between 0 and 1.'
  return.
end.
select. y
  case. 0 do.
    if. p2>:p1 do.
      mbError 'Value error';'Higher proportion is less than or equal to lower proportion.'
      return.
    end.
  case. PRANGE do.
    'max step'=.(toN PU);toN PS
    if. (1<#max)+.1<#step do.
      mbError 'Multiple values';'Multiple values not allowed in power max or step.'
      return.
    end.
    if. p2>:p1 do.
      mbError 'Value error';'Higher proportion is less than or equal to lower proportion.'
      return.
    end.
    if. (2>step) do.
      mbError 'Value error';'Number of steps must be greater than 1.'
      return.
    end.
    if. (0>max)+.1<max do.
      mbError 'Value error';'Min and max values for power must be between 0 and 1.'
      return.
    end.
    if. max<:b do.
      mbError 'Value error';'Min value is larger than or equal to max value for power.'
      return.
    end.
  case. LRANGE do.
    'max step'=.(toN LU);toN LS
    if. (1<#max)+.1<#step do.
      mbError 'Multiple values';'Multiple values not allowed in power max or step.'
      return.
    end.
    if. p2>:p1 do.
      mbError 'Value error';'Higher proportion is less than or equal to lower proportion.'
      return.
    end.
    if. (2>step) do.
      mbError 'Value error';'Number of steps must be greater than 1.'
      return.
    end.
    if. (0>max)+.1<max do.
      mbError 'Value error';'Min and max values for lower proportion must be between 0 and 1.'
      return.
    end.
    if. max<:p2 do.
      mbError 'Value error';'Min value is larger than or equal to max value for lower proportion.'
      return.
    end.
    if. max>:p1 do.
      mbError 'Value error';'Max for lower proportion equals or exceeds higher proportion.'
      return.
    end.
  case. URANGE do.
    'max step'=.(toN UU);toN US
    if. (1<#max)+.1<#step do.
      mbError 'Multiple values';'Multiple values not allowed in power max or step.'
      return.
    end.
    if. p2>:p1 do.
      mbError 'Value error';'Higher proportion is less than lower proportion.'
      return.
    end.
    if. (2>step) do.
      mbError 'Value error';'Number of steps must be greater than 1.'
      return.
    end.
    if. (0>max)+.1<max do.
      mbError 'Value error';'Min and max values for higher proportion must be between 0 and 1.'
      return.
    end.
    if. max<:p1 do.
      mbError 'Value error';'Min value is larger than or equal to max value for higher proportion.'
      return.
    end.
end.
0
)

ssfish_R_button=: 3 : 0
if. ".R do.
  Renable''
else.
  Rdisable''
end.
)

Renable=: 3 : 0
wd 'set R0 enable 1;set R1 enable 1;set R2 enable 1'
wd 'set Plot enable 1;set bwp enable 1'
select. RTYPE
  case. PRANGE do.
    ssfish_R0_button''
  case. LRANGE do.
    ssfish_R1_button''
  case. URANGE do.
    ssfish_R2_button''
end.
RSSF=: 1
)

Rdisable=: 3 : 0
wd 'set R0 enable 0;set R1 enable 0;set R2 enable 0'
wd 'set Plot 0;set Plot enable 0;set bwp enable 0'
wd 'set PLL text Value ;set PUL enable 0;set PU enable 0;set PSL enable 0;set PS enable 0'
wd 'set LLL text Value ;set LUL enable 0;set LU enable 0;set LSL enable 0;set LS enable 0'
wd 'set ULL text Value ;set UUL enable 0;set UU enable 0;set USL enable 0;set US enable 0'
RSSF=:0
)

ssfish_R0_button=: 3 : 0
wd 'set R0 value 1;set R1 value 0;set R2 value 0'
wd 'set PLL text Min ;set PUL enable 1;set PU enable 1;set PSL enable 1;set PS enable 1'
wd 'set LLL text Value ;set LUL enable 0;set LU enable 0;set LSL enable 0;set LS enable 0'
wd 'set ULL text Value ;set UUL enable 0;set UU enable 0;set USL enable 0;set US enable 0'
RTYPE=: PRANGE
)

ssfish_R1_button=: 3 : 0
wd 'set R1 value 1; set R0 value 0; set R2 value 0'
wd 'set PLL text Value ;set PUL enable 0;set PU enable 0;set PSL enable 0;set PS enable 0'
wd 'set LLL text Min ;set LUL enable 1;set LU enable 1;set LSL enable 1;set LS enable 1'
wd 'set ULL text Value ;set UUL enable 0;set UU enable 0;set USL enable 0;set US enable 0'
RTYPE=: LRANGE
)

ssfish_R2_button=: 3 : 0
wd 'set R2 value 1;set R0 value 0;set R1 value 0;'
wd 'set PLL text Value ;set PUL enable 0;set PU enable 0;set PSL enable 0;set PS enable 0'
wd 'set LLL text Value ;set LUL enable 0;set LU enable 0;set LSL enable 0;set LS enable 0'
wd 'set ULL text Min ;set UUL enable 1;set UU enable 1;set USL enable 1;set US enable 1'
RTYPE=: URANGE
)

ssfish_Plot_button=: 3 : 0
if. ".Plot do.
  PSSF=:1
else.
  PSSF=:0
end.
)

ssfish_Sided0_button=: 3 : 0
SSSF=:0
)

ssfish_Sided1_button=: 3 : 0
SSSF=:1
)

ssfish_dlghlp=: 3 : 0
if. HELP__ do.
   HELP__=: 0
   wd 'psel hlp; pclose; psel mstat; set DHlp 0; psel ssfish; pactive; set LL focus'
else.
   HELP__=: 1
   open_hlp_ <'ssfish'
   wd 'psel mstat; set DHlp 1; psel ssfish; pactive; set LL focus'
end.
)

citemize=: ,:^:(2: > #@$)

ssfish_octrl_fkey=: ssfish_OK_button
ssfish_lctrl_fkey=: ssfish_dlghlp
NB. ssmcnem.ijs
NB. form for McNemar sample size

coclass 'ssmcnem'

(;:'base z') copath 'ssmcnem'

RSSM=: 1
PSSM=: 1
SSSM=: 1
beta=: 0.10
alpha=: 0.05
Phi=: 0
M=: 1

PRANGE=: 1
LRANGE=: 2
ORRANGE=: 3
RTYPE=: ORRANGE

mNONE=: 0
mBETA=: 1
mP0=: 2
mOR=: 3
mMATCH=: 4
mCORR=: 5

SSMCN=: 0 : 0
pc ssmcn dialog nosize escclose closeok;
pn "Sample size for McNemar's test";
bin g;

grid cell 0 0;
groupbox "Significance level";
bin v;
bin h;
cc labela static right;cn "alpha ";set labela wh 60 _1;
cc P edit;set P wh 80 _1;
bin sz;
bin h;
cc ls1 static staticbox;set ls1 wh 60 _1;
cc Sided0 radiobutton;cn "o&ne-sided";
bin z;
bin h;
cc ls1a static staticbox;set ls1a wh 60 _1;
cc Sided1 radiobutton group;cn "&two-sided";
bin zz;
groupboxend;

grid cell 0 1;
groupbox "Power";
bin v;
bin h;
cc R0 radiobutton;cn "Range";set R0 wh 70 _1;
cc PLL static right;cn "Value ";set PLL wh 100 _1;
cc PL edit;set PL wh 80 _1;
bin z;
bin h;
cc ls2 static staticbox;set ls2 wh 70 _1;
cc PUL static right;cn "Max ";set PUL wh 100 _1;
cc PU edit;set PU wh 80 _1;
bin z;
bin h;
cc ls2a static staticbox;set ls2a wh 70 _1;
cc PSL static right;cn "Num. steps ";set PSL wh 100 _1;
cc PS edit;set PS wh 80 _1;
bin zz;
groupboxend;

grid cell 1 0;
groupbox "Control proportion";
bin v;
bin h;
cc R1 radiobutton group;cn "Range";set R1 wh 70 _1;
cc LLL static right;cn "Value ";set LLL wh 100 _1;
cc LL edit;set LL wh 80 _1;
bin z;
bin h;
cc ls3 static staticbox;set ls3 wh 70 _1;
cc LUL static right;cn "Max ";set LUL wh 100 _1;
cc LU edit;set LU wh 80 _1;
bin z;
bin h;
cc ls3a static staticbox;set ls3a wh 70 _1;
cc LSL static right;cn "Num. steps ";set LSL wh 100 _1;
cc LS edit;set LS wh 80 _1;
bin zz;
groupboxend;

grid cell 1 1;
groupbox "Odds ratio";
bin v;
bin h;
cc R2 radiobutton group;cn "Range";set R2 wh 70 _1;
cc OLL static right;cn "Value  ";set OLL wh 100 _1;
cc OL edit;set OL wh 80 _1;
bin z;
bin h;
cc ls4 static staticbox;set ls4 wh 70 _1;
cc OUL static right;cn "Max ";set OUL wh 100 _1;
cc OU edit;set OU wh 80 _1;
bin z;
bin h;
cc ls4a static staticbox;set ls4a wh 70 _1;
cc OSL static right;cn "Num. steps ";set OSL wh 100 _1;
cc OS edit;set OS wh 80 _1;
bin zz;
groupboxend;

grid cell 2 0;
bin v;
cc R checkbox;cn "Enable &range";
bin h;
cc Plot checkbox;cn "&Plot";
cc bwp checkbox;cn "Black and white";
bin z;
bin z;

grid cell 2 1;
bin v;
bin hs;
cc labelcon static right;cn "Num. matched controls ";set labelcon wh 190 _1;
cc match edit;set match wh 60 _1;
bin z;
bin hs;
cc labelcor static right;cn "Case-control correlation ";set labelcor wh 190 _1;
cc corr edit;set corr wh 60 _1;
bin zz;

grid cell 3 1;
bin hs2;
cc OK button;cn "&OK";
cc Cancel button;cn "&Cancel";
bin z;
bin z;
pcenter;

)

open=: 3 : 0
wd SSMCN
wd 'set P text ',":alpha
wd 'set PL text *',":1-beta
wd 'set match text *',":M
wd 'set corr text *',":Phi
wd 'set bwp value ',":PlotBW__
if. RSSM do.
  wd 'set R value 1'
  Renable''
  select. RTYPE
    case. PRANGE do.
      ssmcn_R0_button''
    case. LRANGE do.
      ssmcn_R1_button''
    case. ORRANGE do.
      ssmcn_R2_button''
  end.
  if. PSSM do.
    wd 'set Plot value 1'
  else.
    wd 'set Plot value 0'
  end.
else.
  Rdisable''
  wd 'set R value 0'
  wd 'set R0 value 0; set R',(":RTYPE-1),' value 1'
end.
if. SSSM do.
   wd 'set Sided1 value 1'
else.
   wd 'set Sided0 value 1'
end.
wd 'pshow;'
wd 'set LL focus'
if. HELP__ do.
   update_hlp_ <'ssmcn'
   wd 'psel ssmcn; pactive; set LL focus'
end.
)

close=: 3 : 0
wd 'pclose'
)

ssmcn_Cancel_button=: ssmcn_cancel=: close

ssmcn_OK_button=: 3 : 0
if. RSSM do.
  RTYPE=: {.(". R0,' ',R1,' ',R2)#1 2 3
end.
PlotBW__=: ".bwp
alpha=: toN P
s=. 1+".Sided1
Sd=.>s{'';'one';'two'
beta=: 1 - toN PL
p0=. toN LL
or=. toN OL
M=: toN match
Phi=: toN corr
if. Invalid RTYPE*RSSM do.
  return.
end.
mvtype=. mNONE
nval=. ,># each beta;p0;or;M;Phi
if. +/nval>1 do.
  mvtype=. {. 1+inxb nval>1
end.
mvname=. mvtype{beta;beta;p0;or;M;Phi
if. 2>mvtype do. mvname=. ":1->mvname else. mvname=. ":>mvname end.
tout 'Sample size for McNemar''s test.',LF
doPlot=. ".Plot
if. RSSM do.
  select. RTYPE
    case. PRANGE do.
      maxb=. 1 - toN PU
      stpb=. toN PS
      bi=. range beta,maxb,-(maxb-beta)%stpb
      ns=. (#bi)#0
      n=. <'Num. cases'
      if. doPlot do.
        px=. 1 - range beta,maxb,-(maxb-beta)%100
        plabel=. 'Power';'Number of cases';'McNemar''s test, Alpha(',Sd,'-sided) = ',(":alpha),LF,'P(control) = ',(":p0),', Odds ratio = ',(":or),', Matched controls = ',(":M),', Corr. = ',(":Phi)
        nsp=. (#px)#0
      end.
      select. mvtype
        case. mNONE do.
          ns=. ns,. mcnemss alpha;s;bi;p0;or;Phi;M
          if. doPlot do. nsp=. nsp,.mcnemss alpha;s;(1-px);p0;or;Phi;M end.
        case. mP0 do.
          for_pi. p0 do.
            ns=. ns,.mcnemss alpha;s;bi;pi;or;Phi;M
            if. doPlot do. nsp=.nsp,.mcnemss alpha;s;(1-px);pi;or;Phi;M end.
          end.
        case. mOR do.
          for_oi. or do.
            ns=. ns,.mcnemss alpha;s;bi;p0;oi;Phi;M
            if. doPlot do. nsp=. nsp,.mcnemss alpha;s;(1-px);p0;oi;Phi;M end.
          end.
        case. mMATCH do.
          for_mi. M do.
            ns=. ns,.mcnemss alpha;s;bi;p0;or;Phi;mi
            if. doPlot do. nsp=. nsp,.mcnemss alpha;s;(1-px);p0;or;Phi;mi end.
          end.
        case. mCORR do.
          for_ci. Phi do.
            ns=. ns,.mcnemss alpha;s;bi;p0;or;ci;M
            if. doPlot do. nsp=. nsp,.mcnemss alpha;s;(1-px);p0;or;ci;M end.
          end.
      end.
      n=. n,bxv }."1 >.ns
      if. doPlot do. py=. |: }."1 nsp end.
      dtab=. |: (2,1+#bi)$(<'Power'),(ft each bxv 1-bi),n
      tout 'Alpha(',Sd,'-sided) = ',(":alpha),LF
      tout 'P(control) = ',(":p0),', Odds ratio = ',(":or),LF
      tout 'Matched controls = ',(":M),', Correlation = ',(":Phi),LF
      tout bfmt dtab
      tout LF,LF
    case. LRANGE do.
      maxp0=. toN LU
      stpp0=. toN LS
      pi=. range p0,maxp0,(maxp0-p0)%stpp0
      ns=. (#pi)#0
      n=. <'Num. cases'
      if. doPlot do.
        px=. range p0,maxp0,(maxp0-p0)%100
        plabel=. 'P(control)';'Number of cases';'McNemar''s test, Alpha(',Sd,'-sided) = ',(":alpha),', Power = ',(":1-beta),LF,'Odds ratio = ',(":or),', Matched controls = ',(":M),', Corr. = ',(":Phi)
        nsp=. (#px)#0
      end.
      select. mvtype
        case. mNONE do.
          ns=. ns,. mcnemss alpha;s;beta;pi;or;Phi;M
          if. doPlot do. nsp=. nsp,.mcnemss alpha;s;beta;px;or;Phi;M end.
        case. mBETA do.
          for_bi. beta do.
            ns=. ns,. mcnemss alpha;s;bi;pi;or;Phi;M
            if. doPlot do. nsp=. nsp,. mcnemss alpha;s;bi;px;or;Phi;M end.
          end.
        case. mOR do.
          for_oi. or do.
            ns=. ns,. mcnemss alpha;s;beta;pi;oi;Phi;M
            if. doPlot do. nsp=. nsp,. mcnemss alpha;s;beta;px;oi;Phi;M end.
          end.
        case. mMATCH do.
          for_mi. M do.
            ns=. ns,. mcnemss alpha;s;beta;pi;or;Phi;mi
            if. doPlot do. nsp=. nsp,. mcnemss alpha;s;beta;px;or;Phi;mi end.
          end.
        case. mCORR do.
          for_ci. Phi do.
            ns=. ns,.mcnemss alpha;s;beta;pi;or;ci;M
            if. doPlot do. nsp=. nsp,.mcnemss alpha;s;beta;px;or;ci;M end.
          end.
      end.
      n=. n,bxv }."1 >.ns
      if. doPlot do. py=. |: }."1 nsp end.
      tout 'Alpha(',Sd,'-sided = ',(":alpha),', Power = ',(":1-beta),LF
      tout 'Odds ratio =',(":or),', Matched controls = ',(":M),', Correlation = ',(":Phi),LF
      dtab=. |: (2,1+#pi)$(<'P(control)'),(ft each bxv  pi),n
      tout bfmt dtab
      tout LF,LF
    case. ORRANGE do.
      maxor=. toN OU
      stpor=. toN OS
      oi=. range or,maxor,(maxor-or)%stpor
      n=. <'Num. cases'
      ns=. (#oi)#0
      if. doPlot do.
        px=. range or,maxor,(maxor-or)%100
        plabel=. 'Odds ratio';'Number of cases';'McNemar''s test, Alpha(',Sd,'-sided) = ',(":alpha),', Power = ',(":1-beta),LF,'P(control) = ',(":p0),', Matched controls = ',(":M),', Corr. = ',(":Phi)
        nsp=. (#px)#0
      end.
      select. mvtype
        case. mNONE do.
          ns=. ns,. mcnemss alpha;s;beta;p0;oi;Phi;M
          if. doPlot do. nsp=. nsp,. mcnemss alpha;s;beta;p0;px;Phi;M end.
        case. mBETA do.
          for_bi. beta do.
            ns=. ns,. mcnemss alpha;s;bi;p0;oi;Phi;M
            if. doPlot do. nsp=. nsp,. mcnemss alpha;s;bi;p0;px;Phi;M end.
          end.
        case. mP0 do.
          for_pi. p0 do.
            ns=. ns,. mcnemss alpha;s;beta;pi;oi;Phi;M
            if. doPlot do. nsp=. nsp,. mcnemss alpha;s;beta;pi;px;Phi;M end.
          end.
        case. mMATCH do.
          for_mi. M do.
            ns=. ns,. mcnemss alpha;s;beta;p0;oi;Phi;mi
            if. doPlot do. nsp=. nsp,. mcnemss alpha;s;beta;p0;px;Phi;mi end.
          end.
        case. mCORR do.
          for_ci. Phi do.
            ns=. ns,.mcnemss alpha;s;beta;p0;oi;ci;M
            if. doPlot do. nsp=. nsp,.mcnemss alpha;s;beta;p0;px;ci;M end.
          end.
      end.
      n=. n,bxv }."1 >.ns
      if. doPlot do. py=. |: }."1 nsp end.
      tout 'Alpha(',Sd,'-sided) = ',(":alpha),', Power = ',(":1-beta),LF
      tout 'P(control) = ',(":p0),', Matched controls = ',(":M),', Correlation = ',(":Phi),LF
      dtab=. |: (2,1+#oi)$(<'Odds ratio'),(ft each bxv oi),n
      tout bfmt dtab
      tout LF,LF
  end.
else.
  n=. >.mcnemss alpha;s;beta;p0;or;Phi;M
  tout 'Alpha(',Sd,'-sided) = ',(":alpha),', Power = ',(":1-beta),LF
  tout 'P(control) = ',(":p0),', Odds ratio = ',(":or),', Matched controls = ',(":M),', Correlation = ',(":Phi),LF
  tout 'N = ',(":n),' cases.',LF,LF
end.
close''
view''
if. doPlot do.
  'pow' makeplot (<mvname),(<px),(<py),plabel
end.
)

Invalid=: 3 : 0
1
'a b p0 or'=. v=. (toN P);(toN PL);(toN LL);toN OL
v=. ,>}:v
nval=. ,># each b;p0;or;M;Phi
if. 0<+/nval>1 do.
  if. 1<+/nval>1 do.
    mbError'Multiple value error';'Multiple values allowed in only one of Power, control proportion, odds ratio, matched controls, or correlation.'
    return.
  end.
  if. (inxb nval>1)=RTYPE-1 do.
    mbError'Multiple value error';'Multiple values allowed only where range not enabled.'
    return.
  end.
end.
if. (+./0>/ v) +. +./1</  v do.
  mbError 'Value error';'Values for alpha, power, and control proportion must be between 0 and 1.'
  return.
end.
if. -. isposint M do.
  mbError 'Value error';'The number of matched controls must be a positive integer.'
  wd 'set match select; set match focus'
  return.
end.
if. -. (0<:Phi) *. (Phi<1) do.
  mbError 'Value error';'The case control correlation must be greater than or equal to 0 and less than 1'
  wd 'set corr select; set corr focus'
  return.
end.
if. (0>or) +. (1=or) do.
  mbError 'Value error';'Value for odds ratio must be positive and not equal to 1'
  return.
end.
select. y
  case. PRANGE do.
    'max step'=.(toN PU),toN PS
    if. (2>step) do.
      mbError 'Value error';'Number of steps must be greater than 1.'
      return.
    end.
    if. (0>max)+.1<max do.
      mbError 'Value error';'Min and max values for power must be between 0 and 1.'
      return.
    end.
    if. max<:b do.
      mbError 'Value error';'Min value is larger than or equal to max value for power.'
      return.
    end.
  case. LRANGE do.
    'max step'=.(toN LU),toN LS
    if. (2>step) do.
      mbError 'Value error';'Number of steps must be greater than 1.'
      return.
    end.
    if. (0>max)+.1<max do.
      mbError 'Value error';'Min and max values for control proportion must be between 0 and 1.'
      return.
    end.
    if. max<:p0 do.
      mbError 'Value error';'Min value is larger than or equal to max value for control proportion.'
      return.
    end.
  case. ORRANGE do.
    'max step'=.(toN OU),toN OS
    if. (2>step) do.
      mbError 'Value error';'Number of steps must be greater than 1.'
      return.
    end.
    if. (0>max) +. (1=max) do.
      mbError 'Value error';'Min and max values for odds ratio must be greater than 0 and not equal to 1.'
      return.
    end.
end.
0
)

ssmcn_R_button=: 3 : 0
if. ".R do.
  Renable''
else.
  Rdisable''
end.
)

Renable=: 3 : 0
wd 'set R0 enable 1;set R1 enable 1;set R2 enable 1'
wd 'set Plot enable 1;set bwp enable 1'
select. RTYPE
  case. PRANGE do.
    ssmcn_R0_button''
  case. LRANGE do.
    ssmcn_R1_button''
  case. ORRANGE do.
    ssmcn_R2_button''
end.
RSSM=: 1
)

Rdisable=: 3 : 0
wd 'set R0 enable 0;set R1 enable 0;set R2 enable 0'
wd 'set Plot 0;set Plot enable 0;set bwp enable 0'
wd 'set PLL text Value ;set PUL enable 0;set PU enable 0;set PSL enable 0;set PS enable 0'
wd 'set LLL text Value ;set LUL enable 0;set LU enable 0;set LSL enable 0;set LS enable 0'
wd 'set OLL text Value ;set OUL enable 0;set OU enable 0;set OSL enable 0;set OS enable 0'
RSSM=:0
)

ssmcn_R0_button=: 3 : 0
wd 'set R0 value 1;set R1 value 0;set R2 value 0'
wd 'set PLL text Min ;set PUL enable 1;set PU enable 1;set PSL enable 1;set PS enable 1'
wd 'set LLL text Value ;set LUL enable 0;set LU enable 0;set LSL enable 0;set LS enable 0'
wd 'set OLL text Value ;set OUL enable 0;set OU enable 0;set OSL enable 0;set OS enable 0'
RTYPE=: PRANGE
)

ssmcn_R1_button=: 3 : 0
wd 'set R0 value 0;set R1 value 1;set R2 value 0'
wd 'set PLL text Value ;set PUL enable 0;set PU enable 0;set PSL enable 0;set PS enable 0'
wd 'set LLL text Min ;set LUL enable 1;set LU enable 1;set LSL enable 1;set LS enable 1'
wd 'set OLL text Value ;set OUL enable 0;set OU enable 0;set OSL enable 0;set OS enable 0'
RTYPE=: LRANGE
)

ssmcn_R2_button=: 3 : 0
wd 'set R0 value 0;set R1 value 0;set R2 value 1'
wd 'set PLL text Value ;set PUL enable 0;set PU enable 0;set PSL enable 0;set PS enable 0'
wd 'set LLL text Value ;set LUL enable 0;set LU enable 0;set LSL enable 0;set LS enable 0'
wd 'set OLL text Min ;set OUL enable 1;set OU enable 1;set OSL enable 1;set OS enable 1'
RTYPE=: ORRANGE
)

ssmcn_Plot_button=: 3 : 0
if. ".Plot do.
  PSSM=:1
else.
  PSSM=:0
end.
)

ssmcn_Sided0_button=: 3 : 0
SSSM=:0
)

ssmcn_Sided1_button=: 3 : 0
SSSM=:1
)

ssmcn_dlghlp=: 3 : 0
if. HELP__ do.
   HELP__=: 0
   wd 'psel hlp; pclose; psel mstat; set DHlp 0; psel ssmcn; pactive; set LL focus'
else.
   HELP__=: 1
   open_hlp_ <'ssmcn'
   wd 'psel mstat; set DHlp 1; psel ssmcn; pactive; set LL focus'
end.
)

ssmcn_octrl_fkey=: ssmcn_OK_button
ssmcn_lctrl_fkey=: ssmcn_dlghlp

NB. sswil.ijs
NB. Sample size required for Wilcoxon rank sum test

coclass 'sswil'

(;:'base z') copath 'sswil'

RANGE=:1
PLOT=:1
SIDED2=:1
NBDK=:5
ALPHA=: 0.05
NORM=: 0
POISS=: 1
NBD=: 2
MODEL=: NORM
PRANGE=: 1
LRANGE=: 2
URANGE=: 3
RTYPE=: URANGE
POWER=:0.95
POWERU=: POWERS=: ''
LOWER=: LOWERU=: LOWERS=: ''
UPPER=: UPPERU=: UPPERS=: ''
VLOWER=: VUPPER=: ''

SSWIL=: 0 : 0
pc sswil dialog nosize escclose closeok;
pn "Sample size for Wilcoxon rank sum test";
bin g;
grid cell 0 0;
groupbox "Significance level";
bin v;
bin h;
cc labela static right;cn "alpha ";set labela wh 60 _1;
cc P edit;set P wh 80 _1;
bin z;
bin h;
cc ls1 static staticbox;set ls1 wh 60 _1;
cc Sided0 radiobutton;cn "o&ne-sided";
bin z;
bin h;
cc ls1a static staticbox;set ls1a wh 60 _1;
cc Sided1 radiobutton group;cn "&two-sided";
bin zz;
groupboxend;

grid cell 0 1;
groupbox "Power";
bin v;
bin h;
cc R0 radiobutton;cn "Range";set R0 wh 70 _1;
cc PLL static right;cn "Value ";set PLL wh 100 _1;
cc PL edit;set PL wh 80 _1;
bin z;
bin h;
cc ls2 static staticbox;set ls2 wh 70 _1;
cc PUL static right;cn "Max ";set PUL wh 100 _1;
cc PU edit;set PU wh 80 _1;
bin z;
bin h;
cc ls2a static staticbox;set ls2a wh 70 _1;
cc PSL static right;cn "Num. steps ";set PSL wh 100 _1;
cc PS edit;set PS wh 80 _1;
bin zz;
groupboxend;

grid cell 1 0;
groupbox "Model";
bin v;
cc RM0 radiobutton;cn "&Normal";
cc RM1 radiobutton group;cn "&Poisson";
bin h;
cc RM2 radiobutton group;cn "Neg. &binom.";
cc KL static right;cn "k ";
cc K edit;set K wh 60 _1;
bin szz;
groupboxend;

grid cell 1 1 132;
bin v;
cc R checkbox;cn "Enable &range";
bin h;
cc Plot checkbox;cn "P&lot";
cc bwp checkbox;cn "Black and white";
bin zz;

grid cell 2 0;
groupbox "Lower mean";
bin v;
bin h;
cc R1 radiobutton;cn "Range";set R1 wh 70 _1;
cc LLL static right;cn "Value ";set LLL wh 100 _1;
cc LL edit;set LL wh 80 _1;
bin z;
bin h;
cc ls4 static staticbox;set ls4 wh 70 _1;
cc LUL static right;cn "Max ";set LUL wh 100 _1;
cc LU edit;set LU wh 80 _1;
bin z;
bin h;
cc ls4a static staticbox;set ls4a wh 70 _1;
cc LSL static right;cn "Num. steps ";set LSL wh 100 _1;
cc LS edit;set LS wh 80 _1;
bin z;
bin h;
cc ls4b static staticbox;set ls4b wh 70 _1;
cc LVL static right;cn "Variance ";set LVL wh 100 _1;
cc LV edit;set LV wh 80 _1;
bin zz;
groupboxend;

grid cell 2 1;
groupbox "Upper mean";
bin v;
bin h;
cc R2 radiobutton group;cn "Range";set R2 wh 70 _1;
cc ULL static right;cn "Value ";set ULL wh 100 _1;
cc UL edit;set UL wh 80 _1;
bin z;
bin h;
cc ls5 static staticbox;set ls5 wh 70 _1;
cc UUL static right;cn "Max ";set UUL wh 100 _1;
cc UU edit;set UU wh 80 _1;
bin z;
bin h;
cc ls5a static staticbox;set ls5a wh 70 _1;
cc USL static right;cn "Num. Steps ";set USL wh 100 _1;
cc US edit;set US wh 80 _1;
bin z;
bin h;
cc ls5b static staticbox;set ls5b wh 70 _1;
cc UVL static right;cn "Variance ";set UVL wh 100 _1;
cc UV edit;set UV wh 80 _1;
bin zz;
groupboxend;

grid cell 3 1;
bin hs2;
cc OK button;cn "&OK";
cc Cancel button;cn "&Cancel";
bin z;

bin z;
pcenter;
)

open=: 3 : 0
wd SSWIL
NB. initialize form here
wd 'set P text ',":ALPHA
wd 'set PL text *',":POWER
wd 'set PU text *',":POWERU
wd 'set PS text *',":POWERS
wd 'set LL text *',":LOWER
wd 'set LU text *',":LOWERU
wd 'set LS text *',":LOWERS
wd 'set UL text *',":UPPER
wd 'set UU text *',":UPPERU
wd 'set US text *',":UPPERS
wd 'set LV text *',":VLOWER
wd 'set UV text *',":VUPPER
wd 'set K text *',":NBDK
wd 'set bwp ',":PlotBW__
if. RANGE do.
  wd 'set R value 1'
  Renable''
  select. RTYPE
    case. PRANGE do.
      wd 'set R0 value 1'
      sswil_R0_button''
    case. LRANGE do.
      wd 'set R1 value 1'
      sswil_R1_button''
    case. URANGE do.
      wd 'set R2 value 1'
      sswil_R2_button''
  end.
  if. PLOT do.
    wd 'set Plot value 1'
  else.
    wd 'set Plot value 0'
  end.
else.
  Rdisable''
  wd 'set R value 0'
  wd 'set R0 value 0; set R',(":RTYPE-1),' value 1'
end.
select. MODEL
  case. NORM do.
    wd 'set RM0 value 1'
    sswil_RM0_button''
  case. POISS do.
    wd 'set RM1 value 1'
    sswil_RM1_button''
  case. NBD do.
    wd 'set RM2 value 1'
    sswil_RM2_button''
end.
if. SIDED2 do.
   wd 'set Sided1 value 1'
else.
   wd 'set Sided0 value 1'
end.
wd 'pshow;'
wd 'set LL focus'
if. HELP__ do.
   update_hlp_ <'sswil'
   wd 'psel sswil; set LL focus'
end.
)

close=: 3 : 0
wd 'pclose'
)

sswil_Cancel_button=: sswil_cancel=: close

sswil_R_button=: 3 : 0
if. ".R do.
  Renable''
else.
  Rdisable''
end.
)

sswil_Plot_button=: 3 : 0
if. ".Plot do.
  PLOT=:1
else.
  PLOT=:0
end.
)

sswil_Sided0_button=: 3 : 0
SIDED2=:0
)

sswil_Sided1_button=: 3 : 0
SIDED2=:1
)

Renable=: 3 : 0
wd 'set R0 enable 1;set R1 enable 1;set R2 enable 1'
wd 'set Plot enable 1;set bwp enable  1'
select. RTYPE
  case. PRANGE do.
    sswil_R0_button''
  case. LRANGE do.
    sswil_R1_button''
  case. URANGE do.
    sswil_R2_button''
end.
RANGE=: 1
)

Rdisable=: 3 : 0
wd 'set R0 enable 0;set R1 enable 0;set R2 enable 0'
wd 'set Plot 0;set Plot enable 0;set bwp enable 0'
wd 'set PLL text Value ;set PUL enable 0;set PU enable 0;set PSL enable 0;set PS enable 0'
wd 'set LLL text Value ;set LUL enable 0;set LU enable 0;set LSL enable 0;set LS enable 0'
wd 'set ULL text Value ;set UUL enable 0;set UU enable 0;set USL enable 0;set US enable 0'
RANGE=:0
)

sswil_R0_button=: 3 : 0
wd 'set R0 value 1;set R1 value 0;set R2 value 0;'
wd 'set PLL text Min ;set PUL enable 1;set PU enable 1;set PSL enable 1;set PS enable 1'
wd 'set LLL text Value ;set LUL enable 0;set LU enable 0;set LSL enable 0;set LS enable 0'
wd 'set ULL text Value ;set UUL enable 0;set UU enable 0;set USL enable 0;set US enable 0'
RTYPE=: PRANGE
)

sswil_R1_button=: 3 : 0
wd 'set R0 value 0;set R1 value 1;set R2 value 0;'
wd 'set PLL text Value ;set PUL enable 0;set PU enable 0;set PSL enable 0;set PS enable 0'
wd 'set LLL text Min ;set LUL enable 1;set LU enable 1;set LSL enable 1;set LS enable 1'
wd 'set ULL text Value ;set UUL enable 0;set UU enable 0;set USL enable 0;set US enable 0'
RTYPE=: LRANGE
)

sswil_R2_button=: 3 : 0
wd 'set R0 value 0;set R1 value 0;set R2 value 1;'
wd 'set PLL text Value ;set PUL enable 0;set PU enable 0;set PSL enable 0;set PS enable 0'
wd 'set LLL text Value ;set LUL enable 0;set LU enable 0;set LSL enable 0;set LS enable 0'
wd 'set ULL text Min ;set UUL enable 1;set UU enable 1;set USL enable 1;set US enable 1'
RTYPE=: URANGE
)


sswil_RM0_button=: 3 : 0
wd 'set LV enable 1;set LVL enable 1;set UV enable 1;set UVL enable 1'
wd 'set K enable 0;set KL enable 0'
MODEL=: 0
)

sswil_RM1_button=: 3 : 0
wd 'set LV enable 0;set LVL enable 0;set UV enable 0;set UVL enable 0'
wd 'set K enable 0;set KL enable 0'
MODEL=: 1
)

sswil_RM2_button=: 3 : 0
wd 'set LV enable 0;set LVL enable 0;set UV enable 0;set UVL enable 0'
wd 'set K enable 1;set KL enable 1'
MODEL=: 2
)

sswil_OK_button=: 3 : 0
if. RANGE do.
  RTYPE=: {.(". R0,' ',R1,' ',R2)#1 2 3
end.
mType=. {.(". RM0,' ',RM1,' ',RM2)#0 1 2
if. mType Invalid RANGE*RTYPE do.
  return.
end.
Mod=. ,>mType{'Normal';'Poisson';'Negative binomial'
ALPHA=: toN P
s=. 1+toN Sided1
Sd=.>s{'';'one';'two'
POWER=:toN PL
b=. 1-POWER
LOWER=: toN LL
UPPER=: toN UL
m1=. LOWER
m2=. UPPER
PlotBW__=: ".bwp
if. mType=NBD do. k=. toN K else. k=. '' end.
nval=. ,># each b;m1;m2;k
mvname=. ''
if. +/nval>1 do.
  mvtype=. inxb nval>1
  mvname=. mvtype{b;m1;m2;k
  if. 0=mvtype do. mvname=. ": 1->mvname else. mvname=. ":>mvname end.
else.
  mvname=. ": 1-b
end.
if. mType = NBD do.
  NBDK=: toN K
end.
if. mType = NORM do.
  VLOWER=: toN LV
  VUPPER=: toN UV
end.
tout 'Sample size for Wilcoxon rank sum test.',LF
tout 'alpha=',(":ALPHA),' (',Sd,'-sided)'
doPlot=. ".Plot
if. RANGE do.
  select. RTYPE
    case. PRANGE do.
      select. mType
        case. NORM do.
          v1=. VLOWER
          v2=. VUPPER
          mtab=. 3 3$ 'Group';'Mean';'Var.';'1';(":m1);(":v1);'2';(":m2);":v2
          hdr=. Mod,' data',LF,bfmt mtab
          plabel=. 'Power';'Number per group';'Wilcoxon, alpha=',(":ALPHA),' (',Sd,'-sided)',LF,'Normal data, group 1: ',(":m1),' (',(":v1),'), group 2: ',(":m2),'(',(":v2),')'
          'p t'=. (m2;v2) pgnorm m1;v1
        case. POISS do.
          mtab=. 3 2$ 'Group';'Mean';'1';(":m1);'2';(":m2)
          hdr=. Mod,' data',LF,bfmt mtab
          plabel=. 'Power';'Number per group';'Wilcoxon, alpha=',(":ALPHA),' (',Sd,'-sided)',LF,'Poisson data, group 1: ',(":m1),', group 2: ',(":m2)
          'p t'=. m2 pgpoiss m1
        case. NBD do.
          k=. NBDK
          mtab=. 3 2$ 'Group';'Mean';'1';(":m1);'2';(":m2)
          hdr=. Mod,' data (k=',(":k),')',LF,bfmt mtab
          plabel=. 'Power';'Number per group';'Wilcoxon, alpha=',(":ALPHA),' (',Sd,'-sided)',LF,'Neg. binom. data (k=',(":k),'), group 1: ',(":m1),', group 2: ',(":m2)
          if. 1<#k do.
            'p t'=. |: each k pgnbdmk m2;m1
          else.
            'p t'=. k pgnbd m2;m1
          end.
        end.
      POWERU=: toN PU
      POWERS=: toN PS
      maxb=. 1-POWERU
      stp=. POWERS
      bi=. range b,maxb,-(maxb-b)%stp
      nb=. #bi
      n=.(<'N/group'),bxv >. wilss ALPHA;s;bi;(nb#p);(nb#t)
      dtab=. |:(2,1+#bi)$(<'Power'),(ft each bxv 1-bi),n
      tout LF,hdr
      tout LF,bfmt dtab
      tout LF,LF
      if. doPlot do.
        px=.1-range b,maxb,-(maxb-b)%100
        npx=. #px
        py=. |:wilss ALPHA;s;(1-px);(npx#p);(npx#t)
      end.
    case. LRANGE do.
      LOWERU=: toN LU
      LOWERS=: toN LS
      maxm1=. LOWERU
      stp=. LOWERS
      m1i=. range m1,maxm1,(maxm1-m1)%stp
      select. mType
         case. NORM do.
           v1=. VLOWER
           v2=. VUPPER
           hdr=. 'Normal data, Mean(upper)=',(":m2),', Variance(upper)=',(":v2),LF,'Variance(lower)=',(":v1),LF
           plabel=. 'Lower mean';'Number per group';'Wilcoxon, alpha=',(":ALPHA),' (',Sd,'-sided), power=',(":1-b),LF,'Normal data, Mean(upper)=',(":m2),', Variance(upper)=',(":v2),', Variance(lower)=',(":v1)
           'p t'=. (m2;v2) pgnorm (m1i;v1)
         case. POISS do.
           hdr=. 'Poisson data, Mean(upper)=',(":m2),LF
           plabel=. 'Lower mean';'Number per group';'Wilcoxon, alpha=',(":ALPHA),' (',Sd,'-sided), power=',(":1-b),LF,'Poisson data, Mean(upper)=',(":m2)
           'p t'=. m2 pgpoiss m1i
         case. NBD do.
           k=. NBDK
           hdr=. 'Negative binomial data, Mean(upper)=',(":m2),', k=',(":k),LF
           plabel=. 'Lower mean';'Number per group';'Wilcoxon, alpha=',(":ALPHA),' (',Sd,'-sided), power=',(":1-b),LF,'Negative binomial data, Mean(upper)=',(":m2),', k=',(":k)
           if. 1<#k do.
             'p t'=.  k pgnbdmk m2;m1i
           else.
             'p t'=. k pgnbd m2;m1i
           end.
      end.
      nb=. #b
      n=. (<'N/group'), , each boxcols >. wilss ALPHA;s;b;(nb#p);(nb#t)
      dtab=. |:(2,1+#m1i)$(<'Lower Mean'),(ft each bxv m1i),n
      tout '; Power=',(":1-b),LF
      tout hdr
      tout bfmt dtab
      tout LF,LF
      if. doPlot do.
        px=. range m1,maxm1,(maxm1-m1)%100
        select. mType
          case. NORM do.
            'p t'=. (m2;v2) pgnorm (px;v1)
          case. POISS do.
            'p t'=. m2 pgpoiss px
          case. NBD do.
            if. 1<#k do.
              'p t'=. k pgnbdmk m2;px
            else.
              'p t'=. k pgnbd m2;px
            end.
        end.
        py=. wilss ALPHA;s;b;(nb#p);(nb#t)
      end.
    case. URANGE do.
      UPPERU=: toN UU
      UPPERS=: toN US
      maxm2=. UPPERU
      stp=. UPPERS
      m2i=. range m2,maxm2,(maxm2-m2)%stp
      select. mType
         case. NORM do.
           v1=. VLOWER
           v2=. VUPPER
           hdr=. 'Normal data, Mean(lower)=',(":m1),', Variance(lower)=',(":v1),LF,'Variance(upper)=',(":v2),LF
           plabel=. 'Upper mean';'Number per group';'Wilcoxon, alpha=',(":ALPHA),' (',Sd,'-sided), power=',(":1-b),LF,'Normal data, Mean(lower)=',(":m1),', Variance(lower)=',(":v1),', Variance(upper)=',(":v2)
           'p t'=.  (m2i;v2) pgnorm (m1;v1)
         case. POISS do.
           hdr=. 'Poisson data, Mean(lower)=',(":m1),LF
           plabel=. 'Upper mean';'Number per group';'Wilcoxon, alpha=',(":ALPHA),' (',Sd,'-sided), power=',(":1-b),LF,'Poisson data, Mean(lower)=',(":m1)
           'p t'=. m2i pgpoiss m1
         case. NBD do.
           k=. NBDK
           hdr=. 'Negative binomial data, Mean(lower)=',(":m1),', k=',(":k),LF
           plabel=. 'Upper mean';'Number per group';'Wilcoxon, alpha=',(":ALPHA),' (',Sd,'-sided), power=',(":1-b),LF,'Negative binomial data, Mean(lower)=',(":m1),', k=',(":k)
           if. 1<#k do.
             'p t'=.   k pgnbdmk m2i;m1
           else.
             'p t'=. k pgnbd m2i;m1
           end.
      end.
      nb=. #b
      if. (1<#m1) do.
        p=. |:p
        t=. |:t
      end.
      n=. (<'N/group'), , each boxcols >. wilss ALPHA;s;b;(nb#p);(nb#t)
      dtab=. |:(2,1+#m2i)$(<'Upper Mean'),(ft each bxv m2i),n
      tout '; Power=',(":1-b),LF
      tout hdr
      tout bfmt dtab
      tout LF,LF
      if. doPlot do.
        px=. range m2,maxm2,(maxm2-m2)%100
        select. mType
          case. NORM do.
            'p t'=. (px;v2) pgnorm (m1;v1)
          case. POISS do.
            'p t'=. px pgpoiss m1
          case. NBD do.
            if. 1<#k do.
              'p t'=.  |: each k pgnbdmk px;m1
            else.
              'p t'=. k pgnbd px;m1
            end.
        end.
        py=. wilss ALPHA;s;b;(nb#p);(nb#t)
        if. (1<#m1) +. (1<#k) do. py=. |: py end.
      end.
  end.
else.
  select. mType
    case. NORM do.
      v1=. VLOWER
      v2=. VUPPER
      mtab=. 3 3$ 'Group';'Mean';'Var.';'1';(":m1);(":v1);'2';(":m2);":v2
      hdr=. Mod,' data',LF,bfmt mtab
      'p t'=. (m1;v1) pgnorm m2;v2
    case. POISS do.
      mtab=. 3 2$ 'Group';'Mean';'1';(":m1);'2';(":m2)
      hdr=. Mod,' data',LF,bfmt mtab
      'p t'=. m2 pgpoiss m1
    case. NBD do.
      k=. NBDK
      mtab=. 3 2$ 'Group';'Mean';'1';(":m1);'2';(":m2)
      hdr=. Mod,' data (k=',(":k),')',LF,bfmt mtab
      'p t'=. k pgnbd m2;m1
  end.
  nb=. #b
  n=. ,>.wilss ALPHA;s;b;(nb#p);(nb#t)
  tout '; Power=',(":1-b),LF
  tout hdr,LF
  tout 'n = ',(":n),' per group.',LF,LF
end.
close''
view''
if. doPlot do.
  'pow' makeplot (<mvname),(<px),(<py),plabel
end.
)


Invalid=: 3 : 0
:
1
'm1 m2 a b'=. (toN LL);(toN UL); (toN P); (toN PL)
v=. a,b
if. x=NBD do.
  k=. toN K
  nval=. (#b),(#m1),(#m2),#k
else.
  nval=. (#b),(#m1),#m2
end.
if. 0<+/nval>1 do.
  if. 1<+/nval>1 do.
    msg=. 'Multiple values allowed in only one of Power, lower mean, upper mean.'
    if. x=NBD do. msg=. (}:msg),', k.' end. 
    mbError'Multiple value error';msg
    return.
  end.
  if. RANGE do.
    if. (inxb nval>1)=RTYPE-1 do.
      mbError'Multiple value error';'Multiple values allowed only where range not enabled.'
      return.
    end.
  end.
end.
if. (+./0>/v) +. +./1</v do.
  mbError 'Value error';'Values for alpha and power must be between 0 and 1.'
  wd 'set P focus'
  return.
end.
if. __ e. m1,m2 do.
  mbError 'Value error';'Lower and Upper means must be numeric values.'
  wd 'set LL focus'
  return.
end.
if. m1>:m2 do.
  mbError 'Value error';'Upper mean must be larger than lower mean.'
  wd 'set UL focus'
  return.
end.
select. y
  case. 0 do.
    select. x
      case. NORM do.
        if. -. (ispos toN LV) *. ispos toN UV do.
          mbError 'Value error';'Variances must be positive real values.'
          wd 'set LV focus'
          return.
        end.
      case. NBD do.
        if. -. ispos toN K do.
          mbError 'Value error';'K must be a numeric value.'
          wd 'set K focus'
          return.
        end.
    end.
  case. PRANGE do.
    bm=. toN PU
    if. (b>bm) +. 1<bm do.
      mbError 'Value error';'Max power must be between min power and 1.'
      wd 'set PU focus'
      return.
    end.
    if. -. isposint toN PS do.
      mbError 'Value error';'Number of steps must be a positive integer.'
      wd 'set PS focus'
      return.
    end.
    select. x
      case. NORM do.
        if. -. (ispos toN LV) *. ispos toN UV do.
          mbError 'Value error';'Variances must be positive real values.'
          wd 'set LV focus'
          return.
        end.
      case. NBD do.
        if. -. ispos toN K do.
          mbError 'Value error';'K must be a numeric value.'
          wd 'set K focus'
          return.
        end.
    end.
  case. LRANGE do.
    if. (m1>:toN LU) +. m2<:toN LU do.
      mbError 'Value error';'Max mean must be larger than min of lower mean and smaller than upper mean.'
      wd 'set LU focus'
      return.
    end.
    if. -. isposint toN LS do.
      mbError 'Value error';'Number of steps must be a positive integer.'
      wd 'set LS focus'
      return.
    end.
    select. x
      case. NORM do.
        if. -. (ispos toN LV) *. ispos toN UV do.
          mbError 'Value error';'Variances must be positive real values.'
          wd 'set LV focus'
          return.
        end.
      case. NBD do.
        if. -. ispos toN K do.
          mbError 'Value error';'K must be a numeric value.'
          wd 'set K focus'
          return.
        end.
    end.
  case. URANGE do.
    maxm2=. toN UU
    if. m2>:maxm2 do.
      mbError 'Value error';'Max must be larger than min value.'
      wd 'set UU focus'
      return.
    end.
    if. -. isposint toN US do.
      mbError 'Value error';'Number of steps must be a positive integer.'
      wd 'set US focus'
      return.
    end.
    select. x
      case. NORM do.
        if. -. (ispos toN LV) *. ispos toN UV do.
          mbError 'Value error';'Variances must be positive real values.'
          wd 'set LV focus'
          return.
        end.
      case. NBD do.
        if. -. ispos toN K do.
          mbError 'Value error';'K must be a numeric value.'
          wd 'set K focus'
          return.
        end.
    end.
end.
0
)

sswil_dlghlp=: 3 : 0
if. HELP__ do.
   HELP__=: 0
   wd 'psel hlp; pclose; psel mstat; set DHlp 0; psel sswil; pactive; set LL focus'
else.
   HELP__=: 1
   open_hlp_ <'sswil'
   wd 'psel mstat; set DHlp 1; psel sswil; pactive; set LL focus'
end.
)

sswil_octrl_fkey=: sswil_OK_button
sswil_lctrl_fkey=: sswil_dlghlp

NB. toord.ijs
NB. Convert table with ordered columns to ordinal variables.

coclass 'toord'

(;:'base z') copath 'toord'

ORD=: 0 : 0
pc ord dialog escclose closeok;pn "Convert to ordinal values";
bin v;
cc label static;cn "Table ";
cc tn edit readonly;set tn stylesheet background-color:#eeeeee;
cc tdata editm readonly;set tdata minwh 240 160;set tdata wrap 0;
groupbox "Column order";
bin v;
cc dir0 radiobutton;cn "&Increasing";
cc dir1 radiobutton group;cn "&Decreasing";
bin z;
groupboxend;
bin hs2;
cc ok button;cn "&OK";
cc cancel button;cn "&Cancel";
bin zz;
pcenter;
)

open=: 3 : 0
wd ORD
Tname=: >OSvar__
Table=: ".loct Tname
wd 'set tn text ',Tname
wd 'set tdata text *',bfmt Table
wd 'set tdata font ',Vfont__
wd 'set dir0 value 1'
wd 'set tdata stylesheet *QPlainTextEdit {background-color:#eeeeee;',(font2css Vfont__),'}'
wd 'pshow;'
wd 'set ok focus'
if. HELP__ do.
   update_hlp_ <'ord'
   wd 'psel ord; pactive; set ok focus'
end.
)

close=: 3 : 0
wd 'pclose'
)

ord_ok_button=: 3 : 0
ordval=. i. _1+{: $Table
if. (". dir1) do.
  ordval=.|.ordval
end.
dat=.>}.}."1 Table
NB.vn=. (,&('_',Tname)) each }.{."1 Table
vn=. ((Tname,'_')&,) each }.{."1 Table
for_i. i.#vn do.
  while. e=.'v' invalidVn >i{vn do.
    n=.e open_chgvn_ >i{vn
    vnames=.(<n) i}vn
  end.
  ".(>i{vn),'_v_=:',":,(i{dat)#ordval
end.
close''
Ddirty__=: 1
wd 'psel mstat'
wd 'set sbar setlabel nvar "',(":numvar''),' variables defined"'
)

ord_cancel_button=: ord_cancel=: ord_close=: close

ord_dlghlp=: 3 : 0
if. HELP__ do.
   HELP__=: 0
   wd 'psel hlp; pclose; psel mstat; set DHlp 0; psel ord; pactive; set tdata focus'
else.
   HELP__=: 1
   open_hlp_ <'ord'
   wd 'psel mstat; set DHlp 1; psel ord; pactive; set tdata focus'
end.
)

ord_octrl_fkey=: ord_ok_button
ord_lctrl_fkey=: ord_dlghlp

NB. transf.ijs 

coclass 'transf'

(;:'base z') copath 'transf'

TRANSF=: 0 : 0
pc transf dialog nosize escclose closeok;
pn "Transform variable";
bin g;
grid cell 0 0;
bin v;
cc labels static;cn "Sample to be transformed";
cc l listbox;set l wh 200 80;
bin z;

grid cell 1 0;
bin v;
cc labelc static;cn "Current data";
cc current editm readonly;set current wh 200 80;
bin z;

grid cell 0 1 2 1 4;
bin v;
cc rblab static;cn "Transformation";
cc rb0 radiobutton;cn "&Add";
cc rb1 radiobutton group;cn "&Multiply";
cc rb2 radiobutton group;cn "&Power";
cc rb3 radiobutton group;cn "&Inverse";
cc rb4 radiobutton group;cn "Log(&e)";
cc rb5 radiobutton group;cn "&Log(10)";
cc rb6 radiobutton group;cn "&J";
bin z;

grid cell 2 0;
bin v;
cc labelt static;cn "Transformed data";
cc new editm readonly;set new wh 200 80;
bin z;

grid cell 2 1;
bin v;
cc labelo static;cn "Operand";
cc val edit;
cc labeln static;cn "New variable name";
cc newname edit;
bin sz;

grid cell 3 0 4;
bin h;
cc show button;cn "&Show";
cc apply button;cn "&Apply";
bin z;

grid cell 3 1;
bin hs;
cc ok button;cn "&Close";
bin z;

bin z;
pcenter;
)

open=: 3 : 0
wd TRANSF
VarN=: nl_v_''
if. 0=#VarN do.
  return.
end.
wd 'set l items *',vfm >VarN
wd 'set l select 0'
wd 'set rb0 value 1'
wd 'set current stylesheet *QPlainTextEdit {background-color:#eeeeee;',(font2css Vfont),'}'
wd 'set new stylesheet *QPlainTextEdit {background-color:#eeeeee;',(font2css Vfont),'}'
fn=:+
TFNewVal=:''
wd 'pshow;'
wd 'set l focus'
if. HELP__ do.
   update_hlp_ <'transf'
   wd 'psel transf; pactive; set l focus'
end.
)

close=: 3 : 0
wd 'pclose'
)

transf_cancel=: close

transf_apply_button=: 3 : 0
res=. transf_show_button''
if. -.res do.
  return.
end.
Vn=. deb newname
if. ($Vn)=0 do.
  mbError 'No varible name specified';'You need to give your transformed variable a new name.'
  wd 'set newname focus'
  res=. 0
  return.
end.
if. e=.'v' invalidVn Vn do.
  if. e ~: VNDUP__ do.
    vnError e
    wd 'set newname focus; set newname select'
    res=. 0
    return.
  end.
  r=. mbQuery 'Duplicate variable name';'Variable ',Vn,' already exists. Replace this variable?'
  if. 'N' = {.r do.
    wd 'set newname focus; set newname select'
    res=. 0
    return.
  end.
end.
". Vn,'_v_=: ', ":TFNewVal
wd'set newname text *'
TFNewVal=:''
res=. 1
)

transf_ok_button=: 3 : 0
vn=. newname
if. (0<$vn) do.
  if. -. transf_apply_button'' do. return. end.
end.
close''
wd 'psel mstat'
wd 'set sbar setlabel nvar  *',(":numvar''),' variables defined'
)

transf_show_button=: 3 : 0
transf_l_button''
TFNewVal=:''
if. (".rb6) do.
  if. 0=# deb val do. 
    mbError 'J expression';'You must enter a valid J expression.'
    wd 'set val focus'
    res=. 0
    return.
  end.
  ".'fn=:',val
end.
if. (".rb0) +. (".rb1) +. (".rb2) do.
  tfv=.__ ". val
  if. (__ e. tfv) +. 0=#tfv do.
    mbError 'Operand';'Operand must be numeric.'
    wd 'set val focus;set val select'
    res=. 0
    return.
  end.
  newval=. (". locv l) fn tfv
else.
  newval=. fn ". locv l
end.
wd 'set new text *',":newval
if. (_ e. newval) +. (__ e. newval) do.
  mbError 'Undefined values';'Some of the results of this transformation are undefined.'
  res=. 0
  return.
end.
TFNewVal=:newval
res=. 1
)

transf_val_button=: transf_show_button

transf_rb0_button=: 3 : 0
fn=:+
wd 'set val enable  1'
wd 'set val focus'
)

transf_rb1_button=: 3 : 0
fn=:*
wd 'set val enable  1'
wd 'set val focus'
)

transf_rb2_button=: 3 : 0
fn=:^
wd 'set val enable  1'
wd 'set val focus'
)

transf_rb3_button=: 3 : 0
fn=:%
wd 'set val text '
wd 'set val enable 0'
)

transf_rb4_button=: 3 : 0
fn=:^.
wd 'set val text '
wd 'set val enable 0'
)

transf_rb5_button=: 3 : 0
fn=: 10&^.
wd 'set val text '
wd 'set val enable 0'
)

transf_rb6_button=: 3 : 0
wd 'set val enable  1'
wd 'set val focus'
)

transf_l_select=: 3 : 0
wd 'set current text *',":".locv l
)

transf_l_button=: transf_l_select

transf_dlghlp=: 3 : 0
if. HELP__ do.
   HELP__=: 0
   wd 'psel hlp; pclose; psel mstat; set DHlp 0; psel transf; pactive; set l focus'
else.
   HELP__=: 1
   open_hlp_ <'transf'
   wd 'psel mstat; set DHlp 1; psel transf; pactive; set l focus'
end.
)

transf_octrl_fkey=: transf_ok_button
transf_sctrl_fkey=: transf_show_button
transf_pctrl_fkey=: transf_apply_button
transf_lctrl_fkey=: transf_dlghlp


NB. tripsmp.ijs
NB. form for triple sample selection

coclass'tripsmp'

(;:'base z') copath 'tripsmp'


TRIPSMP=: 0 : 0
pc tripsmp dialog nosize escclose closeok;
bin g;
grid cell 0 0;
bin v;
cc v1lab static center;cn "X values";
cc v1 listbox;set v1 wh 160 120;
bin z;

grid cell 0 1;
bin v;
cc v2lab static center;cn "Y values";
cc v2 listbox;set v2 wh 160 120;
bin z;

grid cell 0 2;
bin v;
cc v3lab static center;cn "S.D. values";
cc v3 listbox;set v3 wh 160 120;
bin z;

grid cell 1 0 1 3 4;
bin hs;
cc add button;cn "&Add";
cc reset button;cn "&Reset";
bin sz;

grid cell 2 0 1 3 4;
bin v;
cc tlab static;cn "X, Y, S.D. groups";
cc trips editm readonly;set trips wh 340 120;set trips wrap 0;
bin z;

grid cell 3 0 1 3 4;
bin h;
cc xlog checkbox;cn "Log X";
cc ylog checkbox;cn "Log Y";
cc bwp checkbox;cn "Black and white";
bin z;

grid cell 4 2;
bin hs;
cc done button;cn "&Done";
cc cancel button;cn "&Cancel";
bin z;

pcenter;
)

open=: 3 : 0
LOGX__=: LOGY__=: 0
VarN=: nl_v_''
TRIPLIST=: ''
wd TRIPSMP
wd 'pn "',y,'"'
wd 'set v1 items ',vfm >VarN
wd 'set v2 items ',vfm >VarN
wd 'set v3 items ',vfm >VarN
wd 'set v1 select 0;set v2 select 1;set v3 select 2'
wd 'set xlog value ',":LOGX__
wd 'set ylog value ',":LOGY__
wd 'set bwp value ',":PlotBW__
wd 'set trips stylesheet *QPlainTextEdit {background-color:#eeeeee;}'
wd 'pshow;'
if. HELP__ do.
  update_hlp_ Test__;'tripsmp'
  wd 'psel tripsmp; pactive; set v1 focus'
end.
)

tripsmp_close=: 3 : 0
wd 'pclose'
)

close=: 3 : 0
wd 'pclose'
)

tripsmp_cancel=: tripsamp_cancel_button

tripsmp_cancel_button=: 3 : 0
close''
TPvar__=: ''
)

tripsmp_add_button=: 3 : 0
xv=. v1
yv=. v2
sdv=. v3
if. (0=#xv)+.(0=#yv)+.(0=#sdv) do.
  mbError'Select three variables';'Select a variable from each of the three lists.'
  return.
end.
if. -. 3 = #~. xv;yv;sdv do.
  mbError'Select three variables';'You must select different variables from each list.'
  return.
end.
TRIPLIST=: TRIPLIST,(<xv;yv;sdv)
wd 'set trips text *',vfm (>0{"1 >TRIPLIST),.';',.' ',.(>1{"1 >TRIPLIST),.';',.' ',.(>2{"1 >TRIPLIST)
)

tripsmp_reset_button=: 3 : 0
TRIPLIST=: ''
wd 'set trips text *',TRIPLIST
)

tripsmp_done_button=: 3 : 0
if. 1>#TRIPLIST do.
  mbError'Sample groups';'You must choose at least one set of three variables.'
  return.
end.
exec=. ''
TPvar__=: TRIPLIST
if. -. (#~. 1{"1 >TRIPLIST)=#TRIPLIST do.
  mbError 'Sample groups';'Each Y variable must be unique.'
  TPvar__=: ''
  return.
end.
data=. ". each locv each >TPvar__
for_s. data do.
  nobs=. ,># each s
  if. -. (=/2{.nobs)*.(=/}.nobs) do.
    mbError 'Unequal sample sizes';'Equal numbers of X and Y values are required for each sample pair.'
    return.
  end.
end.
LOGX__=: ".xlog
LOGY__=: ".ylog
PlotBW__=: ".bwp
exec=. Test__,''''''
close''
".exec
)

tripsmp_dlghlp=: 3 : 0
if. HELP__ do.
   HELP__=: 0
   wd 'psel hlp; pclose; psel mstat; set DHlp 0; psel tripsmp; pactive; set v1 focus'
else.
   HELP__=: 1
   open_hlp_ Test__;'tripsmp'
   wd 'psel mstat; set DHlp 1; psel tripsmp; pactive; set v1 focus'
end.
)

tripsmp_octrl_fkey=: tripsmp_done_button
tripsmp_lctrl_fkey=: tripsmp_dlghlp
tripsmp_dctrl_fkey=: tripsmp_add_button
tripsmp_rctrl_fkey=: tripsmp_reset_button

NB. twosamp.ijs

coclass 'twosmp'

(;:'base z') copath 'twosmp'

TWOSMP=: 0 : 0
pc twosmp dialog nosize escclose closeok;
bin g;
grid cell 0 0;
bin v;
cc label1 static center;cn "Sample 1";
cc l1 listbox;set l1 wh 180 140;
bin z;

grid cell 0 1;
bin v;
cc label2 static center;cn "Sample 2";
cc l2 listbox;set l2 wh 180 140;
bin z;

grid cell 2 1;
bin hs;
cc ok button;cn "&OK";
cc cancel button;cn "&Cancel";
bin z;
)

GFITCONTROL=: 0 : 0
grid cell 1 0 128;
bin h;
cc labelp static;cn "Estim. param. ";
cc gfnpar edit;set gfnpar wh 60 _1;
bin sz;

grid cell 1 1;
groupbox "Expected";
bin v;
cc gfrb0 radiobutton;cn "&Values";
cc gfrb1 radiobutton group;cn "&Frequencies";
bin z;
groupboxend;

set label1 text Observed values;
set label2 text Expected values;
bin z;
pcenter;
)

SIDEDCONTROL=: 0 : 0
grid cell 1 0 1 2 4;
bin v;
cc rb0 radiobutton;cn "O&ne-sided";
cc rb1 radiobutton group;cn "&Two-sided";
bin zz;
pas 6 6;pcenter;ptop;
)

CORRCONTROL=: 0 : 0
grid cell 1 0 4;
bin v;
cc rb0 radiobutton;cn "O&ne-sided";
cc rb1 radiobutton group;cn "&Two-sided";
bin z;
grid cell 1 1;
bin h;
cc conc checkbox;cn "Show concordance";
bin zz;
pas 6 6;pcenter;ptop;
)

open=: 3 : 0
VarN=: nl_v_''
wd TWOSMP
wd 'pn *','Choose two samples for ',y
wd 'set l1 items *',vfm >VarN
wd 'set l2 items *',vfm >VarN
wd 'set l1 select 0'
wd 'set l2 select 1'
select. Tlast__
  case. cGFIT do.
    wd GFITCONTROL
    wd 'set gfrb0 value 1'
    wd 'set gfnpar text 0'
  case. cKEN;cSPEAR do.
    wd CORRCONTROL
    wd 'set rb',(":Sided__-1),' value 1'
    wd 'set conc value ',":Concord__    
  case. do.
    wd SIDEDCONTROL
    wd 'set rb',(":Sided__-1),' value 1'
end.
wd 'pshow'
if. HELP__ do.
   update_hlp_ Test__;'twosmp'
   wd 'psel twosmp; pactive; set l1 focus'
end.
)

close=: 3 : 0
wd 'pclose'
)


twosmp_cancel_button=: 3 : 0
close''
TSvar__=:''
)

twosmp_cancel=: twosmp_cancel_button

twosmp_ok_button=: 3 : 0
exec=.''
if. l1 -: l2 do.
  mbError'Same samples';'Two different variables must be chosen in the list boxes.'
  return.
end.
select. Tlast__
  case. cSRANK do.
    TSvar__=:l1;l2
    Sided__=:1+". rb1
    'x y'=. ". each locv each TSvar__
    Ny=.#y
    Nx=.#x
    if. Ny ~: Nx do.
      mbError 'Unequal group sizes';'The Wilcoxon signed rank test only applies to paired observations.'
      return.
    end.
    exec=. Test__,''''''
  case. cGFIT do.
    freq=. ".gfrb1
    npar=. __ ". gfnpar
    if. (0=#npar) +. -. isnonnegint npar do.
      mbError 'Invalid parameter';'Estimated parameters must be an integer greater than or equal to 0'
      wd 'setfocus gfnpar; setselect gfnpar 0 ',(":#gfnpar)
      return.
    end.
    TSvar__=:l1;l2
    'obs exp'=. ". each locv each TSvar__
    if.  (#obs)~:(#exp) do.
      mbError 'Unequal sample size';'The numbers of observed and expected values must be the same.'
      return.
    end.
    no=. +/obs
    if. freq do.
      exp=. no*exp
    end.
    if. -. approx no,+/exp do.
      if. freq do.
        mbError 'Unequal numbers';'Frequencies must sum to 1.0'
        return.
      else.
        mbError 'Unequal numbers';'Totals for observed and expected must be equal.'
        return.
      end.
    end.
    exec=. Test__,' freq;npar'
  case. cSPEAR;cKEN do.
    TSvar__=:l1;l2
    Sided__=:1+". rb1
    Concord__=: ".conc
    'x y'=. ". each locv each TSvar__
    if. (#x) ~: (#y) do.
       mbError 'Unequal sample sizes';'Both samples must have the same number of observations for this correlation test.'
       return.
    end.
    exec=. Test__,''''''
  case. do.
   TSvar__=:l1;l2
   Sided__=:1+". rb1
   exec=. Test__,''''''
end.
close''
". exec
DBEXEC__=: exec
)

twosmp_dlghlp=: 3 : 0
if. HELP__ do.
   HELP__=: 0
   wd 'psel hlp; pclose; psel mstat; set DHlp 0; psel twosmp; pactive; set l1 focus'
else.
   HELP__=: 1
   open_hlp_ Test__;'twosmp'
   wd 'psel mstat; set DHlp 1; psel twosmp; pactive; set l1 focus'
end.
)

twosmp_octrl_fkey=: twosmp_ok_button
twosmp_lctrl_fkey=: twosmp_dlghlp

NB. wch.ijs
NB. Help on choosing statistical test

NB. v 4.0 made non-modal so can leave open

coclass 'wch'

('base';'z') copath <'wch'

T0=:'What type of data?';'Measurement';'Categorical'
T1=:'How are samples related';'Independent';'Paired'
T2=:'What hypothesis?';'Difference in location';'Independence'
T3=:'How many samples';'Two samples';'Multiple samples'
T4=:'Which alternative?';'General';'Ordered'
T5=:'What shape table?';'1 x c table';'2 x 2 table';'r x c table'
T6=:T1
T7=:'How are categories related?';'Arbitrary categories';'Column (or row) categories follow a natural order';'Column and row categories follow a natural order'
T8=:'How many unordered rows (or columns)?';'Two unordered categories (dichotomous response)';'Three or more unordered categories'
T9=:T4
T10=:'How many rows?';'Two rows';'More than two rows'

Node=: 0
adv=:''

WCH=: 0 : 0
pc wch dialog nosize escclose closeok;
bin v;
cc label1 static center;
cc qu combolist;
cc ed editm readonly;set ed wh 320 160;
bin hs2;
cc ok button;cn "&Done";
cc reset button;cn "&Restart";
bin zz;
pcenter;
)

open=: 3 : 0
wd WCH
wd'set ed stylesheet *QPlainTextEdit {background-color:#eeeeee;}'
wd 'pn *Help on tests'
wd 'set label1 text Please answer the question by',LF,' choosing from the list below.'
adv=:''
wd 'set qu items *',vfm >T0
wd 'set qu select 0'
wd 'set ed text',adv
Node=:0
wd 'pshow;'
)

close=: 3 : 0
wd'pclose'
)

wch_ok_button=: wch_cancel=: wch_close=: close

wch_qu_select=: 3 : 0
r=. < qu
select. r
  case. (<'Measurement') do.
    r setnode 1
  case. (<'Categorical') do.
    r setnode 5
  case. (<'Independent') do.
    if. Node=1 do. r setnode 3 end.
    if. Node=6 do. r setnode 9 end.    
  case. (<'Paired') do.
    if. Node=1 do. r setnode 2 end.
    if. Node=6 do. r endnode 'Use McNemar''s test.' end.
  case. (<'Two samples') do.
    if. Node=3 do.
      r endnode 'Use the Wilcoxon rank sum test.'
    end.
  case. (<'Multiple samples') do.
    if. Node=3 do.
      r setnode 4
    end.
  case. (<'General') do.
    if. Node=4 do.
      r endnode 'Use the Kruskal-Wallis test.'
    end.
    if. Node=9 do.
      r endnode 'Use  Fisher''s or Barnard''s exact test or the Chi-square test.'
    end.
  case. (<'Ordered') do.
    if. Node=4 do.
      r endnode 'Use the Jonckheere-Terpstra test.'
    end.
    if. Node=9 do.
      r endnode 'Use Fisher''s or Barnard''s exact test'
    end.
  case. (<'Difference in location') do.
    r endnode 'Use the Wilcoxon signed rank test.'
  case. (<'Independence') do.
    r endnode 'Use either the Kendall or',LF,' Spearman rank correlation tests.'
  case. (<'1 x c table') do.
    r endnode 'Use Goodness of Fit test.'
  case. (<'2 x 2 table') do.
    r setnode 6
  case. (<'r x c table') do.
    r setnode 7
  case. (<'Column (or row) categories follow a natural order') do.
    r setnode 8
  case. (<'Column and row categories follow a natural order') do.
    a=.'Convert table to ordinal variables and',LF
    a=.a,'use the Jonckheere-Terpstra test.'
    r endnode a
  case. (<'Two unordered categories (dichotomous response)') do.
    r endnode 'Use the Cochran-Armitage test.'
  case. ('Three or more unordered categories') do.
    r setnode 10
  case. (<'Two rows') do.
    a=.'Convert table to ordinal variables and',LF,'use the Wilcoxon rank sum test.'
    r endnode a
  case. (<'More than two rows') do.
    a=.'Convert table to ordinal variables and',LF,'use the Kruskal-Wallis test.'
    r endnode a
  case. (<'Arbitrary categories') do.
    r endnode 'Use the Chi-square test.'  
end.
)

setnode=: 4 : 0
NB. x is text for adv
NB. y is next node
wd 'set qu items *',vfm > ".'T',":y
adv=: adv,(>x),LF
wd 'set ed text *', adv
wd 'setselect qu 0'
Node=:y
)

endnode=: 4 : 0
adv=:adv,(>x),LF,LF,y
wd 'set ed text *', adv
Node=:_1
wd 'setenable qu 0'
)

wch_reset_button=: 3 : 0
adv=:''
wd 'set qu items *',vfm >T0
wd 'setselect qu 0'
wd 'set ed text *',adv
Node=:0
wd 'setenable qu 1'
)

wch_octrl_fkey=: wch_ok_button
wch_rctrl_fkey=: wch_reset_button
NB. zlibmp.ijs
NB. functions to provide access to the zlib dll
NB. initial implementation-uses mmapped files
NB. revised to allow use on all platforms per Oleg Kobchenko zfiles
NB. change to c calling convention on win32 for j7 compatibility
NB. Updated for j807
NB. Copyright (c) 2011-2019 Norman Drinkwater
NB. Provisions of Artistic License 2.0 apply

require 'jmf'

coclass'zlib'

PPC=: 0  NB. flag for PPC architecture, reset at runtime

NB. platform setup
libp=. #.IFWIN,'Darwin'-:UNAME
libf=. libp{:: 'libz'; 'libz'; 'zlib1';''
libe=. libp{:: 'so.1'     ; 'dylib'  ; 'dll'     ;''
LIB=: <dquote libf,'.',libe


cddef=: 4 : 0
y=. dtb (y i. ':'){.y
if. 0=#y do. '' return. end.
n=. y i. ' '
f=. n {. y
d=. (_2 * (<_2{.f) e. '_1';'_2';'_3') }. f
if. IFUNIX do.
  p=. n }. y
else.
  p=. (n+1) }. y
  if. '>' = {.p do.
    p=. ' >+', }.p
  else.
    p=. ' +', p
  end.
end.
(f)=: (x,' ',d,p)&(15!:0)
''
)

LIB cddef each <;._2 [ 0 : 0
gzopen > x *c *c
gzdopen > x i *c
gzread > i x & i
gzwrite > i x & i
gzclose > i x
adler32 > x x & i
)

NB. gzread * to &
NB. Functions

gzip=: 3 : 0
NB. Compresses file y to (y).gz and deletes y
NB. returns number of uncompressed bytes written
fn=. y
if. -. fexist fn do. return. end.  NB. return if file not found
if. (<'.gz')=<_3{.fn do. return. end. NB. return if file extension is .gz
fnout=. fn,'.gz'
t=. fread fn
insz=. #t
gzfaddr=. gzopen fnout;'wb'
len=. gzwrite gzfaddr;t;insz
ret=. gzclose <gzfaddr
if. (0<len) *. 0=ret do. ferase fn end. NB. only erase original if file written and no error
len
)

gunzip=: 3 : 0
NB. Uncompresses file y to give parent file (sans .gz) and deletes .gz file
NB. returns number of uncompressed bytes written
fn=. y
if. -. fexist fn do. return. end.  NB. return if file not found
if. -.(<'.gz')=<_3{.fn do. return. end. NB. return if file extension is not .gz
fnout=. '.gz' taketo fn
JCHAR map_jmf_ 'infil';fn
outsz=. {. uint4 _4{.infil__
unmap_jmf_'infil'
gzfaddr=. gzopen fn;'rb'
t=. outsz$' '
gzread gzfaddr;t;outsz
gzclose <gzfaddr
len=. t fwrite fnout
if. 0<len do. ferase fn end. NB. erase if new file written
len
)

zread=: 3 : 0
NB. reads compressed (or uncompressed) file y
NB. returns file contents (x=0) or x bytes from file
NB. mapping is read-only
0 zread y
:
fn=. y
if. -.fexist fn do.
  empty''
  return.
end.
JCHAR map_jmf_ 'infil';fn;'';1
magic=. 2{.infil__
if. (<magic)=<31 139{a. do.
  outsz=. {. uint4 _4{.infil__
else.    NB. file is not compressed
  if. 0<x do. outdat=. x{.,infil__ else. outdat=. ,infil__ end.
  unmap_jmf_'infil'
  outdat
  return.
end.
unmap_jmf_'infil'
gzfaddr=. gzopen fn;'rb'
if. 0<x do. len=. x else. len=. outsz end.
t=. len$' '
gzread gzfaddr;t;len
gzclose <gzfaddr
t
)

zwrite=: 4 : 0
NB. writes byte data x to compressed file y (which should have a .gz extension)
NB. returns number of bytes written
if. -. (2= 3!:0 x) *. 2>$$x  do. return. end.
insz=. #x
gzfaddr=. gzopen y;'wb'
len=. gzwrite gzfaddr;x;insz
ret=. gzclose <gzfaddr
>{.len
)

zadler=: 3 : 0
NB. returns adler32 checksum of y
init=. adler32 0;'';0
r=. x: uint4 2 ic adler32 init;y;(#y)
)

NULL=: {. a.
 
tzread=: 3 : 0
NB. reads possibly gzipped text file y and returns in UTF-8 format
NB. returns NULL if not a text file
NB. J901 kludge clear jmf
unmapall_jmf_''
dat=. zread y
if. (dat -: _1) +. (0=#dat) do. 
  dat=.''
  return.
end.
if. (NULL e. dat) *. -. (255 254 { a.) -: 2 {. dat do.
  dat=. ''
  return.
end.
NB. u16 marker:
if. (255 254 { a.) -: 2 {. dat do.
  dat=. utf8 6 u: 2 }. dat
NB. u8 marker:
elseif. (239 187 191 { a.) -: 3 {. dat do.
  dat=. 3 }. dat
NB. ansi codepage:
elseif. 0 -: 7 u: :: 0: dat do.
  val=. a. i. dat
  msk=. 127 < val
  uni=. 192 128 +"1 [ 0 64 #: msk # val
  val=. val #~ 1 j. msk
  ndx=. I. 127 < val
  dat=. a. {~ uni (ndx +/ 0 1) } val
end.
dat
)

NB. Utility functions
NB. note i86 byte order

uint4=: 3 : 0
r=.(65536 * uint2 2}.y)+uint2 2{.y
)

uint2=: 0&ic

NB. exports to z locale
gzip_z_=: gzip_zlib_
gunzip_z_=: gunzip_zlib_
zread_z_=: zread_zlib_
zwrite_z_=: zwrite_zlib_
zadler_z_=: zadler_zlib_
tzread_z_=: tzread_zlib_
NB. msmain.ijs
NB. main window routine

coclass 'base'

VERSION=: '8.0.1'
VERSIONDATE=: '2024-02-12'
MSTATSITE=:'https://oncology.wisc.edu/mstat/'

NB. base form

MSTATFILE=: 0 : 0
pc mstat escclose;pn "Mstat";
menupop "&File";
menu Fnew "&New";
menu Fsave "Save &output...";
menusep;
menu Dload "&Load data...";
menu Dsave "&Save data..." "Ctrl+S";
menu Dimport "&Import data...";
menu Dexport "&Export data...";
menusep;
menu Fprintpref "Printer setup...";
menu Fprint "&Print" "Ctrl+P";
menusep;
menu Fpref "P&references...";
menusep;
menu Fexit "E&xit" "Ctrl+Q";
menupopz;
menupop "&Edit";
menu Eannot "&Annotate";
menu Eundo "&Undo";
menu Ewrap "&Wrap";
menusep;
menu Espad "&Scratchpad" "Ctrl+R";
menu Eterm "&Terminal" "Ctrl+W";
menupopz;
menupop "&Data";
menu Dnew "&New..." "Ctrl+N";
menu Dedit "&Edit..." "Ctrl+E";
menu Dshow "S&how...";
menusep;
menu Dbyind "&Classify...";
menupop "C&onvert";
menu Dtoord "&Ordered table to variables...";
menu Dtoind "Variable to &indicator...";
menu Dtovar "I&ndicator to variable...";
menupopz;
menu Transf "&Transform...";
menu Rescale "&Rescale...";
menusep;
menu Ddel "&Delete...";
menu Dclear "C&lear";
menupopz;
menupop "&Analysis";
menu Desc "&Descriptive...";
menu Bin "&Bin data...";
menu KapM "&Kaplan-Meier...";
menu Regr "&Regression...";
menu Binci "Binomial &conf. interval...";
menu Bootci "B&ootstrap conf. interval...";
menu Ratio "R&atio...";
menupopz;
menupop "&Plot";
menu LoadPlot "&Load plot...";
menu DotPlot "&Dot plot...";
menupop "&Bar graphs";
menu BarPlot "&Grouped...";
menu BarSDPlot "Grouped with S&D...";
menu SBarPlot "&Stacked...";
menu FBarPlot "&Floating...";
menu ABarPlot "&Area...";
menupopz;
menupop "&XY plots";
menu XYm "&Markers...";
menu XYl "&Lines...";
menu XYlm "&Both marker/line...";
menu XYs "Marker with &SD...";
menu XYb "Bands...";
menupopz;
menupopz;
menupop "&Test";
menu Wil "&Wilcoxon...";
menu Srank "&Signed rank...";
menu Kwal "&Kruskal-Wallis...";
menu Jonckt "&Jonckheere...";
menusep;
menu Mil "M&iller jackknife...";
menu Con "Cono&ver...";
menusep;
menu Gfit "&Goodness of fit...";
menu Fishrt "&Fisher exact...";
menu Barnard "&Barnard exact...";
menu Chsqt "&Chi-square...";
menu Chsqp "Partition &table...";
menu Mcnemt "&McNemar...";
menu Cochran "C&ochran-Armitage...";
menu LogR "&Logrank...";
menusep;
menu Ken "&Kendall...";
menu Spear "&Spearman...";
menu Sen "Sen-&Adichie...";
menusep;
menu Pwise "Pa&irwise test...";
menu Multex "Multiple &experiments...";
menu Mantel "Mantel-&Haenszel...";
menusep;
menu Comp "Combine &P...";
menu Fdr "A&djusted P-values...";
menupopz;
menupop "Desig&n";
menupop "&Distributions";
menu Normd "&Normal...";
menu Chid "&Chi-square...";
menusep;
menu Binom "&Binomial...";
menu Hyperg "&Hypergeometric...";
menu Negbin "Ne&gative binomial...";
menu Poiss "&Poisson...";
menupopz;
menupop "&Sample size";
menu SSwil "&Wilcoxon...";
menu SSfish "&Fisher...";
menu SSmcn "&McNemar...";
menupopz;
menu Bpred "&Bayesian predictive value...";
menupopz;
)

MSTAT2=: 0 : 0
minwh 900 32;cc mtb toolbar;
minwh 900 500;cc Em1 editm readonly flush;
cc sbar statusbar;
set sbar addlabel tlast;
set sbar addlabelp nvar;
)

maintb=: 3 : 0
wd 'set mtb add Fnew "Open new output file" "',TBP,'document.png"'
wd 'set mtb add Fsave "Save output file" "',TBP,'disk.png"'
wd 'set mtb add Fprint "Print output file" "',TBP,'printer.png"'
wd 'set mtb addsep'
wd 'set mtb add Fpref "Edit preferences" "',TBP,'gear.png"'
wd 'set mtb add Eterm "Open terminal" "',TBP,'terminal.png"'
wd 'set mtb addsep'
wd 'set mtb add Eannot "Annotate output file" "',TBP,'document-text-pencil.png"'
wd 'set mtb add Eundo  "Undo annotations" "',TBP,'arrow-circle-225-left.png"'
wd 'set mtb addsep'
wd 'set mtb add Dimport "Import data" "',TBP,'folder-import.png"'
wd 'set mtb add Dexport "Export variables" "',TBP,'folder-export.png"'
wd 'set mtb addsep'
wd 'set mtb add Dload "Load variable definitions" "',TBP,'folder-horizontal-open.png"'
wd 'set mtb add Dsave "Save variable definitions" "',TBP,'folder-red-doc.png"'
wd 'set mtb addsep'
wd 'set mtb add Dnew "Define new variable" "',TBP,'plus.png"'
wd 'set mtb add Dedit "Edit variable definition" "',TBP,'table-pencil.png"'
wd 'set mtb add Dshow "Display variables to output window" "',TBP,'table.png"'
wd 'set mtb addsep'
wd 'set mtb add LoadPlot "Load saved plot" "',TBP,'chart.png"'
wd 'set mtb add Tlast "Execute last test" "',TBP,'lightning.png"'
wd 'set mtb add Sload "Load script..." "',TBP,'wand-hat.png"'
wd 'set mtb addright Hlp "Show help" "',TBP,'question.png"'
wd 'set mtb checkable Eannot'
wd 'set mtb checkable Eterm'
)

MSTATHELP=: 0 : 0
menupop "&Help";
menu Wch "&Which test?";
menu DHlp "&Dialog help" "Ctrl+L";
menu Hlp "&Help on Mstat" "Ctrl+H";
menusep;
menu Update "&Check for updates...";
menu About "&About...";
menupopz;
)

mstat_run=: 3 : 0
IDE=: 1
OS=: (<UNAME) inx 'Win';'Darwin';'Linux'
initdir''
readpref''
PMENU=: getPlugins''
MSTAT=: MSTATFILE,MSTATHELP,PMENU,MSTAT2   
wd MSTAT
maintb''
wd'fontdef ',Ffont__
wd 'set Em1 stylesheet *QPlainTextEdit {background-color:#eeeeee; border: 1px solid gray;',(font2css Vfont),'};'
ICON=: TBP,'mstat.png'
NB. setIcon''
wd 'pas 0 0;'
wd 'set sbar setlabel tlast "";set sbar setlabel nvar "No variables"'
wd 'set mtb enable Eundo 0'
wd 'set Em1 wrap 0'
PPI=: 4{ ". wd'qscreen'
if. 1=OS do. DSCALE=: 1 else. DSCALE=: PPI%96 end.
wd'pmove 0 0 ',(":DSCALE*800 600),';pcenter;'
mstat_Eterm_button''
wd 'pshow'
MSTATPID=: getwinpid''
Out__=:'Mstat ',VERSION,' - ',(timestamp''),LF,LF
wd 'psel mstat'
setadv''
Dpath0=: Dpath
MP=:''
Ddirty=:0
Odirty=:0
Dfn=:''
Ofn=:''
Vrep=:0
Ed=:0
Wrap=:0
Concord=: 1
PartTest=: 0
ZeroOrigin=: 1
Quart=: 0
LOGX=: 0
LOGY=: 0
PlotBW=: 0
BarOrd=: 0
BarOrdDir=: 0
MPLOT_DEF=: '"Arial" 12';1;0;0
MPLOT_CLR=:'WHITE';'BLACK';'RED'
PLOT_NUM=: 0
HELP=: 0
PAD=: 0
Ntile=: 0
BSMean=: 1
BSMedian=: BSVar=: 0
BSInt=: 0.95
BSTrial=: 10000
RSCDiv=: 1
RSCName=: 'Copy'
MSvar=: TSvar=: OSvar=: PSvar=: TPvar=:''
TMPCOUNT=: 0
'SCRW SCRH'=: (2 3){". wd 'qscreen' NB. Screen size
if. AUTOUPDATE do. open_msupdate_'a' end.
view''
if. DBG do. mstat_Eterm_button'' end.
)

mstat_close=: mstat_Fexit_button

mstat_Fnew_button=: 3 : 0
ed_check''
res=. mbQuery 'Clear window';'Do you want to clear the output window?'
if. 'no' -: res do.
  return.
else.
  Out__=:'Mstat ',VERSION,' - ',(timestamp''),LF,LF
  Odirty__=:0
  view''
end.
)

mstat_Fprintpref_button=: 3 : 0
open_printpref_''
)

mstat_Fprint_button=: 3 : 0
ed_check''
wd 'defprint orient ',>ORIENT__{'portrait';'landscape'
wd 'defprint margin ',":MARGIN__
wd 'cmd Em1 print'
mbInfo 'Print';'Mstat output printed.'
)

mstat_Fsave_button=: 3 : 0
ed_check''
Fn=. fsavfn''
if. 0=#Fn do.
   return.
end.
Out__ fwrites Fn
Odirty__=:0
)

mstat_Fexit_button=: 3 : 0
ed_check''
if. Odirty__ do.
  q=. mbQuery 'Save or print output?';'Do you want to quit without',LF,'saving or printing your results?'
  if. ('no' -: q) do.
    return.
  end.
end.
if. -. (<Dpath0)=(<Dpath) do. writepref'' end.
if. Ddirty__ do.
  q=. mbQuery 'Save data file?';'Do you want to quit without',LF,'saving your data?'
  if. ('no' -: q) do.
    return.
  end.
end.
owin=. getwinpid''
cwin=. ,(-.MSTATPID =/ owin) # owin
if. 0 < #cwin do.
  for_w. cwin do.
    wd 'psel ',> w
    wd 'pclose'
  end.
end.
tf=. {."1 fdir Tempdir,'*.*'
NB. erase tmp files
if. 0<#tf do. ferase each (Tempdir&,) each tf end. 
if. DBG do. 
  wd'psel mstat' 
else. 
  wd 'psel ',,>MSTATPID
  if. IDE do. wd'ide hide' end.
end.
wd 'pclose;'
)

mstat_Fpref_button=: 3 : 0
ed_check''
open_mspref_''
)

mstat_Sload_button=: 3 : 0
f=. sloadfn''
if. 0=#f do. return. end.
s=. freads f
try.
  scriptn s
catch.
  mbError'Script error';'Error loading script file.'
end.
if. (<10{.s) = <'NB. Plugin' do.
  cl=. rmsqt deball LF taketo 'coclass ' takeafter s
  m=. ". 'MENU_',cl,'_'
  if. 0<#m do. wd m end.
end.
    
)

mstat_Eannot_button=: 3 : 0
if. Ed__ do.
   end_edit''
else.
   wd 'set Em1 readonly 0; set Eannot checked 1;'
   wd 'set mtb checked Eannot 1;set mtb enable Eundo 1'
   wd 'set Em1 stylesheet *QPlainTextEdit {background-color:#ffffff; border: 1px solid gray;',(font2css Vfont__),'}'
   Ed__=: 1
   Out_bak=: Out__
end.
)

mstat_Eundo_button=: 3 : 0
end_edit''
Out__=: Out_bak
view''
)

mstat_Ewrap_button=: 3 : 0
if. Wrap__ do.
  wd 'set Ewrap checked 0'
  wd 'set Em1 wrap 0'
  Wrap__=: 0
else.
  wd 'set Ewrap checked 1'
  wd 'set Em1 wrap 1'
  Wrap__=: 1
end.
)

mstat_Espad_button=: 3 : 0
if. PAD__ do.
   PAD__=: 0
   close_spad_''
else.
   PAD__=: 1
   open_spad_''
end.
)

mstat_Eterm_button=: 3 : 0
if. IDE do.
  IDE=: 0
  wd 'ide hide; set Eterm checked 0; set mtb checked Eterm 0'
else.
  IDE=: 1
  wd 'ide show'
  wd 'psel mstat; pactive; set Eterm checked 1; set mtb checked Eterm 1'
end.
empty''
)

mstat_Dclear_button=: 3 : 0
res=. mbQuery 'Clear data';'Do you want to clear all data from memory?'
if. res -: 'no' do.
  return.
else.
  coerase <'v'
  coerase <'t'
  coerase <'i'
  wd 'set sbar setlabel nvar *No variables'
  Ddirty__=:0
end.
tout 'Data cleared.',LF,LF
view''
)

mstat_Ddel_button=: 3 : 0
if. -. varexist 'A' do.
  mbError 'No variables';'No variables are defined.'
  return.
end.
Test=:'ddel'
Tlast=: cDDEL
'A' open_mulsmp_'Delete sample'
)

mstat_Dedit_button=: 3 : 0
if. -. varexist 'A' do.
  mbError 'No variables';'No variables are defined.'
  return.
end.
open_dedit_''
)

mstat_Dtoord_button=: 3 : 0
if. -. varexist 'T' do.
  mbError 'No tables';'No tables are defined.'
  return.
end.
Test=:'open_toord_'
'T' open_onesmp_ 'Convert table to ordinal variables'
)

mstat_Dbyind_button=: 3 : 0
if. -. varexist 'I' do.
  mbError 'No indicators';'No indicator variables are defined.'
  return.
end.
open_byind_''
)

mstat_Dtoind_button=: 3 : 0
if. -. varexist 'R' do.
  mbError 'No variables';'No variables are defined.'
  return.
end.
Test=:'toind'
'R' open_onesmp_'Convert variable to indicator'
)

mstat_Dtovar_button=:3 : 0
if. -. varexist 'I' do.
  mbError 'No indicators';'No indicators are defined.'
  return.
end.
Test=:'tovar'
'I' open_onesmp_'Convert indicator to variable'
)

mstat_Dnew_button=: 3 : 0
open_dnew_''
)

mstat_Dshow_button=: 3 : 0
if. -. varexist 'A' do.
  mbError 'No variables';'No variables are defined.'
  return.
end.
Test=:'show'
Tlast=: cSHOW
'A' open_mulsmp_'Show variable definitions'
)

mstat_Dsave_button=: 3 : 0
if. -. varexist 'A' do.
  mbError 'No variables';'No variables are defined.'
  return.
end.
Fn=. dsavfn y
if. 0=#Fn do.
   return.
end.
sz=. dwrite Fn
Ddirty__=:0
tout 'Data file saved: ',Fn,', ',(":sz),' bytes',LF
view''
)

mstat_Dload_button=: 3 : 0
if. 0<numvar'' do.
   select. mbAsk 'Save data?';'Variables in data file will overwrite',LF,'existing variables with identical names.',LF,'Save current data before proceeding?'
      case. 'yes' do.
         mstat_Dsave_button''
      case. 'cancel' do.
         return.
   end.
   Ddirty=:1
end.
Ifn=. dloadfn''
if. 0=#Ifn do.
   return.
end.
fullpath=. pathname Ifn
Dpath__=: >0{fullpath
Dfn__=: (>1{fullpath) rplc '.jd';'.ijd'
Pref__=: (<Dpath__) 5} Pref__
D=. freads Ifn
header=. 7{.D
if. (7 ~: +/'NB. ijd' e. header) do.
   if. (7 = +/'NB. jd ' e. header) do.
      load_legacy_file D
      return.
   end.
   mbError 'Not a data file';'Data files must begin with a comment line.'
   return.
end.
scriptn D
wd 'psel mstat;set sbar setlabel nvar *',(":numvar''),' variables defined'
tout 'Data file loaded: ',Ifn,LF,LF
view''
)

mstat_Desc_button=: 3 : 0
if. -. varexist 'R' do.
  mbError 'No variables';'No variables are defined.'
  return.
end.
Test=:'desc'
mstat_Tlast_button=:mstat_Desc_button
setTlast cDESC
'R' open_mulsmp_ 'Descriptive statistics'
)

mstat_Dimport_button=: 3 : 0
open_import_''
)

mstat_Dexport_button=: 3 : 0
if. -. (varexist 'I') +. varexist 'R' do.
  mbError 'No variables';'No appropriate variables are defined.'
  return.
end.
open_export_''
)

mstat_Bin_button=: 3 : 0
if. -. varexist 'R' do.
  mbError 'No variables';'No variables are defined.'
  return.
end.
mstat_Tlast_button=:mstat_Bin_button
setTlast cBIN
Test=: 'open_bin_'
'R' open_mulsmp_ 'Bin data'
)


mstat_KapM_button=: 3 : 0
if. -. varexist 'R' do.
  mbError 'No variables';'No variables are defined.'
  return.
end.
Test=: 'kaplan'
mstat_Tlast_button=: mstat_KapM_button
setTlast cKAPM
open_pairsmp_ 'Kaplan-Meier survival'
)

mstat_Binci_button=: 3 : 0
mstat_Tlast_button=:mstat_Binci_button
setTlast cBINCI
open_binci_''
)

mstat_Bootci_button=: 3 : 0
if. -. varexist 'R' do.
  mbError 'No variables';'No variables are defined.'
  return.
end.
Test=: 'bootci'
mstat_Tlast_button=: mstat_Bootci_button
setTlast cBOOTCI
'R' open_mulsmp_ 'Bootstrap confidence interval'
)

mstat_Ratio_button=: 3 : 0
if. -. 2 varexist 'R' do.
  mbError 'Too few variables';'At least two variables must be defined.'
  return.
end.
Test=: 'ratio'
mstat_Tlast_button=:mstat_Ratio_button
setTlast cRATIO
'R' open_mulsmp_ 'Ratio of variables'
)

mstat_Transf_button=: 3 : 0
if. -. varexist 'R' do.
  mbError 'No variables';'No variables are defined.'
  return.
end.
mstat_Tlast_button=:mstat_Transf_button
setTlast cTRANSF
open_transf_''
)

mstat_Rescale_button=: 3 : 0
if. -. varexist 'R' do.
  mbError 'No variables';'No variables are defined.'
  return.
end.
Test=: 'rescale'
mstat_Tlast_button=:mstat_Rescale_button
setTlast cRESCALE
'R' open_mulsmp_ 'Rescale variables'
)

mstat_LoadPlot_button=: 3 : 0
Ifn=. ploadfn''
if. 0=#Ifn do.
   return.
end.
fullpath=. pathname Ifn
Dpath__=: >0{fullpath
D=. freads Ifn
header=. <7{.D
if. -. (<'NB. ijg') = header do.
   mbError 'Not a graph file';'Graph files must begin with an appropriate comment line.'
   return.
end.
BarOrd__=: BarOrdDir__=: 0 NB. required for legacy plots
'load' makeplot D
)

mstat_SBarPlot_button=: 3 : 0
if. -. varexist 'R' do.
  mbError 'No variables';'No variables are defined.'
  return.
end.
Test=: 'sbar_plot'
mstat_Tlast_button=: mstat_SBarPlot_button
setTlast cSBARPLOT
'R' open_mulsmp_ 'Stacked bar graph data'
)

mstat_FBarPlot_button=: 3 : 0
if. -. varexist 'R' do.
  mbError 'No variables';'No variables are defined.'
  return.
end.
Test=: 'fbar_plot'
mstat_Tlast_button=: mstat_FBarPlot_button
setTlast cFBARPLOT
'R' open_mulsmp_ 'Floating bar graph data'
)

mstat_ABarPlot_button=: 3 : 0
if. -. varexist 'R' do.
  mbError 'No variables';'No variables are defined.'
  return.
end.
Test=: 'abar_plot'
mstat_Tlast_button=: mstat_ABarPlot_button
setTlast cABARPLOT
'R' open_mulsmp_ 'Area plot data'
)

mstat_BarPlot_button=: 3 : 0
if. -. varexist 'R' do.
  mbError 'No variables';'No variables are defined.'
  return.
end.
Test=: 'bar_plot'
mstat_Tlast_button=: mstat_BarPlot_button
setTlast cBARPLOT
'R' open_mulsmp_ 'Bar graph data'
)

mstat_BarSDPlot_button=: 3 : 0
if. -. varexist 'R' do.
  mbError 'No variables';'No variables are defined.'
  return.
end.
Test=: 'barsd_plot'
mstat_Tlast_button=: mstat_BarSDPlot_button
setTlast cBARSD
open_pairsmp_ 'Bar graph with SD'
)

mstat_DotPlot_button=: 3 : 0
if. -. varexist 'R' do.
  mbError 'No variables';'No variables are defined.'
  return.
end.
Test=:'dot_plot'
mstat_Tlast_button=:mstat_DotPlot_button
setTlast cDOTPLOT
'R' open_mulsmp_ 'Dot plot data'
)

mstat_XYm_button=: 3 : 0
if. -. 2 varexist 'R' do.
  mbError 'Too few variables';'At least two variables must be defined.'
  return.
end.
Test=:'xy_plot'
mstat_Tlast_button=:mstat_XYm_button
setTlast cXYM
open_pairsmp_ 'XY marker plot'
)

mstat_XYl_button=: 3 : 0
if. -. 2 varexist 'R' do.
  mbError 'Too few variables';'At least two variables must be defined.'
  return.
end.
Test=:'xy_plot'
mstat_Tlast_button=:mstat_XYl_button
setTlast cXYL
open_pairsmp_ 'XY line plot'
)

mstat_XYlm_button=: 3 : 0
if. -. 2 varexist 'R' do.
  mbError 'Too few variables';'At least two variables must be defined.'
  return.
end.
Test=:'xy_plot'
mstat_Tlast_button=:mstat_XYlm_button
setTlast cXYLM
open_pairsmp_ 'XY line/marker plot'
)

mstat_XYb_button=: 3 : 0
if. -. 2 varexist 'R' do.
  mbError 'Too few variables';'At least two variables must be defined.'
  return.
end.
Test=:'xyb_plot'
mstat_Tlast_button=:mstat_XYb_button
setTlast cXYB
open_pairsmp_ 'XY band plot'
)

mstat_XYs_button=: 3 : 0
if. -. 3 varexist 'R' do.
  mbError 'Too few variables';'At least two variables must be defined.'
  return.
end.
Test=:'xys_plot'
mstat_Tlast_button=:mstat_XYs_button
setTlast cXYS
open_tripsmp_ 'XY marker/sd plot'
)


mstat_Wil_button=: 3 : 0
if. -. 2 varexist 'R' do.
  mbError 'Too few variables';'At least two variables must be defined.'
  return.
end.
Test=:'wil'
mstat_Tlast_button=:mstat_Wil_button
setTlast cWIL
open_twosmp_ 'Wilcoxon rank sum test'
)

mstat_Srank_button=: 3 : 0
if. -. 2 varexist 'R' do.
  mbError 'Too few variables';'At least two variables must be defined.'
  return.
end.
Test=:'srank'
mstat_Tlast_button=:mstat_Srank_button
setTlast cSRANK
open_twosmp_ 'Signed rank test'
)

mstat_Kwal_button=: 3 : 0
if. -. 2 varexist 'R' do.
  mbError 'Too few variables';'At least two variables must be defined.'
  return.
end.
Test=:'kwal'
mstat_Tlast_button=:mstat_Kwal_button
setTlast cKWAL
'R' open_mulsmp_ 'Kruskal-Wallis test'
)

mstat_Jonckt_button=: 3 : 0
if. -. 2 varexist 'R' do.
  mbError 'Too few variables';'At least two variables must be defined.'
  return.
end.
Test=:'jonckt'
mstat_Tlast_button=: mstat_Jonckt_button
setTlast cJONCKT
open_mulsmp_ 'Jonckheere-Terpstra test'
)

mstat_Mil_button=: 3 : 0
if. -. 2 varexist 'R' do.
  mbError 'Too few variables';'At least two variables must be defined.'
  return.
end.
Test=:'miller'
mstat_Tlast_button=: mstat_Mil_button
setTlast cMILLER
open_twosmp_ 'Miller variance jackknife test'
)

mstat_Con_button=: 3 : 0
if. -. 2 varexist 'R' do.
  mbError 'Too few variables';'At least two variables must be defined.'
  return.
end.
Test=:'conover'
mstat_Tlast_button=: mstat_Con_button
setTlast cCONOVER
open_mulsmp_ 'Conover variance test'
)

mstat_Gfit_button=: 3 : 0
if. -. 2 varexist 'R' do.
  mbError 'Too few variables';'At least two variables must be defined.'
  return.
end.
mstat_Tlast_button=: mstat_Gfit_button
Test=: 'gfit'
setTlast cGFIT
open_twosmp_ 'Goodness of fit'
)

mstat_Fishrt_button=: 3 : 0
if. -. varexist 'T' do.
  mbError 'No tables';'No tables are defined.'
  return.
end.
mstat_Tlast_button=: mstat_Fishrt_button
Test=:'fishrt'
setTlast cFISHRT
'T' open_mulsmp_ 'Fisher''s exact test'
)

mstat_Barnard_button__=: 3 : 0
if. -. varexist 'T' do.
  mbError 'No tables';'No tables are defined.'
  return.
end.
mstat_Tlast_button=: mstat_Barnard_button
Test=:'barnt'
setTlast cBARN
'T' open_mulsmp_ 'Barnard''s exact test'
)

mstat_Mcnemt_button=: 3 : 0
if. -. varexist 'T' do.
  mbError 'No tables';'No tables are defined.'
  return.
end.
mstat_Tlast_button=: mstat_Mcnemt_button
Test=:'mcnemt'
setTlast cMCNEMT
'T' open_mulsmp_ 'McNemar''s test'
)

mstat_Cochran_button=: 3 : 0
if. -. varexist 'T' do.
  mbError 'No tables';'No tables are defined.'
  return.
end.
Test=: 'cochran'
mstat_Tlast_button=: mstat_Cochran_button
setTlast cCOCHR
'T' open_mulsmp_ 'Cochran-Armitage test'
)

mstat_LogR_button=: 3 : 0
if. -. 2 varexist 'R' do.
  mbError 'Too few variables';'At least two variables must be defined.'
  return.
end.
mstat_Tlast_button=: mstat_LogR_button
Test=: 'logrank'
setTlast cLOGRANK
open_pairsmp_ 'Logrank test'
)

mstat_Chsqt_button=: 3 : 0
if. -. varexist 'T' do.
  mbError 'No tables';'No tables are defined.'
  return.
end.
Test=:'chsqt'
mstat_Tlast_button=: mstat_Chsqt_button
setTlast cCHSQT
'T' open_mulsmp_ 'Chi-square test'
)

mstat_Chsqp_button=: 3 : 0
if. -. varexist 'T' do.
  mbError 'No tables';'No tables are defined.'
  return.
end.
Test=:'chsqp'
mstat_Tlast_button=: mstat_Chsqp_button
setTlast cCHSQP
'T' open_mulsmp_ 'Chi-square partition'
)

mstat_Mantel_button=: 3 : 0
if. -. 2 varexist 'T' do.
  mbError 'Too few tables';'At least two tables must be defined.'
  return.
end.
Test=: 'mantel'
mstat_Tlast_button=: mstat_Mantel_button
setTlast cMANTEL
'T' open_mulsmp_ 'Mantel-Haenszel test'
)


mstat_Ken_button=: 3 : 0
if. -. 2 varexist 'R' do.
  mbError 'Too few variables';'At least two variables must be defined.'
  return.
end.
Test=:'ken'
mstat_Tlast_button=: mstat_Ken_button
setTlast cKEN
open_twosmp_ 'Kendall rank correlation test'
)

mstat_Spear_button=: 3 : 0
if. -. 2 varexist 'R' do.
  mbError 'Too few variables';'At least two variables must be defined.'
  return.
end.
Test=:'spear'
mstat_Tlast_button=: mstat_Spear_button
setTlast cSPEAR
open_twosmp_ 'Spearman rank correlation test'
)

mstat_Sen_button=: 3 : 0
if. -. 2 varexist 'R' do.
  mbError 'Too few variables';'At least two variables must be defined.'
  return.
end.
Test=:'sen'
mstat_Tlast_button=: mstat_Sen_button
setTlast cSEN
open_pairsmp_ 'Sen-Adichie test for parallelism'
)

mstat_Multex_button=: 3 : 0
if. -. 2 varexist 'R' do.
  mbError 'Too few variables';'At least two variables must be defined.'
  return.
end.
Test=: 'multex'
mstat_Tlast_button=: mstat_Multex_button
setTlast cMULTEX
open_pairsmp_ 'Combine multiple experiments'
)

mstat_Comp_button=: 3 : 0
mstat_Tlast_button=: mstat_Comp_button
setTlast cCOMP
open_comp_''
)

mstat_Fdr_button=: 3 : 0
mstat_Tlast_button=: mstat_Fdr_button
setTlast cFDR
open_fdr_''
)

mstat_Pwise_button=: 3 : 0
if. -. 3 varexist 'R' do.
  mbError 'Too few variables';'At least three variables must be defined.'
  return.
end.
mstat_Tlast_button=: mstat_Pwise_button
setTlast cPAIR
open_pairwise_''
)

mstat_Regr_button=: 3 : 0
if. -. 2 varexist 'R' do.
  mbError 'Too few variables';'At least two variables must be defined.'
  return.
end.
mstat_Tlast_button=: mstat_Regr_button
setTlast cREG
open_regress_''
)

mstat_Chid_button=: 3 : 0
mstat_Tlast_button=: mstat_Chid_button
setTlast cCHID
open_chsqdist_''
)

mstat_Normd_button=: 3 : 0
mstat_Tlast_button=: mstat_Normd_button
setTlast cNORM
open_normdist_''
)

mstat_Binom_button=: 3 : 0
mstat_Tlast_button=: mstat_Binom_button
setTlast cBINOM
open_discrete_''
)

mstat_Negbin_button=: 3 : 0
mstat_Tlast_button=: mstat_Negbin_button
setTlast cNEGBIN
open_discrete_''
)

mstat_Hyperg_button=: 3 : 0
mstat_Tlast_button=: mstat_Hyperg_button
setTlast cHYPERG
open_discrete_''
)

mstat_Poiss_button=: 3 : 0
mstat_Tlast_button=: mstat_Poiss_button
setTlast cPOISS
open_discrete_''
)

mstat_SSwil_button=: 3 : 0
mstat_Tlast_button=: mstat_SSwil_button
setTlast cSSWIL
open_sswil_''
)

mstat_SSfish_button=: 3 : 0
mstat_Tlast_button=: mstat_SSfish_button
setTlast cSSFISH
open_ssfish_''
)

mstat_SSmcn_button=: 3 : 0
mstat_Tlast_button=: mstat_SSmcn_button
setTlast cSSMCN
open_ssmcnem_''
)

mstat_Bpred_button=: 3 : 0
mstat_Tlast_button=: mstat_Bpred_button
setTlast cBPRED
open_bmod_''
)

mstat_About_button=: 3 : 0
open_about_''
)

mstat_Hlp_button=: 3 : 0
select. UNAME
  case. 'Win' do.
    fork BROWSER__,' "file://',Resdir__,'help/Mhelp-1.html" '
  case. 'Darwin' do.
    2!:1 BROWSER__,' "',Resdir__,'help/Mhelp-1.html" '
  case. 'Linux' do.
    if. 0<#BROWSER__ do.
      2!:1 BROWSER__,' "file://',Resdir__,'help/Mhelp-1.html" &'
    else.
      mbInfo 'Default browser not found';'Start help/Mhelp-1.html from file manager.'
    end.
end.
)

mstat_Wch_button=: 3 : 0
open_wch_''
)

mstat_DHlp_button=: 3 : 0
if. HELP__ do.
  close_hlp_''
else.
  HELP__=: 1
  wd 'set DHlp 1'
  open_hlp_''
end.
wd 'psel mstat;pactive'
)

mstat_Update_button=: 3 : 0
open_msupdate_'m'
)

mstat_ectrl_fkey=: mstat_Dedit_button

mstat_hctrl_fkey=: mstat_Hlp_button

mstat_lctrl_fkey=: mstat_DHlp_button

mstat_nctrl_fkey=: mstat_Dnew_button

mstat_pctrl_fkey=: mstat_Fprint_button

mstat_sctrl_fkey=: mstat_Dsave_button

mstat_dctrl_fkey=: mstat_Fexit_button

mstat_qctrl_fkey=: mstat_Fexit_button

mstat_rctrl_fkey=: mstat_Espad_button

mstat_tctrl_fkey=: mstat_Tlast_button

mstat_wctrl_fkey=: mstat_Eterm_button

mstat_f1_fkey=: mstat_Hlp_button

mstat=: 3 : 0
cocurrent 'base'
mstat_run''
)

mstat''
